// -------------------------------------------------------------------------------
// 
// 		cwCu		tHgpvOwb_t@C
// 
// 				Ver 3.23a
// 
// -------------------------------------------------------------------------------

#ifndef DX_FONT_H
#define DX_FONT_H

#include "DxCompileConfig.h"

#ifndef DX_NON_FONT

// CN[h ------------------------------------------------------------------
#include "DxLib.h"
#include "DxStatic.h"
#include "DxMemImg.h"
#include "DxHandle.h"
#include <stdarg.h>

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

#define FSYS FontSystem

/* o[W

0      o[W
1      J[jOyAǉ

*/

/* f[^}bv

FONTDATAFILEHEADER

kĊi[
	FONTDATAFILEPRESSHEADER
	FONTDATAFILECHARADATA ~ ̐
	FONTDATAFILEKERNINGPAIRDATA ~ J[jOyA̐	

*/

// o[W
#define DX_FONTDATAFILE_VERSION					(1)

// o[W 0 ̊e\̂̃TCY
#define DX_FONTBASEINFO_SIZE_VER0				(20)
#define DX_FONTDATAFILEPRESSHEADER_SIZE_VER0	(344)
#define DX_FONTDATAFILEHEADER_SIZE_VER0			(368)

// tHǧC[W̃f[^^Cv
#define DX_FONT_SRCIMAGETYPE_1BIT				(0)					// 1sNZ1rbg
#define DX_FONT_SRCIMAGETYPE_1BIT_SCALE4		(1)					// 1sNZ1rbgA摜𑜓x4{
#define DX_FONT_SRCIMAGETYPE_1BIT_SCALE8		(2)					// 1sNZ1rbgA摜𑜓x8{
#define DX_FONT_SRCIMAGETYPE_1BIT_SCALE16		(3)					// 1sNZ1rbgA摜𑜓x16{
#define DX_FONT_SRCIMAGETYPE_4BIT_MAX15			(4)					// 1sNZ4rbgAl͈̔͂0`15
#define DX_FONT_SRCIMAGETYPE_8BIT_ON_OFF		(5)					// 1sNZ8rbgAl͈̔͂00ȊO
#define DX_FONT_SRCIMAGETYPE_8BIT_MAX16			(6)					// 1sNZ8rbgAl͈̔͂0`16
#define DX_FONT_SRCIMAGETYPE_8BIT_MAX64			(7)					// 1sNZ8rbgAl͈̔͂0`64
#define DX_FONT_SRCIMAGETYPE_8BIT_MAX255		(8)					// 1sNZ8rbgAl͈̔͂0`255

#define FONT_CACHE_MAXNUM						(2024)				// tHgLbVɊi[łő啶
#define FONT_CACHE_EX_NUM						(1024)				// 0xffff 𒴂R[h̕f[^AhXێ鐔
#define FONT_CACHE_MEMORYSIZE					(0x50000)			// tHgLbV̍őe
#define FONT_CACHE_MAX_YLENGTH					(0x4000)			// tHgLbVT[tFX̍őc
#define FONT_GRAPHICHANDLE_IMAGE_MAXNUM			(256)				// ̕R[hOtBbNnh̉摜ɒuő吔
#define FONT_SUBSTITUTION_MAXNUM				(16)				// o^łփtHg̍ő吔

// tHgnh̗L`FbN
#define FONTHCHK( HAND, HPOINT )		HANDLECHK(       DX_HANDLETYPE_FONT, HAND, *( ( HANDLEINFO ** )&HPOINT ) )
#define FONTHCHK_ASYNC( HAND, HPOINT )	HANDLECHK_ASYNC( DX_HANDLETYPE_FONT, HAND, *( ( HANDLEINFO ** )&HPOINT ) )

// ftHgtHgnh^
#define DEFAULT_FONT_HANDLE_SETUP		\
	if( FontHandle == DX_DEFAULT_FONT_HANDLE )\
	{\
		RefreshDefaultFont() ;\
		FontHandle = FSYS.DefaultFontHandle ;\
	}

// \̒` --------------------------------------------------------------------

// tHg񋓎pf[^\
struct ENUMFONTDATA
{
	wchar_t *				FontBuffer ;
	int						FontNum ;
	int						BufferNum ;
	int						JapanOnlyFlag ;
	int						Valid ;
	const wchar_t *			EnumFontName ;
} ;

// CreateFontToHandle ŎgpO[oϐZ߂
struct CREATEFONTTOHANDLE_GPARAM
{
	int						NotTextureFlag ;					// 쐬tHgLbVeNX`ɂ邩AtO
	int						TextureCacheColorBitDepth16Flag ;	// 쐬tHgLbVeNX`̃J[rbg16rbgɂ邩ǂ̃tO
	int						CacheCharNum ;						// tHgLbVŃLbVł镶̐
	int						UsePremulAlphaFlag ;				// Zς݃gp邩ǂ̃tO( TRUE:gp  FALSE:gpȂ )
	int						DisableAdjustFontSize ;				// tHgTCY̕␳sȂǂ̃tO( TRUE:␳sȂ  FALSE:␳s )
} ;

// tHg̊{
struct FONTBASEINFO
{
	WORD					FontThickness ;						// tHg̑
	WORD					FontSize ;							// `悷tHg̃TCY
	WORD					FontHeight ;						// `悷tHg̍őc
	WORD					FontAddHeight ;						// TCŸׂɑ
	BYTE					Italic ;							// C^bNtHgǂ(TRUE:C^bN FALSE:C^bN)
	BYTE					Padding ;
	WORD					MaxWidth ;							// tHg̍ő啝
	WORD					CharSet ;							// LN^Zbg
	WORD					CharCodeFormat ;					// R[h`( 0xffff ̏ꍇ͓ɎwȂ )
	WORD					Ascent ;							// ̃x[XCԏ܂ł̍
	WORD					Padding2 ;
	DWORD					KerningPairNum ;					// J[jOyA̐
	DWORD					Padding3[ 10 ] ;
} ;

// tHgt@C̃wb_̈k镔
struct FONTDATAFILEPRESSHEADER
{
	WORD					FontName[ 128 ] ;	// tHg̖O( UTF-16LE )
	FONTBASEINFO			BaseInfo ;			// {
	BYTE					ImageBitDepth ;		// 摜̃rbg[x( DX_FONTIMAGE_BIT_1  )
	BYTE					Padding[ 3 ] ;
	DWORD					Padding2[ 16 ] ;
} ;

// tHgt@C̃wb_
struct FONTDATAFILEHEADER
{
	BYTE					Magic[ 4 ] ;		// FNTF
	WORD					Version ;			// o[W
	WORD					Padding ;
	DWORD					ImageAddress ;		// 摜f[^ۑĂ擪AhX
	DWORD					MaxImageBytes ;		// 摜f[^̍őTCY
	DWORD					CharaNum ;			// ̐
	DWORD					CharaExNum ;		// ̓AR[h 0x10000 ȏ̐̕
	FONTDATAFILEPRESSHEADER	Press ;				// wb_t@C̈kΏۂ̕
} ;

// J[jOyA
struct FONTDATAFILEKERNINGPAIRDATA
{
	DWORD					First ;				// yÂP
	DWORD					Second ;			// yÂQ
	int						KernAmount ;		// 炷hbg
	DWORD					Padding ;
} ;

// t@Cۑp̃tHgP̏
struct FONTDATAFILECHARADATA
{
	DWORD					CodeUnicode ;		// Unicode ̕R[h
	BYTE					Press ;				// kĂ邩ǂ( 1:kĂ  0:kĂȂ )
	BYTE					Padding ;
	short					DrawX ;				// 摜`悷ׂwW
	short					DrawY ;				// 摜`悷ׂxW
	short					AddX ;				// ̕`悷ׂ΂wW
	WORD					SizeX ;				// ̂wTCY
	WORD					SizeY ;				// ̂xTCY
	DWORD					ImageAddress ;		// 摜f[^ۑĂAhX( FONTDATAFILEHEADER.ImageAddress ̎AhX 0 Ƃ )
	DWORD					ImagePitch ;		// 摜f[^̂PC̃oCg
	DWORD					Padding2[ 2 ] ;
} ;

// tHgP̃LbV
struct FONTCHARDATA
{
	DWORD					CodeUnicode ;		// Unicode ̕R[h
	DWORD					IVSCode ;			// ّ̎ZN^( gpȂꍇ 0 )
	BYTE					ValidFlag ;			// LtO
	BYTE					GraphHandleFlag ;	// GraphIndex OtBbNnhǂ̃tO( TRUE:OtBbNnh  FALSE:f[^̃CfbNX )
	short					DrawX ;				// 摜`悷ׂwW
	short					DrawY ;				// 摜`悷ׂxW
	short					AddX ;				// ̕`悷ׂ΂wW
	WORD					SizeX ;				// 摜̕
	WORD					SizeY ;				// 摜̍
	int						GraphIndex ;		// f[^̃CfbNX( Ⴕ̓OtBbNnh )
	int						GraphIndexX ;		// f[^̂w}Xʒu
	int						GraphIndexY ;		// f[^̂x}Xʒu
	FONTDATAFILEKERNINGPAIRDATA *KerningPair ;	// ̕ɑΉJ[jOyÃAhX
	DWORD					KerningPairNum ;	// ̕ɑΉJ[jOyA̐
	struct FONTCODEDATA *	CodeData ;			// ̃tHgǗĂf[^̃|C^
} ;

// tHgLbV݃tO\
struct FONTCODEDATA
{
	int						ExistFlag ;			// LbV̑݃tO
	FONTCHARDATA *			CharData ;			// LbVf[^݈̑ʒu
} ;

// tHgf[^t@C^pɎgpϐZ߂\
struct FONTDATAFILEUSEINFO
{
	BYTE *					FileBuffer ;						// tHgf[^t@C̒gi[̈̐擪AhX
	int						FontFileSize ;						// tHgf[^t@C̃TCY
	FONTDATAFILEHEADER *	Header ;							// tHgf[^t@Cwb_
	FONTDATAFILECHARADATA *	Chara ;								// tHgf[^t@C̊ȅ
	BYTE *					Image ;								// tHgf[^t@C̉摜f[^̃AhX
	int						ImageType ;							// tHgf[^t@C̃C[Wf[^^Cv( DX_FONT_SRCIMAGETYPE_1BIT  )
	FONTDATAFILECHARADATA **CharaTable ;						// tHgf[^t@C̊ȅւ̃AhX̃e[u( R[h 0x0000`0xffff ͈̔ )
	FONTDATAFILECHARADATA **CharaExArray ;						// 0xffff 𒴂镶R[h̕ւ̃AhX
	void *					PressImageDecodeBuffer ;			// 𓀂C[Wi[obt@
} ;

// փtHg
struct FONTSUBSTITUTIONINFO
{
	int						SubstitutionFontHandle ;			// փtHgnh
	int						DrawX ;								// `XW
	int						DrawY ;								// `YW
} ;

// tHgLbV̊Ǘf[^
struct FONTMANAGE
{
	HANDLEINFO				HandleInfo ;						// nhʃf[^

	struct FONTMANAGE_PF *	PF ;								// ˑf[^

	int *					LostFlag ;							//  TRUE ɂtOւ̃|C^

	int						UseFontDataFile ;					// tHgf[^t@CgpĂ邩ǂ( TRUE:gpĂ  FALSE:gpĂȂ )
	FONTDATAFILEUSEINFO		FontDataFile ;						// tHgf[^t@C̏

	FONTCHARDATA			CharData[ FONT_CACHE_MAXNUM + 1 ] ;	// LbVf[^
	FONTCODEDATA			CodeData[ 0x10000 ] ;				// ݃f[^܂ރf[^z
	int						CodeDataExNum ;						// 0xffff 𒴂镶R[h̕f[^̐
	FONTCHARDATA *			CodeDataEx[ FONT_CACHE_EX_NUM ] ;	// 0xffff 𒴂镶R[h̕f[^ւ̃|C^
	unsigned int			Index ;								// f[^ǉ̔zCfbNX
	int						MaxCacheCharNum ;					// LbVłő吔
	unsigned char *			CacheMem ;							// eLXgLbV
	int						CachePitch ;						// eLXgLbṼsb`	
	int						CacheDataBitNum ;					// eLXgLbV̂PsNZ̃rbg

	FONTDATAFILEKERNINGPAIRDATA * KerningPairData ;				// J[jOyA

	int						GraphHandleFontImageNum ;			// ̕R[hOtBbNnh̉摜ɒuĂ鐔
	FONTCHARDATA			GraphHandleFontImage[ FONT_GRAPHICHANDLE_IMAGE_MAXNUM ] ;	// ̕R[hOtBbNnh̉摜ɒu鏈p̃f[^

	int						SubstitutionInfoNum ;				// փtHg̐
	FONTSUBSTITUTIONINFO	SubstitutionInfo[ FONT_SUBSTITUTION_MAXNUM ] ;	// փtHg

	TCHAR					FontNameT[ 256 ] ;					// tHg( TCHAR  )
	wchar_t					FontName[ 256 ] ;					// tHg
	FONTBASEINFO			BaseInfo ;							// {
	int						UseCharCodeFormat ;					// œnR[h`
	int						Space ;								// ̕\WɉZhbg
	int						LineSpaceValidFlag ;				// LineSpace Lǂ̃tO
	int						LineSpace ;							// s̍ۂɍWɉZhbg
	int						FontType ;							// tHg̃^Cv
	int						EdgeSize ;							// GbW̑

	SIZE					CacheImageSize ;					// LbV摜̂̃TCY 
	int						LengthCharNum ;						// LbV摜̏cɕׂ镶̐

	BYTE *					TempBuffer ;						// tHg̍őTCŶPsNZPoCg̍Ɨpobt@
	DWORD					TempBufferSize ;					// Ɨpobt@̃TCY

	int						ModiDrawScreen[ 2 ] ;				// DrawModiString p̍ƗpXN[
	int						ModiDrawScreenV[ 2 ] ;				// DrawModiString p̍ƗpXN[( cp )

	int						TextureCache ;						// eNX`ɃLbVꍇ̃eNX`OtBbNnh
	int						TextureCacheSub ;					// eNX`ɃLbVꍇ̃eNX`OtBbNnh(p)
	int						TextureCacheLostFlag ;				// TextureCache ɂȂƂ TRUE ɂȂϐ
	BASEIMAGE				TextureCacheBaseImage ;				// TextureCache ɓ]̂Ɠ̂i[{C[W
	int						TextureCacheColorBitDepth ;			// eNX`LbṼJ[rbg
	int						TextureCacheUsePremulAlpha ;		// eNX`LbṼ`lZς݃ɂ邩ǂ
	int						TextureCacheSizeX ;					// eNX`LbV̕
	int						TextureCacheSizeY ;					// eNX`LbV̍
	float					TextureCacheInvSizeX ;				// eNX`LbV̋̕t
	float					TextureCacheInvSizeY ;				// eNX`LbV̍̋t

	int						TextureCacheUpdateRectValid ;		// eNX`LbVXV`񂪗Lǂ
	RECT					TextureCacheUpdateRect ;			// eNX`LbVXV`

	int						TextureCacheFlag ;					// eNX`LbVĂ邩AtO
} ;

// tHgVXep\
struct FONTSYSTEM
{
	int						InitializeFlag ;					// tO

	int						NotTextureFlag ;					// 쐬tHgLbVeNX`ɂ邩AtO
	int						TextureCacheColorBitDepth16Flag ;	// 쐬tHgLbVeNX`̃J[rbg16rbgɂ邩ǂ̃tO
	int						AntialiasingFontOnlyFlag ;			// A`GCAXtHĝݎgpł邩AtO
	int						CacheCharNum ;						// tHgLbVŃLbVł镶̐
	int						UsePremulAlphaFlag ;				// Zς݃gp邩ǂ̃tO( TRUE:gp  FALSE:gpȂ )
	int						DisableAdjustFontSize ;				// tHgTCY̕␳sȂǂ̃tO( TRUE:␳sȂ  FALSE:␳s )
	BYTE					BitCountTable[ 256 ] ;				// rbgJEge[u
	BYTE					MAX15ToMAX16[ 16 ] ;				// 0`15  ̒l 0`16 ɕϊ邽߂̃e[u
	BYTE					MAX255ToMAX16[ 256 ] ;				// 0`255 ̒l 0`16 ɕϊ邽߂̃e[u
	BYTE					MAX15ToMAX64[ 16 ] ;				// 0`15  ̒l 0`64 ɕϊ邽߂̃e[u
	BYTE					MAX255ToMAX64[ 256 ] ;				// 0`255 ̒l 0`64 ɕϊ邽߂̃e[u

	wchar_t					DoubleByteSpaceCharCode ;			// SpXy[X wchar_t R[h

	int						UseDefaultFontImage ;				// ftHgtHgC[WgpĂ邩ǂ( TRUE:gpĂ  FALSE:gpĂȂ )
	void *					DefaultFontImage ;					// ftHgtHgC[Wi[ĂAhXۑ|C^
	int						DefaultFontImageGraphHandle[ 8 ][ 16 ] ;	// ftHgtHgC[W̃OtBbNnh

	int						DefaultFontHandle ;					// ftHgŎgptHg̃nh

	int						EnableInitDefaultFontName ;			// ftHgŎgptHg̐ݒ
	wchar_t					DefaultFontName[ 256 ] ;

	int						EnableInitDefaultFontSize ;
	int						DefaultFontSize ;

	int						EnableInitDefaultFontThick ;
	int						DefaultFontThick ;

	int						EnableInitDefaultFontType ;
	int						DefaultFontType ;

	int						EnableInitDefaultFontCharSet ;
	int						DefaultFontCharSet ;
	int						DefaultFontCharSet_Change ;

	int						EnableInitDefaultFontEdgeSize ;
	int						DefaultFontEdgeSize ;

	int						EnableInitDefaultFontItalic ;
	int						DefaultFontItalic ;

	int						EnableInitDefaultFontSpace ;
	int						DefaultFontSpace ;

	int						EnableInitDefaultFontLineSpace ;
	int						DefaultFontLineSpaceValid ;
	int						DefaultFontLineSpace ;
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

extern FONTSYSTEM FontSystem ;

// ֐vg^Cv錾-----------------------------------------------------------

extern	int			InitFontManage( void ) ;																					// tHgVXȅ
extern	int			TermFontManage( void ) ;																					// tHg̏I
extern	int			InitCacheFontToHandle( void ) ;																				// tHg̃LbV
extern	int			InitFontCacheToHandle( FONTMANAGE *ManageData, int ASyncThread = FALSE ) ;											// ̃tHg̃LbV

extern	int			InitializeFontHandle( HANDLEINFO *HandleInfo ) ;															// tHgnh
extern	int			TerminateFontHandle( HANDLEINFO *HandleInfo ) ;																// tHgnȟn

extern	int			RefreshFontDrawResourceToHandle( FONTMANAGE *ManageData, int ASyncThread = FALSE ) ;						// tHgnhgp`obt@eNX`LbVď
extern	int			SetAntialiasingFontOnlyFlag( int AntialiasingFontOnlyFlag ) ;												// A`GCAXtHĝݎgpł邩AtOZbg

extern	int			FontCacheStringDrawToHandleST(
							int DrawFlag,
							int   xi, int   yi,
							float xf, float yf, int PosIntFlag,
							int ExRateValidFlag,
							double ExRateX, double ExRateY,
							int RotateValidFlag,
							float RotCenterX, float RotCenterY, double RotAngle, 
							const wchar_t *StrData,
							unsigned int Color, MEMIMG *DestMemImg, const RECT *ClipRect,
							int TransFlag, FONTMANAGE *ManageData, unsigned int EdgeColor,
							int StrLen, int VerticalFlag, SIZE *DrawSize,
							int *LineCount, 
							DRAWCHARINFO *CharInfos, size_t CharInfoBufferSize, int *CharInfoNum,
							int OnlyType /* 0:ʏ` 1:{̂̂ 2:̂ */ ) ;
extern	int			RefreshDefaultFont( void ) ;																				// ftHgtHgč쐬
extern	int			InitFontToHandleBase( int Terminate = FALSE ) ;																// InitFontToHandle ̓֐

extern	FONTMANAGE *GetFontManageDataToHandle( int FontHandle ) ;																// tHgǗf[^̎擾

extern	void		InitCreateFontToHandleGParam( CREATEFONTTOHANDLE_GPARAM *GParam ) ;											// CREATEFONTTOHANDLE_GPARAM ̃f[^Zbg

extern	int			CreateFontToHandle_UseGParam(          CREATEFONTTOHANDLE_GPARAM *GParam, const wchar_t *FontName, int Size, int Thick, int FontType, int CharSet, int EdgeSize, int Italic, int Handle, int ASyncLoadFlag = FALSE ) ;	// CreateFontToHandle ̃O[oϐɃANZXȂo[W
extern	int			LoadFontDataFromMemToHandle_UseGParam( CREATEFONTTOHANDLE_GPARAM *GParam, const void *FontDataImage, int FontDataImageSize, int EdgeSize = -1, int Handle = -1, int ASyncLoadFlag = FALSE ) ;				// LoadFontDataFromMemToHandle ̃O[oϐɃANZXȂo[W
extern	int			LoadFontDataToHandle_UseGParam(        CREATEFONTTOHANDLE_GPARAM *GParam, const wchar_t FileName, int EdgeSize, int ASyncLoadFlag = FALSE ) ;																// LoadFontDataToHandle ̃O[oϐɃANZXȂo[W

extern	int			SetupFontCache( CREATEFONTTOHANDLE_GPARAM *GParam, FONTMANAGE *ManageData, int ASyncThread ) ;											// LbṼZbgAbvs
extern	FONTCHARDATA *	FontCacheCharAddToHandle( int AddNum, const DWORD *CharCodeList, const DWORD *IVSCodeList, FONTMANAGE *ManageData, int TextureCacheUpdate = TRUE ) ;	// LbVɐV
extern	int				FontCacheCharImageBltToHandle( FONTMANAGE *ManageData, FONTCHARDATA *CharData, DWORD CharCode, DWORD IVSCode, int Space, int ImageType /* DX_FONT_SRCIMAGETYPE_1BIT  */, void *ImageBuffer, DWORD ImageSizeX, DWORD ImageSizeY, DWORD ImagePitch, int ImageDrawX, int ImageDrawY, int ImageAddX, int TextureCacheUpdate ) ;		// w̃tHgf[^ɉ摜]
extern	int			FontTextureCacheAddUpdateRect( FONTMANAGE *ManageData, RECT *Rect ) ;	// tHg̃eNX`LbV̍XV`ǉ
extern	int			FontTextureCacheUpdateRectApply( FONTMANAGE *ManageData ) ;				// tHg̃eNX`LbV̍XV`ۂ̃eNX`ɓKp

extern	int			GetFontHandleCharCodeFormat( int FontHandle ) ;		// tHgnhɐݒ肳Ă镶R[h`擾( ߂l  -1:G[  -1ȊO:R[h` )

// w̕R[h̃tHgLbVf[^擾ALbVɖꍇ̓LbVւ̒ǉ݂āAs NULL Ԃ
extern	FONTCHARDATA *GetFontCacheChar( FONTMANAGE *ManageData, DWORD CharCode, DWORD IVSCode, FONTMANAGE **UseManageData, int *DrawOffsetX, int *DrawOffsetY, int EnableGraphHandleFontImage, int ErrorMessage ) ;


// wchar_tŊ֐
extern	int			EnumFontName_WCHAR_T(							wchar_t *NameBuffer, int NameBufferNum, int JapanOnlyFlag = TRUE ) ;													// gp\ȃtHg̖O񋓂( NameBuffer  64oCg؂ŖOi[܂ )
extern	int			EnumFontNameEx_WCHAR_T(							wchar_t *NameBuffer, int NameBufferNum,                              int CharSet = -1 /* DX_CHARSET_DEFAULT  */ ) ;	// gp\ȃtHg̖O񋓂( NameBuffer  64oCg؂ŖOi[܂ )( Zbgw )
extern	int			EnumFontNameEx2_WCHAR_T(						wchar_t *NameBuffer, int NameBufferNum, const wchar_t *EnumFontName, int CharSet = -1 /* DX_CHARSET_DEFAULT  */ ) ;	// w̃tHg̃tHg񋓂
extern	int			CheckFontName_WCHAR_T(							const wchar_t *FontName, int CharSet = -1 /* DX_CHARSET_DEFAULT  */ ) ;												// w̃tHg̃tHg݂邩ǂ`FbN( ߂l  TRUE:݂  FALSE:݂Ȃ )

extern	int			CreateFontToHandle_WCHAR_T(                     const wchar_t *FontName, int Size, int Thick, int FontType = -1 , int CharSet = -1 , int EdgeSize = -1 , int Italic = FALSE , int Handle = -1 ) ;		// tHgnh쐬
extern	int			LoadFontDataToHandle_WCHAR_T(					const wchar_t *FileName,                      int EdgeSize = -1 ) ;			// tHgf[^t@CtHgnh쐬
extern	int			ChangeFont_WCHAR_T(                             const wchar_t *FontName, int CharSet = -1 /* DX_CHARSET_SHFTJIS  */ ) ;							// ftHgtHgnhŎgptHgύX
extern	int			SetDefaultFontState_WCHAR_T(                    const wchar_t *FontName, int Size, int Thick, int FontType = -1 , int CharSet = -1 , int EdgeSize = -1 , int Italic = FALSE ) ;	// ftHgtHgnh̐ݒύX
extern	int			AddFontImageToHandle_WCHAR_T(					int FontHandle, const wchar_t *Char, int GrHandle, int DrawX, int DrawY, int AddX ) ;				// w̑̕ɕ`悷OtBbNnho^
extern	int			SubFontImageToHandle_WCHAR_T(					int FontHandle, const wchar_t *Char ) ;															// w̑̕ɕ`悷OtBbNnh̓o^

extern	int			GetDrawStringWidth_WCHAR_T(                     const wchar_t *String, int StrLen, int VerticalFlag ) ;									// ftHgtHgnhgp̕`敝擾
extern	int			GetDrawFormatStringWidth_WCHAR_T(               const wchar_t *FormatString, ... ) ;																// ftHgtHgnhgpt̕`敝擾
extern	int			GetDrawExtendStringWidth_WCHAR_T(               double ExRateX, const wchar_t *String, int StrLen, int VerticalFlag ) ;					// ftHgtHgnhgp̕`敝擾( g嗦t )
extern	int			GetDrawExtendFormatStringWidth_WCHAR_T(         double ExRateX, const wchar_t *FormatString, ... ) ;												// ftHgtHgnhgpt̕`敝擾( g嗦t )

extern	int			GetFontCharInfo_WCHAR_T(                        int FontHandle, const wchar_t *Char, int *DrawX, int *DrawY, int *NextCharX, int *SizeX, int *SizeY ) ;	// tHgnh̎w̕̕`擾
extern	int			GetDrawStringWidthToHandle_WCHAR_T(             const wchar_t   *String, size_t StringLength, int StrLen, int FontHandle, int VerticalFlag ) ;		// tHgnhgp̕`敝擾
extern	int			GetDrawFormatStringWidthToHandle_WCHAR_T(       int FontHandle, const wchar_t *FormatString, ... ) ;												// tHgnhgpt̕`敝擾
extern	int			GetDrawExtendStringWidthToHandle_WCHAR_T(       double ExRateX, const wchar_t *String, size_t StringLength, int StrLen, int FontHandle, int VerticalFlag ) ;	// tHgnhgp̕`敝擾
extern	int			GetDrawExtendFormatStringWidthToHandle_WCHAR_T( double ExRateX, int FontHandle, const wchar_t *FormatString, ... ) ;								// tHgnhgpt̕`敝擾
extern	int			GetDrawStringSizeToHandle_WCHAR_T(              int *SizeX, int *SizeY, int *LineCount, const wchar_t   *String, size_t StringLength, int StrLen, int FontHandle, int VerticalFlag ) ;					// tHgnhgp̕`敝EEs擾
extern	int			GetDrawExtendStringSizeToHandle_WCHAR_T(        int *SizeX, int *SizeY, int *LineCount, double ExRateX, double ExRateY, const wchar_t *String, size_t StringLength, int StrLen, int FontHandle, int VerticalFlag ) ;	// tHgnhgp̕`敝EEs擾
extern	int			GetDrawStringCharInfoToHandle_WCHAR_T(          DRAWCHARINFO *InfoBuffer, size_t InfoBufferSize, const wchar_t *String, size_t StringLength, int StrLen, int FontHandle, int VerticalFlag ) ;									// tHgnhgp̂P̏擾
extern	int			GetDrawExtendStringCharInfoToHandle_WCHAR_T(    DRAWCHARINFO *InfoBuffer, size_t InfoBufferSize, double ExRateX, double ExRateY, const wchar_t *String, size_t StringLength, int StrLen, int FontHandle, int VerticalFlag ) ;	// tHgnhgp̂P̏擾
extern	int			GetDrawStringKerningPairInfoToHandle_WCHAR_T(   const wchar_t *PairChar, int *KernAmount, int FontHandle ) ;		// tHgnhgp̃̕yÃJ[jO擾( PairChar:J[jO𒲂ׂyAƂȂ2̕( 2ȏ゠Ă擪2gp܂ )  KernAmount:2ڂ̕{̈ʒu炸炷hbgint^ϐ̃AhX )
extern	int			GetFontStateToHandle_WCHAR_T(                   wchar_t   *FontName, int *Size, int *Thick, int FontHandle, int *FontType = NULL , int *CharSet = NULL , int *EdgeSize = NULL , int *Italic = NULL ) ;		// tHgnh̏擾

extern	int			FontCacheStringDrawToHandle_WCHAR_T(            int x, int y, const wchar_t *StrData, int StrLen, unsigned int Color, unsigned int EdgeColor, BASEIMAGE *DestImage, const RECT *ClipRect /* NULL  */ , int FontHandle, int VerticalFlag , SIZE *DrawSizeP = NULL ) ;
extern	int			FontBaseImageBlt_WCHAR_T(                       int x, int y, const wchar_t *StrData, int StrLen, BASEIMAGE *DestImage, BASEIMAGE *DestEdgeImage,                 int VerticalFlag ) ;	// {C[Wɕ`悷( ftHgtHgnhgp )
extern	int			FontBaseImageBltToHandle_WCHAR_T(               int x, int y, const wchar_t *StrData, int StrLen, BASEIMAGE *DestImage, BASEIMAGE *DestEdgeImage, int FontHandle, int VerticalFlag ) ;	// {C[Wɕ`悷

extern	int			DrawString_WCHAR_T(                             int x, int y,                                              const wchar_t *String, size_t StringLength, unsigned int Color, unsigned int EdgeColor ) ;							// ftHgtHgnhgpĕ`悷
extern	int			DrawVString_WCHAR_T(                            int x, int y,                                              const wchar_t *String, size_t StringLength, unsigned int Color, unsigned int EdgeColor ) ;							// ftHgtHgnhgpĕ`悷( c )
extern	int			DrawFormatString_WCHAR_T(                       int x, int y,                                 unsigned int Color, const wchar_t *FormatString, ... ) ;														// ftHgtHgnhgpďw蕶`悷
extern	int			DrawFormatVString_WCHAR_T(                      int x, int y,                                 unsigned int Color, const wchar_t *FormatString, ... ) ;														// ftHgtHgnhgpďw蕶`悷( c )
extern	int			DrawExtendString_WCHAR_T(                       int x, int y, double ExRateX, double ExRateY,              const wchar_t *String, size_t StringLength, unsigned int Color, unsigned int EdgeColor ) ;							// ftHgtHgnhgpĕ̊g`
extern	int			DrawExtendVString_WCHAR_T(                      int x, int y, double ExRateX, double ExRateY,              const wchar_t *String, size_t StringLength, unsigned int Color, unsigned int EdgeColor ) ;							// ftHgtHgnhgpĕ̊g`( c )
extern	int			DrawExtendFormatString_WCHAR_T(                 int x, int y, double ExRateX, double ExRateY, unsigned int Color, const wchar_t *FormatString, ... ) ;														// ftHgtHgnhgpďw蕶g`悷
extern	int			DrawExtendFormatVString_WCHAR_T(                int x, int y, double ExRateX, double ExRateY, unsigned int Color, const wchar_t *FormatString, ... ) ;														// ftHgtHgnhgpďw蕶g`悷( c )
extern	int			DrawRotaString_WCHAR_T(							int x, int y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, unsigned int Color, unsigned int EdgeColor, int VerticalFlag , const wchar_t *String, size_t StringLength              ) ;		// ftHgtHgnhgpĕ]`悷
extern	int			DrawRotaFormatString_WCHAR_T(					int x, int y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, unsigned int Color, unsigned int EdgeColor, int VerticalFlag , const wchar_t *FormatString , ... ) ;		// ftHgtHgnhgpďw蕶]`悷
extern	int			DrawModiString_WCHAR_T(							int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, unsigned int Color, unsigned int EdgeColor , int VerticalFlag , const wchar_t *String, size_t StringLength              ) ;		// ftHgtHgnhgpĕό``悷
extern	int			DrawModiFormatString_WCHAR_T(					int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, unsigned int Color, unsigned int EdgeColor , int VerticalFlag , const wchar_t *FormatString , ... ) ;		// ftHgtHgnhgpďw蕶ό``悷

extern	int			DrawStringF_WCHAR_T(                            float x, float y,                                              const wchar_t *String, size_t StringLength, unsigned int Color, unsigned int EdgeColor ) ;						// ftHgtHgnhgpĕ`悷( Ww肪 float  )
extern	int			DrawVStringF_WCHAR_T(                           float x, float y,                                              const wchar_t *String, size_t StringLength, unsigned int Color, unsigned int EdgeColor ) ;						// ftHgtHgnhgpĕ`悷( c )( Ww肪 float  )
extern	int			DrawFormatStringF_WCHAR_T(                      float x, float y,                                 unsigned int Color, const wchar_t *FormatString, ... ) ;													// ftHgtHgnhgpďw蕶`悷( Ww肪 float  )
extern	int			DrawFormatVStringF_WCHAR_T(                     float x, float y,                                 unsigned int Color, const wchar_t *FormatString, ... ) ;													// ftHgtHgnhgpďw蕶`悷( c )( Ww肪 float  )
extern	int			DrawExtendStringF_WCHAR_T(                      float x, float y, double ExRateX, double ExRateY,              const wchar_t *String, size_t StringLength, unsigned int Color, unsigned int EdgeColor ) ;						// ftHgtHgnhgpĕ̊g`( Ww肪 float  )
extern	int			DrawExtendVStringF_WCHAR_T(                     float x, float y, double ExRateX, double ExRateY,              const wchar_t *String, size_t StringLength, unsigned int Color, unsigned int EdgeColor ) ;						// ftHgtHgnhgpĕ̊g`( c )( Ww肪 float  )
extern	int			DrawExtendFormatStringF_WCHAR_T(                float x, float y, double ExRateX, double ExRateY, unsigned int Color, const wchar_t *FormatString, ... ) ;													// ftHgtHgnhgpďw蕶g`悷( Ww肪 float  )
extern	int			DrawExtendFormatVStringF_WCHAR_T(               float x, float y, double ExRateX, double ExRateY, unsigned int Color, const wchar_t *FormatString, ... ) ;													// ftHgtHgnhgpďw蕶g`悷( c )( Ww肪 float  )
extern	int			DrawRotaStringF_WCHAR_T(						float x, float y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, unsigned int Color, unsigned int EdgeColor , int VerticalFlag , const wchar_t *String, size_t StringLength              ) ;		// ftHgtHgnhgpĕ]`悷( Ww肪 float  )
extern	int			DrawRotaFormatStringF_WCHAR_T(					float x, float y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, unsigned int Color, unsigned int EdgeColor , int VerticalFlag , const wchar_t *FormatString , ... ) ;		// ftHgtHgnhgpďw蕶]`悷( Ww肪 float  )
extern	int			DrawModiStringF_WCHAR_T(						float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, unsigned int Color, unsigned int EdgeColor , int VerticalFlag , const wchar_t *String, size_t StringLength              ) ;		// ftHgtHgnhgpĕό``悷( Ww肪 float  )
extern	int			DrawModiFormatStringF_WCHAR_T(					float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, unsigned int Color, unsigned int EdgeColor , int VerticalFlag , const wchar_t *FormatString , ... ) ;		// ftHgtHgnhgpďw蕶ό``悷( Ww肪 float  )

extern	int			DrawNumberPlusToI_WCHAR_T(                      int x, int y, const wchar_t *NoteString, int    Num, int RisesNum, unsigned int Color, unsigned int EdgeColor ) ;											// ftHgtHgnhgpĐ^̐lƂ̐̕xɕ`悷
extern 	int			DrawNumberPlusToF_WCHAR_T(                      int x, int y, const wchar_t *NoteString, double Num, int Length,   unsigned int Color, unsigned int EdgeColor ) ;											// ftHgtHgnhgpĕ_^̐lƂ̐̕xɕ`悷

extern	int			DrawStringToZBuffer_WCHAR_T(                    int x, int y, const wchar_t *String, size_t StringLength,                                                                 int WriteZMode /* DX_ZWRITE_MASK  */ ) ;									// ftHgtHgnhgpĂyobt@ɑ΂ĕ`悷
extern	int			DrawVStringToZBuffer_WCHAR_T(                   int x, int y, const wchar_t *String, size_t StringLength,                                                                 int WriteZMode /* DX_ZWRITE_MASK  */ ) ;									// ftHgtHgnhgpĂyobt@ɑ΂ĕ`悷( c )
extern	int			DrawFormatStringToZBuffer_WCHAR_T(              int x, int y,                                                                                        int WriteZMode /* DX_ZWRITE_MASK  */, const wchar_t *FormatString, ... ) ;	// ftHgtHgnhgpĂyobt@ɑ΂ďw蕶`悷
extern	int			DrawFormatVStringToZBuffer_WCHAR_T(             int x, int y,                                                                                        int WriteZMode /* DX_ZWRITE_MASK  */, const wchar_t *FormatString, ... ) ;	// ftHgtHgnhgpĂyobt@ɑ΂ďw蕶`悷( c )
extern	int			DrawExtendStringToZBuffer_WCHAR_T(              int x, int y, double ExRateX, double ExRateY, const wchar_t *String, size_t StringLength,                                 int WriteZMode /* DX_ZWRITE_MASK  */ ) ;									// ftHgtHgnhgpĂyobt@ɑ΂ĕg`悷
extern	int			DrawExtendVStringToZBuffer_WCHAR_T(             int x, int y, double ExRateX, double ExRateY, const wchar_t *String, size_t StringLength,                                 int WriteZMode /* DX_ZWRITE_MASK  */ ) ;									// ftHgtHgnhgpĂyobt@ɑ΂ĕg`悷( c )
extern	int			DrawExtendFormatStringToZBuffer_WCHAR_T(        int x, int y, double ExRateX, double ExRateY,                                                        int WriteZMode /* DX_ZWRITE_MASK  */, const wchar_t *FormatString, ... ) ;	// ftHgtHgnhgpĂyobt@ɑ΂ďw蕶g`悷
extern	int			DrawExtendFormatVStringToZBuffer_WCHAR_T(       int x, int y, double ExRateX, double ExRateY,                                                        int WriteZMode /* DX_ZWRITE_MASK  */, const wchar_t *FormatString, ... ) ;	// ftHgtHgnhgpĂyobt@ɑ΂ďw蕶g`悷( c )
extern	int			DrawRotaStringToZBuffer_WCHAR_T(				int x, int y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag , const wchar_t *String, size_t StringLength              ) ;		// ftHgtHgnhgpĕ]`悷
extern	int			DrawRotaFormatStringToZBuffer_WCHAR_T(			int x, int y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag , const wchar_t *FormatString , ... ) ;		// ftHgtHgnhgpďw蕶]`悷
extern	int			DrawModiStringToZBuffer_WCHAR_T(				int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4,                                      int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag , const wchar_t *String, size_t StringLength              ) ;		// ftHgtHgnhgpĕό``悷
extern	int			DrawModiFormatStringToZBuffer_WCHAR_T(			int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4,                                      int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag , const wchar_t *FormatString , ... ) ;		// ftHgtHgnhgpďw蕶ό``悷


extern	int			DrawStringToHandle_WCHAR_T(                     int x, int y, const wchar_t *String, size_t StringLength, unsigned int Color, int FontHandle, unsigned int EdgeColor , int VerticalFlag ) ;											// tHgnhgpĕ`悷
extern	int			DrawVStringToHandle_WCHAR_T(                    int x, int y, const wchar_t *String, size_t StringLength, unsigned int Color, int FontHandle, unsigned int EdgeColor ) ;																		// tHgnhgpĕ`悷( c )
extern	int			DrawFormatStringToHandle_WCHAR_T(               int x, int y, unsigned int Color, int FontHandle, const wchar_t *FormatString, ... ) ;																						// tHgnhgpďw蕶`悷
extern	int			DrawFormatVStringToHandle_WCHAR_T(              int x, int y, unsigned int Color, int FontHandle, const wchar_t *FormatString, ... ) ;																						// tHgnhgpďw蕶`悷( c )
extern	int			DrawExtendStringToHandle_WCHAR_T(               int x, int y, double ExRateX, double ExRateY, const wchar_t *String, size_t StringLength, unsigned int Color, int FontHandle, unsigned int EdgeColor , int VerticalFlag ) ;			// tHgnhgpĕg`悷
extern	int			DrawExtendVStringToHandle_WCHAR_T(              int x, int y, double ExRateX, double ExRateY, const wchar_t *String, size_t StringLength, unsigned int Color, int FontHandle, unsigned int EdgeColor ) ;										// tHgnhgpĕg`悷( c )
extern	int			DrawExtendFormatStringToHandle_WCHAR_T(         int x, int y, double ExRateX, double ExRateY, unsigned int Color, int FontHandle, const wchar_t *FormatString, ... ) ;														// tHgnhgpďw蕶g`悷
extern	int			DrawExtendFormatVStringToHandle_WCHAR_T(        int x, int y, double ExRateX, double ExRateY, unsigned int Color, int FontHandle, const wchar_t *FormatString, ... ) ;														// tHgnhgpďw蕶g`悷( c )
extern	int			DrawRotaStringToHandle_WCHAR_T(					int x, int y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, unsigned int Color, int FontHandle, unsigned int EdgeColor , int VerticalFlag , const wchar_t *String, size_t StringLength              ) ;		// tHgnhgpĕ]`悷
extern	int			DrawRotaFormatStringToHandle_WCHAR_T(			int x, int y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, unsigned int Color, int FontHandle, unsigned int EdgeColor , int VerticalFlag , const wchar_t *FormatString , ... ) ;		// tHgnhgpďw蕶]`悷
extern	int			DrawModiStringToHandle_WCHAR_T(					int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, unsigned int Color, int FontHandle, unsigned int EdgeColor , int VerticalFlag , const wchar_t *String, size_t StringLength              ) ;		// tHgnhgpĕό``悷
extern	int			DrawModiFormatStringToHandle_WCHAR_T(			int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, unsigned int Color, int FontHandle, unsigned int EdgeColor , int VerticalFlag , const wchar_t *FormatString , ... ) ;		// tHgnhgpďw蕶ό``悷

extern	int			DrawStringFToHandle_WCHAR_T(                    float x, float y, const wchar_t *String, size_t StringLength, unsigned int Color, int FontHandle, unsigned int EdgeColor , int VerticalFlag ) ;										// tHgnhgpĕ`悷( Ww肪 float  )
extern	int			DrawVStringFToHandle_WCHAR_T(                   float x, float y, const wchar_t *String, size_t StringLength, unsigned int Color, int FontHandle, unsigned int EdgeColor ) ;																	// tHgnhgpĕ`悷( c )( Ww肪 float  )
extern	int			DrawFormatStringFToHandle_WCHAR_T(              float x, float y, unsigned int Color, int FontHandle, const wchar_t *FormatString, ... ) ;																					// tHgnhgpďw蕶`悷( Ww肪 float  )
extern	int			DrawFormatVStringFToHandle_WCHAR_T(             float x, float y, unsigned int Color, int FontHandle, const wchar_t *FormatString, ... ) ;																					// tHgnhgpďw蕶`悷( c )( Ww肪 float  )
extern	int			DrawExtendStringFToHandle_WCHAR_T(              float x, float y, double ExRateX, double ExRateY, const wchar_t *String, size_t StringLength, unsigned int Color, int FontHandle, unsigned int EdgeColor , int VerticalFlag ) ;		// tHgnhgpĕg`悷( Ww肪 float  )
extern	int			DrawExtendVStringFToHandle_WCHAR_T(             float x, float y, double ExRateX, double ExRateY, const wchar_t *String, size_t StringLength, unsigned int Color, int FontHandle, unsigned int EdgeColor ) ;									// tHgnhgpĕg`悷( c )( Ww肪 float  )
extern	int			DrawExtendFormatStringFToHandle_WCHAR_T(        float x, float y, double ExRateX, double ExRateY, unsigned int Color, int FontHandle, const wchar_t *FormatString, ... ) ;													// tHgnhgpďw蕶g`悷( Ww肪 float  )
extern	int			DrawExtendFormatVStringFToHandle_WCHAR_T(       float x, float y, double ExRateX, double ExRateY, unsigned int Color, int FontHandle, const wchar_t *FormatString, ... ) ;													// tHgnhgpďw蕶g`悷( c )( Ww肪 float  )
extern	int			DrawRotaStringFToHandle_WCHAR_T(				float x, float y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, unsigned int Color, int FontHandle, unsigned int EdgeColor , int VerticalFlag , const wchar_t *String, size_t StringLength              ) ;		// tHgnhgpĕ]`悷( Ww肪 float  )
extern	int			DrawRotaFormatStringFToHandle_WCHAR_T(			float x, float y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, unsigned int Color, int FontHandle, unsigned int EdgeColor , int VerticalFlag , const wchar_t *FormatString , ... ) ;		// tHgnhgpďw蕶]`悷( Ww肪 float  )
extern	int			DrawModiStringFToHandle_WCHAR_T(				float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, unsigned int Color, int FontHandle, unsigned int EdgeColor , int VerticalFlag , const wchar_t *String, size_t StringLength              ) ;		// tHgnhgpĕό``悷( Ww肪 float  )
extern	int			DrawModiFormatStringFToHandle_WCHAR_T(			float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, unsigned int Color, int FontHandle, unsigned int EdgeColor , int VerticalFlag , const wchar_t *FormatString , ... ) ;		// tHgnhgpďw蕶ό``悷( Ww肪 float  )

extern	int			DrawNumberPlusToIToHandle_WCHAR_T(              int x, int y, const wchar_t *NoteString, int    Num, int RisesNum, unsigned int Color, int FontHandle, unsigned int EdgeColor ) ;											// tHgnhgpĐ^̐lƂ̐̕xɕ`悷
extern	int			DrawNumberPlusToFToHandle_WCHAR_T(              int x, int y, const wchar_t *NoteString, double Num, int Length,   unsigned int Color, int FontHandle, unsigned int EdgeColor ) ;											// tHgnhgpĕ_^̐lƂ̐̕xɕ`悷


// va_list ֐
extern	int			GetDrawFormatStringWidth_VaList(				const TCHAR *FormatString, va_list VaList ) ;																																				// ftHgtHgnhgpt̕`敝擾
extern	int			GetDrawExtendFormatStringWidth_VaList(			double ExRateX, const TCHAR *FormatString, va_list VaList ) ;																																// ftHgtHgnhgpt̕`敝擾( g嗦t )
extern	int			GetDrawFormatStringSize_VaList(					int *SizeX, int *SizeY, int *LineCount, const TCHAR *FormatString, va_list VaList ) ;																										// ftHgtHgnhgpt̕`敝EEs擾
extern	int			GetDrawExtendFormatStringSize_VaList(			int *SizeX, int *SizeY, int *LineCount, double ExRateX, double ExRateY, const TCHAR *FormatString, va_list VaList ) ;																		// ftHgtHgnhgpt̕`敝EEs擾( g嗦t )
extern	int			GetDrawFormatStringCharInfo_VaList(				DRAWCHARINFO *InfoBuffer, size_t InfoBufferSize, const TCHAR *FormatString, va_list VaList ) ;																								// ftHgtHgnhgpt̂P̏擾
extern	int			GetDrawExtendFormatStringCharInfo_VaList(		DRAWCHARINFO *InfoBuffer, size_t InfoBufferSize, double ExRateX, double ExRateY, const TCHAR *FormatString, va_list VaList ) ;																// ftHgtHgnhgpt̂P̏擾
extern	int			GetDrawFormatStringWidthToHandle_VaList(		int FontHandle, const TCHAR *FormatString, va_list VaList ) ;																																// tHgnhgpt̕`敝擾
extern	int			GetDrawExtendFormatStringWidthToHandle_VaList(	double ExRateX, int FontHandle, const TCHAR *FormatString, va_list VaList ) ;																												// tHgnhgpt̕`敝擾
extern	int			GetDrawFormatStringSizeToHandle_VaList(			int *SizeX, int *SizeY, int *LineCount, int FontHandle, const TCHAR *FormatString, va_list VaList ) ;																						// tHgnhgpt̕`敝EEs擾
extern	int			GetDrawExtendFormatStringSizeToHandle_VaList(	int *SizeX, int *SizeY, int *LineCount, double ExRateX, double ExRateY, int FontHandle, const TCHAR *FormatString, va_list VaList ) ;														// tHgnhgpt̕`敝EEs擾
extern	int			GetDrawFormatStringCharInfoToHandle_VaList(		DRAWCHARINFO *InfoBuffer, size_t InfoBufferSize, int FontHandle, const TCHAR *FormatString, va_list VaList ) ;																				// tHgnhgpt̂P̏擾
extern	int			GetDrawExtendFormatStringCharInfoToHandle_VaList( DRAWCHARINFO *InfoBuffer, size_t InfoBufferSize, double ExRateX, double ExRateY, int FontHandle, const TCHAR *FormatString, va_list VaList ) ;											// tHgnhgpt̂P̏擾

extern	int			DrawFormatString_VaList(						int x, int y,                                 unsigned int Color, const TCHAR *FormatString, va_list VaList ) ;																			// ftHgtHgnhgpďw蕶`悷
extern	int			DrawFormatVString_VaList(						int x, int y,                                 unsigned int Color, const TCHAR *FormatString, va_list VaList ) ;																			// ftHgtHgnhgpďw蕶`悷( c )
extern	int			DrawExtendFormatString_VaList(					int x, int y, double ExRateX, double ExRateY, unsigned int Color, const TCHAR *FormatString, va_list VaList ) ;																			// ftHgtHgnhgpďw蕶g`悷
extern	int			DrawExtendFormatVString_VaList(					int x, int y, double ExRateX, double ExRateY, unsigned int Color, const TCHAR *FormatString, va_list VaList ) ;																			// ftHgtHgnhgpďw蕶g`悷( c )
extern	int			DrawRotaFormatString_VaList(					int x, int y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, unsigned int Color, unsigned int EdgeColor, int VerticalFlag, const TCHAR *FormatString, va_list VaList ) ;	// ftHgtHgnhgpďw蕶]`悷
extern	int			DrawModiFormatString_VaList(					int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, unsigned int Color, unsigned int EdgeColor, int VerticalFlag, const TCHAR *FormatString, va_list VaList ) ;				// ftHgtHgnhgpďw蕶ό``悷
extern	int			DrawFormatStringF_VaList(						float x, float y,                                 unsigned int Color, const TCHAR *FormatString, va_list VaList ) ;																		// ftHgtHgnhgpďw蕶`悷( Ww肪 float  )
extern	int			DrawFormatVStringF_VaList(						float x, float y,                                 unsigned int Color, const TCHAR *FormatString, va_list VaList ) ;																		// ftHgtHgnhgpďw蕶`悷( c )( Ww肪 float  )
extern	int			DrawExtendFormatStringF_VaList(					float x, float y, double ExRateX, double ExRateY, unsigned int Color, const TCHAR *FormatString, va_list VaList ) ;																		// ftHgtHgnhgpďw蕶g`悷( Ww肪 float  )
extern	int			DrawExtendFormatVStringF_VaList(				float x, float y, double ExRateX, double ExRateY, unsigned int Color, const TCHAR *FormatString, va_list VaList ) ;																		// ftHgtHgnhgpďw蕶g`悷( c )( Ww肪 float  )
extern	int			DrawRotaFormatStringF_VaList(					float x, float y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, unsigned int Color, unsigned int EdgeColor, int VerticalFlag, const TCHAR *FormatString, va_list VaList ) ;		// ftHgtHgnhgpďw蕶]`悷( Ww肪 float  )
extern	int			DrawModiFormatStringF_VaList(					float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, unsigned int Color, unsigned int EdgeColor, int VerticalFlag, const TCHAR *FormatString, va_list VaList ) ;									// ftHgtHgnhgpďw蕶ό``悷( Ww肪 float  )
extern	int			DrawFormatStringToZBuffer_VaList(				int x, int y,                                                                                        int WriteZMode /* DX_ZWRITE_MASK  */ , const TCHAR *FormatString, va_list VaList ) ;									// ftHgtHgnhgpĂyobt@ɑ΂ďw蕶`悷
extern	int			DrawFormatVStringToZBuffer_VaList(				int x, int y,                                                                                        int WriteZMode /* DX_ZWRITE_MASK  */ , const TCHAR *FormatString, va_list VaList ) ;									// ftHgtHgnhgpĂyobt@ɑ΂ďw蕶`悷( c )
extern	int			DrawExtendFormatStringToZBuffer_VaList(			int x, int y, double ExRateX, double ExRateY,                                                        int WriteZMode /* DX_ZWRITE_MASK  */ , const TCHAR *FormatString, va_list VaList ) ;									// ftHgtHgnhgpĂyobt@ɑ΂ďw蕶g`悷
extern	int			DrawExtendFormatVStringToZBuffer_VaList(		int x, int y, double ExRateX, double ExRateY,                                                        int WriteZMode /* DX_ZWRITE_MASK  */ , const TCHAR *FormatString, va_list VaList ) ;									// ftHgtHgnhgpĂyobt@ɑ΂ďw蕶g`悷( c )
extern	int			DrawRotaFormatStringToZBuffer_VaList(			int x, int y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag , const TCHAR *FormatString , va_list VaList ) ;				// ftHgtHgnhgpĂyobt@ɑ΂ďw蕶]`悷
extern	int			DrawModiFormatStringToZBuffer_VaList(			int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4,                                      int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag , const TCHAR *FormatString , va_list VaList ) ;				// ftHgtHgnhgpĂyobt@ɑ΂ďw蕶ό``悷

extern	int			DrawFormatStringToHandle_VaList(				int x, int y, unsigned int Color, int FontHandle, const TCHAR *FormatString, va_list VaList ) ;																											// tHgnhgpďw蕶`悷
extern	int			DrawFormatVStringToHandle_VaList(				int x, int y, unsigned int Color, int FontHandle, const TCHAR *FormatString, va_list VaList ) ;																											// tHgnhgpďw蕶`悷( c )
extern	int			DrawExtendFormatStringToHandle_VaList(			int x, int y, double ExRateX, double ExRateY, unsigned int Color, int FontHandle, const TCHAR *FormatString, va_list VaList ) ;																			// tHgnhgpďw蕶g`悷
extern	int			DrawExtendFormatVStringToHandle_VaList(			int x, int y, double ExRateX, double ExRateY, unsigned int Color, int FontHandle, const TCHAR *FormatString, va_list VaList ) ;																			// tHgnhgpďw蕶g`悷( c )
extern	int			DrawRotaFormatStringToHandle_VaList(			int x, int y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, unsigned int Color, int FontHandle, unsigned int EdgeColor, int VerticalFlag, const TCHAR *FormatString, va_list VaList ) ;		// tHgnhgpďw蕶]`悷
extern	int			DrawModiFormatStringToHandle_VaList(			int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, unsigned int Color, int FontHandle, unsigned int EdgeColor, int VerticalFlag, const TCHAR *FormatString, va_list VaList ) ;				// tHgnhgpďw蕶ό``悷
extern	int			DrawFormatStringFToHandle_VaList(				float x, float y, unsigned int Color, int FontHandle, const TCHAR *FormatString, va_list VaList ) ;																										// tHgnhgpďw蕶`悷( Ww肪 float  )
extern	int			DrawFormatVStringFToHandle_VaList(				float x, float y, unsigned int Color, int FontHandle, const TCHAR *FormatString, va_list VaList ) ;																										// tHgnhgpďw蕶`悷( c )( Ww肪 float  )
extern	int			DrawExtendFormatStringFToHandle_VaList(			float x, float y, double ExRateX, double ExRateY, unsigned int Color, int FontHandle, const TCHAR *FormatString, va_list VaList ) ;																		// tHgnhgpďw蕶g`悷( Ww肪 float  )
extern	int			DrawExtendFormatVStringFToHandle_VaList(		float x, float y, double ExRateX, double ExRateY, unsigned int Color, int FontHandle, const TCHAR *FormatString, va_list VaList ) ;																		// tHgnhgpďw蕶g`悷( c )( Ww肪 float  )
extern	int			DrawRotaFormatStringFToHandle_VaList(			float x, float y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, unsigned int Color, int FontHandle, unsigned int EdgeColor, int VerticalFlag, const TCHAR *FormatString, va_list VaList ) ;// tHgnhgpďw蕶]`悷( Ww肪 float  )
extern	int			DrawModiFormatStringFToHandle_VaList(			float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, unsigned int Color, int FontHandle, unsigned int EdgeColor, int VerticalFlag, const TCHAR *FormatString, va_list VaList ) ;							// tHgnhgpďw蕶ό``悷( Ww肪 float  )
extern	int			DrawFormatStringToHandleToZBuffer_VaList(		int x, int y, int FontHandle,                                                                                        int WriteZMode /* DX_ZWRITE_MASK  */ , const TCHAR *FormatString, va_list VaList ) ;							// tHgnhgpĂyobt@ɑ΂ďw蕶`悷
extern	int			DrawFormatVStringToHandleToZBuffer_VaList(		int x, int y, int FontHandle,                                                                                        int WriteZMode /* DX_ZWRITE_MASK  */ , const TCHAR *FormatString, va_list VaList ) ;							// tHgnhgpĂyobt@ɑ΂ďw蕶`悷( c )
extern	int			DrawExtendFormatStringToHandleToZBuffer_VaList(	int x, int y, double ExRateX, double ExRateY, int FontHandle,                                                        int WriteZMode /* DX_ZWRITE_MASK  */ , const TCHAR *FormatString, va_list VaList ) ;							// tHgnhgpĂyobt@ɑ΂ďw蕶g`悷
extern	int			DrawExtendFormatVStringToHandleToZBuffer_VaList(int x, int y, double ExRateX, double ExRateY, int FontHandle,                                                        int WriteZMode /* DX_ZWRITE_MASK  */ , const TCHAR *FormatString, va_list VaList ) ;							// tHgnhgpĂyobt@ɑ΂ďw蕶g`悷( c )
extern	int			DrawRotaFormatStringToHandleToZBuffer_VaList(	int x, int y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag, const TCHAR *FormatString, va_list VaList ) ;		// tHgnhgpĂyobt@ɑ΂ďw蕶]`悷
extern	int			DrawModiFormatStringToHandleToZBuffer_VaList(	int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag, const TCHAR *FormatString, va_list VaList ) ;											// tHgnhgpĂyobt@ɑ΂ďw蕶ό``悷


// ˑ֌W
extern	int			InitFontManage_PF( void ) ;																																// InitFontManage ̊ˑs֐
extern	int			TermFontManage_PF( void ) ;																																// TermFontManage ̊ˑs֐

extern	int			CreateFontToHandle_PF( CREATEFONTTOHANDLE_GPARAM *GParam, FONTMANAGE *	ManageData, int DefaultCharSet ) ;												// CreateFontToHandle ̊ˑs֐
extern	int			CreateFontToHandle_Error_PF( FONTMANAGE * ManageData ) ;																								// CreateFontToHandle ̊ˑG[s֐
extern	int			TerminateFontHandle_PF( FONTMANAGE *ManageData ) ;																										// TerminateFontHandle ̊ˑs֐

extern	int			SetupFontCache_PF( CREATEFONTTOHANDLE_GPARAM *GParam, FONTMANAGE *ManageData, int ASyncThread ) ;														// SetupFontCache ̊ˑs֐

extern	int			FontCacheCharAddToHandle_Timing0_PF( FONTMANAGE *ManageData ) ;																							// FontCacheCharaAddToHandle̊ˑs֐( sӏ 0 )
extern	int			FontCacheCharAddToHandle_Timing1_PF( FONTMANAGE *ManageData, FONTCHARDATA *CharData, DWORD CharCode, DWORD IVSCode, int TextureCacheUpdate ) ;			// FontCacheCharaAddToHandle̊ˑs֐( sӏ 1 )
extern	int			FontCacheCharAddToHandle_Timing2_PF( FONTMANAGE *ManageData ) ;																							// FontCacheCharaAddToHandle̊ˑs֐( sӏ 2 )

extern	int			EnumFontName_PF( ENUMFONTDATA *EnumFontData, int IsEx = FALSE, int CharSet = -1 ) ;																		// EnumFontName ̊ˑs֐




#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_FONT

#endif // DX_FONT_H
