// ----------------------------------------------------------------------------
// 
// 		cwCu		`vO
// 
// 				Ver 3.23a
// 
// ----------------------------------------------------------------------------

// cwCu쐬p`
#define DX_MAKE

#include "DxGraphics.h"

#ifndef DX_NON_GRAPHICS

// CN[h----------------------------------------------------------------
#include "DxLib.h"
#include "DxStatic.h"
#include "DxFile.h"
#include "DxSound.h"
#include "DxGraphicsFilter.h"
#include "DxMask.h"
#include "DxMemImg.h"
#include "DxMath.h"
#include "DxFont.h"
#include "DxLog.h"
#include "DxASyncLoad.h"
#include "DxUseCLib.h"
#include "DxSoftImage.h"

#include "DxModel.h"

#include "DxBaseImage.h"
#include "DxMovie.h"
#include "DxInput.h"
#include "DxBaseFunc.h"
#include "DxSystem.h"
#include "DxMemory.h"

#ifdef WINDOWS_DESKTOP_OS
#include "Windows/DxWinAPI.h"
#endif // WINDOWS_DESKTOP_OS

#ifdef WINDOWS_DESKTOP_OS
#include "Windows/DxGraphicsWin.h"
#endif // WINDOWS_DESKTOP_OS

#ifdef __ANDROID__
#include "Android/DxGraphicsAndroid.h"
#endif // __ANDROID__

#ifdef __APPLE__
    #include "TargetConditionals.h"
    #if TARGET_OS_IPHONE
		#include "iOS/DxGraphicsiOS.h"
    #endif // TARGET_OS_IPHONE
#endif // __APPLE__





#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` -----------------------------------------------------------------

// NbsOtO
#define CLIP_XP							(0x01)				// X+ɃNbv
#define CLIP_XM							(0x02)				// X-ɃNbv
#define CLIP_YP							(0x04)				// Y+ɃNbv
#define CLIP_YM							(0x08)				// Y-ɃNbv
#define CLIP_ZP							(0x10)				// Z+ɃNbv
#define CLIP_ZM							(0x20)				// Z-ɃNbv

// VhE}bv̏[x␳l
#define DEFAULT_SHADOWMAP_ADJUST_DEPTH		( 0.002f )
#define DEFAULT_SHADOWMAP_GRADATION_RANGE	( 0.0007f )
#define DEFAULT_SHADOWMAP_BLUR_PARAM		( 0 )

// eNX`sNZtH[}bg̃rbgfvXCfbNX`
#define TEX_BITDEPTH_16				(0)
#define TEX_BITDEPTH_32 			(1)
#define PIXELBYTE( x )				( x == TEX_BITDEPTH_16 ? 2 : 4 )

// eNX`[̕L̍őTCYƍŏTCY
#define MIN_TEXTURE_SIZE			(1)

// A`GCAXt̐`p̃eNX`̃TCY
#define LINE_TEX_SIZE				(8)

// A`GCAXt̐``p̃eNX`̃TCY
#define LINEBOX_TEX_SIZE			(16)

// ~`W̍ő吔
#define CIRCLE_MAX_POSNUM			(256)

// RQrbgFJ[l̍쐬
#define SETUP32BITCOLOR( Color, FColor )		\
{\
	int cr, cg, cb ;\
	DWORD NoneRevMask ;\
\
	GetColor_Macro( 0, 0, 0, NoneRevMask ) ;\
	NoneRevMask = ~NoneRevMask ;\
	GetColor2_Macro( Color, cr,  cg,  cb  ) ;\
	if( ( GSYS.DrawSetting.bDrawBright & 0x00ffffff ) != 0x00ffffff )\
	{\
		RGBCOLOR *bright ;\
\
		bright = &GSYS.DrawSetting.DrawBright ;	\
		cr  = bright->Red   * cr / 255 ;\
		cg  = bright->Green * cg / 255 ;\
		cb  = bright->Blue  * cb / 255 ;\
		GetColor_Macro( cr, cg, cb, Color ) ;\
	}\
	Color  &= NoneRevMask ;\
	if( GSYS.DrawSetting.BlendMode == DX_BLENDMODE_PMA_INVSRC ||\
		GSYS.DrawSetting.BlendMode == DX_BLENDMODE_INVSRC )\
	{\
		FColor = ( 0xff000000 ) | ( ( 0xff - cr ) << 16 ) | ( ( 0xff - cg ) << 8 ) | ( 0xff - cb ) ;\
	}\
	else\
	{\
		FColor = ( 0xff000000 ) | ( cr << 16 ) | ( cg << 8 ) | ( cb ) ;\
	}\
}

// A`GCAX}``̒^O
#define AA_DRAW_BEGIN		\
	int OldDrawMode = -1 ;\
	int OldBlendMode = -1 ;\
	int OldBlendParam = -1 ;\
	DWORD OrigColor = GSYS.DrawSetting.bDrawBright ;\
	if( GSYS.DrawSetting.AADrawInfoValid == FALSE )\
	{\
		if( GSYS.DrawSetting.DrawMode != DX_DRAWMODE_BILINEAR )\
		{\
			OldDrawMode = GSYS.DrawSetting.DrawMode ;\
			OldBlendParam = GSYS.DrawSetting.BlendParam ;\
			NS_SetDrawMode( DX_DRAWMODE_BILINEAR ) ;\
		}\
		if( GSYS.DrawSetting.BlendMode == DX_BLENDMODE_PMA_INVSRC )\
		{\
			OldBlendMode = GSYS.DrawSetting.BlendMode ;\
			OldBlendParam = GSYS.DrawSetting.BlendParam ;\
			NS_SetDrawBlendMode( DX_BLENDMODE_PMA_ALPHA, GSYS.DrawSetting.BlendParam ) ;\
		}\
		else\
		if( GSYS.DrawSetting.BlendMode == DX_BLENDMODE_INVSRC )\
		{\
			OldBlendMode = GSYS.DrawSetting.BlendMode ;\
			OldBlendParam = GSYS.DrawSetting.BlendParam ;\
			NS_SetDrawBlendMode( DX_BLENDMODE_ALPHA, GSYS.DrawSetting.BlendParam ) ;\
		}\
		else\
		if( GSYS.DrawSetting.BlendMode == DX_BLENDMODE_MUL )\
		{\
			OldBlendMode = GSYS.DrawSetting.BlendMode ;\
			OldBlendParam = GSYS.DrawSetting.BlendParam ;\
			NS_SetDrawBlendMode( DX_BLENDMODE_MULA, 255 ) ;\
		}\
	}

// A`GCAX}``̒^ÔQ
#define AA_DRAW_BEGIN_2		\
	DWORD FColor ;\
	SETUP32BITCOLOR( Color, FColor ) ;\
	Graphics_DrawSetting_SetDrawBrightToOneParam( FColor ) ;

// A`GCAX}``̒^㏈
#define AA_DRAW_END		\
	if( GSYS.DrawSetting.AADrawInfoValid == FALSE )\
	{\
		if( OldDrawMode != -1 )\
		{\
			NS_SetDrawMode( OldDrawMode ) ;\
		}\
		if( OldBlendMode != -1 )\
		{\
			NS_SetDrawBlendMode( OldBlendMode, OldBlendParam ) ;\
		}\
	}\
	Graphics_DrawSetting_SetDrawBrightToOneParam( OrigColor ) ;

// pbg摜̗L`FbN
#define PALETTEIMAGECHK( HAND, MEMIMG )														\
{																							\
	IMAGEDATA *Image ;																	\
																							\
	if( GRAPHCHK( ( HAND ), Image ) )														\
		return -1 ;																			\
	if( Image->Orig->FormatDesc.TextureFlag ) return -1 ;									\
	MEMIMG = &Image->Soft.MemImg;															\
	if( MEMIMG->Base->UsePalette == 0 ) return -1;											\
}

// Cgnh̗L`FbN
#define LIGHTCHK( HAND, LPOINT, ERR )										\
	if( ( ( (HAND) & DX_HANDLEERROR_MASK ) != 0 ) ||											\
		( ( (HAND) & DX_HANDLETYPE_MASK ) != DX_HANDLETYPE_MASK_LIGHT ) ||							\
		( ( (HAND) & DX_HANDLEINDEX_MASK ) >= MAX_LIGHT_NUM ) ||								\
		( ( LPOINT = GSYS.Light.Data[ (HAND) & DX_HANDLEINDEX_MASK ] ) == NULL ) ||				\
		( (int)( (LPOINT)->ID << DX_HANDLECHECK_ADDRESS ) != ( (HAND) & DX_HANDLECHECK_MASK ) ) )\
	{																							\
		return (ERR) ;																			\
	}

// ǂݍݎ̓ߐFύX
#define LUTRANS_START( Img )	\
	int _TransColor = GSYS.CreateImage.TransColor ; \
	if( GSYS.CreateImage.LeftUpColorIsTransColorFlag == TRUE )\
	{\
		GSYS.CreateImage.TransColor = NS_GetGraphImageFullColorCode( Img, 0, 0 ) & 0xffffff ;\
		BASEIM.TransColor = GSYS.CreateImage.TransColor ;\
	}

// ǂݍݎ̓ߐFύX
#define LUTRANS_GPARAM( GParam, Img )	\
	if( GParam->LeftUpColorIsTransColorFlag == TRUE ) GParam->InitHandleGParam.TransColor = NS_GetGraphImageFullColorCode( Img, 0, 0 ) & 0xffffff ;

#define LUTRANS_RE_START( Img, GrH )		\
	LUTRANS_START( Img ) \

#define LUTRANS_RE_GPARAM( GParam, Img, GrH )		\
	LUTRANS_GPARAM( GParam, Img ) \

#define LUTRANS_RE_DIV_START( Img, GrH, Num )	\
	LUTRANS_START( Img ) \

#define LUTRANS_RE_DIV_GPARAM( GParam, Img, GrH, Num )	\
	LUTRANS_GPARAM( GParam, Img ) \

#define LUTRANS_END		\
	GSYS.CreateImage.TransColor = _TransColor ;	\
	BASEIM.TransColor = _TransColor ;

// Zς݃At@̃uh[hǂ̎擾
#define IS_PMA_DRAWBLENDMODE			\
	( (	GSYS.DrawSetting.BlendMode == DX_BLENDMODE_PMA_ALPHA	||	\
		GSYS.DrawSetting.BlendMode == DX_BLENDMODE_PMA_ADD		||	\
		GSYS.DrawSetting.BlendMode == DX_BLENDMODE_PMA_SUB		||	\
		GSYS.DrawSetting.BlendMode == DX_BLENDMODE_PMA_INVSRC	||	\
		GSYS.DrawSetting.BlendMode == DX_BLENDMODE_PMA_ALPHA_X4	||	\
		GSYS.DrawSetting.BlendMode == DX_BLENDMODE_PMA_ADD_X4	) ? TRUE : FALSE )

// \̐錾 -----------------------------------------------------------------

// 摜ǂݍݏɕKvȕϐZ߂
struct CREATEGRAPH_LOADBASEIMAGE_PARAM
{
	int						UseTempBaseImage ;
	int						LoadHr ;
	BASEIMAGE				TempRgbBaseImage ;
	BASEIMAGE				TempAlphaBaseImage ;
	BASEIMAGE *				UseRgbBaseImage ;
	BASEIMAGE *				UseAlphaBaseImage ;
} ;

// l̑傫Wlg`ɂvZx̒ቺ}鏈ōssݒŕKvȏ
struct LARGE3DPOSITIONSUPPORT_DRAWINFO
{
	MATRIX_D				BackupWorldMatrix ;
	MATRIX_D				BackupViewMatrix ;
} ;

// f[^` -----------------------------------------------------------------

// 8x8  A`GCAXt̐`p̉摜
static BYTE LineTexTga8x8TextureImage[ 64 ] = 
{
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,
	0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,
	0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,
	0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
} ;

// 16x16  A`GCAXt̐``p̉摜
static BYTE LineBoxTexTga16x16TextureImage[ 16 * 16 ] = 
{
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,
	0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,
	0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,
	0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,
	0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,
	0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,
	0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,
	0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,
	0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,
	0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,
	0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,
	0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
} ;

// 8x8  A`GCAXt̐`p̉摜
static BYTE LineOneThicknessTexTga8x8TextureImage[ 64 ] = 
{
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0xff,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0xff,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0xff,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0xff,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
} ;

// 16x16  A`GCAXt̐``p̉摜
static BYTE LineBoxOneThicknessTexTga16x16TextureImage[ 16 * 16 ] = 
{
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,
	0x00,0x00,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0x00,0x00,
	0x00,0x00,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0x00,0x00,
	0x00,0x00,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0x00,0x00,
	0x00,0x00,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0x00,0x00,
	0x00,0x00,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0x00,0x00,
	0x00,0x00,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0x00,0x00,
	0x00,0x00,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0x00,0x00,
	0x00,0x00,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0x00,0x00,
	0x00,0x00,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0x00,0x00,
	0x00,0x00,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0x00,0x00,
	0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
} ;

// 4x4̃_ȕɉ]邽߂̃mCYeNX`摜( float^Cv )
static BYTE RandomKernelRotationTextureImage[ 4 * 4 * 4 ] = 
{
	0x77,0x8b,0x12,0xbf,
	0x46,0x57,0x4a,0x3e,
	0x4a,0x39,0x13,0x3f,
	0xcb,0xb0,0x04,0xbf,
	0x50,0xcd,0x88,0xbe,
	0x8c,0x2a,0xbf,0x3e,
	0xbc,0xee,0x11,0x3f,
	0xed,0xd8,0x2c,0x3e,
	0x98,0x09,0xcd,0xbe,
	0x02,0x4e,0x3a,0xbf,
	0x04,0x2d,0x66,0xbf,
	0x6e,0xfb,0x6f,0xbe,
	0x69,0x7d,0x90,0xbe,
	0x26,0xf3,0x63,0x3e,
	0x25,0x65,0xf0,0x3e,
	0x53,0x6b,0x3e,0x3f,
} ;

// `̊{Iȏ
GRAPHICSSYSTEMDATA GraphicsSysData ;

// ֐錾 -------------------------------------------------------------------

// 摜֌W֐
__inline static int		Graphics_Image_CheckBlendGraphSize( IMAGEDATA *GraphData ) ;		// uh摜Ƃ̑傫`FbN
		 static void	Graphics_Image_DefaultRestoreGraphFunction( void ) ;				// ftHg̃OtBbN֐
		 static void	Graphics_Image_CreateGraph_LoadBaseImage(      LOADGRAPH_PARAM *Param, CREATEGRAPH_LOADBASEIMAGE_PARAM *LParam ) ;		// CreateGraph  CreateDivGraph ̋ʂ BASEIMAGE \z֐
		 static void	Graphics_Image_CreateGraph_TerminateBaseImage( LOADGRAPH_PARAM *Param, CREATEGRAPH_LOADBASEIMAGE_PARAM *LParam ) ;		// CreateGraph  CreateDivGraph ̋ʂ BASEIMAGE n֐







// ʊ֌W֐
static int Graphics_Screen_CheckDisplaySetting( int ScreenSizeX, int ScreenSizeY, int ColorBitDepth ) ;		// w̉𑜓xΉĂ邩ǂ𒲂ׂ֐
static void Graphics_Screen_UpdateFlipTime( void ) ;														// ScreenFlipTime̍XV







// `֌W֐
__inline static void	Graphics_Draw_VectorTransformToBillboard( VECTOR *Vector, VECTOR *Position ) ;										// r{[hp̍svZ
		 static int		Graphics_Draw_ModiGraphBase( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int GrHandle, int TransFlag, bool SimpleDrawFlag ) ;
		 static int		Graphics_Draw_ModiGraphFBase( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, int GrHandle, int TransFlag, bool SimpleDrawFlag ) ;
		 static void	Graphics_Draw_BeginLarge3DPositionSupportDraw( LARGE3DPOSITIONSUPPORT_DRAWINFO *DrawInfo, VECTOR_D BasePosition ) ;	// l̑傫Wlg`ɂvZx̒ቺ}ׂ̏s
		 static void	Graphics_Draw_EndLarge3DPositionSupportDraw( const LARGE3DPOSITIONSUPPORT_DRAWINFO *DrawInfo ) ;					// l̑傫Wlg`ɂvZx̒ቺ}ׂ̏ōsύXɖ߂








// n[hEFAANZ[^gp_O֌W֐
static int	Graphics_Hardware_DrawChipMap( int Sx, int Sy, int XNum, int YNum, const int *MapData, int MapDataPitch, int ChipTypeNum, const int *ChipGrHandle, int TransFlag ) ;	// n[hEGAANZ[^gp DrawChipMap
static int	Graphics_Hardware_DrawTile( int x1, int y1, int x2, int y2, int Tx, int Ty, double ExtRate, double Angle, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag ) ;	// n[hEGAANZ[^gp DrawTile








// \tgEGA_O֐
static int	Graphics_Software_Initialize( void ) ;																										// \tgEGA_Ȍs
static int	Graphics_Software_Terminate( void ) ;																										// \tgEGA_Ǒns
static int  Graphics_Software_DrawGraph(            int x,  int y,                                                                  IMAGEDATA *Image, int TransFlag ) ;						// \tgEGA_O DrawGraph
static int  Graphics_Software_DrawExtendGraph(      int x1, int y1, int x2, int y2,                                                 IMAGEDATA *Image, int TransFlag ) ;						// \tgEGA_O DrawExtendGraph
static int  Graphics_Software_DrawRotaGraph(        float x, float y, double ExRate, double Angle,                                  IMAGEDATA *Image, int TransFlag, int ReverseXFlag, int ReverseYFlag ) ;		// \tgEGA_O DrawRotaGraph
static int  Graphics_Software_DrawRotaGraphFast(    float x, float y, float  ExRate, float  Angle,                                  IMAGEDATA *Image, int TransFlag, int ReverseXFlag, int ReverseYFlag ) ;		// \tgEGA_O DrawRotaGraphFast
static int  Graphics_Software_DrawPoly(             DX_POINTDATA *p,                                                                IMAGEDATA *Image, int TransFlag, unsigned int Color ) ;
static int  Graphics_Software_DrawModiGraph(        int   x1, int   y1, int   x2, int   y2, int   x3, int   y3, int   x4, int   y4, IMAGEDATA *Image, int TransFlag ) ;						// \tgEGA_O DrawModiGraph
static int  Graphics_Software_DrawModiGraphF(       float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA *Image, int TransFlag ) ;						// \tgEGA_O DrawModiGraphF
static int  Graphics_Software_DrawChipMap(          int Sx, int Sy, int XNum, int YNum, const int *MapData, int MapDataPitch, int ChipTypeNum, const int *ChipGrHandle, int TransFlag ) ;	// \tgEGA_O DrawChipMap
static int  Graphics_Software_DrawTile(             int x1, int y1, int x2, int y2, int Tx, int Ty, double ExtRate, double Angle,   IMAGEDATA *Image, int TransFlag ) ;						// \tgEGA_O DrawTile
static int  Graphics_Software_DrawFillBox(          int x1, int y1, int x2, int y2,                                 unsigned int Color ) ;						// \tgEGA_O DrawFillBox
static int  Graphics_Software_DrawLineBox(          int x1, int y1, int x2, int y2,                                 unsigned int Color ) ;						// \tgEGA_O DrawLineBox
static int  Graphics_Software_DrawLine(             int x1, int y1, int x2, int y2,                                 unsigned int Color ) ;						// \tgEGA_O DrawLine
static int  Graphics_Software_DrawCircle_Thickness( int x, int y, int r,                                            unsigned int Color, int Thickness ) ;		// \tgEGA_O DrawCircle( w肠 )
static int  Graphics_Software_DrawOval_Thickness(   int x, int y, int rx, int ry,                                   unsigned int Color, int Thickness ) ;		// \tgEGA_O DrawOval( w肠 )
static int  Graphics_Software_DrawCircle(           int x, int y, int r,                                            unsigned int Color, int FillFlag, int Rx_One_Minus = FALSE, int Ry_One_Minus = FALSE ) ;		// \tgEGA_O DrawCircle
static int  Graphics_Software_DrawOval(             int x, int y, int rx, int ry,                                   unsigned int Color, int FillFlag, int Rx_One_Minus = FALSE, int Ry_One_Minus = FALSE ) ;		// \tgEGA_O DrawOval
static int  Graphics_Software_DrawTriangle(         int x1, int y1, int x2, int y2, int x3, int y3,                 unsigned int Color, int FillFlag ) ;		// \tgEGA_O DrawTriangle
static int  Graphics_Software_DrawQuadrangle(       int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, unsigned int Color, int FillFlag ) ;		// \tgEGA_O DrawQuadrangle
static int  Graphics_Software_DrawPixel(            int x, int y,                                                   unsigned int Color ) ;						// \tgEGA_O DrawPixel
static int  Graphics_Software_DrawPixelSet(         const POINTDATA *PointData, int Num ) ;																// \tgEGA_O DrawPixelSet
static int  Graphics_Software_DrawLineSet(          const LINEDATA  *LineData,  int Num ) ;																// \tgEGA_O DrawLineSet
static int  Graphics_Software_DrawBoxSet(           const RECTDATA  *RectData,  int Num ) ;																// \tgEGA_O DrawBoxSet



__inline	static DWORD GetDiffuseColor( void )															// ݂̃fBt[YJ[𓾂
			{
				return  ( ( DWORD )GSYS.DrawSetting.DrawBright.Red   << 16 ) |
						( ( DWORD )GSYS.DrawSetting.DrawBright.Green << 8  ) |
						( ( DWORD )GSYS.DrawSetting.DrawBright.Blue        ) |
						( ( ( GSYS.DrawSetting.BlendMode != DX_BLENDMODE_NOBLEND || GSYS.DrawSetting.UseNoBlendModeParam ) ? ( DWORD )GSYS.DrawSetting.BlendParam : 255 ) << 24 ) ;
			}

// vO -----------------------------------------------------------------

// 摜֌W֐

// uh摜Ƃ̑傫`FbN
__inline static int Graphics_Image_CheckBlendGraphSize( IMAGEDATA *GraphData )
{
	IMAGEDATA *BlendData ;

	// n[hEGAgpꍇ͑傫̐
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		return 0 ;

	// \tgEGȀꍇ̓uh摜W[h DX_BLENDGRAPH_POSMODE_DRAWGRAPH ̂ݑΉ
	if( GSYS.DrawSetting.BlendGraphPosMode != DX_BLENDGRAPH_POSMODE_DRAWGRAPH )
		return -1 ;

	if( GRAPHCHK( GSYS.DrawSetting.BlendGraph, BlendData ) )
		return -1 ;

	// uh摜傫AEg
	return ( ( BlendData->WidthI  - GraphData->WidthI  ) |
		     ( BlendData->HeightI - GraphData->HeightI ) ) & 0x80000000 ? -1 : 0 ;
}

// ftHg̃OtBbN֐
static void Graphics_Image_DefaultRestoreGraphFunction( void )
{
	IMAGEDATA *Image ;
	IMAGEDATA *FileBackImage ;
	IMAGEDATA *MemBackImage ;
	int         i ;
	int         ImageDataArea ;
	BASEIMAGE   FileRgbImage ;
	BASEIMAGE   FileAlphaImage ;
	int         FileRgbLoad ;
	int         FileAlphaLoad ;
	BASEIMAGE   MemRgbImage ;
	BASEIMAGE   MemAlphaImage ;
	int         MemRgbLoad ;
	int         MemAlphaLoad ;
	int         LoadHr ;
	int         IsDXT ;
	RECT        SrcRect ;
	LOADBASEIMAGE_GPARAM LoadBaseImageGParam ;

	_MEMSET( &FileRgbImage, 0, sizeof( FileRgbImage ) ) ;
	_MEMSET( &MemRgbImage, 0, sizeof( MemRgbImage ) ) ;

	DXST_LOGFILE_ADDUTF16LE( "\xb0\x30\xe9\x30\xd5\x30\xa3\x30\xc3\x30\xaf\x30\x92\x30\xa9\x5f\x30\x5e\x57\x30\x7e\x30\x59\x30\x0a\x00\x00"/*@ L"OtBbN𕜋A܂\n" @*/ ) ;

	// ׂẴOtBbN
	ImageDataArea  = HandleManageArray[ DX_HANDLETYPE_GRAPH ].AreaMax ;
	FileBackImage  = NULL ;
	FileRgbLoad    = FALSE ;
	FileAlphaLoad  = FALSE ;
	MemBackImage   = NULL ;
	MemRgbLoad     = FALSE ;
	MemAlphaLoad   = FALSE ;
	if( HandleManageArray[ DX_HANDLETYPE_GRAPH ].InitializeFlag )
	{
		// AtO|
		for( i = HandleManageArray[ DX_HANDLETYPE_GRAPH ].AreaMin ; i <= ImageDataArea ; i ++ )
		{
			Image = ( IMAGEDATA * )HandleManageArray[ DX_HANDLETYPE_GRAPH ].Handle[ i ] ;
			if( Image == NULL || Image->Orig == NULL ) continue ;

			Image->Orig->RestoreFlag = FALSE ;
		}

		for( i = HandleManageArray[ DX_HANDLETYPE_GRAPH ].AreaMin ; i <= ImageDataArea ; i ++ )
		{
			Image = ( IMAGEDATA * )HandleManageArray[ DX_HANDLETYPE_GRAPH ].Handle[ i ] ;
			if( Image == NULL || Image->ReadBase == NULL ) continue ;

			// ɕAĂ牽Ɏ
			if( Image->Orig->RestoreFlag )
			{
				continue ;
			}

			// cwsntH[}bg𒲂ׂĂ
			IsDXT = 
				( Image->Orig->ColorFormat == DX_GRAPHICSIMAGE_FORMAT_3D_DXT1 ||
				  Image->Orig->ColorFormat == DX_GRAPHICSIMAGE_FORMAT_3D_DXT2 ||
				  Image->Orig->ColorFormat == DX_GRAPHICSIMAGE_FORMAT_3D_DXT3 ||
				  Image->Orig->ColorFormat == DX_GRAPHICSIMAGE_FORMAT_3D_DXT4 ||
				  Image->Orig->ColorFormat == DX_GRAPHICSIMAGE_FORMAT_3D_DXT5 ||
				  Image->Orig->ColorFormat == DX_GRAPHICSIMAGE_FORMAT_3D_BC7_UNORM ||
				  Image->Orig->ColorFormat == DX_GRAPHICSIMAGE_FORMAT_3D_BC7_UNORM_SRGB ) ? TRUE : FALSE ;

			// t@Cǂݍ񂾏ꍇ̓t@C摜𕜌
			if( Image->ReadBase->FileName )
			{
				// ÕOtBbNƃpXƃt@Cꍇ͓ǂݍ݂Ȃ
				if( FileBackImage == NULL ||
					FileRgbLoad == FALSE ||
					FileBackImage->ReadBase->FileName == NULL ||
					_WCSCMP( Image->ReadBase->FileName, FileBackImage->ReadBase->FileName ) != 0 ||
					Image->ReadBase->ReverseFlag != FileBackImage->ReadBase->ReverseFlag ||
					Image->ReadBase->ConvertPremultipliedAlpha != FileBackImage->ReadBase->ConvertPremultipliedAlpha )
				{
					// BASEIMAGE ̌n
					if( FileRgbLoad == TRUE )
					{
						NS_ReleaseGraphImage( &FileRgbImage ) ;
						FileRgbLoad = FALSE ;
					}
					if( FileAlphaLoad == TRUE )
					{
						NS_ReleaseGraphImage( &FileAlphaImage ) ;
						FileAlphaLoad = FALSE ;
					}

					// 摜t@C烍[hꍇ͉摜[h
		//			DXST_LOGFILEFMT_ADDW(( L"i:%d tpX:%s [hł܂ł", i, Image->FilePath )) ;
		//			DXST_LOGFILEFMT_ADDW(( L"t@C:%s [h܂", Image->FilePath->String )) ;
		//			DXST_LOGFILEFMT_ADDW(( L"]tO:%d  t@C:%s [h܂", Image->ReadBase->ReverseFlag, Image->ReadBase->FileName )) ;
					InitLoadBaseImageGParam( &LoadBaseImageGParam, FALSE ) ;
					LoadBaseImageGParam.ConvertPremultipliedAlpha = Image->ReadBase->ConvertPremultipliedAlpha ;
					LoadHr = CreateGraphImage_plus_Alpha_UseGParam(
								&LoadBaseImageGParam,
								Image->ReadBase->FileName,
								NULL,
								0,
								LOADIMAGE_TYPE_FILE,
								NULL,
								0,
								LOADIMAGE_TYPE_FILE,
								&FileRgbImage,
								&FileAlphaImage,
								Image->ReadBase->ReverseFlag,
								Image->ReadBase->NotUseTransColor ) ;
					if( LoadHr == -1 )
					{
						DXST_LOGFILEFMT_ADDW(( L"Image File Load Error : %s", Image->ReadBase->FileName )) ;
						goto R1 ;
					}

					FileRgbLoad = TRUE ;
					if( LoadHr == 0 ) FileAlphaLoad = TRUE ;
				}

				// tH[}bgcwsnǂŏ𕪊
				if( IsDXT )
				{
					// cwsn̏ꍇ͉摜Ŝ]
					SrcRect.left   = 0 ;
					SrcRect.top    = 0 ;
					SrcRect.right  = FileRgbImage.Width ;
					SrcRect.bottom = FileRgbImage.Height ;
					Graphics_Image_BltBmpOrBaseImageToGraph3(
						&SrcRect,
						0,
						0,
						Image->HandleInfo.Handle,
						&FileRgbImage,
						FileAlphaLoad == TRUE ? &FileAlphaImage : NULL,
						FALSE,
						FALSE,
						TRUE
					) ;

					// AtO𗧂Ă
					Image->Orig->RestoreFlag = TRUE ;
				}
				else
				{
					// OtBbN̓]
			//		DXST_LOGFILEFMT_ADDW(( L"UseFileX:%d UseFileY:%d", Image->UseFileX, Image->UseFileY )) ;
					Graphics_Image_BltBmpOrGraphImageToGraphBase(
						&FileRgbImage,
						FileAlphaLoad == TRUE ? &FileAlphaImage : NULL,
						Image->UseBaseXI,
						Image->UseBaseYI,
						Image->HandleInfo.Handle,
						GSYS.CreateImage.NotUseTransColor ? FALSE : TRUE
					) ;
				}
		R1 :
				FileBackImage = Image ;
			}
			else
			// ǂݍ񂾏ꍇ̓摜𕜌
			if( Image->ReadBase->MemImage )
			{
				// ÕOtBbNƃAhXꍇ͓ǂݍ݂Ȃ
				if( MemBackImage == NULL ||
					MemRgbLoad == FALSE ||
					Image->ReadBase->MemImage != MemBackImage->ReadBase->MemImage ||
					Image->ReadBase->AlphaMemImage != MemBackImage->ReadBase->AlphaMemImage ||
					Image->ReadBase->ReverseFlag != MemBackImage->ReadBase->ReverseFlag ||
					Image->ReadBase->ConvertPremultipliedAlpha != MemBackImage->ReadBase->ConvertPremultipliedAlpha )
				{
					// BASEIMAGE ̌n
					if( MemRgbLoad == TRUE )
					{
						NS_ReleaseGraphImage( &MemRgbImage ) ;
						MemRgbLoad = FALSE ;
					}
					if( MemAlphaLoad == TRUE )
					{
						NS_ReleaseGraphImage( &MemAlphaImage ) ;
						MemAlphaLoad = FALSE ;
					}

					// 摜烍[hꍇ͉摜[h
					InitLoadBaseImageGParam( &LoadBaseImageGParam, FALSE ) ;
					LoadBaseImageGParam.ConvertPremultipliedAlpha = Image->ReadBase->ConvertPremultipliedAlpha ;
					LoadHr = CreateGraphImage_plus_Alpha_UseGParam(
								&LoadBaseImageGParam,
								NULL,
								Image->ReadBase->MemImage,
								Image->ReadBase->MemImageSize,
								LOADIMAGE_TYPE_MEM,
								Image->ReadBase->AlphaMemImage,
								Image->ReadBase->AlphaMemImageSize,
								LOADIMAGE_TYPE_MEM,
								&MemRgbImage,
								&MemAlphaImage,
								Image->ReadBase->ReverseFlag,
								Image->ReadBase->NotUseTransColor ) ;
					if( LoadHr == -1 )
					{
						DXST_LOGFILEFMT_ADDUTF16LE(( "\xe1\x30\xe2\x30\xea\x30\x4b\x30\x89\x30\x6e\x30\x3b\x75\xcf\x50\xc7\x30\xfc\x30\xbf\x30\x6e\x30\xed\x30\xfc\x30\x4c\x30\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x00"/*@ L"̉摜f[^̃[ł܂ł" @*/ )) ;
						goto R2 ;
					}

					MemRgbLoad = TRUE ;
					if( LoadHr == 0 ) MemAlphaLoad = TRUE ;
				}

				// tH[}bgcwsnǂŏ𕪊
				if( IsDXT )
				{
					// cwsn̏ꍇ͉摜Ŝ]
					SrcRect.left   = 0 ;
					SrcRect.top    = 0 ;
					SrcRect.right  = MemRgbImage.Width ;
					SrcRect.bottom = MemRgbImage.Height ;
					Graphics_Image_BltBmpOrBaseImageToGraph3(
						&SrcRect,
						0,
						0,
						Image->HandleInfo.Handle,
						&MemRgbImage,
						MemAlphaLoad == TRUE ? &MemAlphaImage : NULL,
						FALSE,
						FALSE,
						TRUE
					) ;

					// AtO𗧂Ă
					Image->Orig->RestoreFlag = TRUE ;
				}
				else
				{
					// OtBbN̓]
					Graphics_Image_BltBmpOrGraphImageToGraphBase( 
						&MemRgbImage,
						MemAlphaLoad == TRUE ? &MemAlphaImage : NULL,
						Image->UseBaseXI,
						Image->UseBaseYI,
						Image->HandleInfo.Handle,
						GSYS.CreateImage.NotUseTransColor ? FALSE : TRUE
					) ;
				}
		R2 :
				MemBackImage = Image ;
			}
			else
			// BaseImage ǂݍ񂾏ꍇ BaseImage 摜𕜌
			if( Image->ReadBase->BaseImage )
			{
				// tH[}bgcwsnǂŏ𕪊
				if( IsDXT )
				{
					// cwsn̏ꍇ͉摜Ŝ]
					SrcRect.left   = 0 ;
					SrcRect.top    = 0 ;
					SrcRect.right  = Image->ReadBase->BaseImage->Width ;
					SrcRect.bottom = Image->ReadBase->BaseImage->Height ;
					Graphics_Image_BltBmpOrBaseImageToGraph3(
						&SrcRect,
						0,
						0,
						Image->HandleInfo.Handle,
						Image->ReadBase->BaseImage,
						Image->ReadBase->AlphaBaseImage,
						FALSE,
						FALSE,
						TRUE
					) ;

					// AtO𗧂Ă
					Image->Orig->RestoreFlag = TRUE ;
				}
				else
				{
					// OtBbN̓]
					Graphics_Image_BltBmpOrGraphImageToGraphBase( 
						Image->ReadBase->BaseImage,
						Image->ReadBase->AlphaBaseImage,
						Image->UseBaseXI,
						Image->UseBaseYI,
						Image->HandleInfo.Handle,
						GSYS.CreateImage.NotUseTransColor ? FALSE : TRUE
					) ;
				}
			}
		}
	}

	// GraphImage ̌n
	if( FileRgbLoad == TRUE )
	{
		NS_ReleaseGraphImage( &FileRgbImage ) ;
		FileRgbLoad = FALSE ;
	}
	if( FileAlphaLoad == TRUE )
	{
		NS_ReleaseGraphImage( &FileAlphaImage ) ;
		FileAlphaLoad = FALSE ;
	}
	if( MemRgbLoad == TRUE )
	{
		NS_ReleaseGraphImage( &MemRgbImage ) ;
		MemRgbLoad = FALSE ;
	}
	if( MemAlphaLoad == TRUE )
	{
		NS_ReleaseGraphImage( &MemAlphaImage ) ;
		MemAlphaLoad = FALSE ;
	}

	DXST_LOGFILE_ADDUTF16LE( "\xb0\x30\xe9\x30\xd5\x30\xa3\x30\xc3\x30\xaf\x30\x6e\x30\xa9\x5f\x30\x5e\x4c\x30\x8c\x5b\x86\x4e\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"OtBbN̕A܂\n" @*/ ) ;
}

// CreateGraph  CreateDivGraph ̋ʂ BASEIMAGE \z֐
static void Graphics_Image_CreateGraph_LoadBaseImage(
	 LOADGRAPH_PARAM *Param,
	 CREATEGRAPH_LOADBASEIMAGE_PARAM *LParam
 )
{
	LParam->UseTempBaseImage             = FALSE ;
	LParam->LoadHr                       = -1 ;
	LParam->UseRgbBaseImage              = NULL ;
	LParam->UseAlphaBaseImage            = NULL ;
	LParam->TempRgbBaseImage.GraphData   = NULL ;
	LParam->TempAlphaBaseImage.GraphData = NULL ;

	if( Param->FileName != NULL )
	{
		// t@Cǂݍޏꍇ
		LParam->LoadHr = CreateGraphImage_plus_Alpha_UseGParam(
					&Param->GParam.LoadBaseImageGParam,
					Param->FileName,
					NULL,
					0,
					LOADIMAGE_TYPE_FILE,
					NULL,
					0,
					LOADIMAGE_TYPE_FILE,
					&LParam->TempRgbBaseImage,
					Param->GParam.CreateGraphGParam.InitHandleGParam.NotUseAlphaImageLoadFlag ? NULL : &LParam->TempAlphaBaseImage,
					FALSE,
					Param->GParam.CreateGraphGParam.NotUseTransColor
				) ;
		LParam->UseRgbBaseImage = &LParam->TempRgbBaseImage ;
		if( LParam->LoadHr == 0 )
		{
			LParam->UseAlphaBaseImage = &LParam->TempAlphaBaseImage ;
		}
		LParam->UseTempBaseImage = TRUE ;
	}
	else
	if( Param->RgbMemImage != NULL )
	{
		// ̃t@CC[Wǂݍޏꍇ
		LParam->LoadHr = CreateGraphImage_plus_Alpha_UseGParam(
					&Param->GParam.LoadBaseImageGParam,
					NULL,
					Param->RgbMemImage,
					Param->RgbMemImageSize,
					LOADIMAGE_TYPE_MEM,
					Param->AlphaMemImage,
					Param->AlphaMemImageSize,
					LOADIMAGE_TYPE_MEM,
					&LParam->TempRgbBaseImage,
					&LParam->TempAlphaBaseImage,
					FALSE,
					Param->GParam.CreateGraphGParam.NotUseTransColor
				) ;
		LParam->UseRgbBaseImage = &LParam->TempRgbBaseImage ;
		if( LParam->LoadHr == 0 )
		{
			LParam->UseAlphaBaseImage = &LParam->TempAlphaBaseImage ;
		}
		LParam->UseTempBaseImage = TRUE ;
	}
#ifdef WINDOWS_DESKTOP_OS
	else
	if( Param->RgbBmpInfo != NULL )
	{
		int RgbCopyHr ;
		int AlphaCopyHr ;

		// BMP ǂݍޏꍇ
		RgbCopyHr = NS_ConvBitmapToGraphImage( Param->RgbBmpInfo, Param->RgbBmpImage, &LParam->TempRgbBaseImage, TRUE ) ;
		if( RgbCopyHr == -1 )
			return ;

		if( Param->AlphaBmpInfo != NULL && Param->AlphaBmpImage != NULL )
		{
			AlphaCopyHr = NS_ConvBitmapToGraphImage( Param->AlphaBmpInfo, Param->AlphaBmpImage, &LParam->TempAlphaBaseImage, TRUE ) ;
			if( AlphaCopyHr == -1 )
			{
				if( RgbCopyHr == 1 ) NS_ReleaseGraphImage( &LParam->TempRgbBaseImage ) ;
				return ;
			}
			LParam->UseAlphaBaseImage = &LParam->TempAlphaBaseImage ;
		}
		else
		{
			_MEMSET( &LParam->TempAlphaBaseImage, 0, sizeof( LParam->TempAlphaBaseImage ) ) ;
		}
		LParam->UseRgbBaseImage = &LParam->TempRgbBaseImage ;
		LParam->UseTempBaseImage = TRUE ;

		LParam->LoadHr = 1 ;
	}
#endif // WINDOWS_DESKTOP_OS
	else
	if( Param->RgbBaseImage != NULL )
	{
		// {C[Wǂݍޏꍇ
		LParam->UseRgbBaseImage   = Param->RgbBaseImage ;
		LParam->UseAlphaBaseImage = Param->AlphaBaseImage ;

		LParam->LoadHr = 1 ;
	}

	if( LParam->LoadHr >= 0 )
	{
		// ]tOĂC[W𔽓]
		if( Param->ReverseFlag == TRUE )
		{
			NS_ReverseGraphImage( LParam->UseRgbBaseImage ) ;
			if( LParam->UseAlphaBaseImage != NULL ) NS_ReverseGraphImage( LParam->UseAlphaBaseImage ) ;
		}
	}
}

// CreateGraph  CreateDivGraph ̋ʂ BASEIMAGE n֐
static void Graphics_Image_CreateGraph_TerminateBaseImage(
	LOADGRAPH_PARAM *Param,
	CREATEGRAPH_LOADBASEIMAGE_PARAM *LParam
)
{
	// ǂݍ񂾃OtBbŇn
	if( LParam->UseTempBaseImage )
	{
		NS_ReleaseGraphImage( &LParam->TempRgbBaseImage ) ;
		NS_ReleaseGraphImage( &LParam->TempAlphaBaseImage ) ;
	}
	else
	{
		// ]tOĂC[Wɖ߂
		if( Param->ReverseFlag == TRUE )
		{
			NS_ReverseGraphImage( LParam->UseRgbBaseImage ) ;
			if( LParam->UseAlphaBaseImage != NULL ) NS_ReverseGraphImage( LParam->UseAlphaBaseImage ) ;
		}
	}
}





















// ʊ֌W֐

// w̉𑜓xΉĂ邩ǂ𒲂ׂ֐
static int Graphics_Screen_CheckDisplaySetting( int ScreenSizeX, int ScreenSizeY, int ColorBitDepth )
{
	int Num, i ;
	DISPLAYMODEDATA Mode ;

	Num = NS_GetDisplayModeNum( 0 ) ;
	for( i = 0 ; i < Num ; i ++ )
	{
		Mode = NS_GetDisplayMode( i, 0 ) ;
		if( Mode.Width         == ScreenSizeX &&
			Mode.Height        == ScreenSizeY &&
			Mode.ColorBitDepth == ColorBitDepth )
		{
			return TRUE ;
		}
	}

	return FALSE ;
}























// `֌W֐

// r{[hp̍svZ
__inline static void Graphics_Draw_VectorTransformToBillboard( VECTOR *Vector, VECTOR *Position )
{
	VECTOR invec = *Vector ;
	Vector->x = invec.x * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + invec.y * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Position->x ;
	Vector->y = invec.x * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + invec.y * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Position->y ;
	Vector->z = invec.x * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + invec.y * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Position->z ;
}

#define SETDRAWRECTCODE\
	int x[ 4 ], y[ 4 ], MaxX, MaxY, MinX, MinY ;\
	int i, ix, iy ;\
\
	x[ 0 ] = x1 ; x[ 1 ] = x2 ; x[ 2 ] = x3 ; x[ 3 ] = x4 ;\
	y[ 0 ] = y1 ; y[ 1 ] = y2 ; y[ 2 ] = y3 ; y[ 3 ] = y4 ;\
\
	MaxX = 0 ; MaxY = 0 ;\
	MinX = 0xffffff ; MinY = 0xffffff ;\
\
	for( i = 0 ; i < 4 ; i ++ )\
	{\
		ix = x[ i ] ; iy = y[ i ] ;\
		if( ix > MaxX ) MaxX = ix ; if( iy > MaxY ) MaxY = iy ;\
		if( ix < MinX ) MinX = ix ; if( iy < MinY ) MinY = iy ;\
	}\
\
	SETRECT( DrawRect, MinX, MinY, MaxX, MaxY ) ;\
	DRAWRECT_DRAWAREA_CLIP

static int Graphics_Draw_ModiGraphBase( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int GrHandle, int TransFlag, bool SimpleDrawFlag )
{
	IMAGEDATA *Image ;
	IMAGEDATA *BlendImage ;
	int Ret = -1 ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;
	BlendImage = NULL ;
	if( GSYS.DrawSetting.BlendGraph > 0 )
	{
		GRAPHCHK( GSYS.DrawSetting.BlendGraph, BlendImage ) ;

		// uheNX`gpꍇA`摜G[
		if( Graphics_Image_CheckBlendGraphSize( Image ) ) return -1 ;
	}

#ifndef DX_NON_MOVIE
	if( Image->Orig->MovieHandle != -1 )
		UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
#endif

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawModiGraph_PF( x1, y1, x2, y2, x4, y4, x3, y3, Image, BlendImage, TransFlag, SimpleDrawFlag ),
		Graphics_Software_DrawModiGraph(    x1, y1, x2, y2, x4, y4, x3, y3, Image,             TransFlag                 ),
		SETDRAWRECTCODE,
		Ret,
		Image->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE

#define SETDRAWRECTCODE\
	int x[4], y[4], MaxX, MaxY, MinX, MinY ;\
	int i, ix, iy ;\
\
	x[ 0 ] = _FTOL( x1 ) ; x[ 1 ] = _FTOL( x2 ) ; x[ 2 ] = _FTOL( x3 ) ; x[ 3 ] = _FTOL( x4 ) ;\
	y[ 0 ] = _FTOL( y1 ) ; y[ 1 ] = _FTOL( y2 ) ; y[ 2 ] = _FTOL( y3 ) ; y[ 3 ] = _FTOL( y4 ) ;\
\
	MaxX = 0 ; MaxY = 0 ;\
	MinX = 0xfffffff ; MinY = 0xfffffff ;\
\
	for( i = 0 ; i < 4 ; i ++ )\
	{\
		ix = x[ i ] ; iy = y[ i ] ;\
		if( ix > MaxX ) MaxX = ix ; if( iy > MaxY ) MaxY = iy ;\
		if( ix < MinX ) MinX = ix ; if( iy < MinY ) MinY = iy ;\
	}\
\
	SETRECT( DrawRect, MinX, MinY, MaxX, MaxY ) ;

static int Graphics_Draw_ModiGraphFBase( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, int GrHandle, int TransFlag, bool SimpleDrawFlag )
{
	IMAGEDATA *Image ;
	IMAGEDATA *BlendImage ;
	int Ret = -1 ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;
	BlendImage = NULL ;
	if( GSYS.DrawSetting.BlendGraph > 0 )
	{
		GRAPHCHK( GSYS.DrawSetting.BlendGraph, BlendImage ) ;

		// uheNX`gpꍇA`摜G[
		if( Graphics_Image_CheckBlendGraphSize( Image ) ) return -1 ;
	}

#ifndef DX_NON_MOVIE
	if( Image->Orig->MovieHandle != -1 )
		UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
#endif

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawModiGraphF_PF( x1, y1, x2, y2, x4, y4, x3, y3, Image, BlendImage, TransFlag, SimpleDrawFlag ),
		Graphics_Software_DrawModiGraphF(    x1, y1, x2, y2, x4, y4, x3, y3, Image,             TransFlag                 ),
		SETDRAWRECTCODE,
		Ret,
		Image->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE



// l̑傫Wlg`ɂvZx̒ቺ}ׂ̏s
static void	Graphics_Draw_BeginLarge3DPositionSupportDraw( LARGE3DPOSITIONSUPPORT_DRAWINFO *DrawInfo, VECTOR_D BasePosition )
{
	MATRIX_D TranslateMatrix ;
	MATRIX_D TempWorldMatrix ;
	MATRIX_D IdentityMatrix ;

	DrawInfo->BackupWorldMatrix = GSYS.DrawSetting.WorldMatrix ;
	DrawInfo->BackupViewMatrix  = GSYS.DrawSetting.ViewMatrix ;
	CreateTranslationMatrixD( &TranslateMatrix, BasePosition.x, BasePosition.y, BasePosition.z ) ;
	CreateIdentityMatrixD( &IdentityMatrix ) ;
	CreateMultiplyMatrixD( &TempWorldMatrix, &TranslateMatrix, &GSYS.DrawSetting.WorldViewMatrix ) ;
	NS_SetTransformToWorldD( &TempWorldMatrix ) ;
	NS_SetTransformToViewD( &IdentityMatrix ) ;
}

// l̑傫Wlg`ɂvZx̒ቺ}ׂ̏ōsύXɖ߂
static void	Graphics_Draw_EndLarge3DPositionSupportDraw( const LARGE3DPOSITIONSUPPORT_DRAWINFO *DrawInfo )
{
	NS_SetTransformToWorldD( &DrawInfo->BackupWorldMatrix ) ;
	NS_SetTransformToViewD( &DrawInfo->BackupViewMatrix ) ;
}






















// n[hEFAANZ[^gp_O֌W֐

// n[hEGAANZ[^gp DrawChipMap
static int	Graphics_Hardware_DrawChipMap( int Sx, int Sy, int XNum, int YNum, const int *MapData, int MapDataPitch, int /*ChipTypeNum*/, const int *ChipGrHandle, int TransFlag )
{
	IMAGEDATA *Image ;
	IMAGEDATA *BlendImage ;
	int i, j ;
	int xI, yI, WidthI, HeightI ;
	float xF, yF, WidthF, HeightF ;
	const int *MP ;

	if( Graphics_Hardware_CheckValid_PF() == 0 ) return -1 ;

	// `̏
	if( GRAPHCHK( ChipGrHandle[ 0 ], Image ) )
		return -1 ;
	BlendImage = NULL ;
	if( GSYS.DrawSetting.BlendGraph > 0 )
	{
		GRAPHCHK( GSYS.DrawSetting.BlendGraph, BlendImage ) ;
	}

	WidthI = Image->WidthI ;
	WidthF = Image->WidthF ;
	HeightI = Image->HeightI ;
	HeightF = Image->HeightF ;

	// ʂ for Ń[v`
	yI = Sy ;
	yF = ( float )Sy ;
	MP = MapData ;
	for( i = 0 ; i < YNum ; i ++, yI += HeightI, yF += HeightF )
	{
		xI = Sx ;
		xF = ( float )Sx ;
		for( j = 0 ; j < XNum ; j ++, xI += WidthI, xF += WidthF, MP ++ )
		{
			if( *MP == -1 ) continue ;

			if( GRAPHCHK( ChipGrHandle[ *MP ], Image ) )
				return -1 ;

			Graphics_Hardware_DrawGraph_PF( xI, yI, ( float )xF, ( float )yF, Image, BlendImage, TransFlag, TRUE ) ;
		}
		MP += MapDataPitch - XNum ;
	}

	// I
	return 0 ;
}

/*
x1,y1,x2,y2@ʒA^C\肵̈
Tx,Ty@@@@ψʁ@@@@@@@@@@@@摜́Aǂ̍W^C\Jn邩B
ExtRate@@@摜̊g嗦@@@@@@@@u1vɂƁA摜̂܂܂̑傫Ń^C\肷B
Angle@@@@摜̉]px@@@@@@@u0vɂƁA]ȂŃ^C\肷B
GrHandle@@ 摜̃nh
TransFlag@@߃tO
*/

// n[hEGAANZ[^gp DrawTile
static int	Graphics_Hardware_DrawTile( int x1, int y1, int x2, int y2, int Tx, int Ty, double ExtRate, double Angle, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag )
{
	double MaxLength ;
	float Width, Height, f, Sin, Cos, Sin2, Cos2 ;
	float CenX, CenY, x, y, BaseX, BaseY ;
	float xAddX, xAddY, yAddX, yAddY ;
	int temp, Num, i, j ;
	RECT DrawRect ;
	float FExtRate, FAngle ;

	FExtRate = (float)ExtRate ;
	FAngle = (float)Angle ;

	if( ExtRate <= 0.0 ) ExtRate = 0.0001 ;
	if( x1 > x2 ){ temp = x2 ; x2 = x1 ; x1 = temp ; }
	if( y1 > y2 ){ temp = y2 ; y2 = y1 ; y1 = temp ; }
	Tx %= Image->WidthI ;
	Ty %= Image->HeightI ;

	// iޒlvZ
	_SINCOS_PLATFORM( FAngle, &Sin, &Cos ) ;
	xAddX = Image->WidthI  * Cos * FExtRate ;
	xAddY = Image->HeightI * Sin * FExtRate ;

	_SINCOS_PLATFORM( FAngle + DX_PI_F / 2.0F, &Sin2, &Cos2 ) ;
	yAddX = Image->WidthI  * Cos2 * FExtRate ;
	yAddY = Image->HeightI * Sin2 * FExtRate ;

	// `敝𓾂
	Width = (float)( x2 - x1 ) ;
	Height = (float)( y2 - y1 ) ;

	// ő咷𓾂
	MaxLength = _SQRT( Width * Width + Height * Height ) ;

	// `𓾂
	{
		int k ;

		k = Image->WidthI > Image->HeightI ? Image->HeightI : Image->WidthI ;
		Num = _DTOL( MaxLength / ( k * ExtRate ) + 2 ) ;
		if( Num % 2 == 0 ) Num ++ ;
	}

	// `撆S_𓾂
	CenX = x1 + Width / 2 ;
	CenY = y1 + Height / 2 ;

	// `\͈͂ύX
	DrawRect = GSYS.DrawSetting.DrawArea ;
	NS_SetDrawArea( x1, y1, x2, y2 ) ;

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `JnW𓾂
	BaseX = ( -Tx - ( Num * Image->WidthI  ) / 2 ) * FExtRate ;
	BaseY = ( -Ty - ( Num * Image->HeightI ) / 2 ) * FExtRate ;

	f = BaseX * Cos - BaseY * Sin ;
	BaseY = BaseX * Sin + BaseY * Cos + CenY ;
	BaseX = f + CenX ;

	// `Jn
	for( i = 0 ; i < Num ; i ++, BaseX += yAddX, BaseY += yAddY )
	{
		x = BaseX ;
		y = BaseY ;
		for( j = 0 ; j < Num ; j ++, x += xAddX, y += xAddY )
		{
			Graphics_Hardware_DrawModiGraphF_PF(
				x, y,
				x + xAddX, y + xAddY,
				x + yAddX, y + yAddY,
				x + xAddX + yAddX, y + xAddY + yAddY,
				Image, BlendImage, TransFlag, true ) ;
		}
	}

	// `\͈͂ɖ߂
	NS_SetDrawArea( DrawRect.left, DrawRect.top, DrawRect.right, DrawRect.bottom ) ;

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	return 0 ;
}

























// \tgEGA_O֐

// \tgEGA_Ȍs
static int Graphics_Software_Initialize( void )
{
	// Cʗp MEMIMG ̍쐬
	if( MakeMemImgScreen(
		&GSYS.SoftRender.MainBufferMemImg,
		GSYS.Screen.MainScreenSizeX,
		GSYS.Screen.MainScreenSizeY,
		GSYS.Screen.MainScreenColorBitDepth == 16 ? 0 : 1 ) < 0 )
	{
		return DXST_LOGFILE_ADDUTF16LE( "\xee\x4e\x3b\x75\x62\x97\x28\x75\x6e\x30\x20\x00\x4d\x00\x45\x00\x4d\x00\x49\x00\x4d\x00\x47\x00\x20\x00\x6e\x30\x5c\x4f\x10\x62\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"ʗp MEMIMG ̍쐬Ɏs܂\n" @*/ ) ;
	}

	// UserScreenImage ꍇ̓AhXւĂ
	if( GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode && GSYS.Setting.ValidHardware == FALSE )
	{
		GSYS.SoftRender.MainBufferMemImg.UseImage = ( unsigned char * )GSYS.Screen.UserScreenImage ;
	}

	// ⏕ʗp MEMIMG ̍쐬
	if( MakeMemImgScreen(
		&GSYS.SoftRender.SubBufferMemImg,
		GSYS.Screen.MainScreenSizeX,
		GSYS.Screen.MainScreenSizeY,
		GSYS.Screen.MainScreenColorBitDepth == 16 ? 0 : 1 ) < 0 )
	{
		return DXST_LOGFILE_ADDUTF16LE( "\xdc\x88\xa9\x52\x28\x75\x6e\x30\x20\x00\x4d\x00\x45\x00\x4d\x00\x49\x00\x4d\x00\x47\x00\x20\x00\x6e\x30\x5c\x4f\x10\x62\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"⏕p MEMIMG ̍쐬Ɏs܂\n" @*/ ) ;
	}

	// tHg̔`pAt@摜̍쐬
	_MEMSET( &GSYS.SoftRender.FontScreenMemImgAlpha, 0, sizeof( MEMIMG ) ) ;
	_MEMSET( &GSYS.SoftRender.FontScreenMemImgNormal, 0, sizeof( MEMIMG ) ) ;
	InitializeMemImg(
		&GSYS.SoftRender.FontScreenMemImgNormal,
		GSYS.Screen.MainScreenSizeX,
		GSYS.Screen.MainScreenSizeY,
		-1,
		0,
		GSYS.Screen.MainScreenColorBitDepth == 16 ? 0 : 1,
		FALSE, FALSE, FALSE, NULL ) ;
	InitializeMemImg(
		&GSYS.SoftRender.FontScreenMemImgAlpha,
		GSYS.Screen.MainScreenSizeX,
		GSYS.Screen.MainScreenSizeY,
		-1,
		0,
		GSYS.Screen.MainScreenColorBitDepth == 16 ? 0 : 1,
		FALSE, TRUE, FALSE, NULL ) ;

	// obt@̃NA
	ClearMemImg( &GSYS.SoftRender.MainBufferMemImg, NULL, NS_GetColor3( GSYS.SoftRender.MainBufferMemImg.Base->ColorDataP, GSYS.Screen.BackgroundRed, GSYS.Screen.BackgroundGreen, GSYS.Screen.BackgroundBlue, GSYS.Screen.BackgroundAlpha ) ) ;

	// `Ώۂ̃Zbg
	GSYS.SoftRender.TargetMemImg = &GSYS.SoftRender.MainBufferMemImg ;

	// I
	return 0 ;
}

// \tgEGA_Ǒns
static int	Graphics_Software_Terminate( void )
{
	// Cobt@̉
	TerminateMemImg( &GSYS.SoftRender.MainBufferMemImg ) ;

	// Tuobt@̉
	TerminateMemImg( &GSYS.SoftRender.SubBufferMemImg ) ;

	// tHg̔`pAt@摜̉
	TerminateMemImg( &GSYS.SoftRender.FontScreenMemImgNormal ) ;
	TerminateMemImg( &GSYS.SoftRender.FontScreenMemImgAlpha ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawGraph
static int  Graphics_Software_DrawGraph( int x, int y, IMAGEDATA *Image, int TransFlag )
{
	DrawMemImg( GSYS.SoftRender.TargetMemImg, &Image->Soft.MemImg, x, y, TransFlag, GSYS.SoftRender.BlendMemImg ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawExtendGraph
static int  Graphics_Software_DrawExtendGraph( int x1, int y1, int x2, int y2, IMAGEDATA *Image, int TransFlag )
{
	RECT Rect ;

	Rect.left   = x1 ;
	Rect.top    = y1 ;
	Rect.right  = x2 ;
	Rect.bottom = y2 ;

	DrawEnlargeMemImg( GSYS.SoftRender.TargetMemImg, &Image->Soft.MemImg, &Rect, TransFlag, GSYS.SoftRender.BlendMemImg ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawRotaGraph
static int  Graphics_Software_DrawRotaGraph( float x, float y, double ExRate, double Angle, IMAGEDATA *Image, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	DrawRotationMemImg( GSYS.SoftRender.TargetMemImg, &Image->Soft.MemImg,
		_FTOL( x ), _FTOL( y ), ( float )Angle, ( float )ExRate, ( float )ExRate, TransFlag, ReverseXFlag, ReverseYFlag, GSYS.SoftRender.BlendMemImg ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawRotaGraphFast
static int  Graphics_Software_DrawRotaGraphFast( float x, float y, float ExRate, float Angle, IMAGEDATA *Image, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	DrawRotationMemImg( GSYS.SoftRender.TargetMemImg, &Image->Soft.MemImg,
		_FTOL( x ), _FTOL( y ), Angle, ExRate, ExRate, TransFlag, ReverseXFlag, ReverseYFlag, GSYS.SoftRender.BlendMemImg ) ;

	// I
	return 0 ;
}

static int	Graphics_Software_DrawPoly( DX_POINTDATA *p, IMAGEDATA *Image, int TransFlag, unsigned int Color )
{
	DrawBasicPolygonMemImg( GSYS.SoftRender.TargetMemImg, Image ? &Image->Soft.MemImg : NULL, 
							p, TransFlag, GSYS.SoftRender.BlendMemImg, Color ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawModiGraph
static int  Graphics_Software_DrawModiGraph( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, IMAGEDATA *Image, int TransFlag )
{
	DX_POINTDATA p[4] ;

	p[0].x = x1 ;		p[0].y = y1 ;		p[0].u = 0 ;				p[0].v = 0 ;
	p[1].x = x2 ;		p[1].y = y2 ;		p[1].u = Image->WidthI ;	p[1].v = 0 ;
	p[2].x = x3 ;		p[2].y = y3 ;		p[2].u = 0 ;				p[2].v = Image->HeightI ;
	p[3].x = x4 ;		p[3].y = y4 ;		p[3].u = Image->WidthI ;	p[3].v = Image->HeightI ;

	Graphics_Software_DrawPoly( &p[0], Image, TransFlag, 0 ) ;
	Graphics_Software_DrawPoly( &p[1], Image, TransFlag, 0 ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawModiGraphF
static int  Graphics_Software_DrawModiGraphF( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA *Image, int TransFlag )
{
	return Graphics_Software_DrawModiGraph( _FTOL( x1 ), _FTOL( y1 ), _FTOL( x2 ), _FTOL( y2 ), _FTOL( x3 ), _FTOL( y3 ), _FTOL( x4 ), _FTOL( y4 ), Image, TransFlag ) ;
}

// \tgEGA_O DrawChipMap
static int	Graphics_Software_DrawChipMap( int Sx, int Sy, int XNum, int YNum, const int *MapData, int MapDataPitch, int /*ChipTypeNum*/, const int *ChipGrHandle, int TransFlag )
{
	int x, y, i, j, Width, Height, Pitch2 ;
	const int *MP ;
	IMAGEDATA *Image ;

	if( GRAPHCHK( ChipGrHandle[ 0 ], Image ) )
		return -1 ;

	Width  = Image->WidthI ;
	Height = Image->HeightI ;

	Pitch2 = MapDataPitch - XNum ;

	// ʂ for Ń[v`
	y = Sy ;
	MP = MapData ;
	for( i = 0 ; i < YNum ; i ++, y += Height )
	{
		x = Sx ;
		for( j = 0 ; j < XNum ; j ++, x += Width, MP ++ )
		{
			if( *MP == -1 ) continue ;

			if( GRAPHCHK( ChipGrHandle[ *MP ], Image ) )
				return -1 ;

			Graphics_Software_DrawGraph( x, y, Image, TransFlag ) ;
		}
		MP += Pitch2 ;
	}

	// I
	return 0 ;
}

// \tgEGA_O DrawTile
static int	Graphics_Software_DrawTile( int x1, int y1, int x2, int y2, int Tx, int Ty, double ExtRate, double Angle, IMAGEDATA *Image, int TransFlag )
{
	double MaxLength ;
	float Width, Height, f, Sin, Cos ;
	float CenX, CenY, x, y, BaseX, BaseY ;
	float xAddX, xAddY, yAddX, yAddY ;
	int temp, Num, i, j ;
	RECT DrawRect ;
	float FAngle, FExtRate, Sin2, Cos2 ;

	FAngle = ( float )Angle ;
	FExtRate = ( float )ExtRate ;

	if( ExtRate <= 0.0 ) ExtRate = 0.0001 ;
	if( x1 > x2 ){ temp = x2 ; x2 = x1 ; x1 = temp ; }
	if( y1 > y2 ){ temp = y2 ; y2 = y1 ; y1 = temp ; }
	Tx %= Image->WidthI ;
	Ty %= Image->HeightI ;

	_SINCOS_PLATFORM( FAngle, &Sin, &Cos ) ;
//	Sin = (float)sin( Angle ) ;
//	Cos = (float)cos( Angle ) ;

	// iޒlvZ
	xAddX = Image->WidthI * Cos * FExtRate ;
	xAddY = Image->WidthI * Sin * FExtRate ;

	_SINCOS_PLATFORM( FAngle + DX_PI_F / 2.0F, &Sin2, &Cos2 ) ;
	yAddX = Image->HeightI * Cos2 * FExtRate ;
	yAddY = Image->HeightI * Sin2 * FExtRate ;

	// `敝𓾂
	Width = (float)( x2 - x1 ) ;
	Height = (float)( y2 - y1 ) ;

	// ő咷𓾂
	MaxLength = _SQRT( Width * Width + Height * Height ) ;

	// `𓾂
	{
		int k ;

		k = Image->WidthI > Image->HeightI ? Image->HeightI : Image->WidthI ;
		Num = _DTOL( MaxLength / ( k * ExtRate ) + 2 ) ;
		if( Num % 2 == 0 ) Num ++ ;
	}

	// `撆S_𓾂
	CenX = x1 + Width / 2 ;
	CenY = y1 + Height / 2 ;

	// `\͈͂ύX
	DrawRect = GSYS.DrawSetting.DrawArea ;
	NS_SetDrawArea( x1, y1, x2, y2 ) ;

	// `JnW𓾂
	BaseX = ( -Tx - ( Num * Image->WidthI  ) / 2 ) * FExtRate ;
	BaseY = ( -Ty - ( Num * Image->HeightI ) / 2 ) * FExtRate ;

	f = BaseX * Cos - BaseY * Sin ;
	BaseY = BaseX * Sin + BaseY * Cos + CenY ;
	BaseX = f + CenX ;

	// `Jn
	for( i = 0 ; i < Num ; i ++, BaseX += yAddX, BaseY += yAddY )
	{
		x = BaseX ;
		y = BaseY ;
		for( j = 0 ; j < Num ; j ++, x += xAddX, y += xAddY )
		{
			if( Angle == 0.0 )
			{
				if( ExtRate == 0.0 )
				{
					Graphics_Software_DrawGraph( _FTOL( x ), _FTOL( y ), Image, TransFlag ) ;
				}
				else
				{
					Graphics_Software_DrawExtendGraph( _FTOL( x ), _FTOL( y ),
											 _FTOL( x + xAddX ),
											 _FTOL( y + yAddY ), Image, TransFlag ) ;
				}
			}
			else
			{
				Graphics_Software_DrawModiGraph( _FTOL( x ), _FTOL( y ),
								_FTOL( x + xAddX ), _FTOL( y + xAddY ),
								_FTOL( x + yAddX ), _FTOL( y + yAddY ),
								_FTOL( x + xAddX + yAddX ), _FTOL( y + xAddY + yAddY ),
								Image, TransFlag ) ;
			}
		}
	}

	// `\͈͂ɖ߂
	NS_SetDrawArea( DrawRect.left, DrawRect.top, DrawRect.right, DrawRect.bottom ) ;

	return 0 ;
}

// \tgEGA_O DrawFillBox
static int  Graphics_Software_DrawFillBox( int x1, int y1, int x2, int y2, unsigned int Color )
{
	RECT DestRect ;

	DestRect.left   = x1 ;
	DestRect.top    = y1 ;
	DestRect.right  = x2 ;
	DestRect.bottom = y2 ;

	DrawFillBoxMemImg( GSYS.SoftRender.TargetMemImg, &DestRect, Color ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawLineBox
static int  Graphics_Software_DrawLineBox( int x1, int y1, int x2, int y2, unsigned int Color )
{
	LINEDATA Line[4] ;

	Line[0].x1 = x1 ;		Line[0].y1 = y1 ;		Line[0].x2 = x2 - 1 ;	Line[0].y2 = y1 ;
	Line[1].x1 = x2 - 1 ;	Line[1].y1 = y1 ;		Line[1].x2 = x2 - 1 ;	Line[1].y2 = y2 - 1 ;
	Line[2].x1 = x2 - 1 ;	Line[2].y1 = y2 - 1 ;	Line[2].x2 = x1 ;		Line[2].y2 = y2 - 1 ;
	Line[3].x1 = x1 ;		Line[3].y1 = y2 - 1 ;	Line[3].x2 = x1 ;		Line[3].y2 = y1 ;
	Line[3].color = Line[2].color = Line[1].color = Line[0].color = Color ;
	Line[3].pal   = Line[2].pal   = Line[1].pal   = Line[0].pal   = GSYS.DrawSetting.BlendParam ;

	return Graphics_Software_DrawLineSet( Line, 4 ) ;
}

// \tgEGA_O DrawLine
static int	Graphics_Software_DrawLine( int x1, int y1, int x2, int y2, unsigned int Color )
{
	DrawLineMemImg( GSYS.SoftRender.TargetMemImg, x1, y1, x2, y2, Color ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawCircle( w肠 )
static int	Graphics_Software_DrawCircle_Thickness( int x, int y, int r, unsigned int Color, int Thickness )
{
	int i ;
	RECT DrawRect ;
	short ( *CirclePos )[ 5 ] ;
	int x1, x2, y1 ;

	DrawRect = GSYS.DrawSetting.DrawArea ;

	// ~̍Wobt@擾
	if( Graphics_Other_AllocCommonBuffer( 1, sizeof( short ) * 5 * DrawRect.bottom ) < 0 )
	{
		return -1 ;
	}
	CirclePos = ( short (*)[ 5 ] )GSYS.Resource.CommonBuffer[ 1 ] ;
	_MEMSET( CirclePos, 0, sizeof( short ) * 5 * DrawRect.bottom ) ;

	// ~̍WXg쐬
	Graphics_Draw_GetCircle_ThicknessDrawPosition( x, y, r, Thickness, CirclePos ) ;

	// `揈
	for( i = DrawRect.top ; i < DrawRect.bottom ; i ++ )
	{
		if( CirclePos[ i ][ 4 ] == 0 )
		{
			continue ;
		}

		y1 = i ;

		if( ( CirclePos[ i ][ 4 ] & ( 4 | 8 ) ) == 0 || CirclePos[ i ][ 2 ] >= CirclePos[ i ][ 3 ] )
		{
			x1 = CirclePos[ i ][ 0 ] ;
			x2 = CirclePos[ i ][ 1 ] ;
			DrawLineMemImg( GSYS.SoftRender.TargetMemImg, x1, y1, x2 + 1, y1, Color ) ;
		}
		else
		{
			x1 = CirclePos[ i ][ 0 ] ;
			x2 = CirclePos[ i ][ 2 ] ;
			DrawLineMemImg( GSYS.SoftRender.TargetMemImg, x1, y1, x2 + 1, y1, Color ) ;

			x1 = CirclePos[ i ][ 3 ] ;
			x2 = CirclePos[ i ][ 1 ] ;
			DrawLineMemImg( GSYS.SoftRender.TargetMemImg, x1, y1, x2 + 1, y1, Color ) ;
		}
	}

	// I
	return 0 ;
}

// \tgEGA_O DrawOval( w肠 )
static int	Graphics_Software_DrawOval_Thickness( int x, int y, int rx, int ry, unsigned int Color, int Thickness )
{
	int i ;
	RECT DrawRect ;
	short ( *CirclePos )[ 5 ] ;
	int x1, x2, y1 ;

	DrawRect = GSYS.DrawSetting.DrawArea ;

	// ~̍Wobt@擾
	if( Graphics_Other_AllocCommonBuffer( 1, sizeof( short ) * 5 * DrawRect.bottom ) < 0 )
	{
		return -1 ;
	}
	CirclePos = ( short (*)[ 5 ] )GSYS.Resource.CommonBuffer[ 1 ] ;
	_MEMSET( CirclePos, 0, sizeof( short ) * 5 * DrawRect.bottom ) ;

	// ~̍WXg쐬
	if( Graphics_Draw_GetOval_ThicknessDrawPosition( x, y, rx, ry, Thickness, CirclePos ) < 0 )
	{
		return -1 ;
	}

	// `揈
	for( i = DrawRect.top ; i < DrawRect.bottom ; i ++ )
	{
		if( CirclePos[ i ][ 4 ] == 0 )
		{
			continue ;
		}

		y1 = i ;

		if( ( CirclePos[ i ][ 4 ] & ( 4 | 8 ) ) == 0 || CirclePos[ i ][ 2 ] >= CirclePos[ i ][ 3 ] )
		{
			x1 = CirclePos[ i ][ 0 ] ;
			x2 = CirclePos[ i ][ 1 ] ;
			DrawLineMemImg( GSYS.SoftRender.TargetMemImg, x1, y1, x2 + 1, y1, Color ) ;
		}
		else
		{
			x1 = CirclePos[ i ][ 0 ] ;
			x2 = CirclePos[ i ][ 2 ] ;
			DrawLineMemImg( GSYS.SoftRender.TargetMemImg, x1, y1, x2 + 1, y1, Color ) ;

			x1 = CirclePos[ i ][ 3 ] ;
			x2 = CirclePos[ i ][ 1 ] ;
			DrawLineMemImg( GSYS.SoftRender.TargetMemImg, x1, y1, x2 + 1, y1, Color ) ;
		}
	}

	// I
	return 0 ;
}

// \tgEGA_O DrawCircle
static int	Graphics_Software_DrawCircle( int x, int y, int r, unsigned int Color, int FillFlag, int Rx_One_Minus, int Ry_One_Minus )
{
	DrawCircleMemImg( GSYS.SoftRender.TargetMemImg, x, y, r, Color, FillFlag, Rx_One_Minus, Ry_One_Minus ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawOval
static int	Graphics_Software_DrawOval( int x, int y, int rx, int ry, unsigned int Color, int FillFlag, int Rx_One_Minus, int Ry_One_Minus )
{
	DrawOvalMemImg( GSYS.SoftRender.TargetMemImg, x, y, rx, ry, Color, FillFlag, Rx_One_Minus, Ry_One_Minus ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawTriangle
static int	Graphics_Software_DrawTriangle( int x1, int y1, int x2, int y2, int x3, int y3, unsigned int Color, int FillFlag )
{
	// hԂłȂŏ𕪊
	if( FillFlag == TRUE )
	{
		// hԂ̏ꍇ
		DX_POINTDATA p[3] ;

		p[0].x = x1 ;		p[0].y = y1 ;
		p[1].x = x2 ;		p[1].y = y2 ;
		p[2].x = x3 ;		p[2].y = y3 ;
	
		return Graphics_Software_DrawPoly( p, NULL, FALSE, Color ) ;
	}
	else
	{
		LINEDATA Line[3] ;
		
		Line[0].x1 = x1 ;	Line[0].y1 = y1 ;	Line[0].x2 = x2 ;	Line[0].y2 = y2 ;
		Line[1].x1 = x2 ;	Line[1].y1 = y2 ;	Line[1].x2 = x3 ;	Line[1].y2 = y3 ;
		Line[2].x1 = x3 ;	Line[2].y1 = y3 ;	Line[2].x2 = x1 ;	Line[2].y2 = y1 ;
		Line[2].color = Line[1].color = Line[0].color = Color ;
		Line[2].pal   = Line[1].pal   = Line[0].pal   = GSYS.DrawSetting.BlendParam ;
		return Graphics_Software_DrawLineSet( Line, 3 ) ;
	}
}

// \tgEGA_O DrawQuadrangle
static int	Graphics_Software_DrawQuadrangle( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, unsigned int Color, int FillFlag )
{
	// hԂłȂŏ𕪊
	if( FillFlag == TRUE )
	{
		// hԂ̏ꍇ

		DX_POINTDATA p[3] ;

		p[0].x = x1 ;		p[0].y = y1 ;
		p[1].x = x2 ;		p[1].y = y2 ;
		p[2].x = x4 ;		p[2].y = y4 ;
		Graphics_Software_DrawPoly( p, NULL, FALSE, Color ) ;

		p[0].x = x3 ;		p[0].y = y3 ;
		p[1].x = x4 ;		p[1].y = y4 ;
		p[2].x = x2 ;		p[2].y = y2 ;
		return Graphics_Software_DrawPoly( p, NULL, FALSE, Color ) ;
	}
	else
	{
		LINEDATA Line[4] ;
		
		Line[0].x1 = x1 ;	Line[0].y1 = y1 ;	Line[0].x2 = x2 ;	Line[0].y2 = y2 ;
		Line[1].x1 = x2 ;	Line[1].y1 = y2 ;	Line[1].x2 = x3 ;	Line[1].y2 = y3 ;
		Line[2].x1 = x3 ;	Line[2].y1 = y3 ;	Line[2].x2 = x4 ;	Line[2].y2 = y4 ;
		Line[3].x1 = x4 ;	Line[3].y1 = y4 ;	Line[3].x2 = x1 ;	Line[3].y2 = y1 ;
		Line[3].color = Line[2].color = Line[1].color = Line[0].color = Color ;
		Line[3].pal   = Line[2].pal   = Line[1].pal   = Line[0].pal   = GSYS.DrawSetting.BlendParam ;
		return Graphics_Software_DrawLineSet( Line, 4 ) ;
	}
}


// \tgEGA_O DrawPixel
static int	Graphics_Software_DrawPixel( int x, int y, unsigned int Color )
{
	DrawPixelMemImg( GSYS.SoftRender.TargetMemImg, x, y, Color ) ;

	// I
	return 0 ;
}


// \tgEGA_O DrawPixelSet
static int	Graphics_Software_DrawPixelSet( const POINTDATA *PointData, int Num )
{
	DrawPixelSetMemImg( GSYS.SoftRender.TargetMemImg, PointData, Num ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawLineSet
static int	Graphics_Software_DrawLineSet( const LINEDATA *LineData, int Num )
{
	DrawLineSetMemImg( GSYS.SoftRender.TargetMemImg, LineData, Num ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawBoxSet
static int  Graphics_Software_DrawBoxSet( const RECTDATA *RectData, int Num )
{
	DrawBoxSetMemImg( GSYS.SoftRender.TargetMemImg, RectData, Num ) ;

	// I
	return 0 ;
}



















// OtBbNnh쐬֌W֐

// ̃OtBbN쐬
extern	int NS_MakeGraph( int SizeX, int SizeY, int NotUse3DFlag )
{
	SETUP_GRAPHHANDLE_GPARAM GParam ;

	Graphics_Image_InitSetupGraphHandleGParam( &GParam ) ;

	return Graphics_Image_MakeGraph_UseGParam( &GParam, SizeX, SizeY, NotUse3DFlag, FALSE, 0, GetASyncLoadFlag() ) ;
}

// `\ȉʂ쐬
extern int NS_MakeScreen( int SizeX, int SizeY, int UseAlphaChannel )
{
	SETUP_GRAPHHANDLE_GPARAM GParam ;

	// \tgEGA_O[hł̓At@`lt̕`\摜͍Ȃ
	if( UseAlphaChannel && NS_GetScreenMemToSystemMemFlag() == TRUE )
		return -1 ;

	Graphics_Image_InitSetupGraphHandleGParam( &GParam ) ;

	GParam.DrawValidImageCreateFlag = TRUE ;
	GParam.DrawValidAlphaImageCreateFlag = UseAlphaChannel ;
	return Graphics_Image_MakeGraph_UseGParam( &GParam, SizeX, SizeY, FALSE, FALSE, 0, GetASyncLoadFlag() ) ;
}

// w̃OtBbN̎w蕔𔲂oĐVȃOtBbNnh쐬
extern int NS_DerivationGraph( int SrcX, int SrcY, int Width, int Height, int SrcGraphHandle )
{
	return Graphics_Image_DerivationGraph_UseGParam( FALSE, SrcX, ( float )SrcX, SrcY, ( float )SrcY, Width, ( float )Width, Height, ( float )Height, SrcGraphHandle, FALSE ) ;
}

// w̃OtBbNnh̎w蕔𔲂oĐVȃOtBbNnh쐬( float )
extern int NS_DerivationGraphF( float SrcX, float SrcY, float Width, float Height, int SrcGraphHandle )
{
	return Graphics_Image_DerivationGraph_UseGParam( TRUE, _FTOL( SrcX ), SrcX, _FTOL( SrcY ), SrcY, _FTOL( Width ), Width, _FTOL( Height ), Height, SrcGraphHandle, FALSE ) ;
}

// w̃OtBbNf[^폜
extern	int NS_DeleteGraph( int GrHandle, int )
{
	return SubHandle( GrHandle ) ;
}

// w̃OtBbNnhƁAOtBbNf[^hĂOtBbNnh( DerivationGraph ŔhnhALoadDivGraph ǂݍō쐬ꂽ̃nh )xɍ폜
extern	int NS_DeleteSharingGraph( int GrHandle )
{
	IMAGEDATA_ORIG *Orig ;
	IMAGEDATA *Image, **TmpImage ;
	bool BreakFlag ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;

	// OtBbNf[^hĂnhSč폜
	Orig = Image->Orig ;
	BreakFlag = false ;
	for( TmpImage = ( IMAGEDATA ** )&HandleManageArray[ DX_HANDLETYPE_GRAPH ].Handle[ HandleManageArray[ DX_HANDLETYPE_GRAPH ].AreaMin ] ; ; TmpImage ++ )
	{
		if( *TmpImage == NULL ) continue ;

		if( ( *TmpImage )->Orig == Orig )
		{
			BreakFlag = Orig->RefCount == 1 ;
			NS_DeleteGraph( ( *TmpImage )->HandleInfo.Handle, FALSE ) ;
			if( BreakFlag ) break ;
		}
	}

	// I
	return 0 ;
}

// LȃOtBbN̐擾
extern	int NS_GetGraphNum( void )
{
	return HandleManageArray[ DX_HANDLETYPE_GRAPH ].Num ;
}

// OtBbN̐FœhԂ
extern	int NS_FillGraph( int GrHandle, int Red, int Green, int Blue, int Alpha )
{
	return Graphics_Image_FillGraph_UseGParam( GrHandle, Red, Green, Blue, Alpha, FALSE ) ;
}

// OtBbNnh̎w͈̔͂w̐FœhԂ
extern int NS_FillRectGraph( int GrHandle, int x, int y, int Width, int Height, int Red, int Green, int Blue, int Alpha )
{
	IMAGEDATA *Image ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
	{
		return -1 ;
	}

	// ͈̓`FbN
	if( x < 0 || x + Width  > Image->WidthI  ||
		y < 0 || y + Height > Image->HeightI )
	{
		return -1 ;
	}

	// l̕␳
	if( Red   < 0 ) Red   = 0 ; else if( Red   > 255 ) Red   = 255 ;
	if( Green < 0 ) Green = 0 ; else if( Green > 255 ) Green = 255 ;
	if( Blue  < 0 ) Blue  = 0 ; else if( Blue  > 255 ) Blue  = 255 ;
	if( Alpha < 0 ) Alpha = 0 ; else if( Alpha > 255 ) Alpha = 255 ;

	// h摜ł͂ȂAŜ̏ꍇ FillGraph gp
	if( Image->WidthI       == Width &&
		Image->HeightI      == Height &&
		Image->Orig->Width  == Image->WidthI &&
		Image->Orig->Height == Image->HeightI )
	{
		return NS_FillGraph( GrHandle, Red, Green, Blue, Alpha ) ;
	}

	// eNX`ǂŏ𕪊
	if( Image->Orig->FormatDesc.TextureFlag )
	{
		// `ΏۂɂłAh摜ł͂Ȃǂŏ𕪊
		if( Image->Orig->FormatDesc.DrawValidFlag &&
			Image->Orig->Width  == Image->WidthI &&
			Image->Orig->Height == Image->HeightI )
		{
			SCREENDRAWSETTINGINFO ScreenDrawSettingInfo ;

			// `Ώۂɂłꍇ SetDrawScreen gpĒڕ`悷

			// e`ݒ擾
			Graphics_DrawSetting_GetScreenDrawSettingInfo( &ScreenDrawSettingInfo ) ;

			// `ύX
			NS_SetDrawScreen( GrHandle ) ;
			NS_SetDrawArea( 0, 0, Image->WidthI, Image->HeightI ) ;

			// `uh[hύX
			NS_SetDrawBlendMode( DX_BLENDMODE_SRCCOLOR, Alpha ) ;

			// `
			NS_DrawBox( x, y, x + Width, y + Height, GetColor( Red, Green, Blue ), TRUE ) ;

			// `ݒɖ߂
			Graphics_DrawSetting_SetScreenDrawSettingInfo( &ScreenDrawSettingInfo ) ;
		}
		else
		{
			// `ΏۂɂłȂꍇ BASEIMAGE gp
			BASEIMAGE TempImage ;

			if( NS_CreateARGB8ColorBaseImage( Width, Height, &TempImage ) == 0 )
			{
				RECT SrcRect ;

				SrcRect.left   = 0 ;
				SrcRect.top    = 0 ;
				SrcRect.right  = Width ;
				SrcRect.bottom = Height ;

				NS_FillBaseImage( &TempImage, Red, Green, Blue, Alpha ) ;
				NS_BltBmpOrGraphImageToGraph2( NULL, NULL, NULL, FALSE, &TempImage, NULL, &SrcRect, x, y, GrHandle ) ;
				NS_ReleaseBaseImage( &TempImage ) ;
			}
			else
			{
				return -1 ;
			}
		}
	}
	else
	{
		RECT Rect ;

		// eNX`ł͂Ȃꍇ

		// DrawFillBoxMemImg œhԂ
		Rect.left   = x ;
		Rect.top    = y ;
		Rect.right  = x + Width ;
		Rect.bottom = y + Height ;
		DrawFillBoxMemImg( &Image->Soft.MemImg, &Rect, NS_GetColor( Red, Green, Blue ) ) ; 
	}

	// I
	return 0 ;
}

// ɗĂtÕ|C^Zbg
extern	int NS_SetGraphLostFlag( int GrHandle, int *LostFlag )
{
	IMAGEDATA *Image ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;

	Image->LostFlag = LostFlag ;
	if( LostFlag != NULL ) *LostFlag = FALSE ;

	// I
	return 0 ;
}

// InitGraph ŃOtBbNnh폜邩ǂ`FbN֐
static int DeleteCancelCheckInitGraphFunction( HANDLEINFO *HandleInfo )
{
	IMAGEDATA *Image = ( IMAGEDATA * )HandleInfo ;

	return Image->NotInitGraphDelete || ( Image->NotInitGraphDeleteUser && GSYS.TerminateNowFlag == FALSE ) ;
}

// 摜f[^̏
extern	int NS_InitGraph( int )
{
	int Result ;

	// OtBbNnhSč폜
	Result = AllHandleSub( DX_HANDLETYPE_GRAPH, DeleteCancelCheckInitGraphFunction ) ;

	// VhE}bvnhSč폜
	Result = AllHandleSub( DX_HANDLETYPE_SHADOWMAP ) ;

	// ˑ
	Graphics_Hardware_InitGraph_PF() ;

	// I
	return Result ;
}

// t@Cǂݍ񂾉摜ēxǂݍ
extern	int NS_ReloadFileGraphAll( void )
{
	Graphics_Image_DefaultRestoreGraphFunction() ;

	// I
	return 0 ;
}






















// VhE}bvnh֌W֐

// VhE}bvnh쐬
extern int NS_MakeShadowMap( int SizeX, int SizeY )
{
	SETUP_SHADOWMAPHANDLE_GPARAM GParam ;

	// n[hEGAANZ[^G[
	if( Graphics_Hardware_CheckValid_PF() == 0 )
		return -1 ;

	GParam.Dummy = 0 ;

	return Graphics_ShadowMap_MakeShadowMap_UseGParam( &GParam, SizeX, SizeY, GetASyncLoadFlag() ) ;
}

// VhE}bvnh폜
extern int NS_DeleteShadowMap( int SmHandle )
{
	return SubHandle( SmHandle ) ;
}

// VhE}bvz肷郉Cg̕ݒ肷
extern int NS_SetShadowMapLightDirection( int SmHandle, VECTOR Direction )
{
	VECTOR xvec ;
	VECTOR yvec ;
	VECTOR zvec ;
	SHADOWMAPDATA *ShadowMap ;

	// AhX̎擾
	if( SHADOWMAPCHK( SmHandle, ShadowMap ) )
		return -1 ;

	// CgxNgɉ]邽߂̍s쐬
	zvec = VNorm( Direction ) ;
	yvec = VGet( 0.0f, 1.0f, 0.0f ) ;
	xvec = VCross( yvec, zvec ) ;
	if( VSquareSize( xvec ) <= 0.0000001f )
	{
		yvec = VGet( 1.0f, 0.0f, 0.0f ) ;
		xvec = VCross( yvec, zvec ) ;
	}
	yvec = VNorm( VCross( zvec, xvec ) ) ;
	xvec = VNorm( xvec ) ;
	ShadowMap->ShadowMapViewMatrix.m[ 0 ][ 0 ] = ShadowMap->LightMatrix.m[ 0 ][ 0 ] = xvec.x ;
	ShadowMap->ShadowMapViewMatrix.m[ 1 ][ 0 ] = ShadowMap->LightMatrix.m[ 1 ][ 0 ] = xvec.y ;
	ShadowMap->ShadowMapViewMatrix.m[ 2 ][ 0 ] = ShadowMap->LightMatrix.m[ 2 ][ 0 ] = xvec.z ;

	ShadowMap->ShadowMapViewMatrix.m[ 0 ][ 1 ] = ShadowMap->LightMatrix.m[ 0 ][ 1 ] = yvec.x ;
	ShadowMap->ShadowMapViewMatrix.m[ 1 ][ 1 ] = ShadowMap->LightMatrix.m[ 1 ][ 1 ] = yvec.y ;
	ShadowMap->ShadowMapViewMatrix.m[ 2 ][ 1 ] = ShadowMap->LightMatrix.m[ 2 ][ 1 ] = yvec.z ;

	ShadowMap->ShadowMapViewMatrix.m[ 0 ][ 2 ] = ShadowMap->LightMatrix.m[ 0 ][ 2 ] = zvec.x ;
	ShadowMap->ShadowMapViewMatrix.m[ 1 ][ 2 ] = ShadowMap->LightMatrix.m[ 1 ][ 2 ] = zvec.y ;
	ShadowMap->ShadowMapViewMatrix.m[ 2 ][ 2 ] = ShadowMap->LightMatrix.m[ 2 ][ 2 ] = zvec.z ;

	// Cg̕ۑ
	ShadowMap->LightDirection = Direction ;

	// VhE}bvւ̕`揀ς݂̏ꍇ̓VhE}bvւ̕`ɕKvȍsXV
	if( ShadowMap->DrawSetupFlag )
	{
		// s̍XV
		Graphics_ShadowMap_RefreshMatrix( ShadowMap ) ;
	}

	// I
	return 0 ;
}

// VhE}bvւ̕`̏s
extern int NS_ShadowMap_DrawSetup( int SmHandle )
{
	int i ;
	SHADOWMAPDATA *ShadowMap ;

	// AhX̎擾
	if( SHADOWMAPCHK( SmHandle, ShadowMap ) )
		return -1 ;

	// `ŎgpVhE}bvɐݒ肳Ă
	for( i = 0 ; i < MAX_USE_SHADOWMAP_NUM ; i ++ )
	{
		if( GSYS.DrawSetting.ShadowMap[ i ] == SmHandle )
		{
			NS_SetUseShadowMap( i, -1 ) ;
		}
	}

	// ɕ`揀Ăꍇ͉Ȃ
	if( ShadowMap->DrawSetupFlag == TRUE )
		return -1 ;

	// ʂ̃VhE}bvɑ΂`揀ĂA̕`抮Ԃ
	if( GSYS.DrawSetting.ShadowMapDraw == TRUE )
	{
		NS_ShadowMap_DrawEnd() ;
	}

	// X̕`Ώۂۑ
	for( i = 0 ; i < DX_RENDERTARGET_COUNT ; i ++ )
	{
		ShadowMap->RenderTargetScreen[ i ]         = GSYS.DrawSetting.TargetScreen[ i ] ;
		ShadowMap->RenderTargetScreenSurface[ i ]  = GSYS.DrawSetting.TargetScreenSurface[ i ] ;
		ShadowMap->RenderTargetScreenMipLevel[ i ] = GSYS.DrawSetting.TargetScreenMipLevel[ i ] ;
	}

	// }XNgp邩ǂ̃tOۑ
#ifndef DX_NON_MASK
	ShadowMap->RenderMaskUseFlag          = MASKD.MaskUseFlag ;
#endif

	// tHOgp邩ǂ̃tOۑ
	ShadowMap->RenderFogEnable            = GSYS.DrawSetting.FogEnable ;

	// ݂̕`WvZp̏ۑ
	ShadowMap->RenderCameraPosition       = GSYS.Camera.Position ;
	ShadowMap->RenderCameraTarget         = GSYS.Camera.Target ;
	ShadowMap->RenderCameraUp             = GSYS.Camera.Up ;
	ShadowMap->RenderCameraHRotate        = GSYS.Camera.HRotate ;
	ShadowMap->RenderCameraVRotate        = GSYS.Camera.VRotate ;
	ShadowMap->RenderCameraTRotate        = GSYS.Camera.TRotate ;
	ShadowMap->RenderCameraMatrix         = GSYS.Camera.Matrix ;
	ShadowMap->RenderCameraScreenCenterX  = GSYS.Camera.ScreenCenterX ;
	ShadowMap->RenderCameraScreenCenterY  = GSYS.Camera.ScreenCenterY ;

	ShadowMap->RenderProjectionMatrixMode = GSYS.DrawSetting.ProjectionMatrixMode ;
	ShadowMap->RenderProjNear             = GSYS.DrawSetting.ProjNear ;
	ShadowMap->RenderProjFar              = GSYS.DrawSetting.ProjFar ;
	ShadowMap->RenderProjDotAspect        = GSYS.DrawSetting.ProjDotAspect ;
	ShadowMap->RenderProjFov              = GSYS.DrawSetting.ProjFov ;
	ShadowMap->RenderProjSize             = GSYS.DrawSetting.ProjSize ;
	ShadowMap->RenderProjMatrix           = GSYS.DrawSetting.ProjMatrix ;

	// `͈͂ݒ肳ĂȂꍇɎgp`͈͂Zo
	{
		VECTOR AddXVecP ;
		VECTOR AddXVecM ;
		VECTOR AddYVecP ;
		VECTOR AddYVecM ;
		VECTOR AddZVecP ;
		VECTOR AddZVecM ;

		// `͈͂ɓ͎̈̌Q{AEE㉺PDT{Aɂ
		AddXVecP = VSub( NS_ConvScreenPosToWorldPos( VGet( GSYS.DrawSetting.DrawAreaF.right,                           0.0f, 1.0f ) ), NS_ConvScreenPosToWorldPos( VGet( GSYS.DrawSetting.DrawAreaF.left,                              0.0f, 1.0f ) ) ) ;
		AddYVecP = VSub( NS_ConvScreenPosToWorldPos( VGet(                             0.0f, GSYS.DrawSetting.DrawAreaF.top, 1.0f ) ), NS_ConvScreenPosToWorldPos( VGet(                            0.0f, GSYS.DrawSetting.DrawAreaF.bottom, 1.0f ) ) ) ;
		AddZVecP = VSub( NS_ConvScreenPosToWorldPos( VGet(                             0.0f,                           0.0f, 1.0f ) ), NS_ConvScreenPosToWorldPos( VGet(                            0.0f,                              0.0f, 0.0f ) ) ) ;
		AddXVecM = VScale( AddXVecP, -1.0f ) ;
		AddYVecM = VScale( AddYVecP, -1.0f ) ;
		AddZVecM = VScale( AddZVecP, -1.0f ) ;

		AddXVecP = VScale( AddXVecP, 0.5f ) ;
		AddXVecM = VScale( AddXVecM, 0.5f ) ;
		AddYVecP = VScale( AddYVecP, 0.5f ) ;
		AddYVecM = VScale( AddYVecM, 0.5f ) ;
	//	AddZVecP = VScale( AddZVecP, 0.5f ) ;
	//	AddZVecM = VScale( AddZVecM, 0.5f ) ;

		// CgxNgɃr[NbvW]āAőlƍŏlZo
		for( i = 0 ; i < 8 ; i ++ )
		{
			ShadowMap->DefaultViewClipPos[ i ] = VConvDtoF( ( ( VECTOR_D * )GSYS.DrawSetting.ViewClipPos )[ i ] ) ;
		}
		
		VectorAdd( &ShadowMap->DefaultViewClipPos[ 0 ], &ShadowMap->DefaultViewClipPos[ 0 ], &AddZVecM ) ;
		VectorAdd( &ShadowMap->DefaultViewClipPos[ 1 ], &ShadowMap->DefaultViewClipPos[ 1 ], &AddZVecM ) ;
		VectorAdd( &ShadowMap->DefaultViewClipPos[ 2 ], &ShadowMap->DefaultViewClipPos[ 2 ], &AddZVecM ) ;
		VectorAdd( &ShadowMap->DefaultViewClipPos[ 3 ], &ShadowMap->DefaultViewClipPos[ 3 ], &AddZVecM ) ;
		
		VectorAdd( &ShadowMap->DefaultViewClipPos[ 0 ], &ShadowMap->DefaultViewClipPos[ 0 ], &AddXVecM ) ;
		VectorAdd( &ShadowMap->DefaultViewClipPos[ 2 ], &ShadowMap->DefaultViewClipPos[ 2 ], &AddXVecM ) ;
		VectorAdd( &ShadowMap->DefaultViewClipPos[ 4 ], &ShadowMap->DefaultViewClipPos[ 4 ], &AddXVecM ) ;
		VectorAdd( &ShadowMap->DefaultViewClipPos[ 6 ], &ShadowMap->DefaultViewClipPos[ 6 ], &AddXVecM ) ;

		VectorAdd( &ShadowMap->DefaultViewClipPos[ 1 ], &ShadowMap->DefaultViewClipPos[ 1 ], &AddXVecP ) ;
		VectorAdd( &ShadowMap->DefaultViewClipPos[ 3 ], &ShadowMap->DefaultViewClipPos[ 3 ], &AddXVecP ) ;
		VectorAdd( &ShadowMap->DefaultViewClipPos[ 5 ], &ShadowMap->DefaultViewClipPos[ 5 ], &AddXVecP ) ;
		VectorAdd( &ShadowMap->DefaultViewClipPos[ 7 ], &ShadowMap->DefaultViewClipPos[ 7 ], &AddXVecP ) ;
		
		VectorAdd( &ShadowMap->DefaultViewClipPos[ 0 ], &ShadowMap->DefaultViewClipPos[ 0 ], &AddYVecP ) ;
		VectorAdd( &ShadowMap->DefaultViewClipPos[ 1 ], &ShadowMap->DefaultViewClipPos[ 1 ], &AddYVecP ) ;
		VectorAdd( &ShadowMap->DefaultViewClipPos[ 4 ], &ShadowMap->DefaultViewClipPos[ 4 ], &AddYVecP ) ;
		VectorAdd( &ShadowMap->DefaultViewClipPos[ 5 ], &ShadowMap->DefaultViewClipPos[ 5 ], &AddYVecP ) ;

		VectorAdd( &ShadowMap->DefaultViewClipPos[ 2 ], &ShadowMap->DefaultViewClipPos[ 2 ], &AddYVecM ) ;
		VectorAdd( &ShadowMap->DefaultViewClipPos[ 3 ], &ShadowMap->DefaultViewClipPos[ 3 ], &AddYVecM ) ;
		VectorAdd( &ShadowMap->DefaultViewClipPos[ 6 ], &ShadowMap->DefaultViewClipPos[ 6 ], &AddYVecM ) ;
		VectorAdd( &ShadowMap->DefaultViewClipPos[ 7 ], &ShadowMap->DefaultViewClipPos[ 7 ], &AddYVecM ) ;
	}

#ifndef DX_NON_MASK
	// }XNʂgpȂݒɕύX
	NS_SetUseMaskScreenFlag( FALSE ) ;
#endif

	// tHOgpȂݒɕύX
	NS_SetFogEnable( FALSE ) ;

	// `ΏۂVhE}bvɕύX
	GSYS.DrawSetting.ShadowMapDrawSetupRequest = TRUE ;
	NS_SetDrawScreen( SmHandle ) ;
	for( i = 1 ; i < DX_RENDERTARGET_COUNT ; i ++ )
	{
		NS_SetRenderTargetToShader( i, -1, 0, 0 ) ;
	}

	// VhE}bvւ̃_OɕKvȍs̃ZbgAbv
	Graphics_ShadowMap_RefreshMatrix( ShadowMap ) ;

	// `揀ĂtO𗧂Ă
	ShadowMap->DrawSetupFlag = TRUE ;

	// ˑ
	Graphics_Hardware_ShadowMap_DrawSetup_PF( ShadowMap ) ;

	// ʂŐ[xŃNA
	{
		int Red, Green, Blue, Alpha, Enable ;

		Red   = GSYS.Screen.BackgroundRed ;
		Green = GSYS.Screen.BackgroundGreen ;
		Blue  = GSYS.Screen.BackgroundBlue ;
		Alpha = GSYS.Screen.BackgroundAlpha ;
		Enable = GSYS.Screen.EnableBackgroundColor ;

		NS_SetBackgroundColor( 255,255,255,255 ) ;
		NS_ClearDrawScreen( NULL ) ;

		GSYS.Screen.BackgroundRed = Red ;
		GSYS.Screen.BackgroundGreen = Green ;
		GSYS.Screen.BackgroundBlue = Blue ;
		GSYS.Screen.BackgroundAlpha = Alpha ;
		GSYS.Screen.EnableBackgroundColor = Enable ;
	}

	// I
	return 0 ;
}

// VhE}bvւ̕`I
extern int NS_ShadowMap_DrawEnd( void )
{
	SHADOWMAPDATA *ShadowMap ;
	int i ;

	// `揀ĂȂꍇ͉Ȃ
	if( GSYS.DrawSetting.ShadowMapDraw == FALSE )
		return -1 ;

	// AhX̎擾
	if( SHADOWMAPCHK( GSYS.DrawSetting.ShadowMapDrawHandle, ShadowMap ) )
	{
		GSYS.DrawSetting.ShadowMapDraw = FALSE ;
		return -1 ;
	}

	// `揀ĂȂꍇ͉Ȃ
	if( ShadowMap->DrawSetupFlag == FALSE )
		return -1 ;

	// `揀ς݃tO|
	ShadowMap->DrawSetupFlag = FALSE ;

	// VhE}bvɑ΂`ł邩ǂ̃tO|
	GSYS.DrawSetting.ShadowMapDraw = FALSE ;
	GSYS.DrawSetting.ShadowMapDrawHandle = 0 ;

	// `ɖ߂
	for( i = 0 ; i < DX_RENDERTARGET_COUNT ; i ++ )
	{
		NS_SetRenderTargetToShader( i, ShadowMap->RenderTargetScreen[ i ], ShadowMap->RenderTargetScreenSurface[ i ], ShadowMap->RenderTargetScreenMipLevel[ i ] ) ; 
	}

#ifndef DX_NON_MASK
	// }XNʂgpݒɖ߂
	NS_SetUseMaskScreenFlag( ShadowMap->RenderMaskUseFlag ) ;
#endif

	// tHOgpݒɖ߂
	NS_SetFogEnable( ShadowMap->RenderFogEnable ) ;

	// Jݒɖ߂
	GSYS.Camera.Position      = ShadowMap->RenderCameraPosition ;
	GSYS.Camera.Target        = ShadowMap->RenderCameraTarget ;
	GSYS.Camera.Up            = ShadowMap->RenderCameraUp ;
	GSYS.Camera.HRotate       = ShadowMap->RenderCameraHRotate ;
	GSYS.Camera.VRotate       = ShadowMap->RenderCameraVRotate ;
	GSYS.Camera.TRotate       = ShadowMap->RenderCameraTRotate ;
	GSYS.Camera.Matrix        = ShadowMap->RenderCameraMatrix ;
	NS_SetTransformToViewD( &ShadowMap->RenderCameraMatrix ) ;
	NS_SetCameraScreenCenterD( ShadowMap->RenderCameraScreenCenterX, ShadowMap->RenderCameraScreenCenterY ) ;

	// ˉep[^Zbg
	GSYS.DrawSetting.ProjectionMatrixMode = ShadowMap->RenderProjectionMatrixMode ;
	GSYS.DrawSetting.ProjNear             = ShadowMap->RenderProjNear ;
	GSYS.DrawSetting.ProjFar              = ShadowMap->RenderProjFar ;
	GSYS.DrawSetting.ProjDotAspect        = ShadowMap->RenderProjDotAspect ;
	GSYS.DrawSetting.ProjFov              = ShadowMap->RenderProjFov ;
	GSYS.DrawSetting.ProjSize             = ShadowMap->RenderProjSize ;
	GSYS.DrawSetting.ProjMatrix           = ShadowMap->RenderProjMatrix ;
	Graphics_DrawSetting_SetTransformToProjection_Direct( &GSYS.DrawSetting.ProjMatrix ) ;

	// ˑ
	Graphics_Hardware_ShadowMap_DrawEnd_PF( ShadowMap ) ;

#ifndef DX_NON_FILTER

	// VhE}bvɃu[|
	if( ShadowMap->BlurParam > 0 )
	{
		NS_GraphFilter( ShadowMap->HandleInfo.Handle, DX_GRAPH_FILTER_GAUSS, 8, ShadowMap->BlurParam ) ;
	}

#endif // DX_NON_FILTER

	// I
	return 0 ;
}

// `ŎgpVhE}bvw肷AXbg͂OPw\ASmHandle  -1 nƎw̃Xbg̃VhE}bv
extern int NS_SetUseShadowMap( int SlotIndex, int SmHandle )
{
	SHADOWMAPDATA *ShadowMap = NULL ;

	// Xbg̃CfbNXsȏꍇ̓G[
	if( SlotIndex < 0 || SlotIndex >= MAX_USE_SHADOWMAP_NUM )
		return -1 ;

	// nhl}CiX̒l̏ꍇ͉
	if( SmHandle < 0 )
	{
		// LȃVhE}bvݒ肵Ă鐔XV
		if( GSYS.DrawSetting.ShadowMap[ SlotIndex ] != 0 )
		{
			GSYS.DrawSetting.UseShadowMapNum -- ;
		}

		// nhlZbg
		GSYS.DrawSetting.ShadowMap[ SlotIndex ] = 0 ;
	}
	else
	{
		// AhX̎擾
		if( SHADOWMAPCHK( SmHandle, ShadowMap ) )
			return -1 ;

		// LȃVhE}bvݒ肵Ă鐔XV
		if( GSYS.DrawSetting.ShadowMap[ SlotIndex ] == 0 )
		{
			GSYS.DrawSetting.UseShadowMapNum ++ ;
		}

		// nhl̕ۑ
		GSYS.DrawSetting.ShadowMap[ SlotIndex ] = SmHandle ;
	}

	// ˑ
	Graphics_Hardware_ShadowMap_SetUse_PF( SlotIndex, ShadowMap ) ;

	// VF[_[̃p[^ɔf
	Graphics_ShadowMap_RefreshVSParam() ;
	Graphics_ShadowMap_RefreshPSParam() ;

	// I
	return 0 ;
}

// VhE}bvɕ`悷ۂ͈̔͂ݒ肷( ̊֐ŕ`͈͂ݒ肵Ȃꍇ͎g債͈͂`͈͂ƂȂ )
extern int NS_SetShadowMapDrawArea( int SmHandle, VECTOR MinPosition, VECTOR MaxPosition )
{
	SHADOWMAPDATA *ShadowMap ;

	// G[
	if( SHADOWMAPCHK( SmHandle, ShadowMap ) )
		return -1 ;

	// Wۑ
	if( MinPosition.x < MaxPosition.x )
	{
		ShadowMap->DrawAreaMinPosition.x = MinPosition.x ;
		ShadowMap->DrawAreaMaxPosition.x = MaxPosition.x ;
	}
	else
	{
		ShadowMap->DrawAreaMinPosition.x = MaxPosition.x ;
		ShadowMap->DrawAreaMaxPosition.x = MinPosition.x ;
	}

	if( MinPosition.y < MaxPosition.y )
	{
		ShadowMap->DrawAreaMinPosition.y = MinPosition.y ;
		ShadowMap->DrawAreaMaxPosition.y = MaxPosition.y ;
	}
	else
	{
		ShadowMap->DrawAreaMinPosition.y = MaxPosition.y ;
		ShadowMap->DrawAreaMaxPosition.y = MinPosition.y ;
	}

	if( MinPosition.z < MaxPosition.z )
	{
		ShadowMap->DrawAreaMinPosition.z = MinPosition.z ;
		ShadowMap->DrawAreaMaxPosition.z = MaxPosition.z ;
	}
	else
	{
		ShadowMap->DrawAreaMinPosition.z = MaxPosition.z ;
		ShadowMap->DrawAreaMaxPosition.z = MinPosition.z ;
	}

	// ꍇ͖
	if( ShadowMap->DrawAreaMaxPosition.x - ShadowMap->DrawAreaMinPosition.x < 0.00000001f ||
		ShadowMap->DrawAreaMaxPosition.y - ShadowMap->DrawAreaMinPosition.y < 0.00000001f ||
		ShadowMap->DrawAreaMaxPosition.z - ShadowMap->DrawAreaMinPosition.z < 0.00000001f )
	{
		return -1 ;
	}

	// tOLɐݒ
	ShadowMap->EnableDrawArea = TRUE ;

	// VhE}bvɕ`悷͈͂̍WXV
	ShadowMap->DrawAreaViewClipPos[ 0 ].x = ShadowMap->DrawAreaMinPosition.x ;
	ShadowMap->DrawAreaViewClipPos[ 0 ].y = ShadowMap->DrawAreaMinPosition.y ;
	ShadowMap->DrawAreaViewClipPos[ 0 ].z = ShadowMap->DrawAreaMinPosition.z ;

	ShadowMap->DrawAreaViewClipPos[ 1 ].x = ShadowMap->DrawAreaMaxPosition.x ;
	ShadowMap->DrawAreaViewClipPos[ 1 ].y = ShadowMap->DrawAreaMinPosition.y ;
	ShadowMap->DrawAreaViewClipPos[ 1 ].z = ShadowMap->DrawAreaMinPosition.z ;

	ShadowMap->DrawAreaViewClipPos[ 2 ].x = ShadowMap->DrawAreaMinPosition.x ;
	ShadowMap->DrawAreaViewClipPos[ 2 ].y = ShadowMap->DrawAreaMaxPosition.y ;
	ShadowMap->DrawAreaViewClipPos[ 2 ].z = ShadowMap->DrawAreaMinPosition.z ;

	ShadowMap->DrawAreaViewClipPos[ 3 ].x = ShadowMap->DrawAreaMaxPosition.x ;
	ShadowMap->DrawAreaViewClipPos[ 3 ].y = ShadowMap->DrawAreaMaxPosition.y ;
	ShadowMap->DrawAreaViewClipPos[ 3 ].z = ShadowMap->DrawAreaMinPosition.z ;

	ShadowMap->DrawAreaViewClipPos[ 4 ].x = ShadowMap->DrawAreaMinPosition.x ;
	ShadowMap->DrawAreaViewClipPos[ 4 ].y = ShadowMap->DrawAreaMinPosition.y ;
	ShadowMap->DrawAreaViewClipPos[ 4 ].z = ShadowMap->DrawAreaMaxPosition.z ;

	ShadowMap->DrawAreaViewClipPos[ 5 ].x = ShadowMap->DrawAreaMaxPosition.x ;
	ShadowMap->DrawAreaViewClipPos[ 5 ].y = ShadowMap->DrawAreaMinPosition.y ;
	ShadowMap->DrawAreaViewClipPos[ 5 ].z = ShadowMap->DrawAreaMaxPosition.z ;

	ShadowMap->DrawAreaViewClipPos[ 6 ].x = ShadowMap->DrawAreaMinPosition.x ;
	ShadowMap->DrawAreaViewClipPos[ 6 ].y = ShadowMap->DrawAreaMaxPosition.y ;
	ShadowMap->DrawAreaViewClipPos[ 6 ].z = ShadowMap->DrawAreaMaxPosition.z ;

	ShadowMap->DrawAreaViewClipPos[ 7 ].x = ShadowMap->DrawAreaMaxPosition.x ;
	ShadowMap->DrawAreaViewClipPos[ 7 ].y = ShadowMap->DrawAreaMaxPosition.y ;
	ShadowMap->DrawAreaViewClipPos[ 7 ].z = ShadowMap->DrawAreaMaxPosition.z ;

	// VhE}bvւ̕`揀ς݂̏ꍇ̓VhE}bvւ̕`ɕKvȍsXV
	if( ShadowMap->DrawSetupFlag )
	{
		// s̍XV
		Graphics_ShadowMap_RefreshMatrix( ShadowMap ) ;
	}

	// I
	return 0 ;
}

// SetShadowMapDrawArea ̐ݒ
extern int NS_ResetShadowMapDrawArea( int SmHandle )
{
	SHADOWMAPDATA *ShadowMap ;

	// G[
	if( SHADOWMAPCHK( SmHandle, ShadowMap ) )
		return -1 ;

	// ɐݒ肪Ă牽Ȃ
	if( ShadowMap->EnableDrawArea == FALSE )
	{
		return 0 ;
	}

	// tO|
	ShadowMap->EnableDrawArea = FALSE ;

	// VhE}bvւ̕`揀ς݂̏ꍇ̓VhE}bvւ̕`ɕKvȍsXV
	if( ShadowMap->DrawSetupFlag )
	{
		// s̍XV
		Graphics_ShadowMap_RefreshMatrix( ShadowMap ) ;
	}

	// I
	return 0 ;
}

// VhE}bvgp`掞̕␳[xݒ肷
extern int NS_SetShadowMapAdjustDepth( int SmHandle, float Depth )
{
	SHADOWMAPDATA *ShadowMap ;
	int i ;

	// G[
	if( SHADOWMAPCHK( SmHandle, ShadowMap ) )
		return -1 ;

	// ␳lۑ
	ShadowMap->AdjustDepth = Depth ;

	// ɃVhE}bvgp̏ꍇ͕␳lύX
	for( i = 0 ; i < MAX_USE_SHADOWMAP_NUM ; i ++ )
	{
		if( GSYS.DrawSetting.ShadowMap[ i ] == SmHandle )
		{
			Graphics_ShadowMap_RefreshPSParam() ;
			break ;
		}
	}

	// I
	return 0 ;
}

// VhE}bv쐬KpɎgpr[sƎˉesZs擾
extern int NS_GetShadowMapViewProjectionMatrix( int SmHandle, MATRIX *MatrixBuffer )
{
	SHADOWMAPDATA *ShadowMap ;

	// G[
	if( SHADOWMAPCHK( SmHandle, ShadowMap ) )
		return -1 ;

	// sۑ
	if( MatrixBuffer != NULL )
	{
		*MatrixBuffer = ShadowMap->ShadowMapViewProjectionMatrix ;
	}

	// I
	return 0 ;
}

// VhE}bvɓKpڂxݒ肷
extern int NS_SetShadowMapBlurParam( int SmHandle, int Param )
{
	SHADOWMAPDATA *ShadowMap ;

	// G[
	if( SHADOWMAPCHK( SmHandle, ShadowMap ) )
		return -1 ;

	// ␳lۑ
	ShadowMap->BlurParam = Param ;

	// I
	return 0 ;
}

// VhE}bvgp`掞̉eOf[V͈͂ݒ肷
extern int NS_SetShadowMapGradationParam( int SmHandle, float Param )
{
	SHADOWMAPDATA *ShadowMap ;
	int i ;

	// G[
	if( SHADOWMAPCHK( SmHandle, ShadowMap ) )
		return -1 ;

	// Of[V͈͂ۑ
	ShadowMap->GradationParam = Param ;

	// ɃVhE}bvgp̏ꍇ͕␳lύX
	for( i = 0 ; i < MAX_USE_SHADOWMAP_NUM ; i ++ )
	{
		if( GSYS.DrawSetting.ShadowMap[ i ] == SmHandle )
		{
			Graphics_ShadowMap_RefreshPSParam() ;
			break ;
		}
	}

	// I
	return 0 ;
}

// VhE}bvʂɃeXg`悷
#define SETDRAWRECTCODE_DRAWSHADOWMAP\
	if( x1 < x2 ){ DrawRect.left = x1 ; DrawRect.right = x2; }\
	if( y1 < y2 ){ DrawRect.top = y1 ; DrawRect.bottom = y2; }\
\
	SETRECT( DrawRect, x1, y1, x2, y2 ) ;\
	DRAWRECT_DRAWAREA_CLIP

extern int NS_TestDrawShadowMap( int SmHandle, int x1, int y1, int x2, int y2 )
{
	SHADOWMAPDATA *ShadowMap ;
	VERTEX_2D DrawVert[ 6 ] ;
	int Ret, Flag ;
	float AdjustPos ;

	CheckActiveState() ;

	// AhX̎擾
	if( SHADOWMAPCHK( SmHandle, ShadowMap ) )
		return -1 ;

	Ret = -1 ;
	Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;

	AdjustPos = GSYS.HardInfo.DrawFloatCoordType == DX_DRAWFLOATCOORDTYPE_DIRECT3D9 ? -0.5f : 0.0f ;

	DrawVert[ 0 ].rhw = 1.0f ;
	DrawVert[ 0 ].pos.z = GSYS.DrawSetting.DrawZ ;
	DrawVert[ 0 ].color = 0xffffffff ;

	DrawVert[ 1 ] = DrawVert[ 0 ] ;
	DrawVert[ 2 ] = DrawVert[ 0 ] ;
	DrawVert[ 3 ] = DrawVert[ 0 ] ;

	DrawVert[ 0 ].pos.x = ( float )x1 + AdjustPos ;
	DrawVert[ 0 ].pos.y = ( float )y1 + AdjustPos ;
	DrawVert[ 0 ].u = 0.0f ;
	DrawVert[ 0 ].v = 0.0f ;

	DrawVert[ 1 ].pos.x = ( float )x2 + AdjustPos ;
	DrawVert[ 1 ].pos.y = ( float )y1 + AdjustPos ;
	DrawVert[ 1 ].u = 1.0f ;
	DrawVert[ 1 ].v = 0.0f ;

	DrawVert[ 2 ].pos.x = ( float )x1 + AdjustPos ;
	DrawVert[ 2 ].pos.y = ( float )y2 + AdjustPos ;
	DrawVert[ 2 ].u = 0.0f ;
	DrawVert[ 2 ].v = 1.0f ;

	DrawVert[ 3 ].pos.x = ( float )x2 + AdjustPos ;
	DrawVert[ 3 ].pos.y = ( float )y2 + AdjustPos ;
	DrawVert[ 3 ].u = 1.0f ;
	DrawVert[ 3 ].v = 1.0f ;

	DrawVert[ 4 ] = DrawVert[ 2 ] ;
	DrawVert[ 5 ] = DrawVert[ 1 ] ;

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	DRAW_DEF(
		Graphics_Hardware_DrawPrimitive2D_PF( DrawVert, 6, DX_PRIMTYPE_TRIANGLELIST, ( IMAGEDATA * )( ( DWORD_PTR )SmHandle ), FALSE, FALSE, FALSE, FALSE, FALSE, 0, TRUE ),
		0,
		SETDRAWRECTCODE_DRAWSHADOWMAP,
		Ret,
		Flag
	)

	// I
	return Ret ;
}


























// OtBbNnhւ̉摜]֐

// 摜f[^̓]
extern	int NS_BltBmpToGraph( const COLORDATA *BmpColorData, HBITMAP RgbBmp, HBITMAP AlphaBmp, int CopyPointX, int CopyPointY, int GrHandle )
{
	return NS_BltBmpOrGraphImageToGraph( BmpColorData, RgbBmp, AlphaBmp,
											TRUE, NULL, NULL,
											CopyPointX, CopyPointY, GrHandle ) ;
}

// 摜ւ̂alo̓]
extern	int NS_BltBmpToDivGraph( const COLORDATA *BmpColorData, HBITMAP RgbBmp, HBITMAP AlphaBmp, int AllNum, int XNum, int YNum, int Width, int Height, const int *GrHandle, int ReverseFlag )
{
	return NS_BltBmpOrGraphImageToDivGraph( BmpColorData, RgbBmp, AlphaBmp,
												TRUE, NULL, NULL,
												AllNum, XNum, YNum, Width, Height, GrHandle, ReverseFlag ) ;
}

// alo  GraphImage 摜ɓ]
extern int NS_BltBmpOrGraphImageToGraph(
	const COLORDATA	*BmpColorData,
	      HBITMAP	RgbBmp,
	      HBITMAP	AlphaBmp,
	      int		BmpFlag,
	const BASEIMAGE	*RgbBaseImage,
	const BASEIMAGE	*AlphaBaseImage,
	      int		CopyPointX,
	      int		CopyPointY,
	      int		GrHandle
)
{
	int			Result ;
#ifdef WINDOWS_DESKTOP_OS
	BITMAP		Bmp ;
	BASEIMAGE	TempBaseRGB ;
	BASEIMAGE	TempBaseAlpha = { 0 } ;
#endif // WINDOWS_DESKTOP_OS

	if( GSYS.InitializeFlag == FALSE ) return -1 ;

	// Bitmap ̏ꍇ́ABASEIMAGE ̏쐬
	if( BmpFlag )
	{
#ifdef WINDOWS_DESKTOP_OS
		SETUP_WIN_API

		WinAPIData.Win32Func.GetObjectAFunc( RgbBmp, sizeof( BITMAP ), ( void * )&Bmp ) ;
		TempBaseRGB.GraphData      = Bmp.bmBits ;
		TempBaseRGB.Width          = Bmp.bmWidth ;
		TempBaseRGB.Height         = Bmp.bmHeight ;
		TempBaseRGB.Pitch          = ( Bmp.bmWidthBytes + 3 ) / 4 * 4 ;
		TempBaseRGB.ColorData      = *BmpColorData ;
		TempBaseRGB.MipMapCount    = 0 ;
		TempBaseRGB.GraphDataCount = 0 ;

		RgbBaseImage = &TempBaseRGB ;

		if( AlphaBmp )
		{
			WinAPIData.Win32Func.GetObjectAFunc( AlphaBmp, sizeof( BITMAP ), ( void * )&Bmp ) ;
			TempBaseAlpha.GraphData      = Bmp.bmBits ;
			TempBaseAlpha.Width          = Bmp.bmWidth ;
			TempBaseAlpha.Height         = Bmp.bmHeight ;
			TempBaseAlpha.Pitch          = ( Bmp.bmWidthBytes + 3 ) / 4 * 4 ;
			TempBaseAlpha.ColorData      = *BmpColorData ;
			TempBaseAlpha.MipMapCount    = 0 ;
			TempBaseAlpha.GraphDataCount = 0 ;

			AlphaBaseImage = &TempBaseAlpha ;
		}
		else
		{
			AlphaBaseImage = NULL ;
		}
#else // WINDOWS_DESKTOP_OS
		return -1 ;
#endif // WINDOWS_DESKTOP_OS
	}

	Result = Graphics_Image_BltBmpOrGraphImageToGraphBase( 
				RgbBaseImage,
				AlphaBaseImage,
				CopyPointX,
				CopyPointY,
				GrHandle,
				GSYS.CreateImage.NotUseTransColor ? FALSE : TRUE
			) ;

	if( Result == 0 )
	{
		if( BmpFlag )
		{
			Graphics_Image_SetGraphBaseInfo( GrHandle, NULL, BmpColorData, RgbBmp, AlphaBmp, NULL, 0, NULL, 0, NULL, NULL, FALSE, FALSE, FALSE, -1, FALSE ) ;
		}
		else
		{
			Graphics_Image_SetGraphBaseInfo( GrHandle, NULL, NULL, NULL, NULL, NULL, 0, NULL, 0, RgbBaseImage, AlphaBaseImage, FALSE, FALSE, FALSE, -1, FALSE ) ;
		}
	}

	return Result ;
}

// alo  GraphImage 摜ɓ]
extern	int NS_BltBmpOrGraphImageToGraph2(
	const COLORDATA	*BmpColorData,
	      HBITMAP	RgbBmp,
	      HBITMAP	AlphaBmp,
	      int		BmpFlag,
	const BASEIMAGE	*RgbBaseImage,
	const BASEIMAGE	*AlphaBaseImage,
	const RECT		*SrcRect,
	      int		DestX,
	      int		DestY,
	      int		GrHandle
)
{
#ifdef WINDOWS_DESKTOP_OS
	BITMAP			Bmp ;
	BASEIMAGE		TempBaseRGB ;
	BASEIMAGE		TempBaseAlpha = { 0 } ;
#endif // WINDOWS_DESKTOP_OS

	// Bitmap ̏ꍇ́ABASEIMAGE ̏쐬
	if( BmpFlag )
	{
#ifdef WINDOWS_DESKTOP_OS
		SETUP_WIN_API

		WinAPIData.Win32Func.GetObjectAFunc( RgbBmp, sizeof( BITMAP ), ( void * )&Bmp ) ;
		TempBaseRGB.GraphData      = Bmp.bmBits ;
		TempBaseRGB.Width          = Bmp.bmWidth ;
		TempBaseRGB.Height         = Bmp.bmHeight ;
		TempBaseRGB.Pitch          = ( Bmp.bmWidthBytes + 3 ) / 4 * 4 ;
		TempBaseRGB.ColorData      = *BmpColorData ;
		TempBaseRGB.MipMapCount    = 0 ;
		TempBaseRGB.GraphDataCount = 0 ;

		RgbBaseImage = &TempBaseRGB ;

		if( AlphaBmp )
		{
			WinAPIData.Win32Func.GetObjectAFunc( AlphaBmp, sizeof( BITMAP ), ( void * )&Bmp ) ;
			TempBaseAlpha.GraphData      = Bmp.bmBits ;
			TempBaseAlpha.Width          = Bmp.bmWidth ;
			TempBaseAlpha.Height         = Bmp.bmHeight ;
			TempBaseAlpha.Pitch          = ( Bmp.bmWidthBytes + 3 ) / 4 * 4 ;
			TempBaseAlpha.ColorData      = *BmpColorData ;
			TempBaseAlpha.MipMapCount    = 0 ;
			TempBaseAlpha.GraphDataCount = 0 ;

			AlphaBaseImage = &TempBaseAlpha ;
		}
		else
		{
			AlphaBaseImage = NULL ;
		}
#else // WINDOWS_DESKTOP_OS
		return -1 ;
#endif // WINDOWS_DESKTOP_OS
	}

	// 摜̓]
	return Graphics_Image_BltBmpOrGraphImageToGraph2Base(
				RgbBaseImage,
				AlphaBaseImage,
				SrcRect,
				DestX,
				DestY,
				GrHandle,
				GSYS.CreateImage.NotUseTransColor ? FALSE : TRUE ) ;
}

// 摜ւ alo  GraphImage ̓]
extern	int NS_BltBmpOrGraphImageToDivGraph(
	const COLORDATA	*BmpColorData,
	      HBITMAP	RgbBmp,
	      HBITMAP	AlphaBmp,
	      int		BmpFlag,
	const BASEIMAGE	*RgbBaseImage,
	const BASEIMAGE	*AlphaBaseImage,
	      int		AllNum,
	      int		XNum,
	      int		YNum,
	      int		Width,
	      int		Height,
	const int		*GrHandle,
	      int		ReverseFlag
)
{
	int Result ;
	int i ;
#ifdef WINDOWS_DESKTOP_OS
	BITMAP		Bmp ;
	BASEIMAGE	TempBaseRGB ;
	BASEIMAGE	TempBaseAlpha = { 0 } ;
#endif // WINDOWS_DESKTOP_OS

	if( GSYS.InitializeFlag == FALSE ) return -1 ;

	// Bitmap ̏ꍇ́ABASEIMAGE ̏쐬
	if( BmpFlag )
	{
#ifdef WINDOWS_DESKTOP_OS
		SETUP_WIN_API

		WinAPIData.Win32Func.GetObjectAFunc( RgbBmp, sizeof( BITMAP ), ( void * )&Bmp ) ;
		TempBaseRGB.GraphData      = Bmp.bmBits ;
		TempBaseRGB.Width          = Bmp.bmWidth ;
		TempBaseRGB.Height         = Bmp.bmHeight ;
		TempBaseRGB.Pitch          = ( Bmp.bmWidthBytes + 3 ) / 4 * 4 ;
		TempBaseRGB.ColorData      = *BmpColorData ;
		TempBaseRGB.MipMapCount    = 0 ;
		TempBaseRGB.GraphDataCount = 0 ;

		RgbBaseImage = &TempBaseRGB ;

		if( AlphaBmp )
		{
			WinAPIData.Win32Func.GetObjectAFunc( AlphaBmp, sizeof( BITMAP ), ( void * )&Bmp ) ;
			TempBaseAlpha.GraphData      = Bmp.bmBits ;
			TempBaseAlpha.Width          = Bmp.bmWidth ;
			TempBaseAlpha.Height         = Bmp.bmHeight ;
			TempBaseAlpha.Pitch          = ( Bmp.bmWidthBytes + 3 ) / 4 * 4 ;
			TempBaseAlpha.ColorData      = *BmpColorData ;
			TempBaseAlpha.MipMapCount    = 0 ;
			TempBaseAlpha.GraphDataCount = 0 ;

			AlphaBaseImage = &TempBaseAlpha ;
		}
		else
		{
			AlphaBaseImage = NULL ;
		}
#else // WINDOWS_DESKTOP_OS
		return -1 ;
#endif // WINDOWS_DESKTOP_OS
	}

	// ]
	Result = Graphics_Image_BltBmpOrGraphImageToDivGraphBase(
		RgbBaseImage,
		AlphaBaseImage,
		AllNum,
		XNum,
		YNum,
		FALSE,
		Width, ( float )Width,
		Height, ( float )Height,
		Width, ( float )Width,
		Height, ( float )Height,
		GrHandle,
		ReverseFlag,
		GSYS.CreateImage.NotUseTransColor ? FALSE : TRUE,
		FALSE
	) ;

	// ŏ̉摜Ƀt@CZbg
	if( BmpFlag )
	{
		Graphics_Image_SetGraphBaseInfo( GrHandle[ 0 ], NULL, BmpColorData, RgbBmp, AlphaBmp, NULL, 0, NULL, 0, NULL, NULL, FALSE, FALSE, FALSE, -1, FALSE ) ;
	}
	else
	{
		Graphics_Image_SetGraphBaseInfo( GrHandle[ 0 ], NULL, NULL, NULL, NULL, NULL, 0, NULL, 0, RgbBaseImage, AlphaBaseImage, FALSE, FALSE, FALSE, -1, FALSE ) ;
	}
	for( i = 1 ; i < AllNum ; i ++ )
	{
		Graphics_Image_SetGraphBaseInfo( GrHandle[ i ], NULL, NULL, NULL, NULL, NULL, 0, NULL, 0, NULL, NULL, FALSE, FALSE, FALSE, GrHandle[ 0 ], FALSE ) ;
	}

	// I
	return Result ;
}

// 摜ւ alo  GraphImage ̓]
extern	int NS_BltBmpOrGraphImageToDivGraphF(
	const COLORDATA	*BmpColorData,
	      HBITMAP	RgbBmp,
	      HBITMAP	AlphaBmp,
	      int		BmpFlag,
	const BASEIMAGE	*RgbBaseImage,
	const BASEIMAGE	*AlphaBaseImage,
	      int		AllNum,
	      int		XNum,
	      int		YNum,
	      float		Width,
	      float		Height,
	const int		*GrHandle,
	      int		ReverseFlag
)
{
	int Result ;
	int i ;
#ifdef WINDOWS_DESKTOP_OS
	BITMAP		Bmp ;
	BASEIMAGE	TempBaseRGB ;
	BASEIMAGE	TempBaseAlpha = { 0 } ;
#endif // WINDOWS_DESKTOP_OS

	if( GSYS.InitializeFlag == FALSE ) return -1 ;

	// Bitmap ̏ꍇ́ABASEIMAGE ̏쐬
	if( BmpFlag )
	{
#ifdef WINDOWS_DESKTOP_OS
		SETUP_WIN_API

		WinAPIData.Win32Func.GetObjectAFunc( RgbBmp, sizeof( BITMAP ), ( void * )&Bmp ) ;
		TempBaseRGB.GraphData      = Bmp.bmBits ;
		TempBaseRGB.Width          = Bmp.bmWidth ;
		TempBaseRGB.Height         = Bmp.bmHeight ;
		TempBaseRGB.Pitch          = ( Bmp.bmWidthBytes + 3 ) / 4 * 4 ;
		TempBaseRGB.ColorData      = *BmpColorData ;
		TempBaseRGB.MipMapCount    = 0 ;
		TempBaseRGB.GraphDataCount = 0 ;

		RgbBaseImage = &TempBaseRGB ;

		if( AlphaBmp )
		{
			WinAPIData.Win32Func.GetObjectAFunc( AlphaBmp, sizeof( BITMAP ), ( void * )&Bmp ) ;
			TempBaseAlpha.GraphData      = Bmp.bmBits ;
			TempBaseAlpha.Width          = Bmp.bmWidth ;
			TempBaseAlpha.Height         = Bmp.bmHeight ;
			TempBaseAlpha.Pitch          = ( Bmp.bmWidthBytes + 3 ) / 4 * 4 ;
			TempBaseAlpha.ColorData      = *BmpColorData ;
			TempBaseAlpha.MipMapCount    = 0 ;
			TempBaseAlpha.GraphDataCount = 0 ;

			AlphaBaseImage = &TempBaseAlpha ;
		}
		else
		{
			AlphaBaseImage = NULL ;
		}
#else // WINDOWS_DESKTOP_OS
		return -1 ;
#endif // WINDOWS_DESKTOP_OS
	}

	// ]
	Result = Graphics_Image_BltBmpOrGraphImageToDivGraphBase(
		RgbBaseImage,
		AlphaBaseImage,
		AllNum,
		XNum,
		YNum,
		TRUE,
		_FTOL( Width ),  Width,
		_FTOL( Height ), Height,
		_FTOL( Width ),  Width,
		_FTOL( Height ), Height,
		GrHandle,
		ReverseFlag,
		GSYS.CreateImage.NotUseTransColor ? FALSE : TRUE,
		FALSE
	) ;

	// ŏ̉摜Ƀt@CZbg
	if( BmpFlag )
	{
		Graphics_Image_SetGraphBaseInfo( GrHandle[ 0 ], NULL, BmpColorData, RgbBmp, AlphaBmp, NULL, 0, NULL, 0, NULL, NULL, FALSE, FALSE, FALSE, -1, FALSE ) ;
	}
	else
	{
		Graphics_Image_SetGraphBaseInfo( GrHandle[ 0 ], NULL, NULL, NULL, NULL, NULL, 0, NULL, 0, RgbBaseImage, AlphaBaseImage, FALSE, FALSE, FALSE, -1, FALSE ) ;
	}
	for( i = 1 ; i < AllNum ; i ++ )
	{
		Graphics_Image_SetGraphBaseInfo( GrHandle[ i ], NULL, NULL, NULL, NULL, NULL, 0, NULL, 0, NULL, NULL, FALSE, FALSE, FALSE, GrHandle[ 0 ], FALSE ) ;
	}

	// I
	return Result ;
}



















// 摜OtBbNnh쐬֐

// 摜ǂ݂
extern int NS_LoadBmpToGraph( const TCHAR *FileName, int TextureFlag, int ReverseFlag, int SurfaceMode )
{
#ifdef UNICODE
	return LoadBmpToGraph_WCHAR_T(
		FileName, TextureFlag, ReverseFlag, SurfaceMode
	) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, return -1 )

	Result = LoadBmpToGraph_WCHAR_T(
		UseFileNameBuffer, TextureFlag, ReverseFlag, SurfaceMode
	) ;

	TCHAR_TO_WCHAR_T_STRING_END( FileName )

	return Result ;
#endif
}

// 摜t@COtBbNnh쐬
extern int NS_LoadBmpToGraphWithStrLen( const TCHAR *FileName, size_t FileNameLength, int TextureFlag, int ReverseFlag, int SurfaceMode )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = LoadBmpToGraph_WCHAR_T( UseFileNameBuffer, TextureFlag, ReverseFlag, SurfaceMode ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = LoadBmpToGraph_WCHAR_T( UseFileNameBuffer, TextureFlag, ReverseFlag, SurfaceMode ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#endif
	return Result ;
}

// 摜ǂ݂
extern int LoadBmpToGraph_WCHAR_T( const wchar_t *FileName, int TextureFlag, int ReverseFlag, int SurfaceMode )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_LoadBmpToGraph_UseGParam( &GParam, FALSE, -1, FileName, TextureFlag, ReverseFlag, SurfaceMode, GetASyncLoadFlag() ) ;
}

// alot@C̃ւ̓ǂ݂݁itO)
extern int NS_LoadGraph( const TCHAR *GraphName, int NotUse3DFlag )
{
	return NS_LoadBmpToGraph( GraphName, !NotUse3DFlag, FALSE, DX_MOVIESURFACE_NORMAL ) ;
}

// 摜t@COtBbNnh쐬
extern int NS_LoadGraphWithStrLen( const TCHAR *FileName, size_t FileNameLength, int NotUse3DFlag )
{
	int Result ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = NS_LoadBmpToGraph( UseFileNameBuffer, !NotUse3DFlag, FALSE, DX_MOVIESURFACE_NORMAL ) ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( FileName )
	return Result ;
}

// alot@C̃ւ̓ǂ݂݁itO)
extern int LoadGraph_WCHAR_T( const wchar_t *GraphName, int NotUse3DFlag )
{
	return LoadBmpToGraph_WCHAR_T( GraphName, !NotUse3DFlag, FALSE ) ;
}

// alot@C̃ւ̔]ǂ݂݁itO)
extern int NS_LoadReverseGraph( const TCHAR *GraphName, int NotUse3DFlag )
{
	return NS_LoadBmpToGraph( GraphName, !NotUse3DFlag, TRUE, DX_MOVIESURFACE_NORMAL ) ;
}

// 摜t@C𔽓]̂ŃOtBbNnh쐬
extern int NS_LoadReverseGraphWithStrLen( const TCHAR *FileName, size_t FileNameLength, int NotUse3DFlag )
{
	int Result ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = NS_LoadBmpToGraph( UseFileNameBuffer, !NotUse3DFlag, TRUE, DX_MOVIESURFACE_NORMAL ) ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( FileName )
	return Result ;
}

// alot@C̃ւ̔]ǂ݂݁itO)
extern int LoadReverseGraph_WCHAR_T( const wchar_t *GraphName, int NotUse3DFlag )
{
	return LoadBmpToGraph_WCHAR_T( GraphName, !NotUse3DFlag, TRUE ) ;
}

// alo̕ǂ݂݁itOj
extern int NS_LoadDivGraph( const TCHAR *FileName, int AllNum, int XNum, int YNum, int XSize, int YSize, int *HandleArray, int NotUse3DFlag, int XStride, int YStride )
{
	return NS_LoadDivBmpToGraph( FileName, AllNum, XNum, YNum, XSize, YSize, HandleArray, !NotUse3DFlag, FALSE, XStride, YStride ) ;
}

// 摜t@C𕪊ăOtBbNnh쐬
extern int NS_LoadDivGraphWithStrLen( const TCHAR *FileName, size_t FileNameLength, int AllNum, int XNum, int YNum, int XSize, int YSize, int *HandleArray, int NotUse3DFlag, int XStride, int YStride )
{
	int Result ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = NS_LoadDivBmpToGraph( UseFileNameBuffer, AllNum, XNum, YNum, XSize, YSize, HandleArray, !NotUse3DFlag, FALSE, XStride, YStride ) ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( FileName )
	return Result ;
}

// alo̕ǂ݂݁itOj
extern int NS_LoadDivGraphF( const TCHAR *FileName, int AllNum, int XNum, int YNum, float XSize, float YSize, int *HandleArray, int NotUse3DFlag, float XStride, float YStride )
{
	return NS_LoadDivBmpToGraphF( FileName, AllNum, XNum, YNum, XSize, YSize, HandleArray, !NotUse3DFlag, FALSE, XStride, YStride ) ;
}

// 摜t@C𕪊ăOtBbNnh쐬
extern int NS_LoadDivGraphFWithStrLen( const TCHAR *FileName, size_t FileNameLength, int AllNum, int XNum, int YNum, float XSize, float YSize, int *HandleArray, int NotUse3DFlag, float XStride, float YStride )
{
	int Result ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = NS_LoadDivBmpToGraphF( UseFileNameBuffer, AllNum, XNum, YNum, XSize, YSize, HandleArray, !NotUse3DFlag, FALSE, XStride, YStride ) ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( FileName )
	return Result ;
}

// alo̕ǂ݂
extern int NS_LoadDivBmpToGraph( const TCHAR *FileName, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleArray, int TextureFlag, int ReverseFlag, int XStride, int YStride )
{
#ifdef UNICODE
	return LoadDivBmpToGraph_WCHAR_T(
		FileName, AllNum, XNum, YNum, FALSE, SizeX, ( float )SizeX, SizeY, ( float )SizeY, HandleArray, TextureFlag, ReverseFlag, XStride, ( float )XStride, YStride, ( float )YStride
	) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, return -1 )

	Result = LoadDivBmpToGraph_WCHAR_T(
		UseFileNameBuffer, AllNum, XNum, YNum, FALSE, SizeX, ( float )SizeX, SizeY, ( float )SizeY, HandleArray, TextureFlag, ReverseFlag, XStride, ( float )XStride, YStride, ( float )YStride
	) ;

	TCHAR_TO_WCHAR_T_STRING_END( FileName )

	return Result ;
#endif
}

// 摜t@C𕪊ăOtBbNnh쐬
extern int NS_LoadDivBmpToGraphWithStrLen( const TCHAR *FileName, size_t FileNameLength, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleArray, int TextureFlag, int ReverseFlag, int XStride, int YStride )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = LoadDivBmpToGraph_WCHAR_T( UseFileNameBuffer, AllNum, XNum, YNum, FALSE, SizeX, ( float )SizeX, SizeY, ( float )SizeY, HandleArray, TextureFlag, ReverseFlag, XStride, ( float )XStride, YStride, ( float )YStride ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = LoadDivBmpToGraph_WCHAR_T( UseFileNameBuffer, AllNum, XNum, YNum, FALSE, SizeX, ( float )SizeX, SizeY, ( float )SizeY, HandleArray, TextureFlag, ReverseFlag, XStride, ( float )XStride, YStride, ( float )YStride ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#endif
	return Result ;
}

// alo̕ǂ݂
extern int NS_LoadDivBmpToGraphF( const TCHAR *FileName, int AllNum, int XNum, int YNum, float SizeX, float SizeY, int *HandleArray, int TextureFlag, int ReverseFlag, float XStride, float YStride )
{
#ifdef UNICODE
	return LoadDivBmpToGraph_WCHAR_T(
		FileName, AllNum, XNum, YNum, TRUE, _FTOL( SizeX ), SizeX, _FTOL( SizeY ), SizeY, HandleArray, TextureFlag, ReverseFlag, _FTOL( XStride ), XStride, _FTOL( YStride ), YStride
	) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, return -1 )

	Result = LoadDivBmpToGraph_WCHAR_T(
		UseFileNameBuffer, AllNum, XNum, YNum, TRUE, _FTOL( SizeX ), SizeX, _FTOL( SizeY ), SizeY, HandleArray, TextureFlag, ReverseFlag, _FTOL( XStride ), XStride, _FTOL( YStride ), YStride
	) ;

	TCHAR_TO_WCHAR_T_STRING_END( FileName )

	return Result ;
#endif
}

// 摜t@C𕪊ăOtBbNnh쐬
extern int NS_LoadDivBmpToGraphFWithStrLen( const TCHAR *FileName, size_t FileNameLength, int AllNum, int XNum, int YNum, float SizeX, float SizeY, int *HandleArray, int TextureFlag, int ReverseFlag, float XStride, float YStride )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = LoadDivBmpToGraph_WCHAR_T( UseFileNameBuffer, AllNum, XNum, YNum, TRUE, _FTOL( SizeX ), SizeX, _FTOL( SizeY ), SizeY, HandleArray, TextureFlag, ReverseFlag, _FTOL( XStride ), XStride, _FTOL( YStride ), YStride ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = LoadDivBmpToGraph_WCHAR_T( UseFileNameBuffer, AllNum, XNum, YNum, TRUE, _FTOL( SizeX ), SizeX, _FTOL( SizeY ), SizeY, HandleArray, TextureFlag, ReverseFlag, _FTOL( XStride ), XStride, _FTOL( YStride ), YStride ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#endif
	return Result ;
}

// alo̕ǂ݂
extern int LoadDivBmpToGraph_WCHAR_T( const wchar_t *FileName, int AllNum, int XNum, int YNum, int IsFloat, int SizeXI, float SizeXF, int SizeYI, float SizeYF, int *HandleArray, int TextureFlag, int ReverseFlag, int XStrideI, float XStrideF, int YStrideI, float YStrideF )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_LoadDivBmpToGraph_UseGParam( &GParam, FALSE, FileName, AllNum, XNum, YNum, IsFloat, SizeXI, SizeXF, SizeYI, SizeYF, HandleArray, TextureFlag, ReverseFlag, XStrideI, XStrideF, YStrideI, YStrideF, GetASyncLoadFlag(), FALSE ) ;
}

// alo̔]ǂ݂݁itOj
extern int NS_LoadReverseDivGraph( const TCHAR *FileName, int AllNum, int XNum, int YNum, int XSize, int YSize, int *HandleArray, int NotUse3DFlag, int XStride, int YStride )
{
	return NS_LoadDivBmpToGraph( FileName, AllNum, XNum, YNum, XSize, YSize, HandleArray, !NotUse3DFlag, TRUE, XStride, YStride ) ;
}

// 摜t@C𔽓]̂𕪊ăOtBbNnh쐬
extern int NS_LoadReverseDivGraphWithStrLen( const TCHAR *FileName, size_t FileNameLength, int AllNum, int XNum, int YNum, int XSize, int YSize, int *HandleArray, int NotUse3DFlag, int XStride, int YStride )
{
	int Result ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = NS_LoadDivBmpToGraph( UseFileNameBuffer, AllNum, XNum, YNum, XSize, YSize, HandleArray, !NotUse3DFlag, TRUE, XStride, YStride ) ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( FileName )
	return Result ;
}

// alo̔]ǂ݂݁itOj
extern int NS_LoadReverseDivGraphF( const TCHAR *FileName, int AllNum, int XNum, int YNum, float XSize, float YSize, int *HandleArray, int NotUse3DFlag, float XStride, float YStride )
{
	return NS_LoadDivBmpToGraphF( FileName, AllNum, XNum, YNum, XSize, YSize, HandleArray, !NotUse3DFlag, TRUE, XStride, YStride ) ;
}

// 摜t@C𔽓]̂𕪊ăOtBbNnh쐬
extern int NS_LoadReverseDivGraphFWithStrLen( const TCHAR *FileName, size_t FileNameLength, int AllNum, int XNum, int YNum, float XSize, float YSize, int *HandleArray, int NotUse3DFlag, float XStride, float YStride )
{
	int Result ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = NS_LoadDivBmpToGraphF( UseFileNameBuffer, AllNum, XNum, YNum, XSize, YSize, HandleArray, !NotUse3DFlag, TRUE, XStride, YStride ) ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( FileName )
	return Result ;
}

// 摜t@Cuhp摜ǂݍ
extern int NS_LoadBlendGraph( const TCHAR *FileName )
{
#ifdef UNICODE
	return LoadBlendGraph_WCHAR_T(
		FileName
	) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, return -1 )

	Result = LoadBlendGraph_WCHAR_T(
		UseFileNameBuffer
	) ;

	TCHAR_TO_WCHAR_T_STRING_END( FileName )

	return Result ;
#endif
}

// 摜t@CuhpOtBbNnh쐬
extern int NS_LoadBlendGraphWithStrLen( const TCHAR *FileName, size_t FileNameLength )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = LoadBlendGraph_WCHAR_T( UseFileNameBuffer ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = LoadBlendGraph_WCHAR_T( UseFileNameBuffer ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#endif
	return Result ;
}

// 摜t@Cuhp摜ǂݍ
extern int LoadBlendGraph_WCHAR_T( const wchar_t *FileName )
{
	int Result, UseBlendGraphFlag ;

	UseBlendGraphFlag = NS_GetUseBlendGraphCreateFlag() ;
	NS_SetUseBlendGraphCreateFlag( TRUE ) ;
	
	Result = LoadGraph_WCHAR_T( FileName ) ;
	
	NS_SetUseBlendGraphCreateFlag( UseBlendGraphFlag ) ;
	
	return Result ;
}

// ̃OtBbNC[WOtBbNnh쐬
extern int NS_CreateGraphFromMem( const void *MemImage, int MemImageSize, const void *AlphaImage, int AlphaImageSize, int TextureFlag, int ReverseFlag )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_CreateGraphFromMem_UseGParam( &GParam, FALSE, -1, MemImage, MemImageSize, AlphaImage, AlphaImageSize, TextureFlag, ReverseFlag, GetASyncLoadFlag() ) ;
}

// ̃OtBbNC[W̃OtBbNnhɃf[^]
extern int NS_ReCreateGraphFromMem( const void *MemImage, int MemImageSize, int GrHandle, const void *AlphaImage, int AlphaImageSize, int TextureFlag, int ReverseFlag )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_CreateGraphFromMem_UseGParam( &GParam, TRUE, GrHandle, MemImage, MemImageSize, AlphaImage, AlphaImageSize, TextureFlag, ReverseFlag, GetASyncLoadFlag() ) ;
}

// ̃OtBbNC[W番OtBbNnh쐬
extern int NS_CreateDivGraphFromMem( const void *MemImage, int MemImageSize, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleArray,int TextureFlag, int ReverseFlag, const void *AlphaImage, int AlphaImageSize )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_CreateDivGraphFromMem_UseGParam( &GParam, FALSE, MemImage, MemImageSize, AllNum, XNum, YNum, FALSE, SizeX, ( float )SizeX, SizeY, ( float )SizeY, HandleArray, TextureFlag, ReverseFlag, AlphaImage, AlphaImageSize, GetASyncLoadFlag(), FALSE ) ;
}

// ̃OtBbNC[W番OtBbNnh쐬
extern int NS_CreateDivGraphFFromMem( const void *MemImage, int MemImageSize, int AllNum, int XNum, int YNum, float SizeX, float SizeY, int *HandleArray,int TextureFlag, int ReverseFlag, const void *AlphaImage, int AlphaImageSize )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_CreateDivGraphFromMem_UseGParam( &GParam, FALSE, MemImage, MemImageSize, AllNum, XNum, YNum, TRUE, _FTOL( SizeX ), SizeX, _FTOL( SizeY ), SizeY, HandleArray, TextureFlag, ReverseFlag, AlphaImage, AlphaImageSize, GetASyncLoadFlag(), FALSE ) ;
}

// ̃OtBbNC[W̕OtBbNnhɃf[^]
extern int NS_ReCreateDivGraphFromMem( const void *MemImage, int MemImageSize, int AllNum, int XNum, int YNum, int SizeX, int SizeY, const int *HandleArray,int TextureFlag, int ReverseFlag, const void *AlphaImage, int AlphaImageSize )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_CreateDivGraphFromMem_UseGParam( &GParam, TRUE, MemImage, MemImageSize, AllNum, XNum, YNum, FALSE, SizeX, ( float )SizeX, SizeY, ( float )SizeY, ( int * )HandleArray, TextureFlag, ReverseFlag, AlphaImage, AlphaImageSize, GetASyncLoadFlag(), FALSE ) ;
}

// ̃OtBbNC[W̕OtBbNnhɃf[^]
extern int NS_ReCreateDivGraphFFromMem( const void *MemImage, int MemImageSize, int AllNum, int XNum, int YNum, float SizeX, float SizeY, const int *HandleArray,int TextureFlag, int ReverseFlag, const void *AlphaImage, int AlphaImageSize )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_CreateDivGraphFromMem_UseGParam( &GParam, TRUE, MemImage, MemImageSize, AllNum, XNum, YNum, TRUE, _FTOL( SizeX ), SizeX, _FTOL( SizeY ), SizeY, ( int * )HandleArray, TextureFlag, ReverseFlag, AlphaImage, AlphaImageSize, GetASyncLoadFlag(), FALSE ) ;
}

// rbg}bvf[^OtBbNnh쐬
extern int NS_CreateGraphFromBmp( const BITMAPINFO *BmpInfo, const void *GraphData, const BITMAPINFO *AlphaInfo, const void *AlphaData, int TextureFlag, int ReverseFlag )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_CreateGraphFromBmp_UseGParam( &GParam, FALSE, -1, BmpInfo, GraphData, AlphaInfo, AlphaData, TextureFlag, ReverseFlag, GetASyncLoadFlag() ) ;
}

// rbg}bvf[^̃OtBbNnhɃf[^]
extern int NS_ReCreateGraphFromBmp( const BITMAPINFO *BmpInfo, const void *GraphData, int GrHandle, const BITMAPINFO *AlphaInfo, const void *AlphaData, int TextureFlag, int ReverseFlag )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_CreateGraphFromBmp_UseGParam( &GParam, TRUE, GrHandle, BmpInfo, GraphData, AlphaInfo, AlphaData, TextureFlag, ReverseFlag, GetASyncLoadFlag() ) ;
}

// rbg}bvf[^番OtBbNnh쐬
extern int NS_CreateDivGraphFromBmp( const BITMAPINFO *BmpInfo, const void *GraphData, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleArray, int TextureFlag, int ReverseFlag, const BITMAPINFO *AlphaInfo, const void *AlphaData )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_CreateDivGraphFromBmp_UseGParam( &GParam, FALSE, BmpInfo, GraphData, AllNum, XNum, YNum, FALSE, SizeX, ( float )SizeX, SizeY, ( float )SizeY, HandleArray, TextureFlag, ReverseFlag, AlphaInfo, AlphaData, GetASyncLoadFlag() ) ;
}

// rbg}bvf[^番OtBbNnh쐬
extern int NS_CreateDivGraphFFromBmp( const BITMAPINFO *BmpInfo, const void *GraphData, int AllNum, int XNum, int YNum, float SizeX, float SizeY, int *HandleArray, int TextureFlag, int ReverseFlag, const BITMAPINFO *AlphaInfo, const void *AlphaData )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_CreateDivGraphFromBmp_UseGParam( &GParam, FALSE, BmpInfo, GraphData, AllNum, XNum, YNum, TRUE, _FTOL( SizeX ), SizeX, _FTOL( SizeY ), SizeY, HandleArray, TextureFlag, ReverseFlag, AlphaInfo, AlphaData, GetASyncLoadFlag() ) ;
}

// rbg}bvf[^̕OtBbNnhɃf[^]
extern int NS_ReCreateDivGraphFromBmp( const BITMAPINFO *BmpInfo, const void *GraphData, int AllNum, int XNum, int YNum, int SizeX, int SizeY, const int *HandleArray,int TextureFlag, int ReverseFlag, const BITMAPINFO *AlphaInfo, const void *AlphaData )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_CreateDivGraphFromBmp_UseGParam( &GParam, TRUE, BmpInfo, GraphData, AllNum, XNum, YNum, FALSE, SizeX, ( float )SizeX, SizeY, ( float )SizeY, ( int * )HandleArray, TextureFlag, ReverseFlag, AlphaInfo, AlphaData, GetASyncLoadFlag() ) ;
}

// rbg}bvf[^̕OtBbNnhɃf[^]
extern int NS_ReCreateDivGraphFFromBmp( const BITMAPINFO *BmpInfo, const void *GraphData, int AllNum, int XNum, int YNum, float SizeX, float SizeY, const int *HandleArray,int TextureFlag, int ReverseFlag, const BITMAPINFO *AlphaInfo, const void *AlphaData )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_CreateDivGraphFromBmp_UseGParam( &GParam, TRUE, BmpInfo, GraphData, AllNum, XNum, YNum, TRUE, _FTOL( SizeX ), SizeX, _FTOL( SizeY ), SizeY, ( int * )HandleArray, TextureFlag, ReverseFlag, AlphaInfo, AlphaData, GetASyncLoadFlag() ) ;
}

// GraphImage f[^TCYoAɍOtBbNnh쐬
extern int NS_CreateDXGraph( const BASEIMAGE *RgbBaseImage, const BASEIMAGE *AlphaBaseImage, int TextureFlag )
{
	SETUP_GRAPHHANDLE_GPARAM GParam ;
	int NewGraphHandle ;
	int Result ;

	CheckActiveState() ;

	// nh̍쐬
	NewGraphHandle = Graphics_Image_AddHandle( FALSE ) ;
	if( NewGraphHandle == -1 )
	{
		return -1 ;
	}

	Graphics_Image_InitSetupGraphHandleGParam( &GParam ) ;

	Result = Graphics_Image_CreateDXGraph_UseGParam( &GParam, NewGraphHandle, RgbBaseImage, AlphaBaseImage, TextureFlag ) ;
	if( Result < 0 )
	{
		NS_DeleteGraph( NewGraphHandle, FALSE ) ;
		return -1 ;
	}

	return NewGraphHandle ;
}

// GraphImagef[^OtBbNnh쐬
extern int NS_CreateGraphFromGraphImage( const BASEIMAGE *BaseImage, int TextureFlag, int ReverseFlag )
{
	return NS_CreateGraphFromGraphImage2( BaseImage, NULL, TextureFlag, ReverseFlag ) ;
}

// GraphImagef[^̃OtBbNnhɃf[^]
extern int NS_ReCreateGraphFromGraphImage( const BASEIMAGE *BaseImage, int GrHandle, int TextureFlag, int ReverseFlag )
{
	return NS_ReCreateGraphFromGraphImage2( BaseImage, NULL, GrHandle, TextureFlag, ReverseFlag ) ;
}

// GraphImagef[^番OtBbNnh쐬
extern int NS_CreateDivGraphFromGraphImage( BASEIMAGE *BaseImage, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleArray,int TextureFlag, int ReverseFlag )
{
	return NS_CreateDivGraphFromGraphImage2( BaseImage, NULL, AllNum, XNum, YNum, SizeX, SizeY, HandleArray, TextureFlag, ReverseFlag ) ;
}

// GraphImagef[^番OtBbNnh쐬
extern int NS_CreateDivGraphFFromGraphImage( BASEIMAGE *BaseImage, int AllNum, int XNum, int YNum, float SizeX, float SizeY, int *HandleArray,int TextureFlag, int ReverseFlag )
{
	return NS_CreateDivGraphFFromGraphImage2( BaseImage, NULL, AllNum, XNum, YNum, SizeX, SizeY, HandleArray, TextureFlag, ReverseFlag ) ;
}

// GraphImagef[^̕OtBbNnhɃf[^]
extern int NS_ReCreateDivGraphFromGraphImage( BASEIMAGE *BaseImage, int AllNum, int XNum, int YNum, int SizeX, int SizeY, const int *HandleArray,int TextureFlag, int ReverseFlag )
{
	return NS_ReCreateDivGraphFromGraphImage2( BaseImage, NULL, AllNum, XNum, YNum, SizeX, SizeY, HandleArray, TextureFlag, ReverseFlag ) ;
}

// GraphImagef[^̕OtBbNnhɃf[^]
extern int NS_ReCreateDivGraphFFromGraphImage( BASEIMAGE *BaseImage, int AllNum, int XNum, int YNum, float SizeX, float SizeY, const int *HandleArray,int TextureFlag, int ReverseFlag )
{
	return NS_ReCreateDivGraphFFromGraphImage2( BaseImage, NULL, AllNum, XNum, YNum, SizeX, SizeY, HandleArray, TextureFlag, ReverseFlag ) ;
}

#ifndef DX_COMPILE_TYPE_C_LANGUAGE
// GraphImagef[^OtBbNnh쐬
extern int NS_CreateGraphFromGraphImage( const BASEIMAGE *BaseImage, const BASEIMAGE *AlphaBaseImage, int TextureFlag, int ReverseFlag )
{
	return NS_CreateGraphFromGraphImage2( BaseImage, AlphaBaseImage, TextureFlag, ReverseFlag ) ;
}

// GraphImagef[^̃OtBbNnhɃf[^]
extern int NS_ReCreateGraphFromGraphImage( const BASEIMAGE *BaseImage, const BASEIMAGE *AlphaBaseImage, int GrHandle, int TextureFlag, int ReverseFlag )
{
	return NS_ReCreateGraphFromGraphImage2( BaseImage, AlphaBaseImage, GrHandle, TextureFlag, ReverseFlag ) ;
}

// GraphImagef[^番OtBbNnh쐬
extern int NS_CreateDivGraphFromGraphImage( BASEIMAGE *BaseImage, const BASEIMAGE *AlphaBaseImage, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleArray,int TextureFlag, int ReverseFlag )
{
	return NS_CreateDivGraphFromGraphImage2( BaseImage, AlphaBaseImage, AllNum, XNum, YNum, SizeX, SizeY, HandleArray, TextureFlag, ReverseFlag ) ;
}

// GraphImagef[^番OtBbNnh쐬
extern int NS_CreateDivGraphFFromGraphImage( BASEIMAGE *BaseImage, const BASEIMAGE *AlphaBaseImage, int AllNum, int XNum, int YNum, float SizeX, float SizeY, int *HandleArray,int TextureFlag, int ReverseFlag )
{
	return NS_CreateDivGraphFFromGraphImage2( BaseImage, AlphaBaseImage, AllNum, XNum, YNum, SizeX, SizeY, HandleArray, TextureFlag, ReverseFlag ) ;
}

// GraphImagef[^̕OtBbNnhɃf[^]
extern int NS_ReCreateDivGraphFromGraphImage( BASEIMAGE *BaseImage, const BASEIMAGE *AlphaBaseImage, int AllNum, int XNum, int YNum, int SizeX, int SizeY, const int *HandleArray,int TextureFlag, int ReverseFlag )
{
	return NS_ReCreateDivGraphFromGraphImage2( BaseImage, AlphaBaseImage, AllNum, XNum, YNum, SizeX, SizeY, HandleArray, TextureFlag, ReverseFlag ) ;
}

// GraphImagef[^̕OtBbNnhɃf[^]
extern int NS_ReCreateDivGraphFFromGraphImage( BASEIMAGE *BaseImage, const BASEIMAGE *AlphaBaseImage, int AllNum, int XNum, int YNum, float SizeX, float SizeY, const int *HandleArray,int TextureFlag, int ReverseFlag )
{
	return NS_ReCreateDivGraphFFromGraphImage2( BaseImage, AlphaBaseImage, AllNum, XNum, YNum, SizeX, SizeY, HandleArray, TextureFlag, ReverseFlag ) ;
}
#endif // DX_COMPILE_TYPE_C_LANGUAGE

// GraphImagef[^OtBbNnh쐬
extern int NS_CreateGraphFromGraphImage2( const BASEIMAGE *BaseImage, const BASEIMAGE *AlphaBaseImage, int TextureFlag, int ReverseFlag )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_CreateGraphFromGraphImage_UseGParam( &GParam, FALSE, -1, BaseImage, AlphaBaseImage, TextureFlag, ReverseFlag, GetASyncLoadFlag() ) ; 
}

// GraphImagef[^̃OtBbNnhɃf[^]
extern int NS_ReCreateGraphFromGraphImage2( const BASEIMAGE *BaseImage, const BASEIMAGE *AlphaBaseImage, int GrHandle, int TextureFlag, int ReverseFlag )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_CreateGraphFromGraphImage_UseGParam( &GParam, TRUE, GrHandle, BaseImage, AlphaBaseImage, TextureFlag, ReverseFlag, GetASyncLoadFlag() ) ;
}

// GraphImagef[^番OtBbNnh쐬
extern int NS_CreateDivGraphFromGraphImage2( BASEIMAGE *BaseImage, const BASEIMAGE *AlphaBaseImage, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleArray,int TextureFlag, int ReverseFlag )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_CreateDivGraphFromGraphImage_UseGParam( &GParam, FALSE, BaseImage, AlphaBaseImage, AllNum, XNum, YNum, FALSE, SizeX, ( float )SizeX, SizeY, ( float )SizeY, HandleArray, TextureFlag, ReverseFlag, GetASyncLoadFlag() ) ;
}

// GraphImagef[^番OtBbNnh쐬
extern int NS_CreateDivGraphFFromGraphImage2( BASEIMAGE *BaseImage, const BASEIMAGE *AlphaBaseImage, int AllNum, int XNum, int YNum, float SizeX, float SizeY, int *HandleArray,int TextureFlag, int ReverseFlag )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_CreateDivGraphFromGraphImage_UseGParam( &GParam, FALSE, BaseImage, AlphaBaseImage, AllNum, XNum, YNum, TRUE, _FTOL( SizeX ), SizeX, _FTOL( SizeY ), SizeY, HandleArray, TextureFlag, ReverseFlag, GetASyncLoadFlag() ) ;
}

// GraphImagef[^̕OtBbNnhɃf[^]
extern int NS_ReCreateDivGraphFromGraphImage2( BASEIMAGE *BaseImage, const BASEIMAGE *AlphaBaseImage, int AllNum, int XNum, int YNum, int SizeX, int SizeY, const int *HandleArray,int TextureFlag, int ReverseFlag )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_CreateDivGraphFromGraphImage_UseGParam( &GParam, TRUE, BaseImage, AlphaBaseImage, AllNum, XNum, YNum, FALSE, SizeX, ( float )SizeX, SizeY, ( float )SizeY, ( int * )HandleArray, TextureFlag, ReverseFlag, GetASyncLoadFlag() ) ;
}

// GraphImagef[^̕OtBbNnhɃf[^]
extern int NS_ReCreateDivGraphFFromGraphImage2( BASEIMAGE *BaseImage, const BASEIMAGE *AlphaBaseImage, int AllNum, int XNum, int YNum, float SizeX, float SizeY, const int *HandleArray,int TextureFlag, int ReverseFlag )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_CreateDivGraphFromGraphImage_UseGParam( &GParam, TRUE, BaseImage, AlphaBaseImage, AllNum, XNum, YNum, TRUE, _FTOL( SizeX ), SizeX, _FTOL( SizeY ), SizeY, ( int * )HandleArray, TextureFlag, ReverseFlag, GetASyncLoadFlag() ) ;
}

// ̃OtBbNf[^OtBbNnh쐬
extern int NS_CreateGraph( int Width, int Height, int Pitch, const void *GraphData, const void *AlphaData, int GrHandle )
{
	BITMAPINFO	BmpInfo ;
	BYTE *DData, *AData, *SData, *DestData ;
	int i ;
	int DPitch, SPitch ;
	int NewGraph ;

	// sb`쐬
	{
		int Byte ; 
		
		Byte = Width * 3 ;

		SPitch = ( Pitch == 0 ) ? Width * 3 : Pitch ;
		DPitch = ( ( Byte + 3 ) / 4 ) * 4 ;
	}

	// sb`ȂOtBbNf[^Rs[KvȂ
	AData = NULL ;
	if( SPitch != DPitch )
	{
		// RGBf[^̍쐬
		{
			// LXg
			SData = ( BYTE * )GraphData ;

			// OtBbNf[^𕡐
			if( ( DestData = DData = ( BYTE *)DXCALLOC( ( size_t )( Height * DPitch ) ) ) == NULL ) return -1 ;
			for( i = 0 ; i < Height ; i ++, SData += SPitch, DData += DPitch )
				_MEMCPY( DData, SData, ( size_t )SPitch ) ;
			DData = DestData ;
		}

		// At@f[^̍쐬
		if( AlphaData != NULL )
		{
			// LXg
			SData = ( BYTE * )AlphaData ;

			// OtBbNf[^𕡐
			if( ( DestData = AData = ( BYTE *)DXCALLOC( ( size_t )( Height * DPitch ) ) ) == NULL ) return -1 ;
			for( i = 0 ; i < Height ; i ++, SData += SPitch, AData += DPitch )
				_MEMCPY( AData, SData, ( size_t )SPitch ) ;
			AData = DestData ;
		}
	}
	else
	{
		DData = ( BYTE * )GraphData ;
		AData = ( BYTE * )AlphaData ;
	}

	// VOtBbN쐬
	_MEMSET( &BmpInfo, 0, sizeof( BmpInfo ) ) ;
	BmpInfo.bmiHeader.biSize	= sizeof( BITMAPINFOHEADER ) ;
	BmpInfo.bmiHeader.biWidth	= Width ;
	BmpInfo.bmiHeader.biHeight	= -Height ;
	BmpInfo.bmiHeader.biPlanes	= 1 ;
	BmpInfo.bmiHeader.biBitCount= 24 ;

	if( GrHandle != -1 )
	{
		NS_ReCreateGraphFromBmp( &BmpInfo, DData, GrHandle, AData != NULL ? &BmpInfo : NULL, AData, TRUE, FALSE ) ;
		NewGraph = 0 ;
	}
	else
	{
		NewGraph = NS_CreateGraphFromBmp( &BmpInfo, DData, AData != NULL ? &BmpInfo : NULL, AData, TRUE, FALSE ) ;
	}

	// 
	if( SPitch != DPitch )
	{
		DXFREE( DData ) ;
		DXFREE( AData ) ;
	}

	// I
	return NewGraph ;
}

// ̃OtBbNf[^番OtBbNnh쐬
extern int NS_CreateDivGraph( int Width, int Height, int Pitch, const void *GraphData, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleArray, const void *AlphaData )
{
	BITMAPINFO	BmpInfo ;
	BYTE *DData, *AData, *SData, *DestData ;
	int i, Result ;
	int DPitch, SPitch ;

	// sb`쐬
	{
		int Byte ; 
		
		Byte = Width * 3 ;

		SPitch = ( Pitch == 0 ) ? Width * 3 : Pitch ;
		DPitch = ( ( Byte + 3 ) / 4 ) * 4 ;
	}

	// sb`ȂOtBbNf[^Rs[KvȂ
	AData = NULL ;
	if( SPitch != DPitch )
	{
		// RGBf[^̍쐬
		{
			// LXg
			SData = ( BYTE * )GraphData ;

			// OtBbNf[^𕡐
			if( ( DestData = DData = ( BYTE *)DXCALLOC( ( size_t )( Height * DPitch ) ) ) == NULL ) return -1 ;
			for( i = 0 ; i < Height ; i ++, SData += SPitch, DData += DPitch )
				_MEMCPY( DData, SData, ( size_t )SPitch ) ;
			DData = DestData ;
		}

		// At@f[^̍쐬
		if( AlphaData != NULL )
		{
			// LXg
			SData = ( BYTE * )AlphaData ;

			// OtBbNf[^𕡐
			if( ( DestData = AData = ( BYTE *)DXCALLOC( ( size_t )( Height * DPitch ) ) ) == NULL ) return -1 ;
			for( i = 0 ; i < Height ; i ++, SData += SPitch, AData += DPitch )
				_MEMCPY( AData, SData, ( size_t )SPitch ) ;
			AData = DestData ;
		}
	}
	else
	{
		DData = ( BYTE * )GraphData ;
		AData = ( BYTE * )AlphaData ;
	}

	// VOtBbN쐬
	_MEMSET( &BmpInfo, 0, sizeof( BmpInfo ) ) ;
	BmpInfo.bmiHeader.biSize	= sizeof( BITMAPINFOHEADER ) ;
	BmpInfo.bmiHeader.biWidth	= Width ;
	BmpInfo.bmiHeader.biHeight	= -Height ;
	BmpInfo.bmiHeader.biPlanes	= 1 ;
	BmpInfo.bmiHeader.biBitCount= 24 ;

	Result = NS_CreateDivGraphFromBmp( &BmpInfo, DData, AllNum, XNum, YNum, SizeX, SizeY, HandleArray, TRUE, FALSE, &BmpInfo, AData ) ;

	// 
	if( SPitch != DPitch )
	{
		DXFREE( DData ) ;
		DXFREE( AData ) ;
	}

	// I
	return Result ;
}

// ̃OtBbNf[^番OtBbNnh쐬
extern int NS_CreateDivGraphF( int Width, int Height, int Pitch, const void *GraphData, int AllNum, int XNum, int YNum, float SizeX, float SizeY, int *HandleArray, const void *AlphaData )
{
	BITMAPINFO	BmpInfo ;
	BYTE *DData, *AData, *SData, *DestData ;
	int i, Result ;
	int DPitch, SPitch ;

	// sb`쐬
	{
		int Byte ; 
		
		Byte = Width * 3 ;

		SPitch = ( Pitch == 0 ) ? Width * 3 : Pitch ;
		DPitch = ( ( Byte + 3 ) / 4 ) * 4 ;
	}

	// sb`ȂOtBbNf[^Rs[KvȂ
	AData = NULL ;
	if( SPitch != DPitch )
	{
		// RGBf[^̍쐬
		{
			// LXg
			SData = ( BYTE * )GraphData ;

			// OtBbNf[^𕡐
			if( ( DestData = DData = ( BYTE *)DXCALLOC( ( size_t )( Height * DPitch ) ) ) == NULL ) return -1 ;
			for( i = 0 ; i < Height ; i ++, SData += SPitch, DData += DPitch )
				_MEMCPY( DData, SData, ( size_t )SPitch ) ;
			DData = DestData ;
		}

		// At@f[^̍쐬
		if( AlphaData != NULL )
		{
			// LXg
			SData = ( BYTE * )AlphaData ;

			// OtBbNf[^𕡐
			if( ( DestData = AData = ( BYTE *)DXCALLOC( ( size_t )( Height * DPitch ) ) ) == NULL ) return -1 ;
			for( i = 0 ; i < Height ; i ++, SData += SPitch, AData += DPitch )
				_MEMCPY( AData, SData, ( size_t )SPitch ) ;
			AData = DestData ;
		}
	}
	else
	{
		DData = ( BYTE * )GraphData ;
		AData = ( BYTE * )AlphaData ;
	}

	// VOtBbN쐬
	_MEMSET( &BmpInfo, 0, sizeof( BmpInfo ) ) ;
	BmpInfo.bmiHeader.biSize	= sizeof( BITMAPINFOHEADER ) ;
	BmpInfo.bmiHeader.biWidth	= Width ;
	BmpInfo.bmiHeader.biHeight	= -Height ;
	BmpInfo.bmiHeader.biPlanes	= 1 ;
	BmpInfo.bmiHeader.biBitCount= 24 ;

	Result = NS_CreateDivGraphFFromBmp( &BmpInfo, DData, AllNum, XNum, YNum, SizeX, SizeY, HandleArray, TRUE, FALSE, &BmpInfo, AData ) ;

	// 
	if( SPitch != DPitch )
	{
		DXFREE( DData ) ;
		DXFREE( AData ) ;
	}

	// I
	return Result ;
}

// ̃OtBbNf[^OtBbNnhč쐬
extern int NS_ReCreateGraph( int Width, int Height, int Pitch, const void *GraphData, int GrHandle, const void *AlphaData )
{
	return NS_CreateGraph( Width, Height, Pitch, GraphData, AlphaData, GrHandle ) ;
}

#ifndef DX_NON_SOFTIMAGE

// \tgEGAňC[Wuhp摜OtBbNnh쐬
extern	int		NS_CreateBlendGraphFromSoftImage( int SIHandle )
{
	SOFTIMAGE *SoftImg ;
	LOADGRAPH_GPARAM GParam ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;
	GParam.CreateGraphGParam.InitHandleGParam.BlendImageCreateFlag = TRUE ;

	return Graphics_Image_CreateGraphFromGraphImage_UseGParam( &GParam, FALSE, -1, &SoftImg->BaseImage, NULL, TRUE, FALSE, GetASyncLoadFlag() ) ;
}

// \tgEGAňC[WOtBbNnh쐬
extern	int		NS_CreateGraphFromSoftImage( int SIHandle )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_CreateGraphFromBaseImage( &SoftImg->BaseImage ) ;
}

// \tgEGAňC[W̎ẅ̗găOtBbNnh쐬( -1:G[  -1ȊO:OtBbNnh )
extern	int		NS_CreateGraphFromRectSoftImage( int SIHandle, int x, int y, int SizeX, int SizeY )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_CreateGraphFromRectBaseImage( &SoftImg->BaseImage, x, y, SizeX, SizeY ) ;
}

// \tgEGAňC[W̃OtBbNnhɉ摜f[^]
extern	int		NS_ReCreateGraphFromSoftImage( int SIHandle, int GrHandle )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_ReCreateGraphFromBaseImage( &SoftImg->BaseImage, GrHandle ) ;
}

// \tgEGAňC[W̃OtBbNnhɉ摜f[^]
extern	int		NS_ReCreateGraphFromRectSoftImage( int SIHandle, int x, int y, int SizeX, int SizeY, int GrHandle )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_ReCreateGraphFromRectBaseImage( &SoftImg->BaseImage, x, y, SizeX, SizeY, GrHandle ) ;
}

// \tgEGAňC[W番OtBbNnh쐬
extern	int		NS_CreateDivGraphFromSoftImage( int SIHandle, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleArray )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_CreateDivGraphFromBaseImage( &SoftImg->BaseImage, AllNum, XNum, YNum, SizeX, SizeY, HandleArray ) ;
}

// \tgEGAňC[W番OtBbNnh쐬
extern	int		NS_CreateDivGraphFFromSoftImage( int SIHandle, int AllNum, int XNum, int YNum, float SizeX, float SizeY, int *HandleArray )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_CreateDivGraphFFromBaseImage( &SoftImg->BaseImage, AllNum, XNum, YNum, SizeX, SizeY, HandleArray ) ;
}

// \tgEGAňC[W̕OtBbNnhɃf[^]
extern	int		NS_ReCreateDivGraphFromSoftImage( int SIHandle, int AllNum, int XNum, int YNum, int   SizeX, int   SizeY, const int *HandleArray )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_ReCreateDivGraphFromBaseImage( &SoftImg->BaseImage, AllNum, XNum, YNum, SizeX, SizeY, HandleArray ) ;
}

// \tgEGAňC[W̕OtBbNnhɃf[^]( float )
extern	int		NS_ReCreateDivGraphFFromSoftImage( int SIHandle, int AllNum, int XNum, int YNum, float SizeX, float SizeY, const int *HandleArray )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_ReCreateDivGraphFFromBaseImage( &SoftImg->BaseImage, AllNum, XNum, YNum, SizeX, SizeY, HandleArray ) ;
}

#endif // DX_NON_SOFTIMAGE

// {C[Wf[^OtBbNnh쐬
extern	int		NS_CreateGraphFromBaseImage( const BASEIMAGE *BaseImage )
{
	return NS_CreateGraphFromGraphImage( BaseImage, TRUE, FALSE ) ;
}

// {C[W̎ẅ̗găOtBbNnh쐬
extern	int		NS_CreateGraphFromRectBaseImage( const BASEIMAGE *BaseImage, int x, int y, int SizeX, int SizeY )
{
	BASEIMAGE DummyImage ;

	// ʒuTCYsG[
	if( SizeX <= 0 || SizeY <= 0 ||
		x < 0 || x + SizeX >  BaseImage->Width ||
		y < 0 || y + SizeY >  BaseImage->Height ) 
		return -1 ;

	// _~[̊{C[WłグăOtBbNnh쐬
	DummyImage.ColorData = BaseImage->ColorData ;
	DummyImage.Width = SizeX ;
	DummyImage.Height = SizeY ;
	DummyImage.Pitch = BaseImage->Pitch ;
	DummyImage.MipMapCount = 0 ;
	DummyImage.GraphDataCount = 0 ;
	DummyImage.GraphData = ( BYTE * )BaseImage->GraphData + x * BaseImage->ColorData.PixelByte + y * BaseImage->Pitch ;
	return NS_CreateGraphFromBaseImage( &DummyImage ) ;
}

// {C[Wf[^̃OtBbNnhɉ摜f[^]
extern	int		NS_ReCreateGraphFromBaseImage( const BASEIMAGE *BaseImage, int GrHandle )
{
	return NS_ReCreateGraphFromGraphImage( BaseImage, GrHandle, TRUE, FALSE ) ;
}

// {C[W̎ẅ̗gĊ̃OtBbNnhɉ摜f[^]
extern	int		NS_ReCreateGraphFromRectBaseImage( const BASEIMAGE *BaseImage, int x, int y, int SizeX, int SizeY, int GrHandle )
{
	BASEIMAGE DummyImage ;

	// ʒuTCYsG[
	if( SizeX <= 0 || SizeY <= 0 ||
		x < 0 || x + SizeX >  BaseImage->Width ||
		y < 0 || y + SizeY >  BaseImage->Height ) 
		return -1 ;

	// _~[̊{C[WłグăOtBbNnh쐬
	DummyImage.ColorData = BaseImage->ColorData ;
	DummyImage.Width = SizeX ;
	DummyImage.Height = SizeY ;
	DummyImage.Pitch = BaseImage->Pitch ;
	DummyImage.MipMapCount = 0 ;
	DummyImage.GraphDataCount = 0 ;
	DummyImage.GraphData = ( BYTE * )BaseImage->GraphData + x * BaseImage->ColorData.PixelByte + y * BaseImage->Pitch ;
	return NS_ReCreateGraphFromGraphImage( &DummyImage, GrHandle, TRUE, FALSE ) ;
}

// {C[Wf[^番OtBbNnh쐬
extern int NS_CreateDivGraphFromBaseImage( BASEIMAGE *BaseImage, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleArray )
{
	return NS_CreateDivGraphFromGraphImage( BaseImage,  AllNum,  XNum,  YNum,  SizeX,  SizeY, HandleArray, TRUE, FALSE ) ;
}

// {C[Wf[^番OtBbNnh쐬
extern int NS_CreateDivGraphFFromBaseImage( BASEIMAGE *BaseImage, int AllNum, int XNum, int YNum, float SizeX, float SizeY, int *HandleArray )
{
	return NS_CreateDivGraphFFromGraphImage( BaseImage,  AllNum,  XNum,  YNum,  SizeX,  SizeY, HandleArray, TRUE, FALSE ) ;
}

// {C[Wf[^̕OtBbNnhɃf[^]
extern int NS_ReCreateDivGraphFromBaseImage( BASEIMAGE *BaseImage, int AllNum, int XNum, int YNum, int   SizeX, int   SizeY, const int *HandleArray )
{
	return NS_ReCreateDivGraphFromGraphImage( BaseImage, AllNum, XNum, YNum, SizeX, SizeY, HandleArray, TRUE, FALSE ) ;
}

// {C[Wf[^̕OtBbNnhɃf[^]( float )
extern int NS_ReCreateDivGraphFFromBaseImage( BASEIMAGE *BaseImage, int AllNum, int XNum, int YNum, float SizeX, float SizeY, const int *HandleArray )
{
	return NS_ReCreateDivGraphFFromGraphImage( BaseImage, AllNum, XNum, YNum, SizeX, SizeY, HandleArray, TRUE, FALSE ) ;
}

// OtBbNf[^ւ̃OtBbN̓ǂݍ
extern int NS_ReloadGraph( const TCHAR *FileName, int GrHandle, int ReverseFlag )
{
#ifdef UNICODE
	return ReloadGraph_WCHAR_T(
		FileName, GrHandle, ReverseFlag
	) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, return -1 )

	Result = ReloadGraph_WCHAR_T(
		UseFileNameBuffer, GrHandle, ReverseFlag
	) ;

	TCHAR_TO_WCHAR_T_STRING_END( FileName )

	return Result ;
#endif
}

// 摜t@COtBbNnh։摜f[^]
extern int NS_ReloadGraphWithStrLen( const TCHAR *FileName, size_t FileNameLength, int GrHandle, int ReverseFlag )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = ReloadGraph_WCHAR_T( UseFileNameBuffer, GrHandle, ReverseFlag ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = ReloadGraph_WCHAR_T( UseFileNameBuffer, GrHandle, ReverseFlag ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#endif
	return Result ;
}

// OtBbNf[^ւ̃OtBbN̓ǂݍ
extern int ReloadGraph_WCHAR_T( const wchar_t *FileName, int GrHandle, int ReverseFlag )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_LoadBmpToGraph_UseGParam( &GParam, TRUE, GrHandle, FileName, TRUE, ReverseFlag, DX_MOVIESURFACE_NORMAL, GetASyncLoadFlag() ) ;
}

// OtBbNf[^ւ̃OtBbN̕ǂݍ
extern int NS_ReloadDivGraph( const TCHAR *FileName, int AllNum, int XNum, int YNum, int XSize, int YSize, const int *HandleArray, int ReverseFlag )
{
#ifdef UNICODE
	return ReloadDivGraph_WCHAR_T(
		FileName, AllNum, XNum, YNum, FALSE, XSize, ( float )XSize, YSize, ( float )YSize, HandleArray, ReverseFlag
	) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, return -1 )

	Result = ReloadDivGraph_WCHAR_T(
		UseFileNameBuffer, AllNum, XNum, YNum, FALSE, XSize, ( float )XSize, YSize, ( float )YSize, HandleArray, ReverseFlag
	) ;

	TCHAR_TO_WCHAR_T_STRING_END( FileName )

	return Result ;
#endif
}

// 摜t@COtBbNnh։摜f[^𕪊]
extern int NS_ReloadDivGraphWithStrLen( const TCHAR *FileName, size_t FileNameLength, int AllNum, int XNum, int YNum, int   XSize, int   YSize, const int *HandleArray, int ReverseFlag )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = ReloadDivGraph_WCHAR_T( UseFileNameBuffer, AllNum, XNum, YNum, FALSE, XSize, ( float )XSize, YSize, ( float )YSize, HandleArray, ReverseFlag ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = ReloadDivGraph_WCHAR_T( UseFileNameBuffer, AllNum, XNum, YNum, FALSE, XSize, ( float )XSize, YSize, ( float )YSize, HandleArray, ReverseFlag ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#endif
	return Result ;
}

// OtBbNf[^ւ̃OtBbN̕ǂݍ
extern int NS_ReloadDivGraphF( const TCHAR *FileName, int AllNum, int XNum, int YNum, float XSize, float YSize, const int *HandleArray, int ReverseFlag )
{
#ifdef UNICODE
	return ReloadDivGraph_WCHAR_T(
		FileName, AllNum, XNum, YNum, TRUE, _FTOL( XSize ), XSize, _FTOL( YSize ), YSize, HandleArray, ReverseFlag
	) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, return -1 )

	Result = ReloadDivGraph_WCHAR_T(
		UseFileNameBuffer, AllNum, XNum, YNum, TRUE, _FTOL( XSize ), XSize, _FTOL( YSize ), YSize, HandleArray, ReverseFlag
	) ;

	TCHAR_TO_WCHAR_T_STRING_END( FileName )

	return Result ;
#endif
}

// 摜t@COtBbNnh։摜f[^𕪊]( float )
extern int NS_ReloadDivGraphFWithStrLen( const TCHAR *FileName, size_t FileNameLength, int AllNum, int XNum, int YNum, float XSize, float YSize, const int *HandleArray, int ReverseFlag )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = ReloadDivGraph_WCHAR_T( UseFileNameBuffer, AllNum, XNum, YNum, TRUE, _FTOL( XSize ), XSize, _FTOL( YSize ), YSize, HandleArray, ReverseFlag ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = ReloadDivGraph_WCHAR_T( UseFileNameBuffer, AllNum, XNum, YNum, TRUE, _FTOL( XSize ), XSize, _FTOL( YSize ), YSize, HandleArray, ReverseFlag ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#endif
	return Result ;
}

// OtBbNf[^ւ̃OtBbN̕ǂݍ
extern int ReloadDivGraph_WCHAR_T( const wchar_t *FileName, int AllNum, int XNum, int YNum, int IsFloat, int XSizeI, float XSizeF, int YSizeI, float YSizeF, const int *HandleArray, int ReverseFlag )
{
	LOADGRAPH_GPARAM GParam ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	return Graphics_Image_LoadDivBmpToGraph_UseGParam( &GParam, TRUE, FileName, AllNum, XNum, YNum, IsFloat, XSizeI, XSizeF, YSizeI, YSizeF, ( int * )HandleArray, TRUE, ReverseFlag, GetASyncLoadFlag(), FALSE ) ;
}

// OtBbNf[^ւ̃OtBbN̔]ǂݍ
extern int NS_ReloadReverseGraph( const TCHAR *FileName, int GrHandle )
{
	return NS_ReloadGraph( FileName, GrHandle, TRUE ) ;
}

// ReloadGraph ̉摜]ǉ
extern int NS_ReloadReverseGraphWithStrLen( const TCHAR *FileName, size_t FileNameLength, int GrHandle )
{
	int Result ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = NS_ReloadGraph( UseFileNameBuffer, GrHandle, TRUE ) ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( FileName )
	return Result ;
}

// OtBbNf[^ւ̃OtBbN̔]ǂݍ
extern int ReloadReverseGraph_WCHAR_T( const wchar_t *FileName, int GrHandle )
{
	return ReloadGraph_WCHAR_T( FileName, GrHandle, TRUE ) ;
}

// OtBbNf[^ւ̃OtBbN̔]ǂݍ
extern int NS_ReloadReverseDivGraph( const TCHAR *FileName, int AllNum, int XNum, int YNum, int XSize, int YSize, const int *HandleArray )
{
	return NS_ReloadDivGraph( FileName, AllNum, XNum, YNum, XSize, YSize, HandleArray, TRUE ) ;
}

// ReloadDivGraph ̉摜]ǉ
extern int NS_ReloadReverseDivGraphWithStrLen( const TCHAR *FileName, size_t FileNameLength, int AllNum, int XNum, int YNum, int   XSize, int   YSize, const int *HandleArray )
{
	int Result ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = NS_ReloadDivGraph( UseFileNameBuffer, AllNum, XNum, YNum, XSize, YSize, HandleArray, TRUE ) ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( FileName )
	return Result ;
}

// OtBbNf[^ւ̃OtBbN̔]ǂݍ
extern int NS_ReloadReverseDivGraphF( const TCHAR *FileName, int AllNum, int XNum, int YNum, float XSize, float YSize, const int *HandleArray )
{
	return NS_ReloadDivGraphF( FileName, AllNum, XNum, YNum, XSize, YSize, HandleArray, TRUE ) ;
}

// ReloadDivGraph ̉摜]ǉ( float )
extern int NS_ReloadReverseDivGraphFWithStrLen( const TCHAR *FileName, size_t FileNameLength, int AllNum, int XNum, int YNum, float XSize, float YSize, const int *HandleArray )
{
	int Result ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = NS_ReloadDivGraphF( UseFileNameBuffer, AllNum, XNum, YNum, XSize, YSize, HandleArray, TRUE ) ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( FileName )
	return Result ;
}
























// OtBbNnh쐬ݒW֐

// SetCreateGraphColorBitDepth ̋
extern int NS_SetGraphColorBitDepth( int ColorBitDepth )
{
	return NS_SetCreateGraphColorBitDepth( ColorBitDepth ) ;
}

// GetCreateGraphColorBitDepth ̋
extern int NS_GetGraphColorBitDepth( void )
{
	return NS_GetCreateGraphColorBitDepth() ;
}

// 쐬OtBbN̐F[xݒ肷
extern int NS_SetCreateGraphColorBitDepth( int BitDepth )
{
	// lۑ
	GSYS.CreateImage.ColorBitDepth = BitDepth ;
	
	// I
	return 0 ;
}

// 쐬OtBbN̐F[x擾
extern int NS_GetCreateGraphColorBitDepth( void )
{
	return GSYS.CreateImage.ColorBitDepth ;
}

// 쐬OtBbN̂P`lӂ̃rbg[xݒ肷
extern int NS_SetCreateGraphChannelBitDepth( int BitDepth )
{
	// lۑ
	GSYS.CreateImage.ChannelBitDepth = BitDepth ;
	
	// I
	return 0 ;
}

// 쐬OtBbN̂P`lӂ̃rbg[x擾
extern int NS_GetCreateGraphChannelBitDepth( void )
{
	return GSYS.CreateImage.ChannelBitDepth ;
}

// 쐬OtBbNnh InitGraph() ō폜邩ݒ肷( Flag  TRUE:InitGraphō폜(ftHg)  FALSE:InitGraphō폜Ȃ )
extern int NS_SetCreateGraphInitGraphDelete( int Flag )
{
	// lۑ
	GSYS.CreateImage.NotInitGraphDeleteUserFlag = Flag != FALSE ? FALSE : TRUE ;
	
	// I
	return 0 ;
}

// 쐬OtBbNnh InitGraph() ō폜邩擾( Flag  TRUE:InitGraphō폜(ftHg)  FALSE:InitGraphō폜Ȃ )
extern int NS_GetCreateGraphInitGraphDelete( void )
{
	return GSYS.CreateImage.NotInitGraphDeleteUserFlag != FALSE ? FALSE : TRUE ;
}

// `\ȃOtBbN쐬邩ǂ̃tOZbg( TRUE:쐬  FALSE:쐬Ȃ )
extern int NS_SetDrawValidGraphCreateFlag( int Flag )
{
	// tOۑ
	GSYS.CreateImage.DrawValidFlag = Flag ;
	
	// I
	return 0 ;
}

// `\ȃOtBbN쐬邩ǂ̃tO擾
extern int NS_GetDrawValidGraphCreateFlag( void )
{
	return GSYS.CreateImage.DrawValidFlag ;
}

// SetDrawValidGraphCreateFlag ̋
extern int NS_SetDrawValidFlagOf3DGraph( int Flag )
{
	return NS_SetDrawValidGraphCreateFlag( Flag ) ;
}

// 摜̐F𓧉ߐFɂ邩ǂ̃tOZbg
extern int NS_SetLeftUpColorIsTransColorFlag( int Flag )
{
	// tOZbg
	GSYS.CreateImage.LeftUpColorIsTransColorFlag = Flag ;

	// I
	return 0 ;
}

// ǂݍމ摜pbg摜̏ꍇApbg摜ƂĎgpłꍇ̓pbg摜ƂĎgp邩ǂݒ肷( TRUE:pbg摜ƂĎgpłꍇ̓pbg摜ƂĎgp( ftHg )  FALSE:pbg摜ƂĎgpłꍇpbg摜ƂĂ͎gpȂ( ʏ^Cv̉摜ɕϊĎgp ) )
extern int NS_SetUsePaletteGraphFlag( int Flag )
{
	// tOZbg
	GSYS.CreateImage.NotUsePaletteGraphFlag = Flag ? FALSE : TRUE ;

	// I
	return 0 ;
}

// uhp摜쐬邩ǂ̃tOZbg
extern int NS_SetUseBlendGraphCreateFlag( int Flag )
{
	// tOۑ
	GSYS.CreateImage.BlendImageFlag = Flag ;
	
	// I
	return 0 ;
}

// uhp摜쐬邩ǂ̃tO擾
extern int NS_GetUseBlendGraphCreateFlag( void )
{
	return GSYS.CreateImage.BlendImageFlag ;
}

// At@eXggpOtBbN쐬邩ǂ̃tOZbg
extern int NS_SetUseAlphaTestGraphCreateFlag( int Flag )
{
	// tOZbg
	GSYS.CreateImage.AlphaTestFlag = Flag ;
	BASEIM.AlphaTestImageCreateFlag = Flag ;
	
	// I
	return 0 ;
}

// At@eXggpOtBbN쐬邩ǂ̃tO擾
extern int NS_GetUseAlphaTestGraphCreateFlag( void )
{
	return GSYS.CreateImage.AlphaTestFlag ;
}

// SetUseAlphaTestGraphCreateFlag ̋
extern int NS_SetUseAlphaTestFlag( int Flag )
{
	return NS_SetUseAlphaTestGraphCreateFlag( Flag ) ;
}

// GetUseAlphaTestGraphCreateFlag ̋
extern int NS_GetUseAlphaTestFlag( void )
{
	return NS_GetUseAlphaTestGraphCreateFlag() ;
}

// L[u}bveNX`쐬邩ǂ̃tOݒ肷
extern int NS_SetCubeMapTextureCreateFlag( int Flag )
{
	GSYS.CreateImage.CubeMapFlag = Flag == FALSE ? FALSE : TRUE ;

	// I
	return 0 ;
}

// L[u}bveNX`쐬邩ǂ̃tO擾
extern int NS_GetCubeMapTextureCreateFlag( void )
{
	return 	GSYS.CreateImage.CubeMapFlag ;
}

// SetDrawBlendMode ֐̑ DX_BLENDMODE_NOBLEND ۂɁAftHgł͓͑łQTTw肵ƂɂȂ邪A̎QTTȂǂݒ肷( TRUE:Ȃ(̒lgp)   FALSE:(̒l͖ 255 Ɏgp)(ftHg) )`lt摜ɑ΂ĕ`sꍇ݈̂Ӗ֐
extern int NS_SetUseNoBlendModeParam( int Flag )
{
	GSYS.DrawSetting.UseNoBlendModeParam = Flag ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// `\ȃ`lt摜쐬邩ǂ̃tOZbg,SetDrawValidGraphCreateFlag ֐ŕ`\摜쐬悤ɐݒ肳ĂȂƌʂȂ( TRUE:`lt FALSE:`lȂ )
extern int NS_SetDrawValidAlphaChannelGraphCreateFlag( int Flag )
{
	// tOۑ
	GSYS.CreateImage.DrawValidAlphaFlag = Flag ;
	
	// I
	return 0 ;
}

// `\ȃ`lt摜쐬邩ǂ̃tO擾
extern int NS_GetDrawValidAlphaChannelGraphCreateFlag( void )
{
	// tOԂ
	return GSYS.CreateImage.DrawValidAlphaFlag ;
}

// `\ȕ_^̉摜쐬邩ǂ̃tOZbg,SetDrawValidGraphCreateFlag ֐ŕ`\摜쐬悤ɐݒ肳ĂȂƌʂȂAfot Float^̉摜ɑΉĂȂꍇ͎s( TRUE:Float^ FALSE:Int^ )
extern int NS_SetDrawValidFloatTypeGraphCreateFlag( int Flag )
{
	// tOۑ
	GSYS.CreateImage.DrawValidFloatTypeFlag = Flag ;

	// I
	return 0 ;
}

// `\ȕ_^̉摜쐬邩ǂ̃tO擾
extern int NS_GetDrawValidFloatTypeGraphCreateFlag( void )
{
	// tOԂ
	return GSYS.CreateImage.DrawValidFloatTypeFlag ;
}

// `\摜쐬ۂɐp̂yobt@쐬邩ǂݒ肷( ftHgł TRUE( 쐬 ) )
extern int NS_SetDrawValidGraphCreateZBufferFlag( int Flag )
{
	// tOۑ
	GSYS.CreateImage.NotDrawValidCreateZBufferFlag = Flag ? FALSE : TRUE ;

	// I
	return 0 ;
}

// `\摜쐬ۂɐp̂yobt@쐬邩ǂ擾
extern int NS_GetDrawValidGraphCreateZBufferFlag( void )
{
	// tOԂ
	return GSYS.CreateImage.NotDrawValidCreateZBufferFlag ? FALSE : TRUE ;
}

// SetDrawScreen ̈Ƃēn( `ΏۂƂĎgpł )OtBbNnhɓKpyobt@̃rbg[xݒ肷( BitDepth:rbg[x( w\Ȓl 16, 24, 32 ̉ꂩ( SetDrawValidGraphCreateFlag ֐ŕ`ΏۂƂĎgpłOtBbNnh쐬悤ɐݒ肳ĂȂƌʂ܂ )
extern int NS_SetCreateDrawValidGraphZBufferBitDepth( int BitDepth )
{
	// rbg[xۑ
	GSYS.CreateImage.DrawValidZBufferBitDepth = BitDepth ;

	// I
	return 0 ;
}

// SetDrawScreen ̈Ƃēn( `ΏۂƂĎgpł )OtBbNnhɓKpyobt@̃rbg[x擾
extern int NS_GetCreateDrawValidGraphZBufferBitDepth( void )
{
	// rbg[xԂ
	return GSYS.CreateImage.DrawValidZBufferBitDepth == 0 ? 16 : GSYS.CreateImage.DrawValidZBufferBitDepth ;
}

// SetDrawScreen ̈Ƃēn( `ΏۂƂĎgpł )OtBbNnhɓKpMipMap̃xݒ肷
extern int NS_SetCreateDrawValidGraphMipLevels( int MipLevels )
{
	// `lۑ
	GSYS.CreateImage.DrawValidMipLevels = MipLevels ;

	// I
	return 0 ;
}

// SetDrawScreen ̈Ƃēn( `ΏۂƂĎgpł )OtBbNnhɓKpMipMap̃x擾
extern int NS_GetCreateDrawValidGraphMipLevels( void )
{
	// `lԂ
	return GSYS.CreateImage.DrawValidMipLevels ;
}

// 쐬`\ȉ摜̃`lݒ肷,SetDrawValidGraphCreateFlag ֐ŕ`\摜쐬悤ɐݒ肳ĂȂƌʂȂ
extern int NS_SetCreateDrawValidGraphChannelNum( int ChannelNum )
{
	// `lۑ
	GSYS.CreateImage.DrawValidChannelNum = ChannelNum ;

	// I
	return 0 ;
}

// 쐬`\ȉ摜̃`l擾
extern int NS_GetCreateDrawValidGraphChannelNum( void )
{
	// `lԂ
	return GSYS.CreateImage.DrawValidChannelNum ;
}

// SetDrawScreen ̈Ƃēn( `ΏۂƂĎgpł )OtBbNnhɓKp}`TvO( A`GCAVO )ݒs( Samples:}`TvɎgphbg( قǏdȂ܂ )  Quality:}`Tv̕i )
extern int NS_SetCreateDrawValidGraphMultiSample( int Samples, int Quality )
{
	if( Samples > 16 )
		Samples = 16 ;

	// p[^ۑ
	GSYS.CreateImage.DrawValidMSSamples = Samples ;
	GSYS.CreateImage.DrawValidMSQuality = Quality ;

	// I
	return 0 ;
}

// `\ȉ摜̃}`TvOݒs
extern int NS_SetDrawValidMultiSample( int Samples, int Quality )
{
	return NS_SetCreateDrawValidGraphMultiSample( Samples, Quality ) ;
}

// w̃}`TvŎgpłőNIeBl擾
extern int NS_GetMultiSampleQuality( int Samples )
{
	return Graphics_Hardware_GetMultiSampleQuality_PF( Samples ) ;
}

// ߐF@\gp邩ǂݒ肷
extern int NS_SetUseTransColor( int Flag )
{
	GSYS.CreateImage.NotUseTransColor = !Flag;

	// I
	return 0;
}

// ߐF@\gp邱ƂOƂ摜̓ǂݍݏsǂݒ肷( TRUE ɂ SetDrawMode( DX_DRAWMODE_BILINEAR ); Ԃ DrawGraphF ̕_^W󂯎֐ŏ_ȉ̒lw肵ꍇɔ`挋ʂ̕sRɘaʂ ( ftHg FALSE ) )
extern int NS_SetUseTransColorGraphCreateFlag( int Flag )
{
	GSYS.CreateImage.UseTransColorFlag = Flag;

	return 0;
}

// SetUseAlphaChannelGraphCreateFlag ̋
extern int NS_SetUseGraphAlphaChannel( int Flag )
{
	return NS_SetUseAlphaChannelGraphCreateFlag( Flag ) ;
}

// GetUseAlphaChannelGraphCreateFlag ̋
extern int NS_GetUseGraphAlphaChannel( void )
{
	return NS_GetUseAlphaChannelGraphCreateFlag() ;
}

// `ltOtBbN쐬邩ǂ̃tOZbg( TRUE:`lt   FALSE:`l )
extern int NS_SetUseAlphaChannelGraphCreateFlag( int Flag )
{
	// tOۑ
	GSYS.CreateImage.AlphaChannelFlag = Flag ;
	
	// I
	return 0 ;
}

// `ltOtBbN쐬邩ǂ̃tO擾( TRUE:`lt   FALSE:`l )
extern int NS_GetUseAlphaChannelGraphCreateFlag( void )
{
	return GSYS.CreateImage.AlphaChannelFlag ;
}

// ǗeNX`gp邩ÃtOZbg( TRUE:gp  FALSE:gpȂ )
extern int NS_SetUseNotManageTextureFlag( int Flag )
{
	GSYS.CreateImage.NotUseManagedTextureFlag = Flag ;

	// I
	return 0 ;
}

// ǗeNX`gp邩ÃtO擾( TRUE:gp  FALSE:gpȂ )
extern int NS_GetUseNotManageTextureFlag( void )
{
	return GSYS.CreateImage.NotUseManagedTextureFlag ;
}

// 쐬OtBbNnhŎgpˑ̃eNX`tH[}bgw肷( Direct3D9Ȃ DX_TEXTUREFORMAT_DIRECT3D9_R8G8B8 ȂǁA0 nƉ )
extern int NS_SetUsePlatformTextureFormat( int PlatformTextureFormat )
{
	GSYS.CreateImage.PlatformTextureFormat = PlatformTextureFormat ;

	// ˑs
	Graphics_Hardware_SetUsePlatformTextureFormat_PF( PlatformTextureFormat ) ;

	// I
	return 0 ;
}

// 쐬OtBbNnhŎgpˑ̃eNX`tH[}bg擾
extern int NS_GetUsePlatformTextureFormat( void )
{
	return GSYS.CreateImage.PlatformTextureFormat ;
}

// OtBbNɐݒ肷铧ߐFZbg
extern int NS_SetTransColor( int Red, int Green, int Blue )
{
	if( NS_GetColorBitDepth() == 8 ) return 0 ;
	GSYS.CreateImage.TransColor = ( DWORD)( ( ( ( BYTE )Red ) << 16 ) | ( ( ( BYTE )Green ) << 8 ) | ( ( BYTE )Blue ) ) ;
	BASEIM.TransColor = GSYS.CreateImage.TransColor ;

	// I
	return 0 ;
}

// ߐF𓾂
extern int NS_GetTransColor( int *Red, int *Green, int *Blue )
{
	DWORD TransColor ;

	if( NS_GetColorBitDepth() == 8 ) return -1 ;

	TransColor = GSYS.CreateImage.TransColor ;

	*Red   = ( int )( ( TransColor >> 16 ) & 0xff ) ;
	*Green = ( int )( ( TransColor >> 8  ) & 0xff ) ;
	*Blue  = ( int )(   TransColor         & 0xff ) ;
 
	// I
	return 0 ;
}

// KvȂOtBbN̕sAtÕZbg
extern	int		NS_SetUseDivGraphFlag( int Flag ) 
{
	GSYS.CreateImage.NotUseDivFlag = !Flag ;

	// I
	return 0 ;
}

// LoadGraph Ȃǂ̍ۂɃt@C̖ _a tAt@`lp̉摜t@Cǉœǂݍޏsǂݒ肷( TRUE:s( ftHg )  FALSE:sȂ )
extern	int		NS_SetUseAlphaImageLoadFlag( int Flag )
{
	GSYS.CreateImage.NotUseAlphaImageLoadFlag = Flag ? FALSE : TRUE ;

	// I
	return 0 ;
}

// gpeNX`[̍őTCYZbg(0ŃftHg)
extern	int		NS_SetUseMaxTextureSize( int Size )
{
	int i ;

	if( Size == 0 )
	{
		GSYS.CreateImage.UserMaxTextureSize = 0 ;
		return 0 ;
	}
	
	// w̃TCY܂ŏ̂Q̂̃TCY߂
	for( i = MIN_TEXTURE_SIZE ; i < Size ; i <<= 1 ){}

	// őTCY傫␳
	if( Size > GSYS.HardInfo.MaxTextureSize ) Size = GSYS.HardInfo.MaxTextureSize ; 
	
	// lZbg
	GSYS.CreateImage.UserMaxTextureSize = i ;
	
	// I
	return 0 ;
}

// 摜쐬ۂɎgp摜f[^̃obNAbvăfoCXXgɎgp邩ǂ̃tOZbg( TRUE:obNAbv( ftHg )  FALSE:obNAbvȂ )
extern int NS_SetUseGraphBaseDataBackup( int Flag )
{
	GSYS.CreateImage.NotGraphBaseDataBackupFlag = Flag ? FALSE : TRUE ;

	// I
	return 0 ;
}

// 摜쐬ۂɎgp摜f[^̃obNAbvăfoCXXgɎgp邩ǂ̃tO擾
extern int NS_GetUseGraphBaseDataBackup( void )
{
	return GSYS.CreateImage.NotGraphBaseDataBackupFlag ? FALSE : TRUE ;
}

// VXeɃOtBbN쐬邩ǂ̃tOZbg( TRUE:VXeɍ쐬  FALSE:uq`lɍ쐬 )
extern	int NS_SetUseSystemMemGraphCreateFlag( int /* Flag */ )
{
	// tOۑ
//	GSYS.SystemMemImageCreateFlag = Flag ;

	// I
	return 0 ;
}

// VXeɃOtBbN쐬邩ǂ̃tO擾( TRUE:VXeɍ쐬  FALSE:uq`lɍ쐬 )
extern int NS_GetUseSystemMemGraphCreateFlag( void )
{
//	return GSYS.SystemMemImageCreateFlag ;
	return FALSE ;
}


























// 摜֌W֐

// w̉摜̂`qfaW̃tJ[C[W擾
extern const unsigned int *NS_GetFullColorImage( int GrHandle )
{
	IMAGEDATA *Image ;

//	if( GSYS.NotDrawFlag ) return 0 ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return NULL ;

	// tJ[C[Wi[郁̈܂mۂĂȂꍇ͊mۂ
	if( Image->FullColorImage == NULL )
	{
		Image->FullColorImage = ( DWORD * )DXALLOC( ( size_t )( Image->WidthI * 4 * Image->HeightI ) ) ;
		if( Image->FullColorImage == NULL )
		{
			DXST_LOGFILE_ADDUTF16LE( "\xd5\x30\xeb\x30\xab\x30\xe9\x30\xfc\x30\x6e\x30\x3b\x75\xcf\x50\xa4\x30\xe1\x30\xfc\x30\xb8\x30\xc7\x30\xfc\x30\xbf\x30\x92\x30\x3c\x68\x0d\x7d\x59\x30\x8b\x30\xe1\x30\xe2\x30\xea\x30\x18\x98\xdf\x57\x92\x30\xba\x78\xdd\x4f\xfa\x51\x65\x67\x7e\x30\x5b\x30\x93\x30\x67\x30\x57\x30\x5f\x30\x02\x30\x0a\x00\x00"/*@ L"tJ[̉摜C[Wf[^i[郁̈mۏo܂łB\n" @*/ ) ;
			return NULL;
		}
	}

#ifndef DX_NON_MOVIE

	// [r[̏ꍇ͏𕪊
	if( Image->Orig->MovieHandle >= 0 )
	{
		MOVIEGRAPH * Movie ;
		Movie = GetMovieData( Image->Orig->MovieHandle ) ;
		if( Movie == NULL ) return NULL ;
		static BASEIMAGE Dest ;

		// T[tFX[hI[o[C̏ꍇ͖
		if( Movie->SurfaceMode == DX_MOVIESURFACE_OVERLAY ) return NULL ;

		// ȊȌꍇ̓[r[璼ڃf[^擾

		// [r[̃t[XV
		if( NS_GetMovieStateToGraph( GrHandle ) == FALSE )
		{
			int Time ;

			Time = NS_TellMovieToGraph( GrHandle ) ;
			NS_PlayMovieToGraph( GrHandle, DX_PLAYTYPE_BACK, 0 ) ;
			UpdateMovie( Image->Orig->MovieHandle, TRUE ) ;
			NS_PauseMovieToGraph( GrHandle, 0 ) ;
			NS_SeekMovieToGraph( GrHandle, Time ) ;
		}
		else
		{
//			UpdateMovieToGraph( GrHandle ) ;
		}

		// ]{C[Wf[^̏
		CreateARGB8ColorData( &Dest.ColorData ) ;
		Dest.Width     = Image->WidthI ;
		Dest.Height    = Image->HeightI ;
		Dest.GraphData = Image->FullColorImage ;
		Dest.Pitch     = Image->WidthI * 4 ;

		// ]
		BltBaseImage( 0, 0, Image->WidthI, Image->HeightI, 0, 0, &Movie->NowImage, &Dest ) ;
	}
	else
#endif
	{
	}

	// C[W̃|C^Ԃ
	return (unsigned int *)Image->FullColorImage ;
}

// OtBbN̈̃bN
extern int NS_GraphLock( int GrHandle, int *PitchBuf, void **DataPointBuf, COLORDATA **ColorDataPP, int WriteOnly )
{
	// 摜ǂŏ𕪊
	if( ( DWORD )GrHandle == DX_SCREEN_BACK || ( DWORD )GrHandle == DX_SCREEN_FRONT )
	{
		// n[hEGAgpĂ邩ǂŏ𕪊
		if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		{
			// n[hEGAł̃bN͑ΉĂȂ
			return -1 ;
		}
		else
		{
			// \tgEGȀꍇ͉ʃC[W̏Ԃ
			if( ColorDataPP  ) *ColorDataPP  =        GSYS.SoftRender.MainBufferMemImg.Base->ColorDataP ;
			if( PitchBuf     ) *PitchBuf     = ( int )GSYS.SoftRender.MainBufferMemImg.Base->Pitch ;
			if( DataPointBuf ) *DataPointBuf =        GSYS.SoftRender.MainBufferMemImg.UseImage ;
		}
	}
	else
	{
		IMAGEDATA *Image ;

		// G[
		if( GRAPHCHK( GrHandle, Image ) )
			return -1 ;

		// ɃbNĂG[
		if( Image->LockFlag == TRUE ) return -1 ;

		// bNtO𗧂Ă
		Image->LockFlag = TRUE ;

		// eNX`ǂŏ𕪊
		if( Image->Orig->FormatDesc.TextureFlag )
		{
			COLORDATA *ColorData ;

			// eNX`̏ꍇ
			if( Graphics_Hardware_GraphLock_PF( Image, &ColorData, WriteOnly ) < 0 )
			{
				return -1 ;
			}

			// ̊i[
			if( PitchBuf     ) *PitchBuf     = ( int )Image->LockImagePitch ;
			if( DataPointBuf ) *DataPointBuf = ( void * )Image->LockImage ;
			if( ColorDataPP  ) *ColorDataPP  = ColorData ;
		}
		else
		{
			// eNX`ł͂Ȃꍇ
			if( PitchBuf     ) *PitchBuf     = ( int )Image->Soft.MemImg.Base->Pitch ;
			if( DataPointBuf ) *DataPointBuf =        Image->Soft.MemImg.UseImage ;
			if( ColorDataPP  ) *ColorDataPP  =        Image->Soft.MemImg.Base->ColorDataP ;
		}
	}

	// I
	return 0 ;
}

// OtBbN̈̃bN
extern	int NS_GraphUnLock( int GrHandle )
{
	IMAGEDATA *Image ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;

	// bNĂȂG[
	if( Image->LockFlag == FALSE ) return -1 ;

	// bNtO|
	Image->LockFlag = FALSE ;

	// eNX`ǂŏ𕪊
	if( Image->Orig->FormatDesc.TextureFlag )
	{
		// eNX`̏ꍇ
		if( Graphics_Hardware_GraphUnlock_PF( Image ) < 0 )
		{
			return -1 ;
		}
	}
	else
	{
		// eNX`ł͂Ȃꍇ
	}

	// I
	return 0 ;
}

// OtBbNɂyobt@gp邩ǂݒ肷
extern	int NS_SetUseGraphZBuffer( int GrHandle, int UseFlag, int BitDepth )
{
	IMAGEDATA *Image ;
	int DepthIndex ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;

	// eNX`ł͂Ȃꍇ͉Ȃ
	if( Image->Orig->FormatDesc.TextureFlag == FALSE )
		return -1 ;

	// `\ł͂ȂꍇȂ
	if( Image->Orig->FormatDesc.DrawValidFlag == FALSE )
		return -1 ;

	// rbg[x̃Zbg
	if( Image->Orig->ZBufferFlag == TRUE && BitDepth < 0 )
	{
		DepthIndex = Image->Orig->ZBufferBitDepthIndex ;
	}
	else
	{
		switch( BitDepth )
		{
		default :
		case 16 : DepthIndex = ZBUFFER_FORMAT_16BIT ; break ;
		case 24 : DepthIndex = ZBUFFER_FORMAT_24BIT ; break ;
		case 32 : DepthIndex = ZBUFFER_FORMAT_32BIT ; break ;
		}
	}

	// yobt@gtOƃrbg[x牽Ȃ
	if( Image->Orig->ZBufferFlag == UseFlag && Image->Orig->ZBufferBitDepthIndex == DepthIndex )
		return 0 ;

	// tOۑ
	Image->Orig->ZBufferFlag = UseFlag ;

	// rbg[xCfbNXۑ
	Image->Orig->ZBufferBitDepthIndex = DepthIndex ;

	// eNX`̍蒼
	Graphics_Hardware_CreateOrigTexture_PF( Image->Orig ) ;

	// I
	return 0 ;
}

// OtBbN̂yobt@̏Ԃʂ̃OtBbN̂yobt@ɃRs[( DestGrHandle  SrcGrHandle yobt@Ă`\摜ŁAA`GCAX摜ł͂ȂƂ )
extern int NS_CopyGraphZBufferImage( int DestGrHandle, int SrcGrHandle )
{
	IMAGEDATA *SrcImage ;
	IMAGEDATA *DestImage ;

	// G[
	if( GRAPHCHK( SrcGrHandle, SrcImage ) )
		return -1 ;

	if( GRAPHCHK( DestGrHandle, DestImage ) )
		return -1 ;

	// eNX`ł͂Ȃꍇ͉Ȃ
	if( SrcImage->Orig->FormatDesc.TextureFlag == FALSE ||
		DestImage->Orig->FormatDesc.TextureFlag == FALSE )
		return -1 ;

	// ˑ
	if( Graphics_Hardware_CopyGraphZBufferImage_PF( DestImage, SrcImage ) < 0 )
	{
		return -1 ;
	}

	// I
	return 0 ;
}

// OtBbNXfoCX̃foCXXgɎw̃OtBbNnh폜邩ǂݒ肷( TRUE:foCXXgɍ폜  FALSE:foCXXgĂ폜Ȃ )
extern int NS_SetDeviceLostDeleteGraphFlag(	int GrHandle, int DeleteFlag )
{
	IMAGEDATA *Image ;

	if( GRAPHCHK_ASYNC( GrHandle, Image ) )
		return -1 ;

	Image->DeviceLostDeleteFlag = DeleteFlag ? TRUE : FALSE ;

	return 0 ;
}

// OtBbÑTCY𓾂
extern	int NS_GetGraphSize( int GrHandle, int *SizeXBuf, int *SizeYBuf )
{
	IMAGEDATA *Image ;
	SHADOWMAPDATA *ShadowMap ;

	switch( ( DWORD )GrHandle )
	{
	case DX_SCREEN_BACK	 :
	case DX_SCREEN_FRONT :
		if( SizeXBuf ) *SizeXBuf = GSYS.Screen.MainScreenSizeX ;
		if( SizeYBuf ) *SizeYBuf = GSYS.Screen.MainScreenSizeY ;
		break ;

	default :
		// G[
		if( !GRAPHCHK( GrHandle, Image ) )
		{
			if( SizeXBuf ) *SizeXBuf = Image->WidthI ;
			if( SizeYBuf ) *SizeYBuf = Image->HeightI ;
		}
		else
		if( !SHADOWMAPCHK( GrHandle, ShadowMap ) )
		{
			if( SizeXBuf ) *SizeXBuf = ShadowMap->BaseSizeX ;
			if( SizeYBuf ) *SizeYBuf = ShadowMap->BaseSizeY ;
		}
		else
		{
			return -1 ;
		}
		break ;
	}

	return 0 ;
}

// OtBbÑTCY𓾂( float^ )
extern	int NS_GetGraphSizeF( int GrHandle, float *SizeXBuf, float *SizeYBuf )
{
	IMAGEDATA *Image ;
	SHADOWMAPDATA *ShadowMap ;

	switch( ( DWORD )GrHandle )
	{
	case DX_SCREEN_BACK	 :
	case DX_SCREEN_FRONT :
		if( SizeXBuf ) *SizeXBuf = ( float )GSYS.Screen.MainScreenSizeX ;
		if( SizeYBuf ) *SizeYBuf = ( float )GSYS.Screen.MainScreenSizeY ;
		break ;

	default :
		// G[
		if( !GRAPHCHK( GrHandle, Image ) )
		{
			if( SizeXBuf ) *SizeXBuf = Image->WidthF ;
			if( SizeYBuf ) *SizeYBuf = Image->HeightF ;
		}
		else
		if( !SHADOWMAPCHK( GrHandle, ShadowMap ) )
		{
			if( SizeXBuf ) *SizeXBuf = ( float )ShadowMap->BaseSizeX ;
			if( SizeYBuf ) *SizeYBuf = ( float )ShadowMap->BaseSizeY ;
		}
		else
		{
			return -1 ;
		}
		break ;
	}

	return 0 ;
}

// OtBbNɎgpĂeNX`[̃TCY𓾂
extern int NS_GetGraphTextureSize( int GrHandle, int *SizeXBuf, int *SizeYBuf )
{
	IMAGEDATA *Image = NULL ;
	SHADOWMAPDATA *ShadowMap = NULL ;

	// G[
	if( GRAPHCHK(     GrHandle, Image    ) &&
		SHADOWMAPCHK( GrHandle, ShadowMap ) )
		return -1 ;

	// VhE}bvǂŏ𕪊
	if( ShadowMap != NULL )
	{
		if( SizeXBuf ) *SizeXBuf = ShadowMap->BaseSizeX ;
		if( SizeYBuf ) *SizeYBuf = ShadowMap->BaseSizeY ;
	}
	else
	{
		// eNX`ǂŏ𕪊
		if( Image->Orig->FormatDesc.TextureFlag )
		{
			if( SizeXBuf ) *SizeXBuf = Image->Orig->Hard.Tex[ 0 ].TexWidth ;
			if( SizeYBuf ) *SizeYBuf = Image->Orig->Hard.Tex[ 0 ].TexHeight ;
		}
		else
		{
			if( SizeXBuf ) *SizeXBuf = Image->WidthI ;
			if( SizeYBuf ) *SizeYBuf = Image->HeightI ;
		}
	}

	// I
	return 0 ;
}

// LoadDivGraph  DerivationGraph Ō摜̈ꕔgpĂꍇɁAw̃OtBbNnhgpĂ錳摜͈̔͂擾
extern int NS_GetGraphUseBaseGraphArea( int GrHandle, int *UseX, int *UseY, int *UseSizeX, int *UseSizeY )
{
	IMAGEDATA *Image = NULL ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
	{
		return -1 ;
	}

	if( UseX     ) *UseX     = Image->UseOrigXI ;
	if( UseY     ) *UseY     = Image->UseOrigYI ;
	if( UseSizeX ) *UseSizeX = Image->WidthI ;
	if( UseSizeY ) *UseSizeY = Image->HeightI ;

	// I
	return 0 ;
}

// OtBbN~bv}bvx̐擾
extern int NS_GetGraphMipmapCount( int GrHandle )
{
	IMAGEDATA *Image ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;

	// n[hEFAgpĂȂꍇ͂P
	if( Image->Orig->FormatDesc.TextureFlag == FALSE )
		return 1 ;

	// ~bv}bv̐Ԃ
	return Image->Orig->Hard.MipMapCount ;
}

// OtBbNnh摜t@Cǂݍ܂ĂꍇẢ摜̃t@CpX擾
extern int NS_GetGraphFilePath( int GrHandle, TCHAR *FilePathBuffer )
{
#ifdef UNICODE
	return GetGraphFilePath_WCHAR_T( GrHandle, FilePathBuffer ) ;
#else
	IMAGEDATA *Image ;
	TCHAR TempBuffer[ 2048 ] ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
	{
		return -1 ;
	}

	// 摜t@CpXꍇ̓G[
	if( Image->ReadBase->FileName == NULL )
	{
		return -1 ;
	}

	// 摜t@CpXRs[
	ConvString( ( const char * )Image->ReadBase->FileName, -1, WCHAR_T_CHARCODEFORMAT, TempBuffer, sizeof( TempBuffer ), _TCHARCODEFORMAT ) ;
	if( FilePathBuffer != NULL )
	{
		_TSTRCPY( FilePathBuffer, TempBuffer ) ;
	}

	// Ȉꍇ͕TCYԂ
	return ( int )_TSTRLEN( TempBuffer ) ;
#endif
}

// OtBbNnh摜t@Cǂݍ܂ĂꍇẢ摜̃t@CpX擾
extern int GetGraphFilePath_WCHAR_T( int GrHandle, wchar_t *FilePathBuffer )
{
	IMAGEDATA *Image ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;

	// 摜t@CpXꍇ̓G[
	if( Image->ReadBase->FileName == NULL )
		return -1 ;

	// 摜t@CpXRs[
	if( FilePathBuffer != NULL )
	{
		_WCSCPY( FilePathBuffer, Image->ReadBase->FileName ) ;
	}

	// Ȉꍇ͕TCYԂ
	return ( int )_WCSLEN( Image->ReadBase->FileName ) ;
}

// w̃OtBbNnh`Ώۂɂł( SetDrawScreen ̈ɓn )OtBbNnhǂ擾( ߂l@TRUE:`ΏۂɂłOtBbNnh@FALSE:`ΏۂɂłȂOtBbNnh )
extern int NS_CheckDrawValidGraph( int GrHandle )
{
	IMAGEDATA *Image ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;

	// `Ώۂɂł邩ǂԂ
	return Image->Orig->FormatDesc.DrawValidFlag ;
}

// J[f[^𓾂
extern const COLORDATA * NS_GetTexColorData( int AlphaCh, int AlphaTest, int ColorBitDepth, int DrawValid )
{
	IMAGEFORMATDESC Format ;
	
	Format.DrawValidFlag   = ( unsigned char )DrawValid ;
	Format.AlphaChFlag     = ( unsigned char )AlphaCh ;
	Format.AlphaTestFlag   = ( unsigned char )AlphaTest ;
	Format.ColorBitDepth   = ( BYTE )( ColorBitDepth == TEX_BITDEPTH_16 ? 16 : 32 ) ;
	Format.ChannelNum      = 0 ;
	Format.ChannelBitDepth = 0 ;
	Format.FloatTypeFlag   = FALSE ;
	Format.BaseFormat      = DX_BASEIMAGE_FORMAT_NORMAL ;
	return NS_GetTexColorData2( &Format ) ;
}

#ifndef DX_COMPILE_TYPE_C_LANGUAGE
// tH[}bgɊÂJ[f[^𓾂
extern const COLORDATA * NS_GetTexColorData( const IMAGEFORMATDESC *Format )
{
	return NS_GetTexColorData2( Format ) ;
}

// w̃tH[}bgCfbNX̃J[f[^𓾂
extern const COLORDATA * NS_GetTexColorData( int FormatIndex )
{
	return NS_GetTexColorData3( FormatIndex ) ;
}
#endif // DX_COMPILE_TYPE_C_LANGUAGE

// tH[}bgɊÂJ[f[^𓾂
extern const COLORDATA * NS_GetTexColorData2( const IMAGEFORMATDESC *Format )
{
	const COLORDATA * Result ;

	Result = NS_GetTexColorData3( NS_GetTexFormatIndex( Format ) ) ;

	return Result ;
}

// w̃tH[}bgCfbNX̃J[f[^𓾂
extern const COLORDATA * NS_GetTexColorData3( int FormatIndex )
{
	static int Initialize = FALSE ;
	static COLORDATA ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_NUM ] ;

	// l͈͊OG[
	if( FormatIndex >= DX_GRAPHICSIMAGE_FORMAT_3D_NUM ) return NULL ;

	// ŏɗƂɏ
	if( Initialize == FALSE )
	{
		Initialize = TRUE ;

		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_RGB16                 ],  16, 0x0000f800, 0x000007e0, 0x0000001f, 0x00000000, 0,  0, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_RGB32                 ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0x00000000, 0,  0, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB16           ],  16, 0x00000f00, 0x000000f0, 0x0000000f, 0x0000f000, 0,  0, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB32           ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000, 0,  0, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB16       ],  16, 0x00007c00, 0x000003e0, 0x0000001f, 0x00008000, 0,  0, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB32       ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000, 0,  0, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT1                  ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000, 0,  0, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT2                  ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000, 0,  0, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT3                  ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000, 0,  0, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT4                  ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000, 0,  0, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT5                  ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000, 0,  0, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_BC7_UNORM             ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000, 0,  0, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_BC7_UNORM_SRGB        ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000, 0,  0, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_PLATFORM0             ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000, 0,  0, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_PLATFORM1             ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000, 0,  0, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_PLATFORM2             ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000, 0,  0, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_PLATFORM3             ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000, 0,  0, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_ABGR_I16              ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 4, 16, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_ABGR_F16              ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 4, 16, TRUE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_ABGR_F32              ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 4, 32, TRUE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_ONE_I8                ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1,  8, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_ONE_I16               ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1, 16, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_ONE_F16               ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1, 16, TRUE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_ONE_F32               ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1, 32, TRUE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_TWO_I8                ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 2,  8, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_TWO_I16               ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 2, 16, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_TWO_F16               ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 2, 16, TRUE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_TWO_F32               ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 2, 32, TRUE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB16       ],  16, 0x0000f800, 0x000007e0, 0x0000001f, 0x00000000, 0,  0, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB32       ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0x00000000, 0,  0, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ALPHA_RGB32 ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000, 0,  0, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_I16    ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 4, 16, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F16    ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 4, 16, TRUE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F32    ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 4, 32, TRUE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I8      ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1,  8, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I16     ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1, 16, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16     ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1, 16, TRUE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32     ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1, 32, TRUE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I8      ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 2,  8, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I16     ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 2, 16, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F16     ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 2, 16, TRUE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F32     ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 2, 32, TRUE ) ;

		ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT1           ].Format = DX_BASEIMAGE_FORMAT_DXT1 ;           ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT1           ].ColorBitDepth = 4 ;
		ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT2           ].Format = DX_BASEIMAGE_FORMAT_DXT2 ;           ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT2           ].ColorBitDepth = 8 ;
		ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT3           ].Format = DX_BASEIMAGE_FORMAT_DXT3 ;           ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT3           ].ColorBitDepth = 8 ;
		ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT4           ].Format = DX_BASEIMAGE_FORMAT_DXT4 ;           ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT4           ].ColorBitDepth = 8 ;
		ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT5           ].Format = DX_BASEIMAGE_FORMAT_DXT5 ;           ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT5           ].ColorBitDepth = 8 ;
		ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_BC7_UNORM      ].Format = DX_BASEIMAGE_FORMAT_BC7_UNORM ;      ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_BC7_UNORM      ].ColorBitDepth = 8 ;
		ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_BC7_UNORM_SRGB ].Format = DX_BASEIMAGE_FORMAT_BC7_UNORM_SRGB ; ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_BC7_UNORM_SRGB ].ColorBitDepth = 8 ;
		ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_PLATFORM0      ].Format = DX_BASEIMAGE_FORMAT_PLATFORM0 ;      ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_PLATFORM0      ].ColorBitDepth = 8 ;
		ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_PLATFORM1      ].Format = DX_BASEIMAGE_FORMAT_PLATFORM1 ;      ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_PLATFORM1      ].ColorBitDepth = 8 ;
		ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_PLATFORM2      ].Format = DX_BASEIMAGE_FORMAT_PLATFORM2 ;      ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_PLATFORM2      ].ColorBitDepth = 8 ;
		ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_PLATFORM3      ].Format = DX_BASEIMAGE_FORMAT_PLATFORM3 ;      ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_PLATFORM3      ].ColorBitDepth = 8 ;
	}

	// J[tH[}bgԂ
	return &ColorData[ FormatIndex ] ;
}

// OtBbNɎgpőeNX`TCY擾
extern int NS_GetMaxGraphTextureSize( int *SizeX, int *SizeY )
{
	if( SizeX != NULL ) *SizeX = GSYS.HardInfo.MaxTextureWidth ;
	if( SizeY != NULL ) *SizeY = GSYS.HardInfo.MaxTextureHeight ;

	// I
	return 0 ;
}

// OtBbN֐̗L擾	
extern	int NS_GetValidRestoreShredPoint( void )
{
	return GSYS.Setting.GraphRestoreShred != NULL ;
}

// ꂩVɃOtBbN쐬ꍇɎgpJ[擾
extern	int NS_GetCreateGraphColorData( COLORDATA * /*ColorData*/, IMAGEFORMATDESC * /*Format*/ )
{
	// I
	return 0 ;
}























// 摜pbg֌W֐

// ɓǂݍ񂾉摜̃pbg擾(tJ[摜̏ꍇ͖)
extern	int		NS_GetGraphPalette( int GrHandle, int ColorIndex, int *Red, int *Green, int *Blue )
{
	MEMIMG *MemImg ;
	unsigned int Color;

	// G[`FbN
	if( ColorIndex < 0 || ColorIndex > 255 ) return -1 ;
	PALETTEIMAGECHK( GrHandle, MemImg );
	
	// pbg擾
	switch( MemImg->Base->ColorType )
	{
	case 0: Color = ((WORD  *)MemImg->Base->Palette)[ ColorIndex ]; break;
	case 1: Color = ((DWORD *)MemImg->Base->Palette)[ ColorIndex ]; break;
	default : return -1 ;
	}
	NS_GetColor5( MemImg->Base->ColorDataP, Color, Red, Green, Blue, NULL ) ;
	
	// I
	return 0 ;
}

// ɓǂݍ񂾉摜 SetGraphPalette ŕύXÕpbg擾
extern  int		NS_GetGraphOriginalPalette( int GrHandle, int ColorIndex, int *Red, int *Green, int *Blue )
{
	MEMIMG *MemImg ;
	unsigned int Color ;
	
	// G[`FbN
	if( ColorIndex < 0 || ColorIndex > 255 ) return -1 ;
	PALETTEIMAGECHK( GrHandle, MemImg );

	// pbg擾
	switch( MemImg->Base->ColorType )
	{
	case 0: Color = ((WORD  *)MemImg->Base->OriginalPalette)[ColorIndex]; break;
	case 1: Color = ((DWORD *)MemImg->Base->OriginalPalette)[ColorIndex]; break;
	default : return -1 ;
	}
	NS_GetColor5( MemImg->Base->ColorDataP, Color, Red, Green, Blue, NULL ) ;
	
	// I
	return 0 ;
}

// ɓǂݍ񂾉摜̃pbgύX(tJ[摜̏ꍇ͖)
extern	int		NS_SetGraphPalette( int GrHandle, int ColorIndex, unsigned int Color )
{
	MEMIMG *MemImg ;
	int Red, Green, Blue ;
	COLORDATA *ColorData ;

	// G[`FbN
	if( ColorIndex < 0 || ColorIndex > 255 ) return -1 ;
	PALETTEIMAGECHK( GrHandle, MemImg );

	// FR[hZbg
	NS_GetColor2( Color, &Red, &Green, &Blue ) ;
	ColorData = MemImg->Base->ColorDataP ;
	Color = ColorData->NoneMask +
				( ( ( BYTE )Red   >> ( 8 - ColorData->RedWidth   ) ) << ColorData->RedLoc   ) +
				( ( ( BYTE )Green >> ( 8 - ColorData->GreenWidth ) ) << ColorData->GreenLoc ) +
				( ( ( BYTE )Blue  >> ( 8 - ColorData->BlueWidth  ) ) << ColorData->BlueLoc  ) ;
	switch( MemImg->Base->ColorType )
	{
	case 0: ((WORD  *)MemImg->Base->Palette)[ColorIndex] = (WORD)Color;  break;
	case 1: ((DWORD *)MemImg->Base->Palette)[ColorIndex] = (DWORD)Color; break;
	}
	
	// I
	return 0 ;
}

// SetGraphPalette ŕύXpbgSČɖ߂
extern int NS_ResetGraphPalette( int GrHandle )
{
	MEMIMG *MemImg ;
	int Size;
	
	// G[`FbN
	PALETTEIMAGECHK( GrHandle, MemImg );

	// ̃pbgRs[
	switch( MemImg->Base->ColorType )
	{
	case 0 : Size = 1 ; break ;
	case 1 : Size = 2 ; break ;
	default : return -1 ;
	}
	_MEMCPY( MemImg->Base->Palette, MemImg->Base->OriginalPalette, ( size_t )( MemImg->Base->ColorNum << Size ) ) ;
	
	// I
	return 0 ;
}

























// }``֐

// wt̕`
static int DrawLine_Thickness( int x1, int y1, int x2, int y2, unsigned int Color, int Thickness )
{
	VECTOR v, p1, p2;
	float f ;

	if( Thickness <= 0 || Thickness == 1 )
	{
		return NS_DrawLine( x1, y1, x2, y2, Color, 1 ) ;
	}
	else
	{
		if( x1 == x2 && Thickness % 2 == 1 )
		{
			int x ;

			x = x1 - Thickness / 2 ;
			return NS_DrawBox( x, y1, x + Thickness, y2, Color, TRUE ) ;
		}
		else
		if( y1 == y2 && Thickness % 2 == 1 )
		{
			int y ;

			y = y1 - Thickness / 2 ;
			return NS_DrawBox( x1, y, x2, y + Thickness, Color, TRUE ) ;
		}
	}

	CheckActiveState() ;

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		p1.x = (float)x1;
		p1.y = (float)y1;
		p2.x = (float)x2;
		p2.y = (float)y2;

		v.x = (    p2.y - p1.y   );
		v.y = ( -( p2.x - p1.x ) );
		f = ( 1.0f / _SQRT( v.x * v.x + v.y * v.y ) ) * ( (float)Thickness / 2.0f );
		v.x *= f;
		v.y *= f;

		Graphics_Hardware_DrawQuadrangleF_PF(
			p1.x + v.x, 
			p1.y + v.y,
			p2.x + v.x,
			p2.y + v.y,
			p2.x - v.x,
			p2.y - v.y,
			p1.x - v.x,
			p1.y - v.y, Color, TRUE ) ;
	}
	else
	{
		v.x = ( float )(    y2 - y1   );
		v.y = ( float )( -( x2 - x1 ) );
		f = ( 1.0f / _SQRT( v.x * v.x + v.y * v.y ) ) * ( (float)Thickness / 2.0f ) ;
		v.x *= f ;
		v.y *= f ;

		Graphics_Software_DrawQuadrangle( 
			_FTOL( x1 + v.x ),
			_FTOL( y1 + v.y ),
			_FTOL( x2 + v.x ),
			_FTOL( y2 + v.y ),
			_FTOL( x2 - v.x ),
			_FTOL( y2 - v.y ),
			_FTOL( x1 - v.x ),
			_FTOL( y1 - v.y ), Color, TRUE ) ;
	}

	// I
	return 0;
}

// `
#define SETDRAWRECTCODE\
	SETRECT( DrawRect, x1, y1, x2, y2 ) ;\
	if( x1 > x2 ){ DrawRect.left = x2 ; DrawRect.right  = x1; }\
	if( y1 > y2 ){ DrawRect.top  = y2 ; DrawRect.bottom = y1; }\
	DrawRect.left   -= Thickness ;\
	DrawRect.top    -= Thickness ;\
	DrawRect.right  += 1 + Thickness ;\
	DrawRect.bottom += 1 + Thickness ;\
	DRAWRECT_DRAWAREA_CLIP

extern	int NS_DrawLine( int x1, int y1, int x2, int y2, unsigned int Color, int Thickness )
{
	int Ret = -1 ;
	int Flag ;

	// Pȏ̏ꍇ͑wt`s
	if( Thickness > 1 )
		return DrawLine_Thickness( x1, y1, x2, y2, Color, Thickness ) ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;

	CheckActiveState() ;

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	DRAW_DEF(
		Graphics_Hardware_DrawLine_PF( x1, y1, x2, y2, Color ),
		Graphics_Software_DrawLine(    x1, y1, x2, y2, Color ),
		SETDRAWRECTCODE,
		Ret,
		Flag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE

// `悷( A`GCAXt )
extern int NS_DrawLineAA( float x1, float y1, float x2, float y2, unsigned int Color, float Thickness )
{
	int GrHandle ;
	GRAPHICS_DRAW_DRAWSIMPLEQUADRANGLEGRAPHF_PARAM Param ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX ParamVertex[ 9 * 4 ] ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX *Vertex ;
	VECTOR HVec ;
	VECTOR DVec ;
	float Distance ;
	float LinePosX[ 4 ][ 2 ] ;
	float LinePosY[ 4 ][ 2 ] ;
	float tmp ;
	float tmp1 ;
	float tmp2 ;
	float tmp3 ;
	float tmp4 ;
	int i ;
	int j ;
	static float LineUV[ 4 ] = { 0.0f, 3.0f / LINE_TEX_SIZE, 5.0f / LINE_TEX_SIZE, 1.0f } ;

	if( GSYS.HardInfo.DrawFloatCoordType == DX_DRAWFLOATCOORDTYPE_DIRECT3D9 )
	{
		x1 -= 0.5f ;
		y1 -= 0.5f ;
		x2 -= 0.5f ;
		y2 -= 0.5f ;
	}

	x1 += 0.5f ;
	y1 += 0.5f ;
	x2 += 0.5f ;
	y2 += 0.5f ;

	DVec.x = x2 - x1 ;
	DVec.y = y2 - y1 ;
	DVec.z = 0.0f ;
	Distance = DVec.x * DVec.x + DVec.y * DVec.y ;
	if( Distance < 1.0f )
	{
		return 0 ;
	}
	Distance = _SQRT( Distance ) ;

	DVec.x /= Distance ;
	DVec.y /= Distance ;

	HVec.x =  DVec.y ;
	HVec.y = -DVec.x ;

	tmp = - 2.5f ; LinePosY[ 0 ][ 0 ] = DVec.x * tmp ; LinePosY[ 0 ][ 1 ] = DVec.y * tmp ;
	tmp =   0.5f ; LinePosY[ 1 ][ 0 ] = DVec.x * tmp ; LinePosY[ 1 ][ 1 ] = DVec.y * tmp ;
	tmp = - 1.5f ; LinePosY[ 2 ][ 0 ] = DVec.x * tmp ; LinePosY[ 2 ][ 1 ] = DVec.y * tmp ;
	tmp =   1.5f ; LinePosY[ 3 ][ 0 ] = DVec.x * tmp ; LinePosY[ 3 ][ 1 ] = DVec.y * tmp ;

	AA_DRAW_BEGIN
	AA_DRAW_BEGIN_2

	Param.Vertex      = ParamVertex ;
	Param.TransFlag   = TRUE ;
	if( Thickness <= 1.0f )
	{
		static float LineUV_2[ 2 ] = { 0.0f, 5.0f / LINE_TEX_SIZE } ;

		Param.QuadrangleNum = 3 ;

		GrHandle = Graphics_Image_GetLineOneThicknessTexHandle( IS_PMA_DRAWBLENDMODE ) ;

		Param.GraphHandle = GrHandle ;

		Thickness /= 2.0f;
		tmp1 = - Thickness - 2.0f;
		tmp2 = + Thickness + 2.0f;

		LinePosX[ 0 ][ 0 ] = HVec.x * tmp1 ; LinePosX[ 0 ][ 1 ] = HVec.y * tmp1 ;
		LinePosX[ 1 ][ 0 ] = HVec.x * tmp2 ; LinePosX[ 1 ][ 1 ] = HVec.y * tmp2 ;

		Vertex = ParamVertex ;
		for( i = 0; i < 3 ; i++ )
		{
			Vertex[ 0 ].u = LineUV_2[ 0 ] ;	Vertex[ 0 ].v = LineUV[ i + 0 ] ;
			Vertex[ 1 ].u = LineUV_2[ 1 ] ;	Vertex[ 1 ].v = LineUV[ i + 0 ] ;
			Vertex[ 2 ].u = LineUV_2[ 0 ] ;	Vertex[ 2 ].v = LineUV[ i + 1 ] ;
			Vertex[ 3 ].u = LineUV_2[ 1 ] ;	Vertex[ 3 ].v = LineUV[ i + 1 ] ;

			Vertex += 4 ;
		}

		Vertex = ParamVertex ;
		i = 0 ;
		Vertex[ 0 ].x = x1 + LinePosX[ 0 ][ 0 ] + LinePosY[ i + 0 ][ 0 ] ;	Vertex[ 0 ].y = y1 + LinePosY[ i + 0 ][ 1 ] + LinePosX[ 0 ][ 1 ] ;
		Vertex[ 1 ].x = x1 + LinePosX[ 1 ][ 0 ] + LinePosY[ i + 0 ][ 0 ] ;	Vertex[ 1 ].y = y1 + LinePosY[ i + 0 ][ 1 ] + LinePosX[ 1 ][ 1 ] ;
		Vertex[ 2 ].x = x1 + LinePosX[ 0 ][ 0 ] + LinePosY[ i + 1 ][ 0 ] ;	Vertex[ 2 ].y = y1 + LinePosY[ i + 1 ][ 1 ] + LinePosX[ 0 ][ 1 ] ;
		Vertex[ 3 ].x = x1 + LinePosX[ 1 ][ 0 ] + LinePosY[ i + 1 ][ 0 ] ;	Vertex[ 3 ].y = y1 + LinePosY[ i + 1 ][ 1 ] + LinePosX[ 1 ][ 1 ] ;

		Vertex += 4 ;

		i = 1;
		Vertex[ 0 ].x = x1 + LinePosX[ 0 ][ 0 ] + LinePosY[ i + 0 ][ 0 ] ;	Vertex[ 0 ].y = y1 + LinePosY[ i + 0 ][ 1 ] + LinePosX[ 0 ][ 1 ] ;
		Vertex[ 1 ].x = x1 + LinePosX[ 1 ][ 0 ] + LinePosY[ i + 0 ][ 0 ] ;	Vertex[ 1 ].y = y1 + LinePosY[ i + 0 ][ 1 ] + LinePosX[ 1 ][ 1 ] ;
		Vertex[ 2 ].x = x2 + LinePosX[ 0 ][ 0 ] + LinePosY[ i + 1 ][ 0 ] ;	Vertex[ 2 ].y = y2 + LinePosY[ i + 1 ][ 1 ] + LinePosX[ 0 ][ 1 ] ;
		Vertex[ 3 ].x = x2 + LinePosX[ 1 ][ 0 ] + LinePosY[ i + 1 ][ 0 ] ;	Vertex[ 3 ].y = y2 + LinePosY[ i + 1 ][ 1 ] + LinePosX[ 1 ][ 1 ] ;

		Vertex += 4 ;

		i = 2 ;
		Vertex[ 0 ].x = x2 + LinePosX[ 0 ][ 0 ] + LinePosY[ i + 0 ][ 0 ] ;	Vertex[ 0 ].y = y2 + LinePosY[ i + 0 ][ 1 ] + LinePosX[ 0 ][ 1 ] ;
		Vertex[ 1 ].x = x2 + LinePosX[ 1 ][ 0 ] + LinePosY[ i + 0 ][ 0 ] ;	Vertex[ 1 ].y = y2 + LinePosY[ i + 0 ][ 1 ] + LinePosX[ 1 ][ 1 ] ;
		Vertex[ 2 ].x = x2 + LinePosX[ 0 ][ 0 ] + LinePosY[ i + 1 ][ 0 ] ;	Vertex[ 2 ].y = y2 + LinePosY[ i + 1 ][ 1 ] + LinePosX[ 0 ][ 1 ] ;
		Vertex[ 3 ].x = x2 + LinePosX[ 1 ][ 0 ] + LinePosY[ i + 1 ][ 0 ] ;	Vertex[ 3 ].y = y2 + LinePosY[ i + 1 ][ 1 ] + LinePosX[ 1 ][ 1 ] ;

		Vertex += 4 ;
	}
	else
	{
		Param.QuadrangleNum = 9 ;

		GrHandle = Graphics_Image_GetLineTexHandle( IS_PMA_DRAWBLENDMODE ) ;

		Param.GraphHandle = GrHandle ;

		Thickness /= 2.0f ;
		tmp1 = - Thickness - 2.0f ;
		tmp2 = - Thickness + 1.0f ;
		tmp3 =   Thickness - 1.0f ;
		tmp4 =   Thickness + 2.0f ;

		LinePosX[ 0 ][ 0 ] = HVec.x * tmp1 ; LinePosX[ 0 ][ 1 ] = HVec.y * tmp1 ;
		LinePosX[ 1 ][ 0 ] = HVec.x * tmp2 ; LinePosX[ 1 ][ 1 ] = HVec.y * tmp2 ;
		LinePosX[ 2 ][ 0 ] = HVec.x * tmp3 ; LinePosX[ 2 ][ 1 ] = HVec.y * tmp3 ;
		LinePosX[ 3 ][ 0 ] = HVec.x * tmp4 ; LinePosX[ 3 ][ 1 ] = HVec.y * tmp4 ;

		Vertex = ParamVertex ;
		for( i = 0; i < 3 ; i++ )
		{
			for( j = 0; j < 3 ; j++ )
			{
				Vertex[ 0 ].u = LineUV[ j + 0 ] ;	Vertex[ 0 ].v = LineUV[ i + 0 ] ;
				Vertex[ 1 ].u = LineUV[ j + 1 ] ;	Vertex[ 1 ].v = LineUV[ i + 0 ] ;
				Vertex[ 2 ].u = LineUV[ j + 0 ] ;	Vertex[ 2 ].v = LineUV[ i + 1 ] ;
				Vertex[ 3 ].u = LineUV[ j + 1 ] ;	Vertex[ 3 ].v = LineUV[ i + 1 ] ;

				Vertex += 4 ;
			}
		}

		Vertex = ParamVertex ;
		i = 0 ;
		for( j = 0; j < 3; j++ )
		{
			Vertex[ 0 ].x = x1 + LinePosX[ j + 0 ][ 0 ] + LinePosY[ i + 0 ][ 0 ] ;	Vertex[ 0 ].y = y1 + LinePosY[ i + 0 ][ 1 ] + LinePosX[ j + 0 ][ 1 ] ;
			Vertex[ 1 ].x = x1 + LinePosX[ j + 1 ][ 0 ] + LinePosY[ i + 0 ][ 0 ] ;	Vertex[ 1 ].y = y1 + LinePosY[ i + 0 ][ 1 ] + LinePosX[ j + 1 ][ 1 ] ;
			Vertex[ 2 ].x = x1 + LinePosX[ j + 0 ][ 0 ] + LinePosY[ i + 1 ][ 0 ] ;	Vertex[ 2 ].y = y1 + LinePosY[ i + 1 ][ 1 ] + LinePosX[ j + 0 ][ 1 ] ;
			Vertex[ 3 ].x = x1 + LinePosX[ j + 1 ][ 0 ] + LinePosY[ i + 1 ][ 0 ] ;	Vertex[ 3 ].y = y1 + LinePosY[ i + 1 ][ 1 ] + LinePosX[ j + 1 ][ 1 ] ;

			Vertex += 4 ;
		}

		i = 1;
		for( j = 0; j < 3; j++ )
		{
			Vertex[ 0 ].x = x1 + LinePosX[ j + 0 ][ 0 ] + LinePosY[ i + 0 ][ 0 ] ;	Vertex[ 0 ].y = y1 + LinePosY[ i + 0 ][ 1 ] + LinePosX[ j + 0 ][ 1 ] ;
			Vertex[ 1 ].x = x1 + LinePosX[ j + 1 ][ 0 ] + LinePosY[ i + 0 ][ 0 ] ;	Vertex[ 1 ].y = y1 + LinePosY[ i + 0 ][ 1 ] + LinePosX[ j + 1 ][ 1 ] ;
			Vertex[ 2 ].x = x2 + LinePosX[ j + 0 ][ 0 ] + LinePosY[ i + 1 ][ 0 ] ;	Vertex[ 2 ].y = y2 + LinePosY[ i + 1 ][ 1 ] + LinePosX[ j + 0 ][ 1 ] ;
			Vertex[ 3 ].x = x2 + LinePosX[ j + 1 ][ 0 ] + LinePosY[ i + 1 ][ 0 ] ;	Vertex[ 3 ].y = y2 + LinePosY[ i + 1 ][ 1 ] + LinePosX[ j + 1 ][ 1 ] ;

			Vertex += 4 ;
		}

		i = 2 ;
		for( j = 0; j < 3; j++ )
		{
			Vertex[ 0 ].x = x2 + LinePosX[ j + 0 ][ 0 ] + LinePosY[ i + 0 ][ 0 ] ;	Vertex[ 0 ].y = y2 + LinePosY[ i + 0 ][ 1 ] + LinePosX[ j + 0 ][ 1 ] ;
			Vertex[ 1 ].x = x2 + LinePosX[ j + 1 ][ 0 ] + LinePosY[ i + 0 ][ 0 ] ;	Vertex[ 1 ].y = y2 + LinePosY[ i + 0 ][ 1 ] + LinePosX[ j + 1 ][ 1 ] ;
			Vertex[ 2 ].x = x2 + LinePosX[ j + 0 ][ 0 ] + LinePosY[ i + 1 ][ 0 ] ;	Vertex[ 2 ].y = y2 + LinePosY[ i + 1 ][ 1 ] + LinePosX[ j + 0 ][ 1 ] ;
			Vertex[ 3 ].x = x2 + LinePosX[ j + 1 ][ 0 ] + LinePosY[ i + 1 ][ 0 ] ;	Vertex[ 3 ].y = y2 + LinePosY[ i + 1 ][ 1 ] + LinePosX[ j + 1 ][ 1 ] ;

			Vertex += 4 ;
		}
	}

	Graphics_Draw_DrawSimpleQuadrangleGraphF( &Param ) ;

	AA_DRAW_END

	// I
	return 0 ;
}


// lp`̕`
extern	int NS_DrawBox( int x1, int y1, int x2, int y2, unsigned int Color, int FillFlag )
{
	int Ret ;
	
	if( FillFlag )	Ret = NS_DrawFillBox( x1, y1, x2, y2, Color ) ;
	else			Ret = NS_DrawLineBox( x1, y1, x2, y2, Color ) ;

	// I
	return Ret ;
}

// lp`̕`( A`GCAXt )
static int DrawBoxLineAA( float x1, float y1, float x2, float y2, unsigned int Color, float LineThickness )
{
	int GrHandle ;
	GRAPHICS_DRAW_DRAWSIMPLEQUADRANGLEGRAPHF_PARAM Param ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX ParamVertex[ ( 8 + 4 + 8 ) * 4 ] ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX *Vertex ;
	float LinePos_Out_X[ 4 ];
	float LinePos_Out_Y[ 4 ];
	float LinePos_In_X[ 4 ];
	float LinePos_In_Y[ 4 ];
	int i ;
	int j ;
	static float Line_Out_UV[ 4 ] = { 0.0f,                    4.0f / LINEBOX_TEX_SIZE, 12.0f / LINEBOX_TEX_SIZE, 1.0f } ;
	static float Line_In_UV[ 4 ]  = { 5.0f / LINEBOX_TEX_SIZE, 8.0f / LINEBOX_TEX_SIZE, 8.0f  / LINEBOX_TEX_SIZE, 11.0f / LINEBOX_TEX_SIZE } ;

	if( x1 == x2 || y1 == y2 )
	{
		return 0 ;
	}

	// ]
	{
		float bx, by ;

		if( x1 > x2 || y1 > y2 )
		{
			bx = x1 ; by = y1 ;
			x1 = x2 ; y1 = y2 ;
			x2 = bx ; y2 = by ;
		}
	}

	x2 -= 1.0f ;
	y2 -= 1.0f ;
	if( GSYS.HardInfo.DrawFloatCoordType == DX_DRAWFLOATCOORDTYPE_DIRECT3D9 )
	{
		x1 -= 0.5f ;
		y1 -= 0.5f ;
		x2 -= 0.5f ;
		y2 -= 0.5f ;
	}

	AA_DRAW_BEGIN
	AA_DRAW_BEGIN_2

	Param.Vertex        = ParamVertex ;
	Param.TransFlag     = TRUE ;
	if( LineThickness <= 1.0f )
	{
		Param.QuadrangleNum = 8 ;

		GrHandle = Graphics_Image_GetLineBoxOneThicknessTexHandle( IS_PMA_DRAWBLENDMODE ) ;

		Param.GraphHandle = GrHandle ;

		LineThickness /= 2.0f;
		LinePos_Out_X[ 0 ] = x1 - LineThickness - 1.5f ;
		LinePos_Out_X[ 1 ] = x1 - LineThickness + 2.5f ;
		LinePos_Out_X[ 2 ] = x2 + LineThickness - 1.5f ;
		LinePos_Out_X[ 3 ] = x2 + LineThickness + 2.5f ;

		LinePos_Out_Y[ 0 ] = y1 - LineThickness - 1.5f ;
		LinePos_Out_Y[ 1 ] = y1 - LineThickness + 2.5f ;
		LinePos_Out_Y[ 2 ] = y2 + LineThickness - 1.5f ;
		LinePos_Out_Y[ 3 ] = y2 + LineThickness + 2.5f ;

		Vertex = ParamVertex ;
		for( i = 0; i < 3 ; i++ )
		{
			for( j = 0; j < 3 ; j++ )
			{
				if( j == 1 && i == 1 )
				{
					continue ;
				}

				Vertex[ 0 ].x = LinePos_Out_X[ j + 1 ] ;	Vertex[ 0 ].y = LinePos_Out_Y[ i + 0 ] ;
				Vertex[ 1 ].x = LinePos_Out_X[ j + 0 ] ;	Vertex[ 1 ].y = LinePos_Out_Y[ i + 0 ] ;
				Vertex[ 2 ].x = LinePos_Out_X[ j + 1 ] ;	Vertex[ 2 ].y = LinePos_Out_Y[ i + 1 ] ;
				Vertex[ 3 ].x = LinePos_Out_X[ j + 0 ] ;	Vertex[ 3 ].y = LinePos_Out_Y[ i + 1 ] ;

				Vertex[ 0 ].u = Line_Out_UV[ j + 1 ] ;		Vertex[ 0 ].v = Line_Out_UV[ i + 0 ] ;
				Vertex[ 1 ].u = Line_Out_UV[ j + 0 ] ;		Vertex[ 1 ].v = Line_Out_UV[ i + 0 ] ;
				Vertex[ 2 ].u = Line_Out_UV[ j + 1 ] ;		Vertex[ 2 ].v = Line_Out_UV[ i + 1 ] ;
				Vertex[ 3 ].u = Line_Out_UV[ j + 0 ] ;		Vertex[ 3 ].v = Line_Out_UV[ i + 1 ] ;

				Vertex += 4 ;
			}
		}
	}
	else
	{
		Param.QuadrangleNum = 8 + 4 + 8 ;

		GrHandle = Graphics_Image_GetLineBoxTexHandle( IS_PMA_DRAWBLENDMODE ) ;

		Param.GraphHandle = GrHandle ;

		LineThickness /= 2.0f;
		LinePos_Out_X[ 0 ] = x1 - LineThickness - 1.5f ;
		LinePos_Out_X[ 1 ] = x1 - LineThickness + 2.5f ;
		LinePos_Out_X[ 2 ] = x2 + LineThickness - 1.5f ;
		LinePos_Out_X[ 3 ] = x2 + LineThickness + 2.5f ;

		LinePos_Out_Y[ 0 ] = y1 - LineThickness - 1.5f ;
		LinePos_Out_Y[ 1 ] = y1 - LineThickness + 2.5f ;
		LinePos_Out_Y[ 2 ] = y2 + LineThickness - 1.5f ;
		LinePos_Out_Y[ 3 ] = y2 + LineThickness + 2.5f ;

		LinePos_In_X[ 0 ] = x1 + LineThickness - 0.5f ;
		LinePos_In_X[ 1 ] = x1 + LineThickness + 2.5f ;
		LinePos_In_X[ 2 ] = x2 - LineThickness - 1.5f ;
		LinePos_In_X[ 3 ] = x2 - LineThickness + 1.5f ;

		LinePos_In_Y[ 0 ] = y1 + LineThickness - 0.5f ;
		LinePos_In_Y[ 1 ] = y1 + LineThickness + 2.5f ;
		LinePos_In_Y[ 2 ] = y2 - LineThickness - 1.5f ;
		LinePos_In_Y[ 3 ] = y2 - LineThickness + 1.5f ;

		Vertex = ParamVertex ;
		for( i = 0; i < 3 ; i++ )
		{
			for( j = 0; j < 3 ; j++ )
			{
				if( j == 1 && i == 1 )
				{
					continue ;
				}

				Vertex[ 0 ].x = LinePos_Out_X[ j + 1 ] ;	Vertex[ 0 ].y = LinePos_Out_Y[ i + 0 ] ;
				Vertex[ 1 ].x = LinePos_Out_X[ j + 0 ] ;	Vertex[ 1 ].y = LinePos_Out_Y[ i + 0 ] ;
				Vertex[ 2 ].x = LinePos_Out_X[ j + 1 ] ;	Vertex[ 2 ].y = LinePos_Out_Y[ i + 1 ] ;
				Vertex[ 3 ].x = LinePos_Out_X[ j + 0 ] ;	Vertex[ 3 ].y = LinePos_Out_Y[ i + 1 ] ;

				Vertex[ 0 ].u = Line_Out_UV[ j + 1 ] ;		Vertex[ 0 ].v = Line_Out_UV[ i + 0 ] ;
				Vertex[ 1 ].u = Line_Out_UV[ j + 0 ] ;		Vertex[ 1 ].v = Line_Out_UV[ i + 0 ] ;
				Vertex[ 2 ].u = Line_Out_UV[ j + 1 ] ;		Vertex[ 2 ].v = Line_Out_UV[ i + 1 ] ;
				Vertex[ 3 ].u = Line_Out_UV[ j + 0 ] ;		Vertex[ 3 ].v = Line_Out_UV[ i + 1 ] ;

				Vertex += 4 ;

				Vertex[ 0 ].x = LinePos_In_X[ j + 1 ] ;		Vertex[ 0 ].y = LinePos_In_Y[ i + 0 ] ;
				Vertex[ 1 ].x = LinePos_In_X[ j + 0 ] ;		Vertex[ 1 ].y = LinePos_In_Y[ i + 0 ] ;
				Vertex[ 2 ].x = LinePos_In_X[ j + 1 ] ;		Vertex[ 2 ].y = LinePos_In_Y[ i + 1 ] ;
				Vertex[ 3 ].x = LinePos_In_X[ j + 0 ] ;		Vertex[ 3 ].y = LinePos_In_Y[ i + 1 ] ;

				Vertex[ 0 ].u = Line_In_UV[ j + 1 ] ;		Vertex[ 0 ].v = Line_In_UV[ i + 0 ] ;
				Vertex[ 1 ].u = Line_In_UV[ j + 0 ] ;		Vertex[ 1 ].v = Line_In_UV[ i + 0 ] ;
				Vertex[ 2 ].u = Line_In_UV[ j + 1 ] ;		Vertex[ 2 ].v = Line_In_UV[ i + 1 ] ;
				Vertex[ 3 ].u = Line_In_UV[ j + 0 ] ;		Vertex[ 3 ].v = Line_In_UV[ i + 1 ] ;

				Vertex += 4 ;
			}
		}

		Vertex[ 0 ].x = LinePos_Out_X[ 1 ] ;		Vertex[ 0 ].y = LinePos_Out_Y[ 1 ] ;
		Vertex[ 1 ].x = LinePos_Out_X[ 2 ] ;		Vertex[ 1 ].y = LinePos_Out_Y[ 1 ] ;
		Vertex[ 2 ].x = LinePos_Out_X[ 1 ] ;		Vertex[ 2 ].y = LinePos_In_Y[  0 ] ;
		Vertex[ 3 ].x = LinePos_Out_X[ 2 ] ;		Vertex[ 3 ].y = LinePos_In_Y[  0 ] ;

		Vertex[ 0 ].u = Line_In_UV[ 0 ] ;			Vertex[ 0 ].v = Line_In_UV[ 0 ] ;
		Vertex[ 1 ].u = Line_In_UV[ 0 ] ;			Vertex[ 1 ].v = Line_In_UV[ 0 ] ;
		Vertex[ 2 ].u = Line_In_UV[ 0 ] ;			Vertex[ 2 ].v = Line_In_UV[ 0 ] ;
		Vertex[ 3 ].u = Line_In_UV[ 0 ] ;			Vertex[ 3 ].v = Line_In_UV[ 0 ] ;

		Vertex += 4 ;

		Vertex[ 0 ].x = LinePos_Out_X[ 1 ] ;		Vertex[ 0 ].y = LinePos_In_Y[  3 ] ;
		Vertex[ 1 ].x = LinePos_Out_X[ 2 ] ;		Vertex[ 1 ].y = LinePos_In_Y[  3 ] ;
		Vertex[ 2 ].x = LinePos_Out_X[ 1 ] ;		Vertex[ 2 ].y = LinePos_Out_Y[ 2 ] ;
		Vertex[ 3 ].x = LinePos_Out_X[ 2 ] ;		Vertex[ 3 ].y = LinePos_Out_Y[ 2 ] ;

		Vertex[ 0 ].u = Line_In_UV[ 0 ] ;			Vertex[ 0 ].v = Line_In_UV[ 0 ] ;
		Vertex[ 1 ].u = Line_In_UV[ 0 ] ;			Vertex[ 1 ].v = Line_In_UV[ 0 ] ;
		Vertex[ 2 ].u = Line_In_UV[ 0 ] ;			Vertex[ 2 ].v = Line_In_UV[ 0 ] ;
		Vertex[ 3 ].u = Line_In_UV[ 0 ] ;			Vertex[ 3 ].v = Line_In_UV[ 0 ] ;

		Vertex += 4 ;

		Vertex[ 0 ].x = LinePos_In_X[  3 ] ;		Vertex[ 0 ].y = LinePos_In_Y[ 0 ] ;
		Vertex[ 1 ].x = LinePos_Out_X[ 2 ] ;		Vertex[ 1 ].y = LinePos_In_Y[ 0 ] ;
		Vertex[ 2 ].x = LinePos_In_X[  3 ] ;		Vertex[ 2 ].y = LinePos_In_Y[ 3 ] ;
		Vertex[ 3 ].x = LinePos_Out_X[ 2 ] ;		Vertex[ 3 ].y = LinePos_In_Y[ 3 ] ;

		Vertex[ 0 ].u = Line_In_UV[ 0 ] ;			Vertex[ 0 ].v = Line_In_UV[ 0 ] ;
		Vertex[ 1 ].u = Line_In_UV[ 0 ] ;			Vertex[ 1 ].v = Line_In_UV[ 0 ] ;
		Vertex[ 2 ].u = Line_In_UV[ 0 ] ;			Vertex[ 2 ].v = Line_In_UV[ 0 ] ;
		Vertex[ 3 ].u = Line_In_UV[ 0 ] ;			Vertex[ 3 ].v = Line_In_UV[ 0 ] ;

		Vertex += 4 ;

		Vertex[ 0 ].x = LinePos_Out_X[ 1 ] ;		Vertex[ 0 ].y = LinePos_In_Y[ 0 ] ;
		Vertex[ 1 ].x = LinePos_In_X[  0 ] ;		Vertex[ 1 ].y = LinePos_In_Y[ 0 ] ;
		Vertex[ 2 ].x = LinePos_Out_X[ 1 ] ;		Vertex[ 2 ].y = LinePos_In_Y[ 3 ] ;
		Vertex[ 3 ].x = LinePos_In_X[  0 ] ;		Vertex[ 3 ].y = LinePos_In_Y[ 3 ] ;

		Vertex[ 0 ].u = Line_In_UV[ 0 ] ;			Vertex[ 0 ].v = Line_In_UV[ 0 ] ;
		Vertex[ 1 ].u = Line_In_UV[ 0 ] ;			Vertex[ 1 ].v = Line_In_UV[ 0 ] ;
		Vertex[ 2 ].u = Line_In_UV[ 0 ] ;			Vertex[ 2 ].v = Line_In_UV[ 0 ] ;
		Vertex[ 3 ].u = Line_In_UV[ 0 ] ;			Vertex[ 3 ].v = Line_In_UV[ 0 ] ;

		Vertex += 4 ;
	}

	Graphics_Draw_DrawSimpleQuadrangleGraphF( &Param ) ;

	AA_DRAW_END

	Graphics_DrawSetting_SetDrawBrightToOneParam( OrigColor ) ;

	// I
	return 0 ;
}

// lp`̕`悷( A`GCAXt )
static int DrawBoxFillAA( float x1, float y1, float x2, float y2, unsigned int Color )
{
	int GrHandle ;
	GRAPHICS_DRAW_DRAWSIMPLEQUADRANGLEGRAPHF_PARAM Param ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX ParamVertex[ 9 * 4 ] ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX *Vertex ;
	float LinePosX[ 4 ];
	float LinePosY[ 4 ];
	int i ;
	int j ;
	static float LineUV[ 4 ] = { 0.0f, 3.0f / LINE_TEX_SIZE, 5.0f / LINE_TEX_SIZE, 1.0f };

	if( x1 == x2 || y1 == y2 )
	{
		return 0 ;
	}

	// ]
	{
		float b ;

		if( x1 > x2 ){ b = x1 ; x1 = x2 ; x2 = b ; }
		if( y1 > y2 ){ b = y1 ; y1 = y2 ; y2 = b ; }
	}

	if( GSYS.HardInfo.DrawFloatCoordType == DX_DRAWFLOATCOORDTYPE_DIRECT3D9 )
	{
		x1 -= 0.5f ;
		y1 -= 0.5f ;
		x2 -= 0.5f ;
		y2 -= 0.5f ;
	}

	AA_DRAW_BEGIN
	AA_DRAW_BEGIN_2

	Param.Vertex        = ParamVertex ;
	Param.TransFlag     = TRUE ;
	Param.QuadrangleNum = 9 ;

	GrHandle = Graphics_Image_GetLineTexHandle( IS_PMA_DRAWBLENDMODE ) ;

	Param.GraphHandle = GrHandle ;

	LinePosX[ 0 ] = x1 - 2.0f ;
	LinePosX[ 1 ] = x1 + 1.0f ;
	LinePosX[ 2 ] = x2 - 1.0f ;
	LinePosX[ 3 ] = x2 + 2.0f ;

	LinePosY[ 0 ] = y1 - 2.0f ;
	LinePosY[ 1 ] = y1 + 1.0f ;
	LinePosY[ 2 ] = y2 - 1.0f ;
	LinePosY[ 3 ] = y2 + 2.0f ;

	Vertex = ParamVertex ;
	for( i = 0; i < 3 ; i++ )
	{
		for( j = 0; j < 3 ; j++ )
		{
			Vertex[ 0 ].x = LinePosX[ j + 1 ] ;	Vertex[ 0 ].y = LinePosY[ i + 0 ] ;
			Vertex[ 1 ].x = LinePosX[ j + 0 ] ;	Vertex[ 1 ].y = LinePosY[ i + 0 ] ;
			Vertex[ 2 ].x = LinePosX[ j + 1 ] ;	Vertex[ 2 ].y = LinePosY[ i + 1 ] ;
			Vertex[ 3 ].x = LinePosX[ j + 0 ] ;	Vertex[ 3 ].y = LinePosY[ i + 1 ] ;

			Vertex[ 0 ].u = LineUV[ j + 1 ] ;	Vertex[ 0 ].v = LineUV[ i + 0 ] ;
			Vertex[ 1 ].u = LineUV[ j + 0 ] ;	Vertex[ 1 ].v = LineUV[ i + 0 ] ;
			Vertex[ 2 ].u = LineUV[ j + 1 ] ;	Vertex[ 2 ].v = LineUV[ i + 1 ] ;
			Vertex[ 3 ].u = LineUV[ j + 0 ] ;	Vertex[ 3 ].v = LineUV[ i + 1 ] ;

			Vertex += 4 ;
		}
	}

	Graphics_Draw_DrawSimpleQuadrangleGraphF( &Param ) ;

	AA_DRAW_END

	Graphics_DrawSetting_SetDrawBrightToOneParam( OrigColor ) ;

	// I
	return 0 ;
}

// lp`̕`悷( A`GCAXt )
extern int NS_DrawBoxAA( float x1, float y1, float x2, float y2, unsigned int Color, int FillFlag, float LineThickness )
{
	if( FillFlag == FALSE )
	{
		return DrawBoxLineAA( x1, y1, x2, y2, Color, LineThickness ) ;
	}
	else
	{
		return DrawBoxFillAA( x1, y1, x2, y2, Color ) ;
	}
}

// ĝlp`
#define SETDRAWRECTCODE\
	if( x1 < x2 ){ DrawRect.left = x1 ; DrawRect.right = x2; }\
	if( y1 < y2 ){ DrawRect.top = y1 ; DrawRect.bottom = y2; }\
\
	SETRECT( DrawRect, x1, y1, x2, y2 ) ;\
	DRAWRECT_DRAWAREA_CLIP

extern	int NS_DrawFillBox( int x1, int y1, int x2, int y2, unsigned int Color )
{
	int Ret = -1 ;
	int Flag ;
	
	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;
	
	Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;

	CheckActiveState() ;

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawFillBox_PF( x1, y1, x2, y2, Color ),
		Graphics_Software_DrawFillBox(    x1, y1, x2, y2, Color ),
		SETDRAWRECTCODE,
		Ret,
		Flag
	)

	// I
	return Ret ;
}

// lp`̕` 
extern	int NS_DrawLineBox( int x1, int y1, int x2, int y2, unsigned int Color )
{
	int Ret = -1 ;
	int Flag ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;
	
	Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;

	CheckActiveState() ;

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawLineBox_PF( x1, y1, x2, y2, Color ),
		Graphics_Software_DrawLineBox(    x1, y1, x2, y2, Color ),
		SETDRAWRECTCODE,
		Ret,
		Flag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE

// ~`
#define SETDRAWRECTCODE\
	SETRECT( DrawRect, x - r - 1, y - r - 1, x + r + 1, y + r + 1 )\
	DRAWRECT_DRAWAREA_CLIP
extern	int NS_DrawCircle( int x, int y, int r, unsigned int Color, int FillFlag, int Thickness )
{
	int Ret = -1 ;
	int Flag ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;
	
	Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;

	CheckActiveState() ;

	if( r < 0 ) return 0 ;

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	if( Thickness == 1 )
	{
		DRAW_DEF(
			Graphics_Hardware_DrawCircle_PF( x, y, r, Color, FillFlag ),
			Graphics_Software_DrawCircle(    x, y, r, Color, FillFlag ),
			SETDRAWRECTCODE,
			Ret,
			Flag
		)
	}
	else
	{
		DRAW_DEF(
			Graphics_Hardware_DrawCircle_Thickness_PF( x, y, r, Color, Thickness ),
			Graphics_Software_DrawCircle_Thickness(    x, y, r, Color, Thickness ),
			SETDRAWRECTCODE,
			Ret,
			Flag
		)
	}

	// I
	return Ret ;
}
#undef SETDRAWRECTCODE

// ~`悷( A`GCAXt )
static int DrawCircleLineAA( float x, float y, float r, int posnum, unsigned int Color, float LineThickness )
{
	int GrHandle ;
	GRAPHICS_DRAW_DRAWSIMPLEQUADRANGLEGRAPHF_PARAM Param ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX ParamVertex[ CIRCLE_MAX_POSNUM * 3 * 4 ] ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX *Vertex ;
	float LinePos[ 4 ] ;
	int i ;
	int j ;
	float Sin, Cos ;
	static float LineUV[ 4 ] = { 0.0f, 3.0f / LINE_TEX_SIZE, 5.0f / LINE_TEX_SIZE, 1.0f };
	float PosX[ CIRCLE_MAX_POSNUM + 1 ][ 4 ];
	float PosY[ CIRCLE_MAX_POSNUM + 1 ][ 4 ];

	if( posnum > CIRCLE_MAX_POSNUM )
	{
		posnum = CIRCLE_MAX_POSNUM ;
	}

	if( GSYS.HardInfo.DrawFloatCoordType != DX_DRAWFLOATCOORDTYPE_DIRECT3D9 )
	{
		x += 0.5f ;
		y += 0.5f ;
	}

	AA_DRAW_BEGIN
	AA_DRAW_BEGIN_2

	Param.Vertex      = ParamVertex ;
	Param.TransFlag   = TRUE ;
	if( LineThickness <= 1.0f )
	{
		static float LineUV_2[ 2 ] = { 0.0f, 4.0f / LINE_TEX_SIZE } ;

		r += 1.0f ;

		Param.QuadrangleNum = posnum ;

		GrHandle = Graphics_Image_GetLineOneThicknessTexHandle( IS_PMA_DRAWBLENDMODE ) ;

		Param.GraphHandle = GrHandle ;

		LineThickness /= 2.0f ;
		LinePos[ 0 ] = r + LineThickness + 1.5f ;
		LinePos[ 1 ] = r - LineThickness - 2.5f ;

		for( i = 0; i < posnum + 1; i++ )
		{
			_TABLE_SINCOS( DX_TWO_PI_F * i / posnum, &Sin, &Cos ) ;

			PosX[ i ][ 0 ] = LinePos[ 0 ] * Cos + x ;
			PosX[ i ][ 1 ] = LinePos[ 1 ] * Cos + x ;

			PosY[ i ][ 0 ] = LinePos[ 0 ] * Sin + y ;
			PosY[ i ][ 1 ] = LinePos[ 1 ] * Sin + y ;
		}

		Vertex = ParamVertex ;
		for( i = 0; i < posnum ; i++ )
		{
			Vertex[ 0 ].x = PosX[ i + 1 ][ 0 ] ;	Vertex[ 0 ].y = PosY[ i + 1 ][ 0 ] ;
			Vertex[ 1 ].x = PosX[ i + 0 ][ 0 ] ;	Vertex[ 1 ].y = PosY[ i + 0 ][ 0 ] ;
			Vertex[ 2 ].x = PosX[ i + 1 ][ 1 ] ;	Vertex[ 2 ].y = PosY[ i + 1 ][ 1 ] ;
			Vertex[ 3 ].x = PosX[ i + 0 ][ 1 ] ;	Vertex[ 3 ].y = PosY[ i + 0 ][ 1 ] ;

			Vertex[ 0 ].u = LineUV_2[ 0 ] ;	Vertex[ 0 ].v = LineUV_2[ 1 ] ;
			Vertex[ 1 ].u = LineUV_2[ 0 ] ;	Vertex[ 1 ].v = LineUV_2[ 1 ] ;
			Vertex[ 2 ].u = LineUV_2[ 1 ] ;	Vertex[ 2 ].v = LineUV_2[ 1 ] ;
			Vertex[ 3 ].u = LineUV_2[ 1 ] ;	Vertex[ 3 ].v = LineUV_2[ 1 ] ;

			Vertex += 4 ;
		}
	}
	else
	{
		r += 0.5f ;

		Param.QuadrangleNum = posnum * 3 ;

		GrHandle = Graphics_Image_GetLineTexHandle( IS_PMA_DRAWBLENDMODE ) ;

		Param.GraphHandle = GrHandle ;

		LineThickness /= 2.0f ;
		LinePos[ 0 ] = r + LineThickness + 1.5f ;
		LinePos[ 1 ] = r + LineThickness - 1.5f ;
		LinePos[ 2 ] = r - LineThickness + 0.5f ;
		LinePos[ 3 ] = r - LineThickness - 2.5f ;

		for( i = 0; i < posnum + 1; i++ )
		{
			_TABLE_SINCOS( DX_TWO_PI_F * i / posnum, &Sin, &Cos ) ;

			PosX[ i ][ 0 ] = LinePos[ 0 ] * Cos + x ;
			PosX[ i ][ 1 ] = LinePos[ 1 ] * Cos + x ;
			PosX[ i ][ 2 ] = LinePos[ 2 ] * Cos + x ;
			PosX[ i ][ 3 ] = LinePos[ 3 ] * Cos + x ;

			PosY[ i ][ 0 ] = LinePos[ 0 ] * Sin + y ;
			PosY[ i ][ 1 ] = LinePos[ 1 ] * Sin + y ;
			PosY[ i ][ 2 ] = LinePos[ 2 ] * Sin + y ;
			PosY[ i ][ 3 ] = LinePos[ 3 ] * Sin + y ;
		}

		Vertex = ParamVertex ;
		for( i = 0; i < posnum ; i++ )
		{
			for( j = 0; j < 3 ; j++ )
			{
				Vertex[ 0 ].x = PosX[ i + 1 ][ j + 0 ] ;	Vertex[ 0 ].y = PosY[ i + 1 ][ j + 0 ] ;
				Vertex[ 1 ].x = PosX[ i + 0 ][ j + 0 ] ;	Vertex[ 1 ].y = PosY[ i + 0 ][ j + 0 ] ;
				Vertex[ 2 ].x = PosX[ i + 1 ][ j + 1 ] ;	Vertex[ 2 ].y = PosY[ i + 1 ][ j + 1 ] ;
				Vertex[ 3 ].x = PosX[ i + 0 ][ j + 1 ] ;	Vertex[ 3 ].y = PosY[ i + 0 ][ j + 1 ] ;

				Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ j + 0 ] ;
				Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ j + 0 ] ;
				Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ j + 1 ] ;
				Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ j + 1 ] ;

				Vertex += 4 ;
			}
		}
	}

	Graphics_Draw_DrawSimpleQuadrangleGraphF( &Param ) ;

	AA_DRAW_END

	Graphics_DrawSetting_SetDrawBrightToOneParam( OrigColor ) ;

	// I
	return 0 ;
}

// ~`悷( A`GCAXt )
static int DrawCircleFillAA( float x, float y, float r, int posnum, unsigned int Color )
{
	int GrHandle ;
	GRAPHICS_DRAW_DRAWSIMPLETRIANGLEGRAPHF_PARAM Param ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX ParamVertex[ CIRCLE_MAX_POSNUM * ( 6 + 3 ) ] ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX *Vertex ;
	float LinePos[ 2 ] ;
	int i ;
	float Sin, Cos ;
	static float LineUV[ 4 ] = { 0.0f, 3.0f / LINE_TEX_SIZE, 5.0f / LINE_TEX_SIZE, 1.0f };
	float PosX[ CIRCLE_MAX_POSNUM + 1 ][ 4 ];
	float PosY[ CIRCLE_MAX_POSNUM + 1 ][ 4 ];

	if( posnum > CIRCLE_MAX_POSNUM )
	{
		posnum = CIRCLE_MAX_POSNUM ;
	}

	r += 0.5f ;

	if( GSYS.HardInfo.DrawFloatCoordType != DX_DRAWFLOATCOORDTYPE_DIRECT3D9 )
	{
		x += 0.5f ;
		y += 0.5f ;
	}

	AA_DRAW_BEGIN
	AA_DRAW_BEGIN_2

	Param.Vertex      = ParamVertex ;
	Param.TransFlag   = TRUE ;
	Param.TriangleNum = posnum * 3 ;

	GrHandle = Graphics_Image_GetLineTexHandle( IS_PMA_DRAWBLENDMODE ) ;

	Param.GraphHandle = GrHandle ;

	LinePos[ 0 ] = r + 2.0f ;
	LinePos[ 1 ] = r - 1.0f ;

	for( i = 0; i < posnum + 1; i++ )
	{
		_TABLE_SINCOS( DX_TWO_PI_F * i / posnum, &Sin, &Cos ) ;

		PosX[ i ][ 0 ] = LinePos[ 0 ] * Cos + x ;
		PosX[ i ][ 1 ] = LinePos[ 1 ] * Cos + x ;

		PosY[ i ][ 0 ] = LinePos[ 0 ] * Sin + y ;
		PosY[ i ][ 1 ] = LinePos[ 1 ] * Sin + y ;
	}

	Vertex = ParamVertex ;
	for( i = 0; i < posnum ; i++ )
	{
		Vertex[ 0 ].x = PosX[ i + 1 ][ 0 ] ;	Vertex[ 0 ].y = PosY[ i + 1 ][ 0 ] ;
		Vertex[ 1 ].x = PosX[ i + 0 ][ 0 ] ;	Vertex[ 1 ].y = PosY[ i + 0 ][ 0 ] ;
		Vertex[ 2 ].x = PosX[ i + 1 ][ 1 ] ;	Vertex[ 2 ].y = PosY[ i + 1 ][ 1 ] ;
		Vertex[ 3 ].x = PosX[ i + 0 ][ 1 ] ;	Vertex[ 3 ].y = PosY[ i + 0 ][ 1 ] ;
		Vertex[ 4 ].x = PosX[ i + 1 ][ 1 ] ;	Vertex[ 4 ].y = PosY[ i + 1 ][ 1 ] ;
		Vertex[ 5 ].x = PosX[ i + 0 ][ 0 ] ;	Vertex[ 5 ].y = PosY[ i + 0 ][ 0 ] ;

		Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 0 ] ;
		Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ 0 ] ;
		Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;
		Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ 1 ] ;
		Vertex[ 4 ].u = LineUV[ 1 ] ;	Vertex[ 4 ].v = LineUV[ 1 ] ;
		Vertex[ 5 ].u = LineUV[ 1 ] ;	Vertex[ 5 ].v = LineUV[ 0 ] ;

		Vertex += 6 ;


		Vertex[ 0 ].x = PosX[ i + 1 ][ 1 ] ;	Vertex[ 0 ].y = PosY[ i + 1 ][ 1 ] ;
		Vertex[ 1 ].x = PosX[ i + 0 ][ 1 ] ;	Vertex[ 1 ].y = PosY[ i + 0 ][ 1 ] ;
		Vertex[ 2 ].x = x ;						Vertex[ 2 ].y = y ;

		Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 1 ] ;
		Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ 1 ] ;
		Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;

		Vertex += 3 ;
	}

	Graphics_Draw_DrawSimpleTriangleGraphF( &Param ) ;

	AA_DRAW_END

	Graphics_DrawSetting_SetDrawBrightToOneParam( OrigColor ) ;

	// I
	return 0 ;
}

// ~`悷( A`GCAXt )
extern int NS_DrawCircleAA( float x, float y, float r, int posnum, unsigned int Color, int FillFlag, float LineThickness )
{
	if( FillFlag == FALSE )
	{
		return DrawCircleLineAA( x, y, r, posnum, Color, LineThickness ) ;
	}
	else
	{
		return DrawCircleFillAA( x, y, r, posnum, Color ) ;
	}
}

// ȉ~`
#define SETDRAWRECTCODE\
	SETRECT( DrawRect, x - rx - 1, y - ry - 1, x + rx + 1, y + ry + 1 )\
	DRAWRECT_DRAWAREA_CLIP
extern	int NS_DrawOval( int x, int y, int rx, int ry, unsigned int Color, int FillFlag, int Thickness )
{
	int Ret = -1 ;
	int Flag ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;

	CheckActiveState() ;

	if( rx <= 0 || ry <= 0 ) return 0 ;

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	if( Thickness == 1 )
	{
		DRAW_DEF(
			Graphics_Hardware_DrawOval_PF( x, y, rx, ry, Color, FillFlag ),
			Graphics_Software_DrawOval(    x, y, rx, ry, Color, FillFlag ),
			SETDRAWRECTCODE,
			Ret,
			Flag
		)
	}
	else
	{
		DRAW_DEF(
			Graphics_Hardware_DrawOval_Thickness_PF( x, y, rx, ry, Color, Thickness ),
			Graphics_Software_DrawOval_Thickness(    x, y, rx, ry, Color, Thickness ),
			SETDRAWRECTCODE,
			Ret,
			Flag
		)
	}

	// I
	return Ret ;
}
#undef SETDRAWRECTCODE

// ȉ~`
#define SETDRAWRECTCODE\
	SETRECT( DrawRect, x1 - 1, y1 - 1, x2 + 1, y2 + 1 )\
	DRAWRECT_DRAWAREA_CLIP
extern	int NS_DrawOval_Rect( int x1, int y1, int x2, int y2, unsigned int Color, int FillFlag )
{
	int Ret = -1 ;
	int Flag ;
	int w, h ;
	int x, y ;
	int rx, ry ;
	int Rx_One_Minus ;
	int Ry_One_Minus ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;

	CheckActiveState() ;

	if( x1 >= x2 || y1 >= y2 ) return 0 ;

	w = x2 - x1 ;
	h = y2 - y1 ;
	x = x1 + w / 2 ;
	y = y1 + h / 2 ;
	rx = w / 2 ;
	ry = h / 2 ;
	Rx_One_Minus = ( w == rx * 2 ) ? TRUE : FALSE ;
	Ry_One_Minus = ( h == ry * 2 ) ? TRUE : FALSE ;

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	if( rx == ry )
	{
		DRAW_DEF(
			Graphics_Hardware_DrawCircle_PF( x, y, rx, Color, FillFlag, Rx_One_Minus, Ry_One_Minus ),
			Graphics_Software_DrawCircle(    x, y, rx, Color, FillFlag, Rx_One_Minus, Ry_One_Minus ),
			SETDRAWRECTCODE,
			Ret,
			Flag
		)
	}
	else
	{
		DRAW_DEF(
			Graphics_Hardware_DrawOval_PF( x, y, rx, ry, Color, FillFlag, Rx_One_Minus, Ry_One_Minus ),
			Graphics_Software_DrawOval(    x, y, rx, ry, Color, FillFlag, Rx_One_Minus, Ry_One_Minus ),
			SETDRAWRECTCODE,
			Ret,
			Flag
		)
	}

	// I
	return Ret ;
}
#undef SETDRAWRECTCODE

// ȉ~`悷( A`GCAXt )
static int DrawOvalLineAA( float x, float y, float rx, float ry, int posnum, unsigned int Color, float LineThickness )
{
	int GrHandle ;
	GRAPHICS_DRAW_DRAWSIMPLEQUADRANGLEGRAPHF_PARAM Param ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX ParamVertex[ CIRCLE_MAX_POSNUM * 3 * 4 ] ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX *Vertex ;
	float LinePosX[ 4 ] ;
	float LinePosY[ 4 ] ;
	int i ;
	int j ;
	float Sin, Cos ;
	static float LineUV[ 4 ] = { 0.0f, 3.0f / LINE_TEX_SIZE, 5.0f / LINE_TEX_SIZE, 1.0f };
	float PosX[ CIRCLE_MAX_POSNUM + 1 ][ 4 ];
	float PosY[ CIRCLE_MAX_POSNUM + 1 ][ 4 ];

	if( posnum > CIRCLE_MAX_POSNUM )
	{
		posnum = CIRCLE_MAX_POSNUM ;
	}

	if( GSYS.HardInfo.DrawFloatCoordType != DX_DRAWFLOATCOORDTYPE_DIRECT3D9 )
	{
		x += 0.5f ;
		y += 0.5f ;
	}

	AA_DRAW_BEGIN
	AA_DRAW_BEGIN_2

	Param.Vertex      = ParamVertex ;
	Param.TransFlag   = TRUE ;
	if( LineThickness <= 1.0f )
	{
		static float LineUV_2[ 2 ] = { 0.0f, 4.0f / LINE_TEX_SIZE } ;

		rx += 1.0f ;
		ry += 1.0f ;

		Param.QuadrangleNum = posnum ;

		GrHandle = Graphics_Image_GetLineOneThicknessTexHandle( IS_PMA_DRAWBLENDMODE ) ;

		Param.GraphHandle = GrHandle ;

		LineThickness /= 2.0f ;
		LinePosX[ 0 ] = rx + LineThickness + 1.5f ;
		LinePosX[ 1 ] = rx - LineThickness - 2.5f ;
		LinePosY[ 0 ] = ry + LineThickness + 1.5f ;
		LinePosY[ 1 ] = ry - LineThickness - 2.5f ;

		for( i = 0; i < posnum + 1; i++ )
		{
			_TABLE_SINCOS( DX_TWO_PI_F * i / posnum, &Sin, &Cos ) ;

			PosX[ i ][ 0 ] = LinePosX[ 0 ] * Cos + x ;
			PosX[ i ][ 1 ] = LinePosX[ 1 ] * Cos + x ;

			PosY[ i ][ 0 ] = LinePosY[ 0 ] * Sin + y ;
			PosY[ i ][ 1 ] = LinePosY[ 1 ] * Sin + y ;
		}

		Vertex = ParamVertex ;
		for( i = 0; i < posnum ; i++ )
		{
			Vertex[ 0 ].x = PosX[ i + 1 ][ 0 ] ;	Vertex[ 0 ].y = PosY[ i + 1 ][ 0 ] ;
			Vertex[ 1 ].x = PosX[ i + 0 ][ 0 ] ;	Vertex[ 1 ].y = PosY[ i + 0 ][ 0 ] ;
			Vertex[ 2 ].x = PosX[ i + 1 ][ 1 ] ;	Vertex[ 2 ].y = PosY[ i + 1 ][ 1 ] ;
			Vertex[ 3 ].x = PosX[ i + 0 ][ 1 ] ;	Vertex[ 3 ].y = PosY[ i + 0 ][ 1 ] ;

			Vertex[ 0 ].u = LineUV_2[ 0 ] ;	Vertex[ 0 ].v = LineUV_2[ 1 ] ;
			Vertex[ 1 ].u = LineUV_2[ 0 ] ;	Vertex[ 1 ].v = LineUV_2[ 1 ] ;
			Vertex[ 2 ].u = LineUV_2[ 1 ] ;	Vertex[ 2 ].v = LineUV_2[ 1 ] ;
			Vertex[ 3 ].u = LineUV_2[ 1 ] ;	Vertex[ 3 ].v = LineUV_2[ 1 ] ;

			Vertex += 4 ;
		}
	}
	else
	{
		rx += 0.5f ;
		ry += 0.5f ;

		Param.QuadrangleNum = posnum * 3 ;

		GrHandle = Graphics_Image_GetLineTexHandle( IS_PMA_DRAWBLENDMODE ) ;

		Param.GraphHandle = GrHandle ;

		LineThickness /= 2.0f ;
		LinePosX[ 0 ] = rx + LineThickness + 1.5f ;
		LinePosX[ 1 ] = rx + LineThickness - 1.5f ;
		LinePosX[ 2 ] = rx - LineThickness + 0.5f ;
		LinePosX[ 3 ] = rx - LineThickness - 2.5f ;
		LinePosY[ 0 ] = ry + LineThickness + 1.5f ;
		LinePosY[ 1 ] = ry + LineThickness - 1.5f ;
		LinePosY[ 2 ] = ry - LineThickness + 0.5f ;
		LinePosY[ 3 ] = ry - LineThickness - 2.5f ;

		for( i = 0; i < posnum + 1; i++ )
		{
			_TABLE_SINCOS( DX_TWO_PI_F * i / posnum, &Sin, &Cos ) ;

			PosX[ i ][ 0 ] = LinePosX[ 0 ] * Cos + x ;
			PosX[ i ][ 1 ] = LinePosX[ 1 ] * Cos + x ;
			PosX[ i ][ 2 ] = LinePosX[ 2 ] * Cos + x ;
			PosX[ i ][ 3 ] = LinePosX[ 3 ] * Cos + x ;

			PosY[ i ][ 0 ] = LinePosY[ 0 ] * Sin + y ;
			PosY[ i ][ 1 ] = LinePosY[ 1 ] * Sin + y ;
			PosY[ i ][ 2 ] = LinePosY[ 2 ] * Sin + y ;
			PosY[ i ][ 3 ] = LinePosY[ 3 ] * Sin + y ;
		}

		Vertex = ParamVertex ;
		for( i = 0; i < posnum ; i++ )
		{
			for( j = 0; j < 3 ; j++ )
			{
				Vertex[ 0 ].x = PosX[ i + 1 ][ j + 0 ] ;	Vertex[ 0 ].y = PosY[ i + 1 ][ j + 0 ] ;
				Vertex[ 1 ].x = PosX[ i + 0 ][ j + 0 ] ;	Vertex[ 1 ].y = PosY[ i + 0 ][ j + 0 ] ;
				Vertex[ 2 ].x = PosX[ i + 1 ][ j + 1 ] ;	Vertex[ 2 ].y = PosY[ i + 1 ][ j + 1 ] ;
				Vertex[ 3 ].x = PosX[ i + 0 ][ j + 1 ] ;	Vertex[ 3 ].y = PosY[ i + 0 ][ j + 1 ] ;

				Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ j + 0 ] ;
				Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ j + 0 ] ;
				Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ j + 1 ] ;
				Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ j + 1 ] ;

				Vertex += 4 ;
			}
		}
	}

	Graphics_Draw_DrawSimpleQuadrangleGraphF( &Param ) ;

	AA_DRAW_END

	Graphics_DrawSetting_SetDrawBrightToOneParam( OrigColor ) ;

	// I
	return 0 ;
}

// ȉ~`悷( A`GCAXt )
static int DrawOvalFillAA( float x, float y, float rx, float ry, int posnum, unsigned int Color )
{
	int GrHandle ;
	GRAPHICS_DRAW_DRAWSIMPLETRIANGLEGRAPHF_PARAM Param ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX ParamVertex[ CIRCLE_MAX_POSNUM * ( 6 + 3 ) ] ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX *Vertex ;
	float LinePosX[ 2 ] ;
	float LinePosY[ 2 ] ;
	int i ;
	float Sin, Cos ;
	static float LineUV[ 4 ] = { 0.0f, 3.0f / LINE_TEX_SIZE, 5.0f / LINE_TEX_SIZE, 1.0f };
	float PosX[ CIRCLE_MAX_POSNUM + 1 ][ 2 ];
	float PosY[ CIRCLE_MAX_POSNUM + 1 ][ 2 ];

	if( posnum > CIRCLE_MAX_POSNUM )
	{
		posnum = CIRCLE_MAX_POSNUM ;
	}

	rx += 0.5f ;
	ry += 0.5f ;

	if( GSYS.HardInfo.DrawFloatCoordType != DX_DRAWFLOATCOORDTYPE_DIRECT3D9 )
	{
		x += 0.5f ;
		y += 0.5f ;
	}

	AA_DRAW_BEGIN
	AA_DRAW_BEGIN_2

	Param.Vertex      = ParamVertex ;
	Param.TransFlag   = TRUE ;
	Param.TriangleNum = posnum * 3 ;

	GrHandle = Graphics_Image_GetLineTexHandle( IS_PMA_DRAWBLENDMODE ) ;

	Param.GraphHandle = GrHandle ;

	LinePosX[ 0 ] = rx + 2.0f ;
	LinePosX[ 1 ] = rx - 1.0f ;
	LinePosY[ 0 ] = ry + 2.0f ;
	LinePosY[ 1 ] = ry - 1.0f ;

	for( i = 0; i < posnum + 1; i++ )
	{
		_TABLE_SINCOS( DX_TWO_PI_F * i / posnum, &Sin, &Cos ) ;

		PosX[ i ][ 0 ] = LinePosX[ 0 ] * Cos + x ;
		PosX[ i ][ 1 ] = LinePosX[ 1 ] * Cos + x ;

		PosY[ i ][ 0 ] = LinePosY[ 0 ] * Sin + y ;
		PosY[ i ][ 1 ] = LinePosY[ 1 ] * Sin + y ;
	}

	Vertex = ParamVertex ;
	for( i = 0; i < posnum ; i++ )
	{
		Vertex[ 0 ].x = PosX[ i + 1 ][ 0 ] ;	Vertex[ 0 ].y = PosY[ i + 1 ][ 0 ] ;
		Vertex[ 1 ].x = PosX[ i + 0 ][ 0 ] ;	Vertex[ 1 ].y = PosY[ i + 0 ][ 0 ] ;
		Vertex[ 2 ].x = PosX[ i + 1 ][ 1 ] ;	Vertex[ 2 ].y = PosY[ i + 1 ][ 1 ] ;
		Vertex[ 3 ].x = PosX[ i + 0 ][ 1 ] ;	Vertex[ 3 ].y = PosY[ i + 0 ][ 1 ] ;
		Vertex[ 4 ].x = PosX[ i + 1 ][ 1 ] ;	Vertex[ 4 ].y = PosY[ i + 1 ][ 1 ] ;
		Vertex[ 5 ].x = PosX[ i + 0 ][ 0 ] ;	Vertex[ 5 ].y = PosY[ i + 0 ][ 0 ] ;

		Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 0 ] ;
		Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ 0 ] ;
		Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;
		Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ 1 ] ;
		Vertex[ 4 ].u = LineUV[ 1 ] ;	Vertex[ 4 ].v = LineUV[ 1 ] ;
		Vertex[ 5 ].u = LineUV[ 1 ] ;	Vertex[ 5 ].v = LineUV[ 0 ] ;

		Vertex += 6 ;


		Vertex[ 0 ].x = PosX[ i + 1 ][ 1 ] ;	Vertex[ 0 ].y = PosY[ i + 1 ][ 1 ] ;
		Vertex[ 1 ].x = PosX[ i + 0 ][ 1 ] ;	Vertex[ 1 ].y = PosY[ i + 0 ][ 1 ] ;
		Vertex[ 2 ].x = x ;						Vertex[ 2 ].y = y ;

		Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 1 ] ;
		Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ 1 ] ;
		Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;

		Vertex += 3 ;
	}

	Graphics_Draw_DrawSimpleTriangleGraphF( &Param ) ;

	AA_DRAW_END

	Graphics_DrawSetting_SetDrawBrightToOneParam( OrigColor ) ;

	// I
	return 0 ;
}

// ȉ~`悷( A`GCAXt )
extern int NS_DrawOvalAA( float x, float y, float rx, float ry, int posnum, unsigned int Color, int FillFlag, float LineThickness )
{
	if( FillFlag == FALSE )
	{
		return DrawOvalLineAA( x, y, rx, ry, posnum, Color, LineThickness ) ;
	}
	else
	{
		return DrawOvalFillAA( x, y, rx, ry, posnum, Color ) ;
	}
}

// Op`̕`
#define SETDRAWRECTCODE\
	int x[ 3 ], y[ 3 ], MaxX, MaxY, MinX, MinY ;\
	int i, ix, iy ;\
\
	x[ 0 ] = x1 ; x[ 1 ] = x2 ; x[ 2 ] = x3 ;\
	y[ 0 ] = y1 ; y[ 1 ] = y2 ; y[ 2 ] = y3 ;\
\
	MaxX = 0 ; MaxY = 0 ;\
	MinX = 0xffffff ; MinY = 0xffffff ;\
\
	for( i = 0 ; i < 3 ; i ++ )\
	{\
		ix = x[ i ] ; iy = y[ i ] ;\
		if( ix > MaxX ) MaxX = ix ; if( iy > MaxY ) MaxY = iy ;\
		if( ix < MinX ) MinX = ix ; if( iy < MinY ) MinY = iy ;\
	}\
\
	SETRECT( DrawRect, MinX, MinY, MaxX, MaxY ) ;\
	DRAWRECT_DRAWAREA_CLIP

extern	int NS_DrawTriangle( int x1, int y1, int x2, int y2, int x3, int y3, unsigned int Color, int FillFlag )
{
	int Ret = -1 ;
	int Flag ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;
	
	Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;

	CheckActiveState() ;

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawTriangle_PF( x1, y1, x2, y2, x3, y3, Color, FillFlag ),
		Graphics_Software_DrawTriangle(    x1, y1, x2, y2, x3, y3, Color, FillFlag ),
		SETDRAWRECTCODE,
		Ret,
		Flag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE

// Op`̕`悷( A`GCAXt )
static int DrawTriangleLineAA( float x1, float y1, float x2, float y2, float x3, float y3, unsigned int Color, float LineThickness )
{
	int GrHandle ;
	GRAPHICS_DRAW_DRAWSIMPLEQUADRANGLEGRAPHF_PARAM Param ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX ParamVertex[ ( 3 * 12 ) * 4 ] ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX *Vertex ;
	VECTOR V1Dir, V1Pos, V1Norm, V1Line[ 4 ] ;
	VECTOR V2Dir, V2Pos, V2Norm, V2Line[ 4 ] ;
	VECTOR V3Dir, V3Pos, V3Norm, V3Line[ 4 ] ;
	VECTOR V12Dir ;
	VECTOR V13Dir ;
	VECTOR VPosD[ 3 ][ 4 ][ 4 ] ;
	float Distance ;
	VECTOR TempPos ;
	float P1P2X ;
	float P1P2Y ;
	float P1P3X ;
	float P1P3Y ;
	float TempF ;
	float tmp1 ;
	float tmp2 ;
	float tmp3 ;
	float tmp4 ;
	float CmpDistance ;
	int i ;
	int n ;
	int NormalDraw = FALSE ;
	float SizeSq ;
	static float Line_Out_UV[ 4 ] = { 0.0f,                    4.0f / LINEBOX_TEX_SIZE, 12.0f / LINEBOX_TEX_SIZE, 1.0f } ;
	static float Line_In_UV[ 4 ]  = { 5.0f / LINEBOX_TEX_SIZE, 8.0f / LINEBOX_TEX_SIZE, 8.0f  / LINEBOX_TEX_SIZE, 11.0f / LINEBOX_TEX_SIZE } ;

	if( GSYS.HardInfo.DrawFloatCoordType == DX_DRAWFLOATCOORDTYPE_DIRECT3D9 )
	{
		x1 -= 0.5f ;
		y1 -= 0.5f ;
		x2 -= 0.5f ;
		y2 -= 0.5f ;
		x3 -= 0.5f ;
		y3 -= 0.5f ;
	}

	AA_DRAW_BEGIN
	AA_DRAW_BEGIN_2

	Param.Vertex      = ParamVertex ;
	Param.TransFlag   = TRUE ;
	if( LineThickness <= 1.0f )
	{
		Param.QuadrangleNum = 6 ;

		GrHandle = Graphics_Image_GetLineBoxOneThicknessTexHandle( IS_PMA_DRAWBLENDMODE ) ;

		Param.GraphHandle = GrHandle ;

		LineThickness /= 2.0f ;
		tmp1 = LineThickness + 1.5f ;
		tmp2 = LineThickness - 2.5f ;
		CmpDistance = LineThickness + 3.5f ;
		CmpDistance *= CmpDistance ;

		P1P2X = x2 - x1 ;
		P1P2Y = y2 - y1 ;

		P1P3X = x3 - x1 ;
		P1P3Y = y3 - y1 ;

		if( P1P2X * P1P3Y - P1P2Y * P1P3X < 0.0f )
		{
			TempF = x2 ; x2 = x3 ; x3 = TempF ;
			TempF = y2 ; y2 = y3 ; y3 = TempF ;
		}

		V1Pos.x  = x1 ;			V1Pos.y  = y1 ;			V1Pos.z  = 0.0f ;
		V1Dir.x  = x2 - x1 ;	V1Dir.y  = y2 - y1 ;	V1Dir.z  = 0.0f ;
		V12Dir = V1Dir;
		Distance = V1Dir.x * V1Dir.x + V1Dir.y * V1Dir.y ;
		if( Distance < CmpDistance )
		{
			NormalDraw = TRUE ;
			goto END ;
		}
		Distance = _SQRT( Distance ) ;
		V1Dir.x /= Distance ;
		V1Dir.y /= Distance ;
		V1Norm.x =  V1Dir.y ;
		V1Norm.y = -V1Dir.x ;
		V1Norm.z =  0.0f ;
		TempPos = VAdd( V1Pos, VScale( V1Norm, tmp1 ) ) ;
		V1Line[ 0 ].x =  V1Dir.y ;
		V1Line[ 0 ].y = -V1Dir.x ;
		V1Line[ 0 ].z = ( TempPos.x + V1Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V1Dir.y ) ;
		TempPos = VAdd( V1Pos, VScale( V1Norm, tmp2 ) ) ;
		V1Line[ 1 ].x =  V1Dir.y ;
		V1Line[ 1 ].y = -V1Dir.x ;
		V1Line[ 1 ].z = ( TempPos.x + V1Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V1Dir.y ) ;

		V2Pos.x  = x2 ;			V2Pos.y  = y2 ;			V2Pos.z  = 0.0f ;
		V2Dir.x  = x3 - x2 ;	V2Dir.y  = y3 - y2 ;	V2Dir.z  = 0.0f ;
		Distance = V2Dir.x * V2Dir.x + V2Dir.y * V2Dir.y ;
		if( Distance < CmpDistance )
		{
			NormalDraw = TRUE ;
			goto END ;
		}
		Distance = _SQRT( Distance ) ;
		V2Dir.x /= Distance ;
		V2Dir.y /= Distance ;
		V2Norm.x =  V2Dir.y ;
		V2Norm.y = -V2Dir.x ;
		V2Norm.z =  0.0f ;
		TempPos = VAdd( V2Pos, VScale( V2Norm, tmp1 ) ) ;
		V2Line[ 0 ].x =  V2Dir.y ;
		V2Line[ 0 ].y = -V2Dir.x ;
		V2Line[ 0 ].z = ( TempPos.x + V2Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V2Dir.y ) ;
		TempPos = VAdd( V2Pos, VScale( V2Norm, tmp2 ) ) ;
		V2Line[ 1 ].x =  V2Dir.y ;
		V2Line[ 1 ].y = -V2Dir.x ;
		V2Line[ 1 ].z = ( TempPos.x + V2Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V2Dir.y ) ;

		V13Dir.x = x3 - x1 ;    V13Dir.y = y3 - y1 ;	V13Dir.z = 0.0f ;
		SizeSq = VSquareSize( VCross( V12Dir, V13Dir ) ) ;
		if( SizeSq / 2.0f < 7500.0f )
		{
			NormalDraw = TRUE ;
			goto END ;
		}

		V3Pos.x  = x3 ;			V3Pos.y  = y3 ;			V3Pos.z  = 0.0f ;
		V3Dir.x  = x1 - x3 ;	V3Dir.y  = y1 - y3 ;	V3Dir.z  = 0.0f ;
		Distance = V3Dir.x * V3Dir.x + V3Dir.y * V3Dir.y ;
		if( Distance < CmpDistance )
		{
			NormalDraw = TRUE ;
			goto END ;
		}
		Distance = _SQRT( Distance ) ;
		V3Dir.x /= Distance ;
		V3Dir.y /= Distance ;
		V3Norm.x =  V3Dir.y ;
		V3Norm.y = -V3Dir.x ;
		V3Norm.z =  0.0f ;
		TempPos = VAdd( V3Pos, VScale( V3Norm, tmp1 ) ) ;
		V3Line[ 0 ].x =  V3Dir.y ;
		V3Line[ 0 ].y = -V3Dir.x ;
		V3Line[ 0 ].z = ( TempPos.x + V3Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V3Dir.y ) ;
		TempPos = VAdd( V3Pos, VScale( V3Norm, tmp2 ) ) ;
		V3Line[ 1 ].x =  V3Dir.y ;
		V3Line[ 1 ].y = -V3Dir.x ;
		V3Line[ 1 ].z = ( TempPos.x + V3Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V3Dir.y ) ;


		VPosD[ 0 ][ 0 ][ 0 ].x = ( V3Line[ 0 ].z * V1Line[ 0 ].y - V1Line[ 0 ].z * V3Line[ 0 ].y ) / ( V1Line[ 0 ].x * V3Line[ 0 ].y - V3Line[ 0 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 0 ][ 0 ][ 0 ].y = ( V1Line[ 0 ].x * V3Line[ 0 ].z - V1Line[ 0 ].z * V3Line[ 0 ].x ) / ( V1Line[ 0 ].y * V3Line[ 0 ].x - V1Line[ 0 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 0 ][ 0 ][ 1 ].x = ( V3Line[ 1 ].z * V1Line[ 0 ].y - V1Line[ 0 ].z * V3Line[ 1 ].y ) / ( V1Line[ 0 ].x * V3Line[ 1 ].y - V3Line[ 1 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 0 ][ 0 ][ 1 ].y = ( V1Line[ 0 ].x * V3Line[ 1 ].z - V1Line[ 0 ].z * V3Line[ 1 ].x ) / ( V1Line[ 0 ].y * V3Line[ 1 ].x - V1Line[ 0 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 0 ][ 1 ][ 0 ].x = ( V3Line[ 0 ].z * V1Line[ 1 ].y - V1Line[ 1 ].z * V3Line[ 0 ].y ) / ( V1Line[ 1 ].x * V3Line[ 0 ].y - V3Line[ 0 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 0 ][ 1 ][ 0 ].y = ( V1Line[ 1 ].x * V3Line[ 0 ].z - V1Line[ 1 ].z * V3Line[ 0 ].x ) / ( V1Line[ 1 ].y * V3Line[ 0 ].x - V1Line[ 1 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 0 ][ 1 ][ 1 ].x = ( V3Line[ 1 ].z * V1Line[ 1 ].y - V1Line[ 1 ].z * V3Line[ 1 ].y ) / ( V1Line[ 1 ].x * V3Line[ 1 ].y - V3Line[ 1 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 0 ][ 1 ][ 1 ].y = ( V1Line[ 1 ].x * V3Line[ 1 ].z - V1Line[ 1 ].z * V3Line[ 1 ].x ) / ( V1Line[ 1 ].y * V3Line[ 1 ].x - V1Line[ 1 ].x * V3Line[ 1 ].y ) ;

		VPosD[ 1 ][ 0 ][ 0 ].x = ( V1Line[ 0 ].z * V2Line[ 0 ].y - V2Line[ 0 ].z * V1Line[ 0 ].y ) / ( V2Line[ 0 ].x * V1Line[ 0 ].y - V1Line[ 0 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 1 ][ 0 ][ 0 ].y = ( V2Line[ 0 ].x * V1Line[ 0 ].z - V2Line[ 0 ].z * V1Line[ 0 ].x ) / ( V2Line[ 0 ].y * V1Line[ 0 ].x - V2Line[ 0 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 1 ][ 0 ][ 1 ].x = ( V1Line[ 1 ].z * V2Line[ 0 ].y - V2Line[ 0 ].z * V1Line[ 1 ].y ) / ( V2Line[ 0 ].x * V1Line[ 1 ].y - V1Line[ 1 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 1 ][ 0 ][ 1 ].y = ( V2Line[ 0 ].x * V1Line[ 1 ].z - V2Line[ 0 ].z * V1Line[ 1 ].x ) / ( V2Line[ 0 ].y * V1Line[ 1 ].x - V2Line[ 0 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 1 ][ 1 ][ 0 ].x = ( V1Line[ 0 ].z * V2Line[ 1 ].y - V2Line[ 1 ].z * V1Line[ 0 ].y ) / ( V2Line[ 1 ].x * V1Line[ 0 ].y - V1Line[ 0 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 1 ][ 1 ][ 0 ].y = ( V2Line[ 1 ].x * V1Line[ 0 ].z - V2Line[ 1 ].z * V1Line[ 0 ].x ) / ( V2Line[ 1 ].y * V1Line[ 0 ].x - V2Line[ 1 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 1 ][ 1 ][ 1 ].x = ( V1Line[ 1 ].z * V2Line[ 1 ].y - V2Line[ 1 ].z * V1Line[ 1 ].y ) / ( V2Line[ 1 ].x * V1Line[ 1 ].y - V1Line[ 1 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 1 ][ 1 ][ 1 ].y = ( V2Line[ 1 ].x * V1Line[ 1 ].z - V2Line[ 1 ].z * V1Line[ 1 ].x ) / ( V2Line[ 1 ].y * V1Line[ 1 ].x - V2Line[ 1 ].x * V1Line[ 1 ].y ) ;

		VPosD[ 2 ][ 0 ][ 0 ].x = ( V2Line[ 0 ].z * V3Line[ 0 ].y - V3Line[ 0 ].z * V2Line[ 0 ].y ) / ( V3Line[ 0 ].x * V2Line[ 0 ].y - V2Line[ 0 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 2 ][ 0 ][ 0 ].y = ( V3Line[ 0 ].x * V2Line[ 0 ].z - V3Line[ 0 ].z * V2Line[ 0 ].x ) / ( V3Line[ 0 ].y * V2Line[ 0 ].x - V3Line[ 0 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 2 ][ 0 ][ 1 ].x = ( V2Line[ 1 ].z * V3Line[ 0 ].y - V3Line[ 0 ].z * V2Line[ 1 ].y ) / ( V3Line[ 0 ].x * V2Line[ 1 ].y - V2Line[ 1 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 2 ][ 0 ][ 1 ].y = ( V3Line[ 0 ].x * V2Line[ 1 ].z - V3Line[ 0 ].z * V2Line[ 1 ].x ) / ( V3Line[ 0 ].y * V2Line[ 1 ].x - V3Line[ 0 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 2 ][ 1 ][ 0 ].x = ( V2Line[ 0 ].z * V3Line[ 1 ].y - V3Line[ 1 ].z * V2Line[ 0 ].y ) / ( V3Line[ 1 ].x * V2Line[ 0 ].y - V2Line[ 0 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 2 ][ 1 ][ 0 ].y = ( V3Line[ 1 ].x * V2Line[ 0 ].z - V3Line[ 1 ].z * V2Line[ 0 ].x ) / ( V3Line[ 1 ].y * V2Line[ 0 ].x - V3Line[ 1 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 2 ][ 1 ][ 1 ].x = ( V2Line[ 1 ].z * V3Line[ 1 ].y - V3Line[ 1 ].z * V2Line[ 1 ].y ) / ( V3Line[ 1 ].x * V2Line[ 1 ].y - V2Line[ 1 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 2 ][ 1 ][ 1 ].y = ( V3Line[ 1 ].x * V2Line[ 1 ].z - V3Line[ 1 ].z * V2Line[ 1 ].x ) / ( V3Line[ 1 ].y * V2Line[ 1 ].x - V3Line[ 1 ].x * V2Line[ 1 ].y ) ;

		Vertex = ParamVertex ;
		n = 1 ;
		for( i = 0 ; i < 3 ; i++ )
		{
			Vertex[ 0 ].x = VPosD[ i ][ 0 ][ 1 ].x ;
			Vertex[ 0 ].y = VPosD[ i ][ 0 ][ 1 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 0 ][ 0 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 0 ][ 0 ].y ;
			Vertex[ 2 ].x = VPosD[ i ][ 1 ][ 1 ].x ;
			Vertex[ 2 ].y = VPosD[ i ][ 1 ][ 1 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 1 ][ 0 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 1 ][ 0 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 0 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 0 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;



			Vertex[ 0 ].x = VPosD[ n ][ 1 ][ 0 ].x ;
			Vertex[ 0 ].y = VPosD[ n ][ 1 ][ 0 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 0 ][ 1 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 0 ][ 1 ].y ;
			Vertex[ 2 ].x = VPosD[ n ][ 1 ][ 1 ].x ;
			Vertex[ 2 ].y = VPosD[ n ][ 1 ][ 1 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 1 ][ 1 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 1 ][ 1 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;


			n = n == 2 ? 0 : n + 1 ;
		}
	}
	else
	{
		Param.QuadrangleNum = 3 * 12 ;

		GrHandle = Graphics_Image_GetLineBoxTexHandle( IS_PMA_DRAWBLENDMODE ) ;

		Param.GraphHandle = GrHandle ;

		LineThickness /= 2.0f ;
		tmp1 =  LineThickness + 1.5f ;
		tmp2 =  LineThickness - 2.5f ;
		tmp3 = -LineThickness + 1.5f ;
		tmp4 = -LineThickness - 2.5f ;
		CmpDistance = LineThickness * 2.0f + 6.0f ;
		CmpDistance *= CmpDistance ;

		P1P2X = x2 - x1 ;
		P1P2Y = y2 - y1 ;

		P1P3X = x3 - x1 ;
		P1P3Y = y3 - y1 ;

		if( P1P2X * P1P3Y - P1P2Y * P1P3X < 0.0f )
		{
			TempF = x2 ; x2 = x3 ; x3 = TempF ;
			TempF = y2 ; y2 = y3 ; y3 = TempF ;
		}

		V1Pos.x  = x1 ;			V1Pos.y  = y1 ;			V1Pos.z  = 0.0f ;
		V1Dir.x  = x2 - x1 ;	V1Dir.y  = y2 - y1 ;	V1Dir.z  = 0.0f ;
		V12Dir = V1Dir;
		Distance = V1Dir.x * V1Dir.x + V1Dir.y * V1Dir.y ;
		if( Distance < CmpDistance )
		{
			NormalDraw = TRUE ;
			goto END ;
		}
		Distance = _SQRT( Distance ) ;
		V1Dir.x /= Distance ;
		V1Dir.y /= Distance ;
		V1Norm.x =  V1Dir.y ;
		V1Norm.y = -V1Dir.x ;
		V1Norm.z =  0.0f ;
		TempPos = VAdd( V1Pos, VScale( V1Norm, tmp1 ) ) ;
		V1Line[ 0 ].x =  V1Dir.y ;
		V1Line[ 0 ].y = -V1Dir.x ;
		V1Line[ 0 ].z = ( TempPos.x + V1Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V1Dir.y ) ;
		TempPos = VAdd( V1Pos, VScale( V1Norm, tmp2 ) ) ;
		V1Line[ 1 ].x =  V1Dir.y ;
		V1Line[ 1 ].y = -V1Dir.x ;
		V1Line[ 1 ].z = ( TempPos.x + V1Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V1Dir.y ) ;
		TempPos = VAdd( V1Pos, VScale( V1Norm, tmp3 ) ) ;
		V1Line[ 2 ].x =  V1Dir.y ;
		V1Line[ 2 ].y = -V1Dir.x ;
		V1Line[ 2 ].z = ( TempPos.x + V1Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V1Dir.y ) ;
		TempPos = VAdd( V1Pos, VScale( V1Norm, tmp4 ) ) ;
		V1Line[ 3 ].x =  V1Dir.y ;
		V1Line[ 3 ].y = -V1Dir.x ;
		V1Line[ 3 ].z = ( TempPos.x + V1Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V1Dir.y ) ;

		V2Pos.x  = x2 ;			V2Pos.y  = y2 ;			V2Pos.z  = 0.0f ;
		V2Dir.x  = x3 - x2 ;	V2Dir.y  = y3 - y2 ;	V2Dir.z  = 0.0f ;
		Distance = V2Dir.x * V2Dir.x + V2Dir.y * V2Dir.y ;
		if( Distance < CmpDistance )
		{
			NormalDraw = TRUE ;
			goto END ;
		}
		Distance = _SQRT( Distance ) ;
		V2Dir.x /= Distance ;
		V2Dir.y /= Distance ;
		V2Norm.x =  V2Dir.y ;
		V2Norm.y = -V2Dir.x ;
		V2Norm.z =  0.0f ;
		TempPos = VAdd( V2Pos, VScale( V2Norm, tmp1 ) ) ;
		V2Line[ 0 ].x =  V2Dir.y ;
		V2Line[ 0 ].y = -V2Dir.x ;
		V2Line[ 0 ].z = ( TempPos.x + V2Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V2Dir.y ) ;
		TempPos = VAdd( V2Pos, VScale( V2Norm, tmp2 ) ) ;
		V2Line[ 1 ].x =  V2Dir.y ;
		V2Line[ 1 ].y = -V2Dir.x ;
		V2Line[ 1 ].z = ( TempPos.x + V2Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V2Dir.y ) ;
		TempPos = VAdd( V2Pos, VScale( V2Norm, tmp3 ) ) ;
		V2Line[ 2 ].x =  V2Dir.y ;
		V2Line[ 2 ].y = -V2Dir.x ;
		V2Line[ 2 ].z = ( TempPos.x + V2Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V2Dir.y ) ;
		TempPos = VAdd( V2Pos, VScale( V2Norm, tmp4 ) ) ;
		V2Line[ 3 ].x =  V2Dir.y ;
		V2Line[ 3 ].y = -V2Dir.x ;
		V2Line[ 3 ].z = ( TempPos.x + V2Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V2Dir.y ) ;

		V13Dir.x = x3 - x1 ;    V13Dir.y = y3 - y1 ;	V13Dir.z = 0.0f ;
		SizeSq = VSquareSize( VCross( V12Dir, V13Dir ) ) ;
		if( SizeSq / 2.0f < 7500.0f )
		{
			NormalDraw = TRUE ;
			goto END ;
		}

		V3Pos.x  = x3 ;			V3Pos.y  = y3 ;			V3Pos.z  = 0.0f ;
		V3Dir.x  = x1 - x3 ;	V3Dir.y  = y1 - y3 ;	V3Dir.z  = 0.0f ;
		Distance = V3Dir.x * V3Dir.x + V3Dir.y * V3Dir.y ;
		if( Distance < CmpDistance )
		{
			NormalDraw = TRUE ;
			goto END ;
		}
		Distance = _SQRT( Distance ) ;
		V3Dir.x /= Distance ;
		V3Dir.y /= Distance ;
		V3Norm.x =  V3Dir.y ;
		V3Norm.y = -V3Dir.x ;
		V3Norm.z =  0.0f ;
		TempPos = VAdd( V3Pos, VScale( V3Norm, tmp1 ) ) ;
		V3Line[ 0 ].x =  V3Dir.y ;
		V3Line[ 0 ].y = -V3Dir.x ;
		V3Line[ 0 ].z = ( TempPos.x + V3Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V3Dir.y ) ;
		TempPos = VAdd( V3Pos, VScale( V3Norm, tmp2 ) ) ;
		V3Line[ 1 ].x =  V3Dir.y ;
		V3Line[ 1 ].y = -V3Dir.x ;
		V3Line[ 1 ].z = ( TempPos.x + V3Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V3Dir.y ) ;
		TempPos = VAdd( V3Pos, VScale( V3Norm, tmp3 ) ) ;
		V3Line[ 2 ].x =  V3Dir.y ;
		V3Line[ 2 ].y = -V3Dir.x ;
		V3Line[ 2 ].z = ( TempPos.x + V3Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V3Dir.y ) ;
		TempPos = VAdd( V3Pos, VScale( V3Norm, tmp4 ) ) ;
		V3Line[ 3 ].x =  V3Dir.y ;
		V3Line[ 3 ].y = -V3Dir.x ;
		V3Line[ 3 ].z = ( TempPos.x + V3Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V3Dir.y ) ;


		VPosD[ 0 ][ 0 ][ 0 ].x = ( V3Line[ 0 ].z * V1Line[ 0 ].y - V1Line[ 0 ].z * V3Line[ 0 ].y ) / ( V1Line[ 0 ].x * V3Line[ 0 ].y - V3Line[ 0 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 0 ][ 0 ][ 0 ].y = ( V1Line[ 0 ].x * V3Line[ 0 ].z - V1Line[ 0 ].z * V3Line[ 0 ].x ) / ( V1Line[ 0 ].y * V3Line[ 0 ].x - V1Line[ 0 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 0 ][ 0 ][ 1 ].x = ( V3Line[ 1 ].z * V1Line[ 0 ].y - V1Line[ 0 ].z * V3Line[ 1 ].y ) / ( V1Line[ 0 ].x * V3Line[ 1 ].y - V3Line[ 1 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 0 ][ 0 ][ 1 ].y = ( V1Line[ 0 ].x * V3Line[ 1 ].z - V1Line[ 0 ].z * V3Line[ 1 ].x ) / ( V1Line[ 0 ].y * V3Line[ 1 ].x - V1Line[ 0 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 0 ][ 0 ][ 2 ].x = ( V3Line[ 2 ].z * V1Line[ 0 ].y - V1Line[ 0 ].z * V3Line[ 2 ].y ) / ( V1Line[ 0 ].x * V3Line[ 2 ].y - V3Line[ 2 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 0 ][ 0 ][ 2 ].y = ( V1Line[ 0 ].x * V3Line[ 2 ].z - V1Line[ 0 ].z * V3Line[ 2 ].x ) / ( V1Line[ 0 ].y * V3Line[ 2 ].x - V1Line[ 0 ].x * V3Line[ 2 ].y ) ;
		VPosD[ 0 ][ 0 ][ 3 ].x = ( V3Line[ 3 ].z * V1Line[ 0 ].y - V1Line[ 0 ].z * V3Line[ 3 ].y ) / ( V1Line[ 0 ].x * V3Line[ 3 ].y - V3Line[ 3 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 0 ][ 0 ][ 3 ].y = ( V1Line[ 0 ].x * V3Line[ 3 ].z - V1Line[ 0 ].z * V3Line[ 3 ].x ) / ( V1Line[ 0 ].y * V3Line[ 3 ].x - V1Line[ 0 ].x * V3Line[ 3 ].y ) ;
		VPosD[ 0 ][ 1 ][ 0 ].x = ( V3Line[ 0 ].z * V1Line[ 1 ].y - V1Line[ 1 ].z * V3Line[ 0 ].y ) / ( V1Line[ 1 ].x * V3Line[ 0 ].y - V3Line[ 0 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 0 ][ 1 ][ 0 ].y = ( V1Line[ 1 ].x * V3Line[ 0 ].z - V1Line[ 1 ].z * V3Line[ 0 ].x ) / ( V1Line[ 1 ].y * V3Line[ 0 ].x - V1Line[ 1 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 0 ][ 1 ][ 1 ].x = ( V3Line[ 1 ].z * V1Line[ 1 ].y - V1Line[ 1 ].z * V3Line[ 1 ].y ) / ( V1Line[ 1 ].x * V3Line[ 1 ].y - V3Line[ 1 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 0 ][ 1 ][ 1 ].y = ( V1Line[ 1 ].x * V3Line[ 1 ].z - V1Line[ 1 ].z * V3Line[ 1 ].x ) / ( V1Line[ 1 ].y * V3Line[ 1 ].x - V1Line[ 1 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 0 ][ 1 ][ 2 ].x = ( V3Line[ 2 ].z * V1Line[ 1 ].y - V1Line[ 1 ].z * V3Line[ 2 ].y ) / ( V1Line[ 1 ].x * V3Line[ 2 ].y - V3Line[ 2 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 0 ][ 1 ][ 2 ].y = ( V1Line[ 1 ].x * V3Line[ 2 ].z - V1Line[ 1 ].z * V3Line[ 2 ].x ) / ( V1Line[ 1 ].y * V3Line[ 2 ].x - V1Line[ 1 ].x * V3Line[ 2 ].y ) ;
		VPosD[ 0 ][ 1 ][ 3 ].x = ( V3Line[ 3 ].z * V1Line[ 1 ].y - V1Line[ 1 ].z * V3Line[ 3 ].y ) / ( V1Line[ 1 ].x * V3Line[ 3 ].y - V3Line[ 3 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 0 ][ 1 ][ 3 ].y = ( V1Line[ 1 ].x * V3Line[ 3 ].z - V1Line[ 1 ].z * V3Line[ 3 ].x ) / ( V1Line[ 1 ].y * V3Line[ 3 ].x - V1Line[ 1 ].x * V3Line[ 3 ].y ) ;
		VPosD[ 0 ][ 2 ][ 0 ].x = ( V3Line[ 0 ].z * V1Line[ 2 ].y - V1Line[ 2 ].z * V3Line[ 0 ].y ) / ( V1Line[ 2 ].x * V3Line[ 0 ].y - V3Line[ 0 ].x * V1Line[ 2 ].y ) ;
		VPosD[ 0 ][ 2 ][ 0 ].y = ( V1Line[ 2 ].x * V3Line[ 0 ].z - V1Line[ 2 ].z * V3Line[ 0 ].x ) / ( V1Line[ 2 ].y * V3Line[ 0 ].x - V1Line[ 2 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 0 ][ 2 ][ 1 ].x = ( V3Line[ 1 ].z * V1Line[ 2 ].y - V1Line[ 2 ].z * V3Line[ 1 ].y ) / ( V1Line[ 2 ].x * V3Line[ 1 ].y - V3Line[ 1 ].x * V1Line[ 2 ].y ) ;
		VPosD[ 0 ][ 2 ][ 1 ].y = ( V1Line[ 2 ].x * V3Line[ 1 ].z - V1Line[ 2 ].z * V3Line[ 1 ].x ) / ( V1Line[ 2 ].y * V3Line[ 1 ].x - V1Line[ 2 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 0 ][ 2 ][ 2 ].x = ( V3Line[ 2 ].z * V1Line[ 2 ].y - V1Line[ 2 ].z * V3Line[ 2 ].y ) / ( V1Line[ 2 ].x * V3Line[ 2 ].y - V3Line[ 2 ].x * V1Line[ 2 ].y ) ;
		VPosD[ 0 ][ 2 ][ 2 ].y = ( V1Line[ 2 ].x * V3Line[ 2 ].z - V1Line[ 2 ].z * V3Line[ 2 ].x ) / ( V1Line[ 2 ].y * V3Line[ 2 ].x - V1Line[ 2 ].x * V3Line[ 2 ].y ) ;
		VPosD[ 0 ][ 2 ][ 3 ].x = ( V3Line[ 3 ].z * V1Line[ 2 ].y - V1Line[ 2 ].z * V3Line[ 3 ].y ) / ( V1Line[ 2 ].x * V3Line[ 3 ].y - V3Line[ 3 ].x * V1Line[ 2 ].y ) ;
		VPosD[ 0 ][ 2 ][ 3 ].y = ( V1Line[ 2 ].x * V3Line[ 3 ].z - V1Line[ 2 ].z * V3Line[ 3 ].x ) / ( V1Line[ 2 ].y * V3Line[ 3 ].x - V1Line[ 2 ].x * V3Line[ 3 ].y ) ;
		VPosD[ 0 ][ 3 ][ 0 ].x = ( V3Line[ 0 ].z * V1Line[ 3 ].y - V1Line[ 3 ].z * V3Line[ 0 ].y ) / ( V1Line[ 3 ].x * V3Line[ 0 ].y - V3Line[ 0 ].x * V1Line[ 3 ].y ) ;
		VPosD[ 0 ][ 3 ][ 0 ].y = ( V1Line[ 3 ].x * V3Line[ 0 ].z - V1Line[ 3 ].z * V3Line[ 0 ].x ) / ( V1Line[ 3 ].y * V3Line[ 0 ].x - V1Line[ 3 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 0 ][ 3 ][ 1 ].x = ( V3Line[ 1 ].z * V1Line[ 3 ].y - V1Line[ 3 ].z * V3Line[ 1 ].y ) / ( V1Line[ 3 ].x * V3Line[ 1 ].y - V3Line[ 1 ].x * V1Line[ 3 ].y ) ;
		VPosD[ 0 ][ 3 ][ 1 ].y = ( V1Line[ 3 ].x * V3Line[ 1 ].z - V1Line[ 3 ].z * V3Line[ 1 ].x ) / ( V1Line[ 3 ].y * V3Line[ 1 ].x - V1Line[ 3 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 0 ][ 3 ][ 2 ].x = ( V3Line[ 2 ].z * V1Line[ 3 ].y - V1Line[ 3 ].z * V3Line[ 2 ].y ) / ( V1Line[ 3 ].x * V3Line[ 2 ].y - V3Line[ 2 ].x * V1Line[ 3 ].y ) ;
		VPosD[ 0 ][ 3 ][ 2 ].y = ( V1Line[ 3 ].x * V3Line[ 2 ].z - V1Line[ 3 ].z * V3Line[ 2 ].x ) / ( V1Line[ 3 ].y * V3Line[ 2 ].x - V1Line[ 3 ].x * V3Line[ 2 ].y ) ;
		VPosD[ 0 ][ 3 ][ 3 ].x = ( V3Line[ 3 ].z * V1Line[ 3 ].y - V1Line[ 3 ].z * V3Line[ 3 ].y ) / ( V1Line[ 3 ].x * V3Line[ 3 ].y - V3Line[ 3 ].x * V1Line[ 3 ].y ) ;
		VPosD[ 0 ][ 3 ][ 3 ].y = ( V1Line[ 3 ].x * V3Line[ 3 ].z - V1Line[ 3 ].z * V3Line[ 3 ].x ) / ( V1Line[ 3 ].y * V3Line[ 3 ].x - V1Line[ 3 ].x * V3Line[ 3 ].y ) ;

		VPosD[ 1 ][ 0 ][ 0 ].x = ( V1Line[ 0 ].z * V2Line[ 0 ].y - V2Line[ 0 ].z * V1Line[ 0 ].y ) / ( V2Line[ 0 ].x * V1Line[ 0 ].y - V1Line[ 0 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 1 ][ 0 ][ 0 ].y = ( V2Line[ 0 ].x * V1Line[ 0 ].z - V2Line[ 0 ].z * V1Line[ 0 ].x ) / ( V2Line[ 0 ].y * V1Line[ 0 ].x - V2Line[ 0 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 1 ][ 0 ][ 1 ].x = ( V1Line[ 1 ].z * V2Line[ 0 ].y - V2Line[ 0 ].z * V1Line[ 1 ].y ) / ( V2Line[ 0 ].x * V1Line[ 1 ].y - V1Line[ 1 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 1 ][ 0 ][ 1 ].y = ( V2Line[ 0 ].x * V1Line[ 1 ].z - V2Line[ 0 ].z * V1Line[ 1 ].x ) / ( V2Line[ 0 ].y * V1Line[ 1 ].x - V2Line[ 0 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 1 ][ 0 ][ 2 ].x = ( V1Line[ 2 ].z * V2Line[ 0 ].y - V2Line[ 0 ].z * V1Line[ 2 ].y ) / ( V2Line[ 0 ].x * V1Line[ 2 ].y - V1Line[ 2 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 1 ][ 0 ][ 2 ].y = ( V2Line[ 0 ].x * V1Line[ 2 ].z - V2Line[ 0 ].z * V1Line[ 2 ].x ) / ( V2Line[ 0 ].y * V1Line[ 2 ].x - V2Line[ 0 ].x * V1Line[ 2 ].y ) ;
		VPosD[ 1 ][ 0 ][ 3 ].x = ( V1Line[ 3 ].z * V2Line[ 0 ].y - V2Line[ 0 ].z * V1Line[ 3 ].y ) / ( V2Line[ 0 ].x * V1Line[ 3 ].y - V1Line[ 3 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 1 ][ 0 ][ 3 ].y = ( V2Line[ 0 ].x * V1Line[ 3 ].z - V2Line[ 0 ].z * V1Line[ 3 ].x ) / ( V2Line[ 0 ].y * V1Line[ 3 ].x - V2Line[ 0 ].x * V1Line[ 3 ].y ) ;
		VPosD[ 1 ][ 1 ][ 0 ].x = ( V1Line[ 0 ].z * V2Line[ 1 ].y - V2Line[ 1 ].z * V1Line[ 0 ].y ) / ( V2Line[ 1 ].x * V1Line[ 0 ].y - V1Line[ 0 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 1 ][ 1 ][ 0 ].y = ( V2Line[ 1 ].x * V1Line[ 0 ].z - V2Line[ 1 ].z * V1Line[ 0 ].x ) / ( V2Line[ 1 ].y * V1Line[ 0 ].x - V2Line[ 1 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 1 ][ 1 ][ 1 ].x = ( V1Line[ 1 ].z * V2Line[ 1 ].y - V2Line[ 1 ].z * V1Line[ 1 ].y ) / ( V2Line[ 1 ].x * V1Line[ 1 ].y - V1Line[ 1 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 1 ][ 1 ][ 1 ].y = ( V2Line[ 1 ].x * V1Line[ 1 ].z - V2Line[ 1 ].z * V1Line[ 1 ].x ) / ( V2Line[ 1 ].y * V1Line[ 1 ].x - V2Line[ 1 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 1 ][ 1 ][ 2 ].x = ( V1Line[ 2 ].z * V2Line[ 1 ].y - V2Line[ 1 ].z * V1Line[ 2 ].y ) / ( V2Line[ 1 ].x * V1Line[ 2 ].y - V1Line[ 2 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 1 ][ 1 ][ 2 ].y = ( V2Line[ 1 ].x * V1Line[ 2 ].z - V2Line[ 1 ].z * V1Line[ 2 ].x ) / ( V2Line[ 1 ].y * V1Line[ 2 ].x - V2Line[ 1 ].x * V1Line[ 2 ].y ) ;
		VPosD[ 1 ][ 1 ][ 3 ].x = ( V1Line[ 3 ].z * V2Line[ 1 ].y - V2Line[ 1 ].z * V1Line[ 3 ].y ) / ( V2Line[ 1 ].x * V1Line[ 3 ].y - V1Line[ 3 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 1 ][ 1 ][ 3 ].y = ( V2Line[ 1 ].x * V1Line[ 3 ].z - V2Line[ 1 ].z * V1Line[ 3 ].x ) / ( V2Line[ 1 ].y * V1Line[ 3 ].x - V2Line[ 1 ].x * V1Line[ 3 ].y ) ;
		VPosD[ 1 ][ 2 ][ 0 ].x = ( V1Line[ 0 ].z * V2Line[ 2 ].y - V2Line[ 2 ].z * V1Line[ 0 ].y ) / ( V2Line[ 2 ].x * V1Line[ 0 ].y - V1Line[ 0 ].x * V2Line[ 2 ].y ) ;
		VPosD[ 1 ][ 2 ][ 0 ].y = ( V2Line[ 2 ].x * V1Line[ 0 ].z - V2Line[ 2 ].z * V1Line[ 0 ].x ) / ( V2Line[ 2 ].y * V1Line[ 0 ].x - V2Line[ 2 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 1 ][ 2 ][ 1 ].x = ( V1Line[ 1 ].z * V2Line[ 2 ].y - V2Line[ 2 ].z * V1Line[ 1 ].y ) / ( V2Line[ 2 ].x * V1Line[ 1 ].y - V1Line[ 1 ].x * V2Line[ 2 ].y ) ;
		VPosD[ 1 ][ 2 ][ 1 ].y = ( V2Line[ 2 ].x * V1Line[ 1 ].z - V2Line[ 2 ].z * V1Line[ 1 ].x ) / ( V2Line[ 2 ].y * V1Line[ 1 ].x - V2Line[ 2 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 1 ][ 2 ][ 2 ].x = ( V1Line[ 2 ].z * V2Line[ 2 ].y - V2Line[ 2 ].z * V1Line[ 2 ].y ) / ( V2Line[ 2 ].x * V1Line[ 2 ].y - V1Line[ 2 ].x * V2Line[ 2 ].y ) ;
		VPosD[ 1 ][ 2 ][ 2 ].y = ( V2Line[ 2 ].x * V1Line[ 2 ].z - V2Line[ 2 ].z * V1Line[ 2 ].x ) / ( V2Line[ 2 ].y * V1Line[ 2 ].x - V2Line[ 2 ].x * V1Line[ 2 ].y ) ;
		VPosD[ 1 ][ 2 ][ 3 ].x = ( V1Line[ 3 ].z * V2Line[ 2 ].y - V2Line[ 2 ].z * V1Line[ 3 ].y ) / ( V2Line[ 2 ].x * V1Line[ 3 ].y - V1Line[ 3 ].x * V2Line[ 2 ].y ) ;
		VPosD[ 1 ][ 2 ][ 3 ].y = ( V2Line[ 2 ].x * V1Line[ 3 ].z - V2Line[ 2 ].z * V1Line[ 3 ].x ) / ( V2Line[ 2 ].y * V1Line[ 3 ].x - V2Line[ 2 ].x * V1Line[ 3 ].y ) ;
		VPosD[ 1 ][ 3 ][ 0 ].x = ( V1Line[ 0 ].z * V2Line[ 3 ].y - V2Line[ 3 ].z * V1Line[ 0 ].y ) / ( V2Line[ 3 ].x * V1Line[ 0 ].y - V1Line[ 0 ].x * V2Line[ 3 ].y ) ;
		VPosD[ 1 ][ 3 ][ 0 ].y = ( V2Line[ 3 ].x * V1Line[ 0 ].z - V2Line[ 3 ].z * V1Line[ 0 ].x ) / ( V2Line[ 3 ].y * V1Line[ 0 ].x - V2Line[ 3 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 1 ][ 3 ][ 1 ].x = ( V1Line[ 1 ].z * V2Line[ 3 ].y - V2Line[ 3 ].z * V1Line[ 1 ].y ) / ( V2Line[ 3 ].x * V1Line[ 1 ].y - V1Line[ 1 ].x * V2Line[ 3 ].y ) ;
		VPosD[ 1 ][ 3 ][ 1 ].y = ( V2Line[ 3 ].x * V1Line[ 1 ].z - V2Line[ 3 ].z * V1Line[ 1 ].x ) / ( V2Line[ 3 ].y * V1Line[ 1 ].x - V2Line[ 3 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 1 ][ 3 ][ 2 ].x = ( V1Line[ 2 ].z * V2Line[ 3 ].y - V2Line[ 3 ].z * V1Line[ 2 ].y ) / ( V2Line[ 3 ].x * V1Line[ 2 ].y - V1Line[ 2 ].x * V2Line[ 3 ].y ) ;
		VPosD[ 1 ][ 3 ][ 2 ].y = ( V2Line[ 3 ].x * V1Line[ 2 ].z - V2Line[ 3 ].z * V1Line[ 2 ].x ) / ( V2Line[ 3 ].y * V1Line[ 2 ].x - V2Line[ 3 ].x * V1Line[ 2 ].y ) ;
		VPosD[ 1 ][ 3 ][ 3 ].x = ( V1Line[ 3 ].z * V2Line[ 3 ].y - V2Line[ 3 ].z * V1Line[ 3 ].y ) / ( V2Line[ 3 ].x * V1Line[ 3 ].y - V1Line[ 3 ].x * V2Line[ 3 ].y ) ;
		VPosD[ 1 ][ 3 ][ 3 ].y = ( V2Line[ 3 ].x * V1Line[ 3 ].z - V2Line[ 3 ].z * V1Line[ 3 ].x ) / ( V2Line[ 3 ].y * V1Line[ 3 ].x - V2Line[ 3 ].x * V1Line[ 3 ].y ) ;

		VPosD[ 2 ][ 0 ][ 0 ].x = ( V2Line[ 0 ].z * V3Line[ 0 ].y - V3Line[ 0 ].z * V2Line[ 0 ].y ) / ( V3Line[ 0 ].x * V2Line[ 0 ].y - V2Line[ 0 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 2 ][ 0 ][ 0 ].y = ( V3Line[ 0 ].x * V2Line[ 0 ].z - V3Line[ 0 ].z * V2Line[ 0 ].x ) / ( V3Line[ 0 ].y * V2Line[ 0 ].x - V3Line[ 0 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 2 ][ 0 ][ 1 ].x = ( V2Line[ 1 ].z * V3Line[ 0 ].y - V3Line[ 0 ].z * V2Line[ 1 ].y ) / ( V3Line[ 0 ].x * V2Line[ 1 ].y - V2Line[ 1 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 2 ][ 0 ][ 1 ].y = ( V3Line[ 0 ].x * V2Line[ 1 ].z - V3Line[ 0 ].z * V2Line[ 1 ].x ) / ( V3Line[ 0 ].y * V2Line[ 1 ].x - V3Line[ 0 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 2 ][ 0 ][ 2 ].x = ( V2Line[ 2 ].z * V3Line[ 0 ].y - V3Line[ 0 ].z * V2Line[ 2 ].y ) / ( V3Line[ 0 ].x * V2Line[ 2 ].y - V2Line[ 2 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 2 ][ 0 ][ 2 ].y = ( V3Line[ 0 ].x * V2Line[ 2 ].z - V3Line[ 0 ].z * V2Line[ 2 ].x ) / ( V3Line[ 0 ].y * V2Line[ 2 ].x - V3Line[ 0 ].x * V2Line[ 2 ].y ) ;
		VPosD[ 2 ][ 0 ][ 3 ].x = ( V2Line[ 3 ].z * V3Line[ 0 ].y - V3Line[ 0 ].z * V2Line[ 3 ].y ) / ( V3Line[ 0 ].x * V2Line[ 3 ].y - V2Line[ 3 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 2 ][ 0 ][ 3 ].y = ( V3Line[ 0 ].x * V2Line[ 3 ].z - V3Line[ 0 ].z * V2Line[ 3 ].x ) / ( V3Line[ 0 ].y * V2Line[ 3 ].x - V3Line[ 0 ].x * V2Line[ 3 ].y ) ;
		VPosD[ 2 ][ 1 ][ 0 ].x = ( V2Line[ 0 ].z * V3Line[ 1 ].y - V3Line[ 1 ].z * V2Line[ 0 ].y ) / ( V3Line[ 1 ].x * V2Line[ 0 ].y - V2Line[ 0 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 2 ][ 1 ][ 0 ].y = ( V3Line[ 1 ].x * V2Line[ 0 ].z - V3Line[ 1 ].z * V2Line[ 0 ].x ) / ( V3Line[ 1 ].y * V2Line[ 0 ].x - V3Line[ 1 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 2 ][ 1 ][ 1 ].x = ( V2Line[ 1 ].z * V3Line[ 1 ].y - V3Line[ 1 ].z * V2Line[ 1 ].y ) / ( V3Line[ 1 ].x * V2Line[ 1 ].y - V2Line[ 1 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 2 ][ 1 ][ 1 ].y = ( V3Line[ 1 ].x * V2Line[ 1 ].z - V3Line[ 1 ].z * V2Line[ 1 ].x ) / ( V3Line[ 1 ].y * V2Line[ 1 ].x - V3Line[ 1 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 2 ][ 1 ][ 2 ].x = ( V2Line[ 2 ].z * V3Line[ 1 ].y - V3Line[ 1 ].z * V2Line[ 2 ].y ) / ( V3Line[ 1 ].x * V2Line[ 2 ].y - V2Line[ 2 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 2 ][ 1 ][ 2 ].y = ( V3Line[ 1 ].x * V2Line[ 2 ].z - V3Line[ 1 ].z * V2Line[ 2 ].x ) / ( V3Line[ 1 ].y * V2Line[ 2 ].x - V3Line[ 1 ].x * V2Line[ 2 ].y ) ;
		VPosD[ 2 ][ 1 ][ 3 ].x = ( V2Line[ 3 ].z * V3Line[ 1 ].y - V3Line[ 1 ].z * V2Line[ 3 ].y ) / ( V3Line[ 1 ].x * V2Line[ 3 ].y - V2Line[ 3 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 2 ][ 1 ][ 3 ].y = ( V3Line[ 1 ].x * V2Line[ 3 ].z - V3Line[ 1 ].z * V2Line[ 3 ].x ) / ( V3Line[ 1 ].y * V2Line[ 3 ].x - V3Line[ 1 ].x * V2Line[ 3 ].y ) ;
		VPosD[ 2 ][ 2 ][ 0 ].x = ( V2Line[ 0 ].z * V3Line[ 2 ].y - V3Line[ 2 ].z * V2Line[ 0 ].y ) / ( V3Line[ 2 ].x * V2Line[ 0 ].y - V2Line[ 0 ].x * V3Line[ 2 ].y ) ;
		VPosD[ 2 ][ 2 ][ 0 ].y = ( V3Line[ 2 ].x * V2Line[ 0 ].z - V3Line[ 2 ].z * V2Line[ 0 ].x ) / ( V3Line[ 2 ].y * V2Line[ 0 ].x - V3Line[ 2 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 2 ][ 2 ][ 1 ].x = ( V2Line[ 1 ].z * V3Line[ 2 ].y - V3Line[ 2 ].z * V2Line[ 1 ].y ) / ( V3Line[ 2 ].x * V2Line[ 1 ].y - V2Line[ 1 ].x * V3Line[ 2 ].y ) ;
		VPosD[ 2 ][ 2 ][ 1 ].y = ( V3Line[ 2 ].x * V2Line[ 1 ].z - V3Line[ 2 ].z * V2Line[ 1 ].x ) / ( V3Line[ 2 ].y * V2Line[ 1 ].x - V3Line[ 2 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 2 ][ 2 ][ 2 ].x = ( V2Line[ 2 ].z * V3Line[ 2 ].y - V3Line[ 2 ].z * V2Line[ 2 ].y ) / ( V3Line[ 2 ].x * V2Line[ 2 ].y - V2Line[ 2 ].x * V3Line[ 2 ].y ) ;
		VPosD[ 2 ][ 2 ][ 2 ].y = ( V3Line[ 2 ].x * V2Line[ 2 ].z - V3Line[ 2 ].z * V2Line[ 2 ].x ) / ( V3Line[ 2 ].y * V2Line[ 2 ].x - V3Line[ 2 ].x * V2Line[ 2 ].y ) ;
		VPosD[ 2 ][ 2 ][ 3 ].x = ( V2Line[ 3 ].z * V3Line[ 2 ].y - V3Line[ 2 ].z * V2Line[ 3 ].y ) / ( V3Line[ 2 ].x * V2Line[ 3 ].y - V2Line[ 3 ].x * V3Line[ 2 ].y ) ;
		VPosD[ 2 ][ 2 ][ 3 ].y = ( V3Line[ 2 ].x * V2Line[ 3 ].z - V3Line[ 2 ].z * V2Line[ 3 ].x ) / ( V3Line[ 2 ].y * V2Line[ 3 ].x - V3Line[ 2 ].x * V2Line[ 3 ].y ) ;
		VPosD[ 2 ][ 3 ][ 0 ].x = ( V2Line[ 0 ].z * V3Line[ 3 ].y - V3Line[ 3 ].z * V2Line[ 0 ].y ) / ( V3Line[ 3 ].x * V2Line[ 0 ].y - V2Line[ 0 ].x * V3Line[ 3 ].y ) ;
		VPosD[ 2 ][ 3 ][ 0 ].y = ( V3Line[ 3 ].x * V2Line[ 0 ].z - V3Line[ 3 ].z * V2Line[ 0 ].x ) / ( V3Line[ 3 ].y * V2Line[ 0 ].x - V3Line[ 3 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 2 ][ 3 ][ 1 ].x = ( V2Line[ 1 ].z * V3Line[ 3 ].y - V3Line[ 3 ].z * V2Line[ 1 ].y ) / ( V3Line[ 3 ].x * V2Line[ 1 ].y - V2Line[ 1 ].x * V3Line[ 3 ].y ) ;
		VPosD[ 2 ][ 3 ][ 1 ].y = ( V3Line[ 3 ].x * V2Line[ 1 ].z - V3Line[ 3 ].z * V2Line[ 1 ].x ) / ( V3Line[ 3 ].y * V2Line[ 1 ].x - V3Line[ 3 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 2 ][ 3 ][ 2 ].x = ( V2Line[ 2 ].z * V3Line[ 3 ].y - V3Line[ 3 ].z * V2Line[ 2 ].y ) / ( V3Line[ 3 ].x * V2Line[ 2 ].y - V2Line[ 2 ].x * V3Line[ 3 ].y ) ;
		VPosD[ 2 ][ 3 ][ 2 ].y = ( V3Line[ 3 ].x * V2Line[ 2 ].z - V3Line[ 3 ].z * V2Line[ 2 ].x ) / ( V3Line[ 3 ].y * V2Line[ 2 ].x - V3Line[ 3 ].x * V2Line[ 2 ].y ) ;
		VPosD[ 2 ][ 3 ][ 3 ].x = ( V2Line[ 3 ].z * V3Line[ 3 ].y - V3Line[ 3 ].z * V2Line[ 3 ].y ) / ( V3Line[ 3 ].x * V2Line[ 3 ].y - V2Line[ 3 ].x * V3Line[ 3 ].y ) ;
		VPosD[ 2 ][ 3 ][ 3 ].y = ( V3Line[ 3 ].x * V2Line[ 3 ].z - V3Line[ 3 ].z * V2Line[ 3 ].x ) / ( V3Line[ 3 ].y * V2Line[ 3 ].x - V3Line[ 3 ].x * V2Line[ 3 ].y ) ;

		Vertex = ParamVertex ;
		n = 1 ;
		for( i = 0 ; i < 3 ; i++ )
		{
			Vertex[ 0 ].x = VPosD[ i ][ 0 ][ 1 ].x ;
			Vertex[ 0 ].y = VPosD[ i ][ 0 ][ 1 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 0 ][ 0 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 0 ][ 0 ].y ;
			Vertex[ 2 ].x = VPosD[ i ][ 1 ][ 1 ].x ;
			Vertex[ 2 ].y = VPosD[ i ][ 1 ][ 1 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 1 ][ 0 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 1 ][ 0 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 0 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 0 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;

			Vertex[ 0 ].x = VPosD[ i ][ 0 ][ 2 ].x ;
			Vertex[ 0 ].y = VPosD[ i ][ 0 ][ 2 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 0 ][ 1 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 0 ][ 1 ].y ;
			Vertex[ 2 ].x = VPosD[ i ][ 1 ][ 2 ].x ;
			Vertex[ 2 ].y = VPosD[ i ][ 1 ][ 2 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 1 ][ 1 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 1 ][ 1 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;

			Vertex[ 0 ].x = VPosD[ i ][ 0 ][ 3 ].x ;
			Vertex[ 0 ].y = VPosD[ i ][ 0 ][ 3 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 0 ][ 2 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 0 ][ 2 ].y ;
			Vertex[ 2 ].x = VPosD[ i ][ 1 ][ 3 ].x ;
			Vertex[ 2 ].y = VPosD[ i ][ 1 ][ 3 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 1 ][ 2 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 1 ][ 2 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;



			Vertex[ 0 ].x = VPosD[ i ][ 1 ][ 1 ].x ;
			Vertex[ 0 ].y = VPosD[ i ][ 1 ][ 1 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 1 ][ 0 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 1 ][ 0 ].y ;
			Vertex[ 2 ].x = VPosD[ i ][ 2 ][ 1 ].x ;
			Vertex[ 2 ].y = VPosD[ i ][ 2 ][ 1 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 2 ][ 0 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 2 ][ 0 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 0 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 0 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;

			Vertex[ 0 ].x = VPosD[ i ][ 1 ][ 2 ].x ;
			Vertex[ 0 ].y = VPosD[ i ][ 1 ][ 2 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 1 ][ 1 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 1 ][ 1 ].y ;
			Vertex[ 2 ].x = VPosD[ i ][ 2 ][ 2 ].x ;
			Vertex[ 2 ].y = VPosD[ i ][ 2 ][ 2 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 2 ][ 1 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 2 ][ 1 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;

			Vertex[ 0 ].x = VPosD[ i ][ 1 ][ 3 ].x ;
			Vertex[ 0 ].y = VPosD[ i ][ 1 ][ 3 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 1 ][ 2 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 1 ][ 2 ].y ;
			Vertex[ 2 ].x = VPosD[ i ][ 2 ][ 3 ].x ;
			Vertex[ 2 ].y = VPosD[ i ][ 2 ][ 3 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 2 ][ 2 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 2 ][ 2 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;




			Vertex[ 0 ].x = VPosD[ i ][ 2 ][ 1 ].x ;
			Vertex[ 0 ].y = VPosD[ i ][ 2 ][ 1 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 2 ][ 0 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 2 ][ 0 ].y ;
			Vertex[ 2 ].x = VPosD[ i ][ 3 ][ 1 ].x ;
			Vertex[ 2 ].y = VPosD[ i ][ 3 ][ 1 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 3 ][ 0 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 3 ][ 0 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 0 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 0 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;

			Vertex[ 0 ].x = VPosD[ i ][ 2 ][ 2 ].x ;
			Vertex[ 0 ].y = VPosD[ i ][ 2 ][ 2 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 2 ][ 1 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 2 ][ 1 ].y ;
			Vertex[ 2 ].x = VPosD[ i ][ 3 ][ 2 ].x ;
			Vertex[ 2 ].y = VPosD[ i ][ 3 ][ 2 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 3 ][ 1 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 3 ][ 1 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;

			Vertex[ 0 ].x = VPosD[ i ][ 2 ][ 3 ].x ;
			Vertex[ 0 ].y = VPosD[ i ][ 2 ][ 3 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 2 ][ 2 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 2 ][ 2 ].y ;
			Vertex[ 2 ].x = VPosD[ i ][ 3 ][ 3 ].x ;
			Vertex[ 2 ].y = VPosD[ i ][ 3 ][ 3 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 3 ][ 2 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 3 ][ 2 ].y ;

			Vertex[ 0 ].u = Line_In_UV[ 1 ] ;	Vertex[ 0 ].v = Line_In_UV[ 0 ] ;
			Vertex[ 1 ].u = Line_In_UV[ 0 ] ;	Vertex[ 1 ].v = Line_In_UV[ 0 ] ;
			Vertex[ 2 ].u = Line_In_UV[ 1 ] ;	Vertex[ 2 ].v = Line_In_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_In_UV[ 0 ] ;	Vertex[ 3 ].v = Line_In_UV[ 1 ] ;

			Vertex += 4 ;




			Vertex[ 0 ].x = VPosD[ n ][ 3 ][ 0 ].x ;
			Vertex[ 0 ].y = VPosD[ n ][ 3 ][ 0 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 0 ][ 3 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 0 ][ 3 ].y ;
			Vertex[ 2 ].x = VPosD[ n ][ 3 ][ 1 ].x ;
			Vertex[ 2 ].y = VPosD[ n ][ 3 ][ 1 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 1 ][ 3 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 1 ][ 3 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;


			Vertex[ 0 ].x = VPosD[ n ][ 3 ][ 1 ].x ;
			Vertex[ 0 ].y = VPosD[ n ][ 3 ][ 1 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 1 ][ 3 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 1 ][ 3 ].y ;
			Vertex[ 2 ].x = VPosD[ n ][ 3 ][ 2 ].x ;
			Vertex[ 2 ].y = VPosD[ n ][ 3 ][ 2 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 2 ][ 3 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 2 ][ 3 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;


			Vertex[ 0 ].x = VPosD[ n ][ 3 ][ 2 ].x ;
			Vertex[ 0 ].y = VPosD[ n ][ 3 ][ 2 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 2 ][ 3 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 2 ][ 3 ].y ;
			Vertex[ 2 ].x = VPosD[ n ][ 3 ][ 3 ].x ;
			Vertex[ 2 ].y = VPosD[ n ][ 3 ][ 3 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 3 ][ 3 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 3 ][ 3 ].y ;

			Vertex[ 0 ].u = Line_In_UV[ 1 ] ;	Vertex[ 0 ].v = Line_In_UV[ 0 ] ;
			Vertex[ 1 ].u = Line_In_UV[ 1 ] ;	Vertex[ 1 ].v = Line_In_UV[ 0 ] ;
			Vertex[ 2 ].u = Line_In_UV[ 1 ] ;	Vertex[ 2 ].v = Line_In_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_In_UV[ 1 ] ;	Vertex[ 3 ].v = Line_In_UV[ 1 ] ;

			Vertex += 4 ;


			n = n == 2 ? 0 : n + 1 ;
		}
	}

	Graphics_Draw_DrawSimpleQuadrangleGraphF( &Param ) ;

END :

	AA_DRAW_END

	Graphics_DrawSetting_SetDrawBrightToOneParam( OrigColor ) ;

	if( NormalDraw )
	{
		return NS_DrawTriangle( _FTOL( x1 ), _FTOL( y1 ), _FTOL( x2 ), _FTOL( y2 ), _FTOL( x3 ), _FTOL( y3 ), Color, FALSE ) ;
	}

	// I
	return 0 ;
}

// Op`̕`悷( A`GCAXt )
static int DrawTriangleFillAA( float x1, float y1, float x2, float y2, float x3, float y3, unsigned int Color )
{
	int GrHandle ;
	GRAPHICS_DRAW_DRAWSIMPLETRIANGLEGRAPHF_PARAM Param ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX ParamVertex[ 6 * 6 + 3 ] ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX *Vertex ;
	VECTOR V1Dir, V1Pos, V1Norm, V1Line[ 2 ] ;
	VECTOR V2Dir, V2Pos, V2Norm, V2Line[ 2 ] ;
	VECTOR V3Dir, V3Pos, V3Norm, V3Line[ 2 ] ;
	VECTOR V12Dir ;
	VECTOR V13Dir ;
	VECTOR VPosD[ 3 ][ 4 ] ;
	float Distance ;
	VECTOR TempPos ;
	float P1P2X ;
	float P1P2Y ;
	float P1P3X ;
	float P1P3Y ;
	float TempF ;
	int i ;
	int n ;
	float CmpDistance = 4.0f ;
	int NormalDraw = FALSE ;
	static float LineUV[ 4 ] = { 0.0f, 3.0f / LINE_TEX_SIZE, 5.0f / LINE_TEX_SIZE, 1.0f };
	float SizeSq ;

	if( GSYS.HardInfo.DrawFloatCoordType == DX_DRAWFLOATCOORDTYPE_DIRECT3D9 )
	{
		x1 -= 0.5f ;
		y1 -= 0.5f ;
		x2 -= 0.5f ;
		y2 -= 0.5f ;
		x3 -= 0.5f ;
		y3 -= 0.5f ;
	}

	AA_DRAW_BEGIN
	AA_DRAW_BEGIN_2

	Param.Vertex      = ParamVertex ;
	Param.TransFlag   = TRUE ;
	Param.TriangleNum = 13 ;

	GrHandle = Graphics_Image_GetLineTexHandle( IS_PMA_DRAWBLENDMODE ) ;

	Param.GraphHandle = GrHandle ;

	P1P2X = x2 - x1 ;
	P1P2Y = y2 - y1 ;

	P1P3X = x3 - x1 ;
	P1P3Y = y3 - y1 ;

	if( P1P2X * P1P3Y - P1P2Y * P1P3X < 0.0f )
	{
		TempF = x2 ; x2 = x3 ; x3 = TempF ;
		TempF = y2 ; y2 = y3 ; y3 = TempF ;
	}

	V1Pos.x  = x1 ;			V1Pos.y  = y1 ;			V1Pos.z  = 0.0f ;
	V1Dir.x  = x2 - x1 ;	V1Dir.y  = y2 - y1 ;	V1Dir.z  = 0.0f ;
	V12Dir = V1Dir;
	Distance = V1Dir.x * V1Dir.x + V1Dir.y * V1Dir.y ;
	if( Distance < CmpDistance )
	{
		NormalDraw = TRUE ;
		goto END ;
	}
	Distance = _SQRT( Distance ) ;
	V1Dir.x /= Distance ;
	V1Dir.y /= Distance ;
	V1Norm.x = V1Dir.y ;	V1Norm.y = -V1Dir.x ;	V1Norm.z = 0.0f ;
	TempPos = VAdd( V1Pos, VScale( V1Norm,  2.0f ) ) ;
	V1Line[ 0 ].x =  V1Dir.y ;
	V1Line[ 0 ].y = -V1Dir.x ;
	V1Line[ 0 ].z = ( TempPos.x + V1Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V1Dir.y ) ;
	TempPos = VAdd( V1Pos, VScale( V1Norm, -1.0f ) ) ;
	V1Line[ 1 ].x =  V1Dir.y ;
	V1Line[ 1 ].y = -V1Dir.x ;
	V1Line[ 1 ].z = ( TempPos.x + V1Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V1Dir.y ) ;

	V2Pos.x  = x2 ;			V2Pos.y  = y2 ;			V2Pos.z  = 0.0f ;
	V2Dir.x  = x3 - x2 ;	V2Dir.y  = y3 - y2 ;	V2Dir.z  = 0.0f ;
	Distance = V2Dir.x * V2Dir.x + V2Dir.y * V2Dir.y ;
	if( Distance < CmpDistance )
	{
		NormalDraw = TRUE ;
		goto END ;
	}
	Distance = _SQRT( Distance ) ;
	V2Dir.x /= Distance ;
	V2Dir.y /= Distance ;
	V2Norm.x = V2Dir.y ;	V2Norm.y = -V2Dir.x ;	V2Norm.z = 0.0f ;
	TempPos = VAdd( V2Pos, VScale( V2Norm,  2.0f ) ) ;
	V2Line[ 0 ].x =  V2Dir.y ;
	V2Line[ 0 ].y = -V2Dir.x ;
	V2Line[ 0 ].z = ( TempPos.x + V2Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V2Dir.y ) ;
	TempPos = VAdd( V2Pos, VScale( V2Norm, -1.0f ) ) ;
	V2Line[ 1 ].x =  V2Dir.y ;
	V2Line[ 1 ].y = -V2Dir.x ;
	V2Line[ 1 ].z = ( TempPos.x + V2Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V2Dir.y ) ;

	V13Dir.x = x3 - x1 ;    V13Dir.y = y3 - y1 ;	V13Dir.z = 0.0f ;
	SizeSq = VSquareSize( VCross( V12Dir, V13Dir ) ) ;
	if( SizeSq / 2.0f < 7500.0f )
	{
		NormalDraw = TRUE ;
		goto END ;
	}

	V3Pos.x  = x3 ;			V3Pos.y  = y3 ;			V3Pos.z  = 0.0f ;
	V3Dir.x  = x1 - x3 ;	V3Dir.y  = y1 - y3 ;	V3Dir.z  = 0.0f ;
	Distance = V3Dir.x * V3Dir.x + V3Dir.y * V3Dir.y ;
	if( Distance < CmpDistance )
	{
		NormalDraw = TRUE ;
		goto END ;
	}
	Distance = _SQRT( Distance ) ;
	V3Dir.x /= Distance ;
	V3Dir.y /= Distance ;
	V3Norm.x = V3Dir.y ;	V3Norm.y = -V3Dir.x ;	V3Norm.z = 0.0f ;
	TempPos = VAdd( V3Pos, VScale( V3Norm,  2.0f ) ) ;
	V3Line[ 0 ].x =  V3Dir.y ;
	V3Line[ 0 ].y = -V3Dir.x ;
	V3Line[ 0 ].z = ( TempPos.x + V3Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V3Dir.y ) ;
	TempPos = VAdd( V3Pos, VScale( V3Norm, -1.0f ) ) ;
	V3Line[ 1 ].x =  V3Dir.y ;
	V3Line[ 1 ].y = -V3Dir.x ;
	V3Line[ 1 ].z = ( TempPos.x + V3Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V3Dir.y ) ;


	VPosD[ 0 ][ 0 ].x = ( V3Line[ 0 ].z * V1Line[ 0 ].y - V1Line[ 0 ].z * V3Line[ 0 ].y ) / ( V1Line[ 0 ].x * V3Line[ 0 ].y - V3Line[ 0 ].x * V1Line[ 0 ].y ) ;
	VPosD[ 0 ][ 0 ].y = ( V1Line[ 0 ].x * V3Line[ 0 ].z - V1Line[ 0 ].z * V3Line[ 0 ].x ) / ( V1Line[ 0 ].y * V3Line[ 0 ].x - V1Line[ 0 ].x * V3Line[ 0 ].y ) ;

	VPosD[ 0 ][ 1 ].x = ( V3Line[ 1 ].z * V1Line[ 0 ].y - V1Line[ 0 ].z * V3Line[ 1 ].y ) / ( V1Line[ 0 ].x * V3Line[ 1 ].y - V3Line[ 1 ].x * V1Line[ 0 ].y ) ;
	VPosD[ 0 ][ 1 ].y = ( V1Line[ 0 ].x * V3Line[ 1 ].z - V1Line[ 0 ].z * V3Line[ 1 ].x ) / ( V1Line[ 0 ].y * V3Line[ 1 ].x - V1Line[ 0 ].x * V3Line[ 1 ].y ) ;

	VPosD[ 0 ][ 2 ].x = ( V3Line[ 0 ].z * V1Line[ 1 ].y - V1Line[ 1 ].z * V3Line[ 0 ].y ) / ( V1Line[ 1 ].x * V3Line[ 0 ].y - V3Line[ 0 ].x * V1Line[ 1 ].y ) ;
	VPosD[ 0 ][ 2 ].y = ( V1Line[ 1 ].x * V3Line[ 0 ].z - V1Line[ 1 ].z * V3Line[ 0 ].x ) / ( V1Line[ 1 ].y * V3Line[ 0 ].x - V1Line[ 1 ].x * V3Line[ 0 ].y ) ;

	VPosD[ 0 ][ 3 ].x = ( V3Line[ 1 ].z * V1Line[ 1 ].y - V1Line[ 1 ].z * V3Line[ 1 ].y ) / ( V1Line[ 1 ].x * V3Line[ 1 ].y - V3Line[ 1 ].x * V1Line[ 1 ].y ) ;
	VPosD[ 0 ][ 3 ].y = ( V1Line[ 1 ].x * V3Line[ 1 ].z - V1Line[ 1 ].z * V3Line[ 1 ].x ) / ( V1Line[ 1 ].y * V3Line[ 1 ].x - V1Line[ 1 ].x * V3Line[ 1 ].y ) ;


	VPosD[ 1 ][ 0 ].x = ( V1Line[ 0 ].z * V2Line[ 0 ].y - V2Line[ 0 ].z * V1Line[ 0 ].y ) / ( V2Line[ 0 ].x * V1Line[ 0 ].y - V1Line[ 0 ].x * V2Line[ 0 ].y ) ;
	VPosD[ 1 ][ 0 ].y = ( V2Line[ 0 ].x * V1Line[ 0 ].z - V2Line[ 0 ].z * V1Line[ 0 ].x ) / ( V2Line[ 0 ].y * V1Line[ 0 ].x - V2Line[ 0 ].x * V1Line[ 0 ].y ) ;

	VPosD[ 1 ][ 1 ].x = ( V1Line[ 1 ].z * V2Line[ 0 ].y - V2Line[ 0 ].z * V1Line[ 1 ].y ) / ( V2Line[ 0 ].x * V1Line[ 1 ].y - V1Line[ 1 ].x * V2Line[ 0 ].y ) ;
	VPosD[ 1 ][ 1 ].y = ( V2Line[ 0 ].x * V1Line[ 1 ].z - V2Line[ 0 ].z * V1Line[ 1 ].x ) / ( V2Line[ 0 ].y * V1Line[ 1 ].x - V2Line[ 0 ].x * V1Line[ 1 ].y ) ;

	VPosD[ 1 ][ 2 ].x = ( V1Line[ 0 ].z * V2Line[ 1 ].y - V2Line[ 1 ].z * V1Line[ 0 ].y ) / ( V2Line[ 1 ].x * V1Line[ 0 ].y - V1Line[ 0 ].x * V2Line[ 1 ].y ) ;
	VPosD[ 1 ][ 2 ].y = ( V2Line[ 1 ].x * V1Line[ 0 ].z - V2Line[ 1 ].z * V1Line[ 0 ].x ) / ( V2Line[ 1 ].y * V1Line[ 0 ].x - V2Line[ 1 ].x * V1Line[ 0 ].y ) ;

	VPosD[ 1 ][ 3 ].x = ( V1Line[ 1 ].z * V2Line[ 1 ].y - V2Line[ 1 ].z * V1Line[ 1 ].y ) / ( V2Line[ 1 ].x * V1Line[ 1 ].y - V1Line[ 1 ].x * V2Line[ 1 ].y ) ;
	VPosD[ 1 ][ 3 ].y = ( V2Line[ 1 ].x * V1Line[ 1 ].z - V2Line[ 1 ].z * V1Line[ 1 ].x ) / ( V2Line[ 1 ].y * V1Line[ 1 ].x - V2Line[ 1 ].x * V1Line[ 1 ].y ) ;


	VPosD[ 2 ][ 0 ].x = ( V2Line[ 0 ].z * V3Line[ 0 ].y - V3Line[ 0 ].z * V2Line[ 0 ].y ) / ( V3Line[ 0 ].x * V2Line[ 0 ].y - V2Line[ 0 ].x * V3Line[ 0 ].y ) ;
	VPosD[ 2 ][ 0 ].y = ( V3Line[ 0 ].x * V2Line[ 0 ].z - V3Line[ 0 ].z * V2Line[ 0 ].x ) / ( V3Line[ 0 ].y * V2Line[ 0 ].x - V3Line[ 0 ].x * V2Line[ 0 ].y ) ;

	VPosD[ 2 ][ 1 ].x = ( V2Line[ 1 ].z * V3Line[ 0 ].y - V3Line[ 0 ].z * V2Line[ 1 ].y ) / ( V3Line[ 0 ].x * V2Line[ 1 ].y - V2Line[ 1 ].x * V3Line[ 0 ].y ) ;
	VPosD[ 2 ][ 1 ].y = ( V3Line[ 0 ].x * V2Line[ 1 ].z - V3Line[ 0 ].z * V2Line[ 1 ].x ) / ( V3Line[ 0 ].y * V2Line[ 1 ].x - V3Line[ 0 ].x * V2Line[ 1 ].y ) ;

	VPosD[ 2 ][ 2 ].x = ( V2Line[ 0 ].z * V3Line[ 1 ].y - V3Line[ 1 ].z * V2Line[ 0 ].y ) / ( V3Line[ 1 ].x * V2Line[ 0 ].y - V2Line[ 0 ].x * V3Line[ 1 ].y ) ;
	VPosD[ 2 ][ 2 ].y = ( V3Line[ 1 ].x * V2Line[ 0 ].z - V3Line[ 1 ].z * V2Line[ 0 ].x ) / ( V3Line[ 1 ].y * V2Line[ 0 ].x - V3Line[ 1 ].x * V2Line[ 0 ].y ) ;

	VPosD[ 2 ][ 3 ].x = ( V2Line[ 1 ].z * V3Line[ 1 ].y - V3Line[ 1 ].z * V2Line[ 1 ].y ) / ( V3Line[ 1 ].x * V2Line[ 1 ].y - V2Line[ 1 ].x * V3Line[ 1 ].y ) ;
	VPosD[ 2 ][ 3 ].y = ( V3Line[ 1 ].x * V2Line[ 1 ].z - V3Line[ 1 ].z * V2Line[ 1 ].x ) / ( V3Line[ 1 ].y * V2Line[ 1 ].x - V3Line[ 1 ].x * V2Line[ 1 ].y ) ;

	Vertex = ParamVertex ;
	n = 1 ;
	for( i = 0 ; i < 3 ; i++ )
	{
		Vertex[ 0 ].x = VPosD[ i ][ 1 ].x ;
		Vertex[ 0 ].y = VPosD[ i ][ 1 ].y ;
		Vertex[ 1 ].x = VPosD[ i ][ 0 ].x ;
		Vertex[ 1 ].y = VPosD[ i ][ 0 ].y ;
		Vertex[ 2 ].x = VPosD[ i ][ 3 ].x ;
		Vertex[ 2 ].y = VPosD[ i ][ 3 ].y ;
		Vertex[ 3 ].x = VPosD[ i ][ 2 ].x ;
		Vertex[ 3 ].y = VPosD[ i ][ 2 ].y ;
		Vertex[ 4 ].x = VPosD[ i ][ 3 ].x ;
		Vertex[ 4 ].y = VPosD[ i ][ 3 ].y ;
		Vertex[ 5 ].x = VPosD[ i ][ 0 ].x ;
		Vertex[ 5 ].y = VPosD[ i ][ 0 ].y ;

		Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 0 ] ;
		Vertex[ 1 ].u = LineUV[ 0 ] ;	Vertex[ 1 ].v = LineUV[ 0 ] ;
		Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;
		Vertex[ 3 ].u = LineUV[ 0 ] ;	Vertex[ 3 ].v = LineUV[ 1 ] ;
		Vertex[ 4 ].u = LineUV[ 1 ] ;	Vertex[ 4 ].v = LineUV[ 1 ] ;
		Vertex[ 5 ].u = LineUV[ 0 ] ;	Vertex[ 5 ].v = LineUV[ 0 ] ;

		Vertex += 6 ;


		Vertex[ 0 ].x = VPosD[ n ][ 2 ].x ;
		Vertex[ 0 ].y = VPosD[ n ][ 2 ].y ;
		Vertex[ 1 ].x = VPosD[ i ][ 1 ].x ;
		Vertex[ 1 ].y = VPosD[ i ][ 1 ].y ;
		Vertex[ 2 ].x = VPosD[ n ][ 3 ].x ;
		Vertex[ 2 ].y = VPosD[ n ][ 3 ].y ;
		Vertex[ 3 ].x = VPosD[ i ][ 3 ].x ;
		Vertex[ 3 ].y = VPosD[ i ][ 3 ].y ;
		Vertex[ 4 ].x = VPosD[ n ][ 3 ].x ;
		Vertex[ 4 ].y = VPosD[ n ][ 3 ].y ;
		Vertex[ 5 ].x = VPosD[ i ][ 1 ].x ;
		Vertex[ 5 ].y = VPosD[ i ][ 1 ].y ;

		Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 0 ] ;
		Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ 0 ] ;
		Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;
		Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ 1 ] ;
		Vertex[ 4 ].u = LineUV[ 1 ] ;	Vertex[ 4 ].v = LineUV[ 1 ] ;
		Vertex[ 5 ].u = LineUV[ 1 ] ;	Vertex[ 5 ].v = LineUV[ 0 ] ;

		Vertex += 6 ;

		n = n == 2 ? 0 : n + 1 ;
	}

	Vertex[ 0 ].x = VPosD[ 2 ][ 3 ].x ;
	Vertex[ 0 ].y = VPosD[ 2 ][ 3 ].y ;
	Vertex[ 1 ].x = VPosD[ 1 ][ 3 ].x ;
	Vertex[ 1 ].y = VPosD[ 1 ][ 3 ].y ;
	Vertex[ 2 ].x = VPosD[ 0 ][ 3 ].x ;
	Vertex[ 2 ].y = VPosD[ 0 ][ 3 ].y ;

	Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 1 ] ;
	Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ 1 ] ;
	Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;

	Graphics_Draw_DrawSimpleTriangleGraphF( &Param ) ;

END :

	AA_DRAW_END

	Graphics_DrawSetting_SetDrawBrightToOneParam( OrigColor ) ;

	if( NormalDraw )
	{
		return NS_DrawTriangle( _FTOL( x1 ), _FTOL( y1 ), _FTOL( x2 ), _FTOL( y2 ), _FTOL( x3 ), _FTOL( y3 ), Color, TRUE ) ;
	}

	// I
	return 0 ;
}

// Op``悷( A`GCAXt )
extern int NS_DrawTriangleAA( float x1, float y1, float x2, float y2, float x3, float y3, unsigned int Color, int FillFlag, float LineThickness )
{
	if( FillFlag == FALSE )
	{
		return DrawTriangleLineAA( x1, y1, x2, y2, x3, y3, Color, LineThickness ) ;
	}
	else
	{
		return DrawTriangleFillAA( x1, y1, x2, y2, x3, y3, Color ) ;
	}
}

// lp`̕`
#define SETDRAWRECTCODE\
	int x[ 4 ], y[ 4 ], MaxX, MaxY, MinX, MinY ;\
	int i, ix, iy ;\
\
	x[ 0 ] = x1 ; x[ 1 ] = x2 ; x[ 2 ] = x3 ; x[ 3 ] = x4 ;\
	y[ 0 ] = y1 ; y[ 1 ] = y2 ; y[ 2 ] = y3 ; y[ 3 ] = y4 ;\
\
	MaxX = 0 ; MaxY = 0 ;\
	MinX = 0xffffff ; MinY = 0xffffff ;\
\
	for( i = 0 ; i < 4 ; i ++ )\
	{\
		ix = x[ i ] ; iy = y[ i ] ;\
		if( ix > MaxX ) MaxX = ix ; if( iy > MaxY ) MaxY = iy ;\
		if( ix < MinX ) MinX = ix ; if( iy < MinY ) MinY = iy ;\
	}\
\
	SETRECT( DrawRect, MinX, MinY, MaxX, MaxY ) ;\
	DRAWRECT_DRAWAREA_CLIP

extern	int NS_DrawQuadrangle( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, unsigned int Color, int FillFlag )
{
	int Ret = -1 ;
	int Flag ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;
	
	Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;

	CheckActiveState() ;

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawQuadrangle_PF( x1, y1, x2, y2, x3, y3, x4, y4, Color, FillFlag ),
		Graphics_Software_DrawQuadrangle(    x1, y1, x2, y2, x3, y3, x4, y4, Color, FillFlag ),
		SETDRAWRECTCODE,
		Ret,
		Flag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE

// lp``悷( A`GCAXt )
static int DrawQuadrangleLineAA( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, unsigned int Color, float LineThickness )
{
	int GrHandle ;
	GRAPHICS_DRAW_DRAWSIMPLEQUADRANGLEGRAPHF_PARAM Param ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX ParamVertex[ ( 4 * 12 ) * 4 ] ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX *Vertex ;
	VECTOR V1Dir, V1Pos, V1Norm, V1Line[ 4 ] ;
	VECTOR V2Dir, V2Pos, V2Norm, V2Line[ 4 ] ;
	VECTOR V3Dir, V3Pos, V3Norm, V3Line[ 4 ] ;
	VECTOR V4Dir, V4Pos, V4Norm, V4Line[ 4 ] ;
//	VECTOR V12Dir ;
//	VECTOR V13Dir ;
//	VECTOR V14Dir ;
	VECTOR VPosD[ 4 ][ 4 ][ 4 ] ;
	float Distance ;
	VECTOR TempPos ;
	float P1P2X ;
	float P1P2Y ;
//	float P1P3X ;
//	float P1P3Y ;
	float P1P4X ;
	float P1P4Y ;
	float TempF ;
	float tmp1 ;
	float tmp2 ;
	float tmp3 ;
	float tmp4 ;
	float CmpDistance ;
	int NormalDraw = FALSE ;
	int i ;
	int n ;
	static float Line_Out_UV[ 4 ] = { 0.0f,                    4.0f / LINEBOX_TEX_SIZE, 12.0f / LINEBOX_TEX_SIZE, 1.0f } ;
	static float Line_In_UV[ 4 ]  = { 5.0f / LINEBOX_TEX_SIZE, 8.0f / LINEBOX_TEX_SIZE, 8.0f  / LINEBOX_TEX_SIZE, 11.0f / LINEBOX_TEX_SIZE } ;

	if( GSYS.HardInfo.DrawFloatCoordType == DX_DRAWFLOATCOORDTYPE_DIRECT3D9 )
	{
		x1 -= 0.5f ;
		y1 -= 0.5f ;
		x2 -= 0.5f ;
		y2 -= 0.5f ;
		x3 -= 0.5f ;
		y3 -= 0.5f ;
		x4 -= 0.5f ;
		y4 -= 0.5f ;
	}

	P1P2X = x2 - x1 ;
	P1P2Y = y2 - y1 ;

	P1P4X = x4 - x1 ;
	P1P4Y = y4 - y1 ;

	if( P1P2X * P1P4Y - P1P2Y * P1P4X < 0.0f )
	{
		TempF = x2 ; x2 = x4 ; x4 = TempF ;
		TempF = y2 ; y2 = y4 ; y4 = TempF ;
	}

	AA_DRAW_BEGIN
	AA_DRAW_BEGIN_2

	Param.Vertex      = ParamVertex ;
	Param.TransFlag   = TRUE ;
	if( LineThickness <= 1.0f )
	{
		Param.QuadrangleNum = 8 ;

		GrHandle = Graphics_Image_GetLineBoxOneThicknessTexHandle( IS_PMA_DRAWBLENDMODE ) ;

		Param.GraphHandle = GrHandle ;

		LineThickness /= 2.0f ;
		tmp1 = LineThickness + 1.5f ;
		tmp2 = LineThickness - 2.5f ;
		CmpDistance = LineThickness + 3.5f ;
		CmpDistance *= CmpDistance ;

//		P1P2X = x2 - x1 ;
//		P1P2Y = y2 - y1 ;
//
//		P1P3X = x3 - x1 ;
//		P1P3Y = y3 - y1 ;
//
//		P1P4X = x3 - x1 ;
//		P1P4Y = y3 - y1 ;
//
//		if( P1P2X * P1P3Y - P1P2Y * P1P3X < 0.0f )
//		{
//			TempF = x2 ; x2 = x3 ; x3 = TempF ;
//			TempF = y2 ; y2 = y3 ; y3 = TempF ;
//		}

		V1Pos.x  = x1 ;			V1Pos.y  = y1 ;			V1Pos.z  = 0.0f ;
		V1Dir.x  = x2 - x1 ;	V1Dir.y  = y2 - y1 ;	V1Dir.z  = 0.0f ;
//		V12Dir = V1Dir;
		Distance = V1Dir.x * V1Dir.x + V1Dir.y * V1Dir.y ;
		if( Distance < CmpDistance )
		{
			NormalDraw = TRUE ;
			goto END ;
		}
		Distance = _SQRT( Distance ) ;
		V1Dir.x /= Distance ;
		V1Dir.y /= Distance ;
		V1Norm.x =  V1Dir.y ;
		V1Norm.y = -V1Dir.x ;
		V1Norm.z =  0.0f ;
		TempPos = VAdd( V1Pos, VScale( V1Norm, tmp1 ) ) ;
		V1Line[ 0 ].x =  V1Dir.y ;
		V1Line[ 0 ].y = -V1Dir.x ;
		V1Line[ 0 ].z = ( TempPos.x + V1Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V1Dir.y ) ;
		TempPos = VAdd( V1Pos, VScale( V1Norm, tmp2 ) ) ;
		V1Line[ 1 ].x =  V1Dir.y ;
		V1Line[ 1 ].y = -V1Dir.x ;
		V1Line[ 1 ].z = ( TempPos.x + V1Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V1Dir.y ) ;

		V2Pos.x  = x2 ;			V2Pos.y  = y2 ;			V2Pos.z  = 0.0f ;
		V2Dir.x  = x3 - x2 ;	V2Dir.y  = y3 - y2 ;	V2Dir.z  = 0.0f ;
		Distance = V2Dir.x * V2Dir.x + V2Dir.y * V2Dir.y ;
		if( Distance < CmpDistance )
		{
			NormalDraw = TRUE ;
			goto END ;
		}
		Distance = _SQRT( Distance ) ;
		V2Dir.x /= Distance ;
		V2Dir.y /= Distance ;
		V2Norm.x =  V2Dir.y ;
		V2Norm.y = -V2Dir.x ;
		V2Norm.z =  0.0f ;
		TempPos = VAdd( V2Pos, VScale( V2Norm, tmp1 ) ) ;
		V2Line[ 0 ].x =  V2Dir.y ;
		V2Line[ 0 ].y = -V2Dir.x ;
		V2Line[ 0 ].z = ( TempPos.x + V2Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V2Dir.y ) ;
		TempPos = VAdd( V2Pos, VScale( V2Norm, tmp2 ) ) ;
		V2Line[ 1 ].x =  V2Dir.y ;
		V2Line[ 1 ].y = -V2Dir.x ;
		V2Line[ 1 ].z = ( TempPos.x + V2Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V2Dir.y ) ;

//		V13Dir.x = x3 - x1 ;    V13Dir.y = y3 - y1 ;	V13Dir.z = 0.0f ;
//		float SizeSq = VSquareSize( VCross( V12Dir, V13Dir ) ) ;
//		if( SizeSq / 2.0f < 7500.0f )
//		{
//			NS_DrawTriangle( _FTOL( x1 ), _FTOL( y1 ), _FTOL( x2 ), _FTOL( y2 ), _FTOL( x3 ), _FTOL( y3 ), Color, TRUE ) ;
//			goto END ;
//		}

		V3Pos.x  = x3 ;			V3Pos.y  = y3 ;			V3Pos.z  = 0.0f ;
		V3Dir.x  = x4 - x3 ;	V3Dir.y  = y4 - y3 ;	V3Dir.z  = 0.0f ;
		Distance = V3Dir.x * V3Dir.x + V3Dir.y * V3Dir.y ;
		if( Distance < CmpDistance )
		{
			NormalDraw = TRUE ;
			goto END ;
		}
		Distance = _SQRT( Distance ) ;
		V3Dir.x /= Distance ;
		V3Dir.y /= Distance ;
		V3Norm.x =  V3Dir.y ;
		V3Norm.y = -V3Dir.x ;
		V3Norm.z =  0.0f ;
		TempPos = VAdd( V3Pos, VScale( V3Norm, tmp1 ) ) ;
		V3Line[ 0 ].x =  V3Dir.y ;
		V3Line[ 0 ].y = -V3Dir.x ;
		V3Line[ 0 ].z = ( TempPos.x + V3Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V3Dir.y ) ;
		TempPos = VAdd( V3Pos, VScale( V3Norm, tmp2 ) ) ;
		V3Line[ 1 ].x =  V3Dir.y ;
		V3Line[ 1 ].y = -V3Dir.x ;
		V3Line[ 1 ].z = ( TempPos.x + V3Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V3Dir.y ) ;

		V4Pos.x  = x4 ;			V4Pos.y  = y4 ;			V4Pos.z  = 0.0f ;
		V4Dir.x  = x1 - x4 ;	V4Dir.y  = y1 - y4 ;	V4Dir.z  = 0.0f ;
		Distance = V4Dir.x * V4Dir.x + V4Dir.y * V4Dir.y ;
		if( Distance < CmpDistance )
		{
			NormalDraw = TRUE ;
			goto END ;
		}
		Distance = _SQRT( Distance ) ;
		V4Dir.x /= Distance ;
		V4Dir.y /= Distance ;
		V4Norm.x =  V4Dir.y ;
		V4Norm.y = -V4Dir.x ;
		V4Norm.z =  0.0f ;
		TempPos = VAdd( V4Pos, VScale( V4Norm, tmp1 ) ) ;
		V4Line[ 0 ].x =  V4Dir.y ;
		V4Line[ 0 ].y = -V4Dir.x ;
		V4Line[ 0 ].z = ( TempPos.x + V4Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V4Dir.y ) ;
		TempPos = VAdd( V4Pos, VScale( V4Norm, tmp2 ) ) ;
		V4Line[ 1 ].x =  V4Dir.y ;
		V4Line[ 1 ].y = -V4Dir.x ;
		V4Line[ 1 ].z = ( TempPos.x + V4Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V4Dir.y ) ;


		VPosD[ 0 ][ 0 ][ 0 ].x = ( V4Line[ 0 ].z * V1Line[ 0 ].y - V1Line[ 0 ].z * V4Line[ 0 ].y ) / ( V1Line[ 0 ].x * V4Line[ 0 ].y - V4Line[ 0 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 0 ][ 0 ][ 0 ].y = ( V1Line[ 0 ].x * V4Line[ 0 ].z - V1Line[ 0 ].z * V4Line[ 0 ].x ) / ( V1Line[ 0 ].y * V4Line[ 0 ].x - V1Line[ 0 ].x * V4Line[ 0 ].y ) ;
		VPosD[ 0 ][ 0 ][ 1 ].x = ( V4Line[ 1 ].z * V1Line[ 0 ].y - V1Line[ 0 ].z * V4Line[ 1 ].y ) / ( V1Line[ 0 ].x * V4Line[ 1 ].y - V4Line[ 1 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 0 ][ 0 ][ 1 ].y = ( V1Line[ 0 ].x * V4Line[ 1 ].z - V1Line[ 0 ].z * V4Line[ 1 ].x ) / ( V1Line[ 0 ].y * V4Line[ 1 ].x - V1Line[ 0 ].x * V4Line[ 1 ].y ) ;
		VPosD[ 0 ][ 1 ][ 0 ].x = ( V4Line[ 0 ].z * V1Line[ 1 ].y - V1Line[ 1 ].z * V4Line[ 0 ].y ) / ( V1Line[ 1 ].x * V4Line[ 0 ].y - V4Line[ 0 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 0 ][ 1 ][ 0 ].y = ( V1Line[ 1 ].x * V4Line[ 0 ].z - V1Line[ 1 ].z * V4Line[ 0 ].x ) / ( V1Line[ 1 ].y * V4Line[ 0 ].x - V1Line[ 1 ].x * V4Line[ 0 ].y ) ;
		VPosD[ 0 ][ 1 ][ 1 ].x = ( V4Line[ 1 ].z * V1Line[ 1 ].y - V1Line[ 1 ].z * V4Line[ 1 ].y ) / ( V1Line[ 1 ].x * V4Line[ 1 ].y - V4Line[ 1 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 0 ][ 1 ][ 1 ].y = ( V1Line[ 1 ].x * V4Line[ 1 ].z - V1Line[ 1 ].z * V4Line[ 1 ].x ) / ( V1Line[ 1 ].y * V4Line[ 1 ].x - V1Line[ 1 ].x * V4Line[ 1 ].y ) ;

		VPosD[ 1 ][ 0 ][ 0 ].x = ( V1Line[ 0 ].z * V2Line[ 0 ].y - V2Line[ 0 ].z * V1Line[ 0 ].y ) / ( V2Line[ 0 ].x * V1Line[ 0 ].y - V1Line[ 0 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 1 ][ 0 ][ 0 ].y = ( V2Line[ 0 ].x * V1Line[ 0 ].z - V2Line[ 0 ].z * V1Line[ 0 ].x ) / ( V2Line[ 0 ].y * V1Line[ 0 ].x - V2Line[ 0 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 1 ][ 0 ][ 1 ].x = ( V1Line[ 1 ].z * V2Line[ 0 ].y - V2Line[ 0 ].z * V1Line[ 1 ].y ) / ( V2Line[ 0 ].x * V1Line[ 1 ].y - V1Line[ 1 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 1 ][ 0 ][ 1 ].y = ( V2Line[ 0 ].x * V1Line[ 1 ].z - V2Line[ 0 ].z * V1Line[ 1 ].x ) / ( V2Line[ 0 ].y * V1Line[ 1 ].x - V2Line[ 0 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 1 ][ 1 ][ 0 ].x = ( V1Line[ 0 ].z * V2Line[ 1 ].y - V2Line[ 1 ].z * V1Line[ 0 ].y ) / ( V2Line[ 1 ].x * V1Line[ 0 ].y - V1Line[ 0 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 1 ][ 1 ][ 0 ].y = ( V2Line[ 1 ].x * V1Line[ 0 ].z - V2Line[ 1 ].z * V1Line[ 0 ].x ) / ( V2Line[ 1 ].y * V1Line[ 0 ].x - V2Line[ 1 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 1 ][ 1 ][ 1 ].x = ( V1Line[ 1 ].z * V2Line[ 1 ].y - V2Line[ 1 ].z * V1Line[ 1 ].y ) / ( V2Line[ 1 ].x * V1Line[ 1 ].y - V1Line[ 1 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 1 ][ 1 ][ 1 ].y = ( V2Line[ 1 ].x * V1Line[ 1 ].z - V2Line[ 1 ].z * V1Line[ 1 ].x ) / ( V2Line[ 1 ].y * V1Line[ 1 ].x - V2Line[ 1 ].x * V1Line[ 1 ].y ) ;

		VPosD[ 2 ][ 0 ][ 0 ].x = ( V2Line[ 0 ].z * V3Line[ 0 ].y - V3Line[ 0 ].z * V2Line[ 0 ].y ) / ( V3Line[ 0 ].x * V2Line[ 0 ].y - V2Line[ 0 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 2 ][ 0 ][ 0 ].y = ( V3Line[ 0 ].x * V2Line[ 0 ].z - V3Line[ 0 ].z * V2Line[ 0 ].x ) / ( V3Line[ 0 ].y * V2Line[ 0 ].x - V3Line[ 0 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 2 ][ 0 ][ 1 ].x = ( V2Line[ 1 ].z * V3Line[ 0 ].y - V3Line[ 0 ].z * V2Line[ 1 ].y ) / ( V3Line[ 0 ].x * V2Line[ 1 ].y - V2Line[ 1 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 2 ][ 0 ][ 1 ].y = ( V3Line[ 0 ].x * V2Line[ 1 ].z - V3Line[ 0 ].z * V2Line[ 1 ].x ) / ( V3Line[ 0 ].y * V2Line[ 1 ].x - V3Line[ 0 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 2 ][ 1 ][ 0 ].x = ( V2Line[ 0 ].z * V3Line[ 1 ].y - V3Line[ 1 ].z * V2Line[ 0 ].y ) / ( V3Line[ 1 ].x * V2Line[ 0 ].y - V2Line[ 0 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 2 ][ 1 ][ 0 ].y = ( V3Line[ 1 ].x * V2Line[ 0 ].z - V3Line[ 1 ].z * V2Line[ 0 ].x ) / ( V3Line[ 1 ].y * V2Line[ 0 ].x - V3Line[ 1 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 2 ][ 1 ][ 1 ].x = ( V2Line[ 1 ].z * V3Line[ 1 ].y - V3Line[ 1 ].z * V2Line[ 1 ].y ) / ( V3Line[ 1 ].x * V2Line[ 1 ].y - V2Line[ 1 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 2 ][ 1 ][ 1 ].y = ( V3Line[ 1 ].x * V2Line[ 1 ].z - V3Line[ 1 ].z * V2Line[ 1 ].x ) / ( V3Line[ 1 ].y * V2Line[ 1 ].x - V3Line[ 1 ].x * V2Line[ 1 ].y ) ;

		VPosD[ 3 ][ 0 ][ 0 ].x = ( V3Line[ 0 ].z * V4Line[ 0 ].y - V4Line[ 0 ].z * V3Line[ 0 ].y ) / ( V4Line[ 0 ].x * V3Line[ 0 ].y - V3Line[ 0 ].x * V4Line[ 0 ].y ) ;
		VPosD[ 3 ][ 0 ][ 0 ].y = ( V4Line[ 0 ].x * V3Line[ 0 ].z - V4Line[ 0 ].z * V3Line[ 0 ].x ) / ( V4Line[ 0 ].y * V3Line[ 0 ].x - V4Line[ 0 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 3 ][ 0 ][ 1 ].x = ( V3Line[ 1 ].z * V4Line[ 0 ].y - V4Line[ 0 ].z * V3Line[ 1 ].y ) / ( V4Line[ 0 ].x * V3Line[ 1 ].y - V3Line[ 1 ].x * V4Line[ 0 ].y ) ;
		VPosD[ 3 ][ 0 ][ 1 ].y = ( V4Line[ 0 ].x * V3Line[ 1 ].z - V4Line[ 0 ].z * V3Line[ 1 ].x ) / ( V4Line[ 0 ].y * V3Line[ 1 ].x - V4Line[ 0 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 3 ][ 1 ][ 0 ].x = ( V3Line[ 0 ].z * V4Line[ 1 ].y - V4Line[ 1 ].z * V3Line[ 0 ].y ) / ( V4Line[ 1 ].x * V3Line[ 0 ].y - V3Line[ 0 ].x * V4Line[ 1 ].y ) ;
		VPosD[ 3 ][ 1 ][ 0 ].y = ( V4Line[ 1 ].x * V3Line[ 0 ].z - V4Line[ 1 ].z * V3Line[ 0 ].x ) / ( V4Line[ 1 ].y * V3Line[ 0 ].x - V4Line[ 1 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 3 ][ 1 ][ 1 ].x = ( V3Line[ 1 ].z * V4Line[ 1 ].y - V4Line[ 1 ].z * V3Line[ 1 ].y ) / ( V4Line[ 1 ].x * V3Line[ 1 ].y - V3Line[ 1 ].x * V4Line[ 1 ].y ) ;
		VPosD[ 3 ][ 1 ][ 1 ].y = ( V4Line[ 1 ].x * V3Line[ 1 ].z - V4Line[ 1 ].z * V3Line[ 1 ].x ) / ( V4Line[ 1 ].y * V3Line[ 1 ].x - V4Line[ 1 ].x * V3Line[ 1 ].y ) ;

		Vertex = ParamVertex ;
		n = 1 ;
		for( i = 0 ; i < 4 ; i++ )
		{
			Vertex[ 0 ].x = VPosD[ i ][ 0 ][ 1 ].x ;
			Vertex[ 0 ].y = VPosD[ i ][ 0 ][ 1 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 0 ][ 0 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 0 ][ 0 ].y ;
			Vertex[ 2 ].x = VPosD[ i ][ 1 ][ 1 ].x ;
			Vertex[ 2 ].y = VPosD[ i ][ 1 ][ 1 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 1 ][ 0 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 1 ][ 0 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 0 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 0 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;



			Vertex[ 0 ].x = VPosD[ n ][ 1 ][ 0 ].x ;
			Vertex[ 0 ].y = VPosD[ n ][ 1 ][ 0 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 0 ][ 1 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 0 ][ 1 ].y ;
			Vertex[ 2 ].x = VPosD[ n ][ 1 ][ 1 ].x ;
			Vertex[ 2 ].y = VPosD[ n ][ 1 ][ 1 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 1 ][ 1 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 1 ][ 1 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;


			n = n == 3 ? 0 : n + 1 ;
		}
	}
	else
	{
		Param.QuadrangleNum = 4 * 12 ;

		GrHandle = Graphics_Image_GetLineBoxTexHandle( IS_PMA_DRAWBLENDMODE ) ;

		Param.GraphHandle = GrHandle ;

		LineThickness /= 2.0f ;
		tmp1 =  LineThickness + 1.5f ;
		tmp2 =  LineThickness - 2.5f ;
		tmp3 = -LineThickness + 1.5f ;
		tmp4 = -LineThickness - 2.5f ;
		CmpDistance = LineThickness * 2.0f + 6.0f ;
		CmpDistance *= CmpDistance ;

//		P1P2X = x2 - x1 ;
//		P1P2Y = y2 - y1 ;
//
//		P1P3X = x3 - x1 ;
//		P1P3Y = y3 - y1 ;
//
//		P1P4X = x4 - x1 ;
//		P1P4Y = y4 - y1 ;
//
//		if( P1P2X * P1P3Y - P1P2Y * P1P3X < 0.0f )
//		{
//			TempF = x2 ; x2 = x3 ; x3 = TempF ;
//			TempF = y2 ; y2 = y3 ; y3 = TempF ;
//		}

		V1Pos.x  = x1 ;			V1Pos.y  = y1 ;			V1Pos.z  = 0.0f ;
		V1Dir.x  = x2 - x1 ;	V1Dir.y  = y2 - y1 ;	V1Dir.z  = 0.0f ;
//		V12Dir = V1Dir;
		Distance = V1Dir.x * V1Dir.x + V1Dir.y * V1Dir.y ;
		if( Distance < CmpDistance )
		{
			NormalDraw = TRUE ;
			goto END ;
		}
		Distance = _SQRT( Distance ) ;
		V1Dir.x /= Distance ;
		V1Dir.y /= Distance ;
		V1Norm.x =  V1Dir.y ;
		V1Norm.y = -V1Dir.x ;
		V1Norm.z =  0.0f ;
		TempPos = VAdd( V1Pos, VScale( V1Norm, tmp1 ) ) ;
		V1Line[ 0 ].x =  V1Dir.y ;
		V1Line[ 0 ].y = -V1Dir.x ;
		V1Line[ 0 ].z = ( TempPos.x + V1Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V1Dir.y ) ;
		TempPos = VAdd( V1Pos, VScale( V1Norm, tmp2 ) ) ;
		V1Line[ 1 ].x =  V1Dir.y ;
		V1Line[ 1 ].y = -V1Dir.x ;
		V1Line[ 1 ].z = ( TempPos.x + V1Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V1Dir.y ) ;
		TempPos = VAdd( V1Pos, VScale( V1Norm, tmp3 ) ) ;
		V1Line[ 2 ].x =  V1Dir.y ;
		V1Line[ 2 ].y = -V1Dir.x ;
		V1Line[ 2 ].z = ( TempPos.x + V1Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V1Dir.y ) ;
		TempPos = VAdd( V1Pos, VScale( V1Norm, tmp4 ) ) ;
		V1Line[ 3 ].x =  V1Dir.y ;
		V1Line[ 3 ].y = -V1Dir.x ;
		V1Line[ 3 ].z = ( TempPos.x + V1Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V1Dir.y ) ;

		V2Pos.x  = x2 ;			V2Pos.y  = y2 ;			V2Pos.z  = 0.0f ;
		V2Dir.x  = x3 - x2 ;	V2Dir.y  = y3 - y2 ;	V2Dir.z  = 0.0f ;
		Distance = V2Dir.x * V2Dir.x + V2Dir.y * V2Dir.y ;
		if( Distance < CmpDistance )
		{
			NormalDraw = TRUE ;
			goto END ;
		}
		Distance = _SQRT( Distance ) ;
		V2Dir.x /= Distance ;
		V2Dir.y /= Distance ;
		V2Norm.x =  V2Dir.y ;
		V2Norm.y = -V2Dir.x ;
		V2Norm.z =  0.0f ;
		TempPos = VAdd( V2Pos, VScale( V2Norm, tmp1 ) ) ;
		V2Line[ 0 ].x =  V2Dir.y ;
		V2Line[ 0 ].y = -V2Dir.x ;
		V2Line[ 0 ].z = ( TempPos.x + V2Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V2Dir.y ) ;
		TempPos = VAdd( V2Pos, VScale( V2Norm, tmp2 ) ) ;
		V2Line[ 1 ].x =  V2Dir.y ;
		V2Line[ 1 ].y = -V2Dir.x ;
		V2Line[ 1 ].z = ( TempPos.x + V2Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V2Dir.y ) ;
		TempPos = VAdd( V2Pos, VScale( V2Norm, tmp3 ) ) ;
		V2Line[ 2 ].x =  V2Dir.y ;
		V2Line[ 2 ].y = -V2Dir.x ;
		V2Line[ 2 ].z = ( TempPos.x + V2Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V2Dir.y ) ;
		TempPos = VAdd( V2Pos, VScale( V2Norm, tmp4 ) ) ;
		V2Line[ 3 ].x =  V2Dir.y ;
		V2Line[ 3 ].y = -V2Dir.x ;
		V2Line[ 3 ].z = ( TempPos.x + V2Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V2Dir.y ) ;

//		V13Dir.x = x3 - x1 ;    V13Dir.y = y3 - y1 ;	V13Dir.z = 0.0f ;
//		float SizeSq = VSquareSize( VCross( V12Dir, V13Dir ) ) ;
//		if( SizeSq / 2.0f < 7500.0f )
//		{
//			NS_DrawTriangle( _FTOL( x1 ), _FTOL( y1 ), _FTOL( x2 ), _FTOL( y2 ), _FTOL( x3 ), _FTOL( y3 ), Color, TRUE ) ;
//			goto END ;
//		}

		V3Pos.x  = x3 ;			V3Pos.y  = y3 ;			V3Pos.z  = 0.0f ;
		V3Dir.x  = x4 - x3 ;	V3Dir.y  = y4 - y3 ;	V3Dir.z  = 0.0f ;
		Distance = V3Dir.x * V3Dir.x + V3Dir.y * V3Dir.y ;
		if( Distance < CmpDistance )
		{
			NormalDraw = TRUE ;
			goto END ;
		}
		Distance = _SQRT( Distance ) ;
		V3Dir.x /= Distance ;
		V3Dir.y /= Distance ;
		V3Norm.x =  V3Dir.y ;
		V3Norm.y = -V3Dir.x ;
		V3Norm.z =  0.0f ;
		TempPos = VAdd( V3Pos, VScale( V3Norm, tmp1 ) ) ;
		V3Line[ 0 ].x =  V3Dir.y ;
		V3Line[ 0 ].y = -V3Dir.x ;
		V3Line[ 0 ].z = ( TempPos.x + V3Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V3Dir.y ) ;
		TempPos = VAdd( V3Pos, VScale( V3Norm, tmp2 ) ) ;
		V3Line[ 1 ].x =  V3Dir.y ;
		V3Line[ 1 ].y = -V3Dir.x ;
		V3Line[ 1 ].z = ( TempPos.x + V3Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V3Dir.y ) ;
		TempPos = VAdd( V3Pos, VScale( V3Norm, tmp3 ) ) ;
		V3Line[ 2 ].x =  V3Dir.y ;
		V3Line[ 2 ].y = -V3Dir.x ;
		V3Line[ 2 ].z = ( TempPos.x + V3Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V3Dir.y ) ;
		TempPos = VAdd( V3Pos, VScale( V3Norm, tmp4 ) ) ;
		V3Line[ 3 ].x =  V3Dir.y ;
		V3Line[ 3 ].y = -V3Dir.x ;
		V3Line[ 3 ].z = ( TempPos.x + V3Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V3Dir.y ) ;

		V4Pos.x  = x4 ;			V4Pos.y  = y4 ;			V4Pos.z  = 0.0f ;
		V4Dir.x  = x1 - x4 ;	V4Dir.y  = y1 - y4 ;	V4Dir.z  = 0.0f ;
		Distance = V4Dir.x * V4Dir.x + V4Dir.y * V4Dir.y ;
		if( Distance < CmpDistance )
		{
			NormalDraw = TRUE ;
			goto END ;
		}
		Distance = _SQRT( Distance ) ;
		V4Dir.x /= Distance ;
		V4Dir.y /= Distance ;
		V4Norm.x =  V4Dir.y ;
		V4Norm.y = -V4Dir.x ;
		V4Norm.z =  0.0f ;
		TempPos = VAdd( V4Pos, VScale( V4Norm, tmp1 ) ) ;
		V4Line[ 0 ].x =  V4Dir.y ;
		V4Line[ 0 ].y = -V4Dir.x ;
		V4Line[ 0 ].z = ( TempPos.x + V4Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V4Dir.y ) ;
		TempPos = VAdd( V4Pos, VScale( V4Norm, tmp2 ) ) ;
		V4Line[ 1 ].x =  V4Dir.y ;
		V4Line[ 1 ].y = -V4Dir.x ;
		V4Line[ 1 ].z = ( TempPos.x + V4Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V4Dir.y ) ;
		TempPos = VAdd( V4Pos, VScale( V4Norm, tmp3 ) ) ;
		V4Line[ 2 ].x =  V4Dir.y ;
		V4Line[ 2 ].y = -V4Dir.x ;
		V4Line[ 2 ].z = ( TempPos.x + V4Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V4Dir.y ) ;
		TempPos = VAdd( V4Pos, VScale( V4Norm, tmp4 ) ) ;
		V4Line[ 3 ].x =  V4Dir.y ;
		V4Line[ 3 ].y = -V4Dir.x ;
		V4Line[ 3 ].z = ( TempPos.x + V4Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V4Dir.y ) ;


		VPosD[ 0 ][ 0 ][ 0 ].x = ( V4Line[ 0 ].z * V1Line[ 0 ].y - V1Line[ 0 ].z * V4Line[ 0 ].y ) / ( V1Line[ 0 ].x * V4Line[ 0 ].y - V4Line[ 0 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 0 ][ 0 ][ 0 ].y = ( V1Line[ 0 ].x * V4Line[ 0 ].z - V1Line[ 0 ].z * V4Line[ 0 ].x ) / ( V1Line[ 0 ].y * V4Line[ 0 ].x - V1Line[ 0 ].x * V4Line[ 0 ].y ) ;
		VPosD[ 0 ][ 0 ][ 1 ].x = ( V4Line[ 1 ].z * V1Line[ 0 ].y - V1Line[ 0 ].z * V4Line[ 1 ].y ) / ( V1Line[ 0 ].x * V4Line[ 1 ].y - V4Line[ 1 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 0 ][ 0 ][ 1 ].y = ( V1Line[ 0 ].x * V4Line[ 1 ].z - V1Line[ 0 ].z * V4Line[ 1 ].x ) / ( V1Line[ 0 ].y * V4Line[ 1 ].x - V1Line[ 0 ].x * V4Line[ 1 ].y ) ;
		VPosD[ 0 ][ 0 ][ 2 ].x = ( V4Line[ 2 ].z * V1Line[ 0 ].y - V1Line[ 0 ].z * V4Line[ 2 ].y ) / ( V1Line[ 0 ].x * V4Line[ 2 ].y - V4Line[ 2 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 0 ][ 0 ][ 2 ].y = ( V1Line[ 0 ].x * V4Line[ 2 ].z - V1Line[ 0 ].z * V4Line[ 2 ].x ) / ( V1Line[ 0 ].y * V4Line[ 2 ].x - V1Line[ 0 ].x * V4Line[ 2 ].y ) ;
		VPosD[ 0 ][ 0 ][ 3 ].x = ( V4Line[ 3 ].z * V1Line[ 0 ].y - V1Line[ 0 ].z * V4Line[ 3 ].y ) / ( V1Line[ 0 ].x * V4Line[ 3 ].y - V4Line[ 3 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 0 ][ 0 ][ 3 ].y = ( V1Line[ 0 ].x * V4Line[ 3 ].z - V1Line[ 0 ].z * V4Line[ 3 ].x ) / ( V1Line[ 0 ].y * V4Line[ 3 ].x - V1Line[ 0 ].x * V4Line[ 3 ].y ) ;
		VPosD[ 0 ][ 1 ][ 0 ].x = ( V4Line[ 0 ].z * V1Line[ 1 ].y - V1Line[ 1 ].z * V4Line[ 0 ].y ) / ( V1Line[ 1 ].x * V4Line[ 0 ].y - V4Line[ 0 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 0 ][ 1 ][ 0 ].y = ( V1Line[ 1 ].x * V4Line[ 0 ].z - V1Line[ 1 ].z * V4Line[ 0 ].x ) / ( V1Line[ 1 ].y * V4Line[ 0 ].x - V1Line[ 1 ].x * V4Line[ 0 ].y ) ;
		VPosD[ 0 ][ 1 ][ 1 ].x = ( V4Line[ 1 ].z * V1Line[ 1 ].y - V1Line[ 1 ].z * V4Line[ 1 ].y ) / ( V1Line[ 1 ].x * V4Line[ 1 ].y - V4Line[ 1 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 0 ][ 1 ][ 1 ].y = ( V1Line[ 1 ].x * V4Line[ 1 ].z - V1Line[ 1 ].z * V4Line[ 1 ].x ) / ( V1Line[ 1 ].y * V4Line[ 1 ].x - V1Line[ 1 ].x * V4Line[ 1 ].y ) ;
		VPosD[ 0 ][ 1 ][ 2 ].x = ( V4Line[ 2 ].z * V1Line[ 1 ].y - V1Line[ 1 ].z * V4Line[ 2 ].y ) / ( V1Line[ 1 ].x * V4Line[ 2 ].y - V4Line[ 2 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 0 ][ 1 ][ 2 ].y = ( V1Line[ 1 ].x * V4Line[ 2 ].z - V1Line[ 1 ].z * V4Line[ 2 ].x ) / ( V1Line[ 1 ].y * V4Line[ 2 ].x - V1Line[ 1 ].x * V4Line[ 2 ].y ) ;
		VPosD[ 0 ][ 1 ][ 3 ].x = ( V4Line[ 3 ].z * V1Line[ 1 ].y - V1Line[ 1 ].z * V4Line[ 3 ].y ) / ( V1Line[ 1 ].x * V4Line[ 3 ].y - V4Line[ 3 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 0 ][ 1 ][ 3 ].y = ( V1Line[ 1 ].x * V4Line[ 3 ].z - V1Line[ 1 ].z * V4Line[ 3 ].x ) / ( V1Line[ 1 ].y * V4Line[ 3 ].x - V1Line[ 1 ].x * V4Line[ 3 ].y ) ;
		VPosD[ 0 ][ 2 ][ 0 ].x = ( V4Line[ 0 ].z * V1Line[ 2 ].y - V1Line[ 2 ].z * V4Line[ 0 ].y ) / ( V1Line[ 2 ].x * V4Line[ 0 ].y - V4Line[ 0 ].x * V1Line[ 2 ].y ) ;
		VPosD[ 0 ][ 2 ][ 0 ].y = ( V1Line[ 2 ].x * V4Line[ 0 ].z - V1Line[ 2 ].z * V4Line[ 0 ].x ) / ( V1Line[ 2 ].y * V4Line[ 0 ].x - V1Line[ 2 ].x * V4Line[ 0 ].y ) ;
		VPosD[ 0 ][ 2 ][ 1 ].x = ( V4Line[ 1 ].z * V1Line[ 2 ].y - V1Line[ 2 ].z * V4Line[ 1 ].y ) / ( V1Line[ 2 ].x * V4Line[ 1 ].y - V4Line[ 1 ].x * V1Line[ 2 ].y ) ;
		VPosD[ 0 ][ 2 ][ 1 ].y = ( V1Line[ 2 ].x * V4Line[ 1 ].z - V1Line[ 2 ].z * V4Line[ 1 ].x ) / ( V1Line[ 2 ].y * V4Line[ 1 ].x - V1Line[ 2 ].x * V4Line[ 1 ].y ) ;
		VPosD[ 0 ][ 2 ][ 2 ].x = ( V4Line[ 2 ].z * V1Line[ 2 ].y - V1Line[ 2 ].z * V4Line[ 2 ].y ) / ( V1Line[ 2 ].x * V4Line[ 2 ].y - V4Line[ 2 ].x * V1Line[ 2 ].y ) ;
		VPosD[ 0 ][ 2 ][ 2 ].y = ( V1Line[ 2 ].x * V4Line[ 2 ].z - V1Line[ 2 ].z * V4Line[ 2 ].x ) / ( V1Line[ 2 ].y * V4Line[ 2 ].x - V1Line[ 2 ].x * V4Line[ 2 ].y ) ;
		VPosD[ 0 ][ 2 ][ 3 ].x = ( V4Line[ 3 ].z * V1Line[ 2 ].y - V1Line[ 2 ].z * V4Line[ 3 ].y ) / ( V1Line[ 2 ].x * V4Line[ 3 ].y - V4Line[ 3 ].x * V1Line[ 2 ].y ) ;
		VPosD[ 0 ][ 2 ][ 3 ].y = ( V1Line[ 2 ].x * V4Line[ 3 ].z - V1Line[ 2 ].z * V4Line[ 3 ].x ) / ( V1Line[ 2 ].y * V4Line[ 3 ].x - V1Line[ 2 ].x * V4Line[ 3 ].y ) ;
		VPosD[ 0 ][ 3 ][ 0 ].x = ( V4Line[ 0 ].z * V1Line[ 3 ].y - V1Line[ 3 ].z * V4Line[ 0 ].y ) / ( V1Line[ 3 ].x * V4Line[ 0 ].y - V4Line[ 0 ].x * V1Line[ 3 ].y ) ;
		VPosD[ 0 ][ 3 ][ 0 ].y = ( V1Line[ 3 ].x * V4Line[ 0 ].z - V1Line[ 3 ].z * V4Line[ 0 ].x ) / ( V1Line[ 3 ].y * V4Line[ 0 ].x - V1Line[ 3 ].x * V4Line[ 0 ].y ) ;
		VPosD[ 0 ][ 3 ][ 1 ].x = ( V4Line[ 1 ].z * V1Line[ 3 ].y - V1Line[ 3 ].z * V4Line[ 1 ].y ) / ( V1Line[ 3 ].x * V4Line[ 1 ].y - V4Line[ 1 ].x * V1Line[ 3 ].y ) ;
		VPosD[ 0 ][ 3 ][ 1 ].y = ( V1Line[ 3 ].x * V4Line[ 1 ].z - V1Line[ 3 ].z * V4Line[ 1 ].x ) / ( V1Line[ 3 ].y * V4Line[ 1 ].x - V1Line[ 3 ].x * V4Line[ 1 ].y ) ;
		VPosD[ 0 ][ 3 ][ 2 ].x = ( V4Line[ 2 ].z * V1Line[ 3 ].y - V1Line[ 3 ].z * V4Line[ 2 ].y ) / ( V1Line[ 3 ].x * V4Line[ 2 ].y - V4Line[ 2 ].x * V1Line[ 3 ].y ) ;
		VPosD[ 0 ][ 3 ][ 2 ].y = ( V1Line[ 3 ].x * V4Line[ 2 ].z - V1Line[ 3 ].z * V4Line[ 2 ].x ) / ( V1Line[ 3 ].y * V4Line[ 2 ].x - V1Line[ 3 ].x * V4Line[ 2 ].y ) ;
		VPosD[ 0 ][ 3 ][ 3 ].x = ( V4Line[ 3 ].z * V1Line[ 3 ].y - V1Line[ 3 ].z * V4Line[ 3 ].y ) / ( V1Line[ 3 ].x * V4Line[ 3 ].y - V4Line[ 3 ].x * V1Line[ 3 ].y ) ;
		VPosD[ 0 ][ 3 ][ 3 ].y = ( V1Line[ 3 ].x * V4Line[ 3 ].z - V1Line[ 3 ].z * V4Line[ 3 ].x ) / ( V1Line[ 3 ].y * V4Line[ 3 ].x - V1Line[ 3 ].x * V4Line[ 3 ].y ) ;

		VPosD[ 1 ][ 0 ][ 0 ].x = ( V1Line[ 0 ].z * V2Line[ 0 ].y - V2Line[ 0 ].z * V1Line[ 0 ].y ) / ( V2Line[ 0 ].x * V1Line[ 0 ].y - V1Line[ 0 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 1 ][ 0 ][ 0 ].y = ( V2Line[ 0 ].x * V1Line[ 0 ].z - V2Line[ 0 ].z * V1Line[ 0 ].x ) / ( V2Line[ 0 ].y * V1Line[ 0 ].x - V2Line[ 0 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 1 ][ 0 ][ 1 ].x = ( V1Line[ 1 ].z * V2Line[ 0 ].y - V2Line[ 0 ].z * V1Line[ 1 ].y ) / ( V2Line[ 0 ].x * V1Line[ 1 ].y - V1Line[ 1 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 1 ][ 0 ][ 1 ].y = ( V2Line[ 0 ].x * V1Line[ 1 ].z - V2Line[ 0 ].z * V1Line[ 1 ].x ) / ( V2Line[ 0 ].y * V1Line[ 1 ].x - V2Line[ 0 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 1 ][ 0 ][ 2 ].x = ( V1Line[ 2 ].z * V2Line[ 0 ].y - V2Line[ 0 ].z * V1Line[ 2 ].y ) / ( V2Line[ 0 ].x * V1Line[ 2 ].y - V1Line[ 2 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 1 ][ 0 ][ 2 ].y = ( V2Line[ 0 ].x * V1Line[ 2 ].z - V2Line[ 0 ].z * V1Line[ 2 ].x ) / ( V2Line[ 0 ].y * V1Line[ 2 ].x - V2Line[ 0 ].x * V1Line[ 2 ].y ) ;
		VPosD[ 1 ][ 0 ][ 3 ].x = ( V1Line[ 3 ].z * V2Line[ 0 ].y - V2Line[ 0 ].z * V1Line[ 3 ].y ) / ( V2Line[ 0 ].x * V1Line[ 3 ].y - V1Line[ 3 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 1 ][ 0 ][ 3 ].y = ( V2Line[ 0 ].x * V1Line[ 3 ].z - V2Line[ 0 ].z * V1Line[ 3 ].x ) / ( V2Line[ 0 ].y * V1Line[ 3 ].x - V2Line[ 0 ].x * V1Line[ 3 ].y ) ;
		VPosD[ 1 ][ 1 ][ 0 ].x = ( V1Line[ 0 ].z * V2Line[ 1 ].y - V2Line[ 1 ].z * V1Line[ 0 ].y ) / ( V2Line[ 1 ].x * V1Line[ 0 ].y - V1Line[ 0 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 1 ][ 1 ][ 0 ].y = ( V2Line[ 1 ].x * V1Line[ 0 ].z - V2Line[ 1 ].z * V1Line[ 0 ].x ) / ( V2Line[ 1 ].y * V1Line[ 0 ].x - V2Line[ 1 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 1 ][ 1 ][ 1 ].x = ( V1Line[ 1 ].z * V2Line[ 1 ].y - V2Line[ 1 ].z * V1Line[ 1 ].y ) / ( V2Line[ 1 ].x * V1Line[ 1 ].y - V1Line[ 1 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 1 ][ 1 ][ 1 ].y = ( V2Line[ 1 ].x * V1Line[ 1 ].z - V2Line[ 1 ].z * V1Line[ 1 ].x ) / ( V2Line[ 1 ].y * V1Line[ 1 ].x - V2Line[ 1 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 1 ][ 1 ][ 2 ].x = ( V1Line[ 2 ].z * V2Line[ 1 ].y - V2Line[ 1 ].z * V1Line[ 2 ].y ) / ( V2Line[ 1 ].x * V1Line[ 2 ].y - V1Line[ 2 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 1 ][ 1 ][ 2 ].y = ( V2Line[ 1 ].x * V1Line[ 2 ].z - V2Line[ 1 ].z * V1Line[ 2 ].x ) / ( V2Line[ 1 ].y * V1Line[ 2 ].x - V2Line[ 1 ].x * V1Line[ 2 ].y ) ;
		VPosD[ 1 ][ 1 ][ 3 ].x = ( V1Line[ 3 ].z * V2Line[ 1 ].y - V2Line[ 1 ].z * V1Line[ 3 ].y ) / ( V2Line[ 1 ].x * V1Line[ 3 ].y - V1Line[ 3 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 1 ][ 1 ][ 3 ].y = ( V2Line[ 1 ].x * V1Line[ 3 ].z - V2Line[ 1 ].z * V1Line[ 3 ].x ) / ( V2Line[ 1 ].y * V1Line[ 3 ].x - V2Line[ 1 ].x * V1Line[ 3 ].y ) ;
		VPosD[ 1 ][ 2 ][ 0 ].x = ( V1Line[ 0 ].z * V2Line[ 2 ].y - V2Line[ 2 ].z * V1Line[ 0 ].y ) / ( V2Line[ 2 ].x * V1Line[ 0 ].y - V1Line[ 0 ].x * V2Line[ 2 ].y ) ;
		VPosD[ 1 ][ 2 ][ 0 ].y = ( V2Line[ 2 ].x * V1Line[ 0 ].z - V2Line[ 2 ].z * V1Line[ 0 ].x ) / ( V2Line[ 2 ].y * V1Line[ 0 ].x - V2Line[ 2 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 1 ][ 2 ][ 1 ].x = ( V1Line[ 1 ].z * V2Line[ 2 ].y - V2Line[ 2 ].z * V1Line[ 1 ].y ) / ( V2Line[ 2 ].x * V1Line[ 1 ].y - V1Line[ 1 ].x * V2Line[ 2 ].y ) ;
		VPosD[ 1 ][ 2 ][ 1 ].y = ( V2Line[ 2 ].x * V1Line[ 1 ].z - V2Line[ 2 ].z * V1Line[ 1 ].x ) / ( V2Line[ 2 ].y * V1Line[ 1 ].x - V2Line[ 2 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 1 ][ 2 ][ 2 ].x = ( V1Line[ 2 ].z * V2Line[ 2 ].y - V2Line[ 2 ].z * V1Line[ 2 ].y ) / ( V2Line[ 2 ].x * V1Line[ 2 ].y - V1Line[ 2 ].x * V2Line[ 2 ].y ) ;
		VPosD[ 1 ][ 2 ][ 2 ].y = ( V2Line[ 2 ].x * V1Line[ 2 ].z - V2Line[ 2 ].z * V1Line[ 2 ].x ) / ( V2Line[ 2 ].y * V1Line[ 2 ].x - V2Line[ 2 ].x * V1Line[ 2 ].y ) ;
		VPosD[ 1 ][ 2 ][ 3 ].x = ( V1Line[ 3 ].z * V2Line[ 2 ].y - V2Line[ 2 ].z * V1Line[ 3 ].y ) / ( V2Line[ 2 ].x * V1Line[ 3 ].y - V1Line[ 3 ].x * V2Line[ 2 ].y ) ;
		VPosD[ 1 ][ 2 ][ 3 ].y = ( V2Line[ 2 ].x * V1Line[ 3 ].z - V2Line[ 2 ].z * V1Line[ 3 ].x ) / ( V2Line[ 2 ].y * V1Line[ 3 ].x - V2Line[ 2 ].x * V1Line[ 3 ].y ) ;
		VPosD[ 1 ][ 3 ][ 0 ].x = ( V1Line[ 0 ].z * V2Line[ 3 ].y - V2Line[ 3 ].z * V1Line[ 0 ].y ) / ( V2Line[ 3 ].x * V1Line[ 0 ].y - V1Line[ 0 ].x * V2Line[ 3 ].y ) ;
		VPosD[ 1 ][ 3 ][ 0 ].y = ( V2Line[ 3 ].x * V1Line[ 0 ].z - V2Line[ 3 ].z * V1Line[ 0 ].x ) / ( V2Line[ 3 ].y * V1Line[ 0 ].x - V2Line[ 3 ].x * V1Line[ 0 ].y ) ;
		VPosD[ 1 ][ 3 ][ 1 ].x = ( V1Line[ 1 ].z * V2Line[ 3 ].y - V2Line[ 3 ].z * V1Line[ 1 ].y ) / ( V2Line[ 3 ].x * V1Line[ 1 ].y - V1Line[ 1 ].x * V2Line[ 3 ].y ) ;
		VPosD[ 1 ][ 3 ][ 1 ].y = ( V2Line[ 3 ].x * V1Line[ 1 ].z - V2Line[ 3 ].z * V1Line[ 1 ].x ) / ( V2Line[ 3 ].y * V1Line[ 1 ].x - V2Line[ 3 ].x * V1Line[ 1 ].y ) ;
		VPosD[ 1 ][ 3 ][ 2 ].x = ( V1Line[ 2 ].z * V2Line[ 3 ].y - V2Line[ 3 ].z * V1Line[ 2 ].y ) / ( V2Line[ 3 ].x * V1Line[ 2 ].y - V1Line[ 2 ].x * V2Line[ 3 ].y ) ;
		VPosD[ 1 ][ 3 ][ 2 ].y = ( V2Line[ 3 ].x * V1Line[ 2 ].z - V2Line[ 3 ].z * V1Line[ 2 ].x ) / ( V2Line[ 3 ].y * V1Line[ 2 ].x - V2Line[ 3 ].x * V1Line[ 2 ].y ) ;
		VPosD[ 1 ][ 3 ][ 3 ].x = ( V1Line[ 3 ].z * V2Line[ 3 ].y - V2Line[ 3 ].z * V1Line[ 3 ].y ) / ( V2Line[ 3 ].x * V1Line[ 3 ].y - V1Line[ 3 ].x * V2Line[ 3 ].y ) ;
		VPosD[ 1 ][ 3 ][ 3 ].y = ( V2Line[ 3 ].x * V1Line[ 3 ].z - V2Line[ 3 ].z * V1Line[ 3 ].x ) / ( V2Line[ 3 ].y * V1Line[ 3 ].x - V2Line[ 3 ].x * V1Line[ 3 ].y ) ;

		VPosD[ 2 ][ 0 ][ 0 ].x = ( V2Line[ 0 ].z * V3Line[ 0 ].y - V3Line[ 0 ].z * V2Line[ 0 ].y ) / ( V3Line[ 0 ].x * V2Line[ 0 ].y - V2Line[ 0 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 2 ][ 0 ][ 0 ].y = ( V3Line[ 0 ].x * V2Line[ 0 ].z - V3Line[ 0 ].z * V2Line[ 0 ].x ) / ( V3Line[ 0 ].y * V2Line[ 0 ].x - V3Line[ 0 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 2 ][ 0 ][ 1 ].x = ( V2Line[ 1 ].z * V3Line[ 0 ].y - V3Line[ 0 ].z * V2Line[ 1 ].y ) / ( V3Line[ 0 ].x * V2Line[ 1 ].y - V2Line[ 1 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 2 ][ 0 ][ 1 ].y = ( V3Line[ 0 ].x * V2Line[ 1 ].z - V3Line[ 0 ].z * V2Line[ 1 ].x ) / ( V3Line[ 0 ].y * V2Line[ 1 ].x - V3Line[ 0 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 2 ][ 0 ][ 2 ].x = ( V2Line[ 2 ].z * V3Line[ 0 ].y - V3Line[ 0 ].z * V2Line[ 2 ].y ) / ( V3Line[ 0 ].x * V2Line[ 2 ].y - V2Line[ 2 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 2 ][ 0 ][ 2 ].y = ( V3Line[ 0 ].x * V2Line[ 2 ].z - V3Line[ 0 ].z * V2Line[ 2 ].x ) / ( V3Line[ 0 ].y * V2Line[ 2 ].x - V3Line[ 0 ].x * V2Line[ 2 ].y ) ;
		VPosD[ 2 ][ 0 ][ 3 ].x = ( V2Line[ 3 ].z * V3Line[ 0 ].y - V3Line[ 0 ].z * V2Line[ 3 ].y ) / ( V3Line[ 0 ].x * V2Line[ 3 ].y - V2Line[ 3 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 2 ][ 0 ][ 3 ].y = ( V3Line[ 0 ].x * V2Line[ 3 ].z - V3Line[ 0 ].z * V2Line[ 3 ].x ) / ( V3Line[ 0 ].y * V2Line[ 3 ].x - V3Line[ 0 ].x * V2Line[ 3 ].y ) ;
		VPosD[ 2 ][ 1 ][ 0 ].x = ( V2Line[ 0 ].z * V3Line[ 1 ].y - V3Line[ 1 ].z * V2Line[ 0 ].y ) / ( V3Line[ 1 ].x * V2Line[ 0 ].y - V2Line[ 0 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 2 ][ 1 ][ 0 ].y = ( V3Line[ 1 ].x * V2Line[ 0 ].z - V3Line[ 1 ].z * V2Line[ 0 ].x ) / ( V3Line[ 1 ].y * V2Line[ 0 ].x - V3Line[ 1 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 2 ][ 1 ][ 1 ].x = ( V2Line[ 1 ].z * V3Line[ 1 ].y - V3Line[ 1 ].z * V2Line[ 1 ].y ) / ( V3Line[ 1 ].x * V2Line[ 1 ].y - V2Line[ 1 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 2 ][ 1 ][ 1 ].y = ( V3Line[ 1 ].x * V2Line[ 1 ].z - V3Line[ 1 ].z * V2Line[ 1 ].x ) / ( V3Line[ 1 ].y * V2Line[ 1 ].x - V3Line[ 1 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 2 ][ 1 ][ 2 ].x = ( V2Line[ 2 ].z * V3Line[ 1 ].y - V3Line[ 1 ].z * V2Line[ 2 ].y ) / ( V3Line[ 1 ].x * V2Line[ 2 ].y - V2Line[ 2 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 2 ][ 1 ][ 2 ].y = ( V3Line[ 1 ].x * V2Line[ 2 ].z - V3Line[ 1 ].z * V2Line[ 2 ].x ) / ( V3Line[ 1 ].y * V2Line[ 2 ].x - V3Line[ 1 ].x * V2Line[ 2 ].y ) ;
		VPosD[ 2 ][ 1 ][ 3 ].x = ( V2Line[ 3 ].z * V3Line[ 1 ].y - V3Line[ 1 ].z * V2Line[ 3 ].y ) / ( V3Line[ 1 ].x * V2Line[ 3 ].y - V2Line[ 3 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 2 ][ 1 ][ 3 ].y = ( V3Line[ 1 ].x * V2Line[ 3 ].z - V3Line[ 1 ].z * V2Line[ 3 ].x ) / ( V3Line[ 1 ].y * V2Line[ 3 ].x - V3Line[ 1 ].x * V2Line[ 3 ].y ) ;
		VPosD[ 2 ][ 2 ][ 0 ].x = ( V2Line[ 0 ].z * V3Line[ 2 ].y - V3Line[ 2 ].z * V2Line[ 0 ].y ) / ( V3Line[ 2 ].x * V2Line[ 0 ].y - V2Line[ 0 ].x * V3Line[ 2 ].y ) ;
		VPosD[ 2 ][ 2 ][ 0 ].y = ( V3Line[ 2 ].x * V2Line[ 0 ].z - V3Line[ 2 ].z * V2Line[ 0 ].x ) / ( V3Line[ 2 ].y * V2Line[ 0 ].x - V3Line[ 2 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 2 ][ 2 ][ 1 ].x = ( V2Line[ 1 ].z * V3Line[ 2 ].y - V3Line[ 2 ].z * V2Line[ 1 ].y ) / ( V3Line[ 2 ].x * V2Line[ 1 ].y - V2Line[ 1 ].x * V3Line[ 2 ].y ) ;
		VPosD[ 2 ][ 2 ][ 1 ].y = ( V3Line[ 2 ].x * V2Line[ 1 ].z - V3Line[ 2 ].z * V2Line[ 1 ].x ) / ( V3Line[ 2 ].y * V2Line[ 1 ].x - V3Line[ 2 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 2 ][ 2 ][ 2 ].x = ( V2Line[ 2 ].z * V3Line[ 2 ].y - V3Line[ 2 ].z * V2Line[ 2 ].y ) / ( V3Line[ 2 ].x * V2Line[ 2 ].y - V2Line[ 2 ].x * V3Line[ 2 ].y ) ;
		VPosD[ 2 ][ 2 ][ 2 ].y = ( V3Line[ 2 ].x * V2Line[ 2 ].z - V3Line[ 2 ].z * V2Line[ 2 ].x ) / ( V3Line[ 2 ].y * V2Line[ 2 ].x - V3Line[ 2 ].x * V2Line[ 2 ].y ) ;
		VPosD[ 2 ][ 2 ][ 3 ].x = ( V2Line[ 3 ].z * V3Line[ 2 ].y - V3Line[ 2 ].z * V2Line[ 3 ].y ) / ( V3Line[ 2 ].x * V2Line[ 3 ].y - V2Line[ 3 ].x * V3Line[ 2 ].y ) ;
		VPosD[ 2 ][ 2 ][ 3 ].y = ( V3Line[ 2 ].x * V2Line[ 3 ].z - V3Line[ 2 ].z * V2Line[ 3 ].x ) / ( V3Line[ 2 ].y * V2Line[ 3 ].x - V3Line[ 2 ].x * V2Line[ 3 ].y ) ;
		VPosD[ 2 ][ 3 ][ 0 ].x = ( V2Line[ 0 ].z * V3Line[ 3 ].y - V3Line[ 3 ].z * V2Line[ 0 ].y ) / ( V3Line[ 3 ].x * V2Line[ 0 ].y - V2Line[ 0 ].x * V3Line[ 3 ].y ) ;
		VPosD[ 2 ][ 3 ][ 0 ].y = ( V3Line[ 3 ].x * V2Line[ 0 ].z - V3Line[ 3 ].z * V2Line[ 0 ].x ) / ( V3Line[ 3 ].y * V2Line[ 0 ].x - V3Line[ 3 ].x * V2Line[ 0 ].y ) ;
		VPosD[ 2 ][ 3 ][ 1 ].x = ( V2Line[ 1 ].z * V3Line[ 3 ].y - V3Line[ 3 ].z * V2Line[ 1 ].y ) / ( V3Line[ 3 ].x * V2Line[ 1 ].y - V2Line[ 1 ].x * V3Line[ 3 ].y ) ;
		VPosD[ 2 ][ 3 ][ 1 ].y = ( V3Line[ 3 ].x * V2Line[ 1 ].z - V3Line[ 3 ].z * V2Line[ 1 ].x ) / ( V3Line[ 3 ].y * V2Line[ 1 ].x - V3Line[ 3 ].x * V2Line[ 1 ].y ) ;
		VPosD[ 2 ][ 3 ][ 2 ].x = ( V2Line[ 2 ].z * V3Line[ 3 ].y - V3Line[ 3 ].z * V2Line[ 2 ].y ) / ( V3Line[ 3 ].x * V2Line[ 2 ].y - V2Line[ 2 ].x * V3Line[ 3 ].y ) ;
		VPosD[ 2 ][ 3 ][ 2 ].y = ( V3Line[ 3 ].x * V2Line[ 2 ].z - V3Line[ 3 ].z * V2Line[ 2 ].x ) / ( V3Line[ 3 ].y * V2Line[ 2 ].x - V3Line[ 3 ].x * V2Line[ 2 ].y ) ;
		VPosD[ 2 ][ 3 ][ 3 ].x = ( V2Line[ 3 ].z * V3Line[ 3 ].y - V3Line[ 3 ].z * V2Line[ 3 ].y ) / ( V3Line[ 3 ].x * V2Line[ 3 ].y - V2Line[ 3 ].x * V3Line[ 3 ].y ) ;
		VPosD[ 2 ][ 3 ][ 3 ].y = ( V3Line[ 3 ].x * V2Line[ 3 ].z - V3Line[ 3 ].z * V2Line[ 3 ].x ) / ( V3Line[ 3 ].y * V2Line[ 3 ].x - V3Line[ 3 ].x * V2Line[ 3 ].y ) ;

		VPosD[ 3 ][ 0 ][ 0 ].x = ( V3Line[ 0 ].z * V4Line[ 0 ].y - V4Line[ 0 ].z * V3Line[ 0 ].y ) / ( V4Line[ 0 ].x * V3Line[ 0 ].y - V3Line[ 0 ].x * V4Line[ 0 ].y ) ;
		VPosD[ 3 ][ 0 ][ 0 ].y = ( V4Line[ 0 ].x * V3Line[ 0 ].z - V4Line[ 0 ].z * V3Line[ 0 ].x ) / ( V4Line[ 0 ].y * V3Line[ 0 ].x - V4Line[ 0 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 3 ][ 0 ][ 1 ].x = ( V3Line[ 1 ].z * V4Line[ 0 ].y - V4Line[ 0 ].z * V3Line[ 1 ].y ) / ( V4Line[ 0 ].x * V3Line[ 1 ].y - V3Line[ 1 ].x * V4Line[ 0 ].y ) ;
		VPosD[ 3 ][ 0 ][ 1 ].y = ( V4Line[ 0 ].x * V3Line[ 1 ].z - V4Line[ 0 ].z * V3Line[ 1 ].x ) / ( V4Line[ 0 ].y * V3Line[ 1 ].x - V4Line[ 0 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 3 ][ 0 ][ 2 ].x = ( V3Line[ 2 ].z * V4Line[ 0 ].y - V4Line[ 0 ].z * V3Line[ 2 ].y ) / ( V4Line[ 0 ].x * V3Line[ 2 ].y - V3Line[ 2 ].x * V4Line[ 0 ].y ) ;
		VPosD[ 3 ][ 0 ][ 2 ].y = ( V4Line[ 0 ].x * V3Line[ 2 ].z - V4Line[ 0 ].z * V3Line[ 2 ].x ) / ( V4Line[ 0 ].y * V3Line[ 2 ].x - V4Line[ 0 ].x * V3Line[ 2 ].y ) ;
		VPosD[ 3 ][ 0 ][ 3 ].x = ( V3Line[ 3 ].z * V4Line[ 0 ].y - V4Line[ 0 ].z * V3Line[ 3 ].y ) / ( V4Line[ 0 ].x * V3Line[ 3 ].y - V3Line[ 3 ].x * V4Line[ 0 ].y ) ;
		VPosD[ 3 ][ 0 ][ 3 ].y = ( V4Line[ 0 ].x * V3Line[ 3 ].z - V4Line[ 0 ].z * V3Line[ 3 ].x ) / ( V4Line[ 0 ].y * V3Line[ 3 ].x - V4Line[ 0 ].x * V3Line[ 3 ].y ) ;
		VPosD[ 3 ][ 1 ][ 0 ].x = ( V3Line[ 0 ].z * V4Line[ 1 ].y - V4Line[ 1 ].z * V3Line[ 0 ].y ) / ( V4Line[ 1 ].x * V3Line[ 0 ].y - V3Line[ 0 ].x * V4Line[ 1 ].y ) ;
		VPosD[ 3 ][ 1 ][ 0 ].y = ( V4Line[ 1 ].x * V3Line[ 0 ].z - V4Line[ 1 ].z * V3Line[ 0 ].x ) / ( V4Line[ 1 ].y * V3Line[ 0 ].x - V4Line[ 1 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 3 ][ 1 ][ 1 ].x = ( V3Line[ 1 ].z * V4Line[ 1 ].y - V4Line[ 1 ].z * V3Line[ 1 ].y ) / ( V4Line[ 1 ].x * V3Line[ 1 ].y - V3Line[ 1 ].x * V4Line[ 1 ].y ) ;
		VPosD[ 3 ][ 1 ][ 1 ].y = ( V4Line[ 1 ].x * V3Line[ 1 ].z - V4Line[ 1 ].z * V3Line[ 1 ].x ) / ( V4Line[ 1 ].y * V3Line[ 1 ].x - V4Line[ 1 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 3 ][ 1 ][ 2 ].x = ( V3Line[ 2 ].z * V4Line[ 1 ].y - V4Line[ 1 ].z * V3Line[ 2 ].y ) / ( V4Line[ 1 ].x * V3Line[ 2 ].y - V3Line[ 2 ].x * V4Line[ 1 ].y ) ;
		VPosD[ 3 ][ 1 ][ 2 ].y = ( V4Line[ 1 ].x * V3Line[ 2 ].z - V4Line[ 1 ].z * V3Line[ 2 ].x ) / ( V4Line[ 1 ].y * V3Line[ 2 ].x - V4Line[ 1 ].x * V3Line[ 2 ].y ) ;
		VPosD[ 3 ][ 1 ][ 3 ].x = ( V3Line[ 3 ].z * V4Line[ 1 ].y - V4Line[ 1 ].z * V3Line[ 3 ].y ) / ( V4Line[ 1 ].x * V3Line[ 3 ].y - V3Line[ 3 ].x * V4Line[ 1 ].y ) ;
		VPosD[ 3 ][ 1 ][ 3 ].y = ( V4Line[ 1 ].x * V3Line[ 3 ].z - V4Line[ 1 ].z * V3Line[ 3 ].x ) / ( V4Line[ 1 ].y * V3Line[ 3 ].x - V4Line[ 1 ].x * V3Line[ 3 ].y ) ;
		VPosD[ 3 ][ 2 ][ 0 ].x = ( V3Line[ 0 ].z * V4Line[ 2 ].y - V4Line[ 2 ].z * V3Line[ 0 ].y ) / ( V4Line[ 2 ].x * V3Line[ 0 ].y - V3Line[ 0 ].x * V4Line[ 2 ].y ) ;
		VPosD[ 3 ][ 2 ][ 0 ].y = ( V4Line[ 2 ].x * V3Line[ 0 ].z - V4Line[ 2 ].z * V3Line[ 0 ].x ) / ( V4Line[ 2 ].y * V3Line[ 0 ].x - V4Line[ 2 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 3 ][ 2 ][ 1 ].x = ( V3Line[ 1 ].z * V4Line[ 2 ].y - V4Line[ 2 ].z * V3Line[ 1 ].y ) / ( V4Line[ 2 ].x * V3Line[ 1 ].y - V3Line[ 1 ].x * V4Line[ 2 ].y ) ;
		VPosD[ 3 ][ 2 ][ 1 ].y = ( V4Line[ 2 ].x * V3Line[ 1 ].z - V4Line[ 2 ].z * V3Line[ 1 ].x ) / ( V4Line[ 2 ].y * V3Line[ 1 ].x - V4Line[ 2 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 3 ][ 2 ][ 2 ].x = ( V3Line[ 2 ].z * V4Line[ 2 ].y - V4Line[ 2 ].z * V3Line[ 2 ].y ) / ( V4Line[ 2 ].x * V3Line[ 2 ].y - V3Line[ 2 ].x * V4Line[ 2 ].y ) ;
		VPosD[ 3 ][ 2 ][ 2 ].y = ( V4Line[ 2 ].x * V3Line[ 2 ].z - V4Line[ 2 ].z * V3Line[ 2 ].x ) / ( V4Line[ 2 ].y * V3Line[ 2 ].x - V4Line[ 2 ].x * V3Line[ 2 ].y ) ;
		VPosD[ 3 ][ 2 ][ 3 ].x = ( V3Line[ 3 ].z * V4Line[ 2 ].y - V4Line[ 2 ].z * V3Line[ 3 ].y ) / ( V4Line[ 2 ].x * V3Line[ 3 ].y - V3Line[ 3 ].x * V4Line[ 2 ].y ) ;
		VPosD[ 3 ][ 2 ][ 3 ].y = ( V4Line[ 2 ].x * V3Line[ 3 ].z - V4Line[ 2 ].z * V3Line[ 3 ].x ) / ( V4Line[ 2 ].y * V3Line[ 3 ].x - V4Line[ 2 ].x * V3Line[ 3 ].y ) ;
		VPosD[ 3 ][ 3 ][ 0 ].x = ( V3Line[ 0 ].z * V4Line[ 3 ].y - V4Line[ 3 ].z * V3Line[ 0 ].y ) / ( V4Line[ 3 ].x * V3Line[ 0 ].y - V3Line[ 0 ].x * V4Line[ 3 ].y ) ;
		VPosD[ 3 ][ 3 ][ 0 ].y = ( V4Line[ 3 ].x * V3Line[ 0 ].z - V4Line[ 3 ].z * V3Line[ 0 ].x ) / ( V4Line[ 3 ].y * V3Line[ 0 ].x - V4Line[ 3 ].x * V3Line[ 0 ].y ) ;
		VPosD[ 3 ][ 3 ][ 1 ].x = ( V3Line[ 1 ].z * V4Line[ 3 ].y - V4Line[ 3 ].z * V3Line[ 1 ].y ) / ( V4Line[ 3 ].x * V3Line[ 1 ].y - V3Line[ 1 ].x * V4Line[ 3 ].y ) ;
		VPosD[ 3 ][ 3 ][ 1 ].y = ( V4Line[ 3 ].x * V3Line[ 1 ].z - V4Line[ 3 ].z * V3Line[ 1 ].x ) / ( V4Line[ 3 ].y * V3Line[ 1 ].x - V4Line[ 3 ].x * V3Line[ 1 ].y ) ;
		VPosD[ 3 ][ 3 ][ 2 ].x = ( V3Line[ 2 ].z * V4Line[ 3 ].y - V4Line[ 3 ].z * V3Line[ 2 ].y ) / ( V4Line[ 3 ].x * V3Line[ 2 ].y - V3Line[ 2 ].x * V4Line[ 3 ].y ) ;
		VPosD[ 3 ][ 3 ][ 2 ].y = ( V4Line[ 3 ].x * V3Line[ 2 ].z - V4Line[ 3 ].z * V3Line[ 2 ].x ) / ( V4Line[ 3 ].y * V3Line[ 2 ].x - V4Line[ 3 ].x * V3Line[ 2 ].y ) ;
		VPosD[ 3 ][ 3 ][ 3 ].x = ( V3Line[ 3 ].z * V4Line[ 3 ].y - V4Line[ 3 ].z * V3Line[ 3 ].y ) / ( V4Line[ 3 ].x * V3Line[ 3 ].y - V3Line[ 3 ].x * V4Line[ 3 ].y ) ;
		VPosD[ 3 ][ 3 ][ 3 ].y = ( V4Line[ 3 ].x * V3Line[ 3 ].z - V4Line[ 3 ].z * V3Line[ 3 ].x ) / ( V4Line[ 3 ].y * V3Line[ 3 ].x - V4Line[ 3 ].x * V3Line[ 3 ].y ) ;

		Vertex = ParamVertex ;
		n = 1 ;
		for( i = 0 ; i < 4 ; i++ )
		{
			Vertex[ 0 ].x = VPosD[ i ][ 0 ][ 1 ].x ;
			Vertex[ 0 ].y = VPosD[ i ][ 0 ][ 1 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 0 ][ 0 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 0 ][ 0 ].y ;
			Vertex[ 2 ].x = VPosD[ i ][ 1 ][ 1 ].x ;
			Vertex[ 2 ].y = VPosD[ i ][ 1 ][ 1 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 1 ][ 0 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 1 ][ 0 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 0 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 0 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;

			Vertex[ 0 ].x = VPosD[ i ][ 0 ][ 2 ].x ;
			Vertex[ 0 ].y = VPosD[ i ][ 0 ][ 2 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 0 ][ 1 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 0 ][ 1 ].y ;
			Vertex[ 2 ].x = VPosD[ i ][ 1 ][ 2 ].x ;
			Vertex[ 2 ].y = VPosD[ i ][ 1 ][ 2 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 1 ][ 1 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 1 ][ 1 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;

			Vertex[ 0 ].x = VPosD[ i ][ 0 ][ 3 ].x ;
			Vertex[ 0 ].y = VPosD[ i ][ 0 ][ 3 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 0 ][ 2 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 0 ][ 2 ].y ;
			Vertex[ 2 ].x = VPosD[ i ][ 1 ][ 3 ].x ;
			Vertex[ 2 ].y = VPosD[ i ][ 1 ][ 3 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 1 ][ 2 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 1 ][ 2 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;



			Vertex[ 0 ].x = VPosD[ i ][ 1 ][ 1 ].x ;
			Vertex[ 0 ].y = VPosD[ i ][ 1 ][ 1 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 1 ][ 0 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 1 ][ 0 ].y ;
			Vertex[ 2 ].x = VPosD[ i ][ 2 ][ 1 ].x ;
			Vertex[ 2 ].y = VPosD[ i ][ 2 ][ 1 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 2 ][ 0 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 2 ][ 0 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 0 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 0 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;

			Vertex[ 0 ].x = VPosD[ i ][ 1 ][ 2 ].x ;
			Vertex[ 0 ].y = VPosD[ i ][ 1 ][ 2 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 1 ][ 1 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 1 ][ 1 ].y ;
			Vertex[ 2 ].x = VPosD[ i ][ 2 ][ 2 ].x ;
			Vertex[ 2 ].y = VPosD[ i ][ 2 ][ 2 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 2 ][ 1 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 2 ][ 1 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;

			Vertex[ 0 ].x = VPosD[ i ][ 1 ][ 3 ].x ;
			Vertex[ 0 ].y = VPosD[ i ][ 1 ][ 3 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 1 ][ 2 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 1 ][ 2 ].y ;
			Vertex[ 2 ].x = VPosD[ i ][ 2 ][ 3 ].x ;
			Vertex[ 2 ].y = VPosD[ i ][ 2 ][ 3 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 2 ][ 2 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 2 ][ 2 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;




			Vertex[ 0 ].x = VPosD[ i ][ 2 ][ 1 ].x ;
			Vertex[ 0 ].y = VPosD[ i ][ 2 ][ 1 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 2 ][ 0 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 2 ][ 0 ].y ;
			Vertex[ 2 ].x = VPosD[ i ][ 3 ][ 1 ].x ;
			Vertex[ 2 ].y = VPosD[ i ][ 3 ][ 1 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 3 ][ 0 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 3 ][ 0 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 0 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 0 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;

			Vertex[ 0 ].x = VPosD[ i ][ 2 ][ 2 ].x ;
			Vertex[ 0 ].y = VPosD[ i ][ 2 ][ 2 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 2 ][ 1 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 2 ][ 1 ].y ;
			Vertex[ 2 ].x = VPosD[ i ][ 3 ][ 2 ].x ;
			Vertex[ 2 ].y = VPosD[ i ][ 3 ][ 2 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 3 ][ 1 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 3 ][ 1 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;

			Vertex[ 0 ].x = VPosD[ i ][ 2 ][ 3 ].x ;
			Vertex[ 0 ].y = VPosD[ i ][ 2 ][ 3 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 2 ][ 2 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 2 ][ 2 ].y ;
			Vertex[ 2 ].x = VPosD[ i ][ 3 ][ 3 ].x ;
			Vertex[ 2 ].y = VPosD[ i ][ 3 ][ 3 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 3 ][ 2 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 3 ][ 2 ].y ;

			Vertex[ 0 ].u = Line_In_UV[ 1 ] ;	Vertex[ 0 ].v = Line_In_UV[ 0 ] ;
			Vertex[ 1 ].u = Line_In_UV[ 0 ] ;	Vertex[ 1 ].v = Line_In_UV[ 0 ] ;
			Vertex[ 2 ].u = Line_In_UV[ 1 ] ;	Vertex[ 2 ].v = Line_In_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_In_UV[ 0 ] ;	Vertex[ 3 ].v = Line_In_UV[ 1 ] ;

			Vertex += 4 ;




			Vertex[ 0 ].x = VPosD[ n ][ 3 ][ 0 ].x ;
			Vertex[ 0 ].y = VPosD[ n ][ 3 ][ 0 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 0 ][ 3 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 0 ][ 3 ].y ;
			Vertex[ 2 ].x = VPosD[ n ][ 3 ][ 1 ].x ;
			Vertex[ 2 ].y = VPosD[ n ][ 3 ][ 1 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 1 ][ 3 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 1 ][ 3 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 0 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;


			Vertex[ 0 ].x = VPosD[ n ][ 3 ][ 1 ].x ;
			Vertex[ 0 ].y = VPosD[ n ][ 3 ][ 1 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 1 ][ 3 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 1 ][ 3 ].y ;
			Vertex[ 2 ].x = VPosD[ n ][ 3 ][ 2 ].x ;
			Vertex[ 2 ].y = VPosD[ n ][ 3 ][ 2 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 2 ][ 3 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 2 ][ 3 ].y ;

			Vertex[ 0 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 0 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 1 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 1 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 2 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 2 ].v = Line_Out_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_Out_UV[ 1 ] ;	Vertex[ 3 ].v = Line_Out_UV[ 1 ] ;

			Vertex += 4 ;


			Vertex[ 0 ].x = VPosD[ n ][ 3 ][ 2 ].x ;
			Vertex[ 0 ].y = VPosD[ n ][ 3 ][ 2 ].y ;
			Vertex[ 1 ].x = VPosD[ i ][ 2 ][ 3 ].x ;
			Vertex[ 1 ].y = VPosD[ i ][ 2 ][ 3 ].y ;
			Vertex[ 2 ].x = VPosD[ n ][ 3 ][ 3 ].x ;
			Vertex[ 2 ].y = VPosD[ n ][ 3 ][ 3 ].y ;
			Vertex[ 3 ].x = VPosD[ i ][ 3 ][ 3 ].x ;
			Vertex[ 3 ].y = VPosD[ i ][ 3 ][ 3 ].y ;

			Vertex[ 0 ].u = Line_In_UV[ 1 ] ;	Vertex[ 0 ].v = Line_In_UV[ 0 ] ;
			Vertex[ 1 ].u = Line_In_UV[ 1 ] ;	Vertex[ 1 ].v = Line_In_UV[ 0 ] ;
			Vertex[ 2 ].u = Line_In_UV[ 1 ] ;	Vertex[ 2 ].v = Line_In_UV[ 1 ] ;
			Vertex[ 3 ].u = Line_In_UV[ 1 ] ;	Vertex[ 3 ].v = Line_In_UV[ 1 ] ;

			Vertex += 4 ;


			n = n == 3 ? 0 : n + 1 ;
		}
	}

	Graphics_Draw_DrawSimpleQuadrangleGraphF( &Param ) ;

END :

	AA_DRAW_END

	Graphics_DrawSetting_SetDrawBrightToOneParam( OrigColor ) ;

	if( NormalDraw )
	{
		return NS_DrawQuadrangle( _FTOL( x1 ), _FTOL( y1 ), _FTOL( x2 ), _FTOL( y2 ), _FTOL( x3 ), _FTOL( y3 ), _FTOL( x4 ), _FTOL( y4 ), Color, FALSE ) ;
	}

	// I
	return 0 ;
}

// lp``悷( A`GCAXt )
static int DrawQuadrangleFillAA( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, unsigned int Color )
{
	int GrHandle ;
	GRAPHICS_DRAW_DRAWSIMPLEQUADRANGLEGRAPHF_PARAM Param ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX ParamVertex[ 4 * 2 * 4 + 4 ] ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX *Vertex ;
	VECTOR V1Dir, V1Pos, V1Norm, V1Line[ 2 ] ;
	VECTOR V2Dir, V2Pos, V2Norm, V2Line[ 2 ] ;
	VECTOR V3Dir, V3Pos, V3Norm, V3Line[ 2 ] ;
	VECTOR V4Dir, V4Pos, V4Norm, V4Line[ 2 ] ;
//	VECTOR V12Dir ;
//	VECTOR V13Dir ;
//	VECTOR V14Dir ;
	VECTOR VPosD[ 4 ][ 4 ] ;
	float Distance ;
	VECTOR TempPos ;
	float P1P2X ;
	float P1P2Y ;
//	float P1P3X ;
//	float P1P3Y ;
	float P1P4X ;
	float P1P4Y ;
	float TempF ;
	float CmpDistance = 5.0f * 5.0f ;
	int NormalDraw = FALSE ;
	int i ;
	int n ;
	static float LineUV[ 4 ] = { 0.0f, 3.0f / LINE_TEX_SIZE, 5.0f / LINE_TEX_SIZE, 1.0f };

	if( GSYS.HardInfo.DrawFloatCoordType == DX_DRAWFLOATCOORDTYPE_DIRECT3D9 )
	{
		x1 -= 0.5f ;
		y1 -= 0.5f ;
		x2 -= 0.5f ;
		y2 -= 0.5f ;
		x3 -= 0.5f ;
		y3 -= 0.5f ;
		x4 -= 0.5f ;
		y4 -= 0.5f ;
	}

	AA_DRAW_BEGIN
	AA_DRAW_BEGIN_2

	Param.Vertex        = ParamVertex ;
	Param.TransFlag     = TRUE ;
	Param.QuadrangleNum = 4 * 2 + 1 ;

	GrHandle = Graphics_Image_GetLineTexHandle( IS_PMA_DRAWBLENDMODE ) ;

	Param.GraphHandle = GrHandle ;

	P1P2X = x2 - x1 ;
	P1P2Y = y2 - y1 ;

//	P1P3X = x3 - x1 ;
//	P1P3Y = y3 - y1 ;

	P1P4X = x4 - x1 ;
	P1P4Y = y4 - y1 ;

	if( P1P2X * P1P4Y - P1P2Y * P1P4X < 0.0f )
	{
		TempF = x2 ; x2 = x4 ; x4 = TempF ;
		TempF = y2 ; y2 = y4 ; y4 = TempF ;
	}

	V1Pos.x  = x1 ;			V1Pos.y  = y1 ;			V1Pos.z  = 0.0f ;
	V1Dir.x  = x2 - x1 ;	V1Dir.y  = y2 - y1 ;	V1Dir.z  = 0.0f ;
//	V12Dir = V1Dir;
	Distance = V1Dir.x * V1Dir.x + V1Dir.y * V1Dir.y ;
	if( Distance < CmpDistance )
	{
		NormalDraw = TRUE ;
		goto END ;
	}
	Distance = _SQRT( Distance ) ;
	V1Dir.x /= Distance ;
	V1Dir.y /= Distance ;
	V1Norm.x = V1Dir.y ;	V1Norm.y = -V1Dir.x ;	V1Norm.z = 0.0f ;
	TempPos = VAdd( V1Pos, VScale( V1Norm,  2.0f ) ) ;
	V1Line[ 0 ].x =  V1Dir.y ;
	V1Line[ 0 ].y = -V1Dir.x ;
	V1Line[ 0 ].z = ( TempPos.x + V1Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V1Dir.y ) ;
	TempPos = VAdd( V1Pos, VScale( V1Norm, -1.0f ) ) ;
	V1Line[ 1 ].x =  V1Dir.y ;
	V1Line[ 1 ].y = -V1Dir.x ;
	V1Line[ 1 ].z = ( TempPos.x + V1Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V1Dir.y ) ;

	V2Pos.x  = x2 ;			V2Pos.y  = y2 ;			V2Pos.z  = 0.0f ;
	V2Dir.x  = x3 - x2 ;	V2Dir.y  = y3 - y2 ;	V2Dir.z  = 0.0f ;
	Distance = V2Dir.x * V2Dir.x + V2Dir.y * V2Dir.y ;
	if( Distance < CmpDistance )
	{
		NormalDraw = TRUE ;
		goto END ;
	}
	Distance = _SQRT( Distance ) ;
	V2Dir.x /= Distance ;
	V2Dir.y /= Distance ;
	V2Norm.x = V2Dir.y ;	V2Norm.y = -V2Dir.x ;	V2Norm.z = 0.0f ;
	TempPos = VAdd( V2Pos, VScale( V2Norm,  2.0f ) ) ;
	V2Line[ 0 ].x =  V2Dir.y ;
	V2Line[ 0 ].y = -V2Dir.x ;
	V2Line[ 0 ].z = ( TempPos.x + V2Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V2Dir.y ) ;
	TempPos = VAdd( V2Pos, VScale( V2Norm, -1.0f ) ) ;
	V2Line[ 1 ].x =  V2Dir.y ;
	V2Line[ 1 ].y = -V2Dir.x ;
	V2Line[ 1 ].z = ( TempPos.x + V2Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V2Dir.y ) ;

	V3Pos.x  = x3 ;			V3Pos.y  = y3 ;			V3Pos.z  = 0.0f ;
	V3Dir.x  = x4 - x3 ;	V3Dir.y  = y4 - y3 ;	V3Dir.z  = 0.0f ;
	Distance = V3Dir.x * V3Dir.x + V3Dir.y * V3Dir.y ;
	if( Distance < CmpDistance )
	{
		NormalDraw = TRUE ;
		goto END ;
	}
	Distance = _SQRT( Distance ) ;
	V3Dir.x /= Distance ;
	V3Dir.y /= Distance ;
	V3Norm.x = V3Dir.y ;	V3Norm.y = -V3Dir.x ;	V3Norm.z = 0.0f ;
	TempPos = VAdd( V3Pos, VScale( V3Norm,  2.0f ) ) ;
	V3Line[ 0 ].x =  V3Dir.y ;
	V3Line[ 0 ].y = -V3Dir.x ;
	V3Line[ 0 ].z = ( TempPos.x + V3Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V3Dir.y ) ;
	TempPos = VAdd( V3Pos, VScale( V3Norm, -1.0f ) ) ;
	V3Line[ 1 ].x =  V3Dir.y ;
	V3Line[ 1 ].y = -V3Dir.x ;
	V3Line[ 1 ].z = ( TempPos.x + V3Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V3Dir.y ) ;

	V4Pos.x  = x4 ;			V4Pos.y  = y4 ;			V4Pos.z  = 0.0f ;
	V4Dir.x  = x1 - x4 ;	V4Dir.y  = y1 - y4 ;	V4Dir.z  = 0.0f ;
	Distance = V4Dir.x * V4Dir.x + V4Dir.y * V4Dir.y ;
	if( Distance < CmpDistance )
	{
		NormalDraw = TRUE ;
		goto END ;
	}
	Distance = _SQRT( Distance ) ;
	V4Dir.x /= Distance ;
	V4Dir.y /= Distance ;
	V4Norm.x = V4Dir.y ;	V4Norm.y = -V4Dir.x ;	V4Norm.z = 0.0f ;
	TempPos = VAdd( V4Pos, VScale( V4Norm,  2.0f ) ) ;
	V4Line[ 0 ].x =  V4Dir.y ;
	V4Line[ 0 ].y = -V4Dir.x ;
	V4Line[ 0 ].z = ( TempPos.x + V4Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V4Dir.y ) ;
	TempPos = VAdd( V4Pos, VScale( V4Norm, -1.0f ) ) ;
	V4Line[ 1 ].x =  V4Dir.y ;
	V4Line[ 1 ].y = -V4Dir.x ;
	V4Line[ 1 ].z = ( TempPos.x + V4Dir.x ) * TempPos.y - TempPos.x * ( TempPos.y + V4Dir.y ) ;

//	V13Dir.x = x3 - x1 ;    V13Dir.y = y3 - y1 ;	V13Dir.z = 0.0f ;
//	V14Dir.x = x4 - x1 ;    V14Dir.y = y4 - y1 ;	V14Dir.z = 0.0f ;
//	float SizeSq = VSquareSize( VCross( V12Dir, V13Dir ) ) ;
//	if( SizeSq / 2.0f < 7500.0f )
//	{
//		NS_DrawTriangle( _FTOL( x1 ), _FTOL( y1 ), _FTOL( x2 ), _FTOL( y2 ), _FTOL( x3 ), _FTOL( y3 ), Color, TRUE ) ;
//		goto END ;
//	}


	VPosD[ 0 ][ 0 ].x = ( V4Line[ 0 ].z * V1Line[ 0 ].y - V1Line[ 0 ].z * V4Line[ 0 ].y ) / ( V1Line[ 0 ].x * V4Line[ 0 ].y - V4Line[ 0 ].x * V1Line[ 0 ].y ) ;
	VPosD[ 0 ][ 0 ].y = ( V1Line[ 0 ].x * V4Line[ 0 ].z - V1Line[ 0 ].z * V4Line[ 0 ].x ) / ( V1Line[ 0 ].y * V4Line[ 0 ].x - V1Line[ 0 ].x * V4Line[ 0 ].y ) ;

	VPosD[ 0 ][ 1 ].x = ( V4Line[ 1 ].z * V1Line[ 0 ].y - V1Line[ 0 ].z * V4Line[ 1 ].y ) / ( V1Line[ 0 ].x * V4Line[ 1 ].y - V4Line[ 1 ].x * V1Line[ 0 ].y ) ;
	VPosD[ 0 ][ 1 ].y = ( V1Line[ 0 ].x * V4Line[ 1 ].z - V1Line[ 0 ].z * V4Line[ 1 ].x ) / ( V1Line[ 0 ].y * V4Line[ 1 ].x - V1Line[ 0 ].x * V4Line[ 1 ].y ) ;

	VPosD[ 0 ][ 2 ].x = ( V4Line[ 0 ].z * V1Line[ 1 ].y - V1Line[ 1 ].z * V4Line[ 0 ].y ) / ( V1Line[ 1 ].x * V4Line[ 0 ].y - V4Line[ 0 ].x * V1Line[ 1 ].y ) ;
	VPosD[ 0 ][ 2 ].y = ( V1Line[ 1 ].x * V4Line[ 0 ].z - V1Line[ 1 ].z * V4Line[ 0 ].x ) / ( V1Line[ 1 ].y * V4Line[ 0 ].x - V1Line[ 1 ].x * V4Line[ 0 ].y ) ;

	VPosD[ 0 ][ 3 ].x = ( V4Line[ 1 ].z * V1Line[ 1 ].y - V1Line[ 1 ].z * V4Line[ 1 ].y ) / ( V1Line[ 1 ].x * V4Line[ 1 ].y - V4Line[ 1 ].x * V1Line[ 1 ].y ) ;
	VPosD[ 0 ][ 3 ].y = ( V1Line[ 1 ].x * V4Line[ 1 ].z - V1Line[ 1 ].z * V4Line[ 1 ].x ) / ( V1Line[ 1 ].y * V4Line[ 1 ].x - V1Line[ 1 ].x * V4Line[ 1 ].y ) ;


	VPosD[ 1 ][ 0 ].x = ( V1Line[ 0 ].z * V2Line[ 0 ].y - V2Line[ 0 ].z * V1Line[ 0 ].y ) / ( V2Line[ 0 ].x * V1Line[ 0 ].y - V1Line[ 0 ].x * V2Line[ 0 ].y ) ;
	VPosD[ 1 ][ 0 ].y = ( V2Line[ 0 ].x * V1Line[ 0 ].z - V2Line[ 0 ].z * V1Line[ 0 ].x ) / ( V2Line[ 0 ].y * V1Line[ 0 ].x - V2Line[ 0 ].x * V1Line[ 0 ].y ) ;

	VPosD[ 1 ][ 1 ].x = ( V1Line[ 1 ].z * V2Line[ 0 ].y - V2Line[ 0 ].z * V1Line[ 1 ].y ) / ( V2Line[ 0 ].x * V1Line[ 1 ].y - V1Line[ 1 ].x * V2Line[ 0 ].y ) ;
	VPosD[ 1 ][ 1 ].y = ( V2Line[ 0 ].x * V1Line[ 1 ].z - V2Line[ 0 ].z * V1Line[ 1 ].x ) / ( V2Line[ 0 ].y * V1Line[ 1 ].x - V2Line[ 0 ].x * V1Line[ 1 ].y ) ;

	VPosD[ 1 ][ 2 ].x = ( V1Line[ 0 ].z * V2Line[ 1 ].y - V2Line[ 1 ].z * V1Line[ 0 ].y ) / ( V2Line[ 1 ].x * V1Line[ 0 ].y - V1Line[ 0 ].x * V2Line[ 1 ].y ) ;
	VPosD[ 1 ][ 2 ].y = ( V2Line[ 1 ].x * V1Line[ 0 ].z - V2Line[ 1 ].z * V1Line[ 0 ].x ) / ( V2Line[ 1 ].y * V1Line[ 0 ].x - V2Line[ 1 ].x * V1Line[ 0 ].y ) ;

	VPosD[ 1 ][ 3 ].x = ( V1Line[ 1 ].z * V2Line[ 1 ].y - V2Line[ 1 ].z * V1Line[ 1 ].y ) / ( V2Line[ 1 ].x * V1Line[ 1 ].y - V1Line[ 1 ].x * V2Line[ 1 ].y ) ;
	VPosD[ 1 ][ 3 ].y = ( V2Line[ 1 ].x * V1Line[ 1 ].z - V2Line[ 1 ].z * V1Line[ 1 ].x ) / ( V2Line[ 1 ].y * V1Line[ 1 ].x - V2Line[ 1 ].x * V1Line[ 1 ].y ) ;


	VPosD[ 2 ][ 0 ].x = ( V2Line[ 0 ].z * V3Line[ 0 ].y - V3Line[ 0 ].z * V2Line[ 0 ].y ) / ( V3Line[ 0 ].x * V2Line[ 0 ].y - V2Line[ 0 ].x * V3Line[ 0 ].y ) ;
	VPosD[ 2 ][ 0 ].y = ( V3Line[ 0 ].x * V2Line[ 0 ].z - V3Line[ 0 ].z * V2Line[ 0 ].x ) / ( V3Line[ 0 ].y * V2Line[ 0 ].x - V3Line[ 0 ].x * V2Line[ 0 ].y ) ;

	VPosD[ 2 ][ 1 ].x = ( V2Line[ 1 ].z * V3Line[ 0 ].y - V3Line[ 0 ].z * V2Line[ 1 ].y ) / ( V3Line[ 0 ].x * V2Line[ 1 ].y - V2Line[ 1 ].x * V3Line[ 0 ].y ) ;
	VPosD[ 2 ][ 1 ].y = ( V3Line[ 0 ].x * V2Line[ 1 ].z - V3Line[ 0 ].z * V2Line[ 1 ].x ) / ( V3Line[ 0 ].y * V2Line[ 1 ].x - V3Line[ 0 ].x * V2Line[ 1 ].y ) ;

	VPosD[ 2 ][ 2 ].x = ( V2Line[ 0 ].z * V3Line[ 1 ].y - V3Line[ 1 ].z * V2Line[ 0 ].y ) / ( V3Line[ 1 ].x * V2Line[ 0 ].y - V2Line[ 0 ].x * V3Line[ 1 ].y ) ;
	VPosD[ 2 ][ 2 ].y = ( V3Line[ 1 ].x * V2Line[ 0 ].z - V3Line[ 1 ].z * V2Line[ 0 ].x ) / ( V3Line[ 1 ].y * V2Line[ 0 ].x - V3Line[ 1 ].x * V2Line[ 0 ].y ) ;

	VPosD[ 2 ][ 3 ].x = ( V2Line[ 1 ].z * V3Line[ 1 ].y - V3Line[ 1 ].z * V2Line[ 1 ].y ) / ( V3Line[ 1 ].x * V2Line[ 1 ].y - V2Line[ 1 ].x * V3Line[ 1 ].y ) ;
	VPosD[ 2 ][ 3 ].y = ( V3Line[ 1 ].x * V2Line[ 1 ].z - V3Line[ 1 ].z * V2Line[ 1 ].x ) / ( V3Line[ 1 ].y * V2Line[ 1 ].x - V3Line[ 1 ].x * V2Line[ 1 ].y ) ;


	VPosD[ 3 ][ 0 ].x = ( V3Line[ 0 ].z * V4Line[ 0 ].y - V4Line[ 0 ].z * V3Line[ 0 ].y ) / ( V4Line[ 0 ].x * V3Line[ 0 ].y - V3Line[ 0 ].x * V4Line[ 0 ].y ) ;
	VPosD[ 3 ][ 0 ].y = ( V4Line[ 0 ].x * V3Line[ 0 ].z - V4Line[ 0 ].z * V3Line[ 0 ].x ) / ( V4Line[ 0 ].y * V3Line[ 0 ].x - V4Line[ 0 ].x * V3Line[ 0 ].y ) ;

	VPosD[ 3 ][ 1 ].x = ( V3Line[ 1 ].z * V4Line[ 0 ].y - V4Line[ 0 ].z * V3Line[ 1 ].y ) / ( V4Line[ 0 ].x * V3Line[ 1 ].y - V3Line[ 1 ].x * V4Line[ 0 ].y ) ;
	VPosD[ 3 ][ 1 ].y = ( V4Line[ 0 ].x * V3Line[ 1 ].z - V4Line[ 0 ].z * V3Line[ 1 ].x ) / ( V4Line[ 0 ].y * V3Line[ 1 ].x - V4Line[ 0 ].x * V3Line[ 1 ].y ) ;

	VPosD[ 3 ][ 2 ].x = ( V3Line[ 0 ].z * V4Line[ 1 ].y - V4Line[ 1 ].z * V3Line[ 0 ].y ) / ( V4Line[ 1 ].x * V3Line[ 0 ].y - V3Line[ 0 ].x * V4Line[ 1 ].y ) ;
	VPosD[ 3 ][ 2 ].y = ( V4Line[ 1 ].x * V3Line[ 0 ].z - V4Line[ 1 ].z * V3Line[ 0 ].x ) / ( V4Line[ 1 ].y * V3Line[ 0 ].x - V4Line[ 1 ].x * V3Line[ 0 ].y ) ;

	VPosD[ 3 ][ 3 ].x = ( V3Line[ 1 ].z * V4Line[ 1 ].y - V4Line[ 1 ].z * V3Line[ 1 ].y ) / ( V4Line[ 1 ].x * V3Line[ 1 ].y - V3Line[ 1 ].x * V4Line[ 1 ].y ) ;
	VPosD[ 3 ][ 3 ].y = ( V4Line[ 1 ].x * V3Line[ 1 ].z - V4Line[ 1 ].z * V3Line[ 1 ].x ) / ( V4Line[ 1 ].y * V3Line[ 1 ].x - V4Line[ 1 ].x * V3Line[ 1 ].y ) ;

	Vertex = ParamVertex ;
	n = 1 ;
	for( i = 0 ; i < 4 ; i++ )
	{
		Vertex[ 0 ].x = VPosD[ i ][ 1 ].x ;
		Vertex[ 0 ].y = VPosD[ i ][ 1 ].y ;
		Vertex[ 1 ].x = VPosD[ i ][ 0 ].x ;
		Vertex[ 1 ].y = VPosD[ i ][ 0 ].y ;
		Vertex[ 2 ].x = VPosD[ i ][ 3 ].x ;
		Vertex[ 2 ].y = VPosD[ i ][ 3 ].y ;
		Vertex[ 3 ].x = VPosD[ i ][ 2 ].x ;
		Vertex[ 3 ].y = VPosD[ i ][ 2 ].y ;

		Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 0 ] ;
		Vertex[ 1 ].u = LineUV[ 0 ] ;	Vertex[ 1 ].v = LineUV[ 0 ] ;
		Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;
		Vertex[ 3 ].u = LineUV[ 0 ] ;	Vertex[ 3 ].v = LineUV[ 1 ] ;

		Vertex += 4 ;


		Vertex[ 0 ].x = VPosD[ n ][ 2 ].x ;
		Vertex[ 0 ].y = VPosD[ n ][ 2 ].y ;
		Vertex[ 1 ].x = VPosD[ i ][ 1 ].x ;
		Vertex[ 1 ].y = VPosD[ i ][ 1 ].y ;
		Vertex[ 2 ].x = VPosD[ n ][ 3 ].x ;
		Vertex[ 2 ].y = VPosD[ n ][ 3 ].y ;
		Vertex[ 3 ].x = VPosD[ i ][ 3 ].x ;
		Vertex[ 3 ].y = VPosD[ i ][ 3 ].y ;

		Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 0 ] ;
		Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ 0 ] ;
		Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;
		Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ 1 ] ;

		Vertex += 4 ;

		n = n == 3 ? 0 : n + 1 ;
	}

	Vertex[ 0 ].x = VPosD[ 2 ][ 3 ].x ;
	Vertex[ 0 ].y = VPosD[ 2 ][ 3 ].y ;
	Vertex[ 1 ].x = VPosD[ 3 ][ 3 ].x ;
	Vertex[ 1 ].y = VPosD[ 3 ][ 3 ].y ;
	Vertex[ 2 ].x = VPosD[ 1 ][ 3 ].x ;
	Vertex[ 2 ].y = VPosD[ 1 ][ 3 ].y ;
	Vertex[ 3 ].x = VPosD[ 0 ][ 3 ].x ;
	Vertex[ 3 ].y = VPosD[ 0 ][ 3 ].y ;

	Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 1 ] ;
	Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ 1 ] ;
	Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;
	Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ 1 ] ;

	Graphics_Draw_DrawSimpleQuadrangleGraphF( &Param ) ;

END :

	AA_DRAW_END

	Graphics_DrawSetting_SetDrawBrightToOneParam( OrigColor ) ;

	if( NormalDraw )
	{
		return NS_DrawQuadrangle( _FTOL( x1 ), _FTOL( y1 ), _FTOL( x2 ), _FTOL( y2 ), _FTOL( x3 ), _FTOL( y3 ), _FTOL( x4 ), _FTOL( y4 ), Color, TRUE ) ;
	}

	// I
	return 0 ;
}

// lp``悷( A`GCAXt )
extern int NS_DrawQuadrangleAA( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, unsigned int Color, int FillFlag, float LineThickness )
{
	if( FillFlag == FALSE )
	{
		return DrawQuadrangleLineAA( x1, y1, x2, y2, x3, y3, x4, y4, Color, LineThickness ) ;
	}
	else
	{
		return DrawQuadrangleFillAA( x1, y1, x2, y2, x3, y3, x4, y4, Color ) ;
	}
}

// p̊ۂlp``悷
extern int NS_DrawRoundRect( int x1, int y1, int x2, int y2, int rx, int ry, unsigned int Color, int FillFlag )
{
	RECT  BackupDrawRect ;
	RECTF BackupDrawRectF ;
	int   DrawSizeX ;
	int   DrawSizeY ;
	int   Temp ;

	// Wϊꍇ̓A`GCAXłgp
	if( GSYS.DrawSetting.Valid2DMatrix )
	{
		return NS_DrawRoundRectAA( ( float )x1, ( float )y1, ( float )x2, ( float )y2, ( float )rx, ( float )ry, 16, Color, FillFlag, 1.0f ) ;
	}

	// ``ۑ
	BackupDrawRect  = GSYS.DrawSetting.DrawArea ;
	BackupDrawRectF = GSYS.DrawSetting.DrawAreaF ;

	if( rx <= 0 )
	{
		rx = 1 ;
	}

	if( ry <= 0 )
	{
		ry = 1 ;
	}

	if( x2 < x1 )
	{
		Temp = x1 ;
		x1 = x2 ;
		x2 = Temp ;
	}

	if( y2 < y1 )
	{
		Temp = y1 ;
		y1 = y2 ;
		y2 = Temp ;
	}

	DrawSizeX = x2 - x1 ;
	DrawSizeY = y2 - y1 ;

	if( rx * 2 > DrawSizeX )
	{
		rx = DrawSizeX / 2 ;
	}

	if( ry * 2 > DrawSizeY )
	{
		ry = DrawSizeY / 2 ;
	}

	if( FillFlag )
	{
		NS_DrawBox( x1 + rx, y1,      x2 - rx, y2,      Color, FillFlag ) ;
		NS_DrawBox( x1,      y1 + ry, x1 + rx, y2 - ry, Color, FillFlag ) ;
		NS_DrawBox( x2 - rx, y1 + ry, x2,      y2 - ry, Color, FillFlag ) ;
	}
	else
	{
		NS_SetDrawArea( x1 + rx, y1, x2 - rx, y2 ) ;
		NS_DrawBox( x1, y1, x2, y2, Color, FillFlag ) ;

		NS_SetDrawArea( x1, y1 + ry, x1 + rx, y2 - ry ) ;
		NS_DrawBox( x1, y1, x2, y2, Color, FillFlag ) ;

		NS_SetDrawArea( x2 - rx, y1 + ry, x2, y2 - ry ) ;
		NS_DrawBox( x1, y1, x2, y2, Color, FillFlag ) ;

		NS_SetDrawArea( BackupDrawRect.left, BackupDrawRect.top, BackupDrawRect.right, BackupDrawRect.bottom ) ; 
	}

	SETRECT( GSYS.DrawSetting.DrawArea, x1, y1, x1 + rx, y1 + ry ) ;
	RectClipping_Inline( &GSYS.DrawSetting.DrawArea, &BackupDrawRect ) ;
	SetMemImgDrawArea( &GSYS.DrawSetting.DrawArea ) ;
	GSYS.DrawSetting.DrawAreaF.left   = ( float )GSYS.DrawSetting.DrawArea.left ;
	GSYS.DrawSetting.DrawAreaF.top    = ( float )GSYS.DrawSetting.DrawArea.top ;
	GSYS.DrawSetting.DrawAreaF.right  = ( float )GSYS.DrawSetting.DrawArea.right ;
	GSYS.DrawSetting.DrawAreaF.bottom = ( float )GSYS.DrawSetting.DrawArea.bottom ;
	NS_DrawOval( x1 + rx, y1 + ry, rx, ry, Color, FillFlag, 1 ) ;

	SETRECT( GSYS.DrawSetting.DrawArea, x2 - rx, y1, x2, y1 + ry ) ;
	RectClipping_Inline( &GSYS.DrawSetting.DrawArea, &BackupDrawRect ) ;
	SetMemImgDrawArea( &GSYS.DrawSetting.DrawArea ) ;
	GSYS.DrawSetting.DrawAreaF.left   = ( float )GSYS.DrawSetting.DrawArea.left ;
	GSYS.DrawSetting.DrawAreaF.top    = ( float )GSYS.DrawSetting.DrawArea.top ;
	GSYS.DrawSetting.DrawAreaF.right  = ( float )GSYS.DrawSetting.DrawArea.right ;
	GSYS.DrawSetting.DrawAreaF.bottom = ( float )GSYS.DrawSetting.DrawArea.bottom ;
	NS_DrawOval( x2 - rx - 1, y1 + ry, rx, ry, Color, FillFlag, 1 ) ;

	SETRECT( GSYS.DrawSetting.DrawArea, x1, y2 - ry, x1 + rx, y2 ) ;
	RectClipping_Inline( &GSYS.DrawSetting.DrawArea, &BackupDrawRect ) ;
	SetMemImgDrawArea( &GSYS.DrawSetting.DrawArea ) ;
	GSYS.DrawSetting.DrawAreaF.left   = ( float )GSYS.DrawSetting.DrawArea.left ;
	GSYS.DrawSetting.DrawAreaF.top    = ( float )GSYS.DrawSetting.DrawArea.top ;
	GSYS.DrawSetting.DrawAreaF.right  = ( float )GSYS.DrawSetting.DrawArea.right ;
	GSYS.DrawSetting.DrawAreaF.bottom = ( float )GSYS.DrawSetting.DrawArea.bottom ;
	NS_DrawOval( x1 + rx, y2 - ry - 1, rx, ry, Color, FillFlag, 1 ) ;

	SETRECT( GSYS.DrawSetting.DrawArea, x2 - rx, y2 - ry, x2, y2 ) ;
	RectClipping_Inline( &GSYS.DrawSetting.DrawArea, &BackupDrawRect ) ;
	SetMemImgDrawArea( &GSYS.DrawSetting.DrawArea ) ;
	GSYS.DrawSetting.DrawAreaF.left   = ( float )GSYS.DrawSetting.DrawArea.left ;
	GSYS.DrawSetting.DrawAreaF.top    = ( float )GSYS.DrawSetting.DrawArea.top ;
	GSYS.DrawSetting.DrawAreaF.right  = ( float )GSYS.DrawSetting.DrawArea.right ;
	GSYS.DrawSetting.DrawAreaF.bottom = ( float )GSYS.DrawSetting.DrawArea.bottom ;
	NS_DrawOval( x2 - rx - 1, y2 - ry - 1, rx, ry, Color, FillFlag, 1 ) ;

	// ``ɖ߂
	GSYS.DrawSetting.DrawArea = BackupDrawRect ;
	SetMemImgDrawArea( &BackupDrawRect ) ;
	GSYS.DrawSetting.DrawAreaF = BackupDrawRectF ;

	// I
	return 0 ;
}

// p̊ۂlp``悷( A`GCAXt )
static int DrawRoundRectLineAA( float x1, float y1, float x2, float y2, float rx, float ry, int posnum, unsigned int Color, float LineThickness )
{
	int GrHandle ;
	GRAPHICS_DRAW_DRAWSIMPLEQUADRANGLEGRAPHF_PARAM Param ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX ParamVertex[ CIRCLE_MAX_POSNUM * 3 * 4 + 4 * 4 ] ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX *Vertex ;
	float LinePosX[ 4 ] ;
	float LinePosY[ 4 ] ;
	int i ;
	int j ;
	int k ;
	float Sin, Cos ;
	static float LineUV[ 4 ] = { 0.0f, 3.0f / LINE_TEX_SIZE, 5.0f / LINE_TEX_SIZE, 1.0f };
	float PosX[ 4 ][ CIRCLE_MAX_POSNUM / 2 ][ 4 ] ;
	float PosY[ 4 ][ CIRCLE_MAX_POSNUM / 2 ][ 4 ] ;
	float PosXBase[ 4 ] ;
	float PosYBase[ 4 ] ;

	if( GSYS.HardInfo.DrawFloatCoordType == DX_DRAWFLOATCOORDTYPE_DIRECT3D9 )
	{
		x1 -= 0.5f ;
		y1 -= 0.5f ;
		x2 -= 0.5f ;
		y2 -= 0.5f ;
	}

	PosXBase[ 0 ] = x2 - rx ;
	PosYBase[ 0 ] = y2 - ry ;

	PosXBase[ 1 ] = x1 + rx ;
	PosYBase[ 1 ] = y2 - ry ;

	PosXBase[ 2 ] = x1 + rx ;
	PosYBase[ 2 ] = y1 + ry ;

	PosXBase[ 3 ] = x2 - rx ;
	PosYBase[ 3 ] = y1 + ry ;

	AA_DRAW_BEGIN
	AA_DRAW_BEGIN_2

	Param.Vertex      = ParamVertex ;
	Param.TransFlag   = TRUE ;
	if( LineThickness <= 1.0f )
	{
		static float LineUV_2[ 2 ] = { 0.0f, 4.0f / LINE_TEX_SIZE } ;

		rx += 0.5f ;
		ry += 0.5f ;

		Param.QuadrangleNum = ( posnum - 1 ) * 4 + 4 ;

		GrHandle = Graphics_Image_GetLineOneThicknessTexHandle( IS_PMA_DRAWBLENDMODE ) ;

		Param.GraphHandle = GrHandle ;

		LineThickness /= 2.0f ;
		LinePosX[ 0 ] = rx + LineThickness + 1.5f ;
		LinePosX[ 1 ] = rx - LineThickness - 2.5f ;
		LinePosY[ 0 ] = ry + LineThickness + 1.5f ;
		LinePosY[ 1 ] = ry - LineThickness - 2.5f ;

		for( i = 0; i < posnum ; i++ )
		{
			_TABLE_SINCOS( DX_TWO_PI_F / 4.0f * i / ( posnum - 1 ), &Sin, &Cos ) ;

			PosX[ 0 ][ i ][ 0 ] = LinePosX[ 0 ] * Cos + PosXBase[ 0 ] ;
			PosX[ 0 ][ i ][ 1 ] = LinePosX[ 1 ] * Cos + PosXBase[ 0 ] ;

			PosY[ 0 ][ i ][ 0 ] = LinePosY[ 0 ] * Sin + PosYBase[ 0 ] ;
			PosY[ 0 ][ i ][ 1 ] = LinePosY[ 1 ] * Sin + PosYBase[ 0 ] ;


			PosX[ 1 ][ i ][ 0 ] = LinePosX[ 0 ] * -Sin + PosXBase[ 1 ] ;
			PosX[ 1 ][ i ][ 1 ] = LinePosX[ 1 ] * -Sin + PosXBase[ 1 ] ;

			PosY[ 1 ][ i ][ 0 ] = LinePosY[ 0 ] * Cos + PosYBase[ 1 ] ;
			PosY[ 1 ][ i ][ 1 ] = LinePosY[ 1 ] * Cos + PosYBase[ 1 ] ;


			PosX[ 2 ][ i ][ 0 ] = LinePosX[ 0 ] * -Cos + PosXBase[ 2 ] ;
			PosX[ 2 ][ i ][ 1 ] = LinePosX[ 1 ] * -Cos + PosXBase[ 2 ] ;

			PosY[ 2 ][ i ][ 0 ] = LinePosY[ 0 ] * -Sin + PosYBase[ 2 ] ;
			PosY[ 2 ][ i ][ 1 ] = LinePosY[ 1 ] * -Sin + PosYBase[ 2 ] ;


			PosX[ 3 ][ i ][ 0 ] = LinePosX[ 0 ] * Sin + PosXBase[ 3 ] ;
			PosX[ 3 ][ i ][ 1 ] = LinePosX[ 1 ] * Sin + PosXBase[ 3 ] ;

			PosY[ 3 ][ i ][ 0 ] = LinePosY[ 0 ] * -Cos + PosYBase[ 3 ] ;
			PosY[ 3 ][ i ][ 1 ] = LinePosY[ 1 ] * -Cos + PosYBase[ 3 ] ;
		}

		Vertex = ParamVertex ;
		for( k = 0 ; k < 4 ; k ++ )
		{
			for( i = 0; i < posnum - 1 ; i++ )
			{
				Vertex[ 0 ].x = PosX[ k ][ i + 1 ][ 0 ] ;	Vertex[ 0 ].y = PosY[ k ][ i + 1 ][ 0 ] ;
				Vertex[ 1 ].x = PosX[ k ][ i + 0 ][ 0 ] ;	Vertex[ 1 ].y = PosY[ k ][ i + 0 ][ 0 ] ;
				Vertex[ 2 ].x = PosX[ k ][ i + 1 ][ 1 ] ;	Vertex[ 2 ].y = PosY[ k ][ i + 1 ][ 1 ] ;
				Vertex[ 3 ].x = PosX[ k ][ i + 0 ][ 1 ] ;	Vertex[ 3 ].y = PosY[ k ][ i + 0 ][ 1 ] ;

				Vertex[ 0 ].u = LineUV_2[ 0 ] ;	Vertex[ 0 ].v = LineUV_2[ 1 ] ;
				Vertex[ 1 ].u = LineUV_2[ 0 ] ;	Vertex[ 1 ].v = LineUV_2[ 1 ] ;
				Vertex[ 2 ].u = LineUV_2[ 1 ] ;	Vertex[ 2 ].v = LineUV_2[ 1 ] ;
				Vertex[ 3 ].u = LineUV_2[ 1 ] ;	Vertex[ 3 ].v = LineUV_2[ 1 ] ;

				Vertex += 4 ;
			}
		}

		Vertex[ 0 ].x = PosX[ 1 ][ 0          ][ 0 ] ;	Vertex[ 0 ].y = PosY[ 1 ][ 0          ][ 0 ] ;
		Vertex[ 1 ].x = PosX[ 0 ][ posnum - 1 ][ 0 ] ;	Vertex[ 1 ].y = PosY[ 0 ][ posnum - 1 ][ 0 ] ;
		Vertex[ 2 ].x = PosX[ 1 ][ 0          ][ 1 ] ;	Vertex[ 2 ].y = PosY[ 1 ][ 0          ][ 1 ] ;
		Vertex[ 3 ].x = PosX[ 0 ][ posnum - 1 ][ 1 ] ;	Vertex[ 3 ].y = PosY[ 0 ][ posnum - 1 ][ 1 ] ;

		Vertex[ 0 ].u = LineUV_2[ 0 ] ;	Vertex[ 0 ].v = LineUV_2[ 1 ] ;
		Vertex[ 1 ].u = LineUV_2[ 0 ] ;	Vertex[ 1 ].v = LineUV_2[ 1 ] ;
		Vertex[ 2 ].u = LineUV_2[ 1 ] ;	Vertex[ 2 ].v = LineUV_2[ 1 ] ;
		Vertex[ 3 ].u = LineUV_2[ 1 ] ;	Vertex[ 3 ].v = LineUV_2[ 1 ] ;

		Vertex += 4 ;


		Vertex[ 0 ].x = PosX[ 2 ][ 0          ][ 0 ] ;	Vertex[ 0 ].y = PosY[ 2 ][ 0          ][ 0 ] ;
		Vertex[ 1 ].x = PosX[ 1 ][ posnum - 1 ][ 0 ] ;	Vertex[ 1 ].y = PosY[ 1 ][ posnum - 1 ][ 0 ] ;
		Vertex[ 2 ].x = PosX[ 2 ][ 0          ][ 1 ] ;	Vertex[ 2 ].y = PosY[ 2 ][ 0          ][ 1 ] ;
		Vertex[ 3 ].x = PosX[ 1 ][ posnum - 1 ][ 1 ] ;	Vertex[ 3 ].y = PosY[ 1 ][ posnum - 1 ][ 1 ] ;

		Vertex[ 0 ].u = LineUV_2[ 0 ] ;	Vertex[ 0 ].v = LineUV_2[ 1 ] ;
		Vertex[ 1 ].u = LineUV_2[ 0 ] ;	Vertex[ 1 ].v = LineUV_2[ 1 ] ;
		Vertex[ 2 ].u = LineUV_2[ 1 ] ;	Vertex[ 2 ].v = LineUV_2[ 1 ] ;
		Vertex[ 3 ].u = LineUV_2[ 1 ] ;	Vertex[ 3 ].v = LineUV_2[ 1 ] ;

		Vertex += 4 ;


		Vertex[ 0 ].x = PosX[ 3 ][ 0          ][ 0 ] ;	Vertex[ 0 ].y = PosY[ 3 ][ 0          ][ 0 ] ;
		Vertex[ 1 ].x = PosX[ 2 ][ posnum - 1 ][ 0 ] ;	Vertex[ 1 ].y = PosY[ 2 ][ posnum - 1 ][ 0 ] ;
		Vertex[ 2 ].x = PosX[ 3 ][ 0          ][ 1 ] ;	Vertex[ 2 ].y = PosY[ 3 ][ 0          ][ 1 ] ;
		Vertex[ 3 ].x = PosX[ 2 ][ posnum - 1 ][ 1 ] ;	Vertex[ 3 ].y = PosY[ 2 ][ posnum - 1 ][ 1 ] ;

		Vertex[ 0 ].u = LineUV_2[ 0 ] ;	Vertex[ 0 ].v = LineUV_2[ 1 ] ;
		Vertex[ 1 ].u = LineUV_2[ 0 ] ;	Vertex[ 1 ].v = LineUV_2[ 1 ] ;
		Vertex[ 2 ].u = LineUV_2[ 1 ] ;	Vertex[ 2 ].v = LineUV_2[ 1 ] ;
		Vertex[ 3 ].u = LineUV_2[ 1 ] ;	Vertex[ 3 ].v = LineUV_2[ 1 ] ;

		Vertex += 4 ;


		Vertex[ 0 ].x = PosX[ 0 ][ 0          ][ 0 ] ;	Vertex[ 0 ].y = PosY[ 0 ][ 0          ][ 0 ] ;
		Vertex[ 1 ].x = PosX[ 3 ][ posnum - 1 ][ 0 ] ;	Vertex[ 1 ].y = PosY[ 3 ][ posnum - 1 ][ 0 ] ;
		Vertex[ 2 ].x = PosX[ 0 ][ 0          ][ 1 ] ;	Vertex[ 2 ].y = PosY[ 0 ][ 0          ][ 1 ] ;
		Vertex[ 3 ].x = PosX[ 3 ][ posnum - 1 ][ 1 ] ;	Vertex[ 3 ].y = PosY[ 3 ][ posnum - 1 ][ 1 ] ;

		Vertex[ 0 ].u = LineUV_2[ 0 ] ;	Vertex[ 0 ].v = LineUV_2[ 1 ] ;
		Vertex[ 1 ].u = LineUV_2[ 0 ] ;	Vertex[ 1 ].v = LineUV_2[ 1 ] ;
		Vertex[ 2 ].u = LineUV_2[ 1 ] ;	Vertex[ 2 ].v = LineUV_2[ 1 ] ;
		Vertex[ 3 ].u = LineUV_2[ 1 ] ;	Vertex[ 3 ].v = LineUV_2[ 1 ] ;

		Vertex += 4 ;
	}
	else
	{
		rx += 0.5f ;
		ry += 0.5f ;

		Param.QuadrangleNum = ( ( posnum - 1 ) * 4 + 4 ) * 3  ;

		GrHandle = Graphics_Image_GetLineTexHandle( IS_PMA_DRAWBLENDMODE ) ;

		Param.GraphHandle = GrHandle ;

		LineThickness /= 2.0f ;
		LinePosX[ 0 ] = rx + LineThickness + 1.5f ;
		LinePosX[ 1 ] = rx + LineThickness - 1.5f ;
		LinePosX[ 2 ] = rx - LineThickness + 0.5f ;
		LinePosX[ 3 ] = rx - LineThickness - 2.5f ;
		LinePosY[ 0 ] = ry + LineThickness + 1.5f ;
		LinePosY[ 1 ] = ry + LineThickness - 1.5f ;
		LinePosY[ 2 ] = ry - LineThickness + 0.5f ;
		LinePosY[ 3 ] = ry - LineThickness - 2.5f ;

		for( i = 0; i < posnum ; i++ )
		{
			_TABLE_SINCOS( DX_TWO_PI_F / 4.0f * i / ( posnum - 1 ), &Sin, &Cos ) ;

			PosX[ 0 ][ i ][ 0 ] = LinePosX[ 0 ] * Cos + PosXBase[ 0 ] ;
			PosX[ 0 ][ i ][ 1 ] = LinePosX[ 1 ] * Cos + PosXBase[ 0 ] ;
			PosX[ 0 ][ i ][ 2 ] = LinePosX[ 2 ] * Cos + PosXBase[ 0 ] ;
			PosX[ 0 ][ i ][ 3 ] = LinePosX[ 3 ] * Cos + PosXBase[ 0 ] ;

			PosY[ 0 ][ i ][ 0 ] = LinePosY[ 0 ] * Sin + PosYBase[ 0 ] ;
			PosY[ 0 ][ i ][ 1 ] = LinePosY[ 1 ] * Sin + PosYBase[ 0 ] ;
			PosY[ 0 ][ i ][ 2 ] = LinePosY[ 2 ] * Sin + PosYBase[ 0 ] ;
			PosY[ 0 ][ i ][ 3 ] = LinePosY[ 3 ] * Sin + PosYBase[ 0 ] ;


			PosX[ 1 ][ i ][ 0 ] = LinePosX[ 0 ] * -Sin + PosXBase[ 1 ] ;
			PosX[ 1 ][ i ][ 1 ] = LinePosX[ 1 ] * -Sin + PosXBase[ 1 ] ;
			PosX[ 1 ][ i ][ 2 ] = LinePosX[ 2 ] * -Sin + PosXBase[ 1 ] ;
			PosX[ 1 ][ i ][ 3 ] = LinePosX[ 3 ] * -Sin + PosXBase[ 1 ] ;

			PosY[ 1 ][ i ][ 0 ] = LinePosY[ 0 ] * Cos + PosYBase[ 1 ] ;
			PosY[ 1 ][ i ][ 1 ] = LinePosY[ 1 ] * Cos + PosYBase[ 1 ] ;
			PosY[ 1 ][ i ][ 2 ] = LinePosY[ 2 ] * Cos + PosYBase[ 1 ] ;
			PosY[ 1 ][ i ][ 3 ] = LinePosY[ 3 ] * Cos + PosYBase[ 1 ] ;


			PosX[ 2 ][ i ][ 0 ] = LinePosX[ 0 ] * -Cos + PosXBase[ 2 ] ;
			PosX[ 2 ][ i ][ 1 ] = LinePosX[ 1 ] * -Cos + PosXBase[ 2 ] ;
			PosX[ 2 ][ i ][ 2 ] = LinePosX[ 2 ] * -Cos + PosXBase[ 2 ] ;
			PosX[ 2 ][ i ][ 3 ] = LinePosX[ 3 ] * -Cos + PosXBase[ 2 ] ;

			PosY[ 2 ][ i ][ 0 ] = LinePosY[ 0 ] * -Sin + PosYBase[ 2 ] ;
			PosY[ 2 ][ i ][ 1 ] = LinePosY[ 1 ] * -Sin + PosYBase[ 2 ] ;
			PosY[ 2 ][ i ][ 2 ] = LinePosY[ 2 ] * -Sin + PosYBase[ 2 ] ;
			PosY[ 2 ][ i ][ 3 ] = LinePosY[ 3 ] * -Sin + PosYBase[ 2 ] ;


			PosX[ 3 ][ i ][ 0 ] = LinePosX[ 0 ] * Sin + PosXBase[ 3 ] ;
			PosX[ 3 ][ i ][ 1 ] = LinePosX[ 1 ] * Sin + PosXBase[ 3 ] ;
			PosX[ 3 ][ i ][ 2 ] = LinePosX[ 2 ] * Sin + PosXBase[ 3 ] ;
			PosX[ 3 ][ i ][ 3 ] = LinePosX[ 3 ] * Sin + PosXBase[ 3 ] ;

			PosY[ 3 ][ i ][ 0 ] = LinePosY[ 0 ] * -Cos + PosYBase[ 3 ] ;
			PosY[ 3 ][ i ][ 1 ] = LinePosY[ 1 ] * -Cos + PosYBase[ 3 ] ;
			PosY[ 3 ][ i ][ 2 ] = LinePosY[ 2 ] * -Cos + PosYBase[ 3 ] ;
			PosY[ 3 ][ i ][ 3 ] = LinePosY[ 3 ] * -Cos + PosYBase[ 3 ] ;
		}

		Vertex = ParamVertex ;
		for( k = 0 ; k < 4 ; k ++ )
		{
			for( i = 0; i < posnum - 1 ; i++ )
			{
				for( j = 0; j < 3 ; j++ )
				{
					Vertex[ 0 ].x = PosX[ k ][ i + 1 ][ j + 0 ] ;	Vertex[ 0 ].y = PosY[ k ][ i + 1 ][ j + 0 ] ;
					Vertex[ 1 ].x = PosX[ k ][ i + 0 ][ j + 0 ] ;	Vertex[ 1 ].y = PosY[ k ][ i + 0 ][ j + 0 ] ;
					Vertex[ 2 ].x = PosX[ k ][ i + 1 ][ j + 1 ] ;	Vertex[ 2 ].y = PosY[ k ][ i + 1 ][ j + 1 ] ;
					Vertex[ 3 ].x = PosX[ k ][ i + 0 ][ j + 1 ] ;	Vertex[ 3 ].y = PosY[ k ][ i + 0 ][ j + 1 ] ;

					Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ j + 0 ] ;
					Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ j + 0 ] ;
					Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ j + 1 ] ;
					Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ j + 1 ] ;

					Vertex += 4 ;
				}
			}
		}

		for( j = 0 ; j < 3 ; j ++ )
		{
			Vertex[ 0 ].x = PosX[ 1 ][ 0          ][ j + 0 ] ;	Vertex[ 0 ].y = PosY[ 1 ][ 0          ][ j + 0 ] ;
			Vertex[ 1 ].x = PosX[ 0 ][ posnum - 1 ][ j + 0 ] ;	Vertex[ 1 ].y = PosY[ 0 ][ posnum - 1 ][ j + 0 ] ;
			Vertex[ 2 ].x = PosX[ 1 ][ 0          ][ j + 1 ] ;	Vertex[ 2 ].y = PosY[ 1 ][ 0          ][ j + 1 ] ;
			Vertex[ 3 ].x = PosX[ 0 ][ posnum - 1 ][ j + 1 ] ;	Vertex[ 3 ].y = PosY[ 0 ][ posnum - 1 ][ j + 1 ] ;

			Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ j + 0 ] ;
			Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ j + 0 ] ;
			Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ j + 1 ] ;
			Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ j + 1 ] ;

			Vertex += 4 ;
		}

		for( j = 0 ; j < 3 ; j ++ )
		{
			Vertex[ 0 ].x = PosX[ 2 ][ 0          ][ j + 0 ] ;	Vertex[ 0 ].y = PosY[ 2 ][ 0          ][ j + 0 ] ;
			Vertex[ 1 ].x = PosX[ 1 ][ posnum - 1 ][ j + 0 ] ;	Vertex[ 1 ].y = PosY[ 1 ][ posnum - 1 ][ j + 0 ] ;
			Vertex[ 2 ].x = PosX[ 2 ][ 0          ][ j + 1 ] ;	Vertex[ 2 ].y = PosY[ 2 ][ 0          ][ j + 1 ] ;
			Vertex[ 3 ].x = PosX[ 1 ][ posnum - 1 ][ j + 1 ] ;	Vertex[ 3 ].y = PosY[ 1 ][ posnum - 1 ][ j + 1 ] ;

			Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ j + 0 ] ;
			Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ j + 0 ] ;
			Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ j + 1 ] ;
			Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ j + 1 ] ;

			Vertex += 4 ;
		}

		for( j = 0 ; j < 3 ; j ++ )
		{
			Vertex[ 0 ].x = PosX[ 3 ][ 0          ][ j + 0 ] ;	Vertex[ 0 ].y = PosY[ 3 ][ 0          ][ j + 0 ] ;
			Vertex[ 1 ].x = PosX[ 2 ][ posnum - 1 ][ j + 0 ] ;	Vertex[ 1 ].y = PosY[ 2 ][ posnum - 1 ][ j + 0 ] ;
			Vertex[ 2 ].x = PosX[ 3 ][ 0          ][ j + 1 ] ;	Vertex[ 2 ].y = PosY[ 3 ][ 0          ][ j + 1 ] ;
			Vertex[ 3 ].x = PosX[ 2 ][ posnum - 1 ][ j + 1 ] ;	Vertex[ 3 ].y = PosY[ 2 ][ posnum - 1 ][ j + 1 ] ;

			Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ j + 0 ] ;
			Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ j + 0 ] ;
			Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ j + 1 ] ;
			Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ j + 1 ] ;

			Vertex += 4 ;
		}

		for( j = 0 ; j < 3 ; j ++ )
		{
			Vertex[ 0 ].x = PosX[ 0 ][ 0          ][ j + 0 ] ;	Vertex[ 0 ].y = PosY[ 0 ][ 0          ][ j + 0 ] ;
			Vertex[ 1 ].x = PosX[ 3 ][ posnum - 1 ][ j + 0 ] ;	Vertex[ 1 ].y = PosY[ 3 ][ posnum - 1 ][ j + 0 ] ;
			Vertex[ 2 ].x = PosX[ 0 ][ 0          ][ j + 1 ] ;	Vertex[ 2 ].y = PosY[ 0 ][ 0          ][ j + 1 ] ;
			Vertex[ 3 ].x = PosX[ 3 ][ posnum - 1 ][ j + 1 ] ;	Vertex[ 3 ].y = PosY[ 3 ][ posnum - 1 ][ j + 1 ] ;

			Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ j + 0 ] ;
			Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ j + 0 ] ;
			Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ j + 1 ] ;
			Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ j + 1 ] ;

			Vertex += 4 ;
		}
	}

	Graphics_Draw_DrawSimpleQuadrangleGraphF( &Param ) ;

	AA_DRAW_END

	Graphics_DrawSetting_SetDrawBrightToOneParam( OrigColor ) ;

	// I
	return 0 ;
}

// p̊ۂlp``悷( A`GCAXt )
static int DrawRoundRectFillAA( float x1, float y1, float x2, float y2, float rx, float ry, int posnum, unsigned int Color )
{
	int GrHandle ;
	GRAPHICS_DRAW_DRAWSIMPLETRIANGLEGRAPHF_PARAM Param ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX ParamVertex[ CIRCLE_MAX_POSNUM * ( 6 + 3 ) + 18 * 6 ] ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX *Vertex ;
	float LinePosX[ 2 ] ;
	float LinePosY[ 2 ] ;
	int i, j ;
	float Sin, Cos ;
	static float LineUV[ 4 ] = { 0.0f, 3.0f / LINE_TEX_SIZE, 5.0f / LINE_TEX_SIZE, 1.0f };
	float PosX[ 4 ][ CIRCLE_MAX_POSNUM / 4 ][ 2 ] ;
	float PosY[ 4 ][ CIRCLE_MAX_POSNUM / 4 ][ 2 ] ;
	float PosXBase[ 4 ] ;
	float PosYBase[ 4 ] ;

	rx += 0.5f ;
	ry += 0.5f ;

	if( GSYS.HardInfo.DrawFloatCoordType == DX_DRAWFLOATCOORDTYPE_DIRECT3D9 )
	{
		x1 -= 0.5f ;
		y1 -= 0.5f ;
		x2 -= 0.5f ;
		y2 -= 0.5f ;
	}

	PosXBase[ 0 ] = x2 - rx ;
	PosYBase[ 0 ] = y2 - ry ;

	PosXBase[ 1 ] = x1 + rx ;
	PosYBase[ 1 ] = y2 - ry ;

	PosXBase[ 2 ] = x1 + rx ;
	PosYBase[ 2 ] = y1 + ry ;

	PosXBase[ 3 ] = x2 - rx ;
	PosYBase[ 3 ] = y1 + ry ;

	AA_DRAW_BEGIN
	AA_DRAW_BEGIN_2

	Param.Vertex      = ParamVertex ;
	Param.TransFlag   = TRUE ;
	Param.TriangleNum = ( posnum - 1 ) * 3 * 4 + 18 ;

	GrHandle = Graphics_Image_GetLineTexHandle( IS_PMA_DRAWBLENDMODE ) ;

	Param.GraphHandle = GrHandle ;

	LinePosX[ 0 ] = rx + 2.0f ;
	LinePosX[ 1 ] = rx - 1.0f ;
	LinePosY[ 0 ] = ry + 2.0f ;
	LinePosY[ 1 ] = ry - 1.0f ;

	for( i = 0; i < posnum ; i++ )
	{
		_TABLE_SINCOS( DX_TWO_PI_F / 4.0f * i / ( posnum - 1 ), &Sin, &Cos ) ;

		PosX[ 0 ][ i ][ 0 ] = LinePosX[ 0 ] * Cos  + PosXBase[ 0 ] ;
		PosX[ 0 ][ i ][ 1 ] = LinePosX[ 1 ] * Cos  + PosXBase[ 0 ] ;

		PosY[ 0 ][ i ][ 0 ] = LinePosY[ 0 ] * Sin  + PosYBase[ 0 ] ;
		PosY[ 0 ][ i ][ 1 ] = LinePosY[ 1 ] * Sin  + PosYBase[ 0 ] ;


		PosX[ 1 ][ i ][ 0 ] = LinePosX[ 0 ] * -Sin + PosXBase[ 1 ] ;
		PosX[ 1 ][ i ][ 1 ] = LinePosX[ 1 ] * -Sin + PosXBase[ 1 ] ;

		PosY[ 1 ][ i ][ 0 ] = LinePosY[ 0 ] * Cos  + PosYBase[ 1 ] ;
		PosY[ 1 ][ i ][ 1 ] = LinePosY[ 1 ] * Cos  + PosYBase[ 1 ] ;


		PosX[ 2 ][ i ][ 0 ] = LinePosX[ 0 ] * -Cos + PosXBase[ 2 ] ;
		PosX[ 2 ][ i ][ 1 ] = LinePosX[ 1 ] * -Cos + PosXBase[ 2 ] ;

		PosY[ 2 ][ i ][ 0 ] = LinePosY[ 0 ] * -Sin + PosYBase[ 2 ] ;
		PosY[ 2 ][ i ][ 1 ] = LinePosY[ 1 ] * -Sin + PosYBase[ 2 ] ;


		PosX[ 3 ][ i ][ 0 ] = LinePosX[ 0 ] * Sin  + PosXBase[ 3 ] ;
		PosX[ 3 ][ i ][ 1 ] = LinePosX[ 1 ] * Sin  + PosXBase[ 3 ] ;

		PosY[ 3 ][ i ][ 0 ] = LinePosY[ 0 ] * -Cos + PosYBase[ 3 ] ;
		PosY[ 3 ][ i ][ 1 ] = LinePosY[ 1 ] * -Cos + PosYBase[ 3 ] ;
	}

	Vertex = ParamVertex ;
	for( j = 0 ; j < 4 ; j ++ )
	{
		for( i = 0; i < posnum - 1 ; i++ )
		{
			Vertex[ 0 ].x = PosX[ j ][ i + 1 ][ 0 ] ;	Vertex[ 0 ].y = PosY[ j ][ i + 1 ][ 0 ] ;
			Vertex[ 1 ].x = PosX[ j ][ i + 0 ][ 0 ] ;	Vertex[ 1 ].y = PosY[ j ][ i + 0 ][ 0 ] ;
			Vertex[ 2 ].x = PosX[ j ][ i + 1 ][ 1 ] ;	Vertex[ 2 ].y = PosY[ j ][ i + 1 ][ 1 ] ;
			Vertex[ 3 ].x = PosX[ j ][ i + 0 ][ 1 ] ;	Vertex[ 3 ].y = PosY[ j ][ i + 0 ][ 1 ] ;
			Vertex[ 4 ].x = PosX[ j ][ i + 1 ][ 1 ] ;	Vertex[ 4 ].y = PosY[ j ][ i + 1 ][ 1 ] ;
			Vertex[ 5 ].x = PosX[ j ][ i + 0 ][ 0 ] ;	Vertex[ 5 ].y = PosY[ j ][ i + 0 ][ 0 ] ;

			Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 0 ] ;
			Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ 0 ] ;
			Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;
			Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ 1 ] ;
			Vertex[ 4 ].u = LineUV[ 1 ] ;	Vertex[ 4 ].v = LineUV[ 1 ] ;
			Vertex[ 5 ].u = LineUV[ 1 ] ;	Vertex[ 5 ].v = LineUV[ 0 ] ;

			Vertex += 6 ;


			Vertex[ 0 ].x = PosX[ j ][ i + 1 ][ 1 ] ;	Vertex[ 0 ].y = PosY[ j ][ i + 1 ][ 1 ] ;
			Vertex[ 1 ].x = PosX[ j ][ i + 0 ][ 1 ] ;	Vertex[ 1 ].y = PosY[ j ][ i + 0 ][ 1 ] ;
			Vertex[ 2 ].x = PosXBase[ j ] ;				Vertex[ 2 ].y = PosYBase[ j ] ;

			Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 1 ] ;
			Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ 1 ] ;
			Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;

			Vertex += 3 ;
		}
	}

	Vertex[ 0 ].x = PosX[ 1 ][ 0          ][ 0 ] ;	Vertex[ 0 ].y = PosY[ 1 ][ 0          ][ 0 ] ;
	Vertex[ 1 ].x = PosX[ 0 ][ posnum - 1 ][ 0 ] ;	Vertex[ 1 ].y = PosY[ 0 ][ posnum - 1 ][ 0 ] ;
	Vertex[ 2 ].x = PosX[ 1 ][ 0          ][ 1 ] ;	Vertex[ 2 ].y = PosY[ 1 ][ 0          ][ 1 ] ;
	Vertex[ 3 ].x = PosX[ 0 ][ posnum - 1 ][ 1 ] ;	Vertex[ 3 ].y = PosY[ 0 ][ posnum - 1 ][ 1 ] ;
	Vertex[ 4 ].x = PosX[ 1 ][ 0          ][ 1 ] ;	Vertex[ 4 ].y = PosY[ 1 ][ 0          ][ 1 ] ;
	Vertex[ 5 ].x = PosX[ 0 ][ posnum - 1 ][ 0 ] ;	Vertex[ 5 ].y = PosY[ 0 ][ posnum - 1 ][ 0 ] ;

	Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 0 ] ;
	Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ 0 ] ;
	Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;
	Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ 1 ] ;
	Vertex[ 4 ].u = LineUV[ 1 ] ;	Vertex[ 4 ].v = LineUV[ 1 ] ;
	Vertex[ 5 ].u = LineUV[ 1 ] ;	Vertex[ 5 ].v = LineUV[ 0 ] ;

	Vertex += 6 ;

	Vertex[ 0 ].x = PosX[ 1 ][ 0          ][ 1 ] ;	Vertex[ 0 ].y = PosY[ 1 ][ 0          ][ 1 ] ;
	Vertex[ 1 ].x = PosX[ 0 ][ posnum - 1 ][ 1 ] ;	Vertex[ 1 ].y = PosY[ 0 ][ posnum - 1 ][ 1 ] ;
	Vertex[ 2 ].x = PosXBase[ 1 ] ;					Vertex[ 2 ].y = PosYBase[ 1 ] ;
	Vertex[ 3 ].x = PosXBase[ 0 ] ;					Vertex[ 3 ].y = PosYBase[ 0 ] ;
	Vertex[ 4 ].x = PosXBase[ 1 ] ;					Vertex[ 4 ].y = PosYBase[ 1 ] ;
	Vertex[ 5 ].x = PosX[ 0 ][ posnum - 1 ][ 1 ] ;	Vertex[ 5 ].y = PosY[ 0 ][ posnum - 1 ][ 1 ] ;

	Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 1 ] ;
	Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ 1 ] ;
	Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;
	Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ 1 ] ;
	Vertex[ 4 ].u = LineUV[ 1 ] ;	Vertex[ 4 ].v = LineUV[ 1 ] ;
	Vertex[ 5 ].u = LineUV[ 1 ] ;	Vertex[ 5 ].v = LineUV[ 1 ] ;

	Vertex += 6 ;



	Vertex[ 0 ].x = PosX[ 2 ][ 0          ][ 0 ] ;	Vertex[ 0 ].y = PosY[ 2 ][ 0          ][ 0 ] ;
	Vertex[ 1 ].x = PosX[ 1 ][ posnum - 1 ][ 0 ] ;	Vertex[ 1 ].y = PosY[ 1 ][ posnum - 1 ][ 0 ] ;
	Vertex[ 2 ].x = PosX[ 2 ][ 0          ][ 1 ] ;	Vertex[ 2 ].y = PosY[ 2 ][ 0          ][ 1 ] ;
	Vertex[ 3 ].x = PosX[ 1 ][ posnum - 1 ][ 1 ] ;	Vertex[ 3 ].y = PosY[ 1 ][ posnum - 1 ][ 1 ] ;
	Vertex[ 4 ].x = PosX[ 2 ][ 0          ][ 1 ] ;	Vertex[ 4 ].y = PosY[ 2 ][ 0          ][ 1 ] ;
	Vertex[ 5 ].x = PosX[ 1 ][ posnum - 1 ][ 0 ] ;	Vertex[ 5 ].y = PosY[ 1 ][ posnum - 1 ][ 0 ] ;

	Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 0 ] ;
	Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ 0 ] ;
	Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;
	Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ 1 ] ;
	Vertex[ 4 ].u = LineUV[ 1 ] ;	Vertex[ 4 ].v = LineUV[ 1 ] ;
	Vertex[ 5 ].u = LineUV[ 1 ] ;	Vertex[ 5 ].v = LineUV[ 0 ] ;

	Vertex += 6 ;

	Vertex[ 0 ].x = PosX[ 2 ][ 0          ][ 1 ] ;	Vertex[ 0 ].y = PosY[ 2 ][ 0          ][ 1 ] ;
	Vertex[ 1 ].x = PosX[ 1 ][ posnum - 1 ][ 1 ] ;	Vertex[ 1 ].y = PosY[ 1 ][ posnum - 1 ][ 1 ] ;
	Vertex[ 2 ].x = PosXBase[ 2 ] ;					Vertex[ 2 ].y = PosYBase[ 2 ] ;
	Vertex[ 3 ].x = PosXBase[ 1 ] ;					Vertex[ 3 ].y = PosYBase[ 1 ] ;
	Vertex[ 4 ].x = PosXBase[ 2 ] ;					Vertex[ 4 ].y = PosYBase[ 2 ] ;
	Vertex[ 5 ].x = PosX[ 1 ][ posnum - 1 ][ 1 ] ;	Vertex[ 5 ].y = PosY[ 1 ][ posnum - 1 ][ 1 ] ;

	Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 1 ] ;
	Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ 1 ] ;
	Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;
	Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ 1 ] ;
	Vertex[ 4 ].u = LineUV[ 1 ] ;	Vertex[ 4 ].v = LineUV[ 1 ] ;
	Vertex[ 5 ].u = LineUV[ 1 ] ;	Vertex[ 5 ].v = LineUV[ 1 ] ;

	Vertex += 6 ;



	Vertex[ 0 ].x = PosX[ 3 ][ 0          ][ 0 ] ;	Vertex[ 0 ].y = PosY[ 3 ][ 0          ][ 0 ] ;
	Vertex[ 1 ].x = PosX[ 2 ][ posnum - 1 ][ 0 ] ;	Vertex[ 1 ].y = PosY[ 2 ][ posnum - 1 ][ 0 ] ;
	Vertex[ 2 ].x = PosX[ 3 ][ 0          ][ 1 ] ;	Vertex[ 2 ].y = PosY[ 3 ][ 0          ][ 1 ] ;
	Vertex[ 3 ].x = PosX[ 2 ][ posnum - 1 ][ 1 ] ;	Vertex[ 3 ].y = PosY[ 2 ][ posnum - 1 ][ 1 ] ;
	Vertex[ 4 ].x = PosX[ 3 ][ 0          ][ 1 ] ;	Vertex[ 4 ].y = PosY[ 3 ][ 0          ][ 1 ] ;
	Vertex[ 5 ].x = PosX[ 2 ][ posnum - 1 ][ 0 ] ;	Vertex[ 5 ].y = PosY[ 2 ][ posnum - 1 ][ 0 ] ;

	Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 0 ] ;
	Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ 0 ] ;
	Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;
	Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ 1 ] ;
	Vertex[ 4 ].u = LineUV[ 1 ] ;	Vertex[ 4 ].v = LineUV[ 1 ] ;
	Vertex[ 5 ].u = LineUV[ 1 ] ;	Vertex[ 5 ].v = LineUV[ 0 ] ;

	Vertex += 6 ;

	Vertex[ 0 ].x = PosX[ 3 ][ 0          ][ 1 ] ;	Vertex[ 0 ].y = PosY[ 3 ][ 0          ][ 1 ] ;
	Vertex[ 1 ].x = PosX[ 2 ][ posnum - 1 ][ 1 ] ;	Vertex[ 1 ].y = PosY[ 2 ][ posnum - 1 ][ 1 ] ;
	Vertex[ 2 ].x = PosXBase[ 3 ] ;					Vertex[ 2 ].y = PosYBase[ 3 ] ;
	Vertex[ 3 ].x = PosXBase[ 2 ] ;					Vertex[ 3 ].y = PosYBase[ 2 ] ;
	Vertex[ 4 ].x = PosXBase[ 3 ] ;					Vertex[ 4 ].y = PosYBase[ 3 ] ;
	Vertex[ 5 ].x = PosX[ 2 ][ posnum - 1 ][ 1 ] ;	Vertex[ 5 ].y = PosY[ 2 ][ posnum - 1 ][ 1 ] ;

	Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 1 ] ;
	Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ 1 ] ;
	Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;
	Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ 1 ] ;
	Vertex[ 4 ].u = LineUV[ 1 ] ;	Vertex[ 4 ].v = LineUV[ 1 ] ;
	Vertex[ 5 ].u = LineUV[ 1 ] ;	Vertex[ 5 ].v = LineUV[ 1 ] ;

	Vertex += 6 ;



	Vertex[ 0 ].x = PosX[ 0 ][ 0          ][ 0 ] ;	Vertex[ 0 ].y = PosY[ 0 ][ 0          ][ 0 ] ;
	Vertex[ 1 ].x = PosX[ 3 ][ posnum - 1 ][ 0 ] ;	Vertex[ 1 ].y = PosY[ 3 ][ posnum - 1 ][ 0 ] ;
	Vertex[ 2 ].x = PosX[ 0 ][ 0          ][ 1 ] ;	Vertex[ 2 ].y = PosY[ 0 ][ 0          ][ 1 ] ;
	Vertex[ 3 ].x = PosX[ 3 ][ posnum - 1 ][ 1 ] ;	Vertex[ 3 ].y = PosY[ 3 ][ posnum - 1 ][ 1 ] ;
	Vertex[ 4 ].x = PosX[ 0 ][ 0          ][ 1 ] ;	Vertex[ 4 ].y = PosY[ 0 ][ 0          ][ 1 ] ;
	Vertex[ 5 ].x = PosX[ 3 ][ posnum - 1 ][ 0 ] ;	Vertex[ 5 ].y = PosY[ 3 ][ posnum - 1 ][ 0 ] ;

	Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 0 ] ;
	Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ 0 ] ;
	Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;
	Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ 1 ] ;
	Vertex[ 4 ].u = LineUV[ 1 ] ;	Vertex[ 4 ].v = LineUV[ 1 ] ;
	Vertex[ 5 ].u = LineUV[ 1 ] ;	Vertex[ 5 ].v = LineUV[ 0 ] ;

	Vertex += 6 ;

	Vertex[ 0 ].x = PosX[ 0 ][ 0          ][ 1 ] ;	Vertex[ 0 ].y = PosY[ 0 ][ 0          ][ 1 ] ;
	Vertex[ 1 ].x = PosX[ 3 ][ posnum - 1 ][ 1 ] ;	Vertex[ 1 ].y = PosY[ 3 ][ posnum - 1 ][ 1 ] ;
	Vertex[ 2 ].x = PosXBase[ 0 ] ;					Vertex[ 2 ].y = PosYBase[ 0 ] ;
	Vertex[ 3 ].x = PosXBase[ 3 ] ;					Vertex[ 3 ].y = PosYBase[ 3 ] ;
	Vertex[ 4 ].x = PosXBase[ 0 ] ;					Vertex[ 4 ].y = PosYBase[ 0 ] ;
	Vertex[ 5 ].x = PosX[ 3 ][ posnum - 1 ][ 1 ] ;	Vertex[ 5 ].y = PosY[ 3 ][ posnum - 1 ][ 1 ] ;

	Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 1 ] ;
	Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ 1 ] ;
	Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;
	Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ 1 ] ;
	Vertex[ 4 ].u = LineUV[ 1 ] ;	Vertex[ 4 ].v = LineUV[ 1 ] ;
	Vertex[ 5 ].u = LineUV[ 1 ] ;	Vertex[ 5 ].v = LineUV[ 1 ] ;

	Vertex += 6 ;




	Vertex[ 0 ].x = PosXBase[ 2 ] ;	Vertex[ 0 ].y = PosYBase[ 2 ] ;
	Vertex[ 1 ].x = PosXBase[ 3 ] ;	Vertex[ 1 ].y = PosYBase[ 3 ] ;
	Vertex[ 2 ].x = PosXBase[ 1 ] ;	Vertex[ 2 ].y = PosYBase[ 1 ] ;
	Vertex[ 3 ].x = PosXBase[ 0 ] ;	Vertex[ 3 ].y = PosYBase[ 0 ] ;
	Vertex[ 4 ].x = PosXBase[ 1 ] ;	Vertex[ 4 ].y = PosYBase[ 1 ] ;
	Vertex[ 5 ].x = PosXBase[ 3 ] ;	Vertex[ 5 ].y = PosYBase[ 3 ] ;

	Vertex[ 0 ].u = LineUV[ 1 ] ;	Vertex[ 0 ].v = LineUV[ 1 ] ;
	Vertex[ 1 ].u = LineUV[ 1 ] ;	Vertex[ 1 ].v = LineUV[ 1 ] ;
	Vertex[ 2 ].u = LineUV[ 1 ] ;	Vertex[ 2 ].v = LineUV[ 1 ] ;
	Vertex[ 3 ].u = LineUV[ 1 ] ;	Vertex[ 3 ].v = LineUV[ 1 ] ;
	Vertex[ 4 ].u = LineUV[ 1 ] ;	Vertex[ 4 ].v = LineUV[ 1 ] ;
	Vertex[ 5 ].u = LineUV[ 1 ] ;	Vertex[ 5 ].v = LineUV[ 1 ] ;

	Vertex += 6 ;

	Graphics_Draw_DrawSimpleTriangleGraphF( &Param ) ;

	AA_DRAW_END

	Graphics_DrawSetting_SetDrawBrightToOneParam( OrigColor ) ;

	// I
	return 0 ;
}

// p̊ۂlp``悷( A`GCAXt )
extern int NS_DrawRoundRectAA( float x1, float y1, float x2, float y2, float rx, float ry, int posnum, unsigned int Color, int FillFlag, float LineThickness )
{
	float Temp ;
	float DrawSizeX ;
	float DrawSizeY ;

	if( rx <= 0.0f )
	{
		rx = 1.0f ;
	}

	if( ry <= 0.0f )
	{
		ry = 1.0f ;
	}

	if( x2 < x1 )
	{
		Temp = x1 ;
		x1 = x2 ;
		x2 = Temp ;
	}

	if( y2 < y1 )
	{
		Temp = y1 ;
		y1 = y2 ;
		y2 = Temp ;
	}

	DrawSizeX = x2 - x1 ;
	DrawSizeY = y2 - y1 ;

	if( rx * 2.0f > DrawSizeX )
	{
		rx = DrawSizeX / 2.0f ;
	}

	if( ry * 2 > DrawSizeY )
	{
		ry = DrawSizeY / 2.0f ;
	}

	if( posnum < 2 )
	{
		posnum = 2 ;
	}
	else
	if( posnum > CIRCLE_MAX_POSNUM / 4 )
	{
		posnum = CIRCLE_MAX_POSNUM / 4 ;
	}

	if( FillFlag == FALSE )
	{
		return DrawRoundRectLineAA( x1, y1, x2, y2, rx, ry, posnum, Color, LineThickness ) ;
	}
	else
	{
		return DrawRoundRectFillAA( x1, y1, x2, y2, rx, ry, posnum, Color ) ;
	}
}

// DrawTriangleAA Ȃǂ̃A`GCAXt}``̏s
extern int NS_BeginAADraw( void )
{
	if( GSYS.DrawSetting.AADrawInfoValid )
	{
		return 0 ;
	}

	AA_DRAW_BEGIN

	GSYS.DrawSetting.AADrawOldDrawMode = OldDrawMode ;
	GSYS.DrawSetting.AADrawOldBlendMode = OldBlendMode ;
	GSYS.DrawSetting.AADrawOldBlendParam = OldBlendParam ;
	GSYS.DrawSetting.AADrawOldDrawColor = OrigColor ;

	GSYS.DrawSetting.AADrawInfoValid = TRUE ;

	// I
	return 0 ;
}

// DrawTriangleAA Ȃǂ̃A`GCAXt}``̌ns
extern int NS_EndAADraw( void )
{
	if( GSYS.DrawSetting.AADrawInfoValid == FALSE )
	{
		return 0 ;
	}

	GSYS.DrawSetting.AADrawInfoValid = FALSE ;

	int OldDrawMode = GSYS.DrawSetting.AADrawOldDrawMode ;
	int OldBlendMode = GSYS.DrawSetting.AADrawOldBlendMode ;
	int OldBlendParam = GSYS.DrawSetting.AADrawOldBlendParam ;
	DWORD OrigColor = GSYS.DrawSetting.AADrawOldDrawColor ;

	AA_DRAW_END

	// I
	return 0 ;
}

// _`悷
#define SETDRAWRECTCODE\
	SETRECT( DrawRect, x, y, x + 1, y + 1 )\
	DRAWRECT_DRAWAREA_CLIP
extern 	int NS_DrawPixel( int x, int y, unsigned int Color )
{
	int Ret = -1 ;
	int Flag ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;
	
	Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;

	CheckActiveState() ;

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
//	if( GSYS.DrawSetting.NotUseBasicGraphDraw3DDeviceMethodFlag ) Flag = FALSE ;
	DRAW_DEF(
		Graphics_Hardware_DrawPixel_PF( x, y, Color ),
		Graphics_Software_DrawPixel(    x, y, Color ),
		SETDRAWRECTCODE,
		Ret,
		Flag
	)

	// I
	return Ret ;
}
#undef SETDRAWRECTCODE

// w_狫EFƂ܂œhԂ
extern int NS_Paint( int x, int y, unsigned int FillColor, ULONGLONG BoundaryColor )
{
	// n[hEFAgpĂ邩ǂŏ𕪊
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		// n[hEGA̋@\gpĂꍇ
		if( Graphics_Hardware_Paint_PF( x, y, FillColor, BoundaryColor ) == 2 )
		{
			// QԂĂftHg̏s

			MEMIMG          MemImg ;
			BASEIMAGE       ScreenImage ;
			int             DrawMode ;
			int             DrawBlendMode ;
			int             DrawBlendParam ;
			RGBCOLOR        DrawBright ;
			RECT            DrawArea ;
			const COLORDATA *MemImageColorData ;
			int				Red, Green, Blue ;
//			const COLORDATA *HardwareMainColorData ;

			// ʂ̃C[W擾
			NS_CreateXRGB8ColorBaseImage( GSYS.DrawSetting.DrawSizeX, GSYS.DrawSetting.DrawSizeY, &ScreenImage ) ;
			NS_GetDrawScreenBaseImage( 0, 0, GSYS.DrawSetting.DrawSizeX, GSYS.DrawSetting.DrawSizeY, &ScreenImage ) ;

			// Paint p MEMIMG ZbgAbv
			_MEMSET( &MemImg, 0, sizeof( MEMIMG ) ) ;
			InitializeMemImg(
				&MemImg,
				GSYS.DrawSetting.DrawSizeX,
				GSYS.DrawSetting.DrawSizeY,
				ScreenImage.Pitch,
				0,
				1,
				FALSE, FALSE, FALSE, ScreenImage.GraphData ) ;

			// Paint s
			MemImageColorData     = GetMemImgColorData( 1, FALSE, FALSE ) ;
//			HardwareMainColorData = Graphics_Hardware_GetMainColorData_PF() ;
//			FillColor             = NS_GetColor4( MemImageColorData, HardwareMainColorData, FillColor ) ;
			NS_GetColor2( FillColor, &Red, &Green, &Blue ) ; 
			FillColor             = NS_GetColor3( MemImageColorData, Red, Green, Blue, 255 ) ;
			if( BoundaryColor != ULL_NUM( 0xffffffffffffffff ) )
			{
//				BoundaryColor = ( ULONGLONG )NS_GetColor4( MemImageColorData, HardwareMainColorData, ( unsigned int )BoundaryColor ) ;
				NS_GetColor2( ( unsigned int )BoundaryColor, &Red, &Green, &Blue ) ; 
				BoundaryColor = NS_GetColor3( MemImageColorData, Red, Green, Blue, 255 ) ;
			}
			PaintMemImg( &MemImg, x, y, FillColor, BoundaryColor ) ;

			// MEMIMG ̌n
			TerminateMemImg( &MemImg ) ;

			// ʂɃyCg̉摜`
			DrawBlendMode  = GSYS.DrawSetting.BlendMode ;
			DrawBlendParam = GSYS.DrawSetting.BlendParam ;
			DrawMode       = GSYS.DrawSetting.DrawMode ;
			DrawBright     = GSYS.DrawSetting.DrawBright ;
			DrawArea       = GSYS.DrawSetting.DrawArea ;

			NS_SetDrawBlendMode( DX_BLENDMODE_SRCCOLOR, 255 ) ;
			NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;
			NS_SetDrawBright( 255, 255, 255 ) ;
			NS_SetDrawArea( 0, 0, GSYS.DrawSetting.DrawSizeX, GSYS.DrawSetting.DrawSizeY ) ;

			NS_DrawBaseImage( 0, 0, &ScreenImage ) ;

			NS_SetDrawBlendMode( DrawBlendMode, DrawBlendParam ) ;
			NS_SetDrawMode( DrawMode ) ;
			NS_SetDrawBright( DrawBright.Red, DrawBright.Green, DrawBright.Blue ) ;
			NS_SetDrawArea( DrawArea.left, DrawArea.top, DrawArea.right, DrawArea.bottom ) ;

			NS_ReleaseBaseImage( &ScreenImage ) ;

			// I
			return 0 ;
		}
	}
	else
	{
		MEMIMG *Img ;
		IMAGEDATA *Image ;

		// n[hEGA̋@\gpĂȂꍇ

		// G[
		if( GRAPHCHKFULL( GSYS.DrawSetting.TargetScreen[ 0 ], Image ) )
			Image = NULL ;

		if( Image )
		{
			Img = &Image->Soft.MemImg ;
		}
		else
		{
			Img = &GSYS.SoftRender.MainBufferMemImg ;
		}

		PaintMemImg( Img, x, y, FillColor, BoundaryColor ) ;
	}
	
	// I
	return 0 ;
}

// _̏W`
#define SETDRAWRECTCODE\
	SETRECT( DrawRect, 0, 0, GSYS.DrawSetting.DrawSizeX, GSYS.DrawSetting.DrawSizeY )\
	DRAWRECT_DRAWAREA_CLIP
extern 	int NS_DrawPixelSet( const POINTDATA *PointData, int Num )
{
	int Ret = -1 ;
	int Flag ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;

	CheckActiveState() ;

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawPixelSet_PF( PointData, Num  ),
		Graphics_Software_DrawPixelSet(    PointData, Num  ),
		SETDRAWRECTCODE,
		Ret,
		Flag
	)

	// I
	return Ret ;
}
#undef SETDRAWRECTCODE

// ̏W`
#define SETDRAWRECTCODE\
	SETRECT( DrawRect, 0, 0, GSYS.DrawSetting.DrawSizeX, GSYS.DrawSetting.DrawSizeY )\
	DRAWRECT_DRAWAREA_CLIP
extern	int NS_DrawLineSet( const LINEDATA *LineData, int Num )
{
	int Ret = -1 ;
	int Flag ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;
	
	Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;

	CheckActiveState() ;

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawLineSet_PF( LineData, Num ),
		Graphics_Software_DrawLineSet(    LineData, Num ),
		SETDRAWRECTCODE,
		Ret,
		Flag
	)

	// I
	return Ret ;
}
#undef SETDRAWRECTCODE

// `̏W`悷
#define SETDRAWRECTCODE\
	SETRECT( DrawRect, 0, 0, GSYS.DrawSetting.DrawSizeX, GSYS.DrawSetting.DrawSizeY )\
	DRAWRECT_DRAWAREA_CLIP
extern int NS_DrawBoxSet( const RECTDATA *RectData, int Num )
{
	int Ret = -1 ;
	int Flag ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;
	
	Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;

	CheckActiveState() ;

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawBoxSet_PF( RectData, Num ),
		Graphics_Software_DrawBoxSet(    RectData, Num ),
		SETDRAWRECTCODE,
		Ret,
		Flag
	)

	// I
	return Ret ;
}
#undef SETDRAWRECTCODE

// Rc̓_`悷
extern int NS_DrawPixel3D( VECTOR Pos, unsigned int Color )
{
	LARGE3DPOSITIONSUPPORT_DRAWINFO Large3DPosDrawInfo ;
	int Ret ;
	int Flag ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE ) return -1 ;

	// `ݒ肪Ăꍇ͉I
	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// uheNX`͎gpłȂ
	if( GSYS.DrawSetting.BlendGraph > 0 )
		return -1 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// Rcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware3DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib3DMatrixToHardware() ;

	if( GSYS.DrawSetting.Large3DPositionSupport )
	{
		Graphics_Draw_BeginLarge3DPositionSupportDraw( &Large3DPosDrawInfo, VConvFtoD( Pos ) ) ; 

		Pos = VGet( 0.0f, 0.0f, 0.0f ) ;
	}

	Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawPixel3D_PF( Pos, Color, TRUE, NULL ),
		0,
		DrawRect = GSYS.DrawSetting.DrawArea ;,
		Ret,
		Flag
	)

	if( GSYS.DrawSetting.Large3DPositionSupport )
	{
		Graphics_Draw_EndLarge3DPositionSupportDraw( &Large3DPosDrawInfo ) ;
	}

	// I
	return Ret ;
}

// Rc̓_`悷
extern int NS_DrawPixel3DD( VECTOR_D Pos, unsigned int Color )
{
	LARGE3DPOSITIONSUPPORT_DRAWINFO Large3DPosDrawInfo ;
	VECTOR PosF ;
	int Ret ;
	int Flag ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE ) return -1 ;

	// `ݒ肪Ăꍇ͉I
	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// uheNX`͎gpłȂ
	if( GSYS.DrawSetting.BlendGraph > 0 )
		return -1 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	if( GSYS.DrawSetting.Large3DPositionSupport )
	{
		Graphics_Draw_BeginLarge3DPositionSupportDraw( &Large3DPosDrawInfo, Pos ) ; 

		Pos = VGetD( 0.0, 0.0, 0.0 ) ;
	}

	PosF = VConvDtoF( Pos ) ;

	Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;

	// Rcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware3DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib3DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawPixel3D_PF( PosF, Color, TRUE, NULL ),
		0,
		DrawRect = GSYS.DrawSetting.DrawArea ;,
		Ret,
		Flag
	)

	if( GSYS.DrawSetting.Large3DPositionSupport )
	{
		Graphics_Draw_EndLarge3DPositionSupportDraw( &Large3DPosDrawInfo ) ;
	}

	// I
	return Ret ;
}

// Rc̐`悷
extern int NS_DrawLine3D( VECTOR Pos1, VECTOR Pos2, unsigned int Color )
{
	LARGE3DPOSITIONSUPPORT_DRAWINFO Large3DPosDrawInfo ;
	int Ret ;
	int Flag ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE ) return -1 ;

	// `ݒ肪Ăꍇ͉I
	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// uheNX`͎gpłȂ
	if( GSYS.DrawSetting.BlendGraph > 0 )
		return -1 ;

	if( GSYS.DrawSetting.Large3DPositionSupport )
	{
		Graphics_Draw_BeginLarge3DPositionSupportDraw( &Large3DPosDrawInfo, VConvFtoD( Pos1 ) ) ; 

		Pos2 = VSub( Pos2, Pos1 ) ;
		Pos1 = VGet( 0.0f, 0.0f, 0.0f ) ;
	}

	Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// Rcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware3DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib3DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawLine3D_PF( Pos1, Pos2, Color, TRUE, NULL ),
		0,
		DrawRect = GSYS.DrawSetting.DrawArea ;,
		Ret,
		Flag
	)

	if( GSYS.DrawSetting.Large3DPositionSupport )
	{
		Graphics_Draw_EndLarge3DPositionSupportDraw( &Large3DPosDrawInfo ) ;
	}

	// I
	return Ret ;
}

// Rc̐`悷
extern int NS_DrawLine3DD( VECTOR_D Pos1, VECTOR_D Pos2, unsigned int Color )
{
	LARGE3DPOSITIONSUPPORT_DRAWINFO Large3DPosDrawInfo ;
	VECTOR Pos1F, Pos2F ;
	int Ret ;
	int Flag ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE ) return -1 ;

	// `ݒ肪Ăꍇ͉I
	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// uheNX`͎gpłȂ
	if( GSYS.DrawSetting.BlendGraph > 0 )
		return -1 ;

	if( GSYS.DrawSetting.Large3DPositionSupport )
	{
		Graphics_Draw_BeginLarge3DPositionSupportDraw( &Large3DPosDrawInfo, Pos1 ) ; 

		Pos2 = VSubD( Pos2, Pos1 ) ;
		Pos1 = VGetD( 0.0, 0.0, 0.0 ) ;
	}

	Pos1F = VConvDtoF( Pos1 ) ;
	Pos2F = VConvDtoF( Pos2 ) ;

	Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// Rcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware3DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib3DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawLine3D_PF( Pos1F, Pos2F, Color, TRUE, NULL ),
		0,
		DrawRect = GSYS.DrawSetting.DrawArea ;,
		Ret,
		Flag
	)

	if( GSYS.DrawSetting.Large3DPositionSupport )
	{
		Graphics_Draw_EndLarge3DPositionSupportDraw( &Large3DPosDrawInfo ) ;
	}

	// I
	return Ret ;
}

// Rc̎Op``悷
extern int NS_DrawTriangle3D( VECTOR Pos1, VECTOR Pos2, VECTOR Pos3, unsigned int Color, int FillFlag )
{
	LARGE3DPOSITIONSUPPORT_DRAWINFO Large3DPosDrawInfo ;
	int Ret ;
	int Flag ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE ) return -1 ;

	// `ݒ肪Ăꍇ͉I
	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// uheNX`͎gpłȂ
	if( GSYS.DrawSetting.BlendGraph > 0 )
		return -1 ;

	if( GSYS.DrawSetting.Large3DPositionSupport )
	{
		Graphics_Draw_BeginLarge3DPositionSupportDraw( &Large3DPosDrawInfo, VConvFtoD( Pos1 ) ) ; 

		Pos2 = VSub( Pos2, Pos1 ) ;
		Pos3 = VSub( Pos3, Pos1 ) ;
		Pos1 = VGet( 0.0f, 0.0f, 0.0f ) ;
	}

	Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;

	// Rcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware3DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib3DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawTriangle3D_PF( Pos1, Pos2, Pos3, Color, FillFlag, TRUE, NULL ),
		0,
		DrawRect = GSYS.DrawSetting.DrawArea ;,
		Ret,
		Flag
	)

	if( GSYS.DrawSetting.Large3DPositionSupport )
	{
		Graphics_Draw_EndLarge3DPositionSupportDraw( &Large3DPosDrawInfo ) ;
	}

	// I
	return Ret ;
}

// Rc̎Op``悷
extern int NS_DrawTriangle3DD( VECTOR_D Pos1, VECTOR_D Pos2, VECTOR_D Pos3, unsigned int Color, int FillFlag )
{
	LARGE3DPOSITIONSUPPORT_DRAWINFO Large3DPosDrawInfo ;
	int Ret ;
	int Flag ;
	VECTOR Pos1F, Pos2F, Pos3F ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE ) return -1 ;

	// `ݒ肪Ăꍇ͉I
	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// uheNX`͎gpłȂ
	if( GSYS.DrawSetting.BlendGraph > 0 )
		return -1 ;

	if( GSYS.DrawSetting.Large3DPositionSupport )
	{
		Graphics_Draw_BeginLarge3DPositionSupportDraw( &Large3DPosDrawInfo, Pos1 ) ; 

		Pos2 = VSubD( Pos2, Pos1 ) ;
		Pos3 = VSubD( Pos3, Pos1 ) ;
		Pos1 = VGetD( 0.0, 0.0, 0.0 ) ;
	}

	Pos1F = VConvDtoF( Pos1 ) ;
	Pos2F = VConvDtoF( Pos2 ) ;
	Pos3F = VConvDtoF( Pos3 ) ;

	Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;

	// Rcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware3DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib3DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawTriangle3D_PF( Pos1F, Pos2F, Pos3F, Color, FillFlag, TRUE, NULL ),
		0,
		DrawRect = GSYS.DrawSetting.DrawArea ;,
		Ret,
		Flag
	)

	if( GSYS.DrawSetting.Large3DPositionSupport )
	{
		Graphics_Draw_EndLarge3DPositionSupportDraw( &Large3DPosDrawInfo ) ;
	}

	// I
	return Ret ;
}

// Rĉ̗`悷
extern int NS_DrawCube3D( VECTOR Pos1, VECTOR Pos2, unsigned int DifColor, unsigned int SpcColor, int FillFlag )
{
	return NS_DrawCube3DD( VConvFtoD( Pos1 ), VConvFtoD( Pos2 ), DifColor, SpcColor, FillFlag ) ;
}

// Rĉ̗`悷
extern int NS_DrawCube3DD( VECTOR_D Pos1, VECTOR_D Pos2, unsigned int DifColor, unsigned int SpcColor, int FillFlag )
{
	LARGE3DPOSITIONSUPPORT_DRAWINFO Large3DPosDrawInfo ;
	VECTOR Pos1F, Pos2F ;

	if( GSYS.DrawSetting.Large3DPositionSupport )
	{
		Graphics_Draw_BeginLarge3DPositionSupportDraw( &Large3DPosDrawInfo, Pos1 ) ; 

		Pos2 = VSubD( Pos2, Pos1 ) ;
		Pos1 = VGetD( 0.0, 0.0, 0.0 ) ;
	}

	Pos1F = VConvDtoF( Pos1 ) ;
	Pos2F = VConvDtoF( Pos2 ) ;

	if( GSYS.Light.ProcessDisable == FALSE && FillFlag == TRUE )
	{
		static WORD FillIndex[ 36 ] =
		{
			 0,  1,  2,   3,  2,  1,
			 4,  5,  6,   7,  6,  5,
			 8,  9, 10,  11, 10,  9,
			12, 13, 14,  15, 14, 13,
			16, 17, 18,  19, 18, 17,
			20, 21, 22,  23, 22, 21,
		} ;
		VERTEX3D Vertex[ 6 ][ 4 ] ;
		int i, dr, dg, db, a, sr, sg, sb ;

		// _f[^̍쐬
		NS_GetColor2( DifColor, &dr, &dg, &db ) ;
		NS_GetColor2( SpcColor, &sr, &sg, &sb ) ;
		a = GSYS.DrawSetting.BlendMode == DX_BLENDMODE_NOBLEND ? 255 : GSYS.DrawSetting.BlendParam ;
		Vertex[ 0 ][ 0 ].pos.x = Pos1F.x ; Vertex[ 0 ][ 0 ].pos.y = Pos2F.y ; Vertex[ 0 ][ 0 ].pos.z = Pos1F.z ;
		Vertex[ 0 ][ 1 ].pos.x = Pos2F.x ; Vertex[ 0 ][ 1 ].pos.y = Pos2F.y ; Vertex[ 0 ][ 1 ].pos.z = Pos1F.z ;
		Vertex[ 0 ][ 2 ].pos.x = Pos1F.x ; Vertex[ 0 ][ 2 ].pos.y = Pos1F.y ; Vertex[ 0 ][ 2 ].pos.z = Pos1F.z ;
		Vertex[ 0 ][ 3 ].pos.x = Pos2F.x ; Vertex[ 0 ][ 3 ].pos.y = Pos1F.y ; Vertex[ 0 ][ 3 ].pos.z = Pos1F.z ;
		Vertex[ 0 ][ 0 ].norm.x = 0.0f ;
		Vertex[ 0 ][ 0 ].norm.y = 0.0f ;
		Vertex[ 0 ][ 0 ].norm.z = -1.0f ;
		Vertex[ 0 ][ 1 ].norm = Vertex[ 0 ][ 0 ].norm ;
		Vertex[ 0 ][ 2 ].norm = Vertex[ 0 ][ 0 ].norm ;
		Vertex[ 0 ][ 3 ].norm = Vertex[ 0 ][ 0 ].norm ;

		Vertex[ 1 ][ 0 ].pos.x = Pos2F.x ; Vertex[ 1 ][ 0 ].pos.y = Pos2F.y ; Vertex[ 1 ][ 0 ].pos.z = Pos2F.z ;
		Vertex[ 1 ][ 1 ].pos.x = Pos1F.x ; Vertex[ 1 ][ 1 ].pos.y = Pos2F.y ; Vertex[ 1 ][ 1 ].pos.z = Pos2F.z ;
		Vertex[ 1 ][ 2 ].pos.x = Pos2F.x ; Vertex[ 1 ][ 2 ].pos.y = Pos1F.y ; Vertex[ 1 ][ 2 ].pos.z = Pos2F.z ;
		Vertex[ 1 ][ 3 ].pos.x = Pos1F.x ; Vertex[ 1 ][ 3 ].pos.y = Pos1F.y ; Vertex[ 1 ][ 3 ].pos.z = Pos2F.z ;
		Vertex[ 1 ][ 0 ].norm.x = 0.0f ;
		Vertex[ 1 ][ 0 ].norm.y = 0.0f ;
		Vertex[ 1 ][ 0 ].norm.z = 1.0f ;
		Vertex[ 1 ][ 1 ].norm = Vertex[ 1 ][ 0 ].norm ;
		Vertex[ 1 ][ 2 ].norm = Vertex[ 1 ][ 0 ].norm ;
		Vertex[ 1 ][ 3 ].norm = Vertex[ 1 ][ 0 ].norm ;

		Vertex[ 2 ][ 0 ].pos.x = Pos1F.x ; Vertex[ 2 ][ 0 ].pos.y = Pos2F.y ; Vertex[ 2 ][ 0 ].pos.z = Pos2F.z ;
		Vertex[ 2 ][ 1 ].pos.x = Pos1F.x ; Vertex[ 2 ][ 1 ].pos.y = Pos2F.y ; Vertex[ 2 ][ 1 ].pos.z = Pos1F.z ;
		Vertex[ 2 ][ 2 ].pos.x = Pos1F.x ; Vertex[ 2 ][ 2 ].pos.y = Pos1F.y ; Vertex[ 2 ][ 2 ].pos.z = Pos2F.z ;
		Vertex[ 2 ][ 3 ].pos.x = Pos1F.x ; Vertex[ 2 ][ 3 ].pos.y = Pos1F.y ; Vertex[ 2 ][ 3 ].pos.z = Pos1F.z ;
		Vertex[ 2 ][ 0 ].norm.x = -1.0f ;
		Vertex[ 2 ][ 0 ].norm.y = 0.0f ;
		Vertex[ 2 ][ 0 ].norm.z = 0.0f ;
		Vertex[ 2 ][ 1 ].norm = Vertex[ 2 ][ 0 ].norm ;
		Vertex[ 2 ][ 2 ].norm = Vertex[ 2 ][ 0 ].norm ;
		Vertex[ 2 ][ 3 ].norm = Vertex[ 2 ][ 0 ].norm ;

		Vertex[ 3 ][ 0 ].pos.x = Pos2F.x ; Vertex[ 3 ][ 0 ].pos.y = Pos2F.y ; Vertex[ 3 ][ 0 ].pos.z = Pos1F.z ;
		Vertex[ 3 ][ 1 ].pos.x = Pos2F.x ; Vertex[ 3 ][ 1 ].pos.y = Pos2F.y ; Vertex[ 3 ][ 1 ].pos.z = Pos2F.z ;
		Vertex[ 3 ][ 2 ].pos.x = Pos2F.x ; Vertex[ 3 ][ 2 ].pos.y = Pos1F.y ; Vertex[ 3 ][ 2 ].pos.z = Pos1F.z ;
		Vertex[ 3 ][ 3 ].pos.x = Pos2F.x ; Vertex[ 3 ][ 3 ].pos.y = Pos1F.y ; Vertex[ 3 ][ 3 ].pos.z = Pos2F.z ;
		Vertex[ 3 ][ 0 ].norm.x = 1.0f ;
		Vertex[ 3 ][ 0 ].norm.y = 0.0f ;
		Vertex[ 3 ][ 0 ].norm.z = 0.0f ;
		Vertex[ 3 ][ 1 ].norm = Vertex[ 3 ][ 0 ].norm ;
		Vertex[ 3 ][ 2 ].norm = Vertex[ 3 ][ 0 ].norm ;
		Vertex[ 3 ][ 3 ].norm = Vertex[ 3 ][ 0 ].norm ;

		Vertex[ 4 ][ 0 ].pos.x = Pos1F.x ; Vertex[ 4 ][ 0 ].pos.y = Pos2F.y ; Vertex[ 4 ][ 0 ].pos.z = Pos2F.z ;
		Vertex[ 4 ][ 1 ].pos.x = Pos2F.x ; Vertex[ 4 ][ 1 ].pos.y = Pos2F.y ; Vertex[ 4 ][ 1 ].pos.z = Pos2F.z ;
		Vertex[ 4 ][ 2 ].pos.x = Pos1F.x ; Vertex[ 4 ][ 2 ].pos.y = Pos2F.y ; Vertex[ 4 ][ 2 ].pos.z = Pos1F.z ;
		Vertex[ 4 ][ 3 ].pos.x = Pos2F.x ; Vertex[ 4 ][ 3 ].pos.y = Pos2F.y ; Vertex[ 4 ][ 3 ].pos.z = Pos1F.z ;
		Vertex[ 4 ][ 0 ].norm.x = 0.0f ;
		Vertex[ 4 ][ 0 ].norm.y = 1.0f ;
		Vertex[ 4 ][ 0 ].norm.z = 0.0f ;
		Vertex[ 4 ][ 1 ].norm = Vertex[ 4 ][ 0 ].norm ;
		Vertex[ 4 ][ 2 ].norm = Vertex[ 4 ][ 0 ].norm ;
		Vertex[ 4 ][ 3 ].norm = Vertex[ 4 ][ 0 ].norm ;

		Vertex[ 5 ][ 0 ].pos.x = Pos1F.x ; Vertex[ 5 ][ 0 ].pos.y = Pos1F.y ; Vertex[ 5 ][ 0 ].pos.z = Pos1F.z ;
		Vertex[ 5 ][ 1 ].pos.x = Pos2F.x ; Vertex[ 5 ][ 1 ].pos.y = Pos1F.y ; Vertex[ 5 ][ 1 ].pos.z = Pos1F.z ;
		Vertex[ 5 ][ 2 ].pos.x = Pos1F.x ; Vertex[ 5 ][ 2 ].pos.y = Pos1F.y ; Vertex[ 5 ][ 2 ].pos.z = Pos2F.z ;
		Vertex[ 5 ][ 3 ].pos.x = Pos2F.x ; Vertex[ 5 ][ 3 ].pos.y = Pos1F.y ; Vertex[ 5 ][ 3 ].pos.z = Pos2F.z ;
		Vertex[ 5 ][ 0 ].norm.x = 0.0f ;
		Vertex[ 5 ][ 0 ].norm.y = -1.0f ;
		Vertex[ 5 ][ 0 ].norm.z = 0.0f ;
		Vertex[ 5 ][ 1 ].norm = Vertex[ 5 ][ 0 ].norm ;
		Vertex[ 5 ][ 2 ].norm = Vertex[ 5 ][ 0 ].norm ;
		Vertex[ 5 ][ 3 ].norm = Vertex[ 5 ][ 0 ].norm ;
		for( i = 0 ; i < 4 * 6 ; i ++ )
		{
			( ( VERTEX3D * )Vertex )[ i ].dif.b = ( BYTE )db ;
			( ( VERTEX3D * )Vertex )[ i ].dif.g = ( BYTE )dg ;
			( ( VERTEX3D * )Vertex )[ i ].dif.r = ( BYTE )dr ;
			( ( VERTEX3D * )Vertex )[ i ].dif.a = ( BYTE )a ;
			( ( VERTEX3D * )Vertex )[ i ].spc.b = ( BYTE )sb ;
			( ( VERTEX3D * )Vertex )[ i ].spc.g = ( BYTE )sg ;
			( ( VERTEX3D * )Vertex )[ i ].spc.r = ( BYTE )sr ;
			( ( VERTEX3D * )Vertex )[ i ].spc.a = 0 ;
			( ( VERTEX3D * )Vertex )[ i ].u = 0.0f ;
			( ( VERTEX3D * )Vertex )[ i ].v = 0.0f ;
			( ( VERTEX3D * )Vertex )[ i ].su = 0.0f ;
			( ( VERTEX3D * )Vertex )[ i ].sv = 0.0f ;
		}

		NS_DrawPrimitiveIndexed3D( ( VERTEX3D * )Vertex, 6 * 4, FillIndex, 36, DX_PRIMTYPE_TRIANGLELIST, DX_NONE_GRAPH, TRUE ) ;
	}
	else
	{
		static WORD FillIndex[ 36 ] =
		{
			0, 1, 3,  3, 1, 2,  3, 2, 7,
			7, 2, 6,  2, 1, 6,  6, 1, 5,
			1, 0, 5,  5, 0, 4,  0, 3, 4,
			4, 3, 7,  7, 6, 4,  4, 6, 5,
		} ;
		static WORD LineIndex[ 24 ] =
		{
			0, 1,   1, 2,   2, 3,   3, 0,
			0, 4,   1, 5,   2, 6,   3, 7,
			4, 5,   5, 6,   6, 7,   7, 4,
		} ;
		VERTEX3D Vertex[ 8 ] ;
		int i, dr, dg, db, a, sr, sg, sb ;

		// _f[^̍쐬
		NS_GetColor2( DifColor, &dr, &dg, &db ) ;
		NS_GetColor2( SpcColor, &sr, &sg, &sb ) ;
		a = GSYS.DrawSetting.BlendMode == DX_BLENDMODE_NOBLEND ? 255 : GSYS.DrawSetting.BlendParam ;
		Vertex[ 0 ].norm.x = -0.57735027f ;	Vertex[ 0 ].norm.y =  0.57735027f ;	Vertex[ 0 ].norm.z =  0.57735027f ;
		Vertex[ 1 ].norm.x =  0.57735027f ;	Vertex[ 1 ].norm.y =  0.57735027f ;	Vertex[ 1 ].norm.z =  0.57735027f ;
		Vertex[ 2 ].norm.x =  0.57735027f ;	Vertex[ 2 ].norm.y =  0.57735027f ;	Vertex[ 2 ].norm.z = -0.57735027f ;
		Vertex[ 3 ].norm.x = -0.57735027f ;	Vertex[ 3 ].norm.y =  0.57735027f ;	Vertex[ 3 ].norm.z = -0.57735027f ;
		Vertex[ 4 ].norm.x = -0.57735027f ;	Vertex[ 4 ].norm.y = -0.57735027f ;	Vertex[ 4 ].norm.z =  0.57735027f ;
		Vertex[ 5 ].norm.x =  0.57735027f ;	Vertex[ 5 ].norm.y = -0.57735027f ;	Vertex[ 5 ].norm.z =  0.57735027f ;
		Vertex[ 6 ].norm.x =  0.57735027f ;	Vertex[ 6 ].norm.y = -0.57735027f ;	Vertex[ 6 ].norm.z = -0.57735027f ;
		Vertex[ 7 ].norm.x = -0.57735027f ;	Vertex[ 7 ].norm.y = -0.57735027f ;	Vertex[ 7 ].norm.z = -0.57735027f ;
		Vertex[ 0 ].pos.x = Pos1F.x ; Vertex[ 0 ].pos.y = Pos2F.y ; Vertex[ 0 ].pos.z = Pos2F.z ;
		Vertex[ 1 ].pos.x = Pos2F.x ; Vertex[ 1 ].pos.y = Pos2F.y ; Vertex[ 1 ].pos.z = Pos2F.z ;
		Vertex[ 2 ].pos.x = Pos2F.x ; Vertex[ 2 ].pos.y = Pos2F.y ; Vertex[ 2 ].pos.z = Pos1F.z ;
		Vertex[ 3 ].pos.x = Pos1F.x ; Vertex[ 3 ].pos.y = Pos2F.y ; Vertex[ 3 ].pos.z = Pos1F.z ;
		Vertex[ 4 ].pos.x = Pos1F.x ; Vertex[ 4 ].pos.y = Pos1F.y ; Vertex[ 4 ].pos.z = Pos2F.z ;
		Vertex[ 5 ].pos.x = Pos2F.x ; Vertex[ 5 ].pos.y = Pos1F.y ; Vertex[ 5 ].pos.z = Pos2F.z ;
		Vertex[ 6 ].pos.x = Pos2F.x ; Vertex[ 6 ].pos.y = Pos1F.y ; Vertex[ 6 ].pos.z = Pos1F.z ;
		Vertex[ 7 ].pos.x = Pos1F.x ; Vertex[ 7 ].pos.y = Pos1F.y ; Vertex[ 7 ].pos.z = Pos1F.z ;
		for( i = 0 ; i < 8 ; i ++ )
		{
			Vertex[ i ].dif.b = ( BYTE )db ;
			Vertex[ i ].dif.g = ( BYTE )dg ;
			Vertex[ i ].dif.r = ( BYTE )dr ;
			Vertex[ i ].dif.a = ( BYTE )a ;
			Vertex[ i ].spc.b = ( BYTE )sb ;
			Vertex[ i ].spc.g = ( BYTE )sg ;
			Vertex[ i ].spc.r = ( BYTE )sr ;
			Vertex[ i ].spc.a = 0 ;
			Vertex[ i ].u = 0.0f ;
			Vertex[ i ].v = 0.0f ;
			Vertex[ i ].su = 0.0f ;
			Vertex[ i ].sv = 0.0f ;
		}

		if( FillFlag == TRUE ) 
		{
			NS_DrawPrimitiveIndexed3D( Vertex, 8, FillIndex, 36, DX_PRIMTYPE_TRIANGLELIST, DX_NONE_GRAPH, TRUE ) ;
		}
		else
		{
			NS_DrawPrimitiveIndexed3D( Vertex, 8, LineIndex, 24, DX_PRIMTYPE_LINELIST, DX_NONE_GRAPH, TRUE ) ;
		}
	}

	if( GSYS.DrawSetting.Large3DPositionSupport )
	{
		Graphics_Draw_EndLarge3DPositionSupportDraw( &Large3DPosDrawInfo ) ;
	}

	// I
	return 0 ;
}

// Rĉ̗̏W`悷
extern int NS_DrawCubeSet3D( CUBEDATA *CubeDataArray, int Num, int FillFlag )
{
	int i, j, k ;
	VERTEX3D *Vertex ;
	WORD *Index ;

	if( GSYS.Light.ProcessDisable == FALSE && FillFlag == TRUE )
	{
		// w̐̒_߂obt@mۂĂȂm
		if( GSYS.Resource.DrawCubeSet3DWorkVertexBufferSize[ 1 ] < Num &&
			GSYS.Resource.DrawCubeSet3DWorkVertexBufferSize[ 1 ] < 2730 )
		{
			GSYS.Resource.DrawCubeSet3DWorkVertexBufferSize[ 1 ] = Num * 3 / 2 ;
			if( GSYS.Resource.DrawCubeSet3DWorkVertexBufferSize[ 1 ] > 2730 )
			{
				GSYS.Resource.DrawCubeSet3DWorkVertexBufferSize[ 1 ] = 2730 ;
			}

			if( GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ 1 ] == NULL )
			{
				GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ 1 ] = ( VERTEX3D * )DXALLOC( GSYS.Resource.DrawCubeSet3DWorkVertexBufferSize[ 1 ] * sizeof( VERTEX3D ) * 24 ) ;
			}
			else
			{
				GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ 1 ] = ( VERTEX3D * )DXREALLOC( GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ 1 ], GSYS.Resource.DrawCubeSet3DWorkVertexBufferSize[ 1 ] * sizeof( VERTEX3D ) * 24 ) ;
			}

			// _f[^̌ŒlZbg
			Vertex = GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ 1 ] ;
			for( i = 0 ; i < GSYS.Resource.DrawCubeSet3DWorkVertexBufferSize[ 1 ] ; i ++ )
			{
				Vertex[ 0 ].norm.x = 0.0f ;
				Vertex[ 0 ].norm.y = 0.0f ;
				Vertex[ 0 ].norm.z = -1.0f ;
				Vertex[ 1 ].norm = Vertex[ 0 ].norm ;
				Vertex[ 2 ].norm = Vertex[ 0 ].norm ;
				Vertex[ 3 ].norm = Vertex[ 0 ].norm ;
				Vertex[ 0 ].u = 0.0f ;		Vertex[ 0 ].v = 0.0f ;		Vertex[ 0 ].su = 0.0f ;		Vertex[ 0 ].sv = 0.0f ;
				Vertex[ 1 ].u = 0.0f ;		Vertex[ 1 ].v = 0.0f ;		Vertex[ 1 ].su = 0.0f ;		Vertex[ 1 ].sv = 0.0f ;
				Vertex[ 2 ].u = 0.0f ;		Vertex[ 2 ].v = 0.0f ;		Vertex[ 2 ].su = 0.0f ;		Vertex[ 2 ].sv = 0.0f ;
				Vertex[ 3 ].u = 0.0f ;		Vertex[ 3 ].v = 0.0f ;		Vertex[ 3 ].su = 0.0f ;		Vertex[ 3 ].sv = 0.0f ;

				Vertex[ 4 + 0 ].norm.x = 0.0f ;
				Vertex[ 4 + 0 ].norm.y = 0.0f ;
				Vertex[ 4 + 0 ].norm.z = 1.0f ;
				Vertex[ 4 + 1 ].norm = Vertex[ 4 ].norm ;
				Vertex[ 4 + 2 ].norm = Vertex[ 4 ].norm ;
				Vertex[ 4 + 3 ].norm = Vertex[ 4 ].norm ;
				Vertex[ 4 + 0 ].u = 0.0f ;	Vertex[ 4 + 0 ].v = 0.0f ;	Vertex[ 4 + 0 ].su = 0.0f ;	Vertex[ 4 + 0 ].sv = 0.0f ;
				Vertex[ 4 + 1 ].u = 0.0f ;	Vertex[ 4 + 1 ].v = 0.0f ;	Vertex[ 4 + 1 ].su = 0.0f ;	Vertex[ 4 + 1 ].sv = 0.0f ;
				Vertex[ 4 + 2 ].u = 0.0f ;	Vertex[ 4 + 2 ].v = 0.0f ;	Vertex[ 4 + 2 ].su = 0.0f ;	Vertex[ 4 + 2 ].sv = 0.0f ;
				Vertex[ 4 + 3 ].u = 0.0f ;	Vertex[ 4 + 3 ].v = 0.0f ;	Vertex[ 4 + 3 ].su = 0.0f ;	Vertex[ 4 + 3 ].sv = 0.0f ;

				Vertex[ 8 + 0 ].norm.x = -1.0f ;
				Vertex[ 8 + 0 ].norm.y = 0.0f ;
				Vertex[ 8 + 0 ].norm.z = 0.0f ;
				Vertex[ 8 + 1 ].norm = Vertex[ 8 ].norm ;
				Vertex[ 8 + 2 ].norm = Vertex[ 8 ].norm ;
				Vertex[ 8 + 3 ].norm = Vertex[ 8 ].norm ;
				Vertex[ 8 + 0 ].u = 0.0f ;	Vertex[ 8 + 0 ].v = 0.0f ;	Vertex[ 8 + 0 ].su = 0.0f ;	Vertex[ 8 + 0 ].sv = 0.0f ;
				Vertex[ 8 + 1 ].u = 0.0f ;	Vertex[ 8 + 1 ].v = 0.0f ;	Vertex[ 8 + 1 ].su = 0.0f ;	Vertex[ 8 + 1 ].sv = 0.0f ;
				Vertex[ 8 + 2 ].u = 0.0f ;	Vertex[ 8 + 2 ].v = 0.0f ;	Vertex[ 8 + 2 ].su = 0.0f ;	Vertex[ 8 + 2 ].sv = 0.0f ;
				Vertex[ 8 + 3 ].u = 0.0f ;	Vertex[ 8 + 3 ].v = 0.0f ;	Vertex[ 8 + 3 ].su = 0.0f ;	Vertex[ 8 + 3 ].sv = 0.0f ;

				Vertex[ 12 + 0 ].norm.x = 1.0f ;
				Vertex[ 12 + 0 ].norm.y = 0.0f ;
				Vertex[ 12 + 0 ].norm.z = 0.0f ;
				Vertex[ 12 + 1 ].norm = Vertex[ 12 ].norm ;
				Vertex[ 12 + 2 ].norm = Vertex[ 12 ].norm ;
				Vertex[ 12 + 3 ].norm = Vertex[ 12 ].norm ;
				Vertex[ 12 + 0 ].u = 0.0f ;	Vertex[ 12 + 0 ].v = 0.0f ;	Vertex[ 12 + 0 ].su = 0.0f ;Vertex[ 12 + 0 ].sv = 0.0f ;
				Vertex[ 12 + 1 ].u = 0.0f ;	Vertex[ 12 + 1 ].v = 0.0f ;	Vertex[ 12 + 1 ].su = 0.0f ;Vertex[ 12 + 1 ].sv = 0.0f ;
				Vertex[ 12 + 2 ].u = 0.0f ;	Vertex[ 12 + 2 ].v = 0.0f ;	Vertex[ 12 + 2 ].su = 0.0f ;Vertex[ 12 + 2 ].sv = 0.0f ;
				Vertex[ 12 + 3 ].u = 0.0f ;	Vertex[ 12 + 3 ].v = 0.0f ;	Vertex[ 12 + 3 ].su = 0.0f ;Vertex[ 12 + 3 ].sv = 0.0f ;

				Vertex[ 16 + 0 ].norm.x = 0.0f ;
				Vertex[ 16 + 0 ].norm.y = 1.0f ;
				Vertex[ 16 + 0 ].norm.z = 0.0f ;
				Vertex[ 16 + 1 ].norm = Vertex[ 16 ].norm ;
				Vertex[ 16 + 2 ].norm = Vertex[ 16 ].norm ;
				Vertex[ 16 + 3 ].norm = Vertex[ 16 ].norm ;
				Vertex[ 16 + 0 ].u = 0.0f ;	Vertex[ 16 + 0 ].v = 0.0f ;	Vertex[ 16 + 0 ].su = 0.0f ;Vertex[ 16 + 0 ].sv = 0.0f ;
				Vertex[ 16 + 1 ].u = 0.0f ;	Vertex[ 16 + 1 ].v = 0.0f ;	Vertex[ 16 + 1 ].su = 0.0f ;Vertex[ 16 + 1 ].sv = 0.0f ;
				Vertex[ 16 + 2 ].u = 0.0f ;	Vertex[ 16 + 2 ].v = 0.0f ;	Vertex[ 16 + 2 ].su = 0.0f ;Vertex[ 16 + 2 ].sv = 0.0f ;
				Vertex[ 16 + 3 ].u = 0.0f ;	Vertex[ 16 + 3 ].v = 0.0f ;	Vertex[ 16 + 3 ].su = 0.0f ;Vertex[ 16 + 3 ].sv = 0.0f ;

				Vertex[ 20 + 0 ].norm.x = 0.0f ;
				Vertex[ 20 + 0 ].norm.y = -1.0f ;
				Vertex[ 20 + 0 ].norm.z = 0.0f ;
				Vertex[ 20 + 1 ].norm = Vertex[ 20 ].norm ;
				Vertex[ 20 + 2 ].norm = Vertex[ 20 ].norm ;
				Vertex[ 20 + 3 ].norm = Vertex[ 20 ].norm ;
				Vertex[ 20 + 0 ].u = 0.0f ;	Vertex[ 20 + 0 ].v = 0.0f ;	Vertex[ 20 + 0 ].su = 0.0f ;Vertex[ 20 + 0 ].sv = 0.0f ;
				Vertex[ 20 + 1 ].u = 0.0f ;	Vertex[ 20 + 1 ].v = 0.0f ;	Vertex[ 20 + 1 ].su = 0.0f ;Vertex[ 20 + 1 ].sv = 0.0f ;
				Vertex[ 20 + 2 ].u = 0.0f ;	Vertex[ 20 + 2 ].v = 0.0f ;	Vertex[ 20 + 2 ].su = 0.0f ;Vertex[ 20 + 2 ].sv = 0.0f ;
				Vertex[ 20 + 3 ].u = 0.0f ;	Vertex[ 20 + 3 ].v = 0.0f ;	Vertex[ 20 + 3 ].su = 0.0f ;Vertex[ 20 + 3 ].sv = 0.0f ;

				Vertex += 24 ;
			}
		}

		// w̐̃CfbNX߂obt@mۂĂȂm
		if( GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 2 ] < Num &&
			GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 2 ] < 2730 )
		{
			GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 2 ] = Num * 3 / 2 ;
			if( GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 2 ] > 2730 )
			{
				GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 2 ] = 2730 ;
			}

			if( GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 2 ] == NULL )
			{
				GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 2 ] = ( WORD * )DXALLOC( GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 2 ] * sizeof( WORD ) * 36 ) ;
			}
			else
			{
				GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 2 ] = ( WORD * )DXREALLOC( GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 2 ], GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 2 ] * sizeof( WORD ) * 36 ) ;
			}

			// CfbNX̌ŒlZbg
			Index = GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 2 ] ;
			j = 0 ;
			for( i = 0 ; i < GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 2 ] ; i ++ )
			{
				Index[  0 ] = ( WORD )( j +  0 ) ;	Index[  1 ] = ( WORD )( j +  1 ) ;		Index[  2 ] = ( WORD )( j +  2 ) ;
				Index[  3 ] = ( WORD )( j +  3 ) ;	Index[  4 ] = ( WORD )( j +  2 ) ;		Index[  5 ] = ( WORD )( j +  1 ) ;
				Index[  6 ] = ( WORD )( j +  4 ) ;	Index[  7 ] = ( WORD )( j +  5 ) ;		Index[  8 ] = ( WORD )( j +  6 ) ;
				Index[  9 ] = ( WORD )( j +  7 ) ;	Index[ 10 ] = ( WORD )( j +  6 ) ;		Index[ 11 ] = ( WORD )( j +  5 ) ;
				Index[ 12 ] = ( WORD )( j +  8 ) ;	Index[ 13 ] = ( WORD )( j +  9 ) ;		Index[ 14 ] = ( WORD )( j + 10 ) ;
				Index[ 15 ] = ( WORD )( j + 11 ) ;	Index[ 16 ] = ( WORD )( j + 10 ) ;		Index[ 17 ] = ( WORD )( j +  9 ) ;
				Index[ 18 ] = ( WORD )( j + 12 ) ;	Index[ 19 ] = ( WORD )( j + 13 ) ;		Index[ 20 ] = ( WORD )( j + 14 ) ;
				Index[ 21 ] = ( WORD )( j + 15 ) ;	Index[ 22 ] = ( WORD )( j + 14 ) ;		Index[ 23 ] = ( WORD )( j + 13 ) ;
				Index[ 24 ] = ( WORD )( j + 16 ) ;	Index[ 25 ] = ( WORD )( j + 17 ) ;		Index[ 26 ] = ( WORD )( j + 18 ) ;
				Index[ 27 ] = ( WORD )( j + 19 ) ;	Index[ 28 ] = ( WORD )( j + 18 ) ;		Index[ 29 ] = ( WORD )( j + 17 ) ;
				Index[ 30 ] = ( WORD )( j + 20 ) ;	Index[ 31 ] = ( WORD )( j + 21 ) ;		Index[ 32 ] = ( WORD )( j + 22 ) ;
				Index[ 33 ] = ( WORD )( j + 23 ) ;	Index[ 34 ] = ( WORD )( j + 22 ) ;		Index[ 35 ] = ( WORD )( j + 21 ) ;

				Index += 36 ;
				j += 24 ;
			}
		}

		// ̂̐JԂ
		Vertex = GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ 1 ] ;
		j = 0 ;
		for( k = 0 ; k < Num ; k ++, CubeDataArray ++ )
		{
			// _f[^̍쐬
			Vertex[ 0 ].pos.x = CubeDataArray->Pos1.x ; Vertex[ 0 ].pos.y = CubeDataArray->Pos2.y ; Vertex[ 0 ].pos.z = CubeDataArray->Pos1.z ;
			Vertex[ 1 ].pos.x = CubeDataArray->Pos2.x ; Vertex[ 1 ].pos.y = CubeDataArray->Pos2.y ; Vertex[ 1 ].pos.z = CubeDataArray->Pos1.z ;
			Vertex[ 2 ].pos.x = CubeDataArray->Pos1.x ; Vertex[ 2 ].pos.y = CubeDataArray->Pos1.y ; Vertex[ 2 ].pos.z = CubeDataArray->Pos1.z ;
			Vertex[ 3 ].pos.x = CubeDataArray->Pos2.x ; Vertex[ 3 ].pos.y = CubeDataArray->Pos1.y ; Vertex[ 3 ].pos.z = CubeDataArray->Pos1.z ;

			Vertex[ 4 + 0 ].pos.x = CubeDataArray->Pos2.x ; Vertex[ 4 + 0 ].pos.y = CubeDataArray->Pos2.y ; Vertex[ 4 + 0 ].pos.z = CubeDataArray->Pos2.z ;
			Vertex[ 4 + 1 ].pos.x = CubeDataArray->Pos1.x ; Vertex[ 4 + 1 ].pos.y = CubeDataArray->Pos2.y ; Vertex[ 4 + 1 ].pos.z = CubeDataArray->Pos2.z ;
			Vertex[ 4 + 2 ].pos.x = CubeDataArray->Pos2.x ; Vertex[ 4 + 2 ].pos.y = CubeDataArray->Pos1.y ; Vertex[ 4 + 2 ].pos.z = CubeDataArray->Pos2.z ;
			Vertex[ 4 + 3 ].pos.x = CubeDataArray->Pos1.x ; Vertex[ 4 + 3 ].pos.y = CubeDataArray->Pos1.y ; Vertex[ 4 + 3 ].pos.z = CubeDataArray->Pos2.z ;

			Vertex[ 8 + 0 ].pos.x = CubeDataArray->Pos1.x ; Vertex[ 8 + 0 ].pos.y = CubeDataArray->Pos2.y ; Vertex[ 8 + 0 ].pos.z = CubeDataArray->Pos2.z ;
			Vertex[ 8 + 1 ].pos.x = CubeDataArray->Pos1.x ; Vertex[ 8 + 1 ].pos.y = CubeDataArray->Pos2.y ; Vertex[ 8 + 1 ].pos.z = CubeDataArray->Pos1.z ;
			Vertex[ 8 + 2 ].pos.x = CubeDataArray->Pos1.x ; Vertex[ 8 + 2 ].pos.y = CubeDataArray->Pos1.y ; Vertex[ 8 + 2 ].pos.z = CubeDataArray->Pos2.z ;
			Vertex[ 8 + 3 ].pos.x = CubeDataArray->Pos1.x ; Vertex[ 8 + 3 ].pos.y = CubeDataArray->Pos1.y ; Vertex[ 8 + 3 ].pos.z = CubeDataArray->Pos1.z ;

			Vertex[ 12 + 0 ].pos.x = CubeDataArray->Pos2.x ; Vertex[ 12 + 0 ].pos.y = CubeDataArray->Pos2.y ; Vertex[ 12 + 0 ].pos.z = CubeDataArray->Pos1.z ;
			Vertex[ 12 + 1 ].pos.x = CubeDataArray->Pos2.x ; Vertex[ 12 + 1 ].pos.y = CubeDataArray->Pos2.y ; Vertex[ 12 + 1 ].pos.z = CubeDataArray->Pos2.z ;
			Vertex[ 12 + 2 ].pos.x = CubeDataArray->Pos2.x ; Vertex[ 12 + 2 ].pos.y = CubeDataArray->Pos1.y ; Vertex[ 12 + 2 ].pos.z = CubeDataArray->Pos1.z ;
			Vertex[ 12 + 3 ].pos.x = CubeDataArray->Pos2.x ; Vertex[ 12 + 3 ].pos.y = CubeDataArray->Pos1.y ; Vertex[ 12 + 3 ].pos.z = CubeDataArray->Pos2.z ;

			Vertex[ 16 + 0 ].pos.x = CubeDataArray->Pos1.x ; Vertex[ 16 + 0 ].pos.y = CubeDataArray->Pos2.y ; Vertex[ 16 + 0 ].pos.z = CubeDataArray->Pos2.z ;
			Vertex[ 16 + 1 ].pos.x = CubeDataArray->Pos2.x ; Vertex[ 16 + 1 ].pos.y = CubeDataArray->Pos2.y ; Vertex[ 16 + 1 ].pos.z = CubeDataArray->Pos2.z ;
			Vertex[ 16 + 2 ].pos.x = CubeDataArray->Pos1.x ; Vertex[ 16 + 2 ].pos.y = CubeDataArray->Pos2.y ; Vertex[ 16 + 2 ].pos.z = CubeDataArray->Pos1.z ;
			Vertex[ 16 + 3 ].pos.x = CubeDataArray->Pos2.x ; Vertex[ 16 + 3 ].pos.y = CubeDataArray->Pos2.y ; Vertex[ 16 + 3 ].pos.z = CubeDataArray->Pos1.z ;

			Vertex[ 20 + 0 ].pos.x = CubeDataArray->Pos1.x ; Vertex[ 20 + 0 ].pos.y = CubeDataArray->Pos1.y ; Vertex[ 20 + 0 ].pos.z = CubeDataArray->Pos1.z ;
			Vertex[ 20 + 1 ].pos.x = CubeDataArray->Pos2.x ; Vertex[ 20 + 1 ].pos.y = CubeDataArray->Pos1.y ; Vertex[ 20 + 1 ].pos.z = CubeDataArray->Pos1.z ;
			Vertex[ 20 + 2 ].pos.x = CubeDataArray->Pos1.x ; Vertex[ 20 + 2 ].pos.y = CubeDataArray->Pos1.y ; Vertex[ 20 + 2 ].pos.z = CubeDataArray->Pos2.z ;
			Vertex[ 20 + 3 ].pos.x = CubeDataArray->Pos2.x ; Vertex[ 20 + 3 ].pos.y = CubeDataArray->Pos1.y ; Vertex[ 20 + 3 ].pos.z = CubeDataArray->Pos2.z ;

			for( i = 0 ; i < 24 ; i ++ )
			{
				Vertex[ i ].dif = CubeDataArray->DifColor ;
				Vertex[ i ].spc = CubeDataArray->SpcColor ;
			}

			// _f[^tɂȂ`
			j ++ ;
			if( j >= 2730 )
			{
				NS_DrawPrimitiveIndexed3D(
					GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ 1 ], 24 * j,
					GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 2 ], 36 * j,
					DX_PRIMTYPE_TRIANGLELIST, DX_NONE_GRAPH, TRUE ) ;

				Vertex = GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ 1 ] ;
				j = 0 ;
			}
			else
			{
				Vertex += 24 ;
			}
		}

		// _f[^cĂ`
		if( j > 0 )
		{
			NS_DrawPrimitiveIndexed3D(
				GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ 1 ], 24 * j,
				GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 2 ], 36 * j,
				DX_PRIMTYPE_TRIANGLELIST, DX_NONE_GRAPH, TRUE ) ;
		}
	}
	else
	{
		// w̐̒_߂obt@mۂĂȂm
		if( GSYS.Resource.DrawCubeSet3DWorkVertexBufferSize[ 0 ] < Num &&
			GSYS.Resource.DrawCubeSet3DWorkVertexBufferSize[ 0 ] < 8191 )
		{
			GSYS.Resource.DrawCubeSet3DWorkVertexBufferSize[ 0 ] = Num * 3 / 2 ;
			if( GSYS.Resource.DrawCubeSet3DWorkVertexBufferSize[ 0 ] > 8191 )
			{
				GSYS.Resource.DrawCubeSet3DWorkVertexBufferSize[ 0 ] = 8191 ;
			}

			if( GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ 0 ] == NULL )
			{
				GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ 0 ] = ( VERTEX3D * )DXALLOC( GSYS.Resource.DrawCubeSet3DWorkVertexBufferSize[ 0 ] * sizeof( VERTEX3D ) * 8 ) ;
			}
			else
			{
				GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ 0 ] = ( VERTEX3D * )DXREALLOC( GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ 0 ], GSYS.Resource.DrawCubeSet3DWorkVertexBufferSize[ 0 ] * sizeof( VERTEX3D ) * 8 ) ;
			}

			// _f[^̌ŒlZbg
			Vertex = GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ 0 ] ;
			for( i = 0 ; i < GSYS.Resource.DrawCubeSet3DWorkVertexBufferSize[ 0 ] ; i ++ )
			{
				Vertex[ 0 ].norm.x = -0.57735027f ;	Vertex[ 0 ].norm.y =  0.57735027f ;	Vertex[ 0 ].norm.z =  0.57735027f ;
				Vertex[ 1 ].norm.x =  0.57735027f ;	Vertex[ 1 ].norm.y =  0.57735027f ;	Vertex[ 1 ].norm.z =  0.57735027f ;
				Vertex[ 2 ].norm.x =  0.57735027f ;	Vertex[ 2 ].norm.y =  0.57735027f ;	Vertex[ 2 ].norm.z = -0.57735027f ;
				Vertex[ 3 ].norm.x = -0.57735027f ;	Vertex[ 3 ].norm.y =  0.57735027f ;	Vertex[ 3 ].norm.z = -0.57735027f ;
				Vertex[ 4 ].norm.x = -0.57735027f ;	Vertex[ 4 ].norm.y = -0.57735027f ;	Vertex[ 4 ].norm.z =  0.57735027f ;
				Vertex[ 5 ].norm.x =  0.57735027f ;	Vertex[ 5 ].norm.y = -0.57735027f ;	Vertex[ 5 ].norm.z =  0.57735027f ;
				Vertex[ 6 ].norm.x =  0.57735027f ;	Vertex[ 6 ].norm.y = -0.57735027f ;	Vertex[ 6 ].norm.z = -0.57735027f ;
				Vertex[ 7 ].norm.x = -0.57735027f ;	Vertex[ 7 ].norm.y = -0.57735027f ;	Vertex[ 7 ].norm.z = -0.57735027f ;
				Vertex[ 0 ].u = 0.0f ;		Vertex[ 0 ].v = 0.0f ;		Vertex[ 0 ].su = 0.0f ;		Vertex[ 0 ].sv = 0.0f ;
				Vertex[ 1 ].u = 0.0f ;		Vertex[ 1 ].v = 0.0f ;		Vertex[ 1 ].su = 0.0f ;		Vertex[ 1 ].sv = 0.0f ;
				Vertex[ 2 ].u = 0.0f ;		Vertex[ 2 ].v = 0.0f ;		Vertex[ 2 ].su = 0.0f ;		Vertex[ 2 ].sv = 0.0f ;
				Vertex[ 3 ].u = 0.0f ;		Vertex[ 3 ].v = 0.0f ;		Vertex[ 3 ].su = 0.0f ;		Vertex[ 3 ].sv = 0.0f ;
				Vertex[ 4 ].u = 0.0f ;		Vertex[ 4 ].v = 0.0f ;		Vertex[ 4 ].su = 0.0f ;		Vertex[ 4 ].sv = 0.0f ;
				Vertex[ 5 ].u = 0.0f ;		Vertex[ 5 ].v = 0.0f ;		Vertex[ 5 ].su = 0.0f ;		Vertex[ 5 ].sv = 0.0f ;
				Vertex[ 6 ].u = 0.0f ;		Vertex[ 6 ].v = 0.0f ;		Vertex[ 6 ].su = 0.0f ;		Vertex[ 6 ].sv = 0.0f ;
				Vertex[ 7 ].u = 0.0f ;		Vertex[ 7 ].v = 0.0f ;		Vertex[ 7 ].su = 0.0f ;		Vertex[ 7 ].sv = 0.0f ;

				Vertex += 8 ;
			}
		}

		if( FillFlag == TRUE )
		{
			// w̐̃CfbNX߂obt@mۂĂȂm
			if( GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 1 ] < Num &&
				GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 1 ] < 8191 )
			{
				GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 1 ] = Num * 3 / 2 ;
				if( GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 1 ] > 8191 )
				{
					GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 1 ] = 8191 ;
				}

				if( GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 1 ] == NULL )
				{
					GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 1 ] = ( WORD * )DXALLOC( GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 1 ] * sizeof( WORD ) * 36 ) ;
				}
				else
				{
					GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 1 ] = ( WORD * )DXREALLOC( GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 1 ], GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 1 ] * sizeof( WORD ) * 36 ) ;
				}

				// CfbNX̌ŒlZbg
				Index = GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 1 ] ;
				j = 0 ;
				for( i = 0 ; i < GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 1 ] ; i ++ )
				{
					Index[  0 ] = ( WORD )( j + 0 ) ;	Index[  1 ] = ( WORD )( j + 1 ) ;	Index[  2 ] = ( WORD )( j + 3 ) ;
					Index[  3 ] = ( WORD )( j + 3 ) ;	Index[  4 ] = ( WORD )( j + 1 ) ;	Index[  5 ] = ( WORD )( j + 2 ) ;
					Index[  6 ] = ( WORD )( j + 3 ) ;	Index[  7 ] = ( WORD )( j + 2 ) ;	Index[  8 ] = ( WORD )( j + 7 ) ;
					Index[  9 ] = ( WORD )( j + 7 ) ;	Index[ 10 ] = ( WORD )( j + 2 ) ;	Index[ 11 ] = ( WORD )( j + 6 ) ;
					Index[ 12 ] = ( WORD )( j + 2 ) ;	Index[ 13 ] = ( WORD )( j + 1 ) ;	Index[ 14 ] = ( WORD )( j + 6 ) ;
					Index[ 15 ] = ( WORD )( j + 6 ) ;	Index[ 16 ] = ( WORD )( j + 1 ) ;	Index[ 17 ] = ( WORD )( j + 5 ) ;
					Index[ 18 ] = ( WORD )( j + 1 ) ;	Index[ 19 ] = ( WORD )( j + 0 ) ;	Index[ 20 ] = ( WORD )( j + 5 ) ;
					Index[ 21 ] = ( WORD )( j + 5 ) ;	Index[ 22 ] = ( WORD )( j + 0 ) ;	Index[ 23 ] = ( WORD )( j + 4 ) ;
					Index[ 24 ] = ( WORD )( j + 0 ) ;	Index[ 25 ] = ( WORD )( j + 3 ) ;	Index[ 26 ] = ( WORD )( j + 4 ) ;
					Index[ 27 ] = ( WORD )( j + 4 ) ;	Index[ 28 ] = ( WORD )( j + 3 ) ;	Index[ 29 ] = ( WORD )( j + 7 ) ;
					Index[ 30 ] = ( WORD )( j + 7 ) ;	Index[ 31 ] = ( WORD )( j + 6 ) ;	Index[ 32 ] = ( WORD )( j + 4 ) ;
					Index[ 33 ] = ( WORD )( j + 4 ) ;	Index[ 34 ] = ( WORD )( j + 6 ) ;	Index[ 35 ] = ( WORD )( j + 5 ) ;

					Index += 36 ;
					j += 8 ;
				}
			}
		}
		else
		{
			// w̐̃CfbNX߂obt@mۂĂȂm
			if( GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 2 ] < Num &&
				GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 2 ] < 8191 )
			{
				GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 2 ] = Num * 3 / 2 ;
				if( GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 2 ] > 8191 )
				{
					GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 2 ] = 8191 ;
				}

				if( GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 2 ] == NULL )
				{
					GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 2 ] = ( WORD * )DXALLOC( GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 2 ] * sizeof( WORD ) * 24 ) ;
				}
				else
				{
					GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 2 ] = ( WORD * )DXREALLOC( GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 2 ], GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 2 ] * sizeof( WORD ) * 24 ) ;
				}

				// CfbNX̌ŒlZbg
				Index = GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 2 ] ;
				j = 0 ;
				for( i = 0 ; i < GSYS.Resource.DrawCubeSet3DWorkIndexBufferSize[ 2 ] ; i ++ )
				{
					Index[  0 ] = ( WORD )( j + 0 ) ;	Index[  1 ] = ( WORD )( j + 1 ) ;
					Index[  2 ] = ( WORD )( j + 1 ) ;	Index[  3 ] = ( WORD )( j + 2 ) ;
					Index[  4 ] = ( WORD )( j + 2 ) ;	Index[  5 ] = ( WORD )( j + 3 ) ;
					Index[  6 ] = ( WORD )( j + 3 ) ;	Index[  7 ] = ( WORD )( j + 0 ) ;
					Index[  8 ] = ( WORD )( j + 0 ) ;	Index[  9 ] = ( WORD )( j + 4 ) ;
					Index[ 10 ] = ( WORD )( j + 1 ) ;	Index[ 11 ] = ( WORD )( j + 5 ) ;
					Index[ 12 ] = ( WORD )( j + 2 ) ;	Index[ 13 ] = ( WORD )( j + 6 ) ;
					Index[ 14 ] = ( WORD )( j + 3 ) ;	Index[ 15 ] = ( WORD )( j + 7 ) ;
					Index[ 16 ] = ( WORD )( j + 4 ) ;	Index[ 17 ] = ( WORD )( j + 5 ) ;
					Index[ 18 ] = ( WORD )( j + 5 ) ;	Index[ 19 ] = ( WORD )( j + 6 ) ;
					Index[ 20 ] = ( WORD )( j + 6 ) ;	Index[ 21 ] = ( WORD )( j + 7 ) ;
					Index[ 22 ] = ( WORD )( j + 7 ) ;	Index[ 23 ] = ( WORD )( j + 4 ) ;

					Index += 24 ;
					j += 8 ;
				}
			}
		}

		// ̂̐JԂ
		Vertex = GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ 0 ] ;
		j = 0 ;
		for( k = 0 ; k < Num ; k ++, CubeDataArray ++ )
		{
			// _f[^̍쐬
			Vertex[ 0 ].pos.x = CubeDataArray->Pos1.x ; Vertex[ 0 ].pos.y = CubeDataArray->Pos2.y ; Vertex[ 0 ].pos.z = CubeDataArray->Pos2.z ;
			Vertex[ 1 ].pos.x = CubeDataArray->Pos2.x ; Vertex[ 1 ].pos.y = CubeDataArray->Pos2.y ; Vertex[ 1 ].pos.z = CubeDataArray->Pos2.z ;
			Vertex[ 2 ].pos.x = CubeDataArray->Pos2.x ; Vertex[ 2 ].pos.y = CubeDataArray->Pos2.y ; Vertex[ 2 ].pos.z = CubeDataArray->Pos1.z ;
			Vertex[ 3 ].pos.x = CubeDataArray->Pos1.x ; Vertex[ 3 ].pos.y = CubeDataArray->Pos2.y ; Vertex[ 3 ].pos.z = CubeDataArray->Pos1.z ;
			Vertex[ 4 ].pos.x = CubeDataArray->Pos1.x ; Vertex[ 4 ].pos.y = CubeDataArray->Pos1.y ; Vertex[ 4 ].pos.z = CubeDataArray->Pos2.z ;
			Vertex[ 5 ].pos.x = CubeDataArray->Pos2.x ; Vertex[ 5 ].pos.y = CubeDataArray->Pos1.y ; Vertex[ 5 ].pos.z = CubeDataArray->Pos2.z ;
			Vertex[ 6 ].pos.x = CubeDataArray->Pos2.x ; Vertex[ 6 ].pos.y = CubeDataArray->Pos1.y ; Vertex[ 6 ].pos.z = CubeDataArray->Pos1.z ;
			Vertex[ 7 ].pos.x = CubeDataArray->Pos1.x ; Vertex[ 7 ].pos.y = CubeDataArray->Pos1.y ; Vertex[ 7 ].pos.z = CubeDataArray->Pos1.z ;

			Vertex[ 0 ].dif = CubeDataArray->DifColor ;	Vertex[ 0 ].spc = CubeDataArray->SpcColor ;
			Vertex[ 1 ].dif = CubeDataArray->DifColor ;	Vertex[ 1 ].spc = CubeDataArray->SpcColor ;
			Vertex[ 2 ].dif = CubeDataArray->DifColor ;	Vertex[ 2 ].spc = CubeDataArray->SpcColor ;
			Vertex[ 3 ].dif = CubeDataArray->DifColor ;	Vertex[ 3 ].spc = CubeDataArray->SpcColor ;
			Vertex[ 4 ].dif = CubeDataArray->DifColor ;	Vertex[ 4 ].spc = CubeDataArray->SpcColor ;
			Vertex[ 5 ].dif = CubeDataArray->DifColor ;	Vertex[ 5 ].spc = CubeDataArray->SpcColor ;
			Vertex[ 6 ].dif = CubeDataArray->DifColor ;	Vertex[ 6 ].spc = CubeDataArray->SpcColor ;
			Vertex[ 7 ].dif = CubeDataArray->DifColor ;	Vertex[ 7 ].spc = CubeDataArray->SpcColor ;

			// _f[^tɂȂ`
			j ++ ;
			if( j >= 8191 )
			{
				if( FillFlag == TRUE )
				{
					NS_DrawPrimitiveIndexed3D(
						GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ 0 ], 8 * j,
						GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 1 ], 36 * j,
						DX_PRIMTYPE_TRIANGLELIST, DX_NONE_GRAPH, TRUE ) ;
				}
				else
				{
					NS_DrawPrimitiveIndexed3D(
						GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ 0 ], 8 * j,
						GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 2 ], 24 * j,
						DX_PRIMTYPE_LINELIST, DX_NONE_GRAPH, TRUE ) ;
				}

				Vertex = GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ 0 ] ;
				j = 0 ;
			}
			else
			{
				Vertex += 8 ;
			}
		}

		// _f[^cĂ`
		if( j > 0 )
		{
			if( FillFlag == TRUE )
			{
				NS_DrawPrimitiveIndexed3D(
					GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ 0 ], 8 * j,
					GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 1 ], 36 * j,
					DX_PRIMTYPE_TRIANGLELIST, DX_NONE_GRAPH, TRUE ) ;
			}
			else
			{
				NS_DrawPrimitiveIndexed3D(
					GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ 0 ], 8 * j,
					GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ 2 ], 24 * j,
					DX_PRIMTYPE_LINELIST, DX_NONE_GRAPH, TRUE ) ;
			}
		}
	}

	// I
	return 0 ;
}

// Rc̋̂`悷
extern int NS_DrawSphere3D( VECTOR CenterPos, float r, int DivNum, unsigned int DifColor, unsigned int SpcColor, int FillFlag )
{
	return NS_DrawSphere3DD( VConvFtoD( CenterPos ), r, DivNum, DifColor, SpcColor, FillFlag ) ;
}

// Rc̋̂`悷
extern int NS_DrawSphere3DD( VECTOR_D CenterPos, double r, int DivNum, unsigned int DifColor, unsigned int SpcColor, int FillFlag )
{
	VERTEX3D *Vertex, *vert ;
	WORD *Index, *ind ;
	float *SinCosTable1, *SinCosTable2, *t1, *t2, rf ;
	int CirVertNumH, CirVertNumV, i, j, k, l, indexnum, vertnum ;
	int dr, dg, db, a, sr, sg, sb ;
	VECTOR CenterPosF ;
	LARGE3DPOSITIONSUPPORT_DRAWINFO Large3DPosDrawInfo ;

	if( GSYS.DrawSetting.Large3DPositionSupport )
	{
		Graphics_Draw_BeginLarge3DPositionSupportDraw( &Large3DPosDrawInfo, CenterPos ) ; 

		CenterPos.x = 0.0 ;
		CenterPos.y = 0.0 ;
		CenterPos.z = 0.0 ;
	}

	CenterPosF = VConvDtoF( CenterPos ) ;
	rf         = ( float )r ;

	NS_GetColor2( DifColor, &dr, &dg, &db ) ;
	NS_GetColor2( SpcColor, &sr, &sg, &sb ) ;
	a = GSYS.DrawSetting.BlendMode == DX_BLENDMODE_NOBLEND ? 255 : GSYS.DrawSetting.BlendParam ;

	CirVertNumH = DivNum + 4 ;
	CirVertNumV = DivNum + 1 ;
	indexnum = FillFlag ? ( CirVertNumV - 1 ) * CirVertNumH * 6 + CirVertNumH * 3 * 2 : CirVertNumH * ( CirVertNumV + 1 ) * 2 + CirVertNumV * CirVertNumH * 2 ;
	vertnum = CirVertNumV * CirVertNumH + 2 ;
	Vertex = ( VERTEX3D * )DXALLOC( sizeof( WORD ) * indexnum + sizeof( VERTEX3D ) * vertnum + sizeof( float ) * ( CirVertNumV + CirVertNumH ) * 2 ) ;
	if( Vertex == NULL )
	{
		if( GSYS.DrawSetting.Large3DPositionSupport )
		{
			Graphics_Draw_EndLarge3DPositionSupportDraw( &Large3DPosDrawInfo ) ;
		}
		return 0 ;
	}
	SinCosTable1 = ( float * )( Vertex + vertnum ) ;
	SinCosTable2 = SinCosTable1 + CirVertNumV * 2 ;
	Index = ( WORD * )( SinCosTable2 + CirVertNumH * 2 ) ;

	// _f[^̍쐬
	t1 = SinCosTable1 ;
	t2 = SinCosTable2 ;
	for( i = 0 ; i < CirVertNumH ; i ++, t2 += 2 )
	{
		_SINCOS_PLATFORM( 2 * ( float )DX_PI / CirVertNumH * i, t2, t2 + 1 ) ;
	}
	for( i = 0 ; i < CirVertNumV ; i ++, t1 += 2 )
	{
		_SINCOS_PLATFORM( ( float )DX_PI / 2.0f - ( float )DX_PI / ( CirVertNumV + 1 ) * ( i + 1 ), t1, t1 + 1 ) ;
	}
	vert = Vertex ;
	t1 = SinCosTable1 ;
	for( i = 0 ; i < CirVertNumV ; i ++, t1 += 2 )
	{
		t2 = SinCosTable2 ;
		for( j = 0 ; j < CirVertNumH ; j ++, vert ++, t2 += 2 )
		{
			vert->pos.x = t2[ 1 ] * t1[ 1 ] * rf + CenterPosF.x ;
			vert->pos.y = t1[ 0 ] * rf           + CenterPosF.y ;
			vert->pos.z = t2[ 0 ] * t1[ 1 ] * rf + CenterPosF.z ;
			vert->norm.x = t2[ 1 ] * t1[ 1 ] ;
			vert->norm.y = t1[ 0 ] ;
			vert->norm.z = t2[ 0 ] * t1[ 1 ] ;

			vert->dif.b = ( BYTE )db ;
			vert->dif.g = ( BYTE )dg ;
			vert->dif.r = ( BYTE )dr ;
			vert->dif.a = ( BYTE )a ;
			vert->spc.b = ( BYTE )sb ;
			vert->spc.g = ( BYTE )sg ;
			vert->spc.r = ( BYTE )sr ;
			vert->spc.a = 0 ;
			vert->u = 0.0f ;
			vert->v = 0.0f ;
			vert->su = 0.0f ;
			vert->sv = 0.0f ;
		}
	}
	vert->pos.x = 0.0f + CenterPosF.x ;
	vert->pos.y =   rf + CenterPosF.y ;
	vert->pos.z = 0.0f + CenterPosF.z ;
	vert->norm.x = 0.0f ;
	vert->norm.y = 1.0f ;
	vert->norm.z = 0.0f ;

	vert->dif.b = ( BYTE )db ;
	vert->dif.g = ( BYTE )dg ;
	vert->dif.r = ( BYTE )dr ;
	vert->dif.a = ( BYTE )a ;
	vert->spc.b = ( BYTE )sb ;
	vert->spc.g = ( BYTE )sg ;
	vert->spc.r = ( BYTE )sr ;
	vert->spc.a = 0 ;
	vert->u = 0.0f ;
	vert->v = 0.0f ;
	vert->su = 0.0f ;
	vert->sv = 0.0f ;

	vert ++ ;

	vert->pos.x = 0.0f + CenterPosF.x ;
	vert->pos.y =  -rf + CenterPosF.y ;
	vert->pos.z = 0.0f + CenterPosF.z ;
	vert->norm.x = 0.0f ;
	vert->norm.y = -1.0f ;
	vert->norm.z = 0.0f ;

	vert->dif.b = ( BYTE )db ;
	vert->dif.g = ( BYTE )dg ;
	vert->dif.r = ( BYTE )dr ;
	vert->dif.a = ( BYTE )a ;
	vert->spc.b = ( BYTE )sb ;
	vert->spc.g = ( BYTE )sg ;
	vert->spc.r = ( BYTE )sr ;
	vert->spc.a = 0 ;
	vert->u = 0.0f ;
	vert->v = 0.0f ;
	vert->su = 0.0f ;
	vert->sv = 0.0f ;

	vert ++ ;

	// hԂǂŏ𕪊
	if( FillFlag )
	{
		ind = Index ;
		l = CirVertNumV * CirVertNumH ;
		for( j = 0 ; j < CirVertNumH - 1 ; j ++, ind += 3 )
		{
			ind[ 0 ] = ( WORD )j ;
			ind[ 1 ] = ( WORD )l ;
			ind[ 2 ] = ( WORD )( j + 1 ) ;
		}
		ind[ 0 ] = ( WORD )j ;
		ind[ 1 ] = ( WORD )l ;
		ind[ 2 ] = 0 ;

		ind += 3 ;

		k = 0 ;
		for( i = 0 ; i < CirVertNumV - 1 ; i ++, k += CirVertNumH )
		{
			for( j = 0 ; j < CirVertNumH - 1 ; j ++, ind += 6 )
			{
				ind[ 0 ] = ( WORD )( j + k ) ;
				ind[ 1 ] = ( WORD )( ind[ 0 ] + 1 ) ;
				ind[ 2 ] = ( WORD )( ind[ 0 ] + CirVertNumH ) ;
				
				ind[ 3 ] = ind[ 2 ] ;
				ind[ 4 ] = ind[ 1 ] ;
				ind[ 5 ] = ( WORD )( ind[ 3 ] + 1 ) ;
			}
			ind[ 0 ] = ( WORD )( j + k ) ;
			ind[ 1 ] = ( WORD )k ;
			ind[ 2 ] = ( WORD )( ind[ 0 ] + CirVertNumH ) ;
			
			ind[ 3 ] = ind[ 2 ] ;
			ind[ 4 ] = ind[ 1 ] ;
			ind[ 5 ] = ( WORD )( k + CirVertNumH ) ;

			ind += 6 ;
		}

		l = CirVertNumV * CirVertNumH + 1 ;
		for( j = 0 ; j < CirVertNumH - 1 ; j ++, ind += 3 )
		{
			ind[ 0 ] = ( WORD )( j + 1 + k ) ;
			ind[ 1 ] = ( WORD )l ;
			ind[ 2 ] = ( WORD )( j + k ) ;
		}
		ind[ 0 ] = ( WORD )k ;
		ind[ 1 ] = ( WORD )l ;
		ind[ 2 ] = ( WORD )( j + k ) ;

		ind += 3 ;
		NS_DrawPrimitiveIndexed3D( Vertex, vertnum, Index, indexnum, DX_PRIMTYPE_TRIANGLELIST, DX_NONE_GRAPH, TRUE ) ;
	}
	else
	{
		ind = Index ;
		for( i = 0 ; i < CirVertNumH ; i ++ )
		{
			ind[ 0 ] = ( WORD )( CirVertNumV * CirVertNumH ) ;
			ind[ 1 ] = ( WORD )i ;
			ind += 2 ;

			k = i ;
			for( j = 0 ; j < CirVertNumV - 1 ; j ++, k += CirVertNumH, ind += 2 )
			{
				ind[ 0 ] = ( WORD )k ;
				ind[ 1 ] = ( WORD )( k + CirVertNumH ) ;
			}
			
			ind[ 0 ] = ( WORD )k ;
			ind[ 1 ] = ( WORD )( CirVertNumV * CirVertNumH + 1 ) ;
			ind += 2 ;
		}

		k = 0 ;
		for( i = 0 ; i < CirVertNumV ; i ++, k += CirVertNumH )
		{
			for( j = 0 ; j < CirVertNumH - 1 ; j ++, ind += 2 )
			{
				ind[ 0 ] = ( WORD )( j + k ) ;
				ind[ 1 ] = ( WORD )( j + k + 1 ) ;
			}
			ind[ 0 ] = ( WORD )( j + k ) ;
			ind[ 1 ] = ( WORD )k ;
			ind += 2 ;
		}

		NS_DrawPrimitiveIndexed3D( Vertex, vertnum, Index, indexnum, DX_PRIMTYPE_LINELIST, DX_NONE_GRAPH, TRUE ) ;
	}

	// ̉
	DXFREE( Vertex ) ;

	if( GSYS.DrawSetting.Large3DPositionSupport )
	{
		Graphics_Draw_EndLarge3DPositionSupportDraw( &Large3DPosDrawInfo ) ;
	}

	// I
	return 0 ;
}

// Rc̃JvZ`
extern int NS_DrawCapsule3D( VECTOR Pos1, VECTOR Pos2, float r, int DivNum, unsigned int DifColor, unsigned int SpcColor, int FillFlag )
{
	return NS_DrawCapsule3DD( VConvFtoD( Pos1 ), VConvFtoD( Pos2 ), r, DivNum, DifColor, SpcColor, FillFlag ) ;
}

// Rc̃JvZ`
extern int NS_DrawCapsule3DD( VECTOR_D Pos1, VECTOR_D Pos2, double r, int DivNum, unsigned int DifColor, unsigned int SpcColor, int FillFlag )
{
	VERTEX3D *Vertex, *vert1, *vert2 ;
	WORD *Index, *ind ;
	VECTOR_D SubV, xv, yv, zv ;
	VECTOR xvf, yvf, zvf, Pos1F ;
	double Length ;
	float *SinCosTable1, *SinCosTable2, *t1, *t2, x, y, z, LengthF, rf ;
	int CirVertNumH, CirVertNumV, i, j, k, topind, botind, ettopind, etbotind, indexnum ;
	int dr, dg, db, a, sr, sg, sb, vertnum ;
	LARGE3DPOSITIONSUPPORT_DRAWINFO Large3DPosDrawInfo ;

	if( GSYS.DrawSetting.Large3DPositionSupport )
	{
		Graphics_Draw_BeginLarge3DPositionSupportDraw( &Large3DPosDrawInfo, Pos1 ) ; 

		Pos2 = VSubD( Pos2, Pos1 ) ;
		Pos1 = VGetD( 0.0, 0.0, 0.0 ) ;
	}

	rf = ( float )r ;
	Pos1F = VConvDtoF( Pos1 ) ;

	NS_GetColor2( DifColor, &dr, &dg, &db ) ;
	NS_GetColor2( SpcColor, &sr, &sg, &sb ) ;
	a = GSYS.DrawSetting.BlendMode == DX_BLENDMODE_NOBLEND ? 255 : GSYS.DrawSetting.BlendParam ;

	SubV   = VSubD( Pos2, Pos1 ) ;
	Length = VectorInnerProductD( &SubV, &SubV ) ;
	if( Length < 0.00000000001 )
	{
		xvf = VGet( 1.0, 0.0, 0.0 ) ;
		yvf = VGet( 0.0, 1.0, 0.0 ) ;
		zvf = VGet( 0.0, 0.0, 1.0 ) ;
	}
	else
	{
		Length = _SQRTD( Length ) ;
		yv.x = SubV.x / Length ;
		yv.y = SubV.y / Length ;
		yv.z = SubV.z / Length ;

		xv = VGetD( 1.0, 0.0, 0.0 ) ;
		VectorOuterProductD( &zv, &xv, &yv ) ;
		if( VSquareSizeD( zv ) < 0.0000000001f )
		{
			xv = VGetD( 0.0, 0.0, 1.0 ) ;
			VectorOuterProductD( &zv, &xv, &yv ) ;
		}
		VectorOuterProductD( &xv, &yv, &zv ) ;
		VectorNormalizeD( &xv, &xv ) ;
		VectorNormalizeD( &zv, &zv ) ;

		xvf = VConvDtoF( xv ) ;
		yvf = VConvDtoF( yv ) ;
		zvf = VConvDtoF( zv ) ;
	}
	LengthF = ( float )Length ;

	CirVertNumH = DivNum + 4 ;
	CirVertNumV = DivNum + 2 ;
	indexnum = FillFlag ? ( CirVertNumH * 3 + CirVertNumH * 6 * ( CirVertNumV - 1 ) ) * 2 + CirVertNumH * 6 : CirVertNumH * ( CirVertNumV * 2 + 1 ) * 2 + CirVertNumH * CirVertNumV * 2 * 2 ;
	vertnum  = ( CirVertNumV * CirVertNumH + 1 ) * 2 ;
	Vertex   = ( VERTEX3D * )DXALLOC( sizeof( WORD ) * indexnum + sizeof( VERTEX3D ) * vertnum + sizeof( float ) * ( CirVertNumH + CirVertNumV ) * 2 ) ;
	if( Vertex == NULL )
	{
		if( GSYS.DrawSetting.Large3DPositionSupport )
		{
			Graphics_Draw_EndLarge3DPositionSupportDraw( &Large3DPosDrawInfo ) ;
		}
		return 0 ;
	}
	SinCosTable1 = ( float * )( Vertex + vertnum ) ;
	SinCosTable2 = SinCosTable1 + CirVertNumV * 2 ;
	Index        = ( WORD * )( SinCosTable2 + CirVertNumH * 2 ) ;
	topind       = CirVertNumV * CirVertNumH * 2 ;
	botind       = CirVertNumV * CirVertNumH * 2 + 1 ;
	ettopind     = ( CirVertNumV - 1 ) * CirVertNumH ;
	etbotind     = CirVertNumV * CirVertNumH ;

	// _f[^̍쐬
	t1 = SinCosTable1 ;
	t2 = SinCosTable2 ;
	for( i = 0 ; i < CirVertNumH ; i ++, t2 += 2 )
	{
		_SINCOS_PLATFORM( 2 * ( float )DX_PI / CirVertNumH * i, t2, t2 + 1 ) ;
	}
	for( i = 0 ; i < CirVertNumV ; i ++, t1 += 2 )
	{
		_SINCOS_PLATFORM( ( float )DX_PI / 2.0f - ( float )( DX_PI / 2.0f ) / CirVertNumV * ( i + 1 ), t1, t1 + 1 ) ;
	}
	vert1 = Vertex ;
	t1 = SinCosTable1 ;
	for( i = 0 ; i < CirVertNumV ; i ++, t1 += 2 )
	{
		t2 = SinCosTable2 ;
		vert2 = Vertex + etbotind + ( CirVertNumV - 1 - i ) * CirVertNumH ;
		for( j = 0 ; j < CirVertNumH ; j ++, vert1 ++, vert2 ++, t2 += 2 )
		{
			vert1->pos.x = t2[ 1 ] * t1[ 1 ] * rf ;
			vert1->pos.y = t1[ 0 ] * rf + LengthF ;
			vert1->pos.z = t2[ 0 ] * t1[ 1 ] * rf ;
			vert1->norm.x = t2[ 1 ] * t1[ 1 ] ;
			vert1->norm.y = t1[ 0 ] ;
			vert1->norm.z = t2[ 0 ] * t1[ 1 ] ;

			vert1->dif.b = ( BYTE )db ;
			vert1->dif.g = ( BYTE )dg ;
			vert1->dif.r = ( BYTE )dr ;
			vert1->dif.a = ( BYTE )a ;
			vert1->spc.b = ( BYTE )sb ;
			vert1->spc.g = ( BYTE )sg ;
			vert1->spc.r = ( BYTE )sr ;
			vert1->spc.a = 0 ;
			vert1->u = 0.0f ;
			vert1->v = 0.0f ;
			vert1->su = 0.0f ;
			vert1->sv = 0.0f ;

			vert2->pos.x =    vert1->pos.x ;
			vert2->pos.y = -( vert1->pos.y - LengthF ) ;
			vert2->pos.z =    vert1->pos.z ;
			vert2->norm.x =  vert1->norm.x ;
			vert2->norm.y = -vert1->norm.y ;
			vert2->norm.z =  vert1->norm.z ;

			vert2->dif.b = ( BYTE )db ;
			vert2->dif.g = ( BYTE )dg ;
			vert2->dif.r = ( BYTE )dr ;
			vert2->dif.a = ( BYTE )a ;
			vert2->spc.b = ( BYTE )sb ;
			vert2->spc.g = ( BYTE )sg ;
			vert2->spc.r = ( BYTE )sr ;
			vert2->spc.a = 0 ;
			vert2->u = 0.0f ;
			vert2->v = 0.0f ;
			vert2->su = 0.0f ;
			vert2->sv = 0.0f ;
		}
	}

	vert1 = Vertex + topind ;
	vert1->pos.x = 0.0f ;
	vert1->pos.y = rf + LengthF ;
	vert1->pos.z = 0.0f ;
	vert1->norm.x = 0.0f ;
	vert1->norm.y = 1.0f ;
	vert1->norm.z = 0.0f ;

	vert1->dif.b = ( BYTE )db ;
	vert1->dif.g = ( BYTE )dg ;
	vert1->dif.r = ( BYTE )dr ;
	vert1->dif.a = ( BYTE )a ;
	vert1->spc.b = ( BYTE )sb ;
	vert1->spc.g = ( BYTE )sg ;
	vert1->spc.r = ( BYTE )sr ;
	vert1->spc.a = 0 ;
	vert1->u = 0.0f ;
	vert1->v = 0.0f ;
	vert1->su = 0.0f ;
	vert1->sv = 0.0f ;

	vert1 ++ ;

	vert1->pos.x = 0.0f ;
	vert1->pos.y = -rf ;
	vert1->pos.z = 0.0f ;
	vert1->norm.x = 0.0f ;
	vert1->norm.y = -1.0f ;
	vert1->norm.z = 0.0f ;

	vert1->dif.b = ( BYTE )db ;
	vert1->dif.g = ( BYTE )dg ;
	vert1->dif.r = ( BYTE )dr ;
	vert1->dif.a = ( BYTE )a ;
	vert1->spc.b = ( BYTE )sb ;
	vert1->spc.g = ( BYTE )sg ;
	vert1->spc.r = ( BYTE )sr ;
	vert1->spc.a = 0 ;
	vert1->u = 0.0f ;
	vert1->v = 0.0f ;
	vert1->su = 0.0f ;
	vert1->sv = 0.0f ;

	vert1 ++ ;

	vert1 = Vertex ;
	for( i = 0 ; i < vertnum ; i ++, vert1 ++ )
	{
		x = vert1->pos.x ;
		y = vert1->pos.y ;
		z = vert1->pos.z ;
		vert1->pos.x = x * xvf.x + y * yvf.x + z * zvf.x + Pos1F.x ;
		vert1->pos.y = x * xvf.y + y * yvf.y + z * zvf.y + Pos1F.y ;
		vert1->pos.z = x * xvf.z + y * yvf.z + z * zvf.z + Pos1F.z ;
		x = vert1->norm.x ;
		y = vert1->norm.y ;
		z = vert1->norm.z ;
		vert1->norm.x = x * xvf.x + y * yvf.x + z * zvf.x ;
		vert1->norm.y = x * xvf.y + y * yvf.y + z * zvf.y ;
		vert1->norm.z = x * xvf.z + y * yvf.z + z * zvf.z ;
	}

	// hԂǂŏ𕪊
	if( FillFlag )
	{
		ind = Index ;
		for( j = 0 ; j < CirVertNumH - 1 ; j ++, ind += 3 )
		{
			ind[ 0 ] = ( WORD )j ;
			ind[ 1 ] = ( WORD )topind ;
			ind[ 2 ] = ( WORD )( j + 1 ) ;
		}
		ind[ 0 ] = ( WORD )j ;
		ind[ 1 ] = ( WORD )topind ;
		ind[ 2 ] = 0 ;

		ind += 3 ;

		// 㕔̋̃CfbNXXg쐬
		k = 0 ;
		for( i = 0 ; i < CirVertNumV - 1 ; i ++, k += CirVertNumH )
		{
			for( j = 0 ; j < CirVertNumH - 1 ; j ++, ind += 6 )
			{
				ind[ 0 ] = ( WORD )( j + k ) ;
				ind[ 1 ] = ( WORD )( ind[ 0 ] + 1 ) ;
				ind[ 2 ] = ( WORD )( ind[ 0 ] + CirVertNumH ) ;
				
				ind[ 3 ] = ind[ 2 ] ;
				ind[ 4 ] = ind[ 1 ] ;
				ind[ 5 ] = ( WORD )( ind[ 3 ] + 1 ) ;
			}
			ind[ 0 ] = ( WORD )( j + k ) ;
			ind[ 1 ] = ( WORD )k ;
			ind[ 2 ] = ( WORD )( ind[ 0 ] + CirVertNumH ) ;
			
			ind[ 3 ] = ind[ 2 ] ;
			ind[ 4 ] = ind[ 1 ] ;
			ind[ 5 ] = ( WORD )( k + CirVertNumH ) ;

			ind += 6 ;
		}

		// S̉~̃CfbNXXg쐬
		for( i = 0 ; i < CirVertNumH - 1 ; i ++, ind += 6 )
		{
			ind[ 0 ] = ( WORD )( ettopind + i ) ;
			ind[ 1 ] = ( WORD )( ind[ 0 ] + 1 ) ;
			ind[ 2 ] = ( WORD )( etbotind + i ) ;

			ind[ 3 ] = ind[ 2 ] ;
			ind[ 4 ] = ind[ 1 ] ;
			ind[ 5 ] = ( WORD )( ind[ 3 ] + 1 ) ;
		}
		ind[ 0 ] = ( WORD )( ettopind + i ) ;
		ind[ 1 ] = ( WORD )ettopind ;
		ind[ 2 ] = ( WORD )( etbotind + i ) ;

		ind[ 3 ] = ind[ 2 ] ;
		ind[ 4 ] = ind[ 1 ] ;
		ind[ 5 ] = ( WORD )etbotind ;

		ind += 6 ;
		k += CirVertNumH ;

		// ̋̃CfbNXXg쐬
		for( i = 0 ; i < CirVertNumV - 1 ; i ++, k += CirVertNumH )
		{
			for( j = 0 ; j < CirVertNumH - 1 ; j ++, ind += 6 )
			{
				ind[ 0 ] = ( WORD )( j + k ) ;
				ind[ 1 ] = ( WORD )( ind[ 0 ] + 1 ) ;
				ind[ 2 ] = ( WORD )( ind[ 0 ] + CirVertNumH ) ;
				
				ind[ 3 ] = ind[ 2 ] ;
				ind[ 4 ] = ind[ 1 ] ;
				ind[ 5 ] = ( WORD )( ind[ 3 ] + 1 ) ;
			}
			ind[ 0 ] = ( WORD )( j + k ) ;
			ind[ 1 ] = ( WORD )k ;
			ind[ 2 ] = ( WORD )( ind[ 0 ] + CirVertNumH ) ;
			
			ind[ 3 ] = ind[ 2 ] ;
			ind[ 4 ] = ind[ 1 ] ;
			ind[ 5 ] = ( WORD )( k + CirVertNumH ) ;

			ind += 6 ;
		}

		for( j = 0 ; j < CirVertNumH - 1 ; j ++, ind += 3 )
		{
			ind[ 0 ] = ( WORD )( j + 1 + k ) ;
			ind[ 1 ] = ( WORD )botind ;
			ind[ 2 ] = ( WORD )( j + k ) ;
		}
		ind[ 0 ] = ( WORD )k ;
		ind[ 1 ] = ( WORD )botind ;
		ind[ 2 ] = ( WORD )( j + k ) ;

		ind += 3 ;
		NS_DrawPrimitiveIndexed3D( Vertex, vertnum, Index, indexnum, DX_PRIMTYPE_TRIANGLELIST, DX_NONE_GRAPH, TRUE ) ;
	}
	else
	{
		ind = Index ;
		for( i = 0 ; i < CirVertNumH ; i ++ )
		{
			ind[ 0 ] = ( WORD )topind ;
			ind[ 1 ] = ( WORD )i ;
			ind += 2 ;

			k = i ;
			for( j = 0 ; j < CirVertNumV * 2 - 1 ; j ++, k += CirVertNumH, ind += 2 )
			{
				ind[ 0 ] = ( WORD )k ;
				ind[ 1 ] = ( WORD )( k + CirVertNumH ) ;
			}
			
			ind[ 0 ] = ( WORD )k ;
			ind[ 1 ] = ( WORD )botind ;
			ind += 2 ;
		}

		k = 0 ;
		for( i = 0 ; i < CirVertNumV * 2 ; i ++, k += CirVertNumH )
		{
			for( j = 0 ; j < CirVertNumH - 1 ; j ++, ind += 2 )
			{
				ind[ 0 ] = ( WORD )( j + k ) ;
				ind[ 1 ] = ( WORD )( j + k + 1 ) ;
			}
			ind[ 0 ] = ( WORD )( j + k ) ;
			ind[ 1 ] = ( WORD )k ;
			ind += 2 ;
		}

		NS_DrawPrimitiveIndexed3D( Vertex, vertnum, Index, indexnum, DX_PRIMTYPE_LINELIST, DX_NONE_GRAPH, TRUE ) ;
	}

	// ̉
	DXFREE( Vertex ) ;

	if( GSYS.DrawSetting.Large3DPositionSupport )
	{
		Graphics_Draw_EndLarge3DPositionSupportDraw( &Large3DPosDrawInfo ) ;
	}

	// I
	return 0 ;
}

// Rc̉~`悷
extern int NS_DrawCone3D( VECTOR TopPos, VECTOR BottomPos, float r, int DivNum, unsigned int DifColor, unsigned int SpcColor, int FillFlag )
{
	return NS_DrawCone3DD( VConvFtoD( TopPos ), VConvFtoD( BottomPos ), r, DivNum, DifColor, SpcColor, FillFlag ) ;
}

// Rc̉~`悷
extern int NS_DrawCone3DD( VECTOR_D TopPos, VECTOR_D BottomPos, double r, int DivNum, unsigned int DifColor, unsigned int SpcColor, int FillFlag )
{
	VERTEX3D *Vertex, *vert1, *vert2, *vert3 ;
	MATRIX   Axis ;
	WORD *Index, *ind ;
	VECTOR_D SubV, xv, yv, zv ;
	VECTOR bottomvec, norm, TopPosF ;
	double Length ;
	float *SinCosTable, *t, rf ;
	int CirVertNum, vertnum, indexnum ;
	int dr, dg, db, a, sr, sg, sb, i, j, k, topind, bottomind, num ;
	LARGE3DPOSITIONSUPPORT_DRAWINFO Large3DPosDrawInfo ;

	if( GSYS.DrawSetting.Large3DPositionSupport )
	{
		Graphics_Draw_BeginLarge3DPositionSupportDraw( &Large3DPosDrawInfo, TopPos ) ; 

		BottomPos = VSubD( BottomPos, TopPos ) ;
		TopPos    = VGetD( 0.0, 0.0, 0.0 ) ;
	}

	TopPosF = VConvDtoF( TopPos ) ;
	rf      = ( float )r ;

	NS_GetColor2( DifColor, &dr, &dg, &db ) ;
	NS_GetColor2( SpcColor, &sr, &sg, &sb ) ;
	a = GSYS.DrawSetting.BlendMode == DX_BLENDMODE_NOBLEND ? 255 : GSYS.DrawSetting.BlendParam ;

	SubV   = VSubD( TopPos, BottomPos ) ;
	Length = VSizeD( SubV ) ;
	zv     = VScaleD( SubV, 1.0 / Length ) ;
	xv     = VGetD( 1.0, 0.0, 0.0 ) ;
	VectorOuterProductD( &yv, &xv, &zv ) ;
	if( VSquareSizeD( yv ) < 0.000000001 )
	{
		xv = VGetD( 0.0, 0.0, 1.0 ) ;
		VectorOuterProductD( &yv, &xv, &zv ) ;
	}
	xv     = VNormD( VCrossD( yv, zv ) ) ;
	yv     = VNormD( yv ) ;
	Axis   = MGetAxis1( VConvDtoF( xv ), VConvDtoF( yv ), VConvDtoF( zv ), VConvDtoF( BottomPos ) ) ;

	norm = VConvDtoF( VNormD( VCrossD( VGetD( 0.0, 0.0, 1.0 ), VSubD( VGetD( r, 0.0, 0.0 ), VGetD( 0.0, Length, 0.0 ) ) ) ) ) ;

	CirVertNum = DivNum + 4 ;
	vertnum    = CirVertNum * 3 ;
	topind     = CirVertNum ;
	bottomind  = CirVertNum * 2 ;
	indexnum   = FillFlag ? CirVertNum * 3 + ( CirVertNum - 2 ) * 3 : CirVertNum * 2 + CirVertNum * 2 ;
	Vertex     = ( VERTEX3D * )DXALLOC( sizeof( WORD ) * indexnum + sizeof( VERTEX3D ) * vertnum + sizeof( float ) * CirVertNum * 2 ) ;
	if( Vertex == NULL )
	{
		if( GSYS.DrawSetting.Large3DPositionSupport )
		{
			Graphics_Draw_EndLarge3DPositionSupportDraw( &Large3DPosDrawInfo ) ;
		}
		return 0 ;
	}
	SinCosTable = ( float * )( Vertex + vertnum ) ;
	Index       = ( WORD * )( SinCosTable + CirVertNum * 2 ) ;

	// _f[^̍쐬
	t = SinCosTable ;
	for( i = 0 ; i < CirVertNum ; i ++, t += 2 )
	{
		_SINCOS_PLATFORM( 2 * DX_PI_F / CirVertNum * i, t, t + 1 ) ;
	}
	vert1 = Vertex ;
	vert2 = Vertex + CirVertNum ;
	vert3 = Vertex + CirVertNum * 2 ;
	t = SinCosTable ;
	bottomvec = VTransformSR( VGet( 0.0f, 0.0f, -1.0f ), Axis ) ;
	for( i = 0 ; i < CirVertNum ; i ++, vert1 ++, vert2 ++, vert3 ++, t += 2 )
	{
		vert1->pos = VTransform( VGet( t[ 0 ] * rf, t[ 1 ] * rf, 0.0f ), Axis ) ;
		vert2->pos = TopPosF ;
		vert3->pos = vert1->pos ;
		vert1->norm = VTransformSR( VGet( t[ 0 ] * norm.x, t[ 1 ] * norm.x, norm.y ), Axis ) ;
		vert2->norm = vert1->norm ;
		vert3->norm = bottomvec ;

		vert1->dif.b = ( BYTE )db ; vert1->dif.g = ( BYTE )dg ; vert1->dif.r = ( BYTE )dr ; vert1->dif.a = ( BYTE )a ;
		vert2->dif.b = ( BYTE )db ; vert2->dif.g = ( BYTE )dg ; vert2->dif.r = ( BYTE )dr ; vert2->dif.a = ( BYTE )a ;
		vert3->dif.b = ( BYTE )db ; vert3->dif.g = ( BYTE )dg ; vert3->dif.r = ( BYTE )dr ; vert3->dif.a = ( BYTE )a ;
		vert1->spc.b = ( BYTE )sb ; vert1->spc.g = ( BYTE )sg ; vert1->spc.r = ( BYTE )sr ; vert1->spc.a = 0 ;
		vert2->spc.b = ( BYTE )sb ; vert2->spc.g = ( BYTE )sg ; vert2->spc.r = ( BYTE )sr ; vert2->spc.a = 0 ;
		vert3->spc.b = ( BYTE )sb ; vert3->spc.g = ( BYTE )sg ; vert3->spc.r = ( BYTE )sr ; vert3->spc.a = 0 ;
		vert1->u = 0.0f ; vert1->v = 0.0f ;
		vert2->u = 0.0f ; vert2->v = 0.0f ;
		vert3->u = 0.0f ; vert3->v = 0.0f ;
		vert1->su = 0.0f ; vert1->sv = 0.0f ;
		vert2->su = 0.0f ; vert2->sv = 0.0f ;
		vert3->su = 0.0f ; vert3->sv = 0.0f ;
	}

	// hԂǂŏ𕪊
	if( FillFlag )
	{
		ind = Index ;
		for( i = 0 ; i < CirVertNum - 1 ; i ++, ind += 3 )
		{
			ind[ 0 ] = ( WORD )i ;
			ind[ 1 ] = ( WORD )( topind + i ) ;
			ind[ 2 ] = ( WORD )( i + 1 ) ;
		}
		ind[ 0 ] = ( WORD )i ;
		ind[ 1 ] = ( WORD )( topind + i ) ;
		ind[ 2 ] = 0 ;
		ind += 3 ;

		j = bottomind + CirVertNum - 1 ;
		i = bottomind ;
		ind[ 0 ] = ( WORD )i ;
		ind[ 1 ] = ( WORD )( i + 1 ) ;
		ind[ 2 ] = ( WORD )j ;
		ind += 3 ;

		num = CirVertNum - 2 ;
		for( k = 1 ; k < num ; )
		{
			ind[ 0 ] = ( WORD )j ;
			ind[ 1 ] = ( WORD )( i + 1 ) ;
			ind[ 2 ] = ( WORD )( i + 2 ) ;
			ind += 3 ;
			k ++ ;
			i ++ ;
			if( k >= num ) break ;

			ind[ 0 ] = ( WORD )j ;
			ind[ 1 ] = ( WORD )( i + 1 ) ;
			ind[ 2 ] = ( WORD )( j - 1 ) ;
			ind += 3 ;

			j -- ;
			k ++ ;
			if( k >= num ) break ;
		}
		NS_DrawPrimitiveIndexed3D( Vertex, vertnum, Index, indexnum, DX_PRIMTYPE_TRIANGLELIST, DX_NONE_GRAPH, TRUE ) ;
	}
	else
	{
		ind = Index ;
		for( i = 0 ; i < CirVertNum ; i ++, ind += 2 )
		{
			ind[ 0 ] = ( WORD )i ;
			ind[ 1 ] = ( WORD )( topind + i ) ;
		}
		for( i = 0 ; i < CirVertNum - 1 ; i ++, ind += 2 )
		{
			ind[ 0 ] = ( WORD )( bottomind + i ) ;
			ind[ 1 ] = ( WORD )( bottomind + i + 1 ) ;
		}
		ind[ 0 ] = ( WORD )( bottomind + i ) ;
		ind[ 1 ] = ( WORD )bottomind ;
		NS_DrawPrimitiveIndexed3D( Vertex, vertnum, Index, indexnum, DX_PRIMTYPE_LINELIST, DX_NONE_GRAPH, TRUE ) ;
	}

	// ̉
	DXFREE( Vertex ) ;

	if( GSYS.DrawSetting.Large3DPositionSupport )
	{
		Graphics_Draw_EndLarge3DPositionSupportDraw( &Large3DPosDrawInfo ) ;
	}

	// I
	return 0 ;
}


























// 摜`֐

// alot@Cǂ݂ŉʂɕ`悷
extern	int NS_LoadGraphScreen( int x, int y, const TCHAR *GraphName, int TransFlag )
{
#ifdef UNICODE
	return LoadGraphScreen_WCHAR_T(
		x, y, GraphName, TransFlag
	) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( GraphName, return -1 )

	Result = LoadGraphScreen_WCHAR_T(
		x, y, UseGraphNameBuffer, TransFlag
	) ;

	TCHAR_TO_WCHAR_T_STRING_END( GraphName )

	return Result ;
#endif
}

// 摜t@Cǂ݂ŉʂɕ`悷
extern int NS_LoadGraphScreenWithStrLen( int x, int y, const TCHAR *GraphName, size_t GraphNameLength, int TransFlag )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( GraphName, GraphNameLength, return -1 )
	Result = LoadGraphScreen_WCHAR_T( x, y, UseGraphNameBuffer, TransFlag ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( GraphName )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( GraphName, GraphNameLength, return -1 )
	Result = LoadGraphScreen_WCHAR_T( x, y, UseGraphNameBuffer, TransFlag ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( GraphName )
#endif
	return Result ;
}

// alot@Cǂ݂ŉʂɕ`悷
extern	int LoadGraphScreen_WCHAR_T( int x, int y, const wchar_t *GraphName, int TransFlag )
{
	int GrHandle ;
	LOADGRAPH_GPARAM GParam ;
	
//	if( GSYS.NotDrawFlag ) return 0 ;

	// OtBbNǂ݂
	Graphics_Image_InitLoadGraphGParam( &GParam ) ;
	GrHandle = Graphics_Image_LoadBmpToGraph_UseGParam( &GParam, FALSE, -1, GraphName, TRUE, FALSE, DX_MOVIESURFACE_NORMAL, FALSE ) ;
	if( GrHandle < 0 )
	{
		return -1 ;
	}

	// OtBbN̕`
	NS_DrawGraph( x, y, GrHandle, TransFlag ) ;

	// OtBbN̍폜
	NS_DeleteGraph( GrHandle, FALSE ) ;

	// I
	return 0 ;
}

// OtBbN̕`
#define SETDRAWRECTCODE\
	SETRECT( DrawRect, x, y, x + Image->WidthI, y + Image->HeightI )\
	DRAWRECT_DRAWAREA_CLIP
extern	int NS_DrawGraph( int x, int y, int GrHandle, int TransFlag )
{
	IMAGEDATA *Image ;
	IMAGEDATA *BlendImage ;
	int Ret ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE ) return -1 ;

	// `ݒ肪Ăꍇ͉I
	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;
	BlendImage = NULL ;
	if( GSYS.DrawSetting.BlendGraph > 0 )
	{
		GRAPHCHK( GSYS.DrawSetting.BlendGraph, BlendImage ) ;

		// uheNX`gpꍇA`摜G[
		if( Graphics_Image_CheckBlendGraphSize( Image ) ) return -1 ;
	}

#ifndef DX_NON_MOVIE
	if( Image->Orig->MovieHandle != -1 )
		UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
#endif

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	DRAW_DEF( 
		Graphics_Hardware_DrawGraph_PF( x, y, ( float )x, ( float )y, Image, BlendImage, TransFlag, TRUE ),
		Graphics_Software_DrawGraph(    x, y,                         Image,             TransFlag       ),
		SETDRAWRECTCODE,
		Ret,
		Image->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

// OtBbN̕`
extern	int NS_DrawGraphF( float xf, float yf, int GrHandle, int TransFlag )
{
	IMAGEDATA *Image ;
	IMAGEDATA *BlendImage ;
	int Ret = -1 ;
	int x, y ;

	x = _FTOL( xf ) ;
	y = _FTOL( yf ) ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;
	BlendImage = NULL ;
	if( GSYS.DrawSetting.BlendGraph > 0 )
	{
		GRAPHCHK( GSYS.DrawSetting.BlendGraph, BlendImage ) ;

		// uheNX`gpꍇA`摜G[
		if( Graphics_Image_CheckBlendGraphSize( Image ) ) return -1 ;
	}

#ifndef DX_NON_MOVIE
	if( Image->Orig->MovieHandle != -1 )
		UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
#endif

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawGraph_PF( x, y, xf, yf, Image, BlendImage, TransFlag, FALSE ),
		Graphics_Software_DrawGraph(    x, y,         Image,             TransFlag        ),
		SETDRAWRECTCODE,
		Ret,
		Image->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}
#undef SETDRAWRECTCODE

// OtBbN̊gk`
#define SETDRAWRECTCODE\
	SETRECT( DrawRect, x1, y1, x2, y2 ) ;\
	if( x1 > x2 ){ DrawRect.left = x2 ; DrawRect.right = x1; }\
	if( y1 > y2 ){ DrawRect.top = y2 ; DrawRect.bottom = y1; }\
	DRAWRECT_DRAWAREA_CLIP

extern	int NS_DrawExtendGraph( int x1, int y1, int x2, int y2, int GrHandle, int TransFlag )
{
	IMAGEDATA *Image ;
	IMAGEDATA *BlendImage ;
	int Ret = -1 ;
	
	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;
	BlendImage = NULL ;
	if( GSYS.DrawSetting.BlendGraph > 0 )
	{
		GRAPHCHK( GSYS.DrawSetting.BlendGraph, BlendImage ) ;

		// uheNX`gpꍇA`摜G[
		if( Graphics_Image_CheckBlendGraphSize( Image ) ) return -1 ;
	}

#ifndef DX_NON_MOVIE
	if( Image->Orig->MovieHandle != -1 )
		UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
#endif

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// eNX`̏ꍇƂȊOŏ𕪊
	DRAW_DEF(
		Graphics_Hardware_DrawExtendGraph_PF( x1, y1, x2, y2, (float)x1, (float)y1, (float)x2, (float)y2, Image, BlendImage, TransFlag, TRUE ),
		Graphics_Software_DrawExtendGraph(    x1, y1, x2, y2,                                             Image,             TransFlag       ),
		SETDRAWRECTCODE,
		Ret,
		Image->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

// OtBbN̊gk`
extern	int NS_DrawExtendGraphF( float x1f, float y1f, float x2f, float y2f, int GrHandle, int TransFlag )
{
	IMAGEDATA *Image ;
	IMAGEDATA *BlendImage ;
	int Ret = -1 ;
	int x1, y1, x2, y2 ;
	
	x1 = _FTOL( x1f ) ;
	y1 = _FTOL( y1f ) ;
	x2 = _FTOL( x2f ) ;
	y2 = _FTOL( y2f ) ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;
	BlendImage = NULL ;
	if( GSYS.DrawSetting.BlendGraph > 0 )
	{
		GRAPHCHK( GSYS.DrawSetting.BlendGraph, BlendImage ) ;

		// uheNX`gpꍇA`摜G[
		if( Graphics_Image_CheckBlendGraphSize( Image ) ) return -1 ;
	}

#ifndef DX_NON_MOVIE
	if( Image->Orig->MovieHandle != -1 )
		UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
#endif

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawExtendGraph_PF( x1, y1, x2, y2, x1f, y1f, x2f, y2f, Image, BlendImage, TransFlag, FALSE ),
		Graphics_Software_DrawExtendGraph(    x1, y1, x2, y2,                     Image,             TransFlag        ),
		SETDRAWRECTCODE,
		Ret,
		Image->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE

// OtBbN̉]`
#define SETDRAWRECTCODE\
	int Width, Height ;\
	int i ;\
	float SinF, CosF ;\
	double xb, Lx, Ly ;\
	double px[4], py[4] ;\
	double Sin, Cos ;\
	double MaxMin[4] ; /* 0:MinX 1:MinY 2:MaxX 3:MaxY */\
\
	Lx = x ; Ly = y ;\
\
	_SINCOS_PLATFORM( (float)Angle, &SinF, &CosF ) ;\
	Sin = (double)SinF ;\
	Cos = (double)CosF ;\
\
	Width = Image->WidthI / 2 ;\
	Height = Image->HeightI / 2 ;\
\
	px[0] = -Width ;				py[0] = -Height ;\
	px[1] = Image->WidthI - Width ;	py[1] = -Height ;\
	px[2] = -Width ;				py[2] = Image->HeightI - Height ;\
	px[3] = Image->WidthI - Width ;	py[3] = Image->HeightI - Height ;\
\
	xb = px[0] ;\
	px[0] = ( xb * Cos - py[0] * Sin ) * ExRate + Lx ;\
	py[0] = ( xb * Sin + py[0] * Cos ) * ExRate + Ly ;\
	MaxMin[0] = px[0] ;\
	MaxMin[1] = py[0] ;\
	MaxMin[2] = px[0] ;\
	MaxMin[3] = py[0] ;\
	for( i = 1 ; i < 4 ; i ++ )\
	{\
		xb = px[i] ;\
		px[i] = ( xb * Cos - py[i] * Sin ) * ExRate + Lx ;\
		py[i] = ( xb * Sin + py[i] * Cos ) * ExRate + Ly ;\
\
		if( MaxMin[0] > px[i] ) MaxMin[0] = px[i];\
		if( MaxMin[2] < px[i] ) MaxMin[2] = px[i];\
		if( MaxMin[1] > py[i] ) MaxMin[1] = py[i];\
		if( MaxMin[3] < py[i] ) MaxMin[3] = py[i];\
	}\
\
	MaxMin[0] -= 5.0F ; MaxMin[1] -= 5.0F ;\
	MaxMin[2] += 5.0F ; MaxMin[3] += 5.0F ; \
\
	_DTOL4( MaxMin, (int *)&DrawRect ) ;\
	DRAWRECT_DRAWAREA_CLIP

extern	int NS_DrawRotaGraph( int x, int y, double ExRate, double Angle, int GrHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	IMAGEDATA *Image ;
	IMAGEDATA *BlendImage ;
	int Ret = -1 ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;
	BlendImage = NULL ;
	if( GSYS.DrawSetting.BlendGraph > 0 )
	{
		GRAPHCHK( GSYS.DrawSetting.BlendGraph, BlendImage ) ;

		// uheNX`gpꍇA`摜G[
		if( Graphics_Image_CheckBlendGraphSize( Image ) ) return -1 ;
	}

#ifndef DX_NON_MOVIE
	if( Image->Orig->MovieHandle != -1 )
		UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
#endif

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawRotaGraph_PF( x, y, (float)x, (float)y, ExRate, Angle, Image, BlendImage, TransFlag, ReverseXFlag, ReverseYFlag, TRUE ),
		Graphics_Software_DrawRotaGraph(          (float)x, (float)y, ExRate, Angle, Image,             TransFlag, ReverseXFlag, ReverseYFlag       ),
		SETDRAWRECTCODE,
		Ret,
		Image->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

// OtBbN̉]`
extern	int NS_DrawRotaGraphF( float xf, float yf, double ExRate, double Angle, int GrHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	IMAGEDATA *Image ;
	IMAGEDATA *BlendImage ;
	int Ret = -1 ;
	int x, y ;
	
	x = _FTOL( xf ) ;
	y = _FTOL( yf ) ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;
	BlendImage = NULL ;
	if( GSYS.DrawSetting.BlendGraph > 0 )
	{
		GRAPHCHK( GSYS.DrawSetting.BlendGraph, BlendImage ) ;

		// uheNX`gpꍇA`摜G[
		if( Graphics_Image_CheckBlendGraphSize( Image ) ) return -1 ;
	}

#ifndef DX_NON_MOVIE
	if( Image->Orig->MovieHandle != -1 )
		UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
#endif

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawRotaGraph_PF( x, y, xf, yf, ExRate, Angle, Image, BlendImage, TransFlag, ReverseXFlag, ReverseYFlag, FALSE ),
		Graphics_Software_DrawRotaGraph(          xf, yf, ExRate, Angle, Image,             TransFlag, ReverseXFlag, ReverseYFlag        ),
		SETDRAWRECTCODE,
		Ret,
		Image->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE

// OtBbN̉]`
#define SETDRAWRECTCODE\
	int Width, Height ;\
	int i ;\
	float xb, Lx, Ly ;\
	float px[4], py[4] ;\
	float Sin, Cos ;\
	float MaxMin[4] ; /* 0:MinX 1:MinY 2:MaxX 3:MaxY */\
\
	Lx = ( float )x ; Ly = ( float )y ;\
\
	_TABLE_SINCOS( Angle, &Sin, &Cos ) ;\
\
	Width = Image->WidthI / 2 ;\
	Height = Image->HeightI / 2 ;\
\
	px[0] = ( float )-Width ;						py[0] = ( float )-Height ;\
	px[1] = ( float )( Image->WidthI - Width ) ;	py[1] = ( float )-Height ;\
	px[2] = ( float )-Width ;						py[2] = ( float )( Image->HeightI - Height ) ;\
	px[3] = ( float )( Image->WidthI - Width ) ;	py[3] = ( float )( Image->HeightI - Height ) ;\
\
	xb = px[0] ;\
	px[0] = ( xb * Cos - py[0] * Sin ) * ExRate + Lx ;\
	py[0] = ( xb * Sin + py[0] * Cos ) * ExRate + Ly ;\
	MaxMin[0] = px[0] ;\
	MaxMin[1] = py[0] ;\
	MaxMin[2] = px[0] ;\
	MaxMin[3] = py[0] ;\
	for( i = 1 ; i < 4 ; i ++ )\
	{\
		xb = px[i] ;\
		px[i] = ( xb * Cos - py[i] * Sin ) * ExRate + Lx ;\
		py[i] = ( xb * Sin + py[i] * Cos ) * ExRate + Ly ;\
\
		if( MaxMin[0] > px[i] ) MaxMin[0] = px[i];\
		if( MaxMin[2] < px[i] ) MaxMin[2] = px[i];\
		if( MaxMin[1] > py[i] ) MaxMin[1] = py[i];\
		if( MaxMin[3] < py[i] ) MaxMin[3] = py[i];\
	}\
\
	MaxMin[0] -= 5.0F ; MaxMin[1] -= 5.0F ;\
	MaxMin[2] += 5.0F ; MaxMin[3] += 5.0F ; \
\
	_FTOL4( MaxMin, (int *)&DrawRect ) ;\
	DRAWRECT_DRAWAREA_CLIP

extern	int NS_DrawRotaGraphFast( int x, int y, float ExRate, float Angle, int GrHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	IMAGEDATA *Image ;
	IMAGEDATA *BlendImage ;
	int Ret = -1 ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;
	BlendImage = NULL ;
	if( GSYS.DrawSetting.BlendGraph > 0 )
	{
		GRAPHCHK( GSYS.DrawSetting.BlendGraph, BlendImage ) ;

		// uheNX`gpꍇA`摜G[
		if( Graphics_Image_CheckBlendGraphSize( Image ) ) return -1 ;
	}

#ifndef DX_NON_MOVIE
	if( Image->Orig->MovieHandle != -1 )
		UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
#endif

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawRotaGraphFast_PF( x, y, (float)x, (float)y, ExRate, Angle, Image, BlendImage, TransFlag, ReverseXFlag, ReverseYFlag, TRUE ),
		Graphics_Software_DrawRotaGraphFast(          (float)x, (float)y, ExRate, Angle, Image,             TransFlag, ReverseXFlag, ReverseYFlag       ),
		SETDRAWRECTCODE,
		Ret,
		Image->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

// OtBbN̉]`A
extern	int NS_DrawRotaGraphFastF( float xf, float yf, float ExRate, float Angle, int GrHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	IMAGEDATA *Image ;
	IMAGEDATA *BlendImage ;
	int Ret = -1 ;
	int x, y ;
	
	x = _FTOL( xf ) ;
	y = _FTOL( yf ) ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;
	BlendImage = NULL ;
	if( GSYS.DrawSetting.BlendGraph > 0 )
	{
		GRAPHCHK( GSYS.DrawSetting.BlendGraph, BlendImage ) ;

		// uheNX`gpꍇA`摜G[
		if( Graphics_Image_CheckBlendGraphSize( Image ) ) return -1 ;
	}

#ifndef DX_NON_MOVIE
	if( Image->Orig->MovieHandle != -1 )
		UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
#endif

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawRotaGraphFast_PF( x, y, xf, yf, ExRate, Angle, Image, BlendImage, TransFlag, ReverseXFlag, ReverseYFlag, FALSE ),
		Graphics_Software_DrawRotaGraphFast(          xf, yf, ExRate, Angle, Image,             TransFlag, ReverseXFlag, ReverseYFlag        ),
		SETDRAWRECTCODE,
		Ret,
		Image->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE

// OtBbN̉]`Q
extern	int NS_DrawRotaGraph2( int x, int y, int cx, int cy, double ExtRate, double Angle, int GrHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	int w, h ;

	NS_GetGraphSize( GrHandle, &w,&h ) ;

	if( Angle == 0.0 && ExtRate == 1.0 )
	{
		return NS_DrawReverseGraph( x - cx, y - cy, GrHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;
	}
	else
	{
		return NS_DrawRotaGraph2F( ( float )x, ( float )y, ( float )cx, ( float )cy, ExtRate, Angle, GrHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;
	}
}

// OtBbN̉]`QA
extern	int NS_DrawRotaGraphFast2( int x, int y, int cx, int cy, float ExtRate, float Angle, int GrHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	int w, h ;

	NS_GetGraphSize( GrHandle, &w,&h ) ;

	if( Angle == 0.0f && ExtRate == 1.0f )
	{
		return NS_DrawReverseGraph( x - cx, y - cy, GrHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;
	}
	else
	{
		return NS_DrawRotaGraphFast2F( ( float )x, ( float )y, ( float )cx, ( float )cy, ExtRate, Angle, GrHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;
	}
}


// 摜̎Rό``
extern	int NS_DrawModiGraph( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int GrHandle, int TransFlag )
{
	return Graphics_Draw_ModiGraphBase( x1, y1, x2, y2, x3, y3, x4, y4, GrHandle, TransFlag, false ) ;
}

// 摜̍E]`
extern	int NS_DrawTurnGraph( int x, int y, int GrHandle, int TransFlag )
{
	IMAGEDATA *Image ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;

	return NS_DrawExtendGraph( Image->WidthI + x, y, x, y + Image->HeightI, GrHandle, TransFlag ) ;
}

// 摜̔]`
extern int NS_DrawReverseGraph( int x, int y, int GrHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	IMAGEDATA *Image ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;

	if( ReverseXFlag && ReverseYFlag )
	{
		return NS_DrawExtendGraph( Image->WidthI + x, y + Image->HeightI, x, y, GrHandle, TransFlag ) ;
	}
	else
	if( ReverseXFlag )
	{
		return NS_DrawExtendGraph( Image->WidthI + x, y, x, y + Image->HeightI, GrHandle, TransFlag ) ;
	}
	else
	if( ReverseYFlag )
	{
		return NS_DrawExtendGraph( x, y + Image->HeightI, x + Image->WidthI, y, GrHandle, TransFlag ) ;
	}
	else
	{
		return NS_DrawGraph( x, y, GrHandle, TransFlag ) ;
	}
}




// OtBbN̉]`Q
extern	int NS_DrawRotaGraph2F( float xf, float yf, float cxf, float cyf, double ExtRate, double Angle, int GrHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	int w, h ;

	NS_GetGraphSize( GrHandle, &w,&h ) ;

	if( Angle == 0.0 )
	{
		if( ExtRate == 1.0 )
		{
			return NS_DrawReverseGraphF( xf - cxf, yf - cyf, GrHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;
		}
		else
		{
			float numF[ 4 ] ;

			numF[ 0 ] = xf - ( cxf * ( float )ExtRate ) ;
			numF[ 1 ] = yf - ( cyf * ( float )ExtRate ) ;
			numF[ 2 ] = numF[ 0 ] + ( w * ( float )ExtRate ) ;
			numF[ 3 ] = numF[ 1 ] + ( h * ( float )ExtRate ) ;
			if( ReverseXFlag )
			{
				float d ;

				d = numF[ 0 ] ; numF[ 0 ] = numF[ 2 ] ; numF[ 2 ] = d ;
			}
			if( ReverseYFlag )
			{
				float d ;

				d = numF[ 1 ] ; numF[ 1 ] = numF[ 3 ] ; numF[ 3 ] = d ;
			}
			return NS_DrawExtendGraphF( numF[0], numF[1],
										numF[2], numF[3],
										 GrHandle, TransFlag ) ;
		}
	}
	else
	{
		float dcx, dcy ;
		float Sin, Cos ;
		float bcx, bcy ;

		bcx = ( -cxf + ( float )w * 0.5F ) * ( float )ExtRate ;
		bcy = ( -cyf + ( float )h * 0.5F ) * ( float )ExtRate ;

		_SINCOS_PLATFORM( ( float )Angle, &Sin, &Cos ) ;
		dcx = bcx * Cos - bcy * Sin ;
		dcy = bcx * Sin + bcy * Cos ;

		return NS_DrawRotaGraphF( xf + dcx, yf + dcy, ExtRate, Angle, GrHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ; 
	}
}


// OtBbN̉]`R
static int DrawRotaGraph3F_Base( float xf, float yf, float cxf, float cyf, double ExtRateX, double ExtRateY, double Angle, int GrHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag, int IntFlag )
{
	int w, h ;

	NS_GetGraphSize( GrHandle, &w,&h ) ;

	if( Angle == 0.0 )
	{
		if( ExtRateX == 1.0 && ExtRateY == 1.0 )
		{
			return NS_DrawReverseGraphF( xf - cxf, yf - cyf, GrHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;
		}
		else
		{
			float numF[ 4 ] ;

			numF[ 0 ] = xf - ( cxf * ( float )ExtRateX ) ;
			numF[ 1 ] = yf - ( cyf * ( float )ExtRateY ) ;
			numF[ 2 ] = numF[ 0 ] + ( w * ( float )ExtRateX ) ;
			numF[ 3 ] = numF[ 1 ] + ( h * ( float )ExtRateY ) ;
			if( ReverseXFlag )
			{
				float d ;

				d = numF[ 0 ] ; numF[ 0 ] = numF[ 2 ] ; numF[ 2 ] = d ;
			}
			if( ReverseYFlag )
			{
				float d ;

				d = numF[ 1 ] ; numF[ 1 ] = numF[ 3 ] ; numF[ 3 ] = d ;
			}
			return NS_DrawExtendGraphF( numF[0], numF[1],
										numF[2], numF[3],
										 GrHandle, TransFlag ) ;
		}
	}
	else
	{
		if( ExtRateX == 1.0 && ExtRateY == 1.0 )
		{
			float dcx, dcy ;
			float Sin, Cos ;
			float bcx, bcy ;

			bcx = ( -cxf + ( float )w * 0.5F ) ;
			bcy = ( -cyf + ( float )h * 0.5F ) ;

			_SINCOS_PLATFORM( ( float )Angle, &Sin, &Cos ) ;
			dcx = bcx * Cos - bcy * Sin ;
			dcy = bcx * Sin + bcy * Cos ;

			return NS_DrawRotaGraphF( xf + dcx, yf + dcy, 1.0, Angle, GrHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ; 
		}
		else
		{
			float xx[ 4 ], yy[ 4 ] ;
			float xxt[ 4 ], yyt[ 4 ] ;
			int i ;
			float SinF, CosF ;

			xxt[0] = (   - cxf )	* ( float )ExtRateX ;	yyt[0] = (   - cyf )	* ( float )ExtRateY ;
			xxt[1] = ( w - cxf )	* ( float )ExtRateX ;	yyt[1] = yyt[0] ;
			xxt[2] = xxt[0] ;								yyt[2] = ( h - cyf )	* ( float )ExtRateY ;
			xxt[3] = xxt[1] ;								yyt[3] = yyt[2] ;

			_SINCOS_PLATFORM( ( float )Angle, &SinF, &CosF ) ;
			for( i = 0 ; i < 4 ; i ++ )
			{
				xx[ i ] = xxt[ i ] * CosF - yyt[ i ] * SinF + xf ;
				yy[ i ] = xxt[ i ] * SinF + yyt[ i ] * CosF + yf ;
			}

			if( ReverseXFlag && ReverseYFlag )
			{
				float d ;

				d = xx[ 0 ] ; xx[ 0 ] = xx[ 3 ] ; xx[ 3 ] = d ;
				d = xx[ 1 ] ; xx[ 1 ] = xx[ 2 ] ; xx[ 2 ] = d ;
				d = yy[ 0 ] ; yy[ 0 ] = yy[ 3 ] ; yy[ 3 ] = d ;
				d = yy[ 1 ] ; yy[ 1 ] = yy[ 2 ] ; yy[ 2 ] = d ;
			}
			else
			if( ReverseXFlag )
			{
				float d ;

				d = xx[ 0 ] ; xx[ 0 ] = xx[ 1 ] ; xx[ 1 ] = d ;
				d = xx[ 2 ] ; xx[ 2 ] = xx[ 3 ] ; xx[ 3 ] = d ;
				d = yy[ 0 ] ; yy[ 0 ] = yy[ 1 ] ; yy[ 1 ] = d ;
				d = yy[ 2 ] ; yy[ 2 ] = yy[ 3 ] ; yy[ 3 ] = d ;
			}
			else
			if( ReverseYFlag )
			{
				float d ;

				d = xx[ 0 ] ; xx[ 0 ] = xx[ 2 ] ; xx[ 2 ] = d ;
				d = xx[ 1 ] ; xx[ 1 ] = xx[ 3 ] ; xx[ 3 ] = d ;
				d = yy[ 0 ] ; yy[ 0 ] = yy[ 2 ] ; yy[ 2 ] = d ;
				d = yy[ 1 ] ; yy[ 1 ] = yy[ 3 ] ; yy[ 3 ] = d ;
			}

			if( IntFlag && GSYS.HardInfo.DrawFloatCoordType == DX_DRAWFLOATCOORDTYPE_DIRECT3D9 )
			{
				xx[0] -= 0.5f ;
				yy[0] -= 0.5f ;
				xx[1] -= 0.5f ;
				yy[1] -= 0.5f ;
				xx[3] -= 0.5f ;
				yy[3] -= 0.5f ;
				xx[2] -= 0.5f ;
				yy[2] -= 0.5f ;
			}

			return Graphics_Draw_ModiGraphFBase( xx[0], yy[0], xx[1], yy[1], xx[3], yy[3], xx[2], yy[2], GrHandle, TransFlag, TRUE ) ;
		}
	}
}

// OtBbN̉]`R
extern	int NS_DrawRotaGraph3( int x, int y, int cx, int cy, double ExtRateX, double ExtRateY, double Angle, int GrHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	if( Angle == 0.0 && ExtRateX == 1.0 && ExtRateY == 1.0 )
	{
		int w, h ;

		NS_GetGraphSize( GrHandle, &w,&h ) ;

		return NS_DrawReverseGraph( x - cx, y - cy, GrHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;
	}
	else
	{
		return DrawRotaGraph3F_Base( ( float )x, ( float )y, ( float )cx, ( float )cy, ExtRateX, ExtRateY, Angle, GrHandle, TransFlag, ReverseXFlag, ReverseYFlag, TRUE ) ;
	}
}

extern	int NS_DrawRotaGraph3F( float xf, float yf, float cxf, float cyf, double ExtRateX, double ExtRateY, double Angle, int GrHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	return DrawRotaGraph3F_Base( xf, yf, cxf, cyf, ExtRateX, ExtRateY, Angle, GrHandle, TransFlag, ReverseXFlag, ReverseYFlag, FALSE ) ;
}

// OtBbN̉]`Q()
extern	int NS_DrawRotaGraphFast2F( float xf, float yf, float cxf, float cyf, float ExtRate, float Angle, int GrHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	int w, h ;

	NS_GetGraphSize( GrHandle, &w,&h ) ;

	if( Angle == 0.0f )
	{
		if( ExtRate == 1.0f )
		{
			return NS_DrawReverseGraphF( xf - cxf, yf - cyf, GrHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;
		}
		else
		{
			float numF[ 4 ] ;

			numF[ 0 ] = xf - ( cxf * ExtRate ) ;
			numF[ 1 ] = yf - ( cyf * ExtRate ) ;
			numF[ 2 ] = numF[ 0 ] + ( w * ExtRate ) ;
			numF[ 3 ] = numF[ 1 ] + ( h * ExtRate ) ;
			if( ReverseXFlag )
			{
				float d ;

				d = numF[ 0 ] ; numF[ 0 ] = numF[ 2 ] ; numF[ 2 ] = d ;
			}
			if( ReverseYFlag )
			{
				float d ;

				d = numF[ 1 ] ; numF[ 1 ] = numF[ 3 ] ; numF[ 3 ] = d ;
			}
			return NS_DrawExtendGraphF( numF[0], numF[1],
										numF[2], numF[3],
										 GrHandle, TransFlag ) ;
		}
	}
	else
	{
		float dcx, dcy ;
		float Sin, Cos ;
		float bcx, bcy ;

		bcx = ( -cxf + ( float )w * 0.5f ) * ExtRate ;
		bcy = ( -cyf + ( float )h * 0.5f ) * ExtRate ;

		_TABLE_SINCOS( Angle, &Sin, &Cos ) ;
		dcx = bcx * Cos - bcy * Sin ;
		dcy = bcx * Sin + bcy * Cos ;

		return NS_DrawRotaGraphFastF( xf + dcx, yf + dcy, ExtRate, Angle, GrHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ; 
	}
}


// OtBbN̉]`R()
static int DrawRotaGraphFast3F_Base( float xf, float yf, float cxf, float cyf, float ExtRateX, float ExtRateY, float Angle, int GrHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag, int IntFlag )
{
	int w, h ;

	NS_GetGraphSize( GrHandle, &w,&h ) ;

	if( Angle == 0.0f )
	{
		if( ExtRateX == 1.0f && ExtRateY == 1.0f )
		{
			return NS_DrawReverseGraphF( xf - cxf, yf - cyf, GrHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;
		}
		else
		{
			float numF[ 4 ] ;

			numF[ 0 ] = xf - ( cxf * ExtRateX ) ;
			numF[ 1 ] = yf - ( cyf * ExtRateY ) ;
			numF[ 2 ] = numF[ 0 ] + ( w * ExtRateX ) ;
			numF[ 3 ] = numF[ 1 ] + ( h * ExtRateY ) ;
			if( ReverseXFlag )
			{
				float d ;

				d = numF[ 0 ] ; numF[ 0 ] = numF[ 2 ] ; numF[ 2 ] = d ;
			}
			if( ReverseYFlag )
			{
				float d ;

				d = numF[ 1 ] ; numF[ 1 ] = numF[ 3 ] ; numF[ 3 ] = d ;
			}
			return NS_DrawExtendGraphF( numF[0], numF[1],
										numF[2], numF[3],
										 GrHandle, TransFlag ) ;
		}
	}
	else
	{
		if( ExtRateX == 1.0f && ExtRateY == 1.0f )
		{
			float dcx, dcy ;
			float Sin, Cos ;
			float bcx, bcy ;

			bcx = ( -cxf + ( float )w * 0.5f ) ;
			bcy = ( -cyf + ( float )h * 0.5f ) ;

			_TABLE_SINCOS( Angle, &Sin, &Cos ) ;
			dcx = bcx * Cos - bcy * Sin ;
			dcy = bcx * Sin + bcy * Cos ;

			return NS_DrawRotaGraphFastF( xf + dcx, yf + dcy, 1.0f, Angle, GrHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ; 
		}
		else
		{
			float xxt[ 4 ], yyt[ 4 ] ;
			float xx[ 4 ], yy[ 4 ] ;
			int i ;
			float SinF, CosF ;

			xxt[0] = (   - cxf )	* ExtRateX ;	yyt[0] = (   - cyf )	* ExtRateY ;
			xxt[1] = ( w - cxf )	* ExtRateX ;	yyt[1] = yyt[0] ;
			xxt[2] = xxt[0] ;						yyt[2] = ( h - cyf )	* ExtRateY ;
			xxt[3] = xxt[1] ;						yyt[3] = yyt[2] ;

			_TABLE_SINCOS( Angle, &SinF, &CosF ) ;
			for( i = 0 ; i < 4 ; i ++ )
			{
				xx[ i ] = xxt[ i ] * CosF - yyt[ i ] * SinF + xf ;
				yy[ i ] = xxt[ i ] * SinF + yyt[ i ] * CosF + yf ;
			}

			if( ReverseXFlag && ReverseYFlag )
			{
				float d ;

				d = xx[ 0 ] ; xx[ 0 ] = xx[ 3 ] ; xx[ 3 ] = d ;
				d = xx[ 1 ] ; xx[ 1 ] = xx[ 2 ] ; xx[ 2 ] = d ;
				d = yy[ 0 ] ; yy[ 0 ] = yy[ 3 ] ; yy[ 3 ] = d ;
				d = yy[ 1 ] ; yy[ 1 ] = yy[ 2 ] ; yy[ 2 ] = d ;
			}
			else
			if( ReverseXFlag )
			{
				float d ;

				d = xx[ 0 ] ; xx[ 0 ] = xx[ 1 ] ; xx[ 1 ] = d ;
				d = xx[ 2 ] ; xx[ 2 ] = xx[ 3 ] ; xx[ 3 ] = d ;
				d = yy[ 0 ] ; yy[ 0 ] = yy[ 1 ] ; yy[ 1 ] = d ;
				d = yy[ 2 ] ; yy[ 2 ] = yy[ 3 ] ; yy[ 3 ] = d ;
			}
			else
			if( ReverseYFlag )
			{
				float d ;

				d = xx[ 0 ] ; xx[ 0 ] = xx[ 2 ] ; xx[ 2 ] = d ;
				d = xx[ 1 ] ; xx[ 1 ] = xx[ 3 ] ; xx[ 3 ] = d ;
				d = yy[ 0 ] ; yy[ 0 ] = yy[ 2 ] ; yy[ 2 ] = d ;
				d = yy[ 1 ] ; yy[ 1 ] = yy[ 3 ] ; yy[ 3 ] = d ;
			}

			if( IntFlag && GSYS.HardInfo.DrawFloatCoordType == DX_DRAWFLOATCOORDTYPE_DIRECT3D9 )
			{
				xx[0] -= 0.5f ;
				yy[0] -= 0.5f ;
				xx[1] -= 0.5f ;
				yy[1] -= 0.5f ;
				xx[3] -= 0.5f ;
				yy[3] -= 0.5f ;
				xx[2] -= 0.5f ;
				yy[2] -= 0.5f ;
			}

			return Graphics_Draw_ModiGraphFBase( xx[0], yy[0], xx[1], yy[1], xx[3], yy[3], xx[2], yy[2], GrHandle, TransFlag, TRUE ) ;
		}
	}
}

// OtBbN̉]`RA
extern	int NS_DrawRotaGraphFast3( int x, int y, int cx, int cy, float ExtRateX, float ExtRateY, float Angle, int GrHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	if( Angle == 0.0f && ExtRateX == 1.0f && ExtRateY == 1.0f )
	{
		int w, h ;

		NS_GetGraphSize( GrHandle, &w,&h ) ;

		return NS_DrawReverseGraph( x - cx, y - cy, GrHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;
	}
	else
	{
		return DrawRotaGraphFast3F_Base( ( float )x, ( float )y, ( float )cx, ( float )cy, ExtRateX, ExtRateY, Angle, GrHandle, TransFlag, ReverseXFlag, ReverseYFlag, TRUE ) ;
	}
}

// OtBbN̉]`R()
extern	int NS_DrawRotaGraphFast3F( float xf, float yf, float cxf, float cyf, float ExtRateX, float ExtRateY, float Angle, int GrHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	return DrawRotaGraphFast3F_Base( xf, yf, cxf, cyf, ExtRateX, ExtRateY, Angle, GrHandle, TransFlag, ReverseXFlag, ReverseYFlag, FALSE ) ;
}

// 摜̎Rό``( float  )
extern	int NS_DrawModiGraphF( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, int GrHandle, int TransFlag )
{
	return Graphics_Draw_ModiGraphFBase( x1, y1, x2, y2, x3, y3, x4, y4, GrHandle, TransFlag, false ) ;
}


// 摜̍E]`
extern	int NS_DrawTurnGraphF( float xf, float yf, int GrHandle, int TransFlag )
{
	IMAGEDATA *Image ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;

	return NS_DrawExtendGraphF( Image->WidthF + xf, yf, xf, yf + Image->HeightF, GrHandle, TransFlag ) ;
}

// 摜̔]`( Ww肪 float  )
extern int NS_DrawReverseGraphF( float xf, float yf, int GrHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	IMAGEDATA *Image ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;

	if( ReverseXFlag && ReverseYFlag )
	{
		return NS_DrawExtendGraphF( Image->WidthF + xf, yf + Image->HeightF, xf, yf, GrHandle, TransFlag ) ;
	}
	else
	if( ReverseXFlag )
	{
		return NS_DrawExtendGraphF( Image->WidthF + xf, yf, xf, yf + Image->HeightF, GrHandle, TransFlag ) ;
	}
	else
	if( ReverseYFlag )
	{
		return NS_DrawExtendGraphF( xf, yf + Image->HeightF, xf + Image->WidthF, yf, GrHandle, TransFlag ) ;
	}
	else
	{
		return NS_DrawGraphF( xf, yf, GrHandle, TransFlag ) ;
	}
}

// `bvOtBbNg}bv`
#define SETDRAWRECTCODE\
	SETRECT( DrawRect, Sx, Sy, Sx + XNum * Image->WidthI , Sy + YNum * Image->HeightI )\
	DRAWRECT_DRAWAREA_CLIP
extern	int NS_DrawChipMap( int Sx, int Sy, int XNum, int YNum, const int *MapData, int ChipTypeNum, int MapDataPitch, const int *ChipGrHandle, int TransFlag )
{
	IMAGEDATA *Image ;
	int Ret = -1 ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( ChipGrHandle[0], Image ) )
		return -1 ;

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawChipMap( Sx, Sy, XNum, YNum, MapData, MapDataPitch, ChipTypeNum, ChipGrHandle, TransFlag ),
		Graphics_Software_DrawChipMap( Sx, Sy, XNum, YNum, MapData, MapDataPitch, ChipTypeNum, ChipGrHandle, TransFlag ),
		SETDRAWRECTCODE,
		Ret,
		Image->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}
#undef SETDRAWRECTCODE

#ifndef DX_COMPILE_TYPE_C_LANGUAGE
extern	int NS_DrawChipMap( int MapWidth, int MapHeight, const int *MapData, int ChipTypeNum, const int *ChipGrHandle, int TransFlag, int MapDrawPointX, int MapDrawPointY, int MapDrawWidth, int MapDrawHeight, int ScreenX, int ScreenY )
{
	return NS_DrawChipMap2( MapWidth, MapHeight, MapData, ChipTypeNum, ChipGrHandle, TransFlag, MapDrawPointX, MapDrawPointY, MapDrawWidth, MapDrawHeight, ScreenX, ScreenY ) ;
}
#endif // DX_COMPILE_TYPE_C_LANGUAGE

// `bvOtBbNg}bv`
// int MapWidth, MapHeight : }bvf[^Ŝ̕ƍ
// int *MapData : }bvf[^i[ꂽAhX
// int ChipTypeNum : }bvɎg`bv̎ނ̐
// int *ChipGrHandle : `bṽOtBbNz̃AhX
// int TransFlag : ߐF̗L
// int MapDrawX, MapDrawY : `悷}bv̋N_ƂȂ鍶W
// int MapDrawWidth, MapDrawHeight : N_W`悷}bv̕ƍ
// int ScreenX, ScreenY : }bv`悷ʏ̍W
extern	int NS_DrawChipMap2( int MapWidth, int MapHeight, const int *MapData, int ChipTypeNum, const int *ChipGrHandle, int TransFlag, int MapDrawPointX, int MapDrawPointY, int MapDrawWidth, int MapDrawHeight, int ScreenX, int ScreenY )
{
	int Width, Height ;
	int Result ;
	
	// `bvOtBbÑTCY𓾂
	NS_GetGraphSize( ChipGrHandle[0], &Width, &Height ) ;

	// }bv񂪂͂ݏoꍇ̕␳
	if( MapDrawPointX + MapDrawWidth > MapWidth ) 
		MapDrawWidth -= ( MapDrawPointX + MapDrawWidth ) - MapWidth ;

	if( MapDrawPointY + MapDrawHeight > MapHeight ) 
		MapDrawHeight -= ( MapDrawPointY + MapDrawHeight ) - MapHeight ; 

	if( MapDrawPointX < 0 )
	{
		ScreenX = -MapDrawPointX * Width ;
		MapDrawWidth += MapDrawPointX ; 
		MapDrawPointX = 0 ;
	}
	if( MapDrawPointY < 0 )
	{
		ScreenY = -MapDrawPointY * Height ;
		MapDrawHeight += MapDrawPointY ; 
		MapDrawPointY = 0 ;
	}

	// }bv`
	Result = NS_DrawChipMap( ScreenX, ScreenY, MapDrawWidth, MapDrawHeight,
							 MapData + MapDrawPointX + MapDrawPointY * MapWidth, MapWidth, ChipTypeNum, ChipGrHandle, TransFlag ) ;
						 
	return Result ;
}

// OtBbNẅɃ^Cɕ`悷
#define SETDRAWRECTCODE\
	SETRECT( DrawRect, x1, y1, x2, y2 )\
	DRAWRECT_DRAWAREA_CLIP
extern	int NS_DrawTile( int x1, int y1, int x2, int y2, int Tx, int Ty, double ExtRate, double Angle, int GrHandle, int TransFlag )
{
	IMAGEDATA *Image ;
	IMAGEDATA *BlendImage ;
	int Ret = -1 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;
	if( x1 == x2 || y1 == y2 ) return 0 ;

	BlendImage = NULL ;
	if( GSYS.DrawSetting.BlendGraph > 0 )
	{
		GRAPHCHK( GSYS.DrawSetting.BlendGraph, BlendImage ) ;
	}

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawTile( x1, y1, x2, y2, Tx, Ty, ExtRate, Angle, Image, BlendImage, TransFlag ),
		Graphics_Software_DrawTile( x1, y1, x2, y2, Tx, Ty, ExtRate, Angle, Image,             TransFlag ),
		SETDRAWRECTCODE,
		Ret,
		Image->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}
#undef SETDRAWRECTCODE

// OtBbN̎w`݂̂`
extern	int NS_DrawRectGraph( int DestX, int DestY, int SrcX, int SrcY, int Width, int Height, int GraphHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	RECT  BackupDrawRect ;
	RECTF BackupDrawRectF ;
	int hr = 0 ;

	// TCY
	if( Width <= 0 || Height <= 0 )
		return -1 ;

	// Wϊsꍇ͐؂OtBbN쐬ĕ`
	if( GSYS.DrawSetting.Valid2DMatrix )
	{
		int TempHandle ;

		// ؂OtBbN쐬
		TempHandle = NS_DerivationGraph( SrcX, SrcY, Width, Height, GraphHandle ) ;

		// `
		if( ReverseXFlag == FALSE && ReverseYFlag == FALSE )
		{
			NS_DrawGraph( DestX, DestY, TempHandle, TransFlag ) ;
		}
		else
		{
			NS_DrawReverseGraph( DestX, DestY, TempHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;
		}

		// 폜
		NS_DeleteGraph( TempHandle, FALSE ) ;

		// I
		return 0 ;
	}

	// w``oȂ悤ɂ
	BackupDrawRect  = GSYS.DrawSetting.DrawArea ;
	BackupDrawRectF = GSYS.DrawSetting.DrawAreaF ;
	SETRECT( GSYS.DrawSetting.DrawArea, DestX, DestY, DestX + Width, DestY + Height ) ;
	RectClipping_Inline( &GSYS.DrawSetting.DrawArea, &BackupDrawRect ) ;
	if( GSYS.Setting.ValidHardware == FALSE || GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode )
	{
		SetMemImgDrawArea( &GSYS.DrawSetting.DrawArea ) ;
	}
	GSYS.DrawSetting.DrawAreaF.left   = ( float )GSYS.DrawSetting.DrawArea.left ;
	GSYS.DrawSetting.DrawAreaF.top    = ( float )GSYS.DrawSetting.DrawArea.top ;
	GSYS.DrawSetting.DrawAreaF.right  = ( float )GSYS.DrawSetting.DrawArea.right ;
	GSYS.DrawSetting.DrawAreaF.bottom = ( float )GSYS.DrawSetting.DrawArea.bottom ;

	// OtBbN̕`
	if( ReverseXFlag || ReverseYFlag )
	{
		IMAGEDATA *Image ;

		// G[
		if( GRAPHCHK( GraphHandle, Image ) )
			return -1 ;

		if( ReverseXFlag && ReverseYFlag )
		{
			hr = NS_DrawReverseGraph( DestX - ( Image->WidthI - SrcX - Width ), DestY - ( Image->HeightI - SrcY - Height ), GraphHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;
		}
		else
		if( ReverseXFlag )
		{
			hr = NS_DrawReverseGraph( DestX - ( Image->WidthI - SrcX - Width ), DestY - SrcY, GraphHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;
		}
		else
		if( ReverseYFlag )
		{
			hr = NS_DrawReverseGraph( DestX - SrcX, DestY - ( Image->HeightI - SrcY - Height ), GraphHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;
		}
	}
	else
	{
		hr = NS_DrawGraph( DestX - SrcX, DestY - SrcY, GraphHandle, TransFlag ) ;
	}

	// ``ɖ߂
#ifndef DX_NON_MASK
	if( MASKD.MaskValidFlag )
	{
		// }XNgpĂꍇ̓}XNŐFXύXĂ̂Œʏ SetDrawArea gp
		NS_SetDrawArea( BackupDrawRect.left, BackupDrawRect.top, BackupDrawRect.right, BackupDrawRect.bottom ) ;
	}
	else 
#endif
	{
		// }XNgpĂȂꍇ͊ȈՓIȐݒ蕜A
		GSYS.DrawSetting.DrawArea = BackupDrawRect ;
		if( GSYS.Setting.ValidHardware == FALSE || GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode )
		{
			SetMemImgDrawArea( &BackupDrawRect ) ;
		}
		GSYS.DrawSetting.DrawAreaF = BackupDrawRectF ;
	}

	// I
	return hr ;
}

// OtBbN̎w`݂̂g`
extern	int NS_DrawRectExtendGraph( int DestX1, int DestY1, int DestX2, int DestY2, int SrcX, int SrcY, int SrcWidth, int SrcHeight, int GraphHandle, int TransFlag )
{
	RECT MotoDrawRect ;
	RECTF MotoDrawRectF ;
	int hr, tmp ;
	int x1, y1, x2, y2 ;	
	bool RevX, RevY ;
	int DestWidth, DestHeight ;
	double exX, exY ;
	IMAGEDATA *Image ;

	// TCY
	if( SrcWidth <= 0 || SrcHeight <= 0 )
		return -1 ;
	
	// G[
	if( GRAPHCHK( GraphHandle, Image ) )
		return -1 ;

	// ]
	{
		if( DestX2 < DestX1 )
		{
			RevX = true ;
			tmp = DestX1 ; DestX1 = DestX2 ; DestX2 = tmp ;
		}
		else
		{
			RevX = false ;
		}
		
		if( DestY2 < DestY1 )
		{
			RevY = true ;
			tmp = DestY1 ; DestY1 = DestY2 ; DestY2 = tmp ;
		}
		else
		{
			RevY = false ;
		}
	}

	// Wϊsꍇ͐؂OtBbN쐬ĕ`
	if( GSYS.DrawSetting.Valid2DMatrix )
	{
		int TempHandle ;

		// ؂OtBbN쐬
		TempHandle = NS_DerivationGraph( SrcX, SrcY, SrcWidth, SrcHeight, GraphHandle ) ;

		// `
		NS_DrawExtendGraph( DestX1, DestY1, DestX2, DestY2, TempHandle, TransFlag ) ;

		// 폜
		NS_DeleteGraph( TempHandle, FALSE ) ;

		// I
		return 0 ;
	}

	// w``oȂ悤ɂ
	MotoDrawRect = GSYS.DrawSetting.DrawArea ;
	MotoDrawRectF = GSYS.DrawSetting.DrawAreaF ;
	SETRECT( GSYS.DrawSetting.DrawArea, DestX1, DestY1, DestX2, DestY2 ) ;
	RectClipping_Inline( &GSYS.DrawSetting.DrawArea, &MotoDrawRect ) ;
	SetMemImgDrawArea( &GSYS.DrawSetting.DrawArea ) ;
	GSYS.DrawSetting.DrawAreaF.left   = (float)GSYS.DrawSetting.DrawArea.left ;
	GSYS.DrawSetting.DrawAreaF.top    = (float)GSYS.DrawSetting.DrawArea.top ;
	GSYS.DrawSetting.DrawAreaF.right  = (float)GSYS.DrawSetting.DrawArea.right ;
	GSYS.DrawSetting.DrawAreaF.bottom = (float)GSYS.DrawSetting.DrawArea.bottom ;

	// OtBbN̕`
	{
		DestWidth = DestX2 - DestX1 ;
		DestHeight = DestY2 - DestY1 ;
		exX = (double)DestWidth / SrcWidth ;
		exY = (double)DestHeight / SrcHeight ;
		if( RevX == true )
		{
			x1 = DestX2 + _DTOL( SrcX * exX ) ;
			x2 = DestX2 - _DTOL( ( Image->WidthI - SrcX ) * exX ) ;
		}
		else
		{
			x1 = DestX1 - _DTOL( SrcX * exX ) ;
			x2 = DestX1 + _DTOL( ( Image->WidthI - SrcX ) * exX ) ;
		}

		if( RevY == true )
		{
			y1 = DestY2 + _DTOL( SrcY * exY ) ;
			y2 = DestY2 - _DTOL( ( Image->HeightI - SrcY ) * exY ) ;
		}
		else
		{
			y1 = DestY1 - _DTOL( SrcY * exY ) ;
			y2 = DestY1 + _DTOL( ( Image->HeightI - SrcY ) * exY ) ;
		}
		hr = NS_DrawExtendGraph( x1, y1, x2, y2, GraphHandle, TransFlag ) ;
	}

	// ``ɖ߂
	GSYS.DrawSetting.DrawArea = MotoDrawRect ;
	SetMemImgDrawArea( &MotoDrawRect ) ;
	GSYS.DrawSetting.DrawAreaF = MotoDrawRectF ;

	// I
	return hr ;
}

extern	int NS_DrawRectRotaGraph( int X, int Y, int SrcX, int SrcY, int Width, int Height, double ExtRate, double Angle, int GraphHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag ) 
{
	int TempHandle ;

	// TCY
	if( Width <= 0 || Height <= 0 )
		return -1 ;

	// ؂OtBbN쐬
	TempHandle = NS_DerivationGraph( SrcX, SrcY, Width, Height, GraphHandle ) ;

	// ]`
	NS_DrawRotaGraph( X, Y, ExtRate, Angle, TempHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;

	// 폜
	NS_DeleteGraph( TempHandle, FALSE ) ;

	// I
	return 0 ;
}

extern int NS_DrawRectRotaGraph2( int x, int y, int SrcX, int SrcY, int Width, int Height, int cx, int cy, double ExtRate, double Angle, int GraphHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	int TempHandle ;

	// TCY
	if( Width <= 0 || Height <= 0 )
		return -1 ;

	// ؂OtBbN쐬
	TempHandle = NS_DerivationGraph( SrcX, SrcY, Width, Height, GraphHandle ) ;

	// ]`
	NS_DrawRotaGraph2( x, y, cx, cy, ExtRate, Angle, TempHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;

	// 폜
	NS_DeleteGraph( TempHandle, FALSE ) ;

	// I
	return 0 ;
}

extern int NS_DrawRectRotaGraph3(  int x,   int y,   int SrcX, int SrcY, int Width, int Height, int cx, int cy, double ExtRateX, double ExtRateY, double Angle, int GraphHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	int TempHandle ;

	// TCY
	if( Width <= 0 || Height <= 0 )
		return -1 ;

	// ؂OtBbN쐬
	TempHandle = NS_DerivationGraph( SrcX, SrcY, Width, Height, GraphHandle ) ;

	// ]`
	NS_DrawRotaGraph3( x, y, cx, cy, ExtRateX, ExtRateY, Angle, TempHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;

	// 폜
	NS_DeleteGraph( TempHandle, FALSE ) ;

	// I
	return 0 ;
}

extern	int NS_DrawRectRotaGraphFast( int X, int Y, int SrcX, int SrcY, int Width, int Height, float ExtRate, float Angle, int GraphHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag ) 
{
	int TempHandle ;

	// TCY
	if( Width <= 0 || Height <= 0 )
		return -1 ;

	// ؂OtBbN쐬
	TempHandle = NS_DerivationGraph( SrcX, SrcY, Width, Height, GraphHandle ) ;

	// ]`
	NS_DrawRotaGraphFast( X, Y, ExtRate, Angle, TempHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;

	// 폜
	NS_DeleteGraph( TempHandle, FALSE ) ;

	// I
	return 0 ;
}

extern int NS_DrawRectRotaGraphFast2( int x, int y, int SrcX, int SrcY, int Width, int Height, int cx, int cy, float ExtRate, float Angle, int GraphHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	int TempHandle ;

	// TCY
	if( Width <= 0 || Height <= 0 )
		return -1 ;

	// ؂OtBbN쐬
	TempHandle = NS_DerivationGraph( SrcX, SrcY, Width, Height, GraphHandle ) ;

	// ]`
	NS_DrawRotaGraphFast2( x, y, cx, cy, ExtRate, Angle, TempHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;

	// 폜
	NS_DeleteGraph( TempHandle, FALSE ) ;

	// I
	return 0 ;
}

extern int NS_DrawRectRotaGraphFast3(  int x,   int y,   int SrcX, int SrcY, int Width, int Height, int cx, int cy, float ExtRateX, float ExtRateY, float Angle, int GraphHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	int TempHandle ;

	// TCY
	if( Width <= 0 || Height <= 0 )
		return -1 ;

	// ؂OtBbN쐬
	TempHandle = NS_DerivationGraph( SrcX, SrcY, Width, Height, GraphHandle ) ;

	// ]`
	NS_DrawRotaGraphFast3( x, y, cx, cy, ExtRateX, ExtRateY, Angle, TempHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;

	// 폜
	NS_DeleteGraph( TempHandle, FALSE ) ;

	// I
	return 0 ;
}

// 摜̎w`݂̂Rό``
extern int NS_DrawRectModiGraph( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int SrcX, int SrcY, int Width, int Height, int GraphHandle, int TransFlag )
{
	int TempHandle ;

	// TCY
	if( Width <= 0 || Height <= 0 )
		return -1 ;

	// ؂OtBbN쐬
	TempHandle = NS_DerivationGraph( SrcX, SrcY, Width, Height, GraphHandle ) ;

	// Rό``
	NS_DrawModiGraph( x1, y1, x2, y2, x3, y3, x4, y4, TempHandle, TransFlag ) ;

	// 폜
	NS_DeleteGraph( TempHandle, FALSE ) ;

	// I
	return 0 ;
}

// OtBbN̎w`݂̂`
extern int NS_DrawRectGraphF( float DestX, float DestY, int SrcX, int SrcY, int SrcWidth, int SrcHeight, int GraphHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	IMAGEDATA *Image ;

	GRAPHICS_DRAW_DRAWSIMPLEQUADRANGLEGRAPHF_PARAM Param ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX Vertex[ 4 ] ;

	// G[
	if( GRAPHCHK( GraphHandle, Image ) )
		return -1 ;

	if( Image->Hard.DrawNum == 1 )
	{
		Param.QuadrangleNum = 1 ;
		Param.Vertex        = Vertex ;
		Param.GraphHandle   = GraphHandle ;
		Param.TransFlag     = TransFlag ;

		SrcX += Image->Hard.Draw[ 0 ].UsePosXI ;
		SrcY += Image->Hard.Draw[ 0 ].UsePosYI ;
		if( ReverseXFlag )
		{
			if( ReverseYFlag )
			{
				Vertex[ 0 ].x = DestX + SrcWidth ;
				Vertex[ 0 ].y = DestY + SrcHeight ;
				Vertex[ 1 ].x = DestX ;
				Vertex[ 1 ].y = DestY + SrcHeight ;
				Vertex[ 2 ].x = DestX + SrcWidth ;
				Vertex[ 2 ].y = DestY ;
				Vertex[ 3 ].x = DestX ;
				Vertex[ 3 ].y = DestY ;
			}
			else
			{
				Vertex[ 0 ].x = DestX + SrcWidth ;
				Vertex[ 0 ].y = DestY ;
				Vertex[ 1 ].x = DestX ;
				Vertex[ 1 ].y = DestY ;
				Vertex[ 2 ].x = DestX + SrcWidth ;
				Vertex[ 2 ].y = DestY + SrcHeight ;
				Vertex[ 3 ].x = DestX ;
				Vertex[ 3 ].y = DestY + SrcHeight ;
			}
		}
		else
		if( ReverseYFlag )
		{
			Vertex[ 0 ].x = DestX ;
			Vertex[ 0 ].y = DestY + SrcHeight ;
			Vertex[ 1 ].x = DestX + SrcWidth ;
			Vertex[ 1 ].y = DestY + SrcHeight ;
			Vertex[ 2 ].x = DestX ;
			Vertex[ 2 ].y = DestY ;
			Vertex[ 3 ].x = DestX + SrcWidth ;
			Vertex[ 3 ].y = DestY ;
		}
		else
		{
			Vertex[ 0 ].x = DestX ;
			Vertex[ 0 ].y = DestY ;
			Vertex[ 1 ].x = DestX + SrcWidth ;
			Vertex[ 1 ].y = DestY ;
			Vertex[ 2 ].x = DestX ;
			Vertex[ 2 ].y = DestY + SrcHeight ;
			Vertex[ 3 ].x = DestX + SrcWidth ;
			Vertex[ 3 ].y = DestY + SrcHeight ;
		}

		Vertex[ 0 ].u = ( float )SrcX / Image->Hard.Draw[ 0 ].Tex->TexWidth ;
		Vertex[ 0 ].v = ( float )SrcY / Image->Hard.Draw[ 0 ].Tex->TexHeight ;
		Vertex[ 1 ].u = ( float )( SrcX + SrcWidth ) / Image->Hard.Draw[ 0 ].Tex->TexWidth ;
		Vertex[ 1 ].v = Vertex[ 0 ].v ;
		Vertex[ 2 ].u = Vertex[ 0 ].u ;
		Vertex[ 2 ].v = ( float )( SrcY + SrcHeight ) / Image->Hard.Draw[ 0 ].Tex->TexHeight ;
		Vertex[ 3 ].u = Vertex[ 1 ].u ;
		Vertex[ 3 ].v = Vertex[ 2 ].v ;

		Graphics_Draw_DrawSimpleQuadrangleGraphF( &Param ) ;
	}
	else
	{
		int TempGrHandle;
		
		TempGrHandle = NS_DerivationGraph( SrcX, SrcY, SrcWidth, SrcHeight, GraphHandle ) ;

		if( ReverseXFlag || ReverseYFlag )
		{
			NS_DrawReverseGraphF( DestX, DestY, TempGrHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;
		}
		else
		{
			NS_DrawGraphF( DestX, DestY, TempGrHandle, TransFlag ) ;
		}

		NS_DeleteGraph( TempGrHandle, FALSE );
	}

	return 0 ;
}

// OtBbN̎w`݂̂`
extern int NS_DrawRectGraphF2( float DestX, float DestY, float SrcX, float SrcY, float SrcWidth, float SrcHeight, int GraphHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	IMAGEDATA *Image ;

	GRAPHICS_DRAW_DRAWSIMPLEQUADRANGLEGRAPHF_PARAM Param ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX Vertex[ 4 ] ;

	// G[
	if( GRAPHCHK( GraphHandle, Image ) )
		return -1 ;

	if( Image->Hard.DrawNum == 1 )
	{
		Param.QuadrangleNum = 1 ;
		Param.Vertex        = Vertex ;
		Param.GraphHandle   = GraphHandle ;
		Param.TransFlag     = TransFlag ;

		SrcX += Image->Hard.Draw[ 0 ].UsePosXF ;
		SrcY += Image->Hard.Draw[ 0 ].UsePosYF ;
		if( ReverseXFlag )
		{
			if( ReverseYFlag )
			{
				Vertex[ 0 ].x = DestX + SrcWidth ;
				Vertex[ 0 ].y = DestY + SrcHeight ;
				Vertex[ 1 ].x = DestX ;
				Vertex[ 1 ].y = DestY + SrcHeight ;
				Vertex[ 2 ].x = DestX + SrcWidth ;
				Vertex[ 2 ].y = DestY ;
				Vertex[ 3 ].x = DestX ;
				Vertex[ 3 ].y = DestY ;
			}
			else
			{
				Vertex[ 0 ].x = DestX + SrcWidth ;
				Vertex[ 0 ].y = DestY ;
				Vertex[ 1 ].x = DestX ;
				Vertex[ 1 ].y = DestY ;
				Vertex[ 2 ].x = DestX + SrcWidth ;
				Vertex[ 2 ].y = DestY + SrcHeight ;
				Vertex[ 3 ].x = DestX ;
				Vertex[ 3 ].y = DestY + SrcHeight ;
			}
		}
		else
		if( ReverseYFlag )
		{
			Vertex[ 0 ].x = DestX ;
			Vertex[ 0 ].y = DestY + SrcHeight ;
			Vertex[ 1 ].x = DestX + SrcWidth ;
			Vertex[ 1 ].y = DestY + SrcHeight ;
			Vertex[ 2 ].x = DestX ;
			Vertex[ 2 ].y = DestY ;
			Vertex[ 3 ].x = DestX + SrcWidth ;
			Vertex[ 3 ].y = DestY ;
		}
		else
		{
			Vertex[ 0 ].x = DestX ;
			Vertex[ 0 ].y = DestY ;
			Vertex[ 1 ].x = DestX + SrcWidth ;
			Vertex[ 1 ].y = DestY ;
			Vertex[ 2 ].x = DestX ;
			Vertex[ 2 ].y = DestY + SrcHeight ;
			Vertex[ 3 ].x = DestX + SrcWidth ;
			Vertex[ 3 ].y = DestY + SrcHeight ;
		}

		Vertex[ 0 ].u = SrcX / Image->Hard.Draw[ 0 ].Tex->TexWidth ;
		Vertex[ 0 ].v = SrcY / Image->Hard.Draw[ 0 ].Tex->TexHeight ;
		Vertex[ 1 ].u = ( SrcX + SrcWidth ) / Image->Hard.Draw[ 0 ].Tex->TexWidth ;
		Vertex[ 1 ].v = Vertex[ 0 ].v ;
		Vertex[ 2 ].u = Vertex[ 0 ].u ;
		Vertex[ 2 ].v = ( SrcY + SrcHeight ) / Image->Hard.Draw[ 0 ].Tex->TexHeight ;
		Vertex[ 3 ].u = Vertex[ 1 ].u ;
		Vertex[ 3 ].v = Vertex[ 2 ].v ;

		Graphics_Draw_DrawSimpleQuadrangleGraphF( &Param ) ;
	}
	else
	{
		int TempGrHandle;
		
		TempGrHandle = NS_DerivationGraphF( SrcX, SrcY, SrcWidth, SrcHeight, GraphHandle ) ;

		if( ReverseXFlag || ReverseYFlag )
		{
			NS_DrawReverseGraphF( DestX, DestY, TempGrHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;
		}
		else
		{
			NS_DrawGraphF( DestX, DestY, TempGrHandle, TransFlag ) ;
		}

		NS_DeleteGraph( TempGrHandle, FALSE );
	}

	return 0 ;
}

// OtBbN̎w`݂̂g`
extern int NS_DrawRectExtendGraphF( float DestX1, float DestY1, float DestX2, float DestY2, int SrcX, int SrcY, int SrcWidth, int SrcHeight, int GraphHandle, int TransFlag )
{
	int TempHandle ;

	// TCY
	if( SrcWidth <= 0 || SrcHeight <= 0 )
		return -1 ;

	// ؂OtBbN쐬
	TempHandle = NS_DerivationGraph( SrcX, SrcY, SrcWidth, SrcHeight, GraphHandle ) ;

	// g`
	NS_DrawExtendGraphF( DestX1, DestY1, DestX2, DestY2, TempHandle, TransFlag ) ;

	// 폜
	NS_DeleteGraph( TempHandle, FALSE ) ;

	// I
	return 0 ;
}

// 摜̎w`݂̂g`( Ww肪 float ( 摜W̎w float  ) )
extern int NS_DrawRectExtendGraphF2( float DestX1, float DestY1, float DestX2, float DestY2, float SrcX, float SrcY, float SrcWidth, float SrcHeight, int GraphHandle, int TransFlag )
{
	IMAGEDATA *Image ;

	GRAPHICS_DRAW_DRAWSIMPLEQUADRANGLEGRAPHF_PARAM Param ;
	GRAPHICS_DRAW_DRAWSIMPLEANGLEGRAPHF_VERTEX Vertex[ 4 ] ;

	// G[
	if( GRAPHCHK( GraphHandle, Image ) )
		return -1 ;

	if( Image->Hard.DrawNum == 1 )
	{
		Param.QuadrangleNum = 1 ;
		Param.Vertex        = Vertex ;
		Param.GraphHandle   = GraphHandle ;
		Param.TransFlag     = TransFlag ;

		SrcX += Image->Hard.Draw[ 0 ].UsePosXF ;
		SrcY += Image->Hard.Draw[ 0 ].UsePosYF ;

		Vertex[ 0 ].x = DestX1 ;
		Vertex[ 0 ].y = DestY1 ;
		Vertex[ 0 ].u = SrcX / Image->Hard.Draw[ 0 ].Tex->TexWidth ;
		Vertex[ 0 ].v = SrcY / Image->Hard.Draw[ 0 ].Tex->TexHeight ;

		Vertex[ 1 ].x = DestX2 ;
		Vertex[ 1 ].y = DestY1 ;
		Vertex[ 1 ].u = ( SrcX + SrcWidth ) / Image->Hard.Draw[ 0 ].Tex->TexWidth ;
		Vertex[ 1 ].v = Vertex[ 0 ].v ;

		Vertex[ 2 ].x = DestX1 ;
		Vertex[ 2 ].y = DestY2 ;
		Vertex[ 2 ].u = Vertex[ 0 ].u ;
		Vertex[ 2 ].v = ( SrcY + SrcHeight ) / Image->Hard.Draw[ 0 ].Tex->TexHeight ;

		Vertex[ 3 ].x = DestX2 ;
		Vertex[ 3 ].y = DestY2 ;
		Vertex[ 3 ].u = Vertex[ 1 ].u ;
		Vertex[ 3 ].v = Vertex[ 2 ].v ;

		Graphics_Draw_DrawSimpleQuadrangleGraphF( &Param ) ;
	}
	else
	{
		int TempGrHandle;
		
		TempGrHandle = NS_DerivationGraphF( SrcX, SrcY, SrcWidth, SrcHeight, GraphHandle ) ;
		NS_DrawExtendGraphF( DestX1, DestY1, DestX2, DestY2, TempGrHandle, TransFlag );
		NS_DeleteGraph( TempGrHandle, FALSE );
	}

	return 0 ;
}

extern int NS_DrawRectRotaGraphF( float X, float Y, int SrcX, int SrcY, int Width, int Height, double ExtRate, double Angle, int GraphHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	int TempHandle ;

	// TCY
	if( Width <= 0 || Height <= 0 )
		return -1 ;

	// ؂OtBbN쐬
	TempHandle = NS_DerivationGraph( SrcX, SrcY, Width, Height, GraphHandle ) ;

	// ]`
	NS_DrawRotaGraphF( X, Y, ExtRate, Angle, TempHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;

	// 폜
	NS_DeleteGraph( TempHandle, FALSE ) ;

	// I
	return 0 ;
}

extern int NS_DrawRectRotaGraph2F( float x, float y, int SrcX, int SrcY, int Width, int Height, float cxf, float cyf, double ExtRate, double Angle, int GraphHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	int TempHandle ;

	// TCY
	if( Width <= 0 || Height <= 0 )
		return -1 ;

	// ؂OtBbN쐬
	TempHandle = NS_DerivationGraph( SrcX, SrcY, Width, Height, GraphHandle ) ;

	// ]`
	NS_DrawRotaGraph2F( x, y, cxf, cyf, ExtRate, Angle, TempHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;

	// 폜
	NS_DeleteGraph( TempHandle, FALSE ) ;

	// I
	return 0 ;
}

extern int NS_DrawRectRotaGraph3F( float x, float y, int SrcX, int SrcY, int Width, int Height, float cxf, float cyf, double ExtRateX, double ExtRateY, double Angle, int GraphHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	int TempHandle ;

	// TCY
	if( Width <= 0 || Height <= 0 )
		return -1 ;

	// ؂OtBbN쐬
	TempHandle = NS_DerivationGraph( SrcX, SrcY, Width, Height, GraphHandle ) ;

	// ]`
	NS_DrawRotaGraph3F( x, y, cxf, cyf, ExtRateX, ExtRateY, Angle, TempHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;

	// 폜
	NS_DeleteGraph( TempHandle, FALSE ) ;

	// I
	return 0 ;
}

extern int NS_DrawRectRotaGraphFastF( float X, float Y, int SrcX, int SrcY, int Width, int Height, float ExtRate, float Angle, int GraphHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	int TempHandle ;

	// TCY
	if( Width <= 0 || Height <= 0 )
		return -1 ;

	// ؂OtBbN쐬
	TempHandle = NS_DerivationGraph( SrcX, SrcY, Width, Height, GraphHandle ) ;

	// ]`
	NS_DrawRotaGraphFastF( X, Y, ExtRate, Angle, TempHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;

	// 폜
	NS_DeleteGraph( TempHandle, FALSE ) ;

	// I
	return 0 ;
}

extern int NS_DrawRectRotaGraphFast2F( float x, float y, int SrcX, int SrcY, int Width, int Height, float cxf, float cyf, float ExtRate, float Angle, int GraphHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	int TempHandle ;

	// TCY
	if( Width <= 0 || Height <= 0 )
		return -1 ;

	// ؂OtBbN쐬
	TempHandle = NS_DerivationGraph( SrcX, SrcY, Width, Height, GraphHandle ) ;

	// ]`
	NS_DrawRotaGraphFast2F( x, y, cxf, cyf, ExtRate, Angle, TempHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;

	// 폜
	NS_DeleteGraph( TempHandle, FALSE ) ;

	// I
	return 0 ;
}

extern int NS_DrawRectRotaGraphFast3F( float x, float y, int SrcX, int SrcY, int Width, int Height, float cxf, float cyf, float ExtRateX, float ExtRateY, float Angle, int GraphHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	int TempHandle ;

	// TCY
	if( Width <= 0 || Height <= 0 )
		return -1 ;

	// ؂OtBbN쐬
	TempHandle = NS_DerivationGraph( SrcX, SrcY, Width, Height, GraphHandle ) ;

	// ]`
	NS_DrawRotaGraphFast3F( x, y, cxf, cyf, ExtRateX, ExtRateY, Angle, TempHandle, TransFlag, ReverseXFlag, ReverseYFlag ) ;

	// 폜
	NS_DeleteGraph( TempHandle, FALSE ) ;

	// I
	return 0 ;
}

// 摜̎w`݂̂Rό``( Ww肪 float  )
extern int NS_DrawRectModiGraphF( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, int SrcX, int SrcY, int Width, int Height,         int GraphHandle, int TransFlag )
{
	int TempHandle ;

	// TCY
	if( Width <= 0 || Height <= 0 )
		return -1 ;

	// ؂OtBbN쐬
	TempHandle = NS_DerivationGraph( SrcX, SrcY, Width, Height, GraphHandle ) ;

	// Rό``
	NS_DrawModiGraphF( x1, y1, x2, y2, x3, y3, x4, y4, TempHandle, TransFlag ) ;

	// 폜
	NS_DeleteGraph( TempHandle, FALSE ) ;

	// I
	return 0 ;
}

// uh摜ƍĉ摜`悷
extern	int NS_DrawBlendGraph( int x, int y, int GrHandle, int TransFlag, int BlendGraph, int BorderParam, int BorderRange )
{
	int B_BlendGraph, B_BorderParam, B_BorderRange ;

	B_BlendGraph = GSYS.DrawSetting.BlendGraph ;
	B_BorderParam = GSYS.DrawSetting.BlendGraphBorderParam ;
	B_BorderRange = GSYS.DrawSetting.BlendGraphBorderRange ;

	NS_SetBlendGraph( BlendGraph, BorderParam, BorderRange ) ;
	NS_DrawGraph( x, y, GrHandle, TransFlag ) ;
	NS_SetBlendGraph( B_BlendGraph, B_BorderParam, B_BorderRange ) ;

	// I
	return 0 ;
}

// uh摜ƍĉ摜𓙔{`悷( Ww肪 float  )
extern	int NS_DrawBlendGraphF( float x, float y, int GrHandle, int TransFlag, int BlendGraph, int BorderParam, int BorderRange )
{
	int B_BlendGraph, B_BorderParam, B_BorderRange ;

	B_BlendGraph = GSYS.DrawSetting.BlendGraph ;
	B_BorderParam = GSYS.DrawSetting.BlendGraphBorderParam ;
	B_BorderRange = GSYS.DrawSetting.BlendGraphBorderRange ;

	NS_SetBlendGraph( BlendGraph, BorderParam, BorderRange ) ;
	NS_DrawGraphF( x, y, GrHandle, TransFlag ) ;
	NS_SetBlendGraph( B_BlendGraph, B_BorderParam, B_BorderRange ) ;

	// I
	return 0 ;
}

// uh摜ƍĉ摜`悷( uh摜̋N_Ww肷 )
extern	int NS_DrawBlendGraphPos( int x, int y, int GrHandle, int TransFlag, int bx, int by, int BlendGraph, int BorderParam, int BorderRange )
{
	int B_BlendGraph, B_BorderParam, B_BorderRange, B_PosX, B_PosY ;

	B_BlendGraph = GSYS.DrawSetting.BlendGraph ;
	B_BorderParam = GSYS.DrawSetting.BlendGraphBorderParam ;
	B_BorderRange = GSYS.DrawSetting.BlendGraphBorderRange ;
	B_PosX = GSYS.DrawSetting.BlendGraphX ;
	B_PosY = GSYS.DrawSetting.BlendGraphY ;

	NS_SetBlendGraph( BlendGraph, BorderParam, BorderRange ) ;
	NS_SetBlendGraphPosition( bx, by ) ;
	NS_DrawGraph( x, y, GrHandle, TransFlag ) ;
	NS_SetBlendGraphPosition( B_PosX, B_PosY ) ;
	NS_SetBlendGraph( B_BlendGraph, B_BorderParam, B_BorderRange ) ;

	// I
	return 0 ;
}

// DrawCircleGauge ֐̕⏕֐
static void DrawCircleGaugePolygon(
	int GraphHandle,
	float CenterX,
	float CenterY,
	VECTOR *pVector,
	float SizeR,
	float UScale,
	float VScale,
	float UStart,
	float VStart,
	int ReverseX,
	int ReverseY
)
{
	int i ;
	VERTEX vert[ 3 ] ;
	float AdjustPosition ;

	AdjustPosition = GSYS.HardInfo.DrawFloatCoordType == DX_DRAWFLOATCOORDTYPE_DIRECT3D9 ? 0.5f : 0.0f ;
	
	for( i = 0; i < 3; i ++ )
	{
		vert[i].x = ( ReverseX ? -pVector[i].x : pVector[i].x ) + CenterX + AdjustPosition ;
		vert[i].y = ( ReverseY ? -pVector[i].y : pVector[i].y ) + CenterY + AdjustPosition ;
		vert[i].u = ( pVector[i].x * SizeR + 0.5f ) * UScale + UStart ;
		vert[i].v = ( pVector[i].y * SizeR + 0.5f ) * VScale + VStart ;
		vert[i].b = 255 ;
		vert[i].g = 255 ;
		vert[i].r = 255 ;
		vert[i].a = 255 ;
	}
	NS_DrawPolygon( vert, 1, GraphHandle, TRUE, FALSE );
}

// ~OtIȕ`s
int NS_DrawCircleGauge( int CenterX, int CenterY, double Percent, int GrHandle, double StartPercent , double Scale, int ReverseX, int ReverseY )
{
	VECTOR vertex[3] ;
	VECTOR position[4] ;
	VECTOR positionR ;
	VECTOR positionR2 ;
	float radian ;
	float radian2 ;
	float length ;
	float Sin ;
	float Cos ;
	float CenterXF ;
	float CenterYF ;
	float SizeR ;
	int SizeX ;
	int SizeY ;
	int i ;
	float StartRad ;
	float EndRad ;
	IMAGEDATA *Image ;
	float UScale ;
	float VScale ;
	float UStart ;
	float VStart ;
	RECT DrawRect ;
	RECT GaugeDrawRect ;

	Image = Graphics_Image_GetData( GrHandle ) ;
	if( Image == NULL )
	{
		return -1 ;
	}

	if( Image->Orig->FormatDesc.TextureFlag )
	{
		UStart = ( float )Image->Hard.Draw[ 0 ].UsePosXF / Image->Hard.Draw[ 0 ].Tex->TexWidth ;
		VStart = ( float )Image->Hard.Draw[ 0 ].UsePosYF / Image->Hard.Draw[ 0 ].Tex->TexHeight ;
		UScale = ( float )Image->WidthF                  / Image->Hard.Draw[ 0 ].Tex->TexWidth ;
		VScale = ( float )Image->HeightF                 / Image->Hard.Draw[ 0 ].Tex->TexHeight ;
	}
	else
	{
		UScale = 1.0f ;
		VScale = 1.0f ;
		UStart = 0.0f ;
		VStart = 0.0f ;
	}

	if( StartPercent > 200.0 )
	{
		StartPercent = 200.0 ;
	}
	else
	if( StartPercent < -100.0 )
	{
		StartPercent = -100.0 ;
	}

	if( Percent > 200.0 )
	{
		Percent = 200.0 ;
	}
	else
	if( Percent < -100.0 )
	{
		Percent = -100.0 ;
	}

	if( Percent - StartPercent > 100.0 )
	{
		StartPercent = 0.0 ;
		Percent = 100.0 ;
	}

	if( StartPercent == Percent ||
		StartPercent > Percent )
	{
		return 0 ;
	}

	NS_GetGraphSize( GrHandle, &SizeX, &SizeY );

	radian   = ( float )( Percent      * 2 * DX_PI / 100.0 );
	radian2  = ( float )( StartPercent * 2 * DX_PI / 100.0 );
	length   = ( float )( SizeX * Scale * 0.75f ) ;
	CenterXF = ( float )CenterX;
	CenterYF = ( float )CenterY;
	SizeR    = ( float )( 1.0f / ( SizeX * Scale ) ) ;

	vertex[0].x = 0.0f;
	vertex[0].y = 0.0f;
	vertex[1] = vertex[0];
	vertex[2] = vertex[0];

	position[0].x = 0.0f;
	position[0].y = -length;

	position[1].x = length;
	position[1].y = 0.0f;

	position[2].x = 0.0f;
	position[2].y = length;

	position[3].x = -length;
	position[3].y = 0.0f;

	_SINCOS_PLATFORM( radian2 - DX_PI_F * 0.5f, &Sin, &Cos ) ;
	positionR2.x = Cos * length;
	positionR2.y = Sin * length;

	_SINCOS_PLATFORM( radian - DX_PI_F * 0.5f, &Sin, &Cos ) ;
	positionR.x = Cos * length;
	positionR.y = Sin * length;

	DrawRect = GSYS.DrawSetting.DrawArea ;
	if( Scale != 1.0 )
	{
		GaugeDrawRect.left   = CenterX - _DTOL( SizeX * Scale ) / 2 - 1 ;
		GaugeDrawRect.top    = CenterY - _DTOL( SizeY * Scale ) / 2 - 1 ;
		GaugeDrawRect.right  = CenterX + _DTOL( SizeX * Scale ) / 2 + 1 ;
		GaugeDrawRect.bottom = CenterY + _DTOL( SizeY * Scale ) / 2 + 1 ;
	}
	else
	{
		GaugeDrawRect.left   = CenterX - SizeX / 2 ;
		GaugeDrawRect.top    = CenterY - SizeY / 2 ;
		GaugeDrawRect.right  = CenterX + SizeX / 2 ;
		GaugeDrawRect.bottom = CenterY + SizeY / 2 ;
	}
	RectClipping_Inline( &GaugeDrawRect, &DrawRect ) ;
	NS_SetDrawArea( GaugeDrawRect.left, GaugeDrawRect.top, GaugeDrawRect.right, GaugeDrawRect.bottom ) ; 

	// 90x`
	for( i = 0 ; i < 12 ; i ++ )
	{
		StartRad = DX_PI_F * 0.5f * ( i - 4 ) ;
		EndRad   = DX_PI_F * 0.5f * ( i - 4 + 1 ) ;

		if( ( radian2 >= StartRad && radian2 <= EndRad ) || ( StartRad >= radian2 && StartRad <= radian ) )
		{
			vertex[1] = radian2 <= StartRad ? position[ i         % 4 ] : positionR2;
			vertex[2] = radian  >= EndRad   ? position[ ( i + 1 ) % 4 ] : positionR;
			DrawCircleGaugePolygon( GrHandle, CenterXF, CenterYF, vertex, SizeR, UScale, VScale, UStart, VStart, ReverseX, ReverseY );
		}
	}

	// `\͈͂ɖ߂
	NS_SetDrawArea( DrawRect.left, DrawRect.top, DrawRect.right, DrawRect.bottom ) ;

	// I
	return 0;
}

// ~OtIȕ`s
int NS_DrawCircleGaugeF( float CenterX, float CenterY, double Percent, int GrHandle, double StartPercent , double Scale, int ReverseX, int ReverseY )
{
	VECTOR vertex[3] ;
	VECTOR position[4] ;
	VECTOR positionR ;
	VECTOR positionR2 ;
	float radian ;
	float radian2 ;
	float length ;
	float Sin ;
	float Cos ;
	float CenterXF ;
	float CenterYF ;
	float SizeR ;
	int SizeX ;
	int SizeY ;
	int i ;
	float StartRad ;
	float EndRad ;
	IMAGEDATA *Image ;
	float UScale ;
	float VScale ;
	float UStart ;
	float VStart ;
	RECT DrawRect ;
	RECT GaugeDrawRect ;

	Image = Graphics_Image_GetData( GrHandle ) ;
	if( Image == NULL )
	{
		return -1 ;
	}

	if( Image->Orig->FormatDesc.TextureFlag )
	{
		UStart = ( float )Image->Hard.Draw[ 0 ].UsePosXF / Image->Hard.Draw[ 0 ].Tex->TexWidth ;
		VStart = ( float )Image->Hard.Draw[ 0 ].UsePosYF / Image->Hard.Draw[ 0 ].Tex->TexHeight ;
		UScale = ( float )Image->WidthF                  / Image->Hard.Draw[ 0 ].Tex->TexWidth ;
		VScale = ( float )Image->HeightF                 / Image->Hard.Draw[ 0 ].Tex->TexHeight ;
	}
	else
	{
		UScale = 1.0f ;
		VScale = 1.0f ;
		UStart = 0.0f ;
		VStart = 0.0f ;
	}

	if( StartPercent > 200.0 )
	{
		StartPercent = 200.0 ;
	}
	else
	if( StartPercent < -100.0 )
	{
		StartPercent = -100.0 ;
	}

	if( Percent > 200.0 )
	{
		Percent = 200.0 ;
	}
	else
	if( Percent < -100.0 )
	{
		Percent = -100.0 ;
	}

	if( Percent - StartPercent > 100.0 )
	{
		StartPercent = 0.0 ;
		Percent = 100.0 ;
	}

	if( StartPercent == Percent ||
		StartPercent > Percent )
	{
		return 0 ;
	}

	NS_GetGraphSize( GrHandle, &SizeX, &SizeY );

	radian   = ( float )( Percent      * 2 * DX_PI / 100.0 );
	radian2  = ( float )( StartPercent * 2 * DX_PI / 100.0 );
	length   = ( float )( SizeX * Scale * 0.75f ) ;
	CenterXF = ( float )CenterX;
	CenterYF = ( float )CenterY;
	SizeR    = ( float )( 1.0f / ( SizeX * Scale ) ) ;

	vertex[0].x = 0.0f;
	vertex[0].y = 0.0f;
	vertex[1] = vertex[0];
	vertex[2] = vertex[0];

	position[0].x = 0.0f;
	position[0].y = -length;

	position[1].x = length;
	position[1].y = 0.0f;

	position[2].x = 0.0f;
	position[2].y = length;

	position[3].x = -length;
	position[3].y = 0.0f;

	_SINCOS_PLATFORM( radian2 - DX_PI_F * 0.5f, &Sin, &Cos ) ;
	positionR2.x = Cos * length;
	positionR2.y = Sin * length;

	_SINCOS_PLATFORM( radian - DX_PI_F * 0.5f, &Sin, &Cos ) ;
	positionR.x = Cos * length;
	positionR.y = Sin * length;

	DrawRect = GSYS.DrawSetting.DrawArea ;
	if( Scale != 1.0 )
	{
		GaugeDrawRect.left   = _FTOL( CenterX ) - _DTOL( SizeX * Scale ) / 2 - 2 ;
		GaugeDrawRect.top    = _FTOL( CenterY ) - _DTOL( SizeY * Scale ) / 2 - 2 ;
		GaugeDrawRect.right  = _FTOL( CenterX ) + _DTOL( SizeX * Scale ) / 2 + 2 ;
		GaugeDrawRect.bottom = _FTOL( CenterY ) + _DTOL( SizeY * Scale ) / 2 + 2 ;
	}
	else
	{
		GaugeDrawRect.left   = _FTOL( CenterX ) - SizeX / 2 - 2 ;
		GaugeDrawRect.top    = _FTOL( CenterY ) - SizeY / 2 - 2 ;
		GaugeDrawRect.right  = _FTOL( CenterX ) + SizeX / 2 + 2 ;
		GaugeDrawRect.bottom = _FTOL( CenterY ) + SizeY / 2 + 2 ;
	}
	RectClipping_Inline( &GaugeDrawRect, &DrawRect ) ;
	NS_SetDrawArea( GaugeDrawRect.left, GaugeDrawRect.top, GaugeDrawRect.right, GaugeDrawRect.bottom ) ; 

	// 90x`
	for( i = 0 ; i < 12 ; i ++ )
	{
		StartRad = DX_PI_F * 0.5f * ( i - 4 ) ;
		EndRad   = DX_PI_F * 0.5f * ( i - 4 + 1 ) ;

		if( ( radian2 >= StartRad && radian2 <= EndRad ) || ( StartRad >= radian2 && StartRad <= radian ) )
		{
			vertex[1] = radian2 <= StartRad ? position[ i         % 4 ] : positionR2;
			vertex[2] = radian  >= EndRad   ? position[ ( i + 1 ) % 4 ] : positionR;
			DrawCircleGaugePolygon( GrHandle, CenterXF, CenterYF, vertex, SizeR, UScale, VScale, UStart, VStart, ReverseX, ReverseY );
		}
	}

	// `\͈͂ɖ߂
	NS_SetDrawArea( DrawRect.left, DrawRect.top, DrawRect.right, DrawRect.bottom ) ;

	// I
	return 0;
}

static struct
{
	float DrawZ;
	int BlendMode, BlendParam;
	int AlphaTestMode, AlphaTestParam;
	int ZBufferCmpType2D, WriteZBufferFlag2D;
	int ZBufferCmpType3D, WriteZBufferFlag3D;
} DrawZBuffer_Static;

static void FASTCALL DrawZBuffer_Pre( int WriteZMode )
{
	DrawZBuffer_Static.DrawZ              = GSYS.DrawSetting.DrawZ;
	DrawZBuffer_Static.BlendMode          = GSYS.DrawSetting.BlendMode;
	DrawZBuffer_Static.BlendParam         = GSYS.DrawSetting.BlendParam;
	DrawZBuffer_Static.AlphaTestMode      = GSYS.DrawSetting.AlphaTestMode;
	DrawZBuffer_Static.AlphaTestParam     = GSYS.DrawSetting.AlphaTestParam;
	DrawZBuffer_Static.WriteZBufferFlag2D = GSYS.DrawSetting.WriteZBufferFlag2D;
	DrawZBuffer_Static.WriteZBufferFlag3D = GSYS.DrawSetting.WriteZBufferFlag3D;
	DrawZBuffer_Static.ZBufferCmpType2D   = GSYS.DrawSetting.ZBufferCmpType2D;
	DrawZBuffer_Static.ZBufferCmpType3D   = GSYS.DrawSetting.ZBufferCmpType3D;

	NS_SetDrawZ( WriteZMode == DX_ZWRITE_MASK ? 0.0f : 0.9f );
	NS_SetDrawBlendMode( DX_BLENDMODE_DESTCOLOR, 255 );
	NS_SetDrawAlphaTest( DX_CMP_GREATER, 0 );
	NS_SetWriteZBufferFlag( TRUE );
	NS_SetZBufferCmpType( DX_CMP_ALWAYS );
}

static void FASTCALL DrawZBuffer_Post( void )
{
	NS_SetZBufferCmpType( DrawZBuffer_Static.ZBufferCmpType2D );
	NS_SetWriteZBufferFlag( DrawZBuffer_Static.WriteZBufferFlag2D );
	NS_SetDrawAlphaTest( DrawZBuffer_Static.AlphaTestMode, DrawZBuffer_Static.AlphaTestParam );
	NS_SetDrawBlendMode( DrawZBuffer_Static.BlendMode, DrawZBuffer_Static.BlendParam );
	NS_SetDrawZ( DrawZBuffer_Static.DrawZ );

	NS_SetZBufferCmpType3D( DrawZBuffer_Static.ZBufferCmpType3D );
	NS_SetWriteZBuffer3D( DrawZBuffer_Static.WriteZBufferFlag3D );
}

// yobt@ɑ΂ĉ摜̕`s
extern	int NS_DrawGraphToZBuffer( int X, int Y, int GrHandle, int WriteZMode )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawGraph( X, Y, GrHandle, TRUE );
	DrawZBuffer_Post();

	// I
	return 0 ;
}

// yobt@ɑ΂ĉ摜̍E]`
extern	int NS_DrawTurnGraphToZBuffer( int x, int y, int GrHandle, int WriteZMode /* DX_ZWRITE_MASK  */ )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawTurnGraph( x, y, GrHandle, TRUE );
	DrawZBuffer_Post();

	// I
	return 0 ;
}

// yobt@ɑ΂ĉ摜̔]`
extern int NS_DrawReverseGraphToZBuffer( int x, int y, int GrHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , int ReverseXFlag, int ReverseYFlag )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawReverseGraph( x, y, GrHandle, TRUE, ReverseXFlag, ReverseYFlag );
	DrawZBuffer_Post();

	// I
	return 0 ;
}

// yobt@ɑ΂ĉ摜̊gk`
extern	int NS_DrawExtendGraphToZBuffer( int x1, int y1, int x2, int y2, int GrHandle, int WriteZMode /* DX_ZWRITE_MASK  */ )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawExtendGraph( x1, y1, x2, y2, GrHandle, TRUE );
	DrawZBuffer_Post();

	// I
	return 0 ;
}

// yobt@ɑ΂ĉ摜̉]`
extern	int NS_DrawRotaGraphToZBuffer( int x, int y, double ExRate, double Angle, int GrHandle, int WriteZMode /* DX_ZWRITE_MASK  */, int ReverseXFlag, int ReverseYFlag )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawRotaGraph(  x,  y,  ExRate,  Angle,  GrHandle,  TRUE, ReverseXFlag, ReverseYFlag );
	DrawZBuffer_Post();

	// I
	return 0 ;
}

// yobt@ɑ΂ĉ摜̉]`Q
extern	int NS_DrawRotaGraph2ToZBuffer(  int x, int y, int cx, int cy, double ExtRate,                   double Angle, int GrHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , int ReverseXFlag, int ReverseYFlag )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawRotaGraph2( x,  y,  cx,  cy,  ExtRate,  Angle,  GrHandle,  TRUE, ReverseXFlag, ReverseYFlag ) ;
	DrawZBuffer_Post();

	// I
	return 0 ;
}

// yobt@ɑ΂ĉ摜̉]`R
extern	int NS_DrawRotaGraph3ToZBuffer(  int x, int y, int cx, int cy, double ExtRateX, double ExtRateY, double Angle, int GrHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , int ReverseXFlag, int ReverseYFlag )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawRotaGraph3(   x,  y,  cx,  cy,  ExtRateX,  ExtRateY,  Angle,  GrHandle, TRUE, ReverseXFlag, ReverseYFlag );
	DrawZBuffer_Post();

	// I
	return 0 ;
}

// yobt@ɑ΂ĉ摜̉]`A
extern	int NS_DrawRotaGraphFastToZBuffer( int x, int y, float ExRate, float Angle, int GrHandle, int WriteZMode /* DX_ZWRITE_MASK  */, int ReverseXFlag, int ReverseYFlag )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawRotaGraphFast(  x,  y,  ExRate,  Angle,  GrHandle,  TRUE, ReverseXFlag, ReverseYFlag );
	DrawZBuffer_Post();

	// I
	return 0 ;
}

// yobt@ɑ΂ĉ摜̉]`QA
extern	int NS_DrawRotaGraphFast2ToZBuffer(  int x, int y, int cx, int cy, float ExtRate,                   float Angle, int GrHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , int ReverseXFlag, int ReverseYFlag )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawRotaGraphFast2( x,  y,  cx,  cy,  ExtRate,  Angle,  GrHandle,  TRUE, ReverseXFlag, ReverseYFlag ) ;
	DrawZBuffer_Post();

	// I
	return 0 ;
}

// yobt@ɑ΂ĉ摜̉]`RA
extern	int NS_DrawRotaGraphFast3ToZBuffer(  int x, int y, int cx, int cy, float ExtRateX, float ExtRateY, float Angle, int GrHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , int ReverseXFlag, int ReverseYFlag )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawRotaGraphFast3(   x,  y,  cx,  cy,  ExtRateX,  ExtRateY,  Angle,  GrHandle, TRUE, ReverseXFlag, ReverseYFlag );
	DrawZBuffer_Post();

	// I
	return 0 ;
}

// yobt@ɑ΂ĉ摜̎Rό``
extern	int NS_DrawModiGraphToZBuffer( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int GrHandle, int WriteZMode /* DX_ZWRITE_MASK  */ )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawModiGraph(  x1,  y1,  x2,  y2,  x3,  y3,  x4,  y4,  GrHandle,  TRUE );
	DrawZBuffer_Post();

	// I
	return 0 ;
}

// yobt@ɑ΂ċ`̕`s
extern int NS_DrawBoxToZBuffer( int x1, int y1, int x2, int y2, int FillFlag, int WriteZMode /* DX_ZWRITE_MASK  */ )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawBox( x1, y1, x2, y2, NS_GetColor(255,255,255), FillFlag );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ĉ~̕`s
extern int NS_DrawCircleToZBuffer( int x, int y, int r, int FillFlag, int WriteZMode /* DX_ZWRITE_MASK  */ )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawCircle( x, y, r, GetColor(255,255,255), FillFlag, 1 );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ĎOp``悷
extern int NS_DrawTriangleToZBuffer( int x1, int y1, int x2, int y2, int x3, int y3, int FillFlag, int WriteZMode /* DX_ZWRITE_MASK  */ )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawTriangle( x1, y1, x2, y2, x3, y3, GetColor(255,255,255), FillFlag ) ;
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂Ďlp``悷
extern int NS_DrawQuadrangleToZBuffer(  int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int FillFlag, int WriteZMode /* DX_ZWRITE_MASK  */ )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawQuadrangle( x1, y1, x2, y2, x3, y3, x4, y4, GetColor(255,255,255), FillFlag ) ;
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂Ċp̊ۂlp``悷
extern int NS_DrawRoundRectToZBuffer(   int x1, int y1, int x2, int y2, int rx, int ry, int FillFlag, int WriteZMode /* DX_ZWRITE_MASK  */ )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawRoundRect( x1, y1, x2, y2, rx, ry, GetColor(255,255,255), FillFlag ) ;
	DrawZBuffer_Post();

	// I
	return 0;
}

// Qc|S`悷
extern	int NS_DrawPolygon( const VERTEX *Vertex, int PolygonNum, int GrHandle, int TransFlag, int UVScaling )
{
	return NS_DrawPolygonBase( Vertex, PolygonNum * 3, DX_PRIMTYPE_TRIANGLELIST, GrHandle, TransFlag,  UVScaling ) ;
}

// Qc|S`悷
extern int NS_DrawPolygon2D( const VERTEX2D *Vertex, int PolygonNum, int GrHandle, int TransFlag )
{
	return NS_DrawPrimitive2D( Vertex, PolygonNum * 3, DX_PRIMTYPE_TRIANGLELIST, GrHandle, TransFlag ) ;
}

#ifndef DX_COMPILE_TYPE_C_LANGUAGE
// Rc|S`悷
extern	int NS_DrawPolygon3D( const VERTEX_3D *Vertex, int PolygonNum, int GrHandle, int TransFlag )
{
	return NS_DrawPolygon3D2( Vertex, PolygonNum, GrHandle, TransFlag ) ;
}
#endif // DX_COMPILE_TYPE_C_LANGUAGE

// Rc|S`悷
extern	int NS_DrawPolygon3D2( const VERTEX_3D *Vertex, int PolygonNum, int GrHandle, int TransFlag )
{
	return NS_DrawPolygon3DBase( Vertex, PolygonNum * 3, DX_PRIMTYPE_TRIANGLELIST, GrHandle, TransFlag ) ;
}

// Qc|S`悷( _CfbNXgp )
extern int NS_DrawPolygonIndexed2D( const VERTEX2D  *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum, int GrHandle, int TransFlag )
{
	return NS_DrawPrimitiveIndexed2D( Vertex, VertexNum, Indices, PolygonNum * 3, DX_PRIMTYPE_TRIANGLELIST, GrHandle, TransFlag ) ;
}

// Rc|S`悷(CfbNX)
extern int NS_DrawPolygonIndexed3D( const VERTEX3D *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum, int GrHandle, int TransFlag )
{
	return NS_DrawPrimitiveIndexed3D( Vertex, VertexNum, Indices, PolygonNum * 3, DX_PRIMTYPE_TRIANGLELIST, GrHandle, TransFlag ) ;
}

// Rc|S`悷(CfbNX)
extern	int NS_DrawPolygonIndexed3DBase( const VERTEX_3D *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType, int GrHandle, int TransFlag )
{
	IMAGEDATA *Image ;
	int Ret, i, Flag ;
	const VERTEX_3D *UseVertex ;

	Ret = -1;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	Image = NULL ;
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image ) )
			return -1 ;
		Flag = Image->Orig->FormatDesc.TextureFlag ;
	}
	else
	{
		Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;
	}

#ifndef DX_NON_MOVIE
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( Image->Orig->MovieHandle != -1 )
			UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
	}
#endif

	// Rcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware3DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib3DMatrixToHardware() ;

	// F̕ϊKvȏꍇ͂ŏ
	if( GSYS.DrawSetting.DrawBright.Red   != 255 ||
		GSYS.DrawSetting.DrawBright.Green != 255 ||
		GSYS.DrawSetting.DrawBright.Blue  != 255 ||
		( GSYS.DrawSetting.BlendMode != DX_BLENDMODE_NOBLEND && GSYS.DrawSetting.BlendParam != 255 ) )
	{
		DWORD *RedTable, *GreenTable, *BlueTable, *AlphaTable ;
		const VERTEX_3D *sv ;
		VERTEX_3D *dv ;
		unsigned int Size ;

		// e[upӂ
		RedTable   = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Red] ;
		GreenTable = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Green] ;
		BlueTable  = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Blue] ;
		AlphaTable = MemImgManage.RateTable[GSYS.DrawSetting.BlendParam] ;
		if( GSYS.DrawSetting.BlendMode == DX_BLENDMODE_NOBLEND ) AlphaTable = MemImgManage.RateTable[255] ;

		// _f[^i[郁̈悪Ȃꍇ͊mۂ
		Size = sizeof( VERTEX_3D ) * VertexNum ;
		if( GSYS.Resource.TempVertexBufferSize < ( int )Size )
		{
			if( GSYS.Resource.TempVertexBuffer )
			{
				DXFREE( GSYS.Resource.TempVertexBuffer ) ;
				GSYS.Resource.TempVertexBufferSize = 0 ;
			}
			GSYS.Resource.TempVertexBuffer = DXALLOC( Size ) ;
			if( GSYS.Resource.TempVertexBuffer == NULL )
				return -1 ;
			GSYS.Resource.TempVertexBufferSize = ( int )Size ;
		}

		// ꎞobt@ɕϊȂ]
		sv = Vertex;
		dv = ( VERTEX_3D * )GSYS.Resource.TempVertexBuffer ;
		for( i = 0 ; i < VertexNum ; i ++, sv ++, dv ++ )
		{
			dv->pos = sv->pos ;
			dv->u = sv->u ;
			dv->v = sv->v ;
			dv->b = ( BYTE )BlueTable [ sv->b ] ;
			dv->g = ( BYTE )GreenTable[ sv->g ] ;
			dv->r = ( BYTE )RedTable  [ sv->r ] ;
			dv->a = ( BYTE )AlphaTable[ sv->a ] ;
		}
		UseVertex = ( VERTEX_3D * )GSYS.Resource.TempVertexBuffer ;
	}
	else
	{
		UseVertex = Vertex ;
	}
	
	DRAW_DEF(
		Graphics_Hardware_DrawIndexedPrimitive_PF( UseVertex, VertexNum, Indices, IndexNum, PrimitiveType, Image, TransFlag ),
		0,
		DrawRect = GSYS.DrawSetting.DrawArea ;,
		Ret,
		Flag
	)

	return Ret ;
}

// Rc|S`悷
extern	int NS_DrawPolygon3DBase( const VERTEX_3D *Vertex, int VertexNum, int PrimitiveType, int GrHandle, int TransFlag )
{
	IMAGEDATA *Image ;
	int Ret, i, Flag ;
	const VERTEX_3D *UseVertex ;

	Ret = -1;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	Image = NULL ;
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image ) )
			return -1 ;
		Flag = Image->Orig->FormatDesc.TextureFlag ;
	}
	else
	{
		Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;
	}

#ifndef DX_NON_MOVIE
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( Image->Orig->MovieHandle != -1 )
			UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
	}
#endif

	// Rcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware3DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib3DMatrixToHardware() ;

	// F̕ϊKvȏꍇ͂ŏ
	if( GSYS.DrawSetting.DrawBright.Red   != 255 ||
		GSYS.DrawSetting.DrawBright.Green != 255 ||
		GSYS.DrawSetting.DrawBright.Blue  != 255 ||
		( GSYS.DrawSetting.BlendMode != DX_BLENDMODE_NOBLEND && GSYS.DrawSetting.BlendParam != 255 ) )
	{
		DWORD *RedTable, *GreenTable, *BlueTable, *AlphaTable ;
		const VERTEX_3D *sv ;
		VERTEX_3D *dv ;
		unsigned int Size ;

		// e[upӂ
		RedTable   = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Red] ;
		GreenTable = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Green] ;
		BlueTable  = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Blue] ;
		AlphaTable = MemImgManage.RateTable[GSYS.DrawSetting.BlendParam] ;
		if( GSYS.DrawSetting.BlendMode == DX_BLENDMODE_NOBLEND ) AlphaTable = MemImgManage.RateTable[255] ;

		// _f[^i[郁̈悪Ȃꍇ͊mۂ
		Size = sizeof( VERTEX_3D ) * VertexNum ;
		if( GSYS.Resource.TempVertexBufferSize < ( int )Size )
		{
			if( GSYS.Resource.TempVertexBuffer )
			{
				DXFREE( GSYS.Resource.TempVertexBuffer ) ;
				GSYS.Resource.TempVertexBufferSize = 0 ;
			}
			GSYS.Resource.TempVertexBuffer = DXALLOC( Size ) ;
			if( GSYS.Resource.TempVertexBuffer == NULL )
				return -1 ;
			GSYS.Resource.TempVertexBufferSize = ( int )Size ;
		}

		// ꎞobt@ɕϊȂ]
		sv = Vertex;
		dv = ( VERTEX_3D * )GSYS.Resource.TempVertexBuffer ;
		for( i = 0 ; i < VertexNum ; i ++, sv ++, dv ++ )
		{
			dv->pos = sv->pos ;
			dv->u = sv->u ;
			dv->v = sv->v ;
			dv->b = ( BYTE )BlueTable [ sv->b ] ;
			dv->g = ( BYTE )GreenTable[ sv->g ] ;
			dv->r = ( BYTE )RedTable  [ sv->r ] ;
			dv->a = ( BYTE )AlphaTable[ sv->a ] ;
		}
		UseVertex = ( VERTEX_3D * )GSYS.Resource.TempVertexBuffer ;
	}
	else
	{
		UseVertex = Vertex ;
	}
	
	DRAW_DEF(
		Graphics_Hardware_DrawPrimitive_PF( UseVertex, VertexNum, PrimitiveType, Image, TransFlag ),
		0,
		DrawRect = GSYS.DrawSetting.DrawArea ;,
		Ret,
		Flag
	)

	return Ret ;
}

// Rc|S`悷
extern int NS_DrawPolygon3D( const VERTEX3D *Vertex, int PolygonNum, int GrHandle, int TransFlag )
{
	return NS_DrawPrimitive3D( Vertex, PolygonNum * 3, DX_PRIMTYPE_TRIANGLELIST, GrHandle, TransFlag ) ;
}

// Qc|S`悷
#define SETDRAWRECTCODE\
	float MinX, MinY, MaxX, MaxY ;\
	const VERTEX_2D *Vert ;\
\
	MinX =  100000000.0F ;\
	MinY =  100000000.0F ;\
	MaxX = -100000000.0F ;\
	MaxY = -100000000.0F ;\
	Vert = TransVert ;\
	for( i = 0 ; i < VertexNum ; i ++, Vert ++ )\
	{\
		if( Vert->pos.x - 1.0F < MinX ) MinX = Vert->pos.x - 1.0F ;\
		if( Vert->pos.x + 1.0F > MaxX ) MaxX = Vert->pos.x + 1.0F ;\
\
		if( Vert->pos.y - 1.0F < MinY ) MinY = Vert->pos.y - 1.0F ;\
		if( Vert->pos.y + 1.0F > MaxY ) MaxY = Vert->pos.y + 1.0F ;\
	}\
\
	DrawRect.left   = _FTOL( MinX ) ;\
	DrawRect.top    = _FTOL( MinY ) ;\
	DrawRect.right  = _FTOL( MaxX ) ;\
	DrawRect.bottom = _FTOL( MaxY ) ;\
	DRAWRECT_DRAWAREA_CLIP

extern	int NS_DrawPolygonBase( const VERTEX *Vertex, int VertexNum, int PrimitiveType, int GrHandle, int TransFlag, int UVScaling )
{
	IMAGEDATA *Image ;
	VERTEX_2D *TransVert = NULL ;
	VERTEX_2D *DestP ;
	int Ret, i, Flag ;
	float UPos = 0.0f, VPos = 0.0f, UScale = 1.0f, VScale = 1.0f ;

	Ret = -1;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	Image = NULL ;
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image ) )
			return -1 ;

		Flag = Image->Orig->FormatDesc.TextureFlag ;

		// 摜̃TCYŏQ̂悾tu␳͂Ȃ
		if( UVScaling )
		{
			if( Image->Orig->FormatDesc.TextureFlag == FALSE ||
				( Image->Hard.DrawNum == 1 && 
				  Image->Hard.Draw->Tex->TexWidth  == Image->Hard.Draw->WidthI  &&
				  Image->Hard.Draw->Tex->TexHeight == Image->Hard.Draw->HeightI ) )
			{
				UVScaling = FALSE ;
			}
		}
	}
	else
	{
		Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;
		UVScaling = FALSE ;
	}

#ifndef DX_NON_MOVIE
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( Image->Orig->MovieHandle != -1 )
			UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
	}
#endif

	// UVXP[Osꍇ͂Ńf[^Zo
	if( UVScaling )
	{
		UPos   = Image->Hard.Draw->UsePosXF / Image->Hard.Draw->Tex->TexWidth ;
		VPos   = Image->Hard.Draw->UsePosYF / Image->Hard.Draw->Tex->TexHeight ;
		UScale = Image->Hard.Draw->WidthF   / Image->Hard.Draw->Tex->TexWidth ;
		VScale = Image->Hard.Draw->HeightF  / Image->Hard.Draw->Tex->TexHeight ;
	}

	// _̏o͐mۂ
	TransVert = ( VERTEX_2D * )DXALLOC( sizeof( VERTEX_2D ) * VertexNum ) ;
	if( TransVert == NULL ) return -1 ;

	// _ϊs
	if( GSYS.DrawSetting.DrawBright.Red != 255 || GSYS.DrawSetting.DrawBright.Green != 255 || GSYS.DrawSetting.DrawBright.Blue != 255 ||
		( GSYS.DrawSetting.BlendMode != DX_BLENDMODE_NOBLEND && GSYS.DrawSetting.BlendParam != 255 ) )
	{
		DWORD *RedTable, *GreenTable, *BlueTable, *AlphaTable ;

		// e[upӂ
		RedTable   = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Red] ;
		GreenTable = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Green] ;
		BlueTable  = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Blue] ;
		AlphaTable = MemImgManage.RateTable[GSYS.DrawSetting.BlendParam] ;
		if( GSYS.DrawSetting.BlendMode == DX_BLENDMODE_NOBLEND ) AlphaTable = MemImgManage.RateTable[255] ;

		// _ϊ
		if( UVScaling )
		{
			DestP = TransVert ;
			for( i = 0 ; i < VertexNum ; i ++, DestP ++, Vertex ++ )
			{
				DestP->pos.x = Vertex->x ;
				DestP->pos.y = Vertex->y ;
				DestP->pos.z = GSYS.DrawSetting.DrawZ ;
				DestP->rhw = 1.0F ;
				((BYTE *)&DestP->color)[0] = (BYTE)BlueTable [Vertex->b] ;
				((BYTE *)&DestP->color)[1] = (BYTE)GreenTable[Vertex->g] ;
				((BYTE *)&DestP->color)[2] = (BYTE)RedTable  [Vertex->r] ;
				((BYTE *)&DestP->color)[3] = (BYTE)AlphaTable[Vertex->a] ;
				DestP->u = Vertex->u * UScale + UPos ;
				DestP->v = Vertex->v * VScale + VPos ;
			}
		}
		else
		{
			DestP = TransVert ;
			for( i = 0 ; i < VertexNum ; i ++, DestP ++, Vertex ++ )
			{
				DestP->pos.x = Vertex->x ;
				DestP->pos.y = Vertex->y ;
				DestP->pos.z = GSYS.DrawSetting.DrawZ ;
				DestP->rhw = 1.0F ;
				((BYTE *)&DestP->color)[0] = (BYTE)BlueTable [Vertex->b] ;
				((BYTE *)&DestP->color)[1] = (BYTE)GreenTable[Vertex->g] ;
				((BYTE *)&DestP->color)[2] = (BYTE)RedTable  [Vertex->r] ;
				((BYTE *)&DestP->color)[3] = (BYTE)AlphaTable[Vertex->a] ;
				DestP->u = Vertex->u ;
				DestP->v = Vertex->v ;
			}
		}
	}
	else
	{
		// _ϊ
		if( UVScaling )
		{
			DestP = TransVert ;
			for( i = 0 ; i < VertexNum ; i ++, DestP ++, Vertex ++ )
			{
				DestP->pos.x = Vertex->x ;
				DestP->pos.y = Vertex->y ;
				DestP->pos.z = GSYS.DrawSetting.DrawZ ;
				DestP->rhw = 1.0F ;
				DestP->color = *( ( DWORD * )&Vertex->b ) ;
				DestP->u = Vertex->u * UScale + UPos ;
				DestP->v = Vertex->v * VScale + VPos ;
			}
		}
		else
		{
			DestP = TransVert ;
			for( i = 0 ; i < VertexNum ; i ++, DestP ++, Vertex ++ )
			{
				DestP->pos.x = Vertex->x ;
				DestP->pos.y = Vertex->y ;
				DestP->pos.z = GSYS.DrawSetting.DrawZ ;
				DestP->rhw = 1.0F ;
				DestP->color = *( ( DWORD * )&Vertex->b ) ;
				DestP->u = Vertex->u ;
				DestP->v = Vertex->v ;
			}
		}
	}

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	DRAW_DEF(
		Graphics_Hardware_DrawPrimitive2D_PF( TransVert, VertexNum, PrimitiveType, Image, TransFlag, FALSE, FALSE, FALSE, FALSE, 0, FALSE ),
		0,
		SETDRAWRECTCODE,
		Ret,
		Flag
	)

	if( TransVert != NULL )
	{
		DXFREE( TransVert ) ;
		TransVert = NULL ;
	}

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE

// Qcv~eBu`悷
extern int NS_DrawPrimitive2D( const VERTEX2D *Vertex, int VertexNum, int PrimitiveType, int GrHandle, int TransFlag )
{
	IMAGEDATA *Image ;
	int Ret, i, Flag ;
	const VERTEX2D *UseVertex ;

	Ret = -1;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	Image = NULL ;
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image ) )
			return -1 ;
		Flag = Image->Orig->FormatDesc.TextureFlag ;
	}
	else
	{
		Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;
	}

#ifndef DX_NON_MOVIE
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( Image->Orig->MovieHandle != -1 )
			UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
	}
#endif

	// F̕ϊKvȏꍇ͂ŏ
	if( GSYS.DrawSetting.DrawBright.Red   != 255 ||
		GSYS.DrawSetting.DrawBright.Green != 255 ||
		GSYS.DrawSetting.DrawBright.Blue  != 255 ||
		( GSYS.DrawSetting.BlendMode != DX_BLENDMODE_NOBLEND && GSYS.DrawSetting.BlendParam != 255 ) )
	{
		DWORD *RedTable, *GreenTable, *BlueTable, *AlphaTable ;
		const VERTEX2D *sv ;
		VERTEX2D *dv ;
		unsigned int Size ;

		// e[upӂ
		RedTable   = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Red] ;
		GreenTable = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Green] ;
		BlueTable  = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Blue] ;
		AlphaTable = MemImgManage.RateTable[GSYS.DrawSetting.BlendParam] ;
		if( GSYS.DrawSetting.BlendMode == DX_BLENDMODE_NOBLEND ) AlphaTable = MemImgManage.RateTable[255] ;

		// _f[^i[郁̈悪Ȃꍇ͊mۂ
		Size = sizeof( VERTEX2D ) * VertexNum ;
		if( GSYS.Resource.TempVertexBufferSize < ( int )Size )
		{
			if( GSYS.Resource.TempVertexBuffer )
			{
				DXFREE( GSYS.Resource.TempVertexBuffer ) ;
				GSYS.Resource.TempVertexBufferSize = 0 ;
			}
			GSYS.Resource.TempVertexBuffer = DXALLOC( Size ) ;
			if( GSYS.Resource.TempVertexBuffer == NULL )
				return -1 ;
			GSYS.Resource.TempVertexBufferSize = ( int )Size ;
		}

		// ꎞobt@ɕϊȂ]
		sv = Vertex;
		dv = ( VERTEX2D * )GSYS.Resource.TempVertexBuffer ;
		for( i = 0 ; i < VertexNum ; i ++, sv ++, dv ++ )
		{
			dv->pos = sv->pos ;
			dv->rhw = sv->rhw ;
			dv->dif.b = ( BYTE )BlueTable [ sv->dif.b ] ;
			dv->dif.g = ( BYTE )GreenTable[ sv->dif.g ] ;
			dv->dif.r = ( BYTE )RedTable  [ sv->dif.r ] ;
			dv->dif.a = ( BYTE )AlphaTable[ sv->dif.a ] ;
			dv->u = sv->u ;
			dv->v = sv->v ;
		}
		UseVertex = ( VERTEX2D * )GSYS.Resource.TempVertexBuffer ;
	}
	else
	{
		UseVertex = Vertex ;
	}

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;
	
	DRAW_DEF(
		Graphics_Hardware_DrawPrimitive2DUser_PF( UseVertex, VertexNum, PrimitiveType, Image, TransFlag, FALSE, FALSE, FALSE, 0 ),
		0,
		DrawRect = GSYS.DrawSetting.DrawArea ;,
		Ret,
		Flag
	)

	return Ret ;
}

// Rc|S`悷
extern int NS_DrawPrimitive3D( const VERTEX3D *Vertex, int VertexNum, int PrimitiveType, int GrHandle, int TransFlag )
{
	IMAGEDATA *Image ;
	int Ret, i, Flag ;
	const VERTEX3D *UseVertex ;

	Ret = -1;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	Image = NULL ;
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image ) )
			return -1 ;
		Flag = Image->Orig->FormatDesc.TextureFlag ;
	}
	else
	{
		Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;
	}

#ifndef DX_NON_MOVIE
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( Image->Orig->MovieHandle != -1 )
			UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
	}
#endif

	// Rcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware3DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib3DMatrixToHardware() ;

	// F̕ϊKvȏꍇ͂ŏ
	if( GSYS.DrawSetting.DrawBright.Red   != 255 ||
		GSYS.DrawSetting.DrawBright.Green != 255 ||
		GSYS.DrawSetting.DrawBright.Blue  != 255 ||
		( GSYS.DrawSetting.BlendMode != DX_BLENDMODE_NOBLEND && GSYS.DrawSetting.BlendParam != 255 ) )
	{
		DWORD *RedTable, *GreenTable, *BlueTable, *AlphaTable ;
		const VERTEX3D *sv ;
		VERTEX3D *dv ;
		unsigned int Size ;

		// e[upӂ
		RedTable   = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Red] ;
		GreenTable = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Green] ;
		BlueTable  = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Blue] ;
		AlphaTable = MemImgManage.RateTable[GSYS.DrawSetting.BlendParam] ;
		if( GSYS.DrawSetting.BlendMode == DX_BLENDMODE_NOBLEND ) AlphaTable = MemImgManage.RateTable[255] ;

		// _f[^i[郁̈悪Ȃꍇ͊mۂ
		Size = sizeof( VERTEX3D ) * VertexNum ;
		if( GSYS.Resource.TempVertexBufferSize < ( int )Size )
		{
			if( GSYS.Resource.TempVertexBuffer )
			{
				DXFREE( GSYS.Resource.TempVertexBuffer ) ;
				GSYS.Resource.TempVertexBufferSize = 0 ;
			}
			GSYS.Resource.TempVertexBuffer = DXALLOC( Size ) ;
			if( GSYS.Resource.TempVertexBuffer == NULL )
				return -1 ;
			GSYS.Resource.TempVertexBufferSize = ( int )Size ;
		}

		// ꎞobt@ɕϊȂ]
		sv = Vertex;
		dv = ( VERTEX3D * )GSYS.Resource.TempVertexBuffer ;
		for( i = 0 ; i < VertexNum ; i ++, sv ++, dv ++ )
		{
			dv->pos = sv->pos ;
			dv->norm = sv->norm ;
			dv->dif.b = ( BYTE )BlueTable [ sv->dif.b ] ;
			dv->dif.g = ( BYTE )GreenTable[ sv->dif.g ] ;
			dv->dif.r = ( BYTE )RedTable  [ sv->dif.r ] ;
			dv->dif.a = ( BYTE )AlphaTable[ sv->dif.a ] ;
			dv->spc.b = ( BYTE )BlueTable [ sv->spc.b ] ;
			dv->spc.g = ( BYTE )GreenTable[ sv->spc.g ] ;
			dv->spc.r = ( BYTE )RedTable  [ sv->spc.r ] ;
			dv->spc.a = ( BYTE )AlphaTable[ sv->spc.a ] ;
			dv->u = sv->u ;
			dv->v = sv->v ;
			dv->su = sv->su ;
			dv->sv = sv->sv ;
		}
		UseVertex = ( VERTEX3D * )GSYS.Resource.TempVertexBuffer ;
	}
	else
	{
		UseVertex = Vertex ;
	}
	
	DRAW_DEF(
		Graphics_Hardware_DrawPrimitiveLight_PF( UseVertex, VertexNum, PrimitiveType, Image, TransFlag ),
		0,
		DrawRect = GSYS.DrawSetting.DrawArea ;,
		Ret,
		Flag
	)

	return Ret ;
}

// Qcv~eBu`悷(CfbNX)
extern int NS_DrawPrimitiveIndexed2D( const VERTEX2D *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType, int GrHandle, int TransFlag )
{
	IMAGEDATA *Image ;
	int Ret, i, Flag ;
	const VERTEX2D *UseVertex ;

	Ret = -1;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	Image = NULL ;
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image ) )
			return -1 ;
		Flag = Image->Orig->FormatDesc.TextureFlag ;
	}
	else
	{
		Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;
	}

#ifndef DX_NON_MOVIE
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( Image->Orig->MovieHandle != -1 )
			UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
	}
#endif

	// Rcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware3DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib3DMatrixToHardware() ;

	// F̕ϊKvȏꍇ͂ŏ
	if( GSYS.DrawSetting.DrawBright.Red   != 255 ||
		GSYS.DrawSetting.DrawBright.Green != 255 ||
		GSYS.DrawSetting.DrawBright.Blue  != 255 ||
		( GSYS.DrawSetting.BlendMode != DX_BLENDMODE_NOBLEND && GSYS.DrawSetting.BlendParam != 255 ) )
	{
		DWORD *RedTable, *GreenTable, *BlueTable, *AlphaTable ;
		const VERTEX2D *sv ;
		VERTEX2D *dv ;
		unsigned int Size ;

		// e[upӂ
		RedTable   = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Red] ;
		GreenTable = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Green] ;
		BlueTable  = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Blue] ;
		AlphaTable = MemImgManage.RateTable[GSYS.DrawSetting.BlendParam] ;
		if( GSYS.DrawSetting.BlendMode == DX_BLENDMODE_NOBLEND ) AlphaTable = MemImgManage.RateTable[255] ;

		// _f[^i[郁̈悪Ȃꍇ͊mۂ
		Size = sizeof( VERTEX2D ) * VertexNum ;
		if( GSYS.Resource.TempVertexBufferSize < ( int )Size )
		{
			if( GSYS.Resource.TempVertexBuffer )
			{
				DXFREE( GSYS.Resource.TempVertexBuffer ) ;
				GSYS.Resource.TempVertexBufferSize = 0 ;
			}
			GSYS.Resource.TempVertexBuffer = DXALLOC( Size ) ;
			if( GSYS.Resource.TempVertexBuffer == NULL )
				return -1 ;
			GSYS.Resource.TempVertexBufferSize = ( int )Size ;
		}

		// ꎞobt@ɕϊȂ]
		sv = Vertex;
		dv = ( VERTEX2D * )GSYS.Resource.TempVertexBuffer ;
		for( i = 0 ; i < VertexNum ; i ++, sv ++, dv ++ )
		{
			dv->pos = sv->pos ;
			dv->rhw = sv->rhw ;
			dv->dif.b = ( BYTE )BlueTable [ sv->dif.b ] ;
			dv->dif.g = ( BYTE )GreenTable[ sv->dif.g ] ;
			dv->dif.r = ( BYTE )RedTable  [ sv->dif.r ] ;
			dv->dif.a = ( BYTE )AlphaTable[ sv->dif.a ] ;
			dv->u = sv->u ;
			dv->v = sv->v ;
		}
		UseVertex = ( VERTEX2D * )GSYS.Resource.TempVertexBuffer ;
	}
	else
	{
		UseVertex = Vertex ;
	}

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;
	
	DRAW_DEF(
		Graphics_Hardware_DrawIndexedPrimitive2DUser_PF( UseVertex, VertexNum, Indices, IndexNum, PrimitiveType, Image, TransFlag ),
		0,
		DrawRect = GSYS.DrawSetting.DrawArea ;,
		Ret,
		Flag
	)

	return Ret ;
}

// Rc|S`悷(CfbNX)
extern int NS_DrawPrimitiveIndexed3D( const VERTEX3D *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType, int GrHandle, int TransFlag )
{
	IMAGEDATA *Image ;
	int Ret, i, Flag ;
	const VERTEX3D *UseVertex ;

	Ret = -1;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	Image = NULL ;
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image ) )
			return -1 ;
		Flag = Image->Orig->FormatDesc.TextureFlag ;
	}
	else
	{
		Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;
	}

#ifndef DX_NON_MOVIE
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( Image->Orig->MovieHandle != -1 )
			UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
	}
#endif

	// Rcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware3DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib3DMatrixToHardware() ;

	// F̕ϊKvȏꍇ͂ŏ
	if( GSYS.DrawSetting.DrawBright.Red   != 255 ||
		GSYS.DrawSetting.DrawBright.Green != 255 ||
		GSYS.DrawSetting.DrawBright.Blue  != 255 ||
		( GSYS.DrawSetting.BlendMode != DX_BLENDMODE_NOBLEND && GSYS.DrawSetting.BlendParam != 255 ) )
	{
		DWORD *RedTable, *GreenTable, *BlueTable, *AlphaTable ;
		const VERTEX3D *sv ;
		VERTEX3D *dv ;
		unsigned int Size ;

		// e[upӂ
		RedTable   = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Red] ;
		GreenTable = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Green] ;
		BlueTable  = MemImgManage.RateTable[GSYS.DrawSetting.DrawBright.Blue] ;
		AlphaTable = MemImgManage.RateTable[GSYS.DrawSetting.BlendParam] ;
		if( GSYS.DrawSetting.BlendMode == DX_BLENDMODE_NOBLEND ) AlphaTable = MemImgManage.RateTable[255] ;

		// _f[^i[郁̈悪Ȃꍇ͊mۂ
		Size = sizeof( VERTEX3D ) * VertexNum ;
		if( GSYS.Resource.TempVertexBufferSize < ( int )Size )
		{
			if( GSYS.Resource.TempVertexBuffer )
			{
				DXFREE( GSYS.Resource.TempVertexBuffer ) ;
				GSYS.Resource.TempVertexBufferSize = 0 ;
			}
			GSYS.Resource.TempVertexBuffer = DXALLOC( Size ) ;
			if( GSYS.Resource.TempVertexBuffer == NULL )
				return -1 ;
			GSYS.Resource.TempVertexBufferSize = ( int )Size ;
		}

		// ꎞobt@ɕϊȂ]
		sv = Vertex;
		dv = ( VERTEX3D * )GSYS.Resource.TempVertexBuffer ;
		for( i = 0 ; i < VertexNum ; i ++, sv ++, dv ++ )
		{
			dv->pos = sv->pos ;
			dv->norm = sv->norm ;
			dv->dif.b = ( BYTE )BlueTable [ sv->dif.b ] ;
			dv->dif.g = ( BYTE )GreenTable[ sv->dif.g ] ;
			dv->dif.r = ( BYTE )RedTable  [ sv->dif.r ] ;
			dv->dif.a = ( BYTE )AlphaTable[ sv->dif.a ] ;
			dv->spc.b = ( BYTE )BlueTable [ sv->spc.b ] ;
			dv->spc.g = ( BYTE )GreenTable[ sv->spc.g ] ;
			dv->spc.r = ( BYTE )RedTable  [ sv->spc.r ] ;
			dv->spc.a = ( BYTE )AlphaTable[ sv->spc.a ] ;
			dv->u = sv->u ;
			dv->v = sv->v ;
			dv->su = sv->su ;
			dv->sv = sv->sv ;
		}
		UseVertex = ( VERTEX3D * )GSYS.Resource.TempVertexBuffer ;
	}
	else
	{
		UseVertex = Vertex ;
	}
	
	DRAW_DEF(
		Graphics_Hardware_DrawIndexedPrimitiveLight_PF( UseVertex, VertexNum, Indices, IndexNum, PrimitiveType, Image, TransFlag ),
		0,
		DrawRect = GSYS.DrawSetting.DrawArea ;,
		Ret,
		Flag
	)

	return Ret ;
}

// _obt@gpĂRc|S`悷
extern int NS_DrawPolygon3D_UseVertexBuffer( int VertexBufHandle, int GrHandle, int TransFlag )
{
	return NS_DrawPrimitive3D_UseVertexBuffer( VertexBufHandle, DX_PRIMTYPE_TRIANGLELIST, GrHandle, TransFlag ) ;
}

// _obt@gpĂRcv~eBu`悷
extern int NS_DrawPrimitive3D_UseVertexBuffer( int VertexBufHandle, int PrimitiveType  /* DX_PRIMTYPE_TRIANGLELIST  */, int GrHandle, int TransFlag )
{
	IMAGEDATA *Image ;
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;
	int Ret, Flag ;

	Ret = -1;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	Image = NULL ;
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image ) )
			return -1 ;
		Flag = Image->Orig->FormatDesc.TextureFlag ;
	}
	else
	{
		Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;
	}
	VertexBuffer = NULL ;
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;

#ifndef DX_NON_MOVIE
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( Image->Orig->MovieHandle != -1 )
			UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
	}
#endif

	// Rcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware3DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib3DMatrixToHardware() ;

	DRAW_DEF(
		Graphics_Hardware_DrawPrimitiveLight_UseVertexBuffer_PF( VertexBuffer, PrimitiveType, 0, VertexBuffer->Num, Image, TransFlag ),
		0,
		DrawRect = GSYS.DrawSetting.DrawArea ;,
		Ret,
		Flag
	)

	return Ret ;
}

// _obt@gpĂRcv~eBu`悷
extern int NS_DrawPrimitive3D_UseVertexBuffer2( int VertexBufHandle, int PrimitiveType  /* DX_PRIMTYPE_TRIANGLELIST  */, int StartVertex, int UseVertexNum, int GrHandle, int TransFlag )
{
	IMAGEDATA *Image ;
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;
	int Ret, Flag ;

	Ret = -1;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	Image = NULL ;
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image ) )
			return -1 ;
		Flag = Image->Orig->FormatDesc.TextureFlag ;
	}
	else
	{
		Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;
	}
	VertexBuffer = NULL ;
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;

#ifndef DX_NON_MOVIE
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( Image->Orig->MovieHandle != -1 )
			UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
	}
#endif

	// Rcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware3DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib3DMatrixToHardware() ;

	DRAW_DEF(
		Graphics_Hardware_DrawPrimitiveLight_UseVertexBuffer_PF( VertexBuffer, PrimitiveType, StartVertex, UseVertexNum, Image, TransFlag ),
		0,
		DrawRect = GSYS.DrawSetting.DrawArea ;,
		Ret,
		Flag
	)

	return Ret ;
}

// _obt@ƃCfbNXobt@gpĂRc|S`悷
extern int NS_DrawPolygonIndexed3D_UseVertexBuffer( int VertexBufHandle, int IndexBufHandle, int GrHandle, int TransFlag )
{
	return NS_DrawPrimitiveIndexed3D_UseVertexBuffer( VertexBufHandle, IndexBufHandle, DX_PRIMTYPE_TRIANGLELIST, GrHandle, TransFlag ) ;
}

// _obt@ƃCfbNXobt@gpĂRcv~eBu`悷
extern int NS_DrawPrimitiveIndexed3D_UseVertexBuffer( int VertexBufHandle, int IndexBufHandle, int PrimitiveType  /* DX_PRIMTYPE_TRIANGLELIST  */, int GrHandle, int TransFlag )
{
	IMAGEDATA *Image ;
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;
	INDEXBUFFERHANDLEDATA *IndexBuffer ;
	int Ret, Flag ;

	Ret = -1;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	Image = NULL ;
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image ) )
			return -1 ;
		Flag = Image->Orig->FormatDesc.TextureFlag ;
	}
	else
	{
		Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;
	}
	VertexBuffer = NULL ;
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;
	if( INDEXBUFFERCHK( IndexBufHandle, IndexBuffer ) )
		return -1 ;

#ifndef DX_NON_MOVIE
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( Image->Orig->MovieHandle != -1 )
			UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
	}
#endif

	// Rcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware3DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib3DMatrixToHardware() ;

	DRAW_DEF(
		Graphics_Hardware_DrawIndexedPrimitiveLight_UseVertexBuffer_PF( VertexBuffer, IndexBuffer, PrimitiveType, 0, 0, VertexBuffer->Num, 0, IndexBuffer->Num, Image, TransFlag ),
		0,
		DrawRect = GSYS.DrawSetting.DrawArea ;,
		Ret,
		Flag
	)

	return Ret ;
}

// _obt@ƃCfbNXobt@gpĂRcv~eBu`悷
extern int NS_DrawPrimitiveIndexed3D_UseVertexBuffer2( int VertexBufHandle, int IndexBufHandle, int PrimitiveType  /* DX_PRIMTYPE_TRIANGLELIST  */, int BaseVertex, int StartVertex, int UseVertexNum, int StartIndex, int UseIndexNum, int GrHandle, int TransFlag )
{
	IMAGEDATA *Image ;
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;
	INDEXBUFFERHANDLEDATA *IndexBuffer ;
	int Ret, Flag ;

	Ret = -1;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	Image = NULL ;
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image ) )
			return -1 ;
		Flag = Image->Orig->FormatDesc.TextureFlag ;
	}
	else
	{
		Flag = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;
	}
	VertexBuffer = NULL ;
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;
	if( INDEXBUFFERCHK( IndexBufHandle, IndexBuffer ) )
		return -1 ;

#ifndef DX_NON_MOVIE
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( Image->Orig->MovieHandle != -1 )
			UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
	}
#endif

	// Rcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware3DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib3DMatrixToHardware() ;

	DRAW_DEF(
		Graphics_Hardware_DrawIndexedPrimitiveLight_UseVertexBuffer_PF( VertexBuffer, IndexBuffer, PrimitiveType, BaseVertex, StartVertex, UseVertexNum, StartIndex, UseIndexNum, Image, TransFlag ),
		0,
		DrawRect = GSYS.DrawSetting.DrawArea ;,
		Ret,
		Flag
	)

	return Ret ;
}

// OtBbN̂Rc`
#define SETDRAWRECTCODE\
	float MinX, MinY, MaxX, MaxY ;\
\
	MinX =  100000000.0F ;\
	MinY =  100000000.0F ;\
	MaxX = -100000000.0F ;\
	MaxY = -100000000.0F ;\
	for( i = 0 ; i < 4 ; i ++ )\
	{\
		if( TransVert[i].pos.x - 1.0F < MinX ) MinX = TransVert[i].pos.x - 1.0F ;\
		if( TransVert[i].pos.x + 1.0F > MaxX ) MaxX = TransVert[i].pos.x + 1.0F ;\
\
		if( TransVert[i].pos.y - 1.0F < MinY ) MinY = TransVert[i].pos.y - 1.0F ;\
		if( TransVert[i].pos.y + 1.0F > MaxY ) MaxY = TransVert[i].pos.y + 1.0F ;\
	}\
\
	DrawRect.left   = _FTOL( MinX ) ;\
	DrawRect.top    = _FTOL( MinY ) ;\
	DrawRect.right  = _FTOL( MaxX ) ;\
	DrawRect.bottom = _FTOL( MaxY ) ;\
	DRAWRECT_DRAWAREA_CLIP

extern	int NS_DrawGraph3D( float x, float y, float z, int GrHandle, int TransFlag )
{
	IMAGEDATA *Image ;
	int Ret = -1, i ;
	VERTEX_2D TransVert[6] ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;

#ifndef DX_NON_MOVIE
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( Image->Orig->MovieHandle != -1 )
			UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
	}
#endif

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// Wϊs
	{
		MATRIX *TransMatrix ;

		TransMatrix = &GSYS.DrawSetting.Blend3DMatrixF ;

		// _Zbg
		{
			VECTOR SrcVec[4], Pos ;
			VERTEX_2D DestVec[4] ;
			float SizeX, SizeY ;
			
			// r{[ĥS_𓾂
			SizeX = Image->WidthF  * 0.5f ;
			SizeY = Image->HeightF * 0.5f ;
			Pos.x = x ;	Pos.y = y ;	Pos.z = z ;
			SrcVec[0].x = -SizeX ;	SrcVec[0].y =  SizeY ;	SrcVec[0].z = 0.0F ;
			SrcVec[1].x =  SizeX ;	SrcVec[1].y =  SizeY ;	SrcVec[1].z = 0.0F ;
			SrcVec[2].x = -SizeX ;	SrcVec[2].y = -SizeY ;	SrcVec[2].z = 0.0F ;
			SrcVec[3].x =  SizeX ;	SrcVec[3].y = -SizeY ;	SrcVec[3].z = 0.0F ;

			// Wϊ
			for( i = 0 ; i < 4 ; i ++ )
			{
				// r{[hW[hW֕ϊ
				Graphics_Draw_VectorTransformToBillboard( &SrcVec[i], &Pos ) ;

				// XN[Wɕϊ
				DestVec[i].rhw = 1.0F ;
				VectorTransform4( &DestVec[i].pos,  &DestVec[i].rhw,
								  &SrcVec[i],       &DestVec[i].rhw, TransMatrix ) ;
				DestVec[i].rhw = 1.0F / DestVec[i].rhw ;
				DestVec[i].pos.x *= DestVec[i].rhw ;
				DestVec[i].pos.y *= DestVec[i].rhw ;
				DestVec[i].pos.z *= DestVec[i].rhw ;
			}
									            
			// _̃Zbg
			TransVert[0].pos = DestVec[0].pos ;
			TransVert[1].pos = DestVec[1].pos ;
			TransVert[2].pos = DestVec[2].pos ;
			TransVert[3].pos = DestVec[3].pos ;
			TransVert[0].rhw = DestVec[0].rhw ;
			TransVert[1].rhw = DestVec[1].rhw ;
			TransVert[2].rhw = DestVec[2].rhw ;
			TransVert[3].rhw = DestVec[3].rhw ;

			((BYTE *)&TransVert[0].color)[0] = (BYTE)GSYS.DrawSetting.DrawBright.Blue ;
			((BYTE *)&TransVert[0].color)[1] = (BYTE)GSYS.DrawSetting.DrawBright.Green ;
			((BYTE *)&TransVert[0].color)[2] = (BYTE)GSYS.DrawSetting.DrawBright.Red ;
			((BYTE *)&TransVert[0].color)[3] = ( BYTE )( ( GSYS.DrawSetting.BlendMode != DX_BLENDMODE_NOBLEND || GSYS.DrawSetting.UseNoBlendModeParam ) ? GSYS.DrawSetting.BlendParam : 255 ) ;
			TransVert[1].color =
			TransVert[2].color =
			TransVert[3].color = TransVert[0].color ;

			TransVert[0].u = 0.0F ;	TransVert[0].v = 0.0F ;
			TransVert[1].u = 1.0F ;	TransVert[1].v = 0.0F ;
			TransVert[2].u = 0.0F ;	TransVert[2].v = 1.0F ;
			TransVert[3].u = 1.0F ;	TransVert[3].v = 1.0F ;

			TransVert[4] = TransVert[2] ;
			TransVert[5] = TransVert[1] ;
		}
	}

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawPrimitive2D_PF( TransVert, 6, DX_PRIMTYPE_TRIANGLELIST, Image, TransFlag, TRUE, TRUE, FALSE, FALSE, 0, FALSE ),
		0,
		SETDRAWRECTCODE,
		Ret,
		Image->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

// OtBbN̊gRc`
extern	int NS_DrawExtendGraph3D( float x, float y, float z, double ExRateX, double ExRateY, int GrHandle, int TransFlag )
{
	IMAGEDATA *Image ;
	int Ret = -1, i ;
	VERTEX_2D TransVert[6] ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;

#ifndef DX_NON_MOVIE
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( Image->Orig->MovieHandle != -1 )
			UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
	}
#endif

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// Wϊs
	{
		MATRIX *TransMatrix ;

		TransMatrix = &GSYS.DrawSetting.Blend3DMatrixF ;

		// _Zbg
		{
			VECTOR SrcVec[4], Pos ;
			VERTEX_2D DestVec[4] ;
			float SizeX, SizeY ;
			
			// r{[ĥS_𓾂
			SizeX = Image->WidthF  * ( float )ExRateX * 0.5F ;
			SizeY = Image->HeightF * ( float )ExRateY * 0.5F ;
			Pos.x = x ;	Pos.y = y ;	Pos.z = z ;
			SrcVec[0].x = -SizeX ;	SrcVec[0].y =  SizeY ;	SrcVec[0].z = 0.0F ;
			SrcVec[1].x =  SizeX ;	SrcVec[1].y =  SizeY ;	SrcVec[1].z = 0.0F ;
			SrcVec[2].x = -SizeX ;	SrcVec[2].y = -SizeY ;	SrcVec[2].z = 0.0F ;
			SrcVec[3].x =  SizeX ;	SrcVec[3].y = -SizeY ;	SrcVec[3].z = 0.0F ;

			// Wϊ
			for( i = 0 ; i < 4 ; i ++ )
			{
				// r{[hW[hW֕ϊ
				Graphics_Draw_VectorTransformToBillboard( &SrcVec[i], &Pos ) ;

				// XN[Wɕϊ
				DestVec[i].rhw = 1.0F ;
				VectorTransform4( &DestVec[i].pos,  &DestVec[i].rhw,
									      &SrcVec[i],  &DestVec[i].rhw, TransMatrix ) ;
				DestVec[i].rhw = 1.0F / DestVec[i].rhw ;
				DestVec[i].pos.x *= DestVec[i].rhw ;
				DestVec[i].pos.y *= DestVec[i].rhw ;
				DestVec[i].pos.z *= DestVec[i].rhw ;
			}
									            
			// _̃Zbg
			TransVert[0].pos = DestVec[0].pos ;
			TransVert[1].pos = DestVec[1].pos ;
			TransVert[2].pos = DestVec[2].pos ;
			TransVert[3].pos = DestVec[3].pos ;
			TransVert[0].rhw = DestVec[0].rhw ;
			TransVert[1].rhw = DestVec[1].rhw ;
			TransVert[2].rhw = DestVec[2].rhw ;
			TransVert[3].rhw = DestVec[3].rhw ;

			((BYTE *)&TransVert[0].color)[0] = (BYTE)GSYS.DrawSetting.DrawBright.Blue ;
			((BYTE *)&TransVert[0].color)[1] = (BYTE)GSYS.DrawSetting.DrawBright.Green ;
			((BYTE *)&TransVert[0].color)[2] = (BYTE)GSYS.DrawSetting.DrawBright.Red ;
			((BYTE *)&TransVert[0].color)[3] = ( BYTE )( ( GSYS.DrawSetting.BlendMode != DX_BLENDMODE_NOBLEND || GSYS.DrawSetting.UseNoBlendModeParam ) ? GSYS.DrawSetting.BlendParam : 255 ) ;
			TransVert[1].color =
			TransVert[2].color =
			TransVert[3].color = TransVert[0].color ;

			TransVert[0].u = 0.0F ;	TransVert[0].v = 0.0F ;
			TransVert[1].u = 1.0F ;	TransVert[1].v = 0.0F ;
			TransVert[2].u = 0.0F ;	TransVert[2].v = 1.0F ;
			TransVert[3].u = 1.0F ;	TransVert[3].v = 1.0F ;

			TransVert[4] = TransVert[2] ;
			TransVert[5] = TransVert[1] ;
		}
	}

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawPrimitive2D_PF( TransVert, 6, DX_PRIMTYPE_TRIANGLELIST, Image, TransFlag, TRUE, TRUE, FALSE, FALSE, 0, FALSE ),
		0,
		SETDRAWRECTCODE,
		Ret,
		Image->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

// OtBbN̉]Rc`
extern	int NS_DrawRotaGraph3D( float x, float y, float z, double ExRate, double Angle, int GrHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	IMAGEDATA *Image ;
	int Ret = -1, i ;
	VERTEX_2D TransVert[6] ;
	float Sin, Cos ;
	float ExtendRate = ( float )ExRate ; 
	float ExtendRateX ;
	float ExtendRateY ;
	float XBuf, YBuf ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;

#ifndef DX_NON_MOVIE
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( Image->Orig->MovieHandle != -1 )
			UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
	}
#endif

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// Wϊs
	{
		MATRIX *TransMatrix ;

		TransMatrix = &GSYS.DrawSetting.Blend3DMatrixF ;

		// _Zbg
		{
			VECTOR SrcVec[4], Pos ;
			VERTEX_2D DestVec[4]/*, VectBuf */ ;
			float SizeX, SizeY ;

			// ]l̊g嗦Zbg
			ExtendRateX = ( ( ReverseXFlag == TRUE ) ? -1.0f : 1.0f ) * ExtendRate ;
			ExtendRateY = ( ( ReverseYFlag == TRUE ) ? -1.0f : 1.0f ) * ExtendRate ;

			// r{[ĥS_𓾂
			{
				SizeX = Image->WidthF  * 0.5F * ExtendRateX ;
				SizeY = Image->HeightF * 0.5F * ExtendRateY ;
				Pos.x = x ;	Pos.y = y ;	Pos.z = z ;
				SrcVec[0].x = -SizeX ;	SrcVec[0].y =  SizeY ;	SrcVec[0].z = 0.0F ;
				SrcVec[1].x =  SizeX ;	SrcVec[1].y =  SizeY ;	SrcVec[1].z = 0.0F ;
				SrcVec[2].x = -SizeX ;	SrcVec[2].y = -SizeY ;	SrcVec[2].z = 0.0F ;
				SrcVec[3].x =  SizeX ;	SrcVec[3].y = -SizeY ;	SrcVec[3].z = 0.0F ;

				// ]
				_SINCOS_PLATFORM( (float)Angle, &Sin, &Cos ) ;
				for( i = 0 ; i < 4 ; i ++ )
				{
					XBuf = SrcVec[i].x ;
					YBuf = SrcVec[i].y ;

					SrcVec[i].x = XBuf * Cos - YBuf * Sin ;	
					SrcVec[i].y = XBuf * Sin + YBuf * Cos ;
				}
			}

			// Wϊ
			for( i = 0 ; i < 4 ; i ++ )
			{
				// r{[hW[hW֕ϊ
				Graphics_Draw_VectorTransformToBillboard( &SrcVec[i], &Pos ) ;

				// XN[Wɕϊ
				DestVec[i].rhw = 1.0F ;
				VectorTransform4( &DestVec[i].pos,  &DestVec[i].rhw,
									      &SrcVec[i],  &DestVec[i].rhw, TransMatrix ) ;
				DestVec[i].rhw = 1.0F / DestVec[i].rhw ;
				DestVec[i].pos.x *= DestVec[i].rhw ;
				DestVec[i].pos.y *= DestVec[i].rhw ;
				DestVec[i].pos.z *= DestVec[i].rhw ;
			}
									            
			// _̃Zbg
			TransVert[0].pos = DestVec[0].pos ;
			TransVert[1].pos = DestVec[1].pos ;
			TransVert[2].pos = DestVec[2].pos ;
			TransVert[3].pos = DestVec[3].pos ;
			TransVert[0].rhw = DestVec[0].rhw ;
			TransVert[1].rhw = DestVec[1].rhw ;
			TransVert[2].rhw = DestVec[2].rhw ;
			TransVert[3].rhw = DestVec[3].rhw ;

			((BYTE *)&TransVert[0].color)[0] = (BYTE)GSYS.DrawSetting.DrawBright.Blue ;
			((BYTE *)&TransVert[0].color)[1] = (BYTE)GSYS.DrawSetting.DrawBright.Green ;
			((BYTE *)&TransVert[0].color)[2] = (BYTE)GSYS.DrawSetting.DrawBright.Red ;
			((BYTE *)&TransVert[0].color)[3] = ( BYTE )( ( GSYS.DrawSetting.BlendMode != DX_BLENDMODE_NOBLEND || GSYS.DrawSetting.UseNoBlendModeParam ) ? GSYS.DrawSetting.BlendParam : 255 ) ;
			TransVert[1].color =
			TransVert[2].color =
			TransVert[3].color = TransVert[0].color ;

			TransVert[0].u = 0.0F ;	TransVert[0].v = 0.0F ;
			TransVert[1].u = 1.0F ;	TransVert[1].v = 0.0F ;
			TransVert[2].u = 0.0F ;	TransVert[2].v = 1.0F ;
			TransVert[3].u = 1.0F ;	TransVert[3].v = 1.0F ;

			TransVert[4] = TransVert[2] ;
			TransVert[5] = TransVert[1] ;
		}
	}

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawPrimitive2D_PF( TransVert, 6, DX_PRIMTYPE_TRIANGLELIST, Image, TransFlag, TRUE, TRUE, FALSE, FALSE, 0, FALSE ),
		0,
		SETDRAWRECTCODE,
		Ret,
		Image->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

// OtBbN̉]Rc`(]Sw^)
extern	int NS_DrawRota2Graph3D( float x, float y, float z, float cx, float cy, double ExtRateX, double ExtRateY, double Angle, int GrHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	IMAGEDATA *Image ;
	int Ret = -1, i ;
	VERTEX_2D TransVert[6] ;
	float Sin, Cos ;
	float ExtendRateX = ( float )ExtRateX ; 
	float ExtendRateY = ( float )ExtRateY ; 
	float XBuf, YBuf ;

	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;

#ifndef DX_NON_MOVIE
	if( ( DWORD )GrHandle != DX_NONE_GRAPH )
	{
		if( Image->Orig->MovieHandle != -1 )
			UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
	}
#endif

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// Wϊs
	{
		MATRIX *TransMatrix ;

		TransMatrix = &GSYS.DrawSetting.Blend3DMatrixF ;

		// _Zbg
		{
			VECTOR SrcVec[4], Pos ;
			VERTEX_2D DestVec[4]/* , VectBuf */ ;
			float SizeX, SizeY ;
			
			// r{[ĥS_𓾂
			{
				SizeX = Image->WidthF ;
				SizeY = Image->HeightF ;
				Pos.x = x ;	Pos.y = y ;	Pos.z = z ;
				if( ReverseXFlag && ReverseYFlag )
				{
					SrcVec[0].x = ( -cx + SizeX ) * ExtendRateX ;	SrcVec[0].y =   -cy           * ExtendRateY ;	SrcVec[0].z = 0.0F ;
					SrcVec[1].x =   -cx           * ExtendRateX ;	SrcVec[1].y =   -cy           * ExtendRateY ;	SrcVec[1].z = 0.0F ;
					SrcVec[2].x = ( -cx + SizeX ) * ExtendRateX ;	SrcVec[2].y = ( -cy + SizeY ) * ExtendRateY ;	SrcVec[2].z = 0.0F ;
					SrcVec[3].x =   -cx           * ExtendRateX ;	SrcVec[3].y = ( -cy + SizeY ) * ExtendRateY ;	SrcVec[3].z = 0.0F ;
				}
				else
				if( ReverseXFlag )
				{
					SrcVec[0].x = ( -cx + SizeX ) * ExtendRateX ;	SrcVec[0].y = ( -cy + SizeY ) * ExtendRateY ;	SrcVec[0].z = 0.0F ;
					SrcVec[1].x =   -cx           * ExtendRateX ;	SrcVec[1].y = ( -cy + SizeY ) * ExtendRateY ;	SrcVec[1].z = 0.0F ;
					SrcVec[2].x = ( -cx + SizeX ) * ExtendRateX ;	SrcVec[2].y =   -cy           * ExtendRateY ;	SrcVec[2].z = 0.0F ;
					SrcVec[3].x =   -cx           * ExtendRateX ;	SrcVec[3].y =   -cy           * ExtendRateY ;	SrcVec[3].z = 0.0F ;
				}
				else
				if( ReverseYFlag )
				{
					SrcVec[0].x =   -cx           * ExtendRateX ;	SrcVec[0].y =   -cy           * ExtendRateY ;	SrcVec[0].z = 0.0F ;
					SrcVec[1].x = ( -cx + SizeX ) * ExtendRateX ;	SrcVec[1].y =   -cy           * ExtendRateY ;	SrcVec[1].z = 0.0F ;
					SrcVec[2].x =   -cx           * ExtendRateX ;	SrcVec[2].y = ( -cy + SizeY ) * ExtendRateY ;	SrcVec[2].z = 0.0F ;
					SrcVec[3].x = ( -cx + SizeX ) * ExtendRateX ;	SrcVec[3].y = ( -cy + SizeY ) * ExtendRateY ;	SrcVec[3].z = 0.0F ;
				}
				else
				{
					SrcVec[0].x =   -cx           * ExtendRateX ;	SrcVec[0].y = ( -cy + SizeY ) * ExtendRateY ;	SrcVec[0].z = 0.0F ;
					SrcVec[1].x = ( -cx + SizeX ) * ExtendRateX ;	SrcVec[1].y = ( -cy + SizeY ) * ExtendRateY ;	SrcVec[1].z = 0.0F ;
					SrcVec[2].x =   -cx           * ExtendRateX ;	SrcVec[2].y =   -cy           * ExtendRateY ;	SrcVec[2].z = 0.0F ;
					SrcVec[3].x = ( -cx + SizeX ) * ExtendRateX ;	SrcVec[3].y =   -cy           * ExtendRateY ;	SrcVec[3].z = 0.0F ;
				}

				// ]
				_SINCOS_PLATFORM( (float)Angle, &Sin, &Cos ) ;
				for( i = 0 ; i < 4 ; i ++ )
				{
					XBuf = SrcVec[i].x ;
					YBuf = SrcVec[i].y ;

					SrcVec[i].x = XBuf * Cos - YBuf * Sin ;	
					SrcVec[i].y = XBuf * Sin + YBuf * Cos ;
				}
			}

			// Wϊ
			for( i = 0 ; i < 4 ; i ++ )
			{
				// r{[hW[hW֕ϊ
				Graphics_Draw_VectorTransformToBillboard( &SrcVec[i], &Pos ) ;

				// XN[Wɕϊ
				DestVec[i].rhw = 1.0F ;
				VectorTransform4( &DestVec[i].pos,  &DestVec[i].rhw,
									      &SrcVec[i],  &DestVec[i].rhw, TransMatrix ) ;
				DestVec[i].rhw = 1.0F / DestVec[i].rhw ;
				DestVec[i].pos.x *= DestVec[i].rhw ;
				DestVec[i].pos.y *= DestVec[i].rhw ;
				DestVec[i].pos.z *= DestVec[i].rhw ;
			}
									            
			// _̃Zbg
			TransVert[0].pos = DestVec[0].pos ;
			TransVert[1].pos = DestVec[1].pos ;
			TransVert[2].pos = DestVec[2].pos ;
			TransVert[3].pos = DestVec[3].pos ;
			TransVert[0].rhw = DestVec[0].rhw ;
			TransVert[1].rhw = DestVec[1].rhw ;
			TransVert[2].rhw = DestVec[2].rhw ;
			TransVert[3].rhw = DestVec[3].rhw ;

			((BYTE *)&TransVert[0].color)[0] = (BYTE)GSYS.DrawSetting.DrawBright.Blue ;
			((BYTE *)&TransVert[0].color)[1] = (BYTE)GSYS.DrawSetting.DrawBright.Green ;
			((BYTE *)&TransVert[0].color)[2] = (BYTE)GSYS.DrawSetting.DrawBright.Red ;
			((BYTE *)&TransVert[0].color)[3] = ( BYTE )( ( GSYS.DrawSetting.BlendMode != DX_BLENDMODE_NOBLEND || GSYS.DrawSetting.UseNoBlendModeParam ) ? GSYS.DrawSetting.BlendParam : 255 ) ;
			TransVert[1].color =
			TransVert[2].color =
			TransVert[3].color = TransVert[0].color ;

			TransVert[0].u = 0.0F ;	TransVert[0].v = 0.0F ;
			TransVert[1].u = 1.0F ;	TransVert[1].v = 0.0F ;
			TransVert[2].u = 0.0F ;	TransVert[2].v = 1.0F ;
			TransVert[3].u = 1.0F ;	TransVert[3].v = 1.0F ;

			TransVert[4] = TransVert[2] ;
			TransVert[5] = TransVert[1] ;

			TransVert[4] = TransVert[2] ;
			TransVert[5] = TransVert[1] ;
		}
	}

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawPrimitive2D_PF( TransVert, 6, DX_PRIMTYPE_TRIANGLELIST, Image, TransFlag, TRUE, TRUE, FALSE, FALSE, 0, FALSE ),
		0,
		SETDRAWRECTCODE,
		Ret,
		Image->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE

// OtBbN̎Rό`Rc`
extern int NS_DrawModiBillboard3D( VECTOR Pos, float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, int GrHandle, int TransFlag )
{
	IMAGEDATA *Image ;
	IMAGEDATA *BlendImage ;
	int Ret ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE ) return -1 ;

	// `ݒ肪Ăꍇ͉I
	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;
	BlendImage = NULL ;
	if( GSYS.DrawSetting.BlendGraph > 0 )
	{
		GRAPHCHK( GSYS.DrawSetting.BlendGraph, BlendImage ) ;

		// uheNX`gpꍇA`摜G[
		if( Graphics_Image_CheckBlendGraphSize( Image ) ) return -1 ;

		// Qcsn[hEGAɔf
		if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
			Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;
	}
	else
	{
		// Rcsn[hEGAɔf
		if( GSYS.DrawSetting.MatchHardware3DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
			Graphics_DrawSetting_ApplyLib3DMatrixToHardware() ;
	}

#ifndef DX_NON_MOVIE
	if( Image->Orig->MovieHandle != -1 )
		UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
#endif

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawModiBillboard3D_PF( Pos, x1, y1, x2, y2, x3, y3, x4, y4, Image, BlendImage, TransFlag ),
		0,
		DrawRect = GSYS.DrawSetting.DrawArea ;,
		Ret,
		Image->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

// RcԏɃOtBbN`
extern int NS_DrawBillboard3D( VECTOR Pos, float cx, float cy, float Size, float Angle, int GrHandle, int TransFlag, int ReverseXFlag, int ReverseYFlag )
{
	IMAGEDATA *Image ;
	IMAGEDATA *BlendImage ;
	int Ret ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE ) return -1 ;

	// `ݒ肪Ăꍇ͉I
	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;
	BlendImage = NULL ;
	if( GSYS.DrawSetting.BlendGraph > 0 )
	{
		GRAPHCHK( GSYS.DrawSetting.BlendGraph, BlendImage ) ;

		// uheNX`gpꍇA`摜G[
		if( Graphics_Image_CheckBlendGraphSize( Image ) ) return -1 ;

		// Qcsn[hEGAɔf
		if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
			Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;
	}
	else
	{
		// Rcsn[hEGAɔf
		if( GSYS.DrawSetting.MatchHardware3DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
			Graphics_DrawSetting_ApplyLib3DMatrixToHardware() ;
	}

#ifndef DX_NON_MOVIE
	if( Image->Orig->MovieHandle != -1 )
		UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
#endif

	// `
	DRAW_DEF(
		Graphics_Hardware_DrawBillboard3D_PF( Pos, cx, cy, Size, Angle, Image, BlendImage, TransFlag, ReverseXFlag, ReverseYFlag ),
		0,
		DrawRect = GSYS.DrawSetting.DrawArea ;,
		Ret,
		Image->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

























// `ݒ֌W֐

// `惂[hZbg
extern	int NS_SetDrawMode( int DrawMode )
{
	if( /* GSYS.NotDrawFlag || */ DrawMode == GSYS.DrawSetting.DrawMode )
		return 0 ;

	// `惂[h̕ۑ
	GSYS.DrawSetting.DrawMode = DrawMode ;
	GSYS.ChangeSettingFlag = TRUE ;

	// n[hEGAANZ[V̐ݒɔf
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetDrawMode_PF( DrawMode ) ;
	}

	// I
	return 0 ;
}

// `惂[h擾
extern int NS_GetDrawMode( void )
{
	return GSYS.DrawSetting.DrawMode ;
}

// `uh[hZbg
extern	int NS_SetDrawBlendMode( int BlendMode, int BlendParam )
{
	if( /* GSYS.NotDrawFlag || */ ( GSYS.DrawSetting.BlendMode == BlendMode && GSYS.DrawSetting.BlendParam == BlendParam ) )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// uh[h̕ۑ
	if( GSYS.DrawSetting.BlendMode != BlendMode )
	{
		GSYS.DrawSetting.BlendMode = BlendMode ;
		GSYS.ChangeSettingFlag = TRUE ;
	}

	if( BlendParam > 255 ) BlendParam = 255 ;
	if( BlendParam < 0	 ) BlendParam = 0 ;
	GSYS.DrawSetting.BlendParam = BlendParam ;
	SetMemImgDrawBlendMode( GSYS.DrawSetting.BlendMode, GSYS.DrawSetting.BlendParam ) ;

	// n[hEGAANZ[V̐ݒɔf
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetDrawBlendMode_PF( BlendMode, BlendParam ) ;
	}

	// I
	return 0 ;
}

// `uh[h擾
extern int NS_GetDrawBlendMode( int *BlendMode, int *BlendParam )
{
	if( BlendMode	!= NULL ) *BlendMode =	GSYS.DrawSetting.BlendMode ;
	if( BlendParam	!= NULL ) *BlendParam =	GSYS.DrawSetting.BlendParam ;

	// I
	return 0 ;
}

// `掞̃At@eXg̐ݒs( TestMode:DX_CMP_GREATER( -1:ftHgɖ߂ )  TestParam:`At@lƂ̔rɎgpl )
extern	int	NS_SetDrawAlphaTest( int TestMode, int TestParam )
{
	if( /* GSYS.NotDrawFlag || */ ( GSYS.DrawSetting.AlphaTestMode == TestMode && GSYS.DrawSetting.AlphaTestParam == TestParam ) )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// At@eXgp[^ۑ
	GSYS.DrawSetting.AlphaTestMode = TestMode ;
	if( TestParam > 255 ) TestParam = 255 ;
	if( TestParam < 0	 ) TestParam = 0 ;
	GSYS.DrawSetting.AlphaTestParam = TestParam ;
	GSYS.ChangeSettingFlag = TRUE ;

	// n[hEGAANZ[V̐ݒɔf
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetDrawAlphaTest_PF( TestMode, TestParam ) ;
	}

	// I
	return 0 ;
}

// `掞̃At@eXg̐ݒ擾( TestMode:eXg[h( DX_CMP_GREATER -1ŃftHgɖ߂ )  TestParam:`At@lƂ̔rɎgpl( 0`255 ) )
extern	int NS_GetDrawAlphaTest( int *TestMode, int *TestParam )
{
	if( TestMode  != NULL ) *TestMode  = GSYS.DrawSetting.AlphaTestMode ;
	if( TestParam != NULL ) *TestParam = GSYS.DrawSetting.AlphaTestParam ;

	// I
	return 0 ;
}

// `揈ɕ`悷摜ƃuh郿`lt摜Zbg
extern	int NS_SetBlendGraph( int BlendGraph, int BorderParam, int BorderRange )
{
	return NS_SetBlendGraphParam( BlendGraph, DX_BLENDGRAPHTYPE_WIPE, BorderParam, BorderRange ) ;
}

// `揈ɕ`悷摜ƃuh摜̃uhݒs
extern	int NS_SetBlendGraphParam( int BlendGraph, int BlendType, ... )
{
	int Result ;
	va_list VaList ;

	if( BlendType < 0 || BlendType >= DX_BLENDGRAPHTYPE_NUM )
	{
		return -1 ;
	}

	va_start( VaList, BlendType ) ;

	Result = Graphics_DrawSetting_SetBlendGraphParamBase(  BlendGraph,  BlendType, VaList ) ;

	va_end( VaList ) ;

	return Result ;
}

// uh摜̋N_WZbg
extern	int NS_SetBlendGraphPosition( int x, int y )
{
	// ܂łƒlꍇ͉I
	if( GSYS.DrawSetting.BlendGraphX == x && GSYS.DrawSetting.BlendGraphY == y ) return 0 ;

	// Wۑ
	GSYS.DrawSetting.BlendGraphX = x ;
	GSYS.DrawSetting.BlendGraphY = y ;

	// I
	return 0 ;
}

// uh摜̓KW[hݒ肷
extern int NS_SetBlendGraphPositionMode( int BlendGraphPositionMode /* DX_BLENDGRAPH_POSMODE_DRAWGRAPH Ȃ */ )
{
	if( BlendGraphPositionMode < 0 || BlendGraphPositionMode >= DX_BLENDGRAPH_POSMODE_NUM )
	{
		return -1 ;
	}

	// W[hۑ
	GSYS.DrawSetting.BlendGraphPosMode = BlendGraphPositionMode ;

	// I
	return 0 ;
}

// `PxZbg
extern	int NS_SetDrawBright( int RedBright, int GreenBright, int BlueBright )
{
	if( GSYS.DrawSetting.DrawBright.Red   == RedBright  &&
		GSYS.DrawSetting.DrawBright.Green == GreenBright &&
		GSYS.DrawSetting.DrawBright.Blue  == BlueBright )
	{
		return 0 ;
	}

	if( (unsigned int)RedBright   > 255 )
	{
		     if( RedBright   > 255 ) RedBright   = 255 ;
		else if( RedBright   < 0   ) RedBright   = 0   ;
	}
	if( (unsigned int)GreenBright > 255 )
	{
		     if( GreenBright > 255 ) GreenBright = 255 ;
		else if( GreenBright < 0   ) GreenBright = 0   ;
	}
	if( (unsigned int)BlueBright  > 255 )
	{
		     if( BlueBright  > 255 ) BlueBright  = 255 ;
		else if( BlueBright  < 0   ) BlueBright  = 0   ;
	}

	// Pxۑ
	GSYS.DrawSetting.DrawBright.Red   = ( BYTE )RedBright   ;
	GSYS.DrawSetting.DrawBright.Green = ( BYTE )GreenBright ;
	GSYS.DrawSetting.DrawBright.Blue  = ( BYTE )BlueBright  ;

	// n[hEGAANZ[V̐ݒɔf
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetDrawBright_PF( RedBright, GreenBright, BlueBright ) ;
	}
	else
	{
		SetMemImgDrawBright( GSYS.DrawSetting.bDrawBright ) ;
	}

	// I
	return 0 ;
}

// `Px擾
extern int NS_GetDrawBright( int *Red, int *Green, int *Blue )
{
	if( Red		!= NULL ) *Red =	GSYS.DrawSetting.DrawBright.Red ;
	if( Green	!= NULL ) *Green =	GSYS.DrawSetting.DrawBright.Green ;
	if( Blue	!= NULL ) *Blue =	GSYS.DrawSetting.DrawBright.Blue ;

	// I
	return 0 ;
}

// `J[ɉZFݒ肷
extern int NS_SetDrawAddColor( int Red, int Green, int Blue )
{
	if( GSYS.DrawSetting.DrawAddColorI.x == Red  &&
		GSYS.DrawSetting.DrawAddColorI.y == Green &&
		GSYS.DrawSetting.DrawAddColorI.z == Blue )
	{
		return 0 ;
	}

	// Pxۑ
	GSYS.DrawSetting.DrawAddColorI.x = Red   ;
	GSYS.DrawSetting.DrawAddColorI.y = Green ;
	GSYS.DrawSetting.DrawAddColorI.z = Blue  ;
	GSYS.DrawSetting.DrawAddColorF.r = Red   / 255.0f ;
	GSYS.DrawSetting.DrawAddColorF.g = Green / 255.0f ;
	GSYS.DrawSetting.DrawAddColorF.b = Blue  / 255.0f ;

	// n[hEGAANZ[V̐ݒɔf
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetDrawAddColor_PF( Red, Green, Blue ) ;
	}

	// I
	return 0 ;
}

// `J[ɉZF擾
extern int NS_GetDrawAddColor( int *Red, int *Green, int *Blue )
{
	if( Red		!= NULL ) *Red =	GSYS.DrawSetting.DrawAddColorI.x ;
	if( Green	!= NULL ) *Green =	GSYS.DrawSetting.DrawAddColorI.y ;
	if( Blue	!= NULL ) *Blue =	GSYS.DrawSetting.DrawAddColorI.z ;

	// I
	return 0 ;
}

// `̃At@`l̓e邩ݒ肷( FALSE:Ȃ  TRUE:( ftHg ) )
extern int NS_SetWriteAlphaChannelFlag( int Flag )
{
	// RGB̃uhݒƂ͕ʂɃAt@`l̃uhݒ肪sȂꍇ͉ȂŏI
	if( GSYS.HardInfo.SeparateAlphaBlendEnable == FALSE )
	{
		return -1 ;
	}

	// ݒ肪ωȂꍇ͉ȂŏI
	if( GSYS.DrawSetting.NotWriteAlphaChannelFlag == ( Flag ? FALSE : TRUE ) )
	{
		return 0 ;
	}

	// ݒۑ
	GSYS.DrawSetting.NotWriteAlphaChannelFlag = Flag ? FALSE : TRUE ;
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// `̃At@`l̓e邩擾( FALSE:Ȃ  TRUE:( ftHg ) )
extern int NS_GetWriteAlphaChannelFlag( void )
{
	return GSYS.DrawSetting.NotWriteAlphaChannelFlag ? FALSE : TRUE ;
}

// `̃At@`l̓eȂƂł邩ǂ擾( TRUE:ȂƂł  FALSE:ȂƂłȂ )
extern int NS_CheckSeparateAlphaBlendEnable( void )
{
	return GSYS.HardInfo.SeparateAlphaBlendEnable ;
}

// `悷摜̐F𖳎邩ǂw肷( EnableFlag:̋@\gǂ( TRUE:g  FALSE:gȂ ) )
extern int NS_SetIgnoreDrawGraphColor( int EnableFlag )
{
	if( GSYS.DrawSetting.IgnoreGraphColorFlag == EnableFlag )
		return 0 ;

	// ݒۑ
	GSYS.DrawSetting.IgnoreGraphColorFlag = EnableFlag ;
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// `悷摜̐F𖳎邩ǂ擾( ߂l ̋@\gǂ( TRUE:g  FALSE:gȂ ) )
extern int NS_GetIgnoreDrawGraphColor( void )
{
	return GSYS.DrawSetting.IgnoreGraphColorFlag ;
}

// őٕ̒lZbg
extern int NS_SetMaxAnisotropy( int MaxAnisotropy )
{
	if( /* GSYS.NotDrawFlag || */ MaxAnisotropy == GSYS.DrawSetting.MaxAnisotropy )
		return 0 ;

	// őٕ̕ۑ
	GSYS.DrawSetting.MaxAnisotropy = MaxAnisotropy ;
	GSYS.ChangeSettingFlag = TRUE ;

	// n[hEGAANZ[V̐ݒɔf
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetMaxAnisotropy_PF( MaxAnisotropy ) ;
	}

	// I
	return 0 ;
}

// őٕl擾
extern int NS_GetMaxAnisotropy( void )
{
	// őٕlԂ
	return GSYS.DrawSetting.MaxAnisotropy ;
}

// RcŎgpWl 10000000.0f Ȃǂ̑傫ȒlɂȂĂ`̕}鏈gp邩ǂݒ肷ADxLib_Init ̌ĂяoOł̂ݎgp\( TRUE:`̕}鏈gp( CPUׂオ܂ )@@FALSE:`̕}鏈͎gpȂ( ftHg ) )
extern int NS_SetUseLarge3DPositionSupport( int UseFlag )
{
	// ÔݗL
	if( DxSysData.DxLib_InitializeFlag )
	{
		return -1 ;
	}

	// tOۑ
	GSYS.DrawSetting.Large3DPositionSupport = UseFlag ;

#ifdef WINDOWS_DESKTOP_OS
	// TRUE ̏ꍇ SetUseFPUPreserveFlag Lɂ
	NS_SetUseFPUPreserveFlag( TRUE ) ;
#endif // WINDOWS_DESKTOP_OS

	// I
	return 0 ;
}


// yobt@Lɂ邩AtOZbg
extern	int NS_SetUseZBufferFlag( int Flag )
{
	if( GSYS.DrawSetting.EnableZBufferFlag2D == Flag &&
		GSYS.DrawSetting.EnableZBufferFlag3D == Flag ) return 0 ;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	GSYS.DrawSetting.EnableZBufferFlag2D = Flag ;
	GSYS.DrawSetting.EnableZBufferFlag3D = Flag ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// yobt@ɏ݂sAtOZbg
extern	int NS_SetWriteZBufferFlag( int Flag )
{
	if( GSYS.DrawSetting.WriteZBufferFlag2D == Flag &&
		GSYS.DrawSetting.WriteZBufferFlag3D == Flag ) return 0 ;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	GSYS.DrawSetting.WriteZBufferFlag2D = Flag ;
	GSYS.DrawSetting.WriteZBufferFlag3D = Flag ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// yl̔r[hZbg
extern	int NS_SetZBufferCmpType( int CmpType /* DX_CMP_NEVER  */ )
{
	if( GSYS.DrawSetting.ZBufferCmpType2D == CmpType &&
		GSYS.DrawSetting.ZBufferCmpType3D == CmpType ) return 0 ;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	GSYS.DrawSetting.ZBufferCmpType2D = CmpType ;
	GSYS.DrawSetting.ZBufferCmpType3D = CmpType ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// yoCAXZbg
extern	int NS_SetZBias( int Bias )
{
	if( GSYS.DrawSetting.ZBias2D == Bias &&
		GSYS.DrawSetting.ZBias3D == Bias ) return 0 ;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	GSYS.DrawSetting.ZBias2D = Bias ;
	GSYS.DrawSetting.ZBias3D = Bias ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// yobt@Lɂ邩AtOZbg( Rc}``݂̂ɉe )
extern int NS_SetUseZBuffer3D( int Flag )
{
	if( GSYS.DrawSetting.EnableZBufferFlag3D == Flag ) return 0 ;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	GSYS.DrawSetting.EnableZBufferFlag3D = Flag ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// yobt@ɏ݂sAtOZbg( Rc}``݂̂ɉe )
extern int NS_SetWriteZBuffer3D( int Flag )
{
	if( GSYS.DrawSetting.WriteZBufferFlag3D == Flag ) return 0 ;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	GSYS.DrawSetting.WriteZBufferFlag3D = Flag ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// yl̔r[hZbg( Rc}``݂̂ɉe )
extern int NS_SetZBufferCmpType3D( int CmpType /* DX_CMP_NEVER  */ )
{
	if( GSYS.DrawSetting.ZBufferCmpType3D == CmpType ) return 0 ;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	GSYS.DrawSetting.ZBufferCmpType3D = CmpType ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// yoCAXZbg( Rc}``݂̂ɉe )
extern int NS_SetZBias3D( int Bias )
{
	if( GSYS.DrawSetting.ZBias3D == Bias ) return 0 ;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	GSYS.DrawSetting.ZBias3D = Bias ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// Qc`掞ɂyobt@ɏނylύX
extern int NS_SetDrawZ( float Z )
{
	GSYS.DrawSetting.DrawZ = Z;

	// I
	return 0;
}



// `\̈̃Zbg
extern	int NS_SetDrawArea( int x1, int y1, int x2, int y2 )
{
//	const char *HandleString = NULL ;
	int Buf, SizeX, SizeY ;
	IMAGEDATA *Image ;
	SHADOWMAPDATA *ShadowMap ;

//	if( GSYS.NotDrawFlag ) return 0 ;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// tXN[}XNsĂꍇ̓}XN`̌ʂ𔽉f
	MASK_FULLSCREEN_MASKUPDATE

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
//	CheckActiveState() ;

	// IWi̕`GAۑ
	GSYS.DrawSetting.OriginalDrawRect.left   = x1 ;
	GSYS.DrawSetting.OriginalDrawRect.top    = y1 ;
	GSYS.DrawSetting.OriginalDrawRect.right  = x2 ;
	GSYS.DrawSetting.OriginalDrawRect.bottom = y2 ;
	
	// `̕`\TCY擾
	switch( ( DWORD )GSYS.DrawSetting.TargetScreen[ 0 ] )
	{
	case DX_SCREEN_BACK :
	case DX_SCREEN_FRONT :
//		HandleString = ( DWORD )GSYS.DrawSetting.TargetScreen[ 0 ] == DX_SCREEN_BACK ? "Back Buffer" : "Front Buffer" ;
		SizeX = GSYS.Screen.MainScreenSizeX ;
		SizeY = GSYS.Screen.MainScreenSizeY ;
		break ;

	case DX_SCREEN_OTHER :
		SizeX = GSYS.DrawSetting.DrawSizeX ;
		SizeY = GSYS.DrawSetting.DrawSizeY ;
		break ;

	default :
//		HandleString = "Image Buffer" ;
		// G[
		if( !GRAPHCHK( GSYS.DrawSetting.TargetScreen[ 0 ], Image ) )
		{
			Graphics_Image_CalcMipSize( Image->WidthI, Image->HeightI, GSYS.DrawSetting.TargetScreenMipLevel[ 0 ], &SizeX, &SizeY ) ;
		}
		else
		if( !SHADOWMAPCHK( GSYS.DrawSetting.TargetScreen[ 0 ], ShadowMap ) )
		{
			SizeX = ShadowMap->BaseSizeX ;
			SizeY = ShadowMap->BaseSizeY ;
		}
		else
		{
			return -1 ;
		}
		break ;
	}

	// Et␳Ƃ͂ݏo␳
	if( x1 > x2 ){ Buf = x1 ; x1 = x2 ; x2 = Buf ; }
	if( y1 > y2 ){ Buf = y1 ; y1 = y2 ; y2 = Buf ; }

	if( x1 < 0 )		x1 = 0 ;
	if( x1 > SizeX )	x1 = SizeX ; 
	if( x2 < 0 )		x2 = 0 ;
	if( x2 > SizeX )	x2 = SizeX ;

	if( y1 < 0 )		y1 = 0 ;
	if( y1 > SizeY )	y1 = SizeY ; 
	if( y2 < 0 )		y2 = 0 ;
	if( y2 > SizeY )	y2 = SizeY ;

	// `\`Zbg
	GSYS.DrawSetting.DrawAreaF.left   = ( float )( GSYS.DrawSetting.DrawArea.left   = x1 ) ;
	GSYS.DrawSetting.DrawAreaF.top    = ( float )( GSYS.DrawSetting.DrawArea.top    = y1 ) ;
	GSYS.DrawSetting.DrawAreaF.right  = ( float )( GSYS.DrawSetting.DrawArea.right  = x2 ) ;
	GSYS.DrawSetting.DrawAreaF.bottom = ( float )( GSYS.DrawSetting.DrawArea.bottom = y2 ) ;
	SetMemImgDrawArea( &GSYS.DrawSetting.DrawArea ) ;

	// `\tOZbg
	GSYS.DrawSetting.NotDrawFlagInSetDrawArea = x1 == x2 || y1 == y2 ;
	if( GSYS.DrawSetting.NotDrawFlagInSetDrawArea == FALSE )
	{
		// Direct3D ̃r[|[gs̍XV
		if( GSYS.HardInfo.ScreenAxisYReverse ||
			( GSYS.HardInfo.ScreenAxisYReverse_OnlyDrawValidGraph &&
			  (
#ifndef DX_NON_MASK
				 MASKD.MaskValidFlag ||
#endif
			    ( ( DWORD )GSYS.DrawSetting.TargetScreen[ 0 ] != DX_SCREEN_BACK &&
			      ( DWORD )GSYS.DrawSetting.TargetScreen[ 0 ] != DX_SCREEN_FRONT ) ) ) )
		{
			CreateViewportMatrixD(
				&GSYS.DrawSetting.Direct3DViewportMatrix,
				( double )( GSYS.DrawSetting.DrawArea.right  - GSYS.DrawSetting.DrawArea.left ) / 2.0 + GSYS.DrawSetting.DrawArea.left,
				( double )( GSYS.DrawSetting.DrawArea.bottom - GSYS.DrawSetting.DrawArea.top  ) / 2.0 + GSYS.DrawSetting.DrawArea.top,
				( double )( GSYS.DrawSetting.DrawArea.right  - GSYS.DrawSetting.DrawArea.left ),
				-( double )( GSYS.DrawSetting.DrawArea.bottom - GSYS.DrawSetting.DrawArea.top ) ) ;
		}
		else
		{
			CreateViewportMatrixD(
				&GSYS.DrawSetting.Direct3DViewportMatrix,
				( double )( GSYS.DrawSetting.DrawArea.right  - GSYS.DrawSetting.DrawArea.left ) / 2.0 + GSYS.DrawSetting.DrawArea.left,
				( double )( GSYS.DrawSetting.DrawArea.bottom - GSYS.DrawSetting.DrawArea.top  ) / 2.0 + GSYS.DrawSetting.DrawArea.top,
				( double )( GSYS.DrawSetting.DrawArea.right  - GSYS.DrawSetting.DrawArea.left ),
				( double )( GSYS.DrawSetting.DrawArea.bottom - GSYS.DrawSetting.DrawArea.top  ) ) ;
		}
		CreateInverseMatrixD( &GSYS.DrawSetting.Direct3DViewportMatrixAnti, &GSYS.DrawSetting.Direct3DViewportMatrix ) ;
		GSYS.DrawSetting.MatchHardware_2DMatrix = FALSE ;
		GSYS.DrawSetting.MatchHardware3DMatrix = FALSE ;
		GSYS.DrawSetting.MatchHardwareProjectionMatrix = FALSE ;
		ConvertMatrixDtoF( &GSYS.DrawSetting.Direct3DViewportMatrixAntiF, &GSYS.DrawSetting.Direct3DViewportMatrixAnti ) ;
		ConvertMatrixDtoF( &GSYS.DrawSetting.Direct3DViewportMatrixF,     &GSYS.DrawSetting.Direct3DViewportMatrix ) ;

		// n[hEGAANZ[^gpꍇ̏
		if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		{
			Graphics_Hardware_SetDrawArea_PF( x1, y1, x2, y2 ) ;
		}
	}

	// I
	return 0 ;
}

// `\̈𓾂
extern int NS_GetDrawArea( RECT *Rect )
{
	// Zbg
	*Rect = GSYS.DrawSetting.DrawArea ;

	// I
	return 0 ;
}

// `\̈`ΏۉʑŜɂ
extern int NS_SetDrawAreaFull( void )
{
	int Width, Height ;

	NS_GetGraphSize( GSYS.DrawSetting.TargetScreen[ 0 ], &Width, &Height ) ;
	return NS_SetDrawArea( 0, 0, Width, Height ) ;
}

// Rc`̃XP[Zbg
extern int NS_SetDraw3DScale( float Scale )
{
	// XP[l␳
	if( Scale < 0.00001f && Scale > -0.00001f )
		Scale = 1.0f ;

	// XP[lۑ
	GSYS.DrawSetting.Draw3DScale = Scale ;

	// _̍ČvZ
	NS_SetCameraScreenCenterD( GSYS.Camera.ScreenCenterX, GSYS.Camera.ScreenCenterY ) ;

	// I
	return 0 ;
}

// SetRestoreGraphCallback ̋
extern int NS_SetRestoreShredPoint( void (* ShredPoint )( void ) )
{
	return NS_SetRestoreGraphCallback( ShredPoint ) ;
}

// OtBbNnh֐̓o^
extern	int NS_SetRestoreGraphCallback( void (* Callback )( void ) )
{
	// OtBbNXbhAhX̓o^
	if( Callback == NULL )
	{
		GSYS.Setting.GraphRestoreShred = Graphics_Image_DefaultRestoreGraphFunction ;
	}
	else
	{
		GSYS.Setting.GraphRestoreShred = Callback ;
	}

	// I
	return 0 ;
}

// OtBbN֐̎s
extern	int NS_RunRestoreShred( void )
{
#ifndef DX_NON_ASYNCLOAD
	// 񓯊ǂݍ݂͈ꎞIɖɂ
	int UseASyncThread = GetASyncLoadFlag() ;
	NS_SetUseASyncLoadFlag( FALSE ) ;
#endif

	// OtBbNXbh̎s
	if( GSYS.Setting.GraphRestoreShred == NULL )
	{
		Graphics_Image_DefaultRestoreGraphFunction() ;
	}
	else
	{
		GSYS.Setting.GraphRestoreShred() ;
	}

#ifndef DX_NON_MODEL
	// f̃eNX`ēǂݍ
	MV1ReloadTexture() ;
#endif

#ifndef DX_NON_FONT
	// tHgnhLbV
	InitCacheFontToHandle() ;
#endif

#ifndef DX_NON_ASYNCLOAD
	// 񓯊ǂݍ݂̐ݒɖ߂
	NS_SetUseASyncLoadFlag( UseASyncThread ) ;
#endif

	// I
	return 0 ;
}

// OtBbNXfoCXXg畜AۂɌĂ΂R[obN֐ݒ肷
extern int NS_SetGraphicsDeviceRestoreCallbackFunction( void (* Callback )( void *Data ), void *CallbackData )
{
	return Graphics_Hardware_SetGraphicsDeviceRestoreCallbackFunction_PF( Callback, CallbackData ) ;
}

// OtBbNXfoCXXg畜AOɌĂ΂R[obN֐ݒ肷
extern int NS_SetGraphicsDeviceLostCallbackFunction( void (* Callback )( void *Data ), void *CallbackData )
{
	return Graphics_Hardware_SetGraphicsDeviceLostCallbackFunction_PF( Callback, CallbackData ) ;
}

// Qc`Ɏgpϊsݒ肷( gp̂3s2̂ )
extern int NS_SetTransformTo2D( const MATRIX *Matrix )
{
	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// f[^ۑ
	GSYS.DrawSetting.Valid2DMatrix = TRUE ;
	GSYS.DrawSetting._2DMatrixF = *Matrix ;
	ConvertMatrixFtoD( &GSYS.DrawSetting._2DMatrix, &GSYS.DrawSetting._2DMatrixF ) ;
	GSYS.DrawSetting.MatchHardware_2DMatrix = FALSE ;

	// I
	return 0 ;
}

// Qc`Ɏgpϊsݒ肷( gp̂3s2̂ )
extern int NS_SetTransformTo2DD( const MATRIX_D *Matrix )
{
	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// f[^ۑ
	GSYS.DrawSetting.Valid2DMatrix = TRUE ;
	GSYS.DrawSetting._2DMatrix = *Matrix ;
	ConvertMatrixDtoF( &GSYS.DrawSetting._2DMatrixF, &GSYS.DrawSetting._2DMatrix ) ;
	GSYS.DrawSetting.MatchHardware_2DMatrix = FALSE ;

	// I
	return 0 ;
}

// Qc`pɎgpϊs̐ݒԂɖ߂
extern int NS_ResetTransformTo2D( void )
{
	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// f[^ۑ
	GSYS.DrawSetting.Valid2DMatrix = FALSE ;
	CreateIdentityMatrixD( &GSYS.DrawSetting._2DMatrix ) ;
	CreateIdentityMatrix(  &GSYS.DrawSetting._2DMatrixF ) ;
	GSYS.DrawSetting.MatchHardware_2DMatrix = FALSE ;

	// I
	return 0 ;
}

// [hϊpsZbg
extern	int NS_SetTransformToWorld( const MATRIX *Matrix )
{
	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// f[^ۑ
	GSYS.DrawSetting.WorldMatrixF = *Matrix ;
	ConvertMatrixFtoD( &GSYS.DrawSetting.WorldMatrix, &GSYS.DrawSetting.WorldMatrixF ) ;
	GSYS.DrawSetting.ValidBlend3DMatrix = FALSE ;

	// SĂ̂Rcs|킹sXV
	Graphics_DrawSetting_RefreshBlend3DTransformMatrix() ;

	// n[hEGAANZ[Vɐݒ
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetTransformToWorld_PF( &GSYS.DrawSetting.WorldMatrixF ) ;

		GSYS.DrawSetting.MatchHardwareWorldMatrix = TRUE ;
	}

	// I
	return 0 ;
}

// [hϊpsZbg
extern	int NS_SetTransformToWorldD( const MATRIX_D *Matrix )
{
	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// f[^ۑ
	GSYS.DrawSetting.WorldMatrix = *Matrix ;
	ConvertMatrixDtoF( &GSYS.DrawSetting.WorldMatrixF, &GSYS.DrawSetting.WorldMatrix ) ;
	GSYS.DrawSetting.ValidBlend3DMatrix = FALSE ;

	// SĂ̂Rcs|킹sXV
	Graphics_DrawSetting_RefreshBlend3DTransformMatrix() ;

	// n[hEGAANZ[Vɐݒ
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetTransformToWorld_PF( &GSYS.DrawSetting.WorldMatrixF ) ;

		GSYS.DrawSetting.MatchHardwareWorldMatrix = TRUE ;
	}

	// I
	return 0 ;
}

// [hs擾
extern	int NS_GetTransformToWorldMatrix( MATRIX *MatBuf )
{
	ConvertMatrixDtoF( MatBuf, &GSYS.DrawSetting.WorldMatrix ) ;

	// I
	return 0 ;
}

// [hs擾
extern	int NS_GetTransformToWorldMatrixD( MATRIX_D *MatBuf )
{
	*MatBuf = GSYS.DrawSetting.WorldMatrix ;

	// I
	return 0 ;
}

// r[ϊpsZbg
extern	int NS_SetTransformToView( const MATRIX *Matrix )
{
	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// f[^ۑ
	GSYS.DrawSetting.ViewMatrixF      = *Matrix ;
	ConvertMatrixFtoD( &GSYS.DrawSetting.ViewMatrix, &GSYS.DrawSetting.ViewMatrixF ) ;
	GSYS.DrawSetting.ValidBlend3DMatrix = FALSE ;

	// SĂ̂Rcs|킹sXV
	Graphics_DrawSetting_RefreshBlend3DTransformMatrix() ;

	// n[hEGAANZ[Vɐݒ
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetTransformToView_PF( &GSYS.DrawSetting.ViewMatrixF ) ;

		GSYS.DrawSetting.MatchHardwareViewMatrix = TRUE ;
	}

	// I
	return 0 ;
}

// r[ϊpsZbg
extern	int NS_SetTransformToViewD( const MATRIX_D *Matrix )
{
	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// f[^ۑ
	GSYS.DrawSetting.ViewMatrix       = *Matrix ;
	ConvertMatrixDtoF( &GSYS.DrawSetting.ViewMatrixF, &GSYS.DrawSetting.ViewMatrix ) ;
	GSYS.DrawSetting.ValidBlend3DMatrix = FALSE ;

	// SĂ̂Rcs|킹sXV
	Graphics_DrawSetting_RefreshBlend3DTransformMatrix() ;

	// n[hEGAANZ[Vɐݒ
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetTransformToView_PF( &GSYS.DrawSetting.ViewMatrixF ) ;

		GSYS.DrawSetting.MatchHardwareViewMatrix = TRUE ;
	}

	// I
	return 0 ;
}

// r[s擾
extern	int NS_GetTransformToViewMatrix( MATRIX *MatBuf )
{
	ConvertMatrixDtoF( MatBuf, &GSYS.DrawSetting.ViewMatrix ) ;

	// I
	return 0 ;
}

// r[s擾
extern	int NS_GetTransformToViewMatrixD( MATRIX_D *MatBuf )
{
	*MatBuf = GSYS.DrawSetting.ViewMatrix ;

	// I
	return 0 ;
}

// ˉesݒ肷
extern int NS_SetTransformToProjection( const MATRIX *Matrix )
{
	return NS_SetupCamera_ProjectionMatrix( *Matrix ) ;
}

// ˉesݒ肷
extern int NS_SetTransformToProjectionD( const MATRIX_D *Matrix )
{
	return NS_SetupCamera_ProjectionMatrixD( *Matrix ) ;
}

// ˉes擾
extern	int NS_GetTransformToProjectionMatrix( MATRIX *MatBuf )
{
	*MatBuf = GSYS.DrawSetting.ProjectionMatrixF ;

	// I
	return 0 ;
}

// ˉes擾
extern	int NS_GetTransformToProjectionMatrixD( MATRIX_D *MatBuf )
{
	*MatBuf = GSYS.DrawSetting.ProjectionMatrix ;

	// I
	return 0 ;
}

// r[|[gsZbg
extern	int NS_SetTransformToViewport( const MATRIX *Matrix )
{
	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// f[^ۑ
	GSYS.DrawSetting.ViewportMatrixF   = *Matrix ;
	ConvertMatrixFtoD( &GSYS.DrawSetting.ViewportMatrix, &GSYS.DrawSetting.ViewportMatrixF ) ;
	GSYS.DrawSetting.ValidBlend3DMatrix = FALSE ;

	// SĂ̂Rcs|킹sXV
	Graphics_DrawSetting_RefreshBlend3DTransformMatrix() ;

	// n[hEGAANZ[Vɐݒ
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetTransformToViewport_PF( &GSYS.DrawSetting.ViewportMatrixF ) ;

		GSYS.DrawSetting.MatchHardwareViewMatrix = TRUE ;
	}

	// I
	return 0 ;
}

// r[|[gsZbg
extern	int NS_SetTransformToViewportD( const MATRIX_D *Matrix )
{
	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// f[^ۑ
	GSYS.DrawSetting.ViewportMatrix   = *Matrix ;
	ConvertMatrixDtoF( &GSYS.DrawSetting.ViewportMatrixF, &GSYS.DrawSetting.ViewportMatrix ) ;
	GSYS.DrawSetting.ValidBlend3DMatrix = FALSE ;

	// SĂ̂Rcs|킹sXV
	Graphics_DrawSetting_RefreshBlend3DTransformMatrix() ;

	// n[hEGAANZ[Vɐݒ
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetTransformToViewport_PF( &GSYS.DrawSetting.ViewportMatrixF ) ;

		GSYS.DrawSetting.MatchHardwareViewMatrix = TRUE ;
	}

	// I
	return 0 ;
}

// r[|[gs擾
extern	int NS_GetTransformToViewportMatrix( MATRIX *MatBuf )
{
	*MatBuf = GSYS.DrawSetting.ViewportMatrixF ;

	// I
	return 0 ;
}

// r[|[gs擾
extern	int NS_GetTransformToViewportMatrixD( MATRIX_D *MatBuf )
{
	*MatBuf = GSYS.DrawSetting.ViewportMatrix ;

	// I
	return 0 ;
}

// Direct3DŎKpr[|[gs擾
extern	int NS_GetTransformToAPIViewportMatrix( MATRIX *MatBuf )
{
	*MatBuf = GSYS.DrawSetting.Direct3DViewportMatrixF ;

	// I
	return 0 ;
}

// Direct3DŎKpr[|[gs擾
extern	int NS_GetTransformToAPIViewportMatrixD( MATRIX_D *MatBuf )
{
	*MatBuf = GSYS.DrawSetting.Direct3DViewportMatrix ;

	// I
	return 0 ;
}

// ftHg̕ϊsZbg
#define FOV				(60.0 * DX_PI / 180.0)
#define NEARZ			(0.0)
#define FARZ			(1000.0)
#define TAN_FOV_HALF	(0.52359877559829887307710723054658) // /*(0.57735026918962573)*/ tan( FOV * 0.5 )
extern	int NS_SetDefTransformMatrix( void )
{
	MATRIX_D mat ;
	double D ;
	
	// [hϊs͒Pʍs
	CreateIdentityMatrixD( &mat ) ;
	NS_SetTransformToWorldD( &mat ) ;

	// r[|[gs̃Zbg
	CreateViewportMatrixD(
		&mat,
		( double )GSYS.DrawSetting.DrawSizeX / 2,
		( double )GSYS.DrawSetting.DrawSizeY / 2,
		( double )( GSYS.DrawSetting.DrawSizeX * GSYS.DrawSetting.Draw3DScale ),
		( double )( GSYS.DrawSetting.DrawSizeY * GSYS.DrawSetting.Draw3DScale )
	) ;
	NS_SetTransformToViewportD( &mat ) ;

	// r[s z = 0.0 ̎ɒxXN[ŜʂʒuƕJ
	{
		VECTOR_D up, at, eye ;
		int w, h ;

		w = GSYS.DrawSetting.DrawSizeX ;
		h = GSYS.DrawSetting.DrawSizeY ;
		D = ( double )( ( h / 2 ) / TAN_FOV_HALF ) ;
		eye.x = ( double )w / 2 ;
		eye.y = ( double )h / 2 ;
		eye.z = -D ;

		at.x = eye.x ;
		at.y = eye.y ;
		at.z = eye.z + 1.0 ;

		up.x = 0.0 ;
		up.y = 1.0 ;
		up.z = 0.0 ;

		CreateLookAtMatrixD( &mat, &eye, &at, &up ) ;
		NS_SetTransformToViewD( &mat ) ;
	}

	// vWFNVs͕ʂ
	CreatePerspectiveFovMatrixD( &mat, FOV, D * 0.1, D + FARZ, -1.0f ) ;
	NS_SetTransformToProjectionD( &mat ) ;

	// I
	return 0 ;
}

// [JWʍW擾
extern	int NS_GetTransformPosition( VECTOR *LocalPos, float *x, float *y )
{
	float w ;
	VECTOR ScreenPos ;

	if( LocalPos == NULL ) return -1 ;

	// Wϊ
	w = 1.0F ;
	VectorTransform4(
		&ScreenPos, &w,
		LocalPos,   &w,
		&GSYS.DrawSetting.Blend3DMatrixF
	) ;
	w = 1.0F / w ;

	// ylOȉ̏ꍇ͐Ȃwxl͓Ȃ̂ŃG[
	if( ScreenPos.z * w < 0.0F )
	{
		return -1 ;
	}

	if( x != NULL )
	{
		*x = ScreenPos.x * w ;
	}

	if( y != NULL )
	{
		*y = ScreenPos.y * w ;
	}

	// I
	return 0 ;
}

// [JWʍW擾
extern	int NS_GetTransformPositionD( VECTOR_D *LocalPos, double *x, double *y )
{
	double w ;
	VECTOR_D ScreenPos ;

	if( LocalPos == NULL ) return -1 ;

	// Wϊ
	w = 1.0 ;
	VectorTransform4D(
		&ScreenPos, &w,
		LocalPos,   &w,
		&GSYS.DrawSetting.Blend3DMatrix
	) ;
	w = 1.0 / w ;

	// ylOȉ̏ꍇ͐Ȃwxl͓Ȃ̂ŃG[
	if( ScreenPos.z * w < 0.0 )
	{
		return -1 ;
	}

	if( x != NULL )
	{
		*x = ScreenPos.x * w ;
	}

	if( y != NULL )
	{
		*y = ScreenPos.y * w ;
	}

	// I
	return 0 ;
}

// [hԏ̃r{[h̃TCYXN[ɓeꍇ̃sNZPʂ̃TCY擾
extern float NS_GetBillboardPixelSize( VECTOR WorldPos, float WorldSize )
{
	return ( float )NS_GetBillboardPixelSizeD( VConvFtoD( WorldPos ), WorldSize ) ;
}

// [hԏ̃r{[h̃TCYXN[ɓeꍇ̃sNZPʂ̃TCY擾
extern double NS_GetBillboardPixelSizeD( VECTOR_D WorldPos, double WorldSize )
{
	VECTOR_D ScreenPos, ScreenLeft, ScreenRightDirection ;

	ScreenPos            = NS_ConvWorldPosToScreenPosD( WorldPos ) ;
	ScreenRightDirection = VNormD( VGetD( GSYS.DrawSetting.ViewMatrix.m[ 0 ][ 0 ], GSYS.DrawSetting.ViewMatrix.m[ 1 ][ 0 ], GSYS.DrawSetting.ViewMatrix.m[ 2 ][ 0 ] ) ) ;
	ScreenLeft           = NS_ConvWorldPosToScreenPosD( VSubD( WorldPos, VScaleD( ScreenRightDirection, WorldSize / 2.0 ) ) ) ;
	return VSubD( ScreenPos, ScreenLeft ).x * 2.0 ;
}

// [hWJWɕϊ
extern VECTOR NS_ConvWorldPosToViewPos( VECTOR WorldPos )
{
	return VConvDtoF( NS_ConvWorldPosToViewPosD( VConvFtoD( WorldPos ) ) ) ;
}

// [hWJWɕϊ
extern VECTOR_D NS_ConvWorldPosToViewPosD( VECTOR_D WorldPos )
{
	VECTOR_D ViewPos ;

	VectorTransformD( &ViewPos, &WorldPos, &GSYS.DrawSetting.ViewMatrix ) ;

	return ViewPos ;
}

// [hWXN[Wɕϊ
extern VECTOR NS_ConvWorldPosToScreenPos( VECTOR WorldPos )
{
	float w ;
	VECTOR ScreenPos ;

	// Wϊ
	w = 1.0F ;
	VectorTransform4( &ScreenPos, &w, &WorldPos, &w, &GSYS.DrawSetting.Blend3DMatrixF ) ;

	// ʍWԂ
	w = 1.0F / w ;
	ScreenPos.x *= w ;
	ScreenPos.y *= w ;
	ScreenPos.z *= w ;

	return ScreenPos ;
}

// [hWXN[Wɕϊ
extern VECTOR_D NS_ConvWorldPosToScreenPosD( VECTOR_D WorldPos )
{
	double   w ;
	VECTOR_D ScreenPos ;

	// Wϊ
	w = 1.0 ;
	VectorTransform4D( &ScreenPos, &w, &WorldPos, &w, &GSYS.DrawSetting.Blend3DMatrix ) ;

	// ʍWԂ
	w = 1.0 / w ;
	ScreenPos.x *= w ;
	ScreenPos.y *= w ;
	ScreenPos.z *= w ;

	return ScreenPos ;
}

// [hWXN[WɕϊAŌ̂wxyWvŊO̒l𓾂
extern FLOAT4 NS_ConvWorldPosToScreenPosPlusW( VECTOR WorldPos )
{
	VECTOR ScreenPos ;
	float w ;
	FLOAT4 Result ;

	// Wϊ
	w = 1.0f ;
	VectorTransform4( &ScreenPos, &w, &WorldPos, &w, &GSYS.DrawSetting.Blend3DMatrixF ) ;

	Result.x = ScreenPos.x ;
	Result.y = ScreenPos.y ;
	Result.z = ScreenPos.z ;
	Result.w = w ;

	return Result ;
}

// [hWXN[WɕϊAŌ̂wxyWvŊO̒l𓾂
extern DOUBLE4 NS_ConvWorldPosToScreenPosPlusWD( VECTOR_D WorldPos )
{
	VECTOR_D ScreenPos ;
	double   w ;
	DOUBLE4 Result ;

	// Wϊ
	w = 1.0 ;
	VectorTransform4D( &ScreenPos, &w, &WorldPos, &w, &GSYS.DrawSetting.Blend3DMatrix ) ;

	Result.x = ScreenPos.x ;
	Result.y = ScreenPos.y ;
	Result.z = ScreenPos.z ;
	Result.w = w ;

	return Result ;
}

// XN[W[hWɕϊ
extern VECTOR NS_ConvScreenPosToWorldPos( VECTOR ScreenPos )
{
	float w ;
	VECTOR WorldPos ;

	// uhs̋ts񂪗Lł͂Ȃts\z
	if( GSYS.DrawSetting.ValidInverseBlend3DMatrix == FALSE )
	{
		if( CreateInverseMatrixD( &GSYS.DrawSetting.InverseBlend3DMatrix, &GSYS.DrawSetting.Blend3DMatrix ) < 0 )
		{
			return VGet( -1.0f, -1.0f, -1.0f ) ;
		}
		ConvertMatrixDtoF( &GSYS.DrawSetting.InverseBlend3DMatrixF, &GSYS.DrawSetting.InverseBlend3DMatrix ) ;
		GSYS.DrawSetting.ValidInverseBlend3DMatrix = TRUE ;
	}

	// Wϊ
	w = 1.0F ;
	VectorTransform4( &WorldPos, &w, &ScreenPos, &w, &GSYS.DrawSetting.InverseBlend3DMatrixF ) ;

	// [hWԂ
	w = 1.0F / w ;
	WorldPos.x *= w ;
	WorldPos.y *= w ;
	WorldPos.z *= w ;
	return WorldPos ;
}

// XN[W[hWɕϊ
extern VECTOR_D NS_ConvScreenPosToWorldPosD( VECTOR_D ScreenPos )
{
	double w ;
	VECTOR_D WorldPos ;

	// uhs̋ts񂪗Lł͂Ȃts\z
	if( GSYS.DrawSetting.ValidInverseBlend3DMatrix == FALSE )
	{
		if( CreateInverseMatrixD( &GSYS.DrawSetting.InverseBlend3DMatrix, &GSYS.DrawSetting.Blend3DMatrix ) < 0 )
		{
			return VGetD( -1.0, -1.0, -1.0 ) ;
		}
		ConvertMatrixDtoF( &GSYS.DrawSetting.InverseBlend3DMatrixF, &GSYS.DrawSetting.InverseBlend3DMatrix ) ;
		GSYS.DrawSetting.ValidInverseBlend3DMatrix = TRUE ;
	}

	// Wϊ
	w = 1.0 ;
	VectorTransform4D( &WorldPos, &w, &ScreenPos, &w, &GSYS.DrawSetting.InverseBlend3DMatrix ) ;

	// [hWԂ
	w = 1.0 / w ;
	WorldPos.x *= w ;
	WorldPos.y *= w ;
	WorldPos.z *= w ;
	return WorldPos ;
}

// XN[W[hWɕϊ( ZW` )
extern VECTOR NS_ConvScreenPosToWorldPos_ZLinear( VECTOR ScreenPos )
{
	return VConvDtoF( NS_ConvScreenPosToWorldPos_ZLinearD( VConvFtoD( ScreenPos ) ) ) ;
}

// XN[W[hWɕϊ( ZW` )
extern VECTOR_D NS_ConvScreenPosToWorldPos_ZLinearD( VECTOR_D ScreenPos )
{
	double w, inz ;
	VECTOR_D WorldPos ;

	// uhs̋ts񂪗Lł͂Ȃts\z
	if( GSYS.DrawSetting.ValidInverseBlend3DMatrix == FALSE )
	{
		if( CreateInverseMatrixD( &GSYS.DrawSetting.InverseBlend3DMatrix, &GSYS.DrawSetting.Blend3DMatrix ) < 0 )
		{
			return VGetD( -1.0, -1.0, -1.0 ) ;
		}
		ConvertMatrixDtoF( &GSYS.DrawSetting.InverseBlend3DMatrixF, &GSYS.DrawSetting.InverseBlend3DMatrix ) ;
		GSYS.DrawSetting.ValidInverseBlend3DMatrix = TRUE ;
	}

	// XN[W[hWɕϊۂɎgps񂪗Lł͂Ȃ\z
	if( GSYS.DrawSetting.ValidConvScreenPosToWorldPosMatrix == FALSE )
	{
		MATRIX_D TempMatrix ;

		CreateMultiplyMatrixD( &TempMatrix, &GSYS.DrawSetting.ProjectionMatrix, &GSYS.DrawSetting.ViewportMatrix ) ;
		if( CreateInverseMatrixD( &GSYS.DrawSetting.ConvScreenPosToWorldPosMatrix, &TempMatrix ) < 0 )
		{
			return VGetD( -1.0, -1.0, -1.0 ) ;
		}
		GSYS.DrawSetting.ValidConvScreenPosToWorldPosMatrix = TRUE ;
	}

	// VectorTransform4 ɓnׂ z l߂
	{
		double k1, k2, resz, testz, minz, maxz, sa, target, sikii_plus, sikii_minus ;
		int num ;

		k1 = ScreenPos.x * GSYS.DrawSetting.ConvScreenPosToWorldPosMatrix.m[0][2] + ScreenPos.y * GSYS.DrawSetting.ConvScreenPosToWorldPosMatrix.m[1][2] + GSYS.DrawSetting.ConvScreenPosToWorldPosMatrix.m[3][2] ;
		k2 = ScreenPos.x * GSYS.DrawSetting.ConvScreenPosToWorldPosMatrix.m[0][3] + ScreenPos.y * GSYS.DrawSetting.ConvScreenPosToWorldPosMatrix.m[1][3] + GSYS.DrawSetting.ConvScreenPosToWorldPosMatrix.m[3][3] ;
		target = ScreenPos.z * ( GSYS.DrawSetting.ProjFar - GSYS.DrawSetting.ProjNear ) + GSYS.DrawSetting.ProjNear ;
		testz = 0.5 ;
		sikii_plus  =  ( GSYS.DrawSetting.ProjFar - GSYS.DrawSetting.ProjNear ) / 100000.0 ;
		sikii_minus = -sikii_plus ;
		minz = 0.0 ;
		maxz = 1.0 ;
		for( num = 0 ; num < 20 ; num ++ )
		{
			resz = ( k1 + testz * GSYS.DrawSetting.ConvScreenPosToWorldPosMatrix.m[2][2] ) / ( k2 + testz * GSYS.DrawSetting.ConvScreenPosToWorldPosMatrix.m[2][3] ) ;
			if( resz > target )
			{
				maxz = testz ;
			}
			else
			{
				minz = testz ;
			}
			sa = resz - target ;
			if( sa < 0.0 )
			{
				if( sa > sikii_minus ) break ;
			}
			else
			{
				if( sa < sikii_plus  ) break ;
			}
			testz = ( maxz + minz ) * 0.5 ;
		}
		inz = testz ;
	}

	// Wϊ
	w = 1.0 ;
	ScreenPos.z = inz ;
	VectorTransform4D( &WorldPos, &w, &ScreenPos, &w, &GSYS.DrawSetting.InverseBlend3DMatrix ) ;

	// [hWԂ
	w = 1.0 / w ;
	WorldPos.x *= w ;
	WorldPos.y *= w ;
	WorldPos.z *= w ;
	return WorldPos ;
}



// |SJO̗LAZbg
extern int NS_SetUseCullingFlag( int Flag )
{
	if( GSYS.DrawSetting.CullMode == Flag ) return 0 ;

	// JO[h̃tOۑ
	GSYS.DrawSetting.CullMode = Flag ;
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// |SJO̗LAZbg
extern int NS_SetUseBackCulling( int Flag )
{
	return NS_SetUseCullingFlag( Flag ) ;
}

// |SJO[h擾
extern int NS_GetUseBackCulling( void )
{
	return GSYS.DrawSetting.CullMode ;
}


// eNX`AhX[hݒ肷
extern	int NS_SetTextureAddressMode( int Mode /* DX_TEXADDRESS_WRAP  */, int Stage )
{
	int i ;

	if( Stage == -1 )
	{
		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++ )
		{
			if( GSYS.DrawSetting.TexAddressModeU[ i ] != Mode ||
				GSYS.DrawSetting.TexAddressModeV[ i ] != Mode ||
				GSYS.DrawSetting.TexAddressModeW[ i ] != Mode )
			{
				break ;
			}
		}

		if( i == USE_TEXTURESTAGE_NUM )
		{
			return 0 ;
		}

		// `ҋ@Ă`敨`
		DRAWSTOCKINFO

		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++ )
		{
			GSYS.DrawSetting.TexAddressModeU[ i ] = Mode ;
			GSYS.DrawSetting.TexAddressModeV[ i ] = Mode ;
			GSYS.DrawSetting.TexAddressModeW[ i ] = Mode ;
		}

		GSYS.ChangeSettingFlag = TRUE ;
	}
	else
	{
		if( Stage < 0 || Stage >= USE_TEXTURESTAGE_NUM ) return 0 ;
		if( GSYS.DrawSetting.TexAddressModeU[ Stage ] == Mode &&
			GSYS.DrawSetting.TexAddressModeV[ Stage ] == Mode &&
			GSYS.DrawSetting.TexAddressModeW[ Stage ] == Mode ) return 0;

		// `ҋ@Ă`敨`
		DRAWSTOCKINFO

		GSYS.DrawSetting.TexAddressModeU[ Stage ] = Mode ;
		GSYS.DrawSetting.TexAddressModeV[ Stage ] = Mode ;
		GSYS.DrawSetting.TexAddressModeW[ Stage ] = Mode ;
		GSYS.ChangeSettingFlag = TRUE ;
	}

	// n[hEGAANZ[Vɐݒ
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetTextureAddressMode_PF( Mode, Stage ) ;
	}

	// I
	return 0 ;
}

// eNX`AhX[hݒ肷
extern	int NS_SetTextureAddressModeUV( int ModeU, int ModeV, int Stage )
{
	int i ;

	if( Stage == -1 )
	{
		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++ )
		{
			if( GSYS.DrawSetting.TexAddressModeU[ i ] != ModeU ||
				GSYS.DrawSetting.TexAddressModeV[ i ] != ModeV )
			{
				break ;
			}
		}

		if( i == USE_TEXTURESTAGE_NUM )
		{
			return 0 ;
		}

		// `ҋ@Ă`敨`
		DRAWSTOCKINFO

		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++ )
		{
			GSYS.DrawSetting.TexAddressModeU[ i ] = ModeU ;
			GSYS.DrawSetting.TexAddressModeV[ i ] = ModeV ;
		}

		GSYS.ChangeSettingFlag = TRUE ;
	}
	else
	{
		if( Stage < 0 || Stage >= USE_TEXTURESTAGE_NUM ) return 0 ;
		if( GSYS.DrawSetting.TexAddressModeU[ Stage ] == ModeU &&
			GSYS.DrawSetting.TexAddressModeV[ Stage ] == ModeV ) return 0;

		// `ҋ@Ă`敨`
		DRAWSTOCKINFO

		GSYS.DrawSetting.TexAddressModeU[ Stage ] = ModeU ;
		GSYS.DrawSetting.TexAddressModeV[ Stage ] = ModeV ;
		GSYS.ChangeSettingFlag = TRUE ;
	}

	// n[hEGAANZ[Vɐݒ
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetTextureAddressModeUV_PF( ModeU, ModeV, Stage ) ;
	}

	// I
	return 0 ;
}

// eNX`Wϊp[^Zbg
extern int NS_SetTextureAddressTransform( float TransU, float TransV, float ScaleU, float ScaleV, float RotCenterU, float RotCenterV, float Rotate )
{
	MATRIX Transform, Temp1, Temp2, Temp3 ;
	int UseFlag ;

	UseFlag = FALSE ;

	if( Rotate != 0.0f )
	{
		CreateTranslationMatrix( &Temp1, -RotCenterU, -RotCenterV, 0.0f ) ; 
		CreateRotationZMatrix( &Temp2, Rotate ) ;
		CreateTranslationMatrix( &Temp3,  RotCenterU,  RotCenterV, 0.0f ) ; 
		CreateMultiplyMatrix( &Transform, &Temp1, &Temp2 ) ;
		CreateMultiplyMatrix( &Transform, &Transform, &Temp3 ) ;
		UseFlag = TRUE ;
	}
	else
	{
		CreateIdentityMatrix( &Transform ) ;
	}

	if( TransU != 0.0f || TransV != 0.0f )
	{
		CreateTranslationMatrix( &Temp1, TransU, TransV, 0.0f ) ;
		CreateMultiplyMatrix( &Transform, &Transform, &Temp1 ) ;
		UseFlag = TRUE ;
	}

	if( ScaleU != 1.0f || ScaleV != 1.0f )
	{
		CreateScalingMatrix( &Temp1, ScaleU, ScaleV, 1.0f ) ;
		CreateMultiplyMatrix( &Transform, &Transform, &Temp1 ) ;
		UseFlag = TRUE ;
	}

	// gpȂꍇ͉Ȃ
	if( GSYS.DrawSetting.TextureAddressTransformUse == UseFlag && UseFlag == FALSE )
		return 0 ;

	// ݒۑ
	GSYS.DrawSetting.TextureAddressTransformUse = UseFlag ;
	GSYS.DrawSetting.TextureAddressTransformMatrix = Transform ;
//	GSYS.DrawSetting.TextureMatrixValid = FALSE ;

	// n[hEGAANZ[Vɐݒ
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetTextureAddressTransformMatrix_PF( UseFlag, &Transform ) ;

		GSYS.DrawSetting.MatchHardwareTextureAddressTransformMatrix = TRUE ;
	}

	// I
	return 0 ;
}

// eNX`WϊsZbg
extern int NS_SetTextureAddressTransformMatrix( MATRIX Matrix )
{
	// ݒۑ
	GSYS.DrawSetting.TextureAddressTransformUse    = TRUE ;
//	GSYS.DrawSetting.TextureMatrixValid     = TRUE ;
//	GSYS.TextureMatrix          = Matrix ;
	GSYS.DrawSetting.TextureAddressTransformMatrix = Matrix ;

	// n[hEGAANZ[Vɐݒ
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetTextureAddressTransformMatrix_PF( TRUE, &Matrix ) ;

		GSYS.DrawSetting.MatchHardwareTextureAddressTransformMatrix = TRUE ;
	}

	// I
	return 0 ;
}

// eNX`Wϊp[^Zbg
extern int NS_ResetTextureAddressTransform( void )
{
	return NS_SetTextureAddressTransform( 0.0f, 0.0f, 1.0f, 1.0f, 0.0f, 0.0f, 0.0f ) ;
}

// tHOLɂ邩ǂݒ肷( TRUE:L  FALSE: )
extern int NS_SetFogEnable( int Flag )
{
	if( GSYS.DrawSetting.FogEnable == Flag ) return 0;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	GSYS.DrawSetting.FogEnable = Flag ;
	GSYS.ChangeSettingFlag     = TRUE ;

	// n[hEGAANZ[Vɐݒ
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetFogEnable_PF( Flag ) ;
	}

	// I
	return 0 ;
}

// tHOLǂ擾( TRUE:L  FALSE: )
extern int NS_GetFogEnable( void )
{
	return GSYS.DrawSetting.FogEnable ;
}

// tHO[hݒ肷
extern	int NS_SetFogMode( int Mode /* DX_FOGMODE_NONE  */ )
{
	if( GSYS.DrawSetting.FogMode == Mode ) return 0;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	GSYS.DrawSetting.FogMode = Mode ;

	// n[hEGAANZ[Vɐݒ
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetFogMode_PF( Mode ) ;
	}

	// I
	return 0 ;
}

// tHO[h擾
extern int NS_GetFogMode( void )
{
	return GSYS.DrawSetting.FogMode ;
}

// tHOJ[ύX
extern	int NS_SetFogColor( int r, int g, int b )
{
	DWORD color = ( DWORD )( ( ( 0xff ) << 24 ) | ( ( r & 0xff ) << 16 ) | ( ( g & 0xff ) << 8 ) | ( b & 0xff ) ) ;

	if( GSYS.DrawSetting.FogColor == color ) return 0;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	GSYS.DrawSetting.FogColor = color ;

	// n[hEGAANZ[Vɐݒ
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetFogColor_PF( color ) ;
	}

	// I
	return 0 ;
}

// tHOJ[擾
extern	int NS_GetFogColor( int *r, int *g, int *b )
{
	if( r != NULL )
	{
		*r = ( int )( ( GSYS.DrawSetting.FogColor >> 16 ) & 0xff ) ;
	}

	if( g != NULL )
	{
		*g = ( int )( ( GSYS.DrawSetting.FogColor >> 8  ) & 0xff ) ;
	}

	if( b != NULL )
	{
		*b = ( int )( ( GSYS.DrawSetting.FogColor       ) & 0xff ) ;
	}

	return 0 ;
}

// tHOn܂鋗ƏI鋗ݒ肷( 0.0f ` 1.0f )
extern	int	NS_SetFogStartEnd( float start, float end )
{
	if( GSYS.DrawSetting.FogStart == start && GSYS.DrawSetting.FogEnd == end ) return 0 ;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	GSYS.DrawSetting.FogStart = start ;
	GSYS.DrawSetting.FogEnd = end ;

	// n[hEGAANZ[Vɐݒ
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetFogStartEnd_PF( start, end ) ;
	}

	// I
	return 0 ;
}

// tHOn܂鋗ƏI鋗擾( 0.0f ` 1.0f )
extern	int NS_GetFogStartEnd( float *start, float *end )
{
	if( start != NULL )
	{
		*start = GSYS.DrawSetting.FogStart ;
	}

	if( end != NULL )
	{
		*end = GSYS.DrawSetting.FogEnd ;
	}

	return 0 ;
}

// tHO̖xݒ肷( 0.0f ` 1.0f )
extern	int	NS_SetFogDensity( float density )
{
	if( GSYS.DrawSetting.FogDensity == density ) return 0;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	GSYS.DrawSetting.FogDensity = density ;

	// n[hEGAANZ[Vɐݒ
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetFogDensity_PF( density ) ;
	}

	// I
	return 0 ;
}

// tHO̖x擾( 0.0f ` 1.0f )
extern float NS_GetFogDensity( void )
{
	return GSYS.DrawSetting.FogDensity ;
}


























// ʊ֌W֐

#ifndef DX_COMPILE_TYPE_C_LANGUAGE
// wW̐F擾
extern unsigned int NS_GetPixel( int x, int y )
{
	return NS_GetPixelDX( x, y ) ;
}
#endif // DX_COMPILE_TYPE_C_LANGUAGE

// wW̐F擾
extern unsigned int NS_GetPixelDX( int x, int y )
{
	unsigned int Ret = 0xffffffff ;

	// `W`FbN
	if( x < 0 || y < 0 || x >= GSYS.DrawSetting.DrawSizeX || y >= GSYS.DrawSetting.DrawSizeY ) return 0xffffffff ;

	// n[hEGA@\gp邩ǂŏ𕪊
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		// n[hEFAgpꍇ

		Ret = Graphics_Hardware_GetPixel_PF( x, y ) ;
	}
	else
	{
		MEMIMG    *Img ;
		IMAGEDATA *Image ;

		// n[hEFAgpȂꍇ

		// G[
		if( GRAPHCHKFULL( GSYS.DrawSetting.TargetScreen[ 0 ], Image ) )
			Image = NULL ;

		// `ɂď𕪊
		if( Image )
		{
			Img = &Image->Soft.MemImg ;
		}
		else
		{
			Img = &GSYS.SoftRender.MainBufferMemImg ;
		}

		switch( GSYS.Screen.MainScreenColorBitDepth )
		{
		case 16 : Ret = *( (  WORD * )( ( char * )Img->UseImage + 2 * x + Img->Base->Pitch * y ) ) ; break ;
		case 32 : Ret = *( ( DWORD * )( ( char * )Img->UseImage + 4 * x + Img->Base->Pitch * y ) ) ; break ;
		}
	}

	// I
	return Ret ;
}

// wW̐F擾( float^ )
extern COLOR_F NS_GetPixelF( int x, int y )
{
	// `W`FbN
	if( x < 0 || y < 0 || x >= GSYS.DrawSetting.DrawSizeX || y >= GSYS.DrawSetting.DrawSizeY )
	{
		return NS_GetColorF( -1.0f, -1.0f, -1.0f, -1.0f ) ;
	}

	// n[hEGA@\gp邩ǂŏ𕪊
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		// n[hEFAgpꍇ
		return Graphics_Hardware_GetPixelF_PF( x, y ) ;
	}
	else
	{
		// n[hEFAgpȂꍇ
		unsigned int Color = NS_GetPixelDX( x, y ) ;
		COLOR_F Result ;
		int ri, gi, bi, ai ;
		COLORDATA *ColorData = GetMemImgColorData( GSYS.Screen.MainScreenColorBitDepth == 16 ? 0 : 1, FALSE, FALSE ) ;

		NS_GetColor5( ColorData, Color, &ri, &gi, &bi, &ai ) ;

		Result.r = ( float )ri / 255.0f ;
		Result.g = ( float )gi / 255.0f ;
		Result.b = ( float )bi / 255.0f ;
		Result.a = ( float )ai / 255.0f ;
		return Result ;
	}
}

// CEChẼobNOEhJ[ݒ肷
extern int NS_SetBackgroundColor( int Red, int Green, int Blue, int Alpha )
{
	// F̕ۑ
	GSYS.Screen.BackgroundRed   = Red ;
	GSYS.Screen.BackgroundGreen = Green ;
	GSYS.Screen.BackgroundBlue  = Blue ;
	GSYS.Screen.BackgroundAlpha = Alpha ;

	// obNOEhJ[Lǂ̃tO𗧂Ă
	GSYS.Screen.EnableBackgroundColor = TRUE ;

	// n[hEGAANZ[Vɐݒ
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_SetBackgroundColor_PF( Red, Green, Blue, Alpha ) ;
	}

	// I
	return 0;
}

// CEChẼobNOEhJ[擾
extern int NS_GetBackgroundColor( int *Red, int *Green, int *Blue, int *Alpha )
{
	if( Red != NULL )
	{
		*Red = GSYS.Screen.BackgroundRed ;
	}

	if( Green != NULL )
	{
		*Green = GSYS.Screen.BackgroundGreen ;
	}

	if( Blue != NULL )
	{
		*Blue = GSYS.Screen.BackgroundBlue ;
	}

	if( Alpha != NULL )
	{
		*Alpha = GSYS.Screen.BackgroundAlpha ;
	}

	// I
	return 0;
}

// ANeBuɂȂĂʂẅ̃OtBbN擾
extern	int NS_GetDrawScreenGraph( int x1, int y1, int x2, int y2, int GrHandle, int /*UseClientFlag*/ )
{
	IMAGEDATA *Image ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;

	// 荞݃TCYƉ摜TCYႤꍇ̓G[
	if( Image->WidthI != x2 - x1 || Image->HeightI != y2 - y1 ) return -1 ;

	return Graphics_Image_GetDrawScreenGraphBase( GSYS.DrawSetting.TargetScreen[ 0 ], GSYS.DrawSetting.TargetScreenSurface[ 0 ], GSYS.DrawSetting.TargetScreenMipLevel[ 0 ], x1, y1, x2, y2, 0, 0, GrHandle ) ;
}

// `\摜ẅ̃OtBbN擾
extern int NS_BltDrawValidGraph( int TargetDrawValidGrHandle, int x1, int y1, int x2, int y2, int DestX, int DestY, int DestGrHandle )
{
	IMAGEDATA *Image ;

	// G[
	if( GRAPHCHK( TargetDrawValidGrHandle, Image ) )
		return -1 ;

	return Graphics_Image_GetDrawScreenGraphBase( TargetDrawValidGrHandle, 0, 0, x1, y1, x2, y2, DestX, DestY, DestGrHandle ) ;
}

// ʂƕ\ʂ
extern int NS_ScreenFlip( void )
{
	return Graphics_Screen_FlipBase() ;
}

// ScreenCopy ̃x[X֐
extern int Graphics_Screen_ScreenCopyBase( int DrawTargetFrontScreenMode_Copy )
{
	if( GSYS.Setting.ValidHardware )
	{
		Graphics_Hardware_ScreenCopy_PF( DrawTargetFrontScreenMode_Copy ) ;
	}

	// tbv
	return Graphics_Screen_FlipBase() ;
}

// w̋`̈ɍł߂fBXvCԂ
extern const GRAPHICSSYS_DISPLAYINFO *Graphics_GetRectMatchDisplayInfo( const RECT *Rect )
{
	int i ;
	int MaxMatchIndex = -1 ;
	int MaxMatchAreaSize = 0 ;
	GRAPHICSSYS_DISPLAYINFO *DisplayInfo ;

	if( GSYS.Screen.DisplayInfo == NULL )
	{
		return NULL ;
	}

	DisplayInfo = GSYS.Screen.DisplayInfo ;
	for( i = 0 ; i < GSYS.Screen.DisplayNum ; i ++, DisplayInfo ++ )
	{
		int MatchWidth = 0 ;
		int MatchHeight = 0 ;

		if( Rect->left <= DisplayInfo->DesktopRect.left && DisplayInfo->DesktopRect.left < Rect->right )
		{
			MatchWidth = ( DisplayInfo->DesktopRect.right < Rect->right ? DisplayInfo->DesktopRect.right : Rect->right ) - DisplayInfo->DesktopRect.left ;
		}
		else
		if( DisplayInfo->DesktopRect.left <= Rect->left && Rect->left < DisplayInfo->DesktopRect.right )
		{
			MatchWidth = ( DisplayInfo->DesktopRect.right < Rect->right ? DisplayInfo->DesktopRect.right : Rect->right ) - Rect->left ;
		}
		else
		{
			continue ;
		}

		if( Rect->top <= DisplayInfo->DesktopRect.top && DisplayInfo->DesktopRect.top < Rect->bottom )
		{
			MatchHeight = ( DisplayInfo->DesktopRect.bottom < Rect->bottom ? DisplayInfo->DesktopRect.bottom : Rect->bottom ) - DisplayInfo->DesktopRect.top ;
		}
		else
		if( DisplayInfo->DesktopRect.top <= Rect->top && Rect->top < DisplayInfo->DesktopRect.bottom )
		{
			MatchHeight = ( DisplayInfo->DesktopRect.bottom < Rect->bottom ? DisplayInfo->DesktopRect.bottom : Rect->bottom ) - Rect->top ;
		}
		else
		{
			continue ;
		}

		if( MaxMatchIndex == -1 || MatchWidth * MatchHeight > MaxMatchAreaSize )
		{
			MaxMatchIndex = i ;
			MaxMatchAreaSize = MatchWidth * MatchHeight ;
		}
	}

	return MaxMatchIndex < 0 ? NULL : &GSYS.Screen.DisplayInfo[ MaxMatchIndex ] ;
}

// SetUserScreenImage Ŏw肷sNZtH[}bg COLORDATA 擾
extern COLORDATA *Graphics_Screen_UserScreenPixelFormatColorData( int PixelFormat /* DX_USER_SCREEN_PIXEL_FORMAT_R5G6B5  */ )
{
	volatile static int InitializeFlag = FALSE ;
	static COLORDATA R5G6B5_ColorData ;
	static COLORDATA R5G5B5X1_ColorData ;
	static COLORDATA X1R5G5B5_ColorData ;
	static COLORDATA X8B8G8R8_ColorData ;
	static COLORDATA X8R8G8B8_ColorData ;

	if( InitializeFlag == FALSE )
	{
		NS_CreateColorData( &R5G6B5_ColorData,         16, 0x0000f800, 0x000007e0, 0x0000001f, 0x00000000, 0, 0, FALSE ) ;
		NS_CreateColorData( &R5G5B5X1_ColorData,       16, 0x0000f800, 0x000007c0, 0x0000003e, 0x00000000, 0, 0, FALSE ) ;
		NS_CreateColorData( &X1R5G5B5_ColorData,       16, 0x00007c00, 0x000003e0, 0x0000001f, 0x00000000, 0, 0, FALSE ) ;
		NS_CreateColorData( &X8B8G8R8_ColorData,       32, 0x000000ff, 0x0000ff00, 0x00ff0000, 0x00000000, 0, 0, FALSE ) ;
		NS_CreateColorData( &X8R8G8B8_ColorData,       32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0x00000000, 0, 0, FALSE ) ;
		InitializeFlag = TRUE ;
	}

	switch( PixelFormat )
	{
	case DX_USER_SCREEN_PIXEL_FORMAT_R5G6B5 :       return &R5G6B5_ColorData ;
	case DX_USER_SCREEN_PIXEL_FORMAT_R5G5B5X1 :     return &R5G5B5X1_ColorData ;
	case DX_USER_SCREEN_PIXEL_FORMAT_X1R5G5B5 :     return &X1R5G5B5_ColorData ;
	case DX_USER_SCREEN_PIXEL_FORMAT_X8B8G8R8 :     return &X8B8G8R8_ColorData ;
	case DX_USER_SCREEN_PIXEL_FORMAT_X8R8G8B8 :     return &X8R8G8B8_ColorData ;
	}
	return NULL ;
}

// ʂ̓e\ʂɕ`悷
extern int NS_ScreenCopy( void )
{
	return Graphics_Screen_ScreenCopyBase( FALSE ) ;
}

// M҂
extern	int		NS_WaitVSync( int SyncNum )
{
	return Graphics_Hardware_WaitVSync_PF( SyncNum ) ;
}

// ʂ̏Ԃ
extern	int NS_ClearDrawScreen( const RECT *ClearRect )
{
//	HRESULT hr ;
//	RECT Rect ;

	// tXN[}XNsĂꍇ̓}XN`̌ʂ𔽉f
	MASK_FULLSCREEN_MASKUPDATE

	// `FbN
	if( ClearRect && ( ClearRect->left < 0 || ClearRect->top < 0 ) )
		ClearRect = NULL ;

	// n[hEGA@\gĂ邩ǂŏ𕪊
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		// n[hEGA̋@\gĂꍇ
		Graphics_Hardware_ClearDrawScreen_PF( ClearRect ) ;
	}
	else
	{
		IMAGEDATA *Image = NULL ;
		MEMIMG    *ClearTarget ;

		// \tgEGA_Ȍꍇ

		// `摜̉摜擾
		GRAPHCHKFULL( GSYS.DrawSetting.TargetScreen[ 0 ], Image ) ;

		// `\摜̏ꍇ͂̉摜NA
		ClearTarget = Image ? &Image->Soft.MemImg : &GSYS.SoftRender.MainBufferMemImg ;
		ClearMemImg( ClearTarget, ClearRect, NS_GetColor3( ClearTarget->Base->ColorDataP, GSYS.Screen.BackgroundRed, GSYS.Screen.BackgroundGreen, GSYS.Screen.BackgroundBlue, GSYS.Screen.BackgroundAlpha ) ) ;
	}

	// I
	return 0 ;
}

// ʂ̂yobt@̏Ԃ
extern int NS_ClearDrawScreenZBuffer( const RECT *ClearRect )
{
	// `FbN
	if( ClearRect && ( ClearRect->left < 0 || ClearRect->top < 0 ) )
		ClearRect = NULL ;

	// n[hEGA@\gĂ邩ǂŏ𕪊
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		// n[hEGA̋@\gĂꍇ
		Graphics_Hardware_ClearDrawScreenZBuffer_PF( ClearRect ) ;
	}
	else
	{
		// \tgEGA_Ȍꍇ͉Ȃ
	}

	// I
	return 0 ;
}

// ʂ̏Ԃ(ClearDrawScreen̋)
extern int NS_ClsDrawScreen( void )
{
	return NS_ClearDrawScreen( NULL ) ;
}

// `ʂ̃Zbg
extern	int NS_SetDrawScreen( int DrawScreen )
{
	int OldScreen ;
	int OldScreenSurface ;
	int OldScreenMipLevel ;
#ifndef DX_NON_MASK
	int MaskUseFlag ;
#endif
//	int Result ;
	IMAGEDATA     *Image        = NULL ;
	IMAGEDATA     *OldImage     = NULL ;
	SHADOWMAPDATA *ShadowMap    = NULL ;
	SHADOWMAPDATA *OldShadowMap = NULL ;
	
	if( GSYS.InitializeFlag == FALSE ) return -1 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// OtBbN`悪܂łƓꍇI
//	if( DrawScreen == GSYS.DrawSetting.TargetScreen[ 0 ] && GSYS.DrawSetting.TargetScreenSurface == 0 ) return 0 ;

	// 摜̎擾
	if( GSYS.DrawSetting.ShadowMapDrawSetupRequest )
	{
		// AhX̎擾
		if( SHADOWMAPCHK( DrawScreen, ShadowMap ) )
			return -1 ;
	}
	else
	{
		Image = NULL ;
		if( !GRAPHCHKFULL( DrawScreen, Image ) )
		{
			// 摜ꍇ͕`\ł͖ꍇ̓G[
			if( Image->Orig->FormatDesc.DrawValidFlag == FALSE )
				return -1 ;
		}
		else
		{
			if( Image != NULL )
			{
				return -1 ;
			}
		}
	}

	// ܂ł̕`̉摜̎擾
	if( GRAPHCHKFULL( GSYS.DrawSetting.TargetScreen[ 0 ], OldImage ) )
	{
		OldImage = NULL ;
		if( SHADOWMAPCHKFULL( GSYS.DrawSetting.TargetScreen[ 0 ], OldShadowMap ) )
		{
			OldShadowMap = NULL ;
		}
	}

	// w肵XN[牽I
	if( ( DWORD )DrawScreen != DX_SCREEN_FRONT && ( DWORD )DrawScreen != DX_SCREEN_BACK &&
		( DWORD )DrawScreen != DX_SCREEN_WORK  && ( DWORD )DrawScreen != DX_SCREEN_TEMPFRONT &&
		ShadowMap == NULL &&
		( ( DrawScreen & DX_HANDLEERROR_MASK ) != 0                   ||
		  ( DrawScreen & DX_HANDLETYPE_MASK  ) != DX_HANDLETYPE_MASK_GRAPH || 
		  GetHandleInfo( DrawScreen ) == NULL ) )
	{
		return -1 ;
	}

	// ܂ł̉ʂ\ʂꍇ͈x ScreenCopy s
	if( ( DWORD )GSYS.DrawSetting.TargetScreen[ 0 ] == DX_SCREEN_FRONT )
	{
		Graphics_Screen_ScreenCopyBase( TRUE ) ;
	}

	// VhE}bvւ̕`ݒ肪Ă
	if( GSYS.DrawSetting.ShadowMapDraw )
	{
		NS_ShadowMap_DrawEnd() ;
	}

#ifndef DX_NON_MASK
	// }XNgpI葱
	MaskUseFlag = MASKD.MaskUseFlag ;
	NS_SetUseMaskScreenFlag( FALSE ) ;

	// `̃TCYŃ}XNʂ쐬Ȃ
	if( GSYS.DrawSetting.ShadowMapDrawSetupRequest == FALSE && MASKD.CreateMaskFlag )
	{
		int w, h ;
		NS_GetGraphSize( DrawScreen, &w, &h ) ;
		Mask_CreateScreenFunction( TRUE, w, h ) ;
	}
#endif

	// `ۑ
	OldScreen                                  = GSYS.DrawSetting.TargetScreen[ 0 ] ;
	OldScreenSurface                           = GSYS.DrawSetting.TargetScreenSurface[ 0 ] ;
	OldScreenMipLevel                          = GSYS.DrawSetting.TargetScreenMipLevel[ 0 ] ;
	GSYS.DrawSetting.TargetScreen[ 0 ]         = DrawScreen ;
	GSYS.DrawSetting.TargetScreenSurface[ 0 ]  = 0 ;
	GSYS.DrawSetting.TargetScreenMipLevel[ 0 ] = 0 ;

	// `\TCY̎擾
	NS_GetGraphSize( DrawScreen, &GSYS.DrawSetting.DrawSizeX, &GSYS.DrawSetting.DrawSizeY ) ;

	// `ɐlނǂ̃tOXV
	Graphics_DrawSetting_RefreshAlphaChDrawMode() ;

	// Rc`֌W̕`Zbg
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		// n[hEGAANZ[^gpꍇ̏
		Graphics_Hardware_SetDrawScreen_PF( DrawScreen, OldScreenSurface, OldScreenMipLevel, Image, OldImage, ShadowMap, OldShadowMap ) ;
	}
	else
	{
		// \tgEGA_Ȍꍇ̏

		// `̌
#ifndef DX_NON_MASK
		if( MASKD.MaskValidFlag )
		{
			// }XNLȏꍇ̓}XN`ɂ
			GSYS.SoftRender.TargetMemImg = &MASKD.MaskDrawMemImg ;
		}
		else
#endif
		{
			// 摜`Ώۂǂŏ𕪊
			if( Image != NULL )
			{
				// At@`lt̉摜̏ꍇ͕`ΏۂɂłȂ
				if( Image->Soft.MemImg.Base->UseAlpha == TRUE )
					return -1 ;

				// `\摜`
				GSYS.SoftRender.TargetMemImg = &Image->Soft.MemImg ;
			}
			else
			{
				// Cobt@`
				GSYS.SoftRender.TargetMemImg = &GSYS.SoftRender.MainBufferMemImg ;
			}
		}
	}

	// Qc`p̍s쐬
//	{
//		CreateViewportMatrix(
//			&GSYS.DrawSetting.ViewportMatrix2D,
//			GSYS.DrawSetting.DrawSizeX / 2.0f,
//			GSYS.DrawSetting.DrawSizeY / 2.0f, 
//			( float )GSYS.DrawSetting.DrawSizeX,
//			( float )GSYS.DrawSetting.DrawSizeY
//		) ;
//
//		CreateIdentityMatrix( &GSYS.DrawSetting.ProjectionMatrix2D ) ;
//		GSYS.DrawSetting.ProjectionMatrix2D.m[ 0 ][ 0 ] =  1.0f / ( ( float )GSYS.DrawSetting.DrawSizeX / 2.0f ) ;
//		GSYS.DrawSetting.ProjectionMatrix2D.m[ 1 ][ 1 ] = -1.0f / ( ( float )GSYS.DrawSetting.DrawSizeY / 2.0f ) ;
//		GSYS.DrawSetting.ProjectionMatrix2D.m[ 3 ][ 0 ] = -1.0f ;
//		GSYS.DrawSetting.ProjectionMatrix2D.m[ 3 ][ 1 ] =  1.0f ;
//	}

	// `̈XV
	{
		RECT SrcRect ;
		int NewWidth = 0, NewHeight = 0, OldWidth = 0, OldHeight = 0 ;

		NS_GetGraphSize( DrawScreen, &NewWidth, &NewHeight ) ;
		NS_GetGraphSize( OldScreen,  &OldWidth, &OldHeight ) ;

		SrcRect = GSYS.DrawSetting.DrawArea ;

		if( GSYS.DrawSetting.SetDrawScreenNoSettingResetFlag )
		{
			if( GSYS.DrawSetting.ShadowMapDrawSetupRequest )
			{
				RECT OriginalDrawRect = GSYS.DrawSetting.OriginalDrawRect ;

				NS_SetDrawArea( 0, 0, NewWidth, NewHeight ) ;

				GSYS.DrawSetting.OriginalDrawRect = OriginalDrawRect ;
			}
			else
			{
				NS_SetDrawArea(
					GSYS.DrawSetting.OriginalDrawRect.left,
					GSYS.DrawSetting.OriginalDrawRect.top,
					GSYS.DrawSetting.OriginalDrawRect.right,
					GSYS.DrawSetting.OriginalDrawRect.bottom
				) ;
			}
		}
		else
		{
//			if( GSYS.DrawSetting.ShadowMapDrawSetupRequest || ( NewWidth != OldWidth ) || ( NewHeight != OldHeight ) )
//			{
				NS_SetDrawArea( 0, 0, NewWidth, NewHeight ) ;
//			}
//			else
//			{
//				NS_SetDrawArea( SrcRect.left, SrcRect.top, SrcRect.right, SrcRect.bottom ) ;
//			}
		}
	}
		
	// Rc`揈p̍sݒ̏s
	if( GSYS.DrawSetting.SetDrawScreenNoSettingResetFlag == FALSE )
	{
		MATRIX mat ;
		float D ;

		// hbgAXyNgPDOɖ߂
		NS_SetCameraDotAspect( 1.0f ) ;

		// [hϊs͒Pʍs
		CreateIdentityMatrix( &mat ) ;
		NS_SetTransformToWorld( &mat ) ;

		// CuǗ̃r[|[gsXV
		GSYS.Camera.ScreenCenterX = ( double )GSYS.DrawSetting.DrawSizeX / 2.0 ;
		GSYS.Camera.ScreenCenterY = ( double )GSYS.DrawSetting.DrawSizeY / 2.0 ;
		NS_SetCameraScreenCenterD( GSYS.Camera.ScreenCenterX, GSYS.Camera.ScreenCenterY ) ;

		// r[s z = 0.0 ̎ɒxXN[ŜʂʒuƕJ
		{
			VECTOR up, at, eye ;

			D = (float)( ( GSYS.DrawSetting.DrawSizeY / 2 ) / DEFAULT_TAN_FOV_HALF ) ;

			eye.x = (float)GSYS.DrawSetting.DrawSizeX / 2 ;
			eye.y = (float)GSYS.DrawSetting.DrawSizeY / 2 ;
			eye.z = -D;
			
			at.x = eye.x ;
			at.y = eye.y ;
			at.z = eye.z + 1.0F ;
			
			up.x = 0.0f ;
			up.y = 1.0F ;
			up.z = 0.0f ;
			
			NS_SetCameraPositionAndTargetAndUpVec( eye, at, up ) ;
//				CreateLookAtMatrix( &mat, &eye, &at, &up ) ;
//				NS_SetTransformToView( &mat ) ;
		}

		// vWFNVs͕ʂ
		NS_SetupCamera_Perspective( DEFAULT_FOV ) ;
		NS_SetCameraNearFar( D * 0.1f + DEFAULT_NEAR, D + DEFAULT_FAR ) ;
	}

#ifndef DX_NON_MASK
	// }XNgp葱
	NS_SetUseMaskScreenFlag( MaskUseFlag ) ;
#endif

	// VhE}bvɑ΂`揀NGXgꍇ̓NGXgtO|A`揀Ԃۑ
	if( GSYS.DrawSetting.ShadowMapDrawSetupRequest )
	{
		GSYS.DrawSetting.ShadowMapDrawSetupRequest = FALSE ;

		// VhE}bvɑ΂`ł邩ǂ̃tO𗧂Ă
		GSYS.DrawSetting.ShadowMapDraw = TRUE ;

		// VhE}bvɑ΂`̏ꍇ́AΏۂƂȂVhE}bṽnhۑ
		GSYS.DrawSetting.ShadowMapDrawHandle = DrawScreen ;
	}

	// SetDrawScreen ̌ɍsˑs
	Graphics_Hardware_SetDrawScreen_Post_PF( DrawScreen ) ;

	// I
	return 0 ;
}

// `ʂ̎擾
extern int NS_GetDrawScreen( void )
{
	return GSYS.DrawSetting.TargetScreen[ 0 ] ;
}

// ANeBuɂȂĂOtBbÑnh𓾂
extern int NS_GetActiveGraph( void )
{
	return NS_GetDrawScreen() ;
}

// SetDrawScreen sۂɃJ`͈͂̐ݒZbg邩ݒ肷( UseFlag  TRUE:Zbg( ftHg )  FALSE:ZbgȂ )
extern	int NS_SetUseSetDrawScreenSettingReset( int UseFlag )
{
	GSYS.DrawSetting.SetDrawScreenNoSettingResetFlag = UseFlag ? FALSE : TRUE ;

	// I
	return 0 ;
}

// SetDrawScreen sۂɃJ`͈͂̐ݒZbg邩擾
extern	int NS_GetUseSetDrawScreenSettingReset( void )
{
	return GSYS.DrawSetting.SetDrawScreenNoSettingResetFlag ? FALSE : TRUE ;
}

// `yobt@̃Zbg
extern	int	NS_SetDrawZBuffer( int DrawScreen )
{
	IMAGEDATA *Image ;
	
	if( GSYS.InitializeFlag == FALSE ) return -1 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// 摜̎擾
	Image = NULL ;
	GRAPHCHKFULL( DrawScreen, Image ) ;

	// ˑ
	if( Graphics_Hardware_SetDrawZBuffer_PF( DrawScreen, Image ) < 0 )
	{
		return -1 ;
	}

	// `yobt@̃nhۑ
	GSYS.DrawSetting.TargetZBuffer = DrawScreen ;

	// `yobt@XV
	Graphics_Screen_SetupUseZBuffer() ;

	// I
	return 0 ;
}

// ʃ[h̃Zbg
extern int NS_SetGraphMode( int ScreenSizeX, int ScreenSizeY, int ColorBitDepth, int RefreshRate )
{
	int Width ;
	int Height ;
	int CDepth ;
	int RRate ;
//	int MaxScreenSizeX ;
//	int MaxScreenSizeY ;

	if( ColorBitDepth == 0 )
	{
		ColorBitDepth = DEFAULT_COLOR_BITDEPTH ;
	}

	// RQO~QSỎʂG~[VtOĂꍇ͋Iɉ𑜓xRQO~QSOɂ
	if( GSYS.Screen.Emulation320x240Flag )
	{
		ScreenSizeX = 320 ;
		ScreenSizeY = 240 ;
	}

	// G[`FbN
	if( ScreenSizeX <= 0 ||
		ScreenSizeY <= 0 ||
		( ColorBitDepth != 0 && ColorBitDepth != 8 && ColorBitDepth != 16 && ColorBitDepth != 32 ) )
	{
		return DX_CHANGESCREEN_RETURN ;
	}

	// j^ΉĂ𑜓xł͖Aj^ΉĂő𑜓x傫𑜓xw肳ꂽꍇ̓G[
//	if( Graphics_Screen_CheckDisplaySetting( ScreenSizeX, ScreenSizeY, ColorBitDepth ) == FALSE )
//	{
//		NS_GetDisplayMaxResolution( &MaxScreenSizeX, &MaxScreenSizeY ) ;
//		if( MaxScreenSizeX < ScreenSizeX || MaxScreenSizeY < ScreenSizeY )
//		{
//			return -1 ;
//		}
//	}

	// Ȍꍇ͐ݒlۑ
	if( DxSysData.DxLib_InitializeFlag == FALSE )
	{
		Graphics_Screen_SetMainScreenSize( ScreenSizeX, ScreenSizeY ) ;
		GSYS.Screen.MainScreenColorBitDepth = ColorBitDepth ;
		GSYS.Screen.MainScreenRefreshRate   = RefreshRate ;
		SetMemImgDefaultColorType( ColorBitDepth == 32 ? 1 : 0 ) ;
		return 0 ;
	}

	// ̒lĂ
	Width	= GSYS.Screen.MainScreenSizeX ;
	Height	= GSYS.Screen.MainScreenSizeY ;
	CDepth	= GSYS.Screen.MainScreenColorBitDepth ;
	RRate	= GSYS.Screen.MainScreenRefreshRate ;

	// ʃ[hύX
	Graphics_Screen_ChangeMode( ScreenSizeX, ScreenSizeY, ColorBitDepth, FALSE, RefreshRate ) ;

	// ߂l̃Zbg
	if( ScreenSizeX == GSYS.Screen.MainScreenSizeX &&
		ScreenSizeY == GSYS.Screen.MainScreenSizeY 
#ifdef WINDOWS_DESKTOP_OS
		&&
		(
		  NS_GetWindowModeFlag() == FALSE ||
		  (
		    NS_GetWindowModeFlag() == TRUE &&
		    ColorBitDepth	== GSYS.Screen.MainScreenColorBitDepth &&
		    RefreshRate		== GSYS.Screen.MainScreenRefreshRate
		  )
		)
#endif // WINDOWS_DESKTOP_OS
	  )
	{
		return DX_CHANGESCREEN_OK ;
	}
	else
	{
		if( Width	== GSYS.Screen.MainScreenSizeX &&
			Height	== GSYS.Screen.MainScreenSizeY &&
			CDepth	== GSYS.Screen.MainScreenColorBitDepth &&
			RRate	== GSYS.Screen.MainScreenRefreshRate )
		{
			return DX_CHANGESCREEN_RETURN ;
		}
		else
		{
			if( GSYS.Screen.MainScreenSizeX == DEFAULT_SCREEN_SIZE_X && 
				GSYS.Screen.MainScreenSizeY == DEFAULT_SCREEN_SIZE_Y 
#ifdef WINDOWS_DESKTOP_OS
				&& 
				(
				  NS_GetWindowModeFlag() == FALSE ||
				  (
					NS_GetWindowModeFlag() == TRUE &&
				    GSYS.Screen.MainScreenColorBitDepth == DEFAULT_COLOR_BITDEPTH &&
				    GSYS.Screen.MainScreenRefreshRate   == 0
				  )
				)
#endif // WINDOWS_DESKTOP_OS
			  )
			{
				return DX_CHANGESCREEN_DEFAULT ;
			}
			else
			{
				return -1 ;
			}
		}
	}
}

// ʂ̃C[WZbg( DxLib_Init ̑OŌĂԕKv( DxLib_Init ̑OɈxłĂł΁ADxLib_Init  Image ̃AhX݂̂̕ύXړIŌĂԂƂ͉\ )APixelFormat  DX_USER_SCREEN_PIXEL_FORMAT_R5G6B5  DX_USER_SCREEN_PIXEL_FORMAT_X8R8G8B8 ̓ȊOw肵ꍇ͂cwCu̕`֐͈؎gpłȂȂ܂ )
extern int NS_SetUserScreenImage( void *Image, int PixelFormat /* DX_USER_SCREEN_PIXEL_FORMAT_R5G6B5  */ )
{
	// ̏ꍇ́AOɊɒlݒ肳ĂāAsNZtH[}bgvĂꍇ̂ݐݒύX
	if( DxSysData.DxLib_InitializeFlag == TRUE &&
		( GSYS.Screen.UserScreenImage == NULL || GSYS.Screen.UserScreenImagePixelFormat != PixelFormat ) )
	{
		return -1 ;
	}

	// lۑ
	GSYS.Screen.UserScreenImage = Image ;
	GSYS.Screen.UserScreenImagePixelFormat = PixelFormat ;

	// \tgEFA_O[hɑΉĂ邩ǂ𔻒
	if( PixelFormat == DX_USER_SCREEN_PIXEL_FORMAT_R5G6B5 ||
		PixelFormat == DX_USER_SCREEN_PIXEL_FORMAT_X8R8G8B8 )
	{
		GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode = TRUE ;
	}
	else
	{
		GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode = FALSE ;
	}

	// \tgEFA_O[hgpĂꍇ̓AhXXV
	if( GSYS.SoftRender.MainBufferMemImg.InitializeCheck )
	{
		if( GSYS.Screen.UserScreenImage == NULL || GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		{
			GSYS.SoftRender.MainBufferMemImg.UseImage = GSYS.SoftRender.MainBufferMemImg.Base->Image ;
		}
		else
		{
			GSYS.SoftRender.MainBufferMemImg.UseImage = ( unsigned char * )GSYS.Screen.UserScreenImage ;
		}
	}

	// I
	return 0 ;
}

// tXN[𑜓x[hݒ肷
extern int NS_SetFullScreenResolutionMode( int ResolutionMode /* DX_FSRESOLUTIONMODE_NATIVE  */ )
{
	// ̏ꍇ͉I
	if( DxSysData.DxLib_InitializeFlag == TRUE )
	{
		return -1 ;
	}

	// tXN[𑜓x[hۑ
	GSYS.Screen.FullScreenResolutionMode    = ResolutionMode ;
	GSYS.Screen.FullScreenResolutionModeAct = ResolutionMode ;

	// I
	return 0 ;
}

// tXN[𑜓x[h擾( UseResolutionMode ͎ۂɎgpĂ𑜓x[h( Ⴆ DX_FSRESOLUTIONMODE_NATIVE w肵ĂĂj^w̉𑜓xɑΉĂȂꍇ UseResolutionMode  DX_FSRESOLUTIONMODE_DESKTOP  DX_FSRESOLUTIONMODE_MAXIMUM ɂȂ܂ ) )
extern int NS_GetFullScreenResolutionMode( int *ResolutionMode, int *UseResolutionMode )
{
	if( ResolutionMode != NULL )
	{
		*ResolutionMode = GSYS.Screen.FullScreenResolutionMode ;
	}

	if( UseResolutionMode != NULL )
	{
		*UseResolutionMode = GSYS.Screen.FullScreenResolutionModeAct ;
	}

	// I
	return 0 ;
}

// tXN[[h̉ʊg僂[hݒ肷
extern int NS_SetFullScreenScalingMode( int ScalingMode /* DX_FSSCALINGMODE_NEAREST  */ , int FitScaling )
{
	// tXN[XP[O[hۑ
	GSYS.Screen.FullScreenScalingMode = ScalingMode ;

	// Q[ʂ̉𑜓xƃtXN[ʂ̉𑜓xقȂꍇɃtXN[ʈtɊg債ĕ\邩ǂ̃tOۑ
	GSYS.Screen.FullScreenFitScalingFlag = FitScaling ;

	// I
	return 0 ;
}

// USOSWỎʂłRQOQSỎʉ𑜓xɂ邩ǂ̃tOZbgAUSOSWOȊỎ𑜓xł͖( TRUE:L  FALSE: )
extern int NS_SetEmulation320x240( int Flag )
{
	// ̏ꍇ͉I
	if( DxSysData.DxLib_InitializeFlag == TRUE )
	{
		return -1 ;
	}

	// tOۑ
	GSYS.Screen.Emulation320x240Flag = Flag;

	// tO TRUE ̏ꍇ͉ʃ[h 320x240 ɁAXP[O[h DX_FSSCALINGMODE_NEAREST ɐݒ肷
	if( Flag != FALSE )
	{
		NS_SetGraphMode( 320, 240, GSYS.Screen.MainScreenColorBitDepth, GSYS.Screen.MainScreenRefreshRate ) ;
		NS_SetFullScreenScalingMode( DX_FSSCALINGMODE_NEAREST, FALSE ) ;
	}

	// I
	return 0;
}

// ʗp̂yobt@̃TCYݒ肷
extern int NS_SetZBufferSize( int ZBufferSizeX, int ZBufferSizeY )
{
	return Graphics_Screen_SetZBufferMode( ZBufferSizeX, ZBufferSizeY, -1 ) ;
}

// ʗp̂yobt@̃rbg[xݒ肷( 16 or 24 or 32 )
extern int NS_SetZBufferBitDepth( int BitDepth )
{
	return Graphics_Screen_SetZBufferMode( -1, -1, BitDepth ) ;
}

// urxmb҂邩̃tOZbg
extern int NS_SetWaitVSyncFlag( int Flag )
{
	// DxLib_Init ̌ďo SetWaitVSyncFlag ̎sɑΉĂ炸A̏ꍇ͉I
	if( GSYS.HardInfo.UseOfSetWaitVSyncFlagIsSupportedEvenAfterDxLib_Init == FALSE &&
		DxSysData.DxLib_InitializeFlag == TRUE )
	{
		return -1 ;
	}

	GSYS.Screen.NotWaitVSyncFlag = !Flag ;

	// ˑ֐Ă
	Graphics_SetWaitVSyncFlag_PF( Flag ) ;

//	if( DxSysData.DxLib_InitializeFlag == FALSE )
//	{
//		GSYS.Screen.PreSetWaitVSyncFlag = Flag ;
//	}

	return 0 ;
}

// urxmb҂ݒɂȂĂ邩ǂ擾
extern int NS_GetWaitVSyncFlag( void )
{
	return !GSYS.Screen.NotWaitVSyncFlag ;
}

// ʂ̃tXN[A`GCAX[h̐ݒ
extern int NS_SetFullSceneAntiAliasingMode( int Samples, int Quality )
{
	// ݒł̂͏Ô
	if( DxSysData.DxLib_InitializeFlag == TRUE )
		return 0 ;

	GSYS.Setting.FSAAMultiSampleCount   = Samples ;
	GSYS.Setting.FSAAMultiSampleQuality = Quality ;

	// I
	return 0 ;
}

// ScreenFlip ɕ\ʑŜɓ]闠ʂ̗̈ݒ肷( DxLib_Init ̑Oł̂ݎgp\ )
extern int NS_SetGraphDisplayArea( int x1, int y1, int x2, int y2 )
{
	// ̏ꍇ͉I
	if( DxSysData.DxLib_InitializeFlag == TRUE )
		return -1 ;

	// p[^`FbN
	if( x1 >= x2 || y1 >= y2 )
	{
		GSYS.Screen.ValidGraphDisplayArea = FALSE ;
		return -1 ;
	}

	// p[^ۑ
	GSYS.Screen.GraphDisplayArea.left   = x1 ;
	GSYS.Screen.GraphDisplayArea.right  = x2 ;
	GSYS.Screen.GraphDisplayArea.top    = y1 ;
	GSYS.Screen.GraphDisplayArea.bottom = y2 ;

	GSYS.Screen.ValidGraphDisplayArea   = TRUE ;

	// I
	return 0 ;
}

// ʃ[hύX( ƃEChE[hύX )ɃOtBbNXVXe̐ݒOtBbNnhZbg邩ǂݒ肷( TRUE:Zbg  FALSE:ZbgȂ )
extern int NS_SetChangeScreenModeGraphicsSystemResetFlag( int Flag )
{
	GSYS.Setting.ChangeScreenModeNotGraphicsSystemFlag = Flag ? FALSE : TRUE ;

	return 0 ;
}

// ݂̉ʂ̑傫ƃJ[rbg𓾂 
extern	int NS_GetScreenState( int *SizeX, int *SizeY, int *ColorBitDepth )
{
	if( SizeX ) *SizeX = GSYS.Screen.MainScreenSizeX ;
	if( SizeY ) *SizeY = GSYS.Screen.MainScreenSizeY ;

	if( ColorBitDepth ) *ColorBitDepth = GSYS.Screen.MainScreenColorBitDepth ;

	// I
	return 0 ;
}

// `TCY擾
extern int NS_GetDrawScreenSize( int *XBuf, int *YBuf )
{
	if( XBuf ) *XBuf = GSYS.Screen.MainScreenSizeX_Result == 0 ? DEFAULT_SCREEN_SIZE_X : GSYS.Screen.MainScreenSizeX_Result ;
	if( YBuf ) *YBuf = GSYS.Screen.MainScreenSizeY_Result == 0 ? DEFAULT_SCREEN_SIZE_Y : GSYS.Screen.MainScreenSizeY_Result ;

	// I
	return 0 ;
}

// gpFrbgԂ
extern int NS_GetScreenBitDepth( void )
{
	// I
	return NS_GetColorBitDepth() ;
}

// ʂ̐Frbg[x𓾂
extern int NS_GetColorBitDepth( void )
{
	// I
	return GSYS.Screen.MainScreenColorBitDepth == 0 ? DEFAULT_COLOR_BITDEPTH : GSYS.Screen.MainScreenColorBitDepth ;
}

// ʃ[hύXĂ邩ǂ̃tO擾
extern	int						NS_GetChangeDisplayFlag( void )
{
#ifdef WINDOWS_DESKTOP_OS
	// I
	return NS_GetWindowModeFlag() == FALSE ;
#else // WINDOWS_DESKTOP_OS
	return FALSE ;
#endif // WINDOWS_DESKTOP_OS
}

// rfI̗eʂ𓾂
extern	int						NS_GetVideoMemorySize( int *AllSize, int *FreeSize )
{
	return Graphics_Hardware_GetVideoMemorySize_PF( AllSize, FreeSize ) ;
}

// ݂̉ʂ̃tbV[g擾
extern int NS_GetRefreshRate( void )
{
	return Graphics_GetRefreshRate_PF() ;
}

// fBXvC̐擾
extern int NS_GetDisplayNum( void )
{
	// fBXvC̃ZbgAbvsĂȂꍇ̓ZbgAbv
	if( GSYS.Screen.DisplayInfo == NULL )
	{
		if( Graphics_SetupDisplayInfo_PF() < 0 )
		{
			return -1 ;
		}
	}

	return GSYS.Screen.DisplayNum ;
}

// fBXvC̃fXNgbvł̋`ʒu擾
extern int NS_GetDisplayInfo( int DisplayIndex, int *DesktopRectX, int *DesktopRectY, int *DesktopSizeX, int *DesktopSizeY, int *IsPrimary )
{
	// fBXvC̃ZbgAbvsĂȂꍇ̓ZbgAbv
	if( GSYS.Screen.DisplayInfo == NULL )
	{
		if( Graphics_SetupDisplayInfo_PF() < 0 )
		{
			return -1 ;
		}
	}

	if( DisplayIndex < 0 || DisplayIndex >= GSYS.Screen.DisplayNum )
	{
		return -1 ;
	}

	if( DesktopRectX ) *DesktopRectX = GSYS.Screen.DisplayInfo[ DisplayIndex ].DesktopRect.left ;
	if( DesktopRectY ) *DesktopRectY = GSYS.Screen.DisplayInfo[ DisplayIndex ].DesktopRect.top ;
	if( DesktopSizeX ) *DesktopSizeX = GSYS.Screen.DisplayInfo[ DisplayIndex ].DesktopRect.right  - GSYS.Screen.DisplayInfo[ DisplayIndex ].DesktopRect.left ;
	if( DesktopSizeY ) *DesktopSizeY = GSYS.Screen.DisplayInfo[ DisplayIndex ].DesktopRect.bottom - GSYS.Screen.DisplayInfo[ DisplayIndex ].DesktopRect.top ;
	if( IsPrimary )    *IsPrimary    = GSYS.Screen.DisplayInfo[ DisplayIndex ].IsPrimary ;

	return 0 ;
}


// ύX\ȃfBXvC[h̐擾
extern int NS_GetDisplayModeNum( int DisplayIndex )
{
	// fBXvC̃ZbgAbvsĂȂꍇ̓ZbgAbv
	if( GSYS.Screen.DisplayInfo == NULL )
	{
		if( Graphics_SetupDisplayInfo_PF() < 0 )
		{
			return -1 ;
		}
	}

	if( DisplayIndex < 0 || DisplayIndex >= GSYS.Screen.DisplayNum )
	{
		return -1 ;
	}

	return GSYS.Screen.DisplayInfo[ DisplayIndex ].ModeNum ;
}

// ύX\ȃfBXvC[h̏擾( ModeIndex  0 ` GetDisplayModeNum ̖߂l-1 )
extern DISPLAYMODEDATA NS_GetDisplayMode( int ModeIndex, int DisplayIndex )
{
	static DISPLAYMODEDATA ErrorResult = { -1, -1, -1, -1 } ;

	// fBXvC̃ZbgAbvsĂȂꍇ̓ZbgAbv
	if( GSYS.Screen.DisplayInfo == NULL )
	{
		if( Graphics_SetupDisplayInfo_PF() < 0 )
		{
			return ErrorResult ;
		}
	}

	if( DisplayIndex < 0 || DisplayIndex >= GSYS.Screen.DisplayNum )
	{
		return ErrorResult ;
	}

	if( GSYS.Screen.DisplayInfo[ DisplayIndex ].ModeNum <= ModeIndex || ModeIndex < 0 )
	{
		return ErrorResult ;
	}

	return GSYS.Screen.DisplayInfo[ DisplayIndex ].ModeData[ ModeIndex ] ;
}

// fBXvC̍ő𑜓x擾
extern int NS_GetDisplayMaxResolution( int *SizeX, int *SizeY, int DisplayIndex )
{
	int MaxSizeX ;
	int MaxSizeY ;
	DISPLAYMODEDATA *DisplayModeData ;
	int i ;

	// fBXvC̃ZbgAbvsĂȂꍇ̓ZbgAbv
	if( GSYS.Screen.DisplayInfo == NULL )
	{
		if( Graphics_SetupDisplayInfo_PF() < 0 )
		{
			return -1 ;
		}
	}

	if( DisplayIndex < 0 || DisplayIndex >= GSYS.Screen.DisplayNum )
	{
		return -1 ;
	}

	// ő̖ʐς𑜓x𒲂ׂ
	MaxSizeX = 0 ;
	MaxSizeY = 0 ;
	DisplayModeData = GSYS.Screen.DisplayInfo[ DisplayIndex ].ModeData ;
	for( i = 0 ; i < GSYS.Screen.DisplayInfo[ DisplayIndex ].ModeNum ; i ++, DisplayModeData ++ )
	{
		if( DisplayModeData->Width * DisplayModeData->Height > MaxSizeX * MaxSizeY )
		{
			MaxSizeX = DisplayModeData->Width ;
			MaxSizeY = DisplayModeData->Height ;
		}
	}

	// TCYۑ
	if( SizeX != NULL )
	{
		*SizeX = MaxSizeX ;
	}

	if( SizeY != NULL )
	{
		*SizeY = MaxSizeY ;
	}

	// I
	return 0 ;
}

// fBXv[̃J[f[^|C^𓾂
extern	const COLORDATA *NS_GetDispColorData( void )
{
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		return Graphics_Hardware_GetDispColorData_PF() ;
	}
	else
	{
		return GSYS.SoftRender.MainBufferMemImg.Base->ColorDataP ;
	}
}

// ɕ`sƂłʂ̐擾
extern int NS_GetMultiDrawScreenNum( void )
{
	return GSYS.HardInfo.RenderTargetNum ;
}

// DrawGraphF ̕_lōWw肷֐ɂW^Cv擾( ߂l : DX_DRAWFLOATCOORDTYPE_DIRECT3D9 Ȃ )
extern int NS_GetDrawFloatCoordType( void )
{
	return GSYS.HardInfo.DrawFloatCoordType ;
}

























// ̑ݒ֌W֐

// ʏ`ɃvO}uVF[_[gp邩ǂݒ肷( TRUE:gp( ftHg )  FALSE:gpȂ )
extern	int		NS_SetUseNormalDrawShader( int Flag )
{
	return Graphics_Hardware_SetUseNormalDrawShader_PF( Flag ) ;
}

// \tgEGA_O[hgp邩ǂZbg
extern int NS_SetUseSoftwareRenderModeFlag( int Flag )
{
	return NS_SetScreenMemToVramFlag( Flag == TRUE ? FALSE : TRUE ) ;
}

// Rc@\gȂtÕZbg
extern	int		NS_SetNotUse3DFlag( int Flag )
{
	// Ôݎgp\@
	if( DxSysData.DxLib_InitializeFlag == TRUE ) return -1 ;

	GSYS.Setting.NotUseHardware = Flag ;

	// I
	return 0 ;
}

// Rc@\gÃtOZbg
extern	int NS_SetUse3DFlag( int Flag )
{
	// ÔݗL
	if( DxSysData.DxLib_InitializeFlag == TRUE ) return -1 ;

	GSYS.Setting.NotUseHardware = !Flag ;

	// I
	return 0 ;
}

// `ɂRc@\gtO擾
extern	int NS_GetUse3DFlag( void )
{
	// Ȍꍇ SetUse3DFlag Őݒ肵ê܂ܕԂ
	if( DxSysData.DxLib_InitializeFlag == FALSE )
	{
		return !GSYS.Setting.NotUseHardware ;
	}
	else
	{
		// ̏ꍇ ValidHardware ̓eԂ
		return GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;
	}
}

// ʃf[^uq`lɒuAtO
extern	int		NS_SetScreenMemToVramFlag( int Flag )
{
	// Ô݌Ăяo
	if( DxSysData.DxLib_InitializeFlag == TRUE ) return -1 ;

	GSYS.Setting.NotUseHardware = !Flag ;

	// I
	return 0 ;
}

// ʃOtBbNf[^VXeɑ݂邩tO̎擾
extern	int						NS_GetScreenMemToSystemMemFlag( void )
{
	// I
	return GSYS.Setting.ValidHardware == FALSE || GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode ;
}

// ʏgpȂ
extern int NS_SetWindowDrawRect( const RECT * /* DrawRect */ )
{
//	GSYS.WindowDrawRect = *DrawRect ;

	return 0 ;
}

// cwCũOtBbN֘A̕As
extern	int NS_RestoreGraphSystem( void )
{
	Graphics_RestoreOrChangeSetupGraphSystem( FALSE ) ;

	// I
	return 0 ;
}

// n[hEGA̒_Z@\gp邩ǂݒ肷
extern	int NS_SetUseHardwareVertexProcessing( int Flag )
{
	return Graphics_Hardware_SetUseHardwareVertexProcessing_PF( Flag ) ;
}

// sNZPʂŃCeBOsǂݒ肷Av ShaderModel 3.0( TRUE:sNZPʂ̃CeBOs  FALSE:_Pʂ̃CeBOs( ftHg ) )
extern int NS_SetUsePixelLighting( int Flag )
{
	return Graphics_Hardware_SetUsePixelLighting_PF( Flag ) ;
}

// ȑO DrawModiGraph ֐̃R[hgp邩ǂ̃tOZbg
extern int NS_SetUseOldDrawModiGraphCodeFlag( int Flag )
{
	return Graphics_Hardware_SetUseOldDrawModiGraphCodeFlag_PF( Flag ) ;
}

// uq`lgp邩̃tOZbg
extern	int NS_SetUseVramFlag( int Flag )
{
	return NS_SetUseSystemMemGraphCreateFlag( Flag == TRUE ? FALSE : TRUE ) ;
}

// QcOtBbNT[tFX쐬ɃVXe[gp邩̃tO擾
extern	int NS_GetUseVramFlag( void )
{
	return NS_GetUseSystemMemGraphCreateFlag() == TRUE ? FALSE : TRUE ;
}

// ȗuhsۂ̃tOZbg
extern	int		NS_SetBasicBlendFlag( int /*Flag*/ )
{
	// I
	return 0 ;
}

// P}`̕`ɂRcfoCX̋@\gp邩ǂ̃tOZbg
extern int NS_SetUseBasicGraphDraw3DDeviceMethodFlag( int /* Flag */ )
{
//	GSYS.DrawSetting.NotUseBasicGraphDraw3DDeviceMethodFlag = !Flag ;

	return 0 ;
}

// cwCũEChE\fBXvCfoCXݒ肷( -1 w肷ƃ}EXJ[\fBXvCfoCXɂcwCũEChE\ )
extern int NS_SetUseDisplayIndex( int Index )
{
	if( GSYS.Screen.DisplayInfo == NULL )
	{
		Graphics_SetupDisplayInfo_PF() ;
	}

	// l}CiX̏ꍇ̓}EX|C^̂fBXvCfoCXɂ
	if( Index < 0 )
	{
#ifdef WINDOWS_DESKTOP_OS
		POINT MousePos ;
		int i ;

		SETUP_WIN_API

		// XN[ł̈ʒufBXvCԍo
		WinAPIData.Win32Func.GetCursorPosFunc( &MousePos ) ;

		for( i = 0 ; i < GSYS.Screen.DisplayNum ; i ++ )
		{
			if( GSYS.Screen.DisplayInfo[ i ].DesktopRect.left <= MousePos.x && MousePos.x < GSYS.Screen.DisplayInfo[ i ].DesktopRect.right &&
				GSYS.Screen.DisplayInfo[ i ].DesktopRect.top  <= MousePos.y && MousePos.y < GSYS.Screen.DisplayInfo[ i ].DesktopRect.bottom )
			{
				break ;
			}
		}
		if( i != GSYS.Screen.DisplayNum )
		{
			Index = i ;
		}
#else
		Index = 0 ;
#endif
	}

	if( Index < 0 || Index >= GSYS.Screen.DisplayNum )
	{
		return -1 ;
	}

	GSYS.Screen.ValidUseDisplayIndex = TRUE ;
	GSYS.Screen.UseDisplayIndex      = Index ;

	return 0 ;
}

// _obt@ɗ܂_f[^fo
extern int NS_RenderVertex( void )
{
	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	return 0 ;
}


























// `ptH[}X֌W֐

// OX ScreenFlip ĂяoAO ScreenFlip Ăяo܂ł̊Ԃɍsꂽ`R[̉񐔂擾
extern int NS_GetDrawCallCount( void )
{
	return GSYS.PerformanceInfo.PrevFrameDrawCallCount ;
}

// t[[g( PbԂɌĂ΂ ScreenFlip ̉ )擾
extern float NS_GetFPS( void )
{
#if defined( _MSC_VER ) && _MSC_VER == 1200
	return ( float )( ( double )( LONGLONG )NS_GetSysPerformanceFrequency() / ( LONGLONG )( GSYS.PerformanceInfo.ScreenFlipTime[ 0 ] - GSYS.PerformanceInfo.ScreenFlipTime[ 1 ] ) ) ;
#else
	return ( float )( ( double )NS_GetSysPerformanceFrequency() / ( GSYS.PerformanceInfo.ScreenFlipTime[ 0 ] - GSYS.PerformanceInfo.ScreenFlipTime[ 1 ] ) ) ;
#endif
}
























// `ʕۑ֐

#ifndef DX_NON_SAVEFUNCTION

// Jpeg_Quality         = 0:掿`100:掿
// Png_CompressionLevel = 0:k`  9:ōk
// ݕ`ΏۂɂȂĂʂۑ
extern int NS_SaveDrawScreen( int x1, int y1, int x2, int y2, const TCHAR *FileName, int SaveType, int Jpeg_Quality, int Jpeg_Sample2x1, int Png_CompressionLevel )
{
#ifdef UNICODE
	return SaveDrawScreen_WCHAR_T(
		x1, y1, x2, y2, FileName, SaveType, Jpeg_Quality, Jpeg_Sample2x1, Png_CompressionLevel
	) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, return -1 )

	Result = SaveDrawScreen_WCHAR_T(
		x1, y1, x2, y2, UseFileNameBuffer, SaveType, Jpeg_Quality, Jpeg_Sample2x1, Png_CompressionLevel
	) ;

	TCHAR_TO_WCHAR_T_STRING_END( FileName )

	return Result ;
#endif
}

// ݕ`ΏۂɂȂĂʂt@Cŕۑ
extern int NS_SaveDrawScreenWithStrLen( int x1, int y1, int x2, int y2, const TCHAR *FileName, size_t FileNameLength, int SaveType, int Jpeg_Quality, int Jpeg_Sample2x1, int Png_CompressionLevel )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = SaveDrawScreen_WCHAR_T( x1, y1, x2, y2, UseFileNameBuffer, SaveType, Jpeg_Quality, Jpeg_Sample2x1, Png_CompressionLevel ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = SaveDrawScreen_WCHAR_T( x1, y1, x2, y2, UseFileNameBuffer, SaveType, Jpeg_Quality, Jpeg_Sample2x1, Png_CompressionLevel ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#endif
	return Result ;
}

// Jpeg_Quality         = 0:掿`100:掿
// Png_CompressionLevel = 0:k`  9:ōk
// ݕ`ΏۂɂȂĂʂۑ
extern int SaveDrawScreen_WCHAR_T( int x1, int y1, int x2, int y2, const wchar_t *FileName, int SaveType, int Jpeg_Quality, int Jpeg_Sample2x1, int Png_CompressionLevel )
{
	BASEIMAGE BaseImage ;
	RECT      LockRect ;
	int       UseTempBaseImage = FALSE ;
	BASEIMAGE TempBaseImage ;
	BASEIMAGE *UseBaseImage ;

	// TCYsȏꍇ͉ɏI
	if( x1 >= x2 || y1 >= y2 || x1 < 0 || y1 < 0 || x2 > GSYS.DrawSetting.DrawSizeX || y2 > GSYS.DrawSetting.DrawSizeY )
	{
		return -1 ;
	}

	// `bN
	LockRect.left   = x1 ;
	LockRect.top    = y1 ;
	LockRect.right  = x2 ;
	LockRect.bottom = y2 ;
	if( Graphics_Screen_LockDrawScreen( &LockRect, &BaseImage, -1, -1, -1, TRUE, 0 ) < 0 )
	{
		return -1 ;
	}

	// C[W㉺]Ăꍇ͂ŏ㉺]
	_MEMSET( &TempBaseImage, 0, sizeof( TempBaseImage ) ) ;
	if( GSYS.HardInfo.MainScreenImageYReverse &&
		( ( DWORD )GSYS.DrawSetting.TargetScreen[ 0 ] == DX_SCREEN_BACK ||
		  ( DWORD )GSYS.DrawSetting.TargetScreen[ 0 ] == DX_SCREEN_FRONT ) )
	{
		UseTempBaseImage = TRUE ;
		NS_CreateColorDataBaseImage( BaseImage.Width, BaseImage.Height, &BaseImage.ColorData, &TempBaseImage ) ;
		NS_BltBaseImage2( 0, 0, &BaseImage, &TempBaseImage ) ;
		NS_ReverseBaseImageV( &TempBaseImage ) ;
		UseBaseImage = &TempBaseImage ;
	}
	else
	{
		UseBaseImage = &BaseImage ;
	}

	// ۑ`ɂďύX
	switch( SaveType )
	{
	case DX_IMAGESAVETYPE_JPEG:
#ifndef DX_NON_JPEGREAD
		SaveBaseImageToJpeg_WCHAR_T( FileName, UseBaseImage, Jpeg_Quality, Jpeg_Sample2x1 );
#endif
		break;

	case DX_IMAGESAVETYPE_PNG:
#ifndef DX_NON_PNGREAD
		SaveBaseImageToPng_WCHAR_T( FileName, UseBaseImage, Png_CompressionLevel );
#endif
		break;

	case DX_IMAGESAVETYPE_BMP:	// Bitmap 
		SaveBaseImageToBmp_WCHAR_T( FileName, UseBaseImage ) ;
		break ;

	case DX_IMAGESAVETYPE_DDS:	// Direct Draw Surface
		SaveBaseImageToDds_WCHAR_T( FileName, UseBaseImage ) ;
		break ;
	}

	// `AbN
	Graphics_Screen_UnlockDrawScreen() ;

	// e|C[W
	if( UseTempBaseImage )
	{
		NS_ReleaseBaseImage( &TempBaseImage ) ;
	}

	// I
	return 0 ;
}

// ݕ`ΏۂɂȂĂʂalo`ŕۑ
extern int NS_SaveDrawScreenToBMP( int x1, int y1, int x2, int y2, const TCHAR *FileName )
{
	return NS_SaveDrawScreen( x1, y1, x2, y2, FileName, DX_IMAGESAVETYPE_BMP, 80, TRUE, -1 );
}

// ݕ`ΏۂɂȂĂʂalo`ŕۑ
extern int NS_SaveDrawScreenToBMPWithStrLen( int x1, int y1, int x2, int y2, const TCHAR *FileName, size_t FileNameLength )
{
	int Result ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = NS_SaveDrawScreen( x1, y1, x2, y2, UseFileNameBuffer, DX_IMAGESAVETYPE_BMP, 80, TRUE, -1 ) ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( FileName )
	return Result ;
}

// ݕ`ΏۂɂȂĂʂalo`ŕۑ
extern int SaveDrawScreenToBMP_WCHAR_T( int x1, int y1, int x2, int y2, const wchar_t *FileName )
{
	return SaveDrawScreen_WCHAR_T( x1, y1, x2, y2, FileName, DX_IMAGESAVETYPE_BMP );
}

// ݕ`ΏۂɂȂĂʂccr`ŕۑ
extern int NS_SaveDrawScreenToDDS(  int x1, int y1, int x2, int y2, const TCHAR *FileName )
{
	return NS_SaveDrawScreen( x1, y1, x2, y2, FileName, DX_IMAGESAVETYPE_DDS, 80, TRUE, -1 );
}

// ݕ`ΏۂɂȂĂʂccr`ŕۑ
extern int NS_SaveDrawScreenToDDSWithStrLen( int x1, int y1, int x2, int y2, const TCHAR *FileName, size_t FileNameLength )
{
	int Result ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = NS_SaveDrawScreen( x1, y1, x2, y2, UseFileNameBuffer, DX_IMAGESAVETYPE_DDS, 80, TRUE, -1 ) ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( FileName )
	return Result ;
}

// ݕ`ΏۂɂȂĂʂalo`ŕۑ
extern int SaveDrawScreenToDDS_WCHAR_T( int x1, int y1, int x2, int y2, const wchar_t *FileName )
{
	return SaveDrawScreen_WCHAR_T( x1, y1, x2, y2, FileName, DX_IMAGESAVETYPE_DDS );
}

// ݕ`ΏۂɂȂĂʂiodf`ŕۑ Quality = 掿Al傫قǒሳk掿,0`100 
extern int NS_SaveDrawScreenToJPEG( int x1, int y1, int x2, int y2, const TCHAR *FileName, int Quality, int Sample2x1 )
{
	return NS_SaveDrawScreen( x1, y1, x2, y2, FileName, DX_IMAGESAVETYPE_JPEG, Quality, Sample2x1, -1 );
}

// ݕ`ΏۂɂȂĂʂiodf`ŕۑ Quality = 掿Al傫قǒሳk掿,0`100 
extern int NS_SaveDrawScreenToJPEGWithStrLen( int x1, int y1, int x2, int y2, const TCHAR *FileName, size_t FileNameLength, int Quality, int Sample2x1 )
{
	int Result ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = NS_SaveDrawScreen( x1, y1, x2, y2, UseFileNameBuffer, DX_IMAGESAVETYPE_JPEG, Quality, Sample2x1, -1 ) ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( FileName )
	return Result ;
}

// ݕ`ΏۂɂȂĂʂiodf`ŕۑ Quality = 掿Al傫قǒሳk掿,0`100 
extern int SaveDrawScreenToJPEG_WCHAR_T( int x1, int y1, int x2, int y2, const wchar_t *FileName, int Quality, int Sample2x1 )
{
	return SaveDrawScreen_WCHAR_T( x1, y1, x2, y2, FileName, DX_IMAGESAVETYPE_JPEG, Quality, Sample2x1 );
}

// ݕ`ΏۂɂȂĂʂomf`ŕۑ CompressionLevel = kAl傫قǍkׁAO͖k,0`9
extern int NS_SaveDrawScreenToPNG( int x1, int y1, int x2, int y2, const TCHAR *FileName, int CompressionLevel )
{
	return NS_SaveDrawScreen( x1, y1, x2, y2, FileName, DX_IMAGESAVETYPE_PNG, 80, TRUE, CompressionLevel );
}

// ݕ`ΏۂɂȂĂʂomf`ŕۑ CompressionLevel = kAl傫قǍkׁAO͖k,0`9
extern int NS_SaveDrawScreenToPNGWithStrLen( int x1, int y1, int x2, int y2, const TCHAR *FileName, size_t FileNameLength, int CompressionLevel )
{
	int Result ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = NS_SaveDrawScreen( x1, y1, x2, y2, UseFileNameBuffer, DX_IMAGESAVETYPE_PNG, 80, TRUE, CompressionLevel ) ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( FileName )
	return Result ;
}

// ݕ`ΏۂɂȂĂʂomf`ŕۑ CompressionLevel = kAl傫قǍkׁAO͖k,0`9
extern int SaveDrawScreenToPNG_WCHAR_T( int x1, int y1, int x2, int y2, const wchar_t *FileName, int CompressionLevel )
{
	return SaveDrawScreen_WCHAR_T( x1, y1, x2, y2, FileName, DX_IMAGESAVETYPE_PNG, 80, CompressionLevel );
}

// `ΏۂɂłOtBbNnhۑ֐
// Jpeg_Quality         = 0:掿`100:掿
// Png_CompressionLevel = 0:k`  9:ōk

// `ΏۂɂłOtBbNnht@Cŕۑ
extern int NS_SaveDrawValidGraph( int GrHandle, int x1, int y1, int x2, int y2, const TCHAR *FileName, int SaveType, int Jpeg_Quality, int Jpeg_Sample2x1, int Png_CompressionLevel )
{
#ifdef UNICODE
	return SaveDrawValidGraph_WCHAR_T(
		GrHandle, x1, y1, x2, y2, FileName, SaveType, Jpeg_Quality, Jpeg_Sample2x1, Png_CompressionLevel
	) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, return -1 )

	Result = SaveDrawValidGraph_WCHAR_T(
		GrHandle, x1, y1, x2, y2, UseFileNameBuffer, SaveType, Jpeg_Quality, Jpeg_Sample2x1, Png_CompressionLevel
	) ;

	TCHAR_TO_WCHAR_T_STRING_END( FileName )

	return Result ;
#endif
}

// `ΏۂɂłOtBbNnht@Cŕۑ
extern int NS_SaveDrawValidGraphWithStrLen( int GrHandle, int x1, int y1, int x2, int y2, const TCHAR *FileName, size_t FileNameLength, int SaveType, int Jpeg_Quality, int Jpeg_Sample2x1, int Png_CompressionLevel )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = SaveDrawValidGraph_WCHAR_T( GrHandle, x1, y1, x2, y2, UseFileNameBuffer, SaveType, Jpeg_Quality, Jpeg_Sample2x1, Png_CompressionLevel ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = SaveDrawValidGraph_WCHAR_T( GrHandle, x1, y1, x2, y2, UseFileNameBuffer, SaveType, Jpeg_Quality, Jpeg_Sample2x1, Png_CompressionLevel ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#endif
	return Result ;
}

extern int SaveDrawValidGraph_WCHAR_T( int GrHandle, int x1, int y1, int x2, int y2, const wchar_t *FileName, int SaveType, int Jpeg_Quality, int Jpeg_Sample2x1, int Png_CompressionLevel )
{
	IMAGEDATA *Image ;
	BASEIMAGE BaseImage ;
	RECT LockRect ;

	if( GRAPHCHKFULL( GrHandle, Image ) )
	{
		return -1 ;
	}

	// TCYʂςŁA DDS t@Cł̕ۑŁAeNX`̏ꍇ͐p̏s
	if( x1 == 0 && y1 == 0 && x2 == Image->WidthI && y2 == Image->HeightI &&
		SaveType == DX_IMAGESAVETYPE_DDS && Image->Orig->FormatDesc.TextureFlag == TRUE )
	{
		int CubeMapFlag ;
		int MipMapCount ;
		int ArraySize ;
		int BaseImageNum ;
		BASEIMAGE *BaseImageDim ;
		int i ;
		int j ;
		int k ;
		int Result ;

		CubeMapFlag = Image->Orig->FormatDesc.CubeMapTextureFlag ;
		ArraySize = CubeMapFlag ? CUBEMAP_SURFACE_NUM : 1 ;
		MipMapCount = Image->Orig->Hard.MipMapCount ;
		BaseImageNum = ArraySize * MipMapCount ;

		BaseImageDim = ( BASEIMAGE * )DXALLOC( sizeof( BASEIMAGE ) * BaseImageNum ) ;
		if( BaseImageDim == NULL )
		{
			DXST_LOGFILE_ADDUTF16LE( "\xcf\x63\x3b\x75\xfe\x5b\x61\x8c\x6b\x30\x67\x30\x4d\x30\x8b\x30\xb0\x30\xe9\x30\xd5\x30\xa3\x30\xc3\x30\xaf\x30\xcf\x30\xf3\x30\xc9\x30\xeb\x30\xdd\x4f\x58\x5b\xe6\x51\x06\x74\x67\x30\x7f\x4f\x28\x75\x59\x30\x8b\x30\x20\x00\x42\x00\x41\x00\x53\x00\x45\x00\x49\x00\x4d\x00\x41\x00\x47\x00\x45\x00\x20\x00\xcb\x69\x20\x90\x53\x4f\x4d\x91\x17\x52\x92\x30\xdd\x4f\x58\x5b\x59\x30\x8b\x30\x5f\x30\x81\x30\x6e\x30\xe1\x30\xe2\x30\xea\x30\x6e\x30\xba\x78\xdd\x4f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"`ΏۂɂłOtBbNnhۑŎgp BASEIMAGE \̔zۑ邽߂̃̊mۂɎs܂\n" @*/ ) ;
			return -1 ;
		}
		_MEMSET( BaseImageDim, 0, sizeof( BASEIMAGE ) * BaseImageNum ) ;

		k = 0 ;
		for( i = 0 ; i < ArraySize ; i ++ )
		{
			for( j = 0 ; j < MipMapCount ; j ++, k ++ )
			{
				int Width, Height ;

				Graphics_Image_CalcMipSize( Image->WidthI, Image->HeightI, j, &Width, &Height ) ;

				// `ΏۂɂłOtBbNnhbN
				LockRect.left   = 0 ;
				LockRect.top    = 0 ;
				LockRect.right  = Width ;
				LockRect.bottom = Height ;
				if( Graphics_Screen_LockDrawScreen( &LockRect, &BaseImage, GrHandle, i, j, TRUE, 0 ) < 0 )
				{
					DXFREE( BaseImageDim ) ;
					BaseImageDim = NULL ;

					for( i = 0 ; i < k ; i ++ )
					{
						NS_ReleaseBaseImage( &BaseImageDim[ i ] ) ;
					}

					return -1 ;
				}

				// 摜̕
				if( NS_CreateColorDataBaseImage( BaseImage.Width, BaseImage.Height, &BaseImage.ColorData, &BaseImageDim[ k ] ) < 0 )
				{
					DXFREE( BaseImageDim ) ;
					BaseImageDim = NULL ;

					for( i = 0 ; i < k ; i ++ )
					{
						NS_ReleaseBaseImage( &BaseImageDim[ i ] ) ;
					}

					DXST_LOGFILE_ADDUTF16LE( "\xcf\x63\x3b\x75\xfe\x5b\x61\x8c\x6b\x30\x67\x30\x4d\x30\x8b\x30\xb0\x30\xe9\x30\xd5\x30\xa3\x30\xc3\x30\xaf\x30\xcf\x30\xf3\x30\xc9\x30\xeb\x30\xdd\x4f\x58\x5b\xe6\x51\x06\x74\x67\x30\x7f\x4f\x28\x75\x59\x30\x8b\x30\xe1\x30\xe2\x30\xea\x30\x6e\x30\xba\x78\xdd\x4f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"`ΏۂɂłOtBbNnhۑŎgp郁̊mۂɎs܂\n" @*/ ) ;
					return -1 ;
				}
				BltBaseImage2( 0, 0, &BaseImage, &BaseImageDim[ k ] ) ;

				// `AbN
				Graphics_Screen_UnlockDrawScreen() ;
			}
		}

		// t@C̕ۑ
		Result = SaveBaseImageToDds_WCHAR_T( FileName, BaseImageDim, CubeMapFlag, MipMapCount ) ;

		for( i = 0 ; i < k ; i ++ )
		{
			NS_ReleaseBaseImage( &BaseImageDim[ i ] ) ;
		}

		DXFREE( BaseImageDim ) ;
		BaseImageDim = NULL ;

		return Result ;
	}

	// TCYsȏꍇ͉ɏI
	if( x1 >= x2 || y1 >= y2 || x1 < 0 || y1 < 0 || x2 > Image->WidthI || y2 > Image->HeightI )
	{
		return -1 ;
	}

	// `ΏۂɂłOtBbNnhbN
	LockRect.left   = x1 ;
	LockRect.top    = y1 ;
	LockRect.right  = x2 ;
	LockRect.bottom = y2 ;
	if( Graphics_Screen_LockDrawScreen( &LockRect, &BaseImage, GrHandle, 0, 0, TRUE, 0 ) < 0 )
	{
		return -1 ;
	}

	// ۑ`ɂďύX
	switch( SaveType )
	{
	case DX_IMAGESAVETYPE_JPEG:
#ifndef DX_NON_JPEGREAD
		SaveBaseImageToJpeg_WCHAR_T( FileName, &BaseImage, Jpeg_Quality, Jpeg_Sample2x1 );
#endif
		break;

	case DX_IMAGESAVETYPE_PNG:
#ifndef DX_NON_PNGREAD
		SaveBaseImageToPng_WCHAR_T( FileName, &BaseImage, Png_CompressionLevel );
#endif
		break;

	case DX_IMAGESAVETYPE_BMP:	// Bitmap 
		SaveBaseImageToBmp_WCHAR_T( FileName, &BaseImage ) ;
		break ;

	case DX_IMAGESAVETYPE_DDS:	// Direct Draw Surface
		SaveBaseImageToDds_WCHAR_T( FileName, &BaseImage ) ;
		break ;
	}

	// `AbN
	Graphics_Screen_UnlockDrawScreen() ;

	// I
	return 0 ;
}

// `ΏۂɂłOtBbNnhalo`ŕۑ
extern int NS_SaveDrawValidGraphToBMP(  int GrHandle, int x1, int y1, int x2, int y2, const TCHAR *FileName )
{
	return NS_SaveDrawValidGraph( GrHandle, x1, y1, x2, y2, FileName, DX_IMAGESAVETYPE_BMP, 80, TRUE, -1 );
}

// `ΏۂɂłOtBbNnhalo`ŕۑ
extern int NS_SaveDrawValidGraphToBMPWithStrLen( int GrHandle, int x1, int y1, int x2, int y2, const TCHAR *FileName, size_t FileNameLength )
{
	int Result ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = NS_SaveDrawValidGraph( GrHandle, x1, y1, x2, y2, UseFileNameBuffer, DX_IMAGESAVETYPE_BMP, 80, TRUE, -1 ) ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( FileName )
	return Result ;
}

extern int SaveDrawValidGraphToBMP_WCHAR_T(  int GrHandle, int x1, int y1, int x2, int y2, const wchar_t *FileName )
{
	return SaveDrawValidGraph_WCHAR_T( GrHandle, x1, y1, x2, y2, FileName, DX_IMAGESAVETYPE_BMP );
}

// `ΏۂɂłOtBbNnhccr`ŕۑ
extern int NS_SaveDrawValidGraphToDDS(  int GrHandle, int x1, int y1, int x2, int y2, const TCHAR *FileName )
{
	return NS_SaveDrawValidGraph( GrHandle, x1, y1, x2, y2, FileName, DX_IMAGESAVETYPE_DDS, 80, TRUE, -1 );
}

// `ΏۂɂłOtBbNnhccr`ŕۑ
extern int NS_SaveDrawValidGraphToDDSWithStrLen( int GrHandle, int x1, int y1, int x2, int y2, const TCHAR *FileName, size_t FileNameLength )
{
	int Result ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = NS_SaveDrawValidGraph( GrHandle, x1, y1, x2, y2, UseFileNameBuffer, DX_IMAGESAVETYPE_DDS, 80, TRUE, -1 );
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( FileName )
	return Result ;
}

extern int SaveDrawValidGraphToDDS_WCHAR_T(  int GrHandle, int x1, int y1, int x2, int y2, const wchar_t *FileName )
{
	return SaveDrawValidGraph_WCHAR_T( GrHandle, x1, y1, x2, y2, FileName, DX_IMAGESAVETYPE_DDS );
}

// `ΏۂɂłOtBbNnhiodf`ŕۑ Quality = 掿Al傫قǒሳk掿,0`100 
extern int NS_SaveDrawValidGraphToJPEG( int GrHandle, int x1, int y1, int x2, int y2, const TCHAR *FileName, int Quality , int Sample2x1 )
{
	return NS_SaveDrawValidGraph( GrHandle, x1, y1, x2, y2, FileName, DX_IMAGESAVETYPE_JPEG, Quality, Sample2x1, -1 );
}

// `ΏۂɂłOtBbNnhiodf`ŕۑ Quality = 掿Al傫قǒሳk掿,0`100 
extern int NS_SaveDrawValidGraphToJPEGWithStrLen( int GrHandle, int x1, int y1, int x2, int y2, const TCHAR *FileName, size_t FileNameLength, int Quality, int Sample2x1 )
{
	int Result ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = NS_SaveDrawValidGraph( GrHandle, x1, y1, x2, y2, UseFileNameBuffer, DX_IMAGESAVETYPE_JPEG, Quality, Sample2x1, -1 )  ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( FileName )
	return Result ;
}

extern int SaveDrawValidGraphToJPEG_WCHAR_T( int GrHandle, int x1, int y1, int x2, int y2, const wchar_t *FileName, int Quality, int Sample2x1 )
{
	return SaveDrawValidGraph_WCHAR_T( GrHandle, x1, y1, x2, y2, FileName, DX_IMAGESAVETYPE_JPEG, Quality, Sample2x1 );
}

// `ΏۂɂłOtBbNnhomf`ŕۑ CompressionLevel = kAl傫قǍkׁAO͖k,0`9
extern int NS_SaveDrawValidGraphToPNG(  int GrHandle, int x1, int y1, int x2, int y2, const TCHAR *FileName, int CompressionLevel )
{
	return NS_SaveDrawValidGraph( GrHandle, x1, y1, x2, y2, FileName, DX_IMAGESAVETYPE_PNG, 80, TRUE, CompressionLevel );
}

// `ΏۂɂłOtBbNnhomf`ŕۑ CompressionLevel = kAl傫قǍkׁAO͖k,0`9
extern int NS_SaveDrawValidGraphToPNGWithStrLen( int GrHandle, int x1, int y1, int x2, int y2, const TCHAR *FileName, size_t FileNameLength, int CompressionLevel )
{
	int Result ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = NS_SaveDrawValidGraph( GrHandle, x1, y1, x2, y2, UseFileNameBuffer, DX_IMAGESAVETYPE_PNG, 80, TRUE, CompressionLevel ) ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( FileName )
	return Result ;
}

extern int SaveDrawValidGraphToPNG_WCHAR_T( int GrHandle, int x1, int y1, int x2, int y2, const wchar_t *FileName, int CompressionLevel )
{
	return SaveDrawValidGraph_WCHAR_T( GrHandle, x1, y1, x2, y2, FileName, DX_IMAGESAVETYPE_PNG, 80, TRUE, CompressionLevel );
}

#endif // DX_NON_SAVEFUNCTION

























// _obt@֌W֐

// _obt@쐬( -1:G[  0ȏ:_obt@nh )
extern int NS_CreateVertexBuffer( int VertexNum, int VertexType /* DX_VERTEX_TYPE_NORMAL_3D  */ )
{
	return Graphics_VertexBuffer_Create( VertexNum, VertexType, GetASyncLoadFlag() ) ;
}

// _obt@폜
extern int NS_DeleteVertexBuffer( int VertexBufHandle )
{
	return SubHandle( VertexBufHandle ) ;
}

// ׂĂ̒_obt@폜
extern int NS_InitVertexBuffer()
{
	return AllHandleSub( DX_HANDLETYPE_VERTEX_BUFFER ) ;
}

// _obt@ɒ_f[^]
extern int NS_SetVertexBufferData( int SetIndex, const void *VertexData, int VertexNum, int VertexBufHandle )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;

	// G[
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;

	// G[`FbN
	if( VertexBuffer->Num < SetIndex + VertexNum || SetIndex < 0 )
		return -1 ;

	// VXẽobt@ւ]
	_MEMCPY( ( BYTE * )VertexBuffer->Buffer + SetIndex * VertexBuffer->UnitSize, VertexData, ( size_t )( VertexNum * VertexBuffer->UnitSize ) ) ;

	// ˑ̒_f[^]
	if( Graphics_Hardware_VertexBuffer_SetData_PF( VertexBuffer, SetIndex, VertexData, VertexNum ) < 0 )
	{
		return -1 ;
	}

	// I
	return 0 ;
}

// _obt@nh̒_obt@̃AhX擾
extern void *NS_GetBufferVertexBuffer( int VertexBufHandle )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;

	// G[
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return NULL ;

	// AhXԂ
	return VertexBuffer->Buffer ;
}

// _obt@nh̒_obt@ւ̕ύXKp( GetBufferVertexBuffer Ŏ擾obt@ւ̕ύX𔽉f )
extern int NS_UpdateVertexBuffer( int VertexBufHandle, int UpdateStartIndex, int UpdateVertexNum )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;

	// G[
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;

	// G[`FbN
	if( VertexBuffer->Num < UpdateStartIndex + UpdateVertexNum || UpdateStartIndex < 0 )
		return -1 ;

	// ˑ̒_f[^]
	if( Graphics_Hardware_VertexBuffer_SetData_PF( VertexBuffer, UpdateStartIndex, ( BYTE * )VertexBuffer->Buffer + UpdateStartIndex * VertexBuffer->UnitSize, UpdateVertexNum ) < 0 )
	{
		return -1 ;
	}

	// I
	return 0 ;
}

// CfbNXobt@쐬( -1:G[@0ȏFCfbNXobt@nh )
extern int NS_CreateIndexBuffer( int IndexNum, int IndexType /* DX_INDEX_TYPE_16BIT  */  )
{
	return Graphics_IndexBuffer_Create( IndexNum, IndexType, GetASyncLoadFlag() ) ;
}

// CfbNXobt@폜
extern int NS_DeleteIndexBuffer( int IndexBufHandle )
{
	return SubHandle( IndexBufHandle ) ;
}

// ׂẴCfbNXobt@폜
extern int NS_InitIndexBuffer()
{
	return AllHandleSub( DX_HANDLETYPE_INDEX_BUFFER ) ;
}

// CfbNXobt@ɃCfbNXf[^]
extern int NS_SetIndexBufferData( int SetIndex, const void *IndexData, int IndexNum, int IndexBufHandle )
{
	INDEXBUFFERHANDLEDATA *IndexBuffer ;

	// G[
	if( INDEXBUFFERCHK( IndexBufHandle, IndexBuffer ) )
		return -1 ;

	// G[`FbN
	if( IndexBuffer->Num < SetIndex + IndexNum || SetIndex < 0 )
		return -1 ;

	// VXẽobt@ւ]
	_MEMCPY( ( BYTE * )IndexBuffer->Buffer + SetIndex * IndexBuffer->UnitSize, IndexData, ( size_t )( IndexNum * IndexBuffer->UnitSize ) ) ;

	// ˑ̃CfbNXf[^]
	if( Graphics_Hardware_IndexBuffer_SetData_PF( IndexBuffer, SetIndex, IndexData, IndexNum ) < 0 )
	{
		return -1 ;
	}

	// I
	return 0 ;
}

// CfbNXobt@nh̃CfbNXobt@̃AhX擾
extern void * NS_GetBufferIndexBuffer( int IndexBufHandle )
{
	INDEXBUFFERHANDLEDATA *IndexBuffer ;

	// G[
	if( INDEXBUFFERCHK( IndexBufHandle, IndexBuffer ) )
		return NULL ;

	// AhXԂ
	return IndexBuffer->Buffer ;
}

// CfbNXobt@nh̃CfbNXobt@ւ̕ύXKp( GetBufferIndexBuffer Ŏ擾obt@ւ̕ύX𔽉f )
extern int NS_UpdateIndexBuffer( int IndexBufHandle, int UpdateStartIndex, int UpdateIndexNum )
{
	INDEXBUFFERHANDLEDATA *IndexBuffer ;

	// G[
	if( INDEXBUFFERCHK( IndexBufHandle, IndexBuffer ) )
		return -1 ;

	// G[`FbN
	if( IndexBuffer->Num < UpdateStartIndex + UpdateIndexNum || UpdateStartIndex < 0 )
		return -1 ;

	// ˑ̃CfbNXf[^]
	if( Graphics_Hardware_IndexBuffer_SetData_PF( IndexBuffer, UpdateStartIndex, ( BYTE * )IndexBuffer->Buffer + UpdateStartIndex * IndexBuffer->UnitSize, UpdateIndexNum ) < 0 )
	{
		return -1 ;
	}

	// I
	return 0 ;
}

// OtBbNXfoCXΉĂxɕ`łv~eBu̍ő吔擾
extern int NS_GetMaxPrimitiveCount( void )
{
	return GSYS.HardInfo.MaxPrimitiveCount ;
}

// OtBbNXfoCXΉĂxɎgp邱Ƃ̂łő咸_擾
extern int NS_GetMaxVertexIndex( void )
{
	return GSYS.HardInfo.MaxVertexIndex ;
}






















// VF[_[֌W֐

// gpłVF[_[̃o[W擾( 0=gȂ  200=VF[_[fQDOgp\  300=VF[_[fRDOgp\ )
extern int NS_GetValidShaderVersion( void )
{
	return Graphics_Hardware_Shader_GetValidShaderVersion_PF() ;
}

// _VF[_[oCit@Cǂݍݒ_VF[_[nh쐬( ߂l -1:G[  -1ȊO:VF[_[nh )
extern int NS_LoadVertexShader( const TCHAR *FileName )
{
#ifdef UNICODE
	return LoadVertexShader_WCHAR_T(
		FileName
	) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, return -1 )

	Result = LoadVertexShader_WCHAR_T(
		UseFileNameBuffer
	) ;

	TCHAR_TO_WCHAR_T_STRING_END( FileName )

	return Result ;
#endif
}

// _VF[_[oCit@Cǂݍݒ_VF[_[nh쐬( ߂l -1:G[  -1ȊO:VF[_[nh )
extern int NS_LoadVertexShaderWithStrLen( const TCHAR *FileName, size_t FileNameLength )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = LoadVertexShader_WCHAR_T( UseFileNameBuffer ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = LoadVertexShader_WCHAR_T( UseFileNameBuffer ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#endif
	return Result ;
}

// _VF[_[oCit@Cǂݍݒ_VF[_[nh쐬( ߂l -1:G[  -1ȊO:VF[_[nh )
extern int LoadVertexShader_WCHAR_T( const wchar_t *FileName )
{
	return Graphics_Shader_LoadShader_UseGParam( DX_SHADERTYPE_VERTEX, FileName, GetASyncLoadFlag() ) ;
}

// WIgoCit@Cǂݍ݃WIgnh쐬( ߂l -1:G[  -1ȊO:VF[_[nh )
extern int NS_LoadGeometryShader( const TCHAR *FileName )
{
#ifdef UNICODE
	return LoadGeometryShader_WCHAR_T(
		FileName
	) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, return -1 )

	Result = LoadGeometryShader_WCHAR_T(
		UseFileNameBuffer
	) ;

	TCHAR_TO_WCHAR_T_STRING_END( FileName )

	return Result ;
#endif
}

// WIgoCit@Cǂݍ݃WIgnh쐬( ߂l -1:G[  -1ȊO:VF[_[nh )
extern int NS_LoadGeometryShaderWithStrLen( const TCHAR *FileName, size_t FileNameLength )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = LoadGeometryShader_WCHAR_T( UseFileNameBuffer ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = LoadGeometryShader_WCHAR_T( UseFileNameBuffer ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#endif
	return Result ;
}

// WIgoCit@Cǂݍ݃WIgnh쐬( ߂l -1:G[  -1ȊO:VF[_[nh )
extern int LoadGeometryShader_WCHAR_T( const wchar_t *FileName )
{
	return Graphics_Shader_LoadShader_UseGParam( DX_SHADERTYPE_GEOMETRY, FileName, GetASyncLoadFlag() ) ;
}

// sNZVF[_[oCit@Cǂݍ݃sNZVF[_[nh쐬( ߂l -1:G[  -1ȊO:VF[_[nh )
extern int NS_LoadPixelShader( const TCHAR *FileName )
{
#ifdef UNICODE
	return LoadPixelShader_WCHAR_T(
		FileName
	) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, return -1 )

	Result = LoadPixelShader_WCHAR_T(
		UseFileNameBuffer
	) ;

	TCHAR_TO_WCHAR_T_STRING_END( FileName )

	return Result ;
#endif
}

// sNZVF[_[oCit@Cǂݍ݃sNZVF[_[nh쐬( ߂l -1:G[  -1ȊO:VF[_[nh )
extern int NS_LoadPixelShaderWithStrLen( const TCHAR *FileName, size_t FileNameLength )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = LoadPixelShader_WCHAR_T( UseFileNameBuffer ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = LoadPixelShader_WCHAR_T( UseFileNameBuffer ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#endif
	return Result ;
}

// sNZVF[_[oCit@Cǂݍ݃sNZVF[_[nh쐬( ߂l -1:G[  -1ȊO:VF[_[nh )
extern int LoadPixelShader_WCHAR_T( const wchar_t *FileName )
{
	return Graphics_Shader_LoadShader_UseGParam( DX_SHADERTYPE_PIXEL, FileName, GetASyncLoadFlag() ) ;
}

// ԏɑ݂钸_VF[_[oCi璸_VF[_[nh쐬( ߂l -1:G[  -1ȊO:VF[_[nh )
extern int NS_LoadVertexShaderFromMem( const void *ImageAddress, int ImageSize )
{
	return Graphics_Shader_CreateHandle_UseGParam( DX_SHADERTYPE_VERTEX, ( void * )ImageAddress, ImageSize, FALSE, GetASyncLoadFlag() ) ;
}

// ԏɑ݂WIgVF[_[oCiWIgVF[_[nh쐬( ߂l -1:G[  -1ȊO:VF[_[nh )
extern int NS_LoadGeometryShaderFromMem( const void *ImageAddress, int ImageSize )
{
	return Graphics_Shader_CreateHandle_UseGParam( DX_SHADERTYPE_GEOMETRY, ( void * )ImageAddress, ImageSize, FALSE, GetASyncLoadFlag() ) ;
}

// ԏɑ݂sNZVF[_[oCisNZVF[_[nh쐬( ߂l -1:G[  -1ȊO:VF[_[nh )
extern int NS_LoadPixelShaderFromMem( const void *ImageAddress, int ImageSize )
{
	return Graphics_Shader_CreateHandle_UseGParam( DX_SHADERTYPE_PIXEL, ( void * )ImageAddress, ImageSize, FALSE, GetASyncLoadFlag() ) ;
}

// VF[_[nh̍폜
extern int NS_DeleteShader( int ShaderHandle )
{
	return SubHandle( ShaderHandle ) ;
}

// VF[_[nhSč폜
extern int NS_InitShader( void )
{
	if( GSYS.InitializeFlag == FALSE ) return 0 ;

	return AllHandleSub( DX_HANDLETYPE_SHADER ) ;
}

// w̖O萔gpVF[_[萔̔ԍ擾
extern int NS_GetConstIndexToShader( const TCHAR *ConstantName, int ShaderHandle )
{
#ifdef UNICODE
	return GetConstIndexToShader_WCHAR_T(
		ConstantName, ShaderHandle
	) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( ConstantName, return -1 )

	Result = GetConstIndexToShader_WCHAR_T(
		UseConstantNameBuffer, ShaderHandle
	) ;

	TCHAR_TO_WCHAR_T_STRING_END( ConstantName )

	return Result ;
#endif
}
// w̖O萔gpVF[_[萔̔ԍ擾
extern int NS_GetConstIndexToShaderWithStrLen( const TCHAR *ConstantName, size_t ConstantNameLength, int ShaderHandle )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( ConstantName, ConstantNameLength, return -1 )
	Result = GetConstIndexToShader_WCHAR_T( UseConstantNameBuffer, ShaderHandle ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( ConstantName )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( ConstantName, ConstantNameLength, return -1 )
	Result = GetConstIndexToShader_WCHAR_T( UseConstantNameBuffer, ShaderHandle ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( ConstantName )
#endif
	return Result ;
}


// w̖O萔gpVF[_[萔̔ԍ擾
extern int GetConstIndexToShader_WCHAR_T( const wchar_t *ConstantName, int ShaderHandle )
{
	SHADERHANDLEDATA *Shader ;

	// G[
	if( SHADERCHK( ShaderHandle, Shader ) )
	{
		return -1 ;
	}

	// ˑ
	return Graphics_Hardware_Shader_GetConstIndex_PF( ConstantName, Shader ) ;
}

// w̖O萔gpVF[_[萔̐擾
extern int NS_GetConstCountToShader( const TCHAR *ConstantName, int ShaderHandle )
{
#ifdef UNICODE
	return GetConstCountToShader_WCHAR_T(
		ConstantName, ShaderHandle
	) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( ConstantName, return -1 )

	Result = GetConstCountToShader_WCHAR_T(
		UseConstantNameBuffer, ShaderHandle
	) ;

	TCHAR_TO_WCHAR_T_STRING_END( ConstantName )

	return Result ;
#endif
}

// w̖O萔gpVF[_[萔̐擾
extern int NS_GetConstCountToShaderWithStrLen( const TCHAR *ConstantName, size_t ConstantNameLength, int ShaderHandle )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( ConstantName, ConstantNameLength, return -1 )
	Result = GetConstCountToShader_WCHAR_T( UseConstantNameBuffer, ShaderHandle ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( ConstantName )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( ConstantName, ConstantNameLength, return -1 )
	Result = GetConstCountToShader_WCHAR_T( UseConstantNameBuffer, ShaderHandle ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( ConstantName )
#endif
	return Result ;
}

// w̖O萔gpVF[_[萔̐擾
extern int GetConstCountToShader_WCHAR_T( const wchar_t *ConstantName, int ShaderHandle )
{
	SHADERHANDLEDATA *Shader ;

	// G[
	if( SHADERCHK( ShaderHandle, Shader ) )
		return -1 ;

	// ˑ
	return Graphics_Hardware_Shader_GetConstCount_PF( ConstantName, Shader ) ;
}

// w̖O_萔̃ftHgp[^i[Ă郁AhX擾
extern	const FLOAT4 *NS_GetConstDefaultParamFToShader( const TCHAR *ConstantName, int ShaderHandle )
{
#ifdef UNICODE
	return GetConstDefaultParamFToShader_WCHAR_T(
		ConstantName, ShaderHandle
	) ;
#else
	const FLOAT4 * Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( ConstantName, return NULL )

	Result = GetConstDefaultParamFToShader_WCHAR_T(
		UseConstantNameBuffer, ShaderHandle
	) ;

	TCHAR_TO_WCHAR_T_STRING_END( ConstantName )

	return Result ;
#endif
}

// w̖O_萔̃ftHgp[^i[Ă郁AhX擾
extern const FLOAT4 *NS_GetConstDefaultParamFToShaderWithStrLen( const TCHAR *ConstantName, size_t ConstantNameLength, int ShaderHandle )
{
	const FLOAT4 *Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( ConstantName, ConstantNameLength, return NULL )
	Result = GetConstDefaultParamFToShader_WCHAR_T( UseConstantNameBuffer, ShaderHandle ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( ConstantName )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( ConstantName, ConstantNameLength, return NULL )
	Result = GetConstDefaultParamFToShader_WCHAR_T( UseConstantNameBuffer, ShaderHandle ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( ConstantName )
#endif
	return Result ;
}

// w̖O_萔̃ftHgp[^i[Ă郁AhX擾
extern	const FLOAT4 *GetConstDefaultParamFToShader_WCHAR_T( const wchar_t *ConstantName, int ShaderHandle )
{
	SHADERHANDLEDATA *Shader ;

	// G[
	if( SHADERCHK( ShaderHandle, Shader ) )
		return NULL ;

	// ˑ
	return Graphics_Hardware_Shader_GetConstDefaultParamF_PF( ConstantName, Shader ) ;
}

// _VF[_[ float ^萔ݒ肷
extern int NS_SetVSConstSF( int ConstantIndex, float Param )
{
	FLOAT4 ParamF4 ;

	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex >= 256 )
		return -1 ;

	// 萔XV
	ParamF4.x = Param ;
	ParamF4.y = Param ;
	ParamF4.z = Param ;
	ParamF4.w = Param ;
	NS_SetVSConstF( ConstantIndex, ParamF4 ) ;

	// I
	return 0 ;
}

// _VF[_[ float ^萔ݒ肷
extern int NS_SetVSConstF( int ConstantIndex, FLOAT4 Param )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex >= 256 )
		return -1 ;

	// 萔XV
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_VS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, &Param, 1, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ float ^萔ɍsݒ肷
extern	int			NS_SetVSConstFMtx( int ConstantIndex, MATRIX Param )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + 4 > 256 )
		return -1 ;

	// 萔XV
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_VS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ( FLOAT4 * )&Param, 4, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ float ^萔ɓ]usݒ肷
extern	int			NS_SetVSConstFMtxT( int ConstantIndex, MATRIX Param )
{
	MATRIX Transpose ;

	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + 4 > 256 )
		return -1 ;

	// 萔XV
	CreateTransposeMatrix( &Transpose, &Param ) ;
	NS_SetVSConstFMtx( ConstantIndex, Transpose ) ;

	// I
	return 0 ;
}

// _VF[_[ int ^萔ݒ肷
extern	int			NS_SetVSConstSI( int ConstantIndex, int Param )
{
	INT4 ParamI4 ;

	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex >= 16 )
		return -1 ;

	// 萔XV
	ParamI4.x = Param ;
	ParamI4.y = Param ;
	ParamI4.z = Param ;
	ParamI4.w = Param ;
	return NS_SetVSConstI( ConstantIndex, ParamI4 ) ;
}

// _VF[_[ int ^萔ݒ肷
extern	int			NS_SetVSConstI( int ConstantIndex, INT4 Param )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex >= 16 )
		return -1 ;

	// 萔XV
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_VS_INT, DX_SHADERCONSTANTSET_USER, ConstantIndex, &Param, 1, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ BOOL ^萔ݒ肷
extern	int			NS_SetVSConstB( int ConstantIndex, BOOL Param )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex >= 16 )
		return -1 ;

	// 萔XV
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_VS_BOOL, DX_SHADERCONSTANTSET_USER, ConstantIndex, &Param, 1, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ float ^萔ݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetVSConstSFArray( int ConstantIndex, const float *ParamArray, int ParamNum )
{
	FLOAT4 ParamArrayF4[ 256 ] ;
	int i ;

	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 256 )
		return -1 ;

	// zɃf[^Zbg
	for( i = 0 ; i < ParamNum ; i ++ )
	{
		ParamArrayF4[ i ].x = ParamArray[ i ] ;
		ParamArrayF4[ i ].y = ParamArray[ i ] ;
		ParamArrayF4[ i ].z = ParamArray[ i ] ;
		ParamArrayF4[ i ].w = ParamArray[ i ] ;
	}

	// 萔XV
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_VS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArrayF4, ParamNum, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ float ^萔ݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetVSConstFArray( int ConstantIndex, const FLOAT4 *ParamArray, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 256 )
		return -1 ;

	// 萔XV
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_VS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArray, ParamNum, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ float ^萔ɍsݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetVSConstFMtxArray( int ConstantIndex, const MATRIX *ParamArray, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum * 4 > 256 )
		return -1 ;

	// 萔XV
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_VS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArray, ParamNum * 4, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ float ^萔ɓ]usݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetVSConstFMtxTArray( int ConstantIndex, const MATRIX *ParamArray, int ParamNum )
{
	MATRIX Transpose[ 256 / 4 ] ;
	int i ;

	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum * 4 > 256 )
		return -1 ;

	// 萔XV
	for( i = 0 ; i < ParamNum ; i ++ )
	{
		Transpose[ i ].m[ 0 ][ 0 ] = ParamArray[ i ].m[ 0 ][ 0 ] ;
		Transpose[ i ].m[ 1 ][ 0 ] = ParamArray[ i ].m[ 0 ][ 1 ] ;
		Transpose[ i ].m[ 2 ][ 0 ] = ParamArray[ i ].m[ 0 ][ 2 ] ;
		Transpose[ i ].m[ 3 ][ 0 ] = ParamArray[ i ].m[ 0 ][ 3 ] ;

		Transpose[ i ].m[ 0 ][ 1 ] = ParamArray[ i ].m[ 1 ][ 0 ] ;
		Transpose[ i ].m[ 1 ][ 1 ] = ParamArray[ i ].m[ 1 ][ 1 ] ;
		Transpose[ i ].m[ 2 ][ 1 ] = ParamArray[ i ].m[ 1 ][ 2 ] ;
		Transpose[ i ].m[ 3 ][ 1 ] = ParamArray[ i ].m[ 1 ][ 3 ] ;

		Transpose[ i ].m[ 0 ][ 2 ] = ParamArray[ i ].m[ 2 ][ 0 ] ;
		Transpose[ i ].m[ 1 ][ 2 ] = ParamArray[ i ].m[ 2 ][ 1 ] ;
		Transpose[ i ].m[ 2 ][ 2 ] = ParamArray[ i ].m[ 2 ][ 2 ] ;
		Transpose[ i ].m[ 3 ][ 2 ] = ParamArray[ i ].m[ 2 ][ 3 ] ;

		Transpose[ i ].m[ 0 ][ 3 ] = ParamArray[ i ].m[ 3 ][ 0 ] ;
		Transpose[ i ].m[ 1 ][ 3 ] = ParamArray[ i ].m[ 3 ][ 1 ] ;
		Transpose[ i ].m[ 2 ][ 3 ] = ParamArray[ i ].m[ 3 ][ 2 ] ;
		Transpose[ i ].m[ 3 ][ 3 ] = ParamArray[ i ].m[ 3 ][ 3 ] ;
	}
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_VS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, Transpose, ParamNum * 4, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ int ^萔ݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetVSConstSIArray( int ConstantIndex, const int *ParamArray, int ParamNum )
{
	INT4 ParamArrayI4[ 16 ] ;
	int i ;

	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 16 )
		return -1 ;

	// z̃Zbg
	for( i = 0 ; i < ParamNum ; i ++ )
	{
		ParamArrayI4[ i ].x = ParamArray[ i ] ;
		ParamArrayI4[ i ].y = ParamArray[ i ] ;
		ParamArrayI4[ i ].z = ParamArray[ i ] ;
		ParamArrayI4[ i ].w = ParamArray[ i ] ;
	}

	// 萔XV
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_VS_INT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArrayI4, ParamNum, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ int ^萔ݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetVSConstIArray( int ConstantIndex, const INT4 *ParamArray, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 16 )
		return -1 ;

	// 萔XV
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_VS_INT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArray, ParamNum, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ BOOL ^萔ݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetVSConstBArray( int ConstantIndex, const BOOL *ParamArray, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 16 )
		return -1 ;

	// 萔XV
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_VS_BOOL, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArray, ParamNum, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ float ^萔̐ݒZbg
extern	int			NS_ResetVSConstF( int ConstantIndex, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 256 )
		return -1 ;

	// 萔Zbg
	Graphics_Hardware_Shader_ResetConst_PF( DX_SHADERCONSTANTTYPE_VS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamNum ) ;

	// I
	return 0 ;
}

// _VF[_[ int ^萔̐ݒZbg
extern	int			NS_ResetVSConstI( int ConstantIndex, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 16 )
		return -1 ;

	// 萔Zbg
	Graphics_Hardware_Shader_ResetConst_PF( DX_SHADERCONSTANTTYPE_VS_INT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamNum ) ;

	// I
	return 0 ;
}

// _VF[_[ BOOL ^萔̐ݒZbg
extern	int			NS_ResetVSConstB( int ConstantIndex, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 16 )
		return -1 ;

	// 萔Zbg
	Graphics_Hardware_Shader_ResetConst_PF( DX_SHADERCONSTANTTYPE_VS_BOOL, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamNum ) ;

	// I
	return 0 ;
}

// sNZVF[_[ float ^萔ݒ肷
extern	int			NS_SetPSConstSF( int ConstantIndex, float Param )
{
	FLOAT4 ParamF4 ;

	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex >= 224 )
		return -1 ;

	// 萔XV
	ParamF4.x = Param ;
	ParamF4.y = Param ;
	ParamF4.z = Param ;
	ParamF4.w = Param ;
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, &ParamF4, 1, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ float ^萔ݒ肷
extern	int			NS_SetPSConstF( int ConstantIndex, FLOAT4 Param )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex >= 224 )
		return -1 ;

	// 萔XV
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, &Param, 1, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ float ^萔ɍsݒ肷
extern	int			NS_SetPSConstFMtx( int ConstantIndex, MATRIX Param )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + 4 > 224 )
		return -1 ;

	// 萔XV
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ( FLOAT4 * )&Param, 4, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ float ^萔ɓ]usݒ肷
extern	int			NS_SetPSConstFMtxT( int ConstantIndex, MATRIX Param )
{
	MATRIX Transpose ;

	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + 4 > 224 )
		return -1 ;

	// 萔XV
	CreateTransposeMatrix( &Transpose, &Param ) ;
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ( FLOAT4 * )&Transpose, 4, TRUE ) ;

	// I
	return 0 ;
}


// sNZVF[_[ int ^萔ݒ肷
extern	int			NS_SetPSConstSI( int ConstantIndex, int Param )
{
	INT4 ParamI4 ;

	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex >= 16 )
		return -1 ;

	// 萔XV
	ParamI4.x = Param ;
	ParamI4.y = Param ;
	ParamI4.z = Param ;
	ParamI4.w = Param ;
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_PS_INT, DX_SHADERCONSTANTSET_USER, ConstantIndex, &ParamI4, 1, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ int ^萔ݒ肷
extern	int			NS_SetPSConstI( int ConstantIndex, INT4 Param )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex >= 16 )
		return -1 ;

	// 萔XV
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_PS_INT, DX_SHADERCONSTANTSET_USER, ConstantIndex, &Param, 1, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ BOOL ^萔ݒ肷
extern	int			NS_SetPSConstB( int ConstantIndex, BOOL Param )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex >= 16 )
		return -1 ;

	// 萔XV
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_PS_BOOL, DX_SHADERCONSTANTSET_USER, ConstantIndex, &Param, 1, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ float ^萔ݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetPSConstSFArray( int ConstantIndex, const float *ParamArray, int ParamNum )
{
	FLOAT4 ParamArrayF4[ 256 ] ;
	int i ;

	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 224 )
		return -1 ;

	// zɃZbg
	for( i = 0 ; i < ParamNum ; i ++ )
	{
		ParamArrayF4[ i ].x = ParamArray[ i ] ;
		ParamArrayF4[ i ].y = ParamArray[ i ] ;
		ParamArrayF4[ i ].z = ParamArray[ i ] ;
		ParamArrayF4[ i ].w = ParamArray[ i ] ;
	}

	// 萔XV
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArrayF4, ParamNum, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ float ^萔ݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetPSConstFArray( int ConstantIndex, const FLOAT4 *ParamArray, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 224 )
		return -1 ;

	// 萔XV
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArray, ParamNum, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ float ^萔ɍsݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetPSConstFMtxArray( int ConstantIndex, const MATRIX *ParamArray, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum * 4 > 224 )
		return -1 ;

	// 萔XV
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArray, ParamNum * 4, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ float ^萔ɓ]usݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetPSConstFMtxTArray( int ConstantIndex, const MATRIX *ParamArray, int ParamNum )
{
	int i ;
	MATRIX Transpose[ 224 / 4 ] ;

	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum * 4 > 224 )
		return -1 ;

	// 萔XV
	for( i = 0 ; i < ParamNum ; i ++ )
	{
		Transpose[ i ].m[ 0 ][ 0 ] = ParamArray[ i ].m[ 0 ][ 0 ] ;
		Transpose[ i ].m[ 1 ][ 0 ] = ParamArray[ i ].m[ 0 ][ 1 ] ;
		Transpose[ i ].m[ 2 ][ 0 ] = ParamArray[ i ].m[ 0 ][ 2 ] ;
		Transpose[ i ].m[ 3 ][ 0 ] = ParamArray[ i ].m[ 0 ][ 3 ] ;

		Transpose[ i ].m[ 0 ][ 1 ] = ParamArray[ i ].m[ 1 ][ 0 ] ;
		Transpose[ i ].m[ 1 ][ 1 ] = ParamArray[ i ].m[ 1 ][ 1 ] ;
		Transpose[ i ].m[ 2 ][ 1 ] = ParamArray[ i ].m[ 1 ][ 2 ] ;
		Transpose[ i ].m[ 3 ][ 1 ] = ParamArray[ i ].m[ 1 ][ 3 ] ;

		Transpose[ i ].m[ 0 ][ 2 ] = ParamArray[ i ].m[ 2 ][ 0 ] ;
		Transpose[ i ].m[ 1 ][ 2 ] = ParamArray[ i ].m[ 2 ][ 1 ] ;
		Transpose[ i ].m[ 2 ][ 2 ] = ParamArray[ i ].m[ 2 ][ 2 ] ;
		Transpose[ i ].m[ 3 ][ 2 ] = ParamArray[ i ].m[ 2 ][ 3 ] ;

		Transpose[ i ].m[ 0 ][ 3 ] = ParamArray[ i ].m[ 3 ][ 0 ] ;
		Transpose[ i ].m[ 1 ][ 3 ] = ParamArray[ i ].m[ 3 ][ 1 ] ;
		Transpose[ i ].m[ 2 ][ 3 ] = ParamArray[ i ].m[ 3 ][ 2 ] ;
		Transpose[ i ].m[ 3 ][ 3 ] = ParamArray[ i ].m[ 3 ][ 3 ] ;
	}
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, Transpose, ParamNum * 4, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ int ^萔ݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetPSConstSIArray( int ConstantIndex, const int *ParamArray, int ParamNum )
{
	INT4 ParamArrayI4[ 16 ] ;
	int i ;

	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 16 )
		return -1 ;

	// zɃp[^Zbg
	for( i = 0 ; i < ParamNum ; i ++ )
	{
		ParamArrayI4[ i ].x = ParamArray[ i ] ;
		ParamArrayI4[ i ].y = ParamArray[ i ] ;
		ParamArrayI4[ i ].z = ParamArray[ i ] ;
		ParamArrayI4[ i ].w = ParamArray[ i ] ;
	}

	// 萔XV
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_PS_INT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArrayI4, ParamNum, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ int ^萔ݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetPSConstIArray( int ConstantIndex, const INT4 *ParamArray, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 16 )
		return -1 ;

	// 萔XV
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_PS_INT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArray, ParamNum, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ BOOL ^萔ݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetPSConstBArray( int ConstantIndex, const BOOL *ParamArray, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 16 )
		return -1 ;

	// 萔XV
	Graphics_Hardware_Shader_SetConst_PF( DX_SHADERCONSTANTTYPE_PS_BOOL, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArray, ParamNum, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ float ^萔̐ݒZbg
extern	int			NS_ResetPSConstF( int ConstantIndex, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 256 )
		return -1 ;

	// 萔Zbg
	Graphics_Hardware_Shader_ResetConst_PF( DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamNum ) ;

	// I
	return 0 ;
}

// sNZVF[_[ int ^萔̐ݒZbg
extern	int			NS_ResetPSConstI( int ConstantIndex, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 16 )
		return -1 ;

	// 萔Zbg
	Graphics_Hardware_Shader_ResetConst_PF( DX_SHADERCONSTANTTYPE_PS_INT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamNum ) ;

	// I
	return 0 ;
}

// sNZVF[_[ BOOL ^萔̐ݒZbg
extern	int			NS_ResetPSConstB( int ConstantIndex, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GSYS.HardInfo.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 16 )
		return -1 ;

	// 萔Zbg
	Graphics_Hardware_Shader_ResetConst_PF( DX_SHADERCONSTANTTYPE_PS_BOOL, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamNum ) ;

	// I
	return 0 ;
}

// VF[_[`ł̕`ݒ肷
extern int NS_SetRenderTargetToShader( int TargetIndex, int DrawScreen, int SurfaceIndex , int MipLevel )
{
	int OldScreen ;

	// ^[QbgCfbNX͈̔̓`FbN
	if( TargetIndex < 0 || TargetIndex >= GSYS.HardInfo.RenderTargetNum )
		return -1 ;

	// lꍇ͉I
//	if( GSYS.DrawSetting.TargetScreen[ TargetIndex ] == DrawScreen && GSYS.DrawSetting.TargetScreenSurface[ TargetIndex ] == SurfaceIndex )
//		return 0 ;

	// ^[QbgOŃT[tFXCfbNXȌꍇ SetDrawScreen ɔC
	if( TargetIndex == 0 && SurfaceIndex == 0 && MipLevel == 0 )
	{
		return NS_SetDrawScreen( DrawScreen ) ;
	}

	// n[hEGAœ삵ĂȂꍇ͉Ȃ
	if( GSYS.Setting.ValidHardware == FALSE || GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode )
	{
		return -1 ;
	}

	OldScreen = GSYS.DrawSetting.TargetScreen[ TargetIndex ] ;

	// 摜nhۑ
	GSYS.DrawSetting.TargetScreen[ TargetIndex ] = DrawScreen ;
	GSYS.DrawSetting.TargetScreenSurface[ TargetIndex ] = SurfaceIndex ;
	GSYS.DrawSetting.TargetScreenMipLevel[ TargetIndex ] = MipLevel ;

	// ^[Qbg 0 ꍇ͕`\TCY̎擾
	if( TargetIndex == 0 )
	{
		NS_GetGraphSize( DrawScreen, &GSYS.DrawSetting.DrawSizeX, &GSYS.DrawSetting.DrawSizeY ) ;
		if( MipLevel > 0 )
		{
			Graphics_Image_CalcMipSize( GSYS.DrawSetting.DrawSizeX, GSYS.DrawSetting.DrawSizeY, MipLevel, &GSYS.DrawSetting.DrawSizeX, &GSYS.DrawSetting.DrawSizeY ) ;
		}
	}

	// `ɐlނǂ̃tOXV
	Graphics_DrawSetting_RefreshAlphaChDrawMode() ;

	// n[hEGAANZ[Vʂ̏s
	if( Graphics_Hardware_SetRenderTargetToShader_PF( TargetIndex, DrawScreen, SurfaceIndex, MipLevel ) < 0 )
	{
		return -1 ;
	}

	// ^[Qbg 0 ꍇ͕`͈͂̐ݒJ̐ݒs
	if( TargetIndex == 0 )
	{
		Graphics_DrawSetting_SetupDefaultDrawAreaAndCamera( OldScreen ) ;
	}

	// I
	return 0 ;
}

// VF[_[`ŎgpOtBbNݒ肷
extern	int			NS_SetUseTextureToShader( int StageIndex, int GraphHandle )
{
	// L͈̓`FbN
	if( StageIndex < 0 || StageIndex >= USE_TEXTURESTAGE_NUM )
		return -1 ;

	// OtBbNnh`FbN
	if( GraphHandle != -1 )
	{
		IMAGEDATA *Image ;
		SHADOWMAPDATA *ShadowMap ;

		if( GRAPHCHKFULL(     GraphHandle, Image    ) &&
			SHADOWMAPCHKFULL( GraphHandle, ShadowMap ) )
			return -1 ;

		// nhۑ
		GSYS.DrawSetting.UserShaderRenderInfo.SetTextureGraphHandle[ StageIndex ] = GraphHandle ;
	}
	else
	{
		// nhZbg
		GSYS.DrawSetting.UserShaderRenderInfo.SetTextureGraphHandle[ StageIndex ] = 0 ;
	}

	// I
	return 0 ;
}

// VF[_[`Ɏgp钸_VF[_[ݒ肷
extern	int			NS_SetUseVertexShader( int ShaderHandle )
{
	SHADERHANDLEDATA *VertexShader ;

	if( ShaderHandle > 0 && ( SHADERCHK( ShaderHandle, VertexShader ) || VertexShader->ShaderType != DX_SHADERTYPE_VERTEX ) )
		return -1 ;

	// nhZbg
	GSYS.DrawSetting.UserShaderRenderInfo.SetVertexShaderHandle = ShaderHandle <= 0 ? 0 : ShaderHandle ;

	// I
	return 0 ;
}

// VF[_[gp`ɎgpWIgVF[_[ݒ肷( -1nƉ )
extern	int			NS_SetUseGeometryShader( int ShaderHandle )
{
	SHADERHANDLEDATA *GeometryShader ;

	if( ShaderHandle > 0 && ( SHADERCHK( ShaderHandle, GeometryShader ) || GeometryShader->ShaderType != DX_SHADERTYPE_GEOMETRY ) )
		return -1 ;

	// nhZbg
	GSYS.DrawSetting.UserShaderRenderInfo.SetGeometryShaderHandle = ShaderHandle <= 0 ? 0 : ShaderHandle ;

	// I
	return 0 ;
}

// VF[_[`ɎgpsNZVF[_[ݒ肷
extern	int			NS_SetUsePixelShader( int ShaderHandle )
{
	SHADERHANDLEDATA *PixelShader ;

	if( ShaderHandle > 0 && ( SHADERCHK( ShaderHandle, PixelShader ) || PixelShader->ShaderType != DX_SHADERTYPE_PIXEL ) )
		return -1 ;

	// nhZbg
	GSYS.DrawSetting.UserShaderRenderInfo.SetPixelShaderHandle = ShaderHandle <= 0 ? 0 : ShaderHandle  ;

	// I
	return 0 ;
}

// |S̒_̐ڐƏ]@tuWvZăZbg
extern int NS_CalcPolygonBinormalAndTangentsToShader( VERTEX3DSHADER *Vertex, int PolygonNum )
{
	unsigned short *Indices ;
	int IndexNum ;
	int i ;
	int Result ;

	IndexNum = PolygonNum * 3 ;

	Indices = ( unsigned short * )DXALLOC( IndexNum * sizeof( unsigned short ) ) ;
	if( Indices == NULL )
	{
		DXST_LOGFILEFMT_ADDUTF16LE(( "\x02\x98\xb9\x70\xa4\x30\xf3\x30\xc7\x30\xc3\x30\xaf\x30\xb9\x30\x92\x30\x3c\x68\x0d\x7d\x59\x30\x8b\x30\xe1\x30\xe2\x30\xea\x30\x18\x98\xdf\x57\x6e\x30\xba\x78\xdd\x4f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"_CfbNXi[郁̈̊mۂɎs܂\n" @*/ )) ;
		return -1 ;
	}

	// _CfbNXZbg
	for( i = 0 ; i < IndexNum ; i ++ )
	{
		Indices[ i ] = ( unsigned short )i ;
	}

	// ڐƏ]@vZ
	Result = NS_CalcPolygonIndexedBinormalAndTangentsToShader( Vertex, IndexNum, Indices, PolygonNum ) ;

	// _CfbNXi[Ă̈J
	DXFREE( Indices ) ;

	// I
	return Result ;
}

// |S̒_̐ڐƏ]@tuWvZăZbg(CfbNX)
extern int NS_CalcPolygonIndexedBinormalAndTangentsToShader( VERTEX3DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum )
{
	int i ;
	VECTOR v1, v2, vt, du, dv, vb, vn ;
	BYTE *UseFlag ;
	const unsigned short *Index ;
	int IndexNum ;
	VERTEX3DSHADER *Vert[ 3 ] ;

	// gpĂ钸_̃e[u쐬
	{
		UseFlag = ( BYTE * )DXALLOC( sizeof( BYTE ) * VertexNum ) ;
		if( UseFlag == NULL )
		{
			DXST_LOGFILEFMT_ADDUTF16LE(( "\x02\x98\xb9\x70\x6e\x30\xa5\x63\xda\x7d\x68\x30\x93\x5f\xd5\x6c\xda\x7d\x6e\x30\x5c\x4f\x10\x62\x5c\x4f\x6d\x69\x6b\x30\xc5\x5f\x81\x89\x6a\x30\xe1\x30\xe2\x30\xea\x30\x18\x98\xdf\x57\x6e\x30\xba\x78\xdd\x4f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"_̐ڐƏ]@̍쐬ƂɕKvȃ̈̊mۂɎs܂\n" @*/ )) ;
			return -1 ;
		}
		_MEMSET( UseFlag, 0, ( size_t )VertexNum ) ;

		IndexNum = PolygonNum * 3 ;
		for( i = 0 ; i < IndexNum ; i ++ )
		{
			UseFlag[ Indices[ i ] ] = 1 ;
		}
	}

	// ڐƏ]@̏
	for( i = 0 ; i < VertexNum ; i ++ )
	{
		if( UseFlag[ i ] == 0 ) continue ;
		Vertex[ i ].binorm.x = 0.0f ;
		Vertex[ i ].binorm.y = 0.0f ;
		Vertex[ i ].binorm.z = 0.0f ;
		Vertex[ i ].tan.x = 0.0f ;
		Vertex[ i ].tan.y = 0.0f ;
		Vertex[ i ].tan.z = 0.0f ;
	}

	// SĂ̖ʂ̐JԂ
	Index = Indices ;
	for( i = 0 ; i < PolygonNum ; i ++, Index += 3 )
	{
		Vert[ 0 ] = &Vertex[ Index[ 0 ] ] ;
		Vert[ 1 ] = &Vertex[ Index[ 1 ] ] ;
		Vert[ 2 ] = &Vertex[ Index[ 2 ] ] ;

		v1.x = Vert[ 1 ]->pos.x - Vert[ 0 ]->pos.x ;
		v1.y = Vert[ 1 ]->u - Vert[ 0 ]->u ;
		v1.z = Vert[ 1 ]->v - Vert[ 0 ]->v ;

		v2.x = Vert[ 2 ]->pos.x - Vert[ 0 ]->pos.x ;
		v2.y = Vert[ 2 ]->u - Vert[ 0 ]->u ;
		v2.z = Vert[ 2 ]->v - Vert[ 0 ]->v ;

		vt = VCross( v1, v2 ) ;
		du.x = 1.0f ;
		if( VDot( vt, vt ) >= 0.0000001f )
		{
			du.x = -vt.y / vt.x ;
			dv.x = -vt.z / vt.x ;
		}

		v1.x = Vert[ 1 ]->pos.y - Vert[ 0 ]->pos.y ;
		v2.x = Vert[ 2 ]->pos.y - Vert[ 0 ]->pos.y ;

		vt = VCross( v1, v2 ) ;
		du.y = 1.0f ;
		if( VDot( vt, vt ) >= 0.0000001f )
		{
			du.y = -vt.y / vt.x ;
			dv.y = -vt.z / vt.x ;
		}

		v1.x = Vert[ 1 ]->pos.z - Vert[ 0 ]->pos.z ;
		v2.x = Vert[ 2 ]->pos.z - Vert[ 0 ]->pos.z ;

		vt = VCross( v1, v2 ) ;
		du.z = 1.0f ;
		if( VDot( vt, vt ) >= 0.0000001f )
		{
			du.z = -vt.y / vt.x ;
			dv.z = -vt.z / vt.x ;
		}

		VectorAdd( &Vert[ 0 ]->tan, &Vert[ 0 ]->tan, &du ) ;
		VectorAdd( &Vert[ 1 ]->tan, &Vert[ 1 ]->tan, &du ) ;
		VectorAdd( &Vert[ 2 ]->tan, &Vert[ 2 ]->tan, &du ) ;

		VectorAdd( &Vert[ 0 ]->binorm, &Vert[ 0 ]->binorm, &dv ) ;
		VectorAdd( &Vert[ 1 ]->binorm, &Vert[ 1 ]->binorm, &dv ) ;
		VectorAdd( &Vert[ 2 ]->binorm, &Vert[ 2 ]->binorm, &dv ) ;
	}

	// @̎ZoƐK
	for( i = 0 ; i < VertexNum ; i ++ )
	{
		if( UseFlag[ i ] == 0 ) continue ;

		vt = VNorm( Vertex[ i ].tan ) ;
		vn = VNorm( VCross( vt, Vertex[ i ].binorm ) ) ;
		vb = VNorm( VCross( vn, vt ) ) ;

		// K
		Vertex[ i ].tan    = vt ;
		Vertex[ i ].binorm = vb ;
	}

	// ̉
	DXFREE( UseFlag ) ;

	// I
	return 0 ;
}


// VF[_[găr{[h`悷
extern	int NS_DrawBillboard3DToShader( VECTOR Pos, float cx, float cy, float Size, float Angle, int GrHandle, int /*TransFlag*/, int ReverseXFlag, int ReverseYFlag )
{
	IMAGEDATA_HARD_DRAW *DrawTex ;
//	IMAGEDATA_ORIG *Orig ;
	IMAGEDATA_HARD_VERT *TexVect ;
	DWORD DiffuseColor ;
	float SizeX ;
	float SizeY ;
	float f ;
	VECTOR SrcVec[ 4 ] ;
	float Sin = 0.0f ;
	float Cos = 1.0f ;
	float ScaleX ;
	float ScaleY ;
	IMAGEDATA *Image ;
	VERTEX3DSHADER DrawVect3D[ 6 ] ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE ) return -1 ;

	// `ݒ肪Ăꍇ͉I
	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
		return 0 ;

	// gpeNX`OԂƂăZbg
	NS_SetUseTextureToShader( 0, GrHandle ) ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;

#ifndef DX_NON_MOVIE
	if( Image->Orig->MovieHandle != -1 )
		UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
#endif

//	Orig = Image->Orig ;

	if( Graphics_Hardware_CheckValid_PF() == 0 ) return -1 ;

	// `z̃AhXZbgĂ
	DrawTex = Image->Hard.Draw ;

	// _f[^擾
	DiffuseColor = GetDiffuseColor() ;

	// TCYƍW֌W̎OvZ
	SizeX = Size ;
	SizeY = Size * Image->HeightF / Image->WidthF ;

	ScaleX = SizeX / Image->WidthF ;
	ScaleY = SizeY / Image->HeightF ;
	cx *= Image->WidthF ;
	cy *= Image->HeightF ;

	// ]ꍇ͉]l߂Ă
	if( Angle != 0.0 )
	{
		_SINCOS_PLATFORM( (float)Angle, &Sin, &Cos ) ;
	}

	TexVect = DrawTex->Vertex ;

	// ]ꍇƂȂꍇŏ𕪊
	if( Angle != 0.0 )
	{
		// [JW
		SrcVec[2].x = SrcVec[0].x = ( -cx + TexVect[0].x ) * ScaleX ;
		SrcVec[3].x = SrcVec[1].x = ( -cx + TexVect[1].x ) * ScaleX ;

		SrcVec[1].y = SrcVec[0].y = ( -cy + Image->HeightF - TexVect[0].y ) * ScaleY ;
		SrcVec[3].y = SrcVec[2].y = ( -cy + Image->HeightF - TexVect[2].y ) * ScaleY ;

		// ]vZ
		f             = SrcVec[ 0 ].x * Cos - SrcVec[ 0 ].y * Sin ;	
		SrcVec[ 0 ].y = SrcVec[ 0 ].x * Sin + SrcVec[ 0 ].y * Cos ;
		SrcVec[ 0 ].x = f ;

		f             = SrcVec[ 1 ].x * Cos - SrcVec[ 1 ].y * Sin ;	
		SrcVec[ 1 ].y = SrcVec[ 1 ].x * Sin + SrcVec[ 1 ].y * Cos ;
		SrcVec[ 1 ].x = f ;

		f             = SrcVec[ 2 ].x * Cos - SrcVec[ 2 ].y * Sin ;	
		SrcVec[ 2 ].y = SrcVec[ 2 ].x * Sin + SrcVec[ 2 ].y * Cos ;
		SrcVec[ 2 ].x = f ;

		f             = SrcVec[ 3 ].x * Cos - SrcVec[ 3 ].y * Sin ;	
		SrcVec[ 3 ].y = SrcVec[ 3 ].x * Sin + SrcVec[ 3 ].y * Cos ;
		SrcVec[ 3 ].x = f ;

		// r{[hW[hW֕ϊ
		DrawVect3D[ 0 ].pos.x = SrcVec[ 0 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + SrcVec[ 0 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Pos.x ;
		DrawVect3D[ 0 ].pos.y = SrcVec[ 0 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + SrcVec[ 0 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Pos.y ;
		DrawVect3D[ 0 ].pos.z = SrcVec[ 0 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + SrcVec[ 0 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Pos.z ;

		DrawVect3D[ 1 ].pos.x = SrcVec[ 1 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + SrcVec[ 1 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Pos.x ;
		DrawVect3D[ 1 ].pos.y = SrcVec[ 1 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + SrcVec[ 1 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Pos.y ;
		DrawVect3D[ 1 ].pos.z = SrcVec[ 1 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + SrcVec[ 1 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Pos.z ;

		DrawVect3D[ 2 ].pos.x = SrcVec[ 2 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + SrcVec[ 2 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Pos.x ;
		DrawVect3D[ 2 ].pos.y = SrcVec[ 2 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + SrcVec[ 2 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Pos.y ;
		DrawVect3D[ 2 ].pos.z = SrcVec[ 2 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + SrcVec[ 2 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Pos.z ;

		DrawVect3D[ 3 ].pos.x = SrcVec[ 3 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + SrcVec[ 3 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Pos.x ;
		DrawVect3D[ 3 ].pos.y = SrcVec[ 3 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + SrcVec[ 3 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Pos.y ;
		DrawVect3D[ 3 ].pos.z = SrcVec[ 3 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + SrcVec[ 3 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Pos.z ;
	}
	else
	{
		VECTOR TempVecX[ 2 ], TempVecY[ 2 ] ;

		// [JW
		SrcVec[0].x = ( -cx + TexVect[0].x ) * ScaleX ;
		SrcVec[1].x = ( -cx + TexVect[1].x ) * ScaleX ;

		SrcVec[0].y = ( -cy + Image->HeightF - TexVect[0].y ) * ScaleY ;
		SrcVec[2].y = ( -cy + Image->HeightF - TexVect[2].y ) * ScaleY ;

		// r{[hW[hW֕ϊ
		TempVecX[ 0 ].x = SrcVec[ 0 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + Pos.x ;
		TempVecX[ 0 ].y = SrcVec[ 0 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + Pos.y ;
		TempVecX[ 0 ].z = SrcVec[ 0 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + Pos.z ;

		TempVecX[ 1 ].x = SrcVec[ 1 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + Pos.x ;
		TempVecX[ 1 ].y = SrcVec[ 1 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + Pos.y ;
		TempVecX[ 1 ].z = SrcVec[ 1 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + Pos.z ;

		TempVecY[ 0 ].x = SrcVec[ 0 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][0] ;
		TempVecY[ 0 ].y = SrcVec[ 0 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][1] ;
		TempVecY[ 0 ].z = SrcVec[ 0 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][2] ;

		TempVecY[ 1 ].x = SrcVec[ 2 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][0] ;
		TempVecY[ 1 ].y = SrcVec[ 2 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][1] ;
		TempVecY[ 1 ].z = SrcVec[ 2 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][2] ;

		DrawVect3D[ 0 ].pos.x = TempVecX[ 0 ].x + TempVecY[ 0 ].x ;
		DrawVect3D[ 0 ].pos.y = TempVecX[ 0 ].y + TempVecY[ 0 ].y ;
		DrawVect3D[ 0 ].pos.z = TempVecX[ 0 ].z + TempVecY[ 0 ].z ;

		DrawVect3D[ 1 ].pos.x = TempVecX[ 1 ].x + TempVecY[ 0 ].x ;
		DrawVect3D[ 1 ].pos.y = TempVecX[ 1 ].y + TempVecY[ 0 ].y ;
		DrawVect3D[ 1 ].pos.z = TempVecX[ 1 ].z + TempVecY[ 0 ].z ;

		DrawVect3D[ 2 ].pos.x = TempVecX[ 0 ].x + TempVecY[ 1 ].x ;
		DrawVect3D[ 2 ].pos.y = TempVecX[ 0 ].y + TempVecY[ 1 ].y ;
		DrawVect3D[ 2 ].pos.z = TempVecX[ 0 ].z + TempVecY[ 1 ].z ;

		DrawVect3D[ 3 ].pos.x = TempVecX[ 1 ].x + TempVecY[ 1 ].x ;
		DrawVect3D[ 3 ].pos.y = TempVecX[ 1 ].y + TempVecY[ 1 ].y ;
		DrawVect3D[ 3 ].pos.z = TempVecX[ 1 ].z + TempVecY[ 1 ].z ;
	}

	DrawVect3D[4].pos = DrawVect3D[2].pos ;
	DrawVect3D[5].pos = DrawVect3D[1].pos ;

	*( ( DWORD * )&DrawVect3D[0].dif ) = 
	*( ( DWORD * )&DrawVect3D[1].dif ) = 
	*( ( DWORD * )&DrawVect3D[2].dif ) = 
	*( ( DWORD * )&DrawVect3D[3].dif ) =
	*( ( DWORD * )&DrawVect3D[4].dif ) =
	*( ( DWORD * )&DrawVect3D[5].dif ) = DiffuseColor ;

	if( ReverseXFlag )
	{
		DrawVect3D[5].u = DrawVect3D[3].u = DrawVect3D[1].u = TexVect[0].u ;
		DrawVect3D[4].u = DrawVect3D[2].u = DrawVect3D[0].u = TexVect[1].u ;
	}
	else
	{
		DrawVect3D[4].u = DrawVect3D[2].u = DrawVect3D[0].u = TexVect[0].u ;
		DrawVect3D[5].u = DrawVect3D[3].u = DrawVect3D[1].u = TexVect[1].u ;
	}
	if( ReverseYFlag )
	{
		DrawVect3D[4].v = DrawVect3D[3].v = DrawVect3D[2].v = TexVect[0].v ;
		DrawVect3D[5].v = DrawVect3D[1].v = DrawVect3D[0].v = TexVect[2].v ;
	}
	else
	{
		DrawVect3D[5].v = DrawVect3D[1].v = DrawVect3D[0].v = TexVect[0].v ;
		DrawVect3D[4].v = DrawVect3D[3].v = DrawVect3D[2].v = TexVect[2].v ;
	}

	DrawVect3D[0].spos.x = 0.0f ;
	DrawVect3D[0].spos.y = 0.0f ;
	DrawVect3D[0].spos.z = 0.0f ;
	DrawVect3D[0].norm.x = 0.0f ;
	DrawVect3D[0].norm.y = 0.0f ;
	DrawVect3D[0].norm.z = 0.0f ;
	DrawVect3D[0].tan.x = 0.0f ;
	DrawVect3D[0].tan.y = 0.0f ;
	DrawVect3D[0].tan.z = 0.0f ;
	DrawVect3D[0].binorm.x = 0.0f ;
	DrawVect3D[0].binorm.y = 0.0f ;
	DrawVect3D[0].binorm.z = 0.0f ;
	DrawVect3D[0].spc.r = 0 ;
	DrawVect3D[0].spc.g = 0 ;
	DrawVect3D[0].spc.b = 0 ;
	DrawVect3D[0].spc.a = 0 ;
	DrawVect3D[0].su = 0.0f ;
	DrawVect3D[0].sv = 0.0f ;
	DrawVect3D[1].spos		= DrawVect3D[0].spos ;
	DrawVect3D[1].norm		= DrawVect3D[0].norm ;
	DrawVect3D[1].tan		= DrawVect3D[0].tan ;
	DrawVect3D[1].binorm	= DrawVect3D[0].binorm ;
	DrawVect3D[1].spc		= DrawVect3D[0].spc ;
	DrawVect3D[1].su		= 0.0f ;
	DrawVect3D[1].sv		= 0.0f ;
	DrawVect3D[2].spos		= DrawVect3D[0].spos ;
	DrawVect3D[2].norm		= DrawVect3D[0].norm ;
	DrawVect3D[2].tan		= DrawVect3D[0].tan ;
	DrawVect3D[2].binorm	= DrawVect3D[0].binorm ;
	DrawVect3D[2].spc		= DrawVect3D[0].spc ;
	DrawVect3D[2].su		= 0.0f ;
	DrawVect3D[2].sv		= 0.0f ;
	DrawVect3D[3].spos		= DrawVect3D[0].spos ;
	DrawVect3D[3].norm		= DrawVect3D[0].norm ;
	DrawVect3D[3].tan		= DrawVect3D[0].tan ;
	DrawVect3D[3].binorm	= DrawVect3D[0].binorm ;
	DrawVect3D[3].spc		= DrawVect3D[0].spc ;
	DrawVect3D[3].su		= 0.0f ;
	DrawVect3D[3].sv		= 0.0f ;
	DrawVect3D[4].spos		= DrawVect3D[0].spos ;
	DrawVect3D[4].norm		= DrawVect3D[0].norm ;
	DrawVect3D[4].tan		= DrawVect3D[0].tan ;
	DrawVect3D[4].binorm	= DrawVect3D[0].binorm ;
	DrawVect3D[4].spc		= DrawVect3D[0].spc ;
	DrawVect3D[4].su		= 0.0f ;
	DrawVect3D[4].sv		= 0.0f ;
	DrawVect3D[5].spos		= DrawVect3D[0].spos ;
	DrawVect3D[5].norm		= DrawVect3D[0].norm ;
	DrawVect3D[5].tan		= DrawVect3D[0].tan ;
	DrawVect3D[5].binorm	= DrawVect3D[0].binorm ;
	DrawVect3D[5].spc		= DrawVect3D[0].spc ;
	DrawVect3D[5].su		= 0.0f ;
	DrawVect3D[5].sv		= 0.0f ;

	NS_DrawPrimitive3DToShader( DrawVect3D, 6, DX_PRIMTYPE_TRIANGLELIST ) ;

	// I
	return 0 ;
}

// VF[_[gĂQc|S`悷
extern	int			NS_DrawPolygon2DToShader( const VERTEX2DSHADER *Vertex, int PolygonNum )
{
	return NS_DrawPrimitive2DToShader( Vertex, PolygonNum * 3, DX_PRIMTYPE_TRIANGLELIST ) ;
}

// VF[_[gĂRc|S`悷
extern	int			NS_DrawPolygon3DToShader( const VERTEX3DSHADER *Vertex, int PolygonNum )
{
	return NS_DrawPrimitive3DToShader( Vertex, PolygonNum * 3, DX_PRIMTYPE_TRIANGLELIST ) ;
}

// VF[_[gĂQc|S`悷(CfbNX)
extern	int			NS_DrawPolygonIndexed2DToShader( const VERTEX2DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum )
{
	return NS_DrawPrimitiveIndexed2DToShader( Vertex, VertexNum, Indices, PolygonNum * 3, DX_PRIMTYPE_TRIANGLELIST ) ;
}

// VF[_[gĂRc|S`悷(CfbNX)
extern	int			NS_DrawPolygonIndexed3DToShader( const VERTEX3DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum )
{
	return NS_DrawPrimitiveIndexed3DToShader( Vertex, VertexNum, Indices, PolygonNum * 3, DX_PRIMTYPE_TRIANGLELIST ) ;
}

// VF[_[gĂQcv~eBu`悷
extern	int			NS_DrawPrimitive2DToShader( const VERTEX2DSHADER *Vertex, int VertexNum, int PrimitiveType )
{
	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	return Graphics_Hardware_DrawPrimitive2DToShader_PF( Vertex, VertexNum, PrimitiveType ) ;
}

// VF[_[gĂRcv~eBu`悷
extern	int			NS_DrawPrimitive3DToShader( const VERTEX3DSHADER *Vertex, int VertexNum, int PrimitiveType )
{
	return Graphics_Hardware_DrawPrimitive3DToShader_PF( Vertex, VertexNum, PrimitiveType ) ;
}

// VF[_[gĂQcv~eBu`悷(CfbNX)
extern	int			NS_DrawPrimitiveIndexed2DToShader( const VERTEX2DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType )
{
	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	return Graphics_Hardware_DrawPrimitiveIndexed2DToShader_PF( Vertex, VertexNum, Indices, IndexNum, PrimitiveType ) ;
}

// VF[_[gĂRcv~eBu`悷(CfbNX)
extern	int			NS_DrawPrimitiveIndexed3DToShader( const VERTEX3DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType )
{
	return Graphics_Hardware_DrawPrimitiveIndexed3DToShader_PF( Vertex, VertexNum, Indices, IndexNum, PrimitiveType ) ;
}

// VF[_[gĂRc|S`悷( _obt@gp )
extern	int			NS_DrawPolygon3DToShader_UseVertexBuffer( int VertexBufHandle )
{
	return NS_DrawPrimitive3DToShader_UseVertexBuffer( VertexBufHandle, DX_PRIMTYPE_TRIANGLELIST ) ;
}

// VF[_[gĂRc|S`悷( _obt@ƃCfbNXobt@gp )
extern	int			NS_DrawPolygonIndexed3DToShader_UseVertexBuffer( int VertexBufHandle, int IndexBufHandle )
{
	return NS_DrawPrimitiveIndexed3DToShader_UseVertexBuffer( VertexBufHandle, IndexBufHandle, DX_PRIMTYPE_TRIANGLELIST ) ;
}

// VF[_[gĂRcv~eBu`悷( _obt@gp )
extern	int			NS_DrawPrimitive3DToShader_UseVertexBuffer( int VertexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;

	// G[
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
	{
		return -1 ;
	}

	return NS_DrawPrimitive3DToShader_UseVertexBuffer2( VertexBufHandle, PrimitiveType, 0, VertexBuffer->Num ) ;
}

// VF[_[gĂRcv~eBu`悷( _obt@gp )
extern	int			NS_DrawPrimitive3DToShader_UseVertexBuffer2( int VertexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */, int StartVertex, int UseVertexNum )
{
	return Graphics_Hardware_DrawPrimitive3DToShader_UseVertexBuffer2_PF( VertexBufHandle, PrimitiveType, StartVertex, UseVertexNum ) ;
}

// VF[_[gĂRcv~eBu`悷( _obt@ƃCfbNXobt@gp )
extern	int			NS_DrawPrimitiveIndexed3DToShader_UseVertexBuffer( int VertexBufHandle, int IndexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;
	INDEXBUFFERHANDLEDATA  *IndexBuffer ;

	// G[
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
	{
		return -1 ;
	}
	if( INDEXBUFFERCHK( IndexBufHandle, IndexBuffer ) )
	{
		return -1 ;
	}

	return NS_DrawPrimitiveIndexed3DToShader_UseVertexBuffer2( VertexBufHandle, IndexBufHandle, PrimitiveType, 0, 0, VertexBuffer->Num, 0, IndexBuffer->Num ) ;
}

// VF[_[gĂRcv~eBu`悷( _obt@ƃCfbNXobt@gp )
extern	int			NS_DrawPrimitiveIndexed3DToShader_UseVertexBuffer2( int VertexBufHandle, int IndexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */, int BaseVertex, int StartVertex, int UseVertexNum, int StartIndex, int UseIndexNum )
{
	return Graphics_Hardware_DrawPrimitiveIndexed3DToShader_UseVertexBuffer2_PF( VertexBufHandle, IndexBufHandle, PrimitiveType, BaseVertex, StartVertex, UseVertexNum, StartIndex, UseIndexNum ) ;
}






















// VF[_[p萔obt@֌W֐

// SẴVF[_[p萔obt@nh폜
extern int NS_InitShaderConstantBuffer( void )
{
	if( GSYS.InitializeFlag == FALSE ) return 0 ;

	return AllHandleSub( DX_HANDLETYPE_SHADER_CONSTANT_BUFFER ) ;
}

// VF[_[p萔obt@nh
extern int NS_CreateShaderConstantBuffer(	int BufferSize )
{
	return Graphics_ShaderConstantBuffer_Create( BufferSize, GetASyncLoadFlag() ) ;
}

// VF[_[p萔obt@nȟn
extern int NS_DeleteShaderConstantBuffer( int SConstBufHandle )
{
	return SubHandle( SConstBufHandle ) ;
}

// VF[_[p萔obt@nh̒萔obt@̃AhX擾
extern void *NS_GetBufferShaderConstantBuffer(	int SConstBufHandle )
{
	SHADERCONSTANTBUFFERHANDLEDATA *ShaderConstantBuffer ;

	// G[
	if( SHADERCONSTANTBUFFERCHK( SConstBufHandle, ShaderConstantBuffer ) )
		return NULL ;

	// ˑ
	return Graphics_Hardware_ShaderConstantBuffer_GetBuffer_PF( ShaderConstantBuffer ) ;
}

// VF[_[p萔obt@nh̒萔obt@ւ̕ύXKp
extern int NS_UpdateShaderConstantBuffer( int SConstBufHandle )
{
	SHADERCONSTANTBUFFERHANDLEDATA *ShaderConstantBuffer ;

	// G[
	if( SHADERCONSTANTBUFFERCHK( SConstBufHandle, ShaderConstantBuffer ) )
		return -1 ;

	// ˑ
	return Graphics_Hardware_ShaderConstantBuffer_Update_PF( ShaderConstantBuffer ) ;
}

// VF[_[p萔obt@nh̒萔obt@w̃VF[_[̎w̃XbgɃZbg
extern int NS_SetShaderConstantBuffer( int SConstBufHandle, int TargetShader /* DX_SHADERTYPE_VERTEX Ȃ */ , int Slot )
{
	SHADERCONSTANTBUFFERHANDLEDATA *ShaderConstantBuffer ;

	// G[
	if( SHADERCONSTANTBUFFERCHK( SConstBufHandle, ShaderConstantBuffer ) )
		return -1 ;

	// ˑ
	return Graphics_Hardware_ShaderConstantBuffer_Set_PF( ShaderConstantBuffer, TargetShader, Slot ) ;
}
























#ifndef DX_NON_MOVIE

// [r[OtBbN֌W֐
// t@C̍Đ
extern int NS_PlayMovie( const TCHAR *FileName, int ExRate, int PlayType )
{
#ifdef UNICODE
	return PlayMovie_WCHAR_T(
		FileName, ExRate, PlayType
	) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, return -1 )

	Result = PlayMovie_WCHAR_T(
		UseFileNameBuffer, ExRate, PlayType
	) ;

	TCHAR_TO_WCHAR_T_STRING_END( FileName )

	return Result ;
#endif
}

// t@C̍Đ
extern int NS_PlayMovieWithStrLen( const TCHAR *FileName, size_t FileNameLength, int ExRate, int PlayType )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = PlayMovie_WCHAR_T( UseFileNameBuffer, ExRate, PlayType ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = PlayMovie_WCHAR_T( UseFileNameBuffer, ExRate, PlayType ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#endif
	return Result ;
}

// [r[OtBbN֌W֐
// t@C̍Đ
extern int PlayMovie_WCHAR_T( const wchar_t *FileName, int ExRate, int PlayType )
{
	int MovieHandle ;
	LOADGRAPH_GPARAM GParam ;
	int x1, y1, x2, y2, w, h ;
	int DrawScreen ;
	int DrawScreenSurface ;
	int DrawScreenMipLevel ;
#ifndef DX_NON_INPUT
	int KeyOffFlag ;
	int State ;
#endif // DX_NON_INPUT
	int ScreenW, ScreenH ;

	Graphics_Image_InitLoadGraphGParam( &GParam ) ;

	MovieHandle = Graphics_Image_LoadBmpToGraph_UseGParam( &GParam, FALSE, -1, FileName, FALSE, FALSE, DX_MOVIESURFACE_NORMAL, FALSE ) ;
	if( MovieHandle < 0 )
		return -1 ;

#ifndef DX_NON_INPUT
#ifndef DX_NON_INPUTSTRING
	NS_ClearInputCharBuf() ;
#endif // DX_NON_INPUTSTRING
	KeyOffFlag = NS_CheckHitKeyAll( DX_CHECKINPUT_ALL ) ;
#endif // DX_NON_INPUT
	if( MovieHandle != -1 )
	{
		NS_PlayMovieToGraph( MovieHandle, DX_PLAYTYPE_BACK, 0 ) ;

		NS_GetDrawScreenSize( &ScreenW, &ScreenH ) ;
		NS_GetGraphSize( MovieHandle, &w, &h ) ;
		x1 = ( ScreenW - w * ExRate ) >> 1 ;
		y1 = ( ScreenH - h * ExRate ) >> 1 ;

		x2 = x1 + w * ExRate ;
		y2 = y1 + h * ExRate ;

		DrawScreen = GSYS.DrawSetting.TargetScreen[ 0 ] ;
		DrawScreenSurface = GSYS.DrawSetting.TargetScreenSurface[ 0 ] ;
		DrawScreenMipLevel = GSYS.DrawSetting.TargetScreenMipLevel[ 0 ] ;

		NS_SetDrawScreen( DX_SCREEN_BACK ) ;
		NS_ClearDrawScreen( NULL ) ;

		while( NS_GetMovieStateToGraph( MovieHandle ) == 1 )
		{
//			NS_DrawBox( 0,0,32,32, GetColor( 255,255,255 ), TRUE ) ;
			NS_DrawExtendGraph( x1, y1, x2, y2, MovieHandle, FALSE ) ;

			NS_ScreenFlip() ;

#ifndef DX_NON_INPUT
			State = NS_CheckHitKeyAll( DX_CHECKINPUT_ALL ) ;
			if( State == FALSE ) 
			{
				KeyOffFlag = FALSE ;
			}
#endif // DX_NON_INPUT

			if( ProcessMessage() != 0 
#ifndef DX_NON_INPUT
				|| ( PlayType == DX_MOVIEPLAYTYPE_BCANCEL &&
#ifdef WINDOWS_DESKTOP_OS
					GetActiveFlag() && 
#endif // WINDOWS_DESKTOP_OS
					( State && KeyOffFlag == FALSE
#ifndef DX_NON_INPUTSTRING
						|| NS_GetInputChar( FALSE ) != 0
#endif // DX_NON_INPUTSTRING
						) )
#endif // DX_NON_INPUT
				) break ;
		}
		NS_DeleteGraph( MovieHandle, FALSE ) ;

		NS_SetRenderTargetToShader( 0, DrawScreen, DrawScreenSurface, DrawScreenMipLevel ) ;
	}

	// I
	return 0;
}

// t@C̉sNZƏcsNZ擾
extern int NS_GetMovieImageSize_File( const TCHAR *FileName, int *SizeX, int *SizeY )
{
#ifdef UNICODE
	return GetMovieImageSize_File_WCHAR_T(
		FileName, SizeX, SizeY
	) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, return -1 )

	Result = GetMovieImageSize_File_WCHAR_T(
		UseFileNameBuffer, SizeX, SizeY
	) ;

	TCHAR_TO_WCHAR_T_STRING_END( FileName )

	return Result ;
#endif
}

// t@C̉sNZƏcsNZ擾
extern int NS_GetMovieImageSize_File_WithStrLen( const TCHAR *FileName, size_t FileNameLength, int *SizeX, int *SizeY )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = GetMovieImageSize_File_WCHAR_T( UseFileNameBuffer, SizeX, SizeY ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = GetMovieImageSize_File_WCHAR_T( UseFileNameBuffer, SizeX, SizeY ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( FileName )
#endif
	return Result ;
}

// t@C̉sNZƏcsNZ擾
extern int GetMovieImageSize_File_WCHAR_T( const wchar_t *FileName, int *SizeX, int *SizeY )
{
	int MovieHandle ;
	OPENMOVIE_GPARAM OpenMovieGParam ;

	// C[WTCŶ݂擾wœt@CI[v
	Graphics_Image_InitOpenMovieGParam( &OpenMovieGParam ) ;
	MovieHandle = OpenMovie_UseGParam( -1, &OpenMovieGParam, FileName, NULL, 0, SizeX, SizeY, DX_MOVIESURFACE_NORMAL, TRUE, FALSE ) ;
	if( MovieHandle < 0 )
	{
		return -1 ;
	}

	// ꍇɃnh
	CloseMovie( MovieHandle ) ;

	// I
	return 0 ;
}

// ɓWJꂽt@C̉sNZƏcsNZ擾
extern int NS_GetMovieImageSize_Mem( const void *FileImage, int FileImageSize, int *SizeX, int *SizeY )
{
	int MovieHandle ;
	OPENMOVIE_GPARAM OpenMovieGParam ;

	// C[WTCŶ݂擾wœt@CI[v
	Graphics_Image_InitOpenMovieGParam( &OpenMovieGParam ) ;
	MovieHandle = OpenMovie_UseGParam( -1, &OpenMovieGParam, NULL, FileImage, FileImageSize, SizeX, SizeY, DX_MOVIESURFACE_NORMAL, TRUE, FALSE ) ;
	if( MovieHandle < 0 )
	{
		return -1 ;
	}

	// ꍇɃnh
	CloseMovie( MovieHandle ) ;

	// I
	return 0 ;
}

// [r[J
extern int NS_OpenMovieToGraph( const TCHAR *FileName, int FullColor )
{
	return NS_LoadBmpToGraph( FileName, FALSE, FALSE, FullColor ? DX_MOVIESURFACE_FULLCOLOR : DX_MOVIESURFACE_NORMAL );
}

// t@CJ
extern int NS_OpenMovieToGraphWithStrLen( const TCHAR *FileName, size_t FileNameLength, int FullColor )
{
	int Result ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_ONE_BEGIN( FileName, FileNameLength, return -1 )
	Result = NS_LoadBmpToGraph( UseFileNameBuffer, FALSE, FALSE, FullColor ? DX_MOVIESURFACE_FULLCOLOR : DX_MOVIESURFACE_NORMAL );
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( FileName )
	return Result ;
}

// [r[J
extern int OpenMovieToGraph_WCHAR_T( const wchar_t *FileName, int FullColor )
{
	return LoadBmpToGraph_WCHAR_T( FileName, FALSE, FALSE, FullColor ? DX_MOVIESURFACE_FULLCOLOR : DX_MOVIESURFACE_NORMAL );
}

// [r[OtBbNɊ܂܂郀[r[̍ĐJn
extern 	int		NS_PlayMovieToGraph( int GraphHandle, int PlayType, int SysPlay  )
{
	IMAGEDATA *Image ;

	if( GRAPHCHK( GraphHandle, Image ) )
		return -1 ;

	if( Image->Orig->MovieHandle < 0 ) return  0 ;

	return PlayMovie_( Image->Orig->MovieHandle, PlayType, SysPlay ) ;
}

// [r[OtBbNɊ܂܂郀[r[̍ĐXgbv
extern 	int		NS_PauseMovieToGraph( int GraphHandle, int SysPause  )
{
	IMAGEDATA *Image ;

	if( GRAPHCHK( GraphHandle, Image ) )
		return -1 ;

	if( Image->Orig->MovieHandle < 0 ) return  0 ;

	return PauseMovie( Image->Orig->MovieHandle, SysPause ) ;
}

// [r[̃t[i߂A߂Ƃ͏oȂ( [r[~ԂŁA Ogg Theora ̂ݗL )
extern	int		NS_AddMovieFrameToGraph( int GraphHandle, unsigned int FrameNum )
{
	IMAGEDATA *Image ;

	if( GRAPHCHK( GraphHandle, Image ) )
		return -1 ;

	if( Image->Orig->MovieHandle < 0 ) return 0 ;

	return AddMovieFrame( Image->Orig->MovieHandle, FrameNum ) ;
}

// [r[̍Đʒuݒ肷(~bP)
extern	int		NS_SeekMovieToGraph( int GraphHandle, int Time )
{
	IMAGEDATA *Image ;

	if( GRAPHCHK( GraphHandle, Image ) )
		return -1 ;

	if( Image->Orig->MovieHandle < 0 ) return 0 ;

	return SeekMovie( Image->Orig->MovieHandle, Time ) ;
}

// t@C̍Đxݒ肷( 1.0 = {  2.0 = Q{ )Aꕔ̃t@CtH[}bĝ݂ŗLȋ@\ł
extern	int		NS_SetPlaySpeedRateMovieToGraph( int GraphHandle, double SpeedRate )
{
	IMAGEDATA *Image ;

	if( GRAPHCHK( GraphHandle, Image ) )
		return -1 ;

	if( Image->Orig->MovieHandle < 0 ) return 0 ;

	return SetPlaySpeedRateMovie( Image->Orig->MovieHandle, SpeedRate ) ;
}

// [r[̍ĐԂ𓾂
extern 	int		NS_GetMovieStateToGraph( int GraphHandle )
{
	IMAGEDATA *Image ;

	if( GRAPHCHK( GraphHandle, Image ) )
		return -1 ;

	if( Image->Orig->MovieHandle < 0 ) return 0 ;

	return GetMovieState( Image->Orig->MovieHandle ) ;
}

// [r[̃{[Zbg(0`10000)
extern	int		NS_SetMovieVolumeToGraph( int Volume, int GraphHandle )	
{
	IMAGEDATA *Image ;

	if( GRAPHCHK( GraphHandle, Image ) )
		return -1 ;

	if( Image->Orig->MovieHandle < 0 ) return 0 ;

	return SetMovieVolume( Volume, Image->Orig->MovieHandle ) ;
}

// [r[̃{[Zbg(0`255)
extern	int		NS_ChangeMovieVolumeToGraph( int Volume, int GraphHandle )
{
	IMAGEDATA *Image ;
	int temp ;

	if( GRAPHCHK( GraphHandle, Image ) )
		return -1 ;

	if( Image->Orig->MovieHandle < 0 ) return 0 ;

	if( Volume < 0 )
	{
		Volume = 0 ;
	}
	else
	if( Volume > 255 )
	{
		Volume = 255 ;
	}

	if( Volume == 0 )
	{
		temp = 0 ;
	}
	else
	{
		if( SoundSysData.OldVolumeTypeFlag )
		{
			temp = _DTOL( _LOG10( Volume / 255.0f ) * 10.0 * 100.0 ) + 10000;
		}
		else
		{
			temp = _DTOL( _LOG10( Volume / 255.0f ) * 50.0 * 100.0 ) + 10000;
		}
	}

	return SetMovieVolume( temp, Image->Orig->MovieHandle ) ;
}

// [r[̊{C[Wf[^擾
extern	const BASEIMAGE *NS_GetMovieBaseImageToGraph( int GraphHandle, int *ImageUpdateFlag, int ImageUpdateFlagSetOnly )
{
	IMAGEDATA *Image ;

	if( GRAPHCHK( GraphHandle, Image ) )
		return NULL ;

	if( Image->Orig->MovieHandle < 0 ) return  NULL ;

	return GetMovieBaseImage( Image->Orig->MovieHandle, ImageUpdateFlag, ImageUpdateFlagSetOnly ) ;
}

// [r[̑t[𓾂( Ogg Theora ł̂ݗL )
extern	int		NS_GetMovieTotalFrameToGraph( int GraphHandle )
{
	IMAGEDATA *Image ;

	if( GRAPHCHK( GraphHandle, Image ) )
		return -1 ;

	if( Image->Orig->MovieHandle < 0 ) return 0 ;

	return GetMovieTotalFrame( Image->Orig->MovieHandle ) ;
}

// [r[̍Đʒu擾(~bP)
extern	int		NS_TellMovieToGraph( int GraphHandle )
{
	IMAGEDATA *Image ;

	if( GRAPHCHK( GraphHandle, Image ) )
		return -1 ;

	if( Image->Orig->MovieHandle < 0 ) return  0 ;

	return TellMovie( Image->Orig->MovieHandle ) ;
}

// [r[̍Đʒu擾(t[P)
extern	int		NS_TellMovieToGraphToFrame( int GraphHandle )
{
	IMAGEDATA *Image ;

	if( GRAPHCHK( GraphHandle, Image ) )
		return -1 ;

	if( Image->Orig->MovieHandle < 0 ) return  0 ;

	return TellMovieToFrame( Image->Orig->MovieHandle ) ;
}

// [r[̍Đʒuݒ肷(t[P)
extern	int		NS_SeekMovieToGraphToFrame( int GraphHandle, int Frame )
{
	IMAGEDATA *Image ;

	if( GRAPHCHK( GraphHandle, Image ) )
		return -1 ;

	if( Image->Orig->MovieHandle < 0 ) return  0 ;

	return SeekMovieToFrame( Image->Orig->MovieHandle, Frame ) ;
}

// [r[̂Pt[̎Ԃ𓾂
extern	LONGLONG NS_GetOneFrameTimeMovieToGraph( int GraphHandle )
{
	IMAGEDATA *Image ;

	if( GRAPHCHK( GraphHandle, Image ) )
		return -1 ;

	if( Image->Orig->MovieHandle < 0 ) return  0 ;

	return GetOneFrameTimeMovie( Image->Orig->MovieHandle ) ;
}

// [r[̃C[WŌɍXVԂ𓾂(~bP)
extern int NS_GetLastUpdateTimeMovieToGraph( int GraphHandle )
{
	IMAGEDATA *Image ;
	MOVIEGRAPH *Movie ;

	if( GRAPHCHK( GraphHandle, Image ) )
		return -1 ;

	if( Image->Orig->MovieHandle < 0 ) return  -1 ;

	Movie = GetMovieData( Image->Orig->MovieHandle ) ;
	if( Movie == NULL ) return -1 ;

	return ( int )( Movie->RefreshTime / 1000 ) ;
}

#endif // DX_NON_MOVIE



















// J֌W֐

// J NearNbvʂ FarNbvʂ̋ݒ肷
extern int NS_SetCameraNearFar( float Near, float Far )
{
	return NS_SetCameraNearFarD( Near, Far ) ;
}

// J NearNbvʂ FarNbvʂ̋ݒ肷
extern int NS_SetCameraNearFarD( double Near, double Far )
{
	// p[^̕ۑ
	GSYS.DrawSetting.ProjNear = Near ;
	GSYS.DrawSetting.ProjFar = Far ;

	// ˉes̍XV
	Graphics_DrawSetting_RefreshProjectionMatrix() ;

	// I
	return 0 ;
}

// J̐ݒA_A_AAbvxNg͂x
extern int NS_SetCameraPositionAndTarget_UpVecY( VECTOR Position, VECTOR Target )
{
	return NS_SetCameraPositionAndTarget_UpVecYD( VConvFtoD( Position ), VConvFtoD( Target ) ) ;
}

// J̐ݒA_A_AAbvxNg͂x
extern int NS_SetCameraPositionAndTarget_UpVecYD( VECTOR_D Position, VECTOR_D Target )
{
	VECTOR_D Up = { 0.0, 1.0, 0.0 }, Side, Dir ;
	MATRIX_D LookAt ;

	// ZbgAbv^CvZbg
	GSYS.Camera.SetupType = CAMERA_SETUPTYPE_POS_TARG ;

	// _ƒ_ۑ
	GSYS.Camera.Position = Position ;
	GSYS.Camera.Target   = Target ;

	// AbvxNgZo
	VectorSubD( &Dir, &GSYS.Camera.Target, &GSYS.Camera.Position ) ;
	VectorOuterProductD( &Side, &Dir, &Up ) ;
	VectorOuterProductD( &GSYS.Camera.Up, &Side, &Dir ) ;
	VectorNormalizeD( &GSYS.Camera.Up, &GSYS.Camera.Up ) ;

	// s̍쐬
	CreateLookAtMatrixD( &LookAt, &GSYS.Camera.Position, &GSYS.Camera.Target, &GSYS.Camera.Up ) ;

	// r[sɃZbg
	NS_SetTransformToViewD( &LookAt ) ;
	GSYS.Camera.Matrix = LookAt ;

	// ]pxZo
	Graphics_Camera_CalcCameraRollViewMatrix() ;

	// I
	return 0 ;
}

// J̐ݒA_A_AAbvxNgw
extern int NS_SetCameraPositionAndTargetAndUpVec( VECTOR Position, VECTOR Target, VECTOR Up )
{
	return NS_SetCameraPositionAndTargetAndUpVecD( VConvFtoD( Position ), VConvFtoD( Target ), VConvFtoD( Up ) ) ;
}

// J̐ݒA_A_AAbvxNgw
extern int NS_SetCameraPositionAndTargetAndUpVecD( VECTOR_D Position, VECTOR_D Target, VECTOR_D Up )
{
	VECTOR_D Side, Dir ;
	MATRIX_D LookAt ;

	// ZbgAbv^CvZbg
	GSYS.Camera.SetupType = CAMERA_SETUPTYPE_POS_TARG_UP ;

	// _ƒ_ۑ
	GSYS.Camera.Position = Position ;
	GSYS.Camera.Target   = Target ;

	// AbvxNgZo
	VectorSubD( &Dir, &Target, &Position ) ;
	VectorOuterProductD( &Side, &Dir, &Up ) ;
	VectorOuterProductD( &GSYS.Camera.Up, &Side, &Dir ) ;
	VectorNormalizeD( &GSYS.Camera.Up, &GSYS.Camera.Up ) ;

	// s̍쐬
	CreateLookAtMatrixD( &LookAt, &GSYS.Camera.Position, &GSYS.Camera.Target, &GSYS.Camera.Up ) ;

	// r[sɃZbg
	NS_SetTransformToViewD( &LookAt ) ;
	GSYS.Camera.Matrix = LookAt ;

	// ]pxZo
	Graphics_Camera_CalcCameraRollViewMatrix() ;

	// I
	return 0 ;
}

// J̐ݒA]pxA]pxAP]pxA_w
extern int NS_SetCameraPositionAndAngle( VECTOR Position, float VRotate, float HRotate, float TRotate )
{
	return NS_SetCameraPositionAndAngleD( VConvFtoD( Position ), VRotate, HRotate, TRotate ) ;
}

// J̐ݒA]pxA]pxAP]pxA_w
extern int NS_SetCameraPositionAndAngleD( VECTOR_D Position, double VRotate, double HRotate, double TRotate )
{
	VECTOR_D ZVec, YVec, XVec, TVec, Target ;
	MATRIX_D LookAt ;
	double Sin, Cos ;

	// ZbgAbv^CvZbg
	GSYS.Camera.SetupType = CAMERA_SETUPTYPE_POS_ANGLE ;

	// ]pxA]pxAP]pxA_ۑ
	GSYS.Camera.HRotate = HRotate ;
	GSYS.Camera.VRotate = VRotate ;
	GSYS.Camera.TRotate = TRotate ;
	GSYS.Camera.Position = Position ;

	// s̍쐬
	_SINCOSD( VRotate, &Sin, &Cos ) ;
	ZVec.x  =  0.0 ;
	ZVec.y  = -Sin ;
	ZVec.z  =  Cos ;

	YVec.z  =  Sin ;
	YVec.y  =  Cos ;
	YVec.x  =  0.0 ;

	_SINCOSD( HRotate, &Sin, &Cos ) ;
	ZVec.x  =  Sin * ZVec.z ;
	ZVec.z *=  Cos ;

	YVec.x  =  Sin * YVec.z ;
	YVec.z *=  Cos ;

	XVec.x  =  Cos ;
	XVec.y  =  0.0 ;
	XVec.z  = -Sin ;

	_SINCOSD( TRotate, &Sin, &Cos ) ;
	TVec.x = -Sin * XVec.x + Cos * YVec.x ;
	TVec.y = -Sin * XVec.y + Cos * YVec.y ;
	TVec.z = -Sin * XVec.z + Cos * YVec.z ;

	VectorAddD( &Target, &Position, &ZVec ) ;
	CreateLookAtMatrixD( &LookAt, &Position, &Target, &TVec ) ;

	// r[sɃZbg
	NS_SetTransformToViewD( &LookAt ) ;
	GSYS.Camera.Matrix = LookAt ;

	// _ƒ_ۑ
	GSYS.Camera.Position = Position ;
	GSYS.Camera.Target   = Target ;
	GSYS.Camera.Up       = TVec ;

//	Graphics_Camera_CalcCameraRollViewMatrix() ;

	// I
	return 0 ;
}

// r[s𒼐ڐݒ肷
extern int NS_SetCameraViewMatrix( MATRIX ViewMatrix )
{
	MATRIX_D ViewMatrixD ;

	ConvertMatrixFtoD( &ViewMatrixD, &ViewMatrix ) ;

	// r[sɃZbg
	NS_SetCameraViewMatrixD( ViewMatrixD ) ;

	// I
	return 0 ;
}

// r[s𒼐ڐݒ肷
extern int NS_SetCameraViewMatrixD( MATRIX_D ViewMatrix )
{
	// ZbgAbv^CvZbg
	GSYS.Camera.SetupType = CAMERA_SETUPTYPE_MATRIX ;

	// p[^ۑ
	GSYS.Camera.Matrix = ViewMatrix ;

	// r[sɃZbg
	NS_SetTransformToViewD( &ViewMatrix ) ;

	// I
	return 0 ;
}

// ʏɂJĂf̒S̍Wݒ肷
extern int NS_SetCameraScreenCenter( float x, float y )
{
	return NS_SetCameraScreenCenterD( x, y ) ;
}

// ʏɂJĂf̒S̍Wݒ肷
extern int NS_SetCameraScreenCenterD( double x, double y )
{
	MATRIX_D ViewportMatrix ;

	// lۑ
	GSYS.Camera.ScreenCenterX = x ;
	GSYS.Camera.ScreenCenterY = y ;

	// r[|[gs̍쐬
	CreateViewportMatrixD(
		&ViewportMatrix,
		x,
		y, 
		GSYS.DrawSetting.DrawSizeX * GSYS.DrawSetting.Draw3DScale,
		GSYS.DrawSetting.DrawSizeY * GSYS.DrawSetting.Draw3DScale ) ;

	// r[|[sƂăZbg
	NS_SetTransformToViewportD( &ViewportMatrix ) ;

	// I
	return 0 ;
}






// ߖ@JZbgAbv
extern int NS_SetupCamera_Perspective( float Fov )
{
	return NS_SetupCamera_PerspectiveD( Fov ) ;
}

// ߖ@JZbgAbv
extern int NS_SetupCamera_PerspectiveD( double Fov )
{
	// p[^̕ۑ
	GSYS.DrawSetting.ProjectionMatrixMode = 0 ;
	GSYS.DrawSetting.ProjFov = Fov ;

	// ˉes̍XV
	Graphics_DrawSetting_RefreshProjectionMatrix() ;

	// I
	return 0 ;
}

// ˉeJZbgAbv
extern int NS_SetupCamera_Ortho( float Size )
{
	return NS_SetupCamera_OrthoD( Size ) ;
}

// ˉeJZbgAbv
extern int NS_SetupCamera_OrthoD( double Size )
{
	// p[^̕ۑ
	GSYS.DrawSetting.ProjectionMatrixMode = 1 ;
	GSYS.DrawSetting.ProjSize = Size ;

	// ˉes̍XV
	Graphics_DrawSetting_RefreshProjectionMatrix() ;

	// I
	return 0 ;
}

// ˉesݒ肷
extern int NS_SetupCamera_ProjectionMatrix( MATRIX ProjectionMatrix )
{
	MATRIX_D ProjectionMatrixD ;

	ConvertMatrixFtoD( &ProjectionMatrixD, &ProjectionMatrix ) ;

	return NS_SetupCamera_ProjectionMatrixD( ProjectionMatrixD ) ;
}

// ˉesݒ肷
extern int NS_SetupCamera_ProjectionMatrixD( MATRIX_D ProjectionMatrix )
{
	// p[^̕ۑ
	GSYS.DrawSetting.ProjectionMatrixMode = 2 ;
	GSYS.DrawSetting.ProjMatrix = ProjectionMatrix ;

	// ˉes̍XV
	Graphics_DrawSetting_RefreshProjectionMatrix() ;

	// I
	return 0 ;
}

// J̃hbgAXyNgݒ肷
extern int NS_SetCameraDotAspect( float DotAspect )
{
	return NS_SetCameraDotAspectD( DotAspect ) ;
}

// J̃hbgAXyNgݒ肷
extern int NS_SetCameraDotAspectD( double DotAspect )
{
	// p[^̕ۑ
	GSYS.DrawSetting.ProjDotAspect = DotAspect ;

	// ˉes̍XV
	Graphics_DrawSetting_RefreshProjectionMatrix() ;

	// I
	return 0 ;
}





// w̍WJ̎EɓĂ邩ǂ𔻒肷( ߂l TRUE:EɓĂȂ  FALSE:EɓĂ )
extern int NS_CheckCameraViewClip( VECTOR CheckPos )
{
	if( GSYS.DrawSetting.ClippingPlane[ 0 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 0 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 0 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 0 ].w < 0.0f ||
		GSYS.DrawSetting.ClippingPlane[ 1 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 1 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 1 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 1 ].w < 0.0f ||
		GSYS.DrawSetting.ClippingPlane[ 2 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 2 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 2 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 2 ].w < 0.0f ||
		GSYS.DrawSetting.ClippingPlane[ 3 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 3 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 3 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 3 ].w < 0.0f ||
		GSYS.DrawSetting.ClippingPlane[ 4 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 4 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 4 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 4 ].w < 0.0f ||
		GSYS.DrawSetting.ClippingPlane[ 5 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 5 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 5 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 5 ].w < 0.0f )
		return TRUE ;

	return FALSE ;
}

// w̍WJ̎EɓĂ邩ǂ𔻒肷( ߂l TRUE:EɓĂȂ  FALSE:EɓĂ )
extern int NS_CheckCameraViewClipD( VECTOR_D CheckPos )
{
	if( GSYS.DrawSetting.ClippingPlane[ 0 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 0 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 0 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 0 ].w < 0.0 ||
		GSYS.DrawSetting.ClippingPlane[ 1 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 1 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 1 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 1 ].w < 0.0 ||
		GSYS.DrawSetting.ClippingPlane[ 2 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 2 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 2 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 2 ].w < 0.0 ||
		GSYS.DrawSetting.ClippingPlane[ 3 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 3 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 3 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 3 ].w < 0.0 ||
		GSYS.DrawSetting.ClippingPlane[ 4 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 4 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 4 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 4 ].w < 0.0 ||
		GSYS.DrawSetting.ClippingPlane[ 5 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 5 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 5 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 5 ].w < 0.0 )
		return TRUE ;

	return FALSE ;
}

// w̍WJ̎EɓĂ邩ǂ𔻒肷A߂lŊOĂm邱Ƃł( ߂l 0:EɓĂ  0ȊO:EɓĂȂ( DX_CAMERACLIP_LEFT  DX_CAMERACLIP_RIGHT  or Zōꂽ́Aand ZŕmFł ) )
extern int NS_CheckCameraViewClip_Dir( VECTOR CheckPos )
{
	int clip ;

	clip = 0 ;
	if( GSYS.DrawSetting.ClippingPlane[ 0 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 0 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 0 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 0 ].w < 0.0f ) clip |= DX_CAMERACLIP_LEFT ;
	if( GSYS.DrawSetting.ClippingPlane[ 1 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 1 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 1 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 1 ].w < 0.0f ) clip |= DX_CAMERACLIP_RIGHT ;
	if( GSYS.DrawSetting.ClippingPlane[ 2 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 2 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 2 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 2 ].w < 0.0f ) clip |= DX_CAMERACLIP_BOTTOM ;
	if( GSYS.DrawSetting.ClippingPlane[ 3 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 3 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 3 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 3 ].w < 0.0f ) clip |= DX_CAMERACLIP_TOP ;
	if( GSYS.DrawSetting.ClippingPlane[ 4 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 4 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 4 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 4 ].w < 0.0f ) clip |= DX_CAMERACLIP_BACK ;
	if( GSYS.DrawSetting.ClippingPlane[ 5 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 5 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 5 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 5 ].w < 0.0f ) clip |= DX_CAMERACLIP_FRONT ;

	return clip ;
}

// w̍WJ̎EɓĂ邩ǂ𔻒肷A߂lŊOĂm邱Ƃł( ߂l 0:EɓĂ  0ȊO:EɓĂȂ( DX_CAMERACLIP_LEFT  DX_CAMERACLIP_RIGHT  or Zōꂽ́Aand ZŕmFł ) )
extern int NS_CheckCameraViewClip_DirD( VECTOR_D CheckPos )
{
	int clip ;

	clip = 0 ;
	if( GSYS.DrawSetting.ClippingPlane[ 0 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 0 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 0 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 0 ].w < 0.0 ) clip |= DX_CAMERACLIP_LEFT ;
	if( GSYS.DrawSetting.ClippingPlane[ 1 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 1 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 1 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 1 ].w < 0.0 ) clip |= DX_CAMERACLIP_RIGHT ;
	if( GSYS.DrawSetting.ClippingPlane[ 2 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 2 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 2 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 2 ].w < 0.0 ) clip |= DX_CAMERACLIP_BOTTOM ;
	if( GSYS.DrawSetting.ClippingPlane[ 3 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 3 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 3 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 3 ].w < 0.0 ) clip |= DX_CAMERACLIP_TOP ;
	if( GSYS.DrawSetting.ClippingPlane[ 4 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 4 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 4 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 4 ].w < 0.0 ) clip |= DX_CAMERACLIP_BACK ;
	if( GSYS.DrawSetting.ClippingPlane[ 5 ].x * CheckPos.x + GSYS.DrawSetting.ClippingPlane[ 5 ].y * CheckPos.y + GSYS.DrawSetting.ClippingPlane[ 5 ].z * CheckPos.z + GSYS.DrawSetting.ClippingPlane[ 5 ].w < 0.0 ) clip |= DX_CAMERACLIP_FRONT ;

	return clip ;
}


// ̍Wŕ\{bNXJ̎EɓĂ邩ǂ𔻒肷( ߂l TRUE:EɓĂȂ  FALSE:EɓĂ )
extern int NS_CheckCameraViewClip_Box( VECTOR BoxPos1, VECTOR BoxPos2 )
{
	VECTOR CheckBoxPos[ 8 ] ;
	VECTOR Tmp ;

	Tmp   = BoxPos2   ; CheckBoxPos[ 0 ] = Tmp ;
	Tmp.x = BoxPos1.x ; CheckBoxPos[ 1 ] = Tmp ;
	Tmp.y = BoxPos1.y ; CheckBoxPos[ 2 ] = Tmp ;
	Tmp.x = BoxPos2.x ; CheckBoxPos[ 3 ] = Tmp ;
	Tmp.z = BoxPos1.z ; CheckBoxPos[ 4 ] = Tmp ;
	Tmp.y = BoxPos2.y ; CheckBoxPos[ 5 ] = Tmp ;
	Tmp.x = BoxPos1.x ; CheckBoxPos[ 6 ] = Tmp ;
	Tmp.y = BoxPos1.y ; CheckBoxPos[ 7 ] = Tmp ;

	return Graphics_Camera_CheckCameraViewClip_Box_PosDim( CheckBoxPos ) ;
}

// ̍Wŕ\{bNXJ̎EɓĂ邩ǂ𔻒肷( ߂l TRUE:EɓĂȂ  FALSE:EɓĂ )
extern int NS_CheckCameraViewClip_BoxD( VECTOR_D BoxPos1, VECTOR_D BoxPos2 )
{
	VECTOR_D CheckBoxPos[ 8 ] ;
	VECTOR_D Tmp ;

	Tmp   = BoxPos2   ; CheckBoxPos[ 0 ] = Tmp ;
	Tmp.x = BoxPos1.x ; CheckBoxPos[ 1 ] = Tmp ;
	Tmp.y = BoxPos1.y ; CheckBoxPos[ 2 ] = Tmp ;
	Tmp.x = BoxPos2.x ; CheckBoxPos[ 3 ] = Tmp ;
	Tmp.z = BoxPos1.z ; CheckBoxPos[ 4 ] = Tmp ;
	Tmp.y = BoxPos2.y ; CheckBoxPos[ 5 ] = Tmp ;
	Tmp.x = BoxPos1.x ; CheckBoxPos[ 6 ] = Tmp ;
	Tmp.y = BoxPos1.y ; CheckBoxPos[ 7 ] = Tmp ;

	return Graphics_Camera_CheckCameraViewClip_Box_PosDimD( CheckBoxPos ) ;
}

// J Near Nbvʂ̋擾
extern float NS_GetCameraNear( void )
{
	return ( float )GSYS.DrawSetting.ProjNear ;
}

// J Near Nbvʂ̋擾
extern double NS_GetCameraNearD( void )
{
	return GSYS.DrawSetting.ProjNear ;
}

// J Far Nbvʂ̋擾
extern float NS_GetCameraFar( void )
{
	return ( float )GSYS.DrawSetting.ProjFar ;
}

// J Far Nbvʂ̋擾
extern double NS_GetCameraFarD( void )
{
	return GSYS.DrawSetting.ProjFar ;
}

// J̈ʒu擾
extern	VECTOR	NS_GetCameraPosition( void )
{
	return VConvDtoF( GSYS.Camera.Position ) ;
}

// J̈ʒu擾
extern	VECTOR_D NS_GetCameraPositionD( void )
{
	return GSYS.Camera.Position ;
}

// J̒_擾
extern	VECTOR	NS_GetCameraTarget( void )
{
	return VConvDtoF( GSYS.Camera.Target ) ;
}

// J̒_擾
extern	VECTOR_D NS_GetCameraTargetD( void )
{
	return GSYS.Camera.Target ;
}

// J̎ɐȏ̃xNg𓾂
extern	VECTOR	NS_GetCameraUpVector( void )
{
	return VConvDtoF( GSYS.Camera.Up ) ;
}

// J̎ɐȏ̃xNg𓾂
extern	VECTOR_D NS_GetCameraUpVectorD( void )
{
	return GSYS.Camera.Up ;
}

// J̎ɐȉ̃xNg𓾂
extern	VECTOR	NS_GetCameraDownVector( void )
{
	return VConvDtoF( VScaleD( GSYS.Camera.Up, -1.0 ) ) ;
}

// J̎ɐȉ̃xNg𓾂
extern	VECTOR_D NS_GetCameraDownVectorD( void )
{
	return VScaleD( GSYS.Camera.Up, -1.0f ) ;
}

// J̎ɐȉẼxNg𓾂
extern	VECTOR	NS_GetCameraRightVector( void )
{
	return VConvDtoF( VNormD( VCrossD( GSYS.Camera.Up, VSubD( GSYS.Camera.Target, GSYS.Camera.Position ) ) ) ) ;
}

// J̎ɐȉẼxNg𓾂
extern	VECTOR_D NS_GetCameraRightVectorD( void )
{
	return VNormD( VCrossD( GSYS.Camera.Up, VSubD( GSYS.Camera.Target, GSYS.Camera.Position ) ) ) ;
}

// J̎ɐȍ̃xNg𓾂
extern	VECTOR	NS_GetCameraLeftVector( void )
{
	return VConvDtoF( VNormD( VCrossD( GSYS.Camera.Up, VSubD( GSYS.Camera.Position, GSYS.Camera.Target ) ) ) ) ;
}

// J̎ɐȍ̃xNg𓾂
extern	VECTOR_D NS_GetCameraLeftVectorD( void )
{
	return VNormD( VCrossD( GSYS.Camera.Up, VSubD( GSYS.Camera.Position, GSYS.Camera.Target ) ) ) ;
}

// J̌ẴxNg擾
extern VECTOR NS_GetCameraFrontVector( void )
{
	return VConvDtoF( VNormD( VSubD( GSYS.Camera.Target, GSYS.Camera.Position ) ) ) ;
}

// J̌ẴxNg擾
extern VECTOR_D NS_GetCameraFrontVectorD( void )
{
	return VNormD( VSubD( GSYS.Camera.Target, GSYS.Camera.Position ) ) ;
}

// J̌̃xNg擾
extern VECTOR NS_GetCameraBackVector( void )
{
	return VConvDtoF( VNormD( VSubD( GSYS.Camera.Position, GSYS.Camera.Target ) ) ) ;
}

// J̌̃xNg擾
extern VECTOR_D NS_GetCameraBackVectorD( void )
{
	return VNormD( VSubD( GSYS.Camera.Position, GSYS.Camera.Target ) ) ;
}

// J̐̌擾
extern	float	NS_GetCameraAngleHRotate( void )
{
	return ( float )GSYS.Camera.HRotate ;
}

// J̐̌擾
extern	double NS_GetCameraAngleHRotateD( void )
{
	return GSYS.Camera.HRotate ;
}

// J̐̌擾
extern	float	NS_GetCameraAngleVRotate( void )
{
	return ( float )GSYS.Camera.VRotate ;
}

// J̐̌擾
extern	double NS_GetCameraAngleVRotateD( void )
{
	return GSYS.Camera.VRotate ;
}

// J̌̔Ppx擾
extern	float	NS_GetCameraAngleTRotate( void )
{
	return ( float )GSYS.Camera.TRotate ;
}

// J̌̔Ppx擾
extern	double NS_GetCameraAngleTRotateD( void )
{
	return GSYS.Camera.TRotate ;
}




// r[s擾
extern MATRIX NS_GetCameraViewMatrix( void )
{
	MATRIX Result ;

	ConvertMatrixDtoF( &Result, &GSYS.DrawSetting.ViewMatrix ) ;
	return Result ;
}

// r[s擾
extern MATRIX_D NS_GetCameraViewMatrixD( void )
{
	return GSYS.DrawSetting.ViewMatrix ;
}

// r{[hs擾
extern MATRIX NS_GetCameraBillboardMatrix( void )
{
	return GSYS.DrawSetting.BillboardMatrixF ;
}

// r{[hs擾
extern MATRIX_D NS_GetCameraBillboardMatrixD( void )
{
	return GSYS.DrawSetting.BillboardMatrix ;
}

// ʏɂJĂf̒S̍W擾
extern int NS_GetCameraScreenCenter( float  *x, float  *y )
{
	if( x != NULL )
	{
		*x = ( float )GSYS.Camera.ScreenCenterX ;
	}

	if( y != NULL )
	{
		*y = ( float )GSYS.Camera.ScreenCenterY ;
	}

	return 0 ;
}

// ʏɂJĂf̒S̍W擾
extern int NS_GetCameraScreenCenterD( double *x, double *y )
{
	if( x != NULL )
	{
		*x = GSYS.Camera.ScreenCenterX ;
	}

	if( y != NULL )
	{
		*y = GSYS.Camera.ScreenCenterY ;
	}

	return 0 ;
}

// J̎p擾
extern float NS_GetCameraFov( void )
{
	return ( float )GSYS.DrawSetting.ProjFov ;
}

// J̎p擾
extern double NS_GetCameraFovD( void )
{
	return GSYS.DrawSetting.ProjFov ;
}

// J̎TCY擾
extern float NS_GetCameraSize( void )
{
	return ( float )GSYS.DrawSetting.ProjSize ;
}

// J̎TCY擾
extern double NS_GetCameraSizeD( void )
{
	return GSYS.DrawSetting.ProjSize ;
}

// ˉes擾
extern MATRIX NS_GetCameraProjectionMatrix( void )
{
	return GSYS.DrawSetting.ProjectionMatrixF ;
}

// ˉes擾
extern MATRIX_D NS_GetCameraProjectionMatrixD( void )
{
	return GSYS.DrawSetting.ProjectionMatrix ;
}

// J̃hbgAXyNg𓾂
extern float NS_GetCameraDotAspect( void )
{
	return ( float )GSYS.DrawSetting.ProjDotAspect ;
}

// J̃hbgAXyNg𓾂
extern double NS_GetCameraDotAspectD( void )
{
	return GSYS.DrawSetting.ProjDotAspect ;
}

// r[|[gs擾
extern MATRIX NS_GetCameraViewportMatrix( void )
{
	return GSYS.DrawSetting.ViewportMatrixF ;
}

// r[|[gs擾
extern MATRIX_D NS_GetCameraViewportMatrixD( void )
{
	return GSYS.DrawSetting.ViewportMatrix ;
}

// Direct3DŎKpr[|[gs擾
extern MATRIX NS_GetCameraAPIViewportMatrix( void )
{
	return GSYS.DrawSetting.Direct3DViewportMatrixF ;
}

// Direct3DŎKpr[|[gs擾
extern MATRIX_D NS_GetCameraAPIViewportMatrixD( void )
{
	return GSYS.DrawSetting.Direct3DViewportMatrix ;
}



























// Cg֌W֐

// CeBOvZ@\gp邩ǂݒ肷
extern int NS_SetUseLighting( int Flag )
{
//	if( GSYS.Light.ProcessDisable == !Flag )
//		return 0 ;
	GSYS.Light.ProcessDisable = Flag ? FALSE : TRUE ;

	// Zbg
	Graphics_Hardware_Light_SetUse_PF( Flag ) ;

	// Cg̐ݒ肪ύXꂽtO𗧂Ă
	GSYS.Light.HardwareChange = TRUE ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// CeBOvZɒ_J[̃fBt[YJ[gp邩ǂݒ肷
extern int NS_SetMaterialUseVertDifColor( int UseFlag )
{
	GSYS.Light.MaterialNotUseVertexDiffuseColor = UseFlag ? FALSE : TRUE ;
	
	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// CeBOvZɒ_J[̃XyLJ[gp邩ǂݒ肷
extern int NS_SetMaterialUseVertSpcColor( int UseFlag )
{
	GSYS.Light.MaterialNotUseVertexSpecularColor = UseFlag ? FALSE : TRUE ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// CeBOvZɎgp}eAp[^ݒ肷
extern int NS_SetMaterialParam( MATERIALPARAM Material )
{
	GSYS.Light.ChangeMaterial = 1 ;
	GSYS.Light.Material = Material ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// Rc}``ɃXyLgp邩ǂݒ肷
extern int NS_SetUseSpecular( int UseFlag )
{
	GSYS.DrawSetting.NotUseSpecular = UseFlag ? FALSE : TRUE ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// O[oArGgCgJ[ݒ肷
extern int NS_SetGlobalAmbientLight( COLOR_F Color )
{
	     if( Color.r < 0.0f ) Color.r = 0.0f ;
	else if( Color.r > 1.0f ) Color.r = 1.0f ;
	     if( Color.g < 0.0f ) Color.g = 0.0f ;
	else if( Color.g > 1.0f ) Color.g = 1.0f ;
	     if( Color.b < 0.0f ) Color.b = 0.0f ;
	else if( Color.b > 1.0f ) Color.b = 1.0f ;

	// n[hEGAɐݒ肷
	Graphics_Hardware_Light_GlobalAmbient_PF( &Color ) ;

	// I
	return 0 ;
}

// Rc`̃CeBOvZŊpxsǂݒ肷( TRUE:pxs( ftHg )  FALSE:pxsȂ )
extern int NS_SetUseLightAngleAttenuation( int UseFlag )
{
	// lꍇ͉I
	if( ( GSYS.Light.NoLightAngleAttenuation == FALSE && UseFlag == TRUE  ) ||
		( GSYS.Light.NoLightAngleAttenuation == TRUE  && UseFlag == FALSE ) )
	{
		return 0 ;
	}

	// lۑ
	GSYS.Light.NoLightAngleAttenuation = UseFlag ? FALSE : TRUE ;

	// n[hEFAɐݒ肷
	Graphics_Hardware_Light_SetNoAngleAttenuation_PF( GSYS.Light.NoLightAngleAttenuation ) ;

	// I
	return 0 ;
}

// Cg̃^CvfBNViCgɂ
extern int NS_ChangeLightTypeDir( VECTOR Direction )
{
	LIGHT_HANDLE *pLH ;
	float Length ;

	LIGHTCHK( GSYS.Light.DefaultHandle, pLH, -1 ) ;

	// ^CvύX
	pLH->Param.LightType = DX_LIGHTTYPE_D3DLIGHT_DIRECTIONAL ;

	// Zbg
	Length = _SQRT( VectorInnerProduct( &Direction, &Direction ) ) ;
	Direction.x /= Length ;
	Direction.y /= Length ;
	Direction.z /= Length ;
	pLH->Param.Direction = Direction ;

	// ύXtO𗧂Ă
	pLH->HardwareChangeFlag = TRUE ;
	GSYS.Light.HardwareChange = TRUE ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// Cg̃^CvX|bgCgɂ
extern int NS_ChangeLightTypeSpot( VECTOR Position, VECTOR Direction, float OutAngle, float InAngle/*, float Falloff*/, float Range, float Atten0, float Atten1, float Atten2 )
{
	float Falloff = 1.0f ;

	LIGHT_HANDLE *pLH ;
	LIGHTCHK( GSYS.Light.DefaultHandle, pLH, -1 ) ;

	// ^CvZbg
	pLH->Param.LightType = DX_LIGHTTYPE_D3DLIGHT_SPOT ;

	// p[^Zbg
	pLH->Param.Position = Position ;
	pLH->Param.Direction = Direction ;
	pLH->Param.Phi = OutAngle ;
	pLH->Param.Theta = InAngle ;
	pLH->Param.Falloff = Falloff ;
	pLH->Param.Range = Range ;
	pLH->Param.Attenuation0 = Atten0 ;
	pLH->Param.Attenuation1 = Atten1 ;
	pLH->Param.Attenuation2 = Atten2 ;

	// ύXtO𗧂Ă
	pLH->HardwareChangeFlag = TRUE ;
	GSYS.Light.HardwareChange = TRUE ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// Cg̃^Cv|CgCgɂ
extern int NS_ChangeLightTypePoint( VECTOR Position, float Range, float Atten0, float Atten1, float Atten2 )
{
	LIGHT_HANDLE *pLH ;
	LIGHTCHK( GSYS.Light.DefaultHandle, pLH, -1 ) ;

	// ^CvZbg
	pLH->Param.LightType = DX_LIGHTTYPE_D3DLIGHT_POINT ;

	// p[^Zbg
	pLH->Param.Range = Range ;
	pLH->Param.Position = Position ;
	pLH->Param.Attenuation0 = Atten0 ;
	pLH->Param.Attenuation1 = Atten1 ;
	pLH->Param.Attenuation2 = Atten2 ;

	// ύXtO𗧂Ă
	pLH->HardwareChangeFlag = TRUE ;
	GSYS.Light.HardwareChange = TRUE ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// Cgnh̃Cg̃^Cv擾( ߂l DX_LIGHTTYPE_DIRECTIONAL  )
extern	int NS_GetLightType( void )
{
	return NS_GetLightTypeHandle( GSYS.Light.DefaultHandle ) ;
}

// Cg̗LAZbg
extern int NS_SetLightEnable( int EnableFlag )
{
	return NS_SetLightEnableHandle( GSYS.Light.DefaultHandle, EnableFlag ) ;
}

// Cgnh̃Cgʂ̗LAݒ肷( TRUE:L  FALSE: )
extern	int NS_GetLightEnable( void )
{
	return NS_GetLightEnableHandle( GSYS.Light.DefaultHandle ) ;
}

// Cg̃fBt[YJ[ݒ肷
extern int NS_SetLightDifColor( COLOR_F Color )
{
	return NS_SetLightDifColorHandle( GSYS.Light.DefaultHandle, Color ) ;
}

// Cgnh̃Cg̃fBt[YJ[ݒ肷
extern COLOR_F NS_GetLightDifColor( void )
{
	return NS_GetLightDifColorHandle( GSYS.Light.DefaultHandle ) ;
}

// Cg̃XyLJ[ݒ肷
extern int NS_SetLightSpcColor( COLOR_F Color )
{
	return NS_SetLightSpcColorHandle( GSYS.Light.DefaultHandle, Color ) ;
}

// Cgnh̃Cg̃XyLJ[ݒ肷
extern COLOR_F NS_GetLightSpcColor(  void )
{
	return NS_GetLightSpcColorHandle( GSYS.Light.DefaultHandle ) ;
}

// Cg̃ArGgJ[ݒ肷
extern int NS_SetLightAmbColor( COLOR_F Color )
{
	return NS_SetLightAmbColorHandle( GSYS.Light.DefaultHandle, Color ) ;
}

// Cgnh̃Cg̃ArGgJ[ݒ肷
extern COLOR_F NS_GetLightAmbColor(  void )
{
	return NS_GetLightAmbColorHandle( GSYS.Light.DefaultHandle ) ;
}

// Cg̕ݒ肷
extern int NS_SetLightDirection( VECTOR Direction )
{
	return NS_SetLightDirectionHandle( GSYS.Light.DefaultHandle, Direction ) ;
}

// Cgnh̃Cg̕ݒ肷
extern	VECTOR NS_GetLightDirection( void )
{
	return NS_GetLightDirectionHandle( GSYS.Light.DefaultHandle ) ;
}

// Cg̈ʒuݒ肷
extern int NS_SetLightPosition( VECTOR Position )
{
	return NS_SetLightPositionHandle( GSYS.Light.DefaultHandle, Position ) ;
}

// Cgnh̃Cg̈ʒuݒ肷
extern	VECTOR NS_GetLightPosition( void )
{
	return NS_GetLightPositionHandle( GSYS.Light.DefaultHandle ) ;
}

// Cg̋p[^ݒ肷( LAWOAPAQ )
extern int NS_SetLightRangeAtten( float Range, float Atten0, float Atten1, float Atten2 )
{
	return NS_SetLightRangeAttenHandle( GSYS.Light.DefaultHandle, Range,  Atten0,  Atten1,  Atten2 ) ;
}

// Cg̋p[^擾( LAWOAPAQ )
extern int NS_GetLightRangeAtten( float *Range, float *Atten0, float *Atten1, float *Atten2 )
{
	return NS_GetLightRangeAttenHandle( GSYS.Light.DefaultHandle, Range, Atten0, Atten1, Atten2 ) ;
}

// Cg̃X|bgCg̃p[^ݒ肷( OR[pxAR[pxAtH[It( 1.0f 𐄏 ) )
extern int NS_SetLightAngle( float OutAngle, float InAngle /*, float Falloff */ )
{
	return NS_SetLightAngleHandle( GSYS.Light.DefaultHandle,  OutAngle,  InAngle /*,  Falloff */ ) ;
}

// Cg̃X|bgCg̃p[^擾( OR[pxAR[pxAtH[It )
extern int NS_GetLightAngle( float *OutAngle, float *InAngle /*, float *Falloff */ )
{
	return NS_GetLightAngleHandle( GSYS.Light.DefaultHandle, OutAngle, InAngle /*, Falloff */ ) ;
}

// ftHgCg SetUseShadowMap Ŏw肵VhE}bvKp邩ǂݒ肷( SmSlotIndex:VhE}bvXbg( SetUseShadowMap ̑ɐݒ肷l ) UseFlag:Kpɂ邩ǂ̃tO( TRUE:Kp( ftHg )  FALSE:KpȂ ) )
extern int NS_SetLightUseShadowMap( int SmSlotIndex, int UseFlag )
{
	return NS_SetLightUseShadowMapHandle( GSYS.Light.DefaultHandle, SmSlotIndex, UseFlag ) ;
}

// fBNViCgnh쐬
extern int NS_CreateDirLightHandle( VECTOR Direction )
{
	int LHandle ;
	LIGHT_HANDLE *pLH ;
	float Length ;

	// Vnh̒ǉ
	LHandle = Graphics_Light_AddHandle() ;
	LIGHTCHK( LHandle, pLH, -1 ) ;

	// ^CvZbg
	pLH->Param.LightType = DX_LIGHTTYPE_D3DLIGHT_DIRECTIONAL ;

	// Zbg
	Length = _SQRT( VectorInnerProduct( &Direction, &Direction ) ) ;
	Direction.x /= Length ;
	Direction.y /= Length ;
	Direction.z /= Length ;
	pLH->Param.Direction = Direction ;

	// nhԂ
	return LHandle ;
}

// X|bgCgnh쐬
extern int NS_CreateSpotLightHandle( VECTOR Position, VECTOR Direction, float OutAngle, float InAngle/*, float Falloff*/, float Range, float Atten0, float Atten1, float Atten2 )
{
	float Falloff = 1.0f ;
	int LHandle ;
	LIGHT_HANDLE *pLH ;

	// Vnh̒ǉ
	LHandle = Graphics_Light_AddHandle() ;
	LIGHTCHK( LHandle, pLH, -1 ) ;

	// ^CvZbg
	pLH->Param.LightType = DX_LIGHTTYPE_D3DLIGHT_SPOT ;

	// p[^Zbg
	pLH->Param.Position = Position ;
	pLH->Param.Direction = Direction ;
	pLH->Param.Phi = OutAngle ;
	pLH->Param.Theta = InAngle ;
	pLH->Param.Falloff = Falloff ;
	pLH->Param.Range = Range ;
	pLH->Param.Attenuation0 = Atten0 ;
	pLH->Param.Attenuation1 = Atten1 ;
	pLH->Param.Attenuation2 = Atten2 ;

	// nhԂ
	return LHandle ;
}

// |CgCgnh쐬
extern int NS_CreatePointLightHandle( VECTOR Position, float Range, float Atten0, float Atten1, float Atten2 )
{
	int LHandle ;
	LIGHT_HANDLE *pLH ;

	// Vnh̒ǉ
	LHandle = Graphics_Light_AddHandle() ;
	LIGHTCHK( LHandle, pLH, -1 ) ;

	// ^CvZbg
	pLH->Param.LightType = DX_LIGHTTYPE_D3DLIGHT_POINT ;

	// p[^Zbg
	pLH->Param.Position = Position ;
	pLH->Param.Range = Range ;
	pLH->Param.Attenuation0 = Atten0 ;
	pLH->Param.Attenuation1 = Atten1 ;
	pLH->Param.Attenuation2 = Atten2 ;

	// nhԂ
	return LHandle ;
}

// Cgnh폜
extern int NS_DeleteLightHandle( int LHandle )
{
	LIGHT_HANDLE *pLH ;

	// G[
	LIGHTCHK( LHandle, pLH, -1 ) ;

	// Cgnh̑炷
	GSYS.Light.Num -- ;

	// LȃCgnh݂͈͂̍XV
	if( ( LHandle & DX_HANDLEINDEX_MASK ) == GSYS.Light.Area - 1 )
	{
		if( GSYS.Light.Num == 0 )
		{
			GSYS.Light.Area = 0 ;
		}
		else
		{
			while( GSYS.Light.Data[ GSYS.Light.Area - 1 ] == NULL )
				GSYS.Light.Area -- ; 
		}
	}

	// f[^̈
	DXFREE( pLH ) ;

	// e[u NULL Zbg
	GSYS.Light.Data[ LHandle & DX_HANDLEINDEX_MASK ] = NULL ;

	// ύXtO𗧂Ă
	GSYS.Light.HardwareChange = TRUE ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// CgnhSč폜
extern int NS_DeleteLightHandleAll( void )
{
	int i ;
	LIGHT_HANDLE **ppLH ;

	// WCgȊÔׂẴCgf[^폜
	ppLH = GSYS.Light.Data ;
	for( i = 0 ; i < GSYS.Light.Area ; i ++, ppLH ++ )
	{
		if( *ppLH && ( *ppLH )->Handle != GSYS.Light.DefaultHandle )
			NS_DeleteLightHandle( ( *ppLH )->Handle ) ;
	}

	// I
	return 0 ;
}

// Cgnh̃Cg̃^CvύX( DX_LIGHTTYPE_DIRECTIONAL  )
extern int NS_SetLightTypeHandle( int LHandle, int LightType )
{
	LIGHT_HANDLE *pLH ;

	// G[
	LIGHTCHK( LHandle, pLH, -1 ) ;

	// Cg^Cvsꍇ̓G[
	if( LightType != DX_LIGHTTYPE_DIRECTIONAL &&
		LightType != DX_LIGHTTYPE_SPOT &&
		LightType != DX_LIGHTTYPE_POINT )
		return -1 ;

	// ^CvZbg
	pLH->Param.LightType = LightType ;

	// ύXtO𗧂Ă
	pLH->HardwareChangeFlag = TRUE ;
	GSYS.Light.HardwareChange = TRUE ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// Cgnh̃Cg̗LAݒ肷( TRUE:L  FALSE: )
extern int NS_SetLightEnableHandle( int LHandle, int EnableFlag )
{
	LIGHT_HANDLE *pLH ;

	// G[
	LIGHTCHK( LHandle, pLH, -1 ) ;

	// ܂łƓꍇ͉ɏI
	if( pLH->EnableFlag == EnableFlag )
		return 0 ;

	// tOۑ
	pLH->EnableFlag = EnableFlag ;
	if( EnableFlag == FALSE )
	{
		pLH->SetHardwareIndex = -1 ;
	}

	// ύXtO𗧂Ă
	pLH->HardwareChangeFlag = TRUE ;
	GSYS.Light.HardwareChange = TRUE ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// Cgnh̃Cg̃fBt[YJ[ݒ肷
extern int NS_SetLightDifColorHandle( int LHandle, COLOR_F Color )
{
	LIGHT_HANDLE *pLH ;

	// G[
	LIGHTCHK( LHandle, pLH, -1 ) ;

	Color.a = 0.0f ;
	pLH->Param.Diffuse = Color ;

	// ύXtO𗧂Ă
	pLH->HardwareChangeFlag = TRUE ;
	GSYS.Light.HardwareChange = TRUE ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// Cgnh̃Cg̃XyLJ[ݒ肷
extern int NS_SetLightSpcColorHandle( int LHandle, COLOR_F Color )
{
	LIGHT_HANDLE *pLH ;

	// G[
	LIGHTCHK( LHandle, pLH, -1 ) ;

	Color.a = 0.0f ;
	pLH->Param.Specular = Color ;

	// ύXtO𗧂Ă
	pLH->HardwareChangeFlag = TRUE ;
	GSYS.Light.HardwareChange = TRUE ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// Cgnh̃Cg̃ArGgJ[ݒ肷
extern int NS_SetLightAmbColorHandle( int LHandle, COLOR_F Color )
{
	LIGHT_HANDLE *pLH ;

	// G[
	LIGHTCHK( LHandle, pLH, -1 ) ;

	Color.a = 0.0f ;
	pLH->Param.Ambient = Color ;

	// ύXtO𗧂Ă
	pLH->HardwareChangeFlag = TRUE ;
	GSYS.Light.HardwareChange = TRUE ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// Cgnh̃Cg̕ݒ肷
extern int NS_SetLightDirectionHandle( int LHandle, VECTOR Direction )
{
	LIGHT_HANDLE *pLH ;
	float Length ;

	// G[
	LIGHTCHK( LHandle, pLH, -1 ) ;

	// ۑ
	Length = _SQRT( VectorInnerProduct( &Direction, &Direction ) ) ;
	Direction.x /= Length ;
	Direction.y /= Length ;
	Direction.z /= Length ;
	pLH->Param.Direction = Direction ;

	// ύXtO𗧂Ă
	pLH->HardwareChangeFlag = TRUE ;
	GSYS.Light.HardwareChange = TRUE ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// Cgnh̃Cg̈ʒuݒ肷
extern int NS_SetLightPositionHandle( int LHandle, VECTOR Position )
{
	LIGHT_HANDLE *pLH ;

	// G[
	LIGHTCHK( LHandle, pLH, -1 ) ;

	pLH->Param.Position = Position ;

	// ύXtO𗧂Ă
	pLH->HardwareChangeFlag = TRUE ;
	GSYS.Light.HardwareChange = TRUE ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// Cgnh̃Cg̋p[^ݒ肷( LAWOAPAQ )
extern int NS_SetLightRangeAttenHandle( int LHandle, float Range, float Atten0, float Atten1, float Atten2 )
{
	LIGHT_HANDLE *pLH ;

	// G[
	LIGHTCHK( LHandle, pLH, -1 ) ;

	pLH->Param.Range = Range ;
	pLH->Param.Attenuation0 = Atten0 ;
	pLH->Param.Attenuation1 = Atten1 ;
	pLH->Param.Attenuation2 = Atten2 ;

	// ύXtO𗧂Ă
	pLH->HardwareChangeFlag = TRUE ;
	GSYS.Light.HardwareChange = TRUE ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// Cgnh̃Cg̃X|bgCg̃p[^ݒ肷( OR[pxAR[pxAtH[It( 1.0f 𐄏 ) )
extern int NS_SetLightAngleHandle( int LHandle, float OutAngle, float InAngle /*, float Falloff */ )
{
	LIGHT_HANDLE *pLH ;
	float Falloff = 1.0f ;

	// G[
	LIGHTCHK( LHandle, pLH, -1 ) ;

	pLH->Param.Phi = OutAngle ;
	pLH->Param.Theta = InAngle ;
	pLH->Param.Falloff = Falloff ;

	// ύXtO𗧂Ă
	pLH->HardwareChangeFlag = TRUE ;
	GSYS.Light.HardwareChange = TRUE ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// Cgnh̃Cg SetUseShadowMap Ŏw肵VhE}bvKp邩ǂݒ肷
// ( SmSlotIndex:VhE}bvXbg( SetUseShadowMap ̑ɐݒ肷l )
//   UseFlag:Kpɂ邩ǂ̃tO( TRUE:Kp( ftHg )  FALSE:KpȂ ) )
extern int NS_SetLightUseShadowMapHandle( int LHandle, int SmSlotIndex, int UseFlag )
{
	LIGHT_HANDLE *pLH ;

	// G[
	LIGHTCHK( LHandle, pLH, -1 ) ;

	// G[`FbN
	if( SmSlotIndex < 0 || SmSlotIndex >= MAX_USE_SHADOWMAP_NUM )
	{
		return -1 ;
	}

	// tOZbg
	pLH->ShadowMapSlotDisableFlag[ SmSlotIndex ] = UseFlag == FALSE ? TRUE : FALSE ;

	// ύXtO𗧂Ă
	pLH->HardwareChangeFlag = TRUE ;
	GSYS.Light.HardwareChange = TRUE ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// Cgnh̃Cg̃^Cv擾( ߂l DX_LIGHTTYPE_DIRECTIONAL  )
extern int NS_GetLightTypeHandle( int LHandle )
{
	LIGHT_HANDLE *pLH ;

	// G[
	LIGHTCHK( LHandle, pLH, -1 ) ;

	return pLH->Param.LightType ;
}

// Cgnh̃Cgʂ̗LA擾( TRUE:L  FALSE: )
extern int NS_GetLightEnableHandle( int LHandle )
{
	LIGHT_HANDLE *pLH ;

	// G[
	LIGHTCHK( LHandle, pLH, -1 ) ;

	return pLH->EnableFlag ;
}

// Cgnh̃Cg̃fBt[YJ[擾
extern COLOR_F NS_GetLightDifColorHandle( int LHandle )
{
	COLOR_F ErrorResult = { -1.0f, -1.0f, -1.0f, -1.0f } ;
	LIGHT_HANDLE *pLH ;

	// G[
	LIGHTCHK( LHandle, pLH, ErrorResult ) ;

	// FԂ
	return pLH->Param.Diffuse ;
}

// Cgnh̃Cg̃XyLJ[擾
extern COLOR_F NS_GetLightSpcColorHandle( int LHandle )
{
	COLOR_F ErrorResult = { -1.0f, -1.0f, -1.0f, -1.0f } ;
	LIGHT_HANDLE *pLH ;

	// G[
	LIGHTCHK( LHandle, pLH, ErrorResult ) ;

	// FԂ
	return pLH->Param.Specular ;
}

// Cgnh̃Cg̃ArGgJ[擾
extern COLOR_F NS_GetLightAmbColorHandle( int LHandle )
{
	COLOR_F ErrorResult = { -1.0f, -1.0f, -1.0f, -1.0f } ;
	LIGHT_HANDLE *pLH ;

	// G[
	LIGHTCHK( LHandle, pLH, ErrorResult ) ;

	// FԂ
	return pLH->Param.Ambient ;
}

// Cgnh̃Cg̕擾
extern VECTOR NS_GetLightDirectionHandle( int LHandle )
{
	LIGHT_HANDLE *pLH ;
	VECTOR ErrorResult = { -1.0f, -1.0f, -1.0f } ;

	// G[
	LIGHTCHK( LHandle, pLH, ErrorResult ) ;

	return pLH->Param.Direction ;
}

// Cgnh̃Cg̈ʒu擾
extern VECTOR NS_GetLightPositionHandle( int LHandle )
{
	LIGHT_HANDLE *pLH ;
	VECTOR ErrorResult = { -1.0f, -1.0f, -1.0f } ;

	// G[
	LIGHTCHK( LHandle, pLH, ErrorResult ) ;

	return pLH->Param.Position ;
}

// Cgnh̃Cg̋p[^擾( LAWOAPAQ )
extern int NS_GetLightRangeAttenHandle( int LHandle, float *Range, float *Atten0, float *Atten1, float *Atten2 )
{
	LIGHT_HANDLE *pLH ;

	// G[
	LIGHTCHK( LHandle, pLH, -1 ) ;

	if( Range ) *Range = pLH->Param.Range ;
	if( Atten0 ) *Atten0 = pLH->Param.Attenuation0 ;
	if( Atten1 ) *Atten1 = pLH->Param.Attenuation1 ;
	if( Atten2 ) *Atten2 = pLH->Param.Attenuation2 ;

	// I
	return 0 ;
}

// Cgnh̃Cg̃X|bgCg̃p[^擾( OR[pxAR[pxAtH[It )
extern int NS_GetLightAngleHandle( int LHandle, float *OutAngle, float *InAngle /*, float *Falloff */ )
{
	LIGHT_HANDLE *pLH ;

	// G[
	LIGHTCHK( LHandle, pLH, -1 ) ;

	if( OutAngle ) *OutAngle = pLH->Param.Phi ;
	if( InAngle  ) *InAngle  = pLH->Param.Theta ;
//	if( Falloff  ) *Falloff  = pLH->Param.Falloff ;

	// I
	return 0 ;
}

// LɂȂĂ郉Cgnh̐擾
extern int NS_GetEnableLightHandleNum( void )
{
	// XVtOĂXV
	if( GSYS.Light.HardwareChange )
	{
		Graphics_Light_RefreshState() ;
	}

	// LɂȂĂ郉Cgnh̐Ԃ
	return GSYS.Light.EnableNum ;
}

// LɂȂĂ郉Cgnh擾
extern int NS_GetEnableLightHandle( int Index )
{
	// CfbNX`FbN
	if( Index < 0 || Index >= MAX_HARDWAREENABLELIGHTINDEX_NUM )
		return -1 ;

	// XVtOĂXV
	if( GSYS.Light.HardwareChange )
	{
		Graphics_Light_RefreshState() ;
	}

	// ͈͊Ȍꍇ̓G[
	if( Index >= GSYS.Light.EnableNum )
		return -1 ;

	// nhlԂ
	return GSYS.Light.Data[ GSYS.Light.EnableHardwareIndex[ Index ] ]->Handle ;
}

























// F擾p֐

// eNX`tH[}bg̃CfbNX𓾂
extern int NS_GetTexFormatIndex( const IMAGEFORMATDESC *Format )
{
	int Result = DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB32 ;

	switch( Format->BaseFormat )
	{
	case DX_BASEIMAGE_FORMAT_DXT1 :           return DX_GRAPHICSIMAGE_FORMAT_3D_DXT1 ;
	case DX_BASEIMAGE_FORMAT_DXT2 :           return DX_GRAPHICSIMAGE_FORMAT_3D_DXT2 ;
	case DX_BASEIMAGE_FORMAT_DXT3 :           return DX_GRAPHICSIMAGE_FORMAT_3D_DXT3 ;
	case DX_BASEIMAGE_FORMAT_DXT4 :           return DX_GRAPHICSIMAGE_FORMAT_3D_DXT4 ;
	case DX_BASEIMAGE_FORMAT_DXT5 :           return DX_GRAPHICSIMAGE_FORMAT_3D_DXT5 ;
	case DX_BASEIMAGE_FORMAT_BC7_UNORM :      return DX_GRAPHICSIMAGE_FORMAT_3D_BC7_UNORM ;
	case DX_BASEIMAGE_FORMAT_BC7_UNORM_SRGB : return DX_GRAPHICSIMAGE_FORMAT_3D_BC7_UNORM_SRGB ;
	case DX_BASEIMAGE_FORMAT_PLATFORM0 :      return DX_GRAPHICSIMAGE_FORMAT_3D_PLATFORM0 ;
	case DX_BASEIMAGE_FORMAT_PLATFORM1 :      return DX_GRAPHICSIMAGE_FORMAT_3D_PLATFORM1 ;
	case DX_BASEIMAGE_FORMAT_PLATFORM2 :      return DX_GRAPHICSIMAGE_FORMAT_3D_PLATFORM2 ;
	case DX_BASEIMAGE_FORMAT_PLATFORM3 :      return DX_GRAPHICSIMAGE_FORMAT_3D_PLATFORM3 ;

	default:
		switch( Format->ChannelNum )
		{
		case 1 :
			if( Format->DrawValidFlag == 0 )
			{
				if( Format->FloatTypeFlag )
				{
					if( Format->ChannelBitDepth != 0 )
					{
						if( Format->ChannelBitDepth < 32 )
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_ONE_F16 ;
						}
						else
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_ONE_F32 ;
						}
					}
					else
					{
						if( Format->ColorBitDepth < 32 )
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_ONE_F16 ;
						}
						else
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_ONE_F32 ;
						}
					}
				}
				else
				{
					if( Format->ChannelBitDepth != 0 )
					{
						if( Format->ChannelBitDepth < 16 )
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_ONE_I8 ;
						}
						else
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_ONE_I16 ;
						}
					}
					else
					{
						if( Format->ColorBitDepth < 16 )
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_ONE_I8 ;
						}
						else
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_ONE_I16 ;
						}
					}
				}
			}
			else
			{
				if( Format->FloatTypeFlag )
				{
					if( Format->ChannelBitDepth != 0 )
					{
						if( Format->ChannelBitDepth < 32 )
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ;
						}
						else
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ;
						}
					}
					else
					{
						if( Format->ColorBitDepth < 32 )
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ;
						}
						else
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ;
						}
					}
				}
				else
				{
					if( Format->ChannelBitDepth != 0 )
					{
						if( Format->ChannelBitDepth < 16 )
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I8 ;
						}
						else
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I16 ;
						}
					}
					else
					{
						if( Format->ColorBitDepth < 16 )
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I8 ;
						}
						else
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I16 ;
						}
					}
				}
			}

		case 2 :
			if( Format->DrawValidFlag == 0 )
			{
				if( Format->FloatTypeFlag )
				{
					if( Format->ChannelBitDepth != 0 )
					{
						if( Format->ChannelBitDepth < 32 )
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_TWO_F16 ;
						}
						else
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_TWO_F32 ;
						}
					}
					else
					{
						if( Format->ColorBitDepth < 64 )
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_TWO_F16 ;
						}
						else
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_TWO_F32 ;
						}
					}
				}
				else
				{
					if( Format->ChannelBitDepth != 0 )
					{
						if( Format->ChannelBitDepth < 16 )
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_TWO_I8 ;
						}
						else
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_TWO_I16 ;
						}
					}
					else
					{
						if( Format->ColorBitDepth < 32 )
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_TWO_I8 ;
						}
						else
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_TWO_I16 ;
						}
					}
				}
			}
			else
			{
				if( Format->FloatTypeFlag )
				{
					if( Format->ChannelBitDepth != 0 )
					{
						if( Format->ChannelBitDepth < 32 )
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F16 ;
						}
						else
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F32 ;
						}
					}
					else
					{
						if( Format->ColorBitDepth < 64 )
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F16 ;
						}
						else
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F32 ;
						}
					}
				}
				else
				{
					if( Format->ChannelBitDepth != 0 )
					{
						if( Format->ChannelBitDepth < 16 )
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I8 ;
						}
						else
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I16 ;
						}
					}
					else
					{
						if( Format->ColorBitDepth < 32 )
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I8 ;
						}
						else
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I16 ;
						}
					}
				}
			}

		case 4 :
		default :
			if( Format->ColorBitDepth == 4 )
			{
					 if( Format->AlphaChFlag   ) Result = DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_PAL4 ;
				else if( Format->AlphaTestFlag ) Result = DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_PAL4 ;
				else                             Result = DX_GRAPHICSIMAGE_FORMAT_3D_PAL4 ;
			}
			else
			if( Format->ColorBitDepth == 8 )
			{
					 if( Format->AlphaChFlag   ) Result = DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_PAL8 ;
				else if( Format->AlphaTestFlag ) Result = DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_PAL8 ;
				else                             Result = DX_GRAPHICSIMAGE_FORMAT_3D_PAL8 ;
			}
			else
			{
				if( Format->DrawValidFlag == 0 )
				{
					if( Format->FloatTypeFlag )
					{
						if( Format->ChannelBitDepth != 0 )
						{
							if( Format->ChannelBitDepth < 32 )
							{
								return DX_GRAPHICSIMAGE_FORMAT_3D_ABGR_F16 ;
							}
							else
							{
								return DX_GRAPHICSIMAGE_FORMAT_3D_ABGR_F32 ;
							}
						}
						else
						{
							if( Format->ColorBitDepth < 128 )
							{
								return DX_GRAPHICSIMAGE_FORMAT_3D_ABGR_F16 ;
							}
							else
							{
								return DX_GRAPHICSIMAGE_FORMAT_3D_ABGR_F32 ;
							}
						}
					}
					else
					{
						if( Format->ChannelBitDepth >= 9 )
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_ABGR_I16 ;
						}
						else
						if( Format->AlphaChFlag )
						{
							if( Format->ColorBitDepth == 16 )
							{
								return DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB16 ;
							}
							else
							{
								return DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB32 ;
							}
						}
						else
						if( Format->AlphaTestFlag )
						{
							if( Format->ColorBitDepth == 16 )
							{
								return DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB16 ;
							}
							else
							{
								return DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB32 ;
							}
						}
						else
						{
							if( Format->ColorBitDepth == 16 )
							{
								return DX_GRAPHICSIMAGE_FORMAT_3D_RGB16 ;
							}
							else
							{
								return DX_GRAPHICSIMAGE_FORMAT_3D_RGB32 ;
							}
						}
					}
				}
				else
				{
					if( Format->FloatTypeFlag )
					{
						if( Format->ChannelBitDepth != 0 )
						{
							if( Format->ChannelBitDepth < 32 )
							{
								return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F16 ;
							}
							else
							{
								return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F32 ;
							}
						}
						else
						{
							if( Format->ColorBitDepth < 128 )
							{
								return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F16 ;
							}
							else
							{
								return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F32 ;
							}
						}
					}
					else
					{
						if( Format->ChannelBitDepth >= 9 )
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_I16 ;
						}
						else
						if( Format->AlphaChFlag == TRUE || Format->AlphaTestFlag == TRUE )
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ALPHA_RGB32 ;
						}
						else
						if( Format->ColorBitDepth == 16 )
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB16 ;
						}
						else
						{
							return DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB32 ;
						}
					}
				}
			}
			break ;
		}
		break ;
	}

	return Result ;
}

#ifdef WINDOWS_DESKTOP_OS

// F
extern int NS_ColorKaiseki( const void *PixelData, LPCOLORDATA ColorData )
{
	D_DDPIXELFORMAT *PData = ( D_DDPIXELFORMAT * )PixelData ;
	DWORD ColorMask ;
	int ColorWidth, ColorLoc ;
	int i, j ;

	unsigned int  ColorMaskBuf[ 5 ] ;
	unsigned char *ColorWidthBuf[ 5 ] ;
	unsigned char *ColorLocBuf[ 5 ] ;

	// rbgfvXۑ
	ColorData->ColorBitDepth = ( unsigned char )PData->dwRGBBitCount ;

	// sNZ̃oCgۑ
	ColorData->PixelByte = ( unsigned char )( ColorData->ColorBitDepth / 8 ) ;

	// F͂
	{
		// J[}XN𓾂鏀
		ColorData->RedMask		= PData->dwRBitMask;
		ColorMaskBuf[ 0 ]		= ColorData->RedMask ;
		ColorWidthBuf[ 0 ]		= &ColorData->RedWidth ;
		ColorLocBuf[ 0 ]		= &ColorData->RedLoc ;

		ColorData->GreenMask	= PData->dwGBitMask;
		ColorMaskBuf[ 1 ]		= ColorData->GreenMask ;
		ColorWidthBuf[ 1 ]		= &ColorData->GreenWidth ;
		ColorLocBuf[ 1 ]		= &ColorData->GreenLoc ;

		ColorData->BlueMask		= PData->dwBBitMask;
		ColorMaskBuf[ 2 ]		= ColorData->BlueMask ;
		ColorWidthBuf[ 2 ]		= &ColorData->BlueWidth ;
		ColorLocBuf[ 2 ]		= &ColorData->BlueLoc ;

		ColorData->AlphaMask	= PData->dwRGBAlphaBitMask ;
		ColorMaskBuf[ 3 ]		= ColorData->AlphaMask ;
		ColorWidthBuf[ 3 ]		= &ColorData->AlphaWidth ;
		ColorLocBuf[ 3 ]		= &ColorData->AlphaLoc ;

		if( ColorData->ColorBitDepth == 32 ) ColorData->NoneMask = 0xffffffff;
		else                                 ColorData->NoneMask = ( unsigned int )( ( 1 << ColorData->ColorBitDepth ) - 1 ) ;
		ColorData->NoneMask		&= ~( ColorData->RedMask | ColorData->GreenMask | ColorData->BlueMask | ColorData->AlphaMask ) ;
		ColorMaskBuf[ 4 ]		= ColorData->NoneMask ;
		ColorWidthBuf[ 4 ]		= &ColorData->NoneWidth ;
		ColorLocBuf[ 4 ]		= &ColorData->NoneLoc ;
	}

	// F̉͊Jn
 	for( j = 0 ; j < 5 ; j ++ )
	{
		// J[}XN擾
		ColorMask = ColorMaskBuf[ j ] ;

		if( ColorMask == 0 )
		{
			*ColorLocBuf[ j ] = 0 ;
			*ColorWidthBuf[ j ] = 0 ;
			continue ;
		}

		// J[̐擪rbg܂ł̃rbgƃrbg̏
		ColorLoc = 0 ;
		ColorWidth = 0 ;

		// J[̂擪rbg܂ł̃rbg
		for( i = 0 ; i < 32 ; i ++ )
		{
			// 擪rbgɓBȂԂ͌JԂ
			if( ColorMask & 1 )
			{	
				ColorLoc = i ;
				break ;
			}
			ColorMask >>= 1 ;
		}
		// J[񂪂ȂΈُI
		if( i == 32 ) return -1 ;

		// J[̃rbg𒲂ׂ
		for( i = 0 ; i < 32 ; i ++ )
		{
			// rbgr؂ȂԌJԂ
			if( !( ColorMask & 1 ) ) 
			{
				ColorWidth = i ;
				break ;
			}
			ColorMask >>= 1 ;
		}

		// ͌ʂۑ
		*ColorLocBuf[ j ] = ( unsigned char )ColorLoc ;
		*ColorWidthBuf[ j ] = ( unsigned char )ColorWidth ;
	}

	// Ȃ̋@\tĂȂrbg̃}XNZbg
//	NS_SetColorDataNoneMask( ColorData ) ;

	// I
	return 0 ;
}

#endif // WINDOWS_DESKTOP_OS





















// `֐

#ifndef DX_NON_FONT

// yobt@ɑ΂ĕ̕`
extern int NS_DrawStringToZBuffer( int x, int y, const TCHAR *String, int WriteZMode /* DX_ZWRITE_MASK  */ )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawString(  x,  y, String,  GetColor( 255,255,255 ),  GetColor( 0,0,0 ) );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ĕ̕`
extern int NS_DrawNStringToZBuffer( int x, int y, const TCHAR *String, size_t StringLength, int WriteZMode /* DX_ZWRITE_MASK  */ )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawNString(  x,  y, String, StringLength, GetColor( 255,255,255 ),  GetColor( 0,0,0 ) );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ĕ̕`
extern int NS_DrawVStringToZBuffer( int x, int y, const TCHAR *String, int WriteZMode /* DX_ZWRITE_MASK  */ )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawVString(  x,  y, String,  GetColor( 255,255,255 ),  GetColor( 0,0,0 ) );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ĕ̕`
extern int NS_DrawNVStringToZBuffer( int x, int y, const TCHAR *String, size_t StringLength, int WriteZMode /* DX_ZWRITE_MASK  */ )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawNVString(  x,  y, String, StringLength,  GetColor( 255,255,255 ),  GetColor( 0,0,0 ) );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ĕ`悷
extern int NS_DrawStringToHandleToZBuffer( int x, int y, const TCHAR *String, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawStringToHandle(  x,  y, String,  GetColor( 255,255,255 ),  FontHandle,  GetColor( 0,0,0 ) ,  VerticalFlag );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ĕ`悷
extern int NS_DrawNStringToHandleToZBuffer( int x, int y, const TCHAR *String, size_t StringLength, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawNStringToHandle(  x,  y, String, StringLength,  GetColor( 255,255,255 ),  FontHandle,  GetColor( 0,0,0 ) ,  VerticalFlag );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ĕ`悷
extern int NS_DrawVStringToHandleToZBuffer( int x, int y, const TCHAR *String, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawVStringToHandle(  x,  y, String,  GetColor( 255,255,255 ),  FontHandle,  GetColor( 0,0,0 ) );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ĕ`悷
extern int NS_DrawNVStringToHandleToZBuffer( int x, int y, const TCHAR *String, size_t StringLength, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawNVStringToHandle(  x,  y, String, StringLength,  GetColor( 255,255,255 ),  FontHandle,  GetColor( 0,0,0 ) );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ďw蕶`悷
extern int NS_DrawFormatStringToZBuffer( int x, int y, int WriteZMode /* DX_ZWRITE_MASK  */, const TCHAR *FormatString, ... )
{
	va_list VaList ;
	TCHAR String[ 2048 ] ;

	va_start( VaList, FormatString ) ;
	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;
	va_end( VaList ) ;

	DrawZBuffer_Pre( WriteZMode );
	NS_DrawString(  x,  y, String,  GetColor( 255,255,255 ), 0 );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ďw蕶`悷
extern int NS_DrawFormatVStringToZBuffer( int x, int y, int WriteZMode /* DX_ZWRITE_MASK  */, const TCHAR *FormatString, ... )
{
	va_list VaList ;
	TCHAR String[ 2048 ] ;

	va_start( VaList, FormatString ) ;
	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;
	va_end( VaList ) ;

	DrawZBuffer_Pre( WriteZMode );
	NS_DrawVString(  x,  y, String,  GetColor( 255,255,255 ), 0 );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ďw蕶`悷
extern int NS_DrawFormatStringToHandleToZBuffer( int x, int y, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */, const TCHAR *FormatString, ... )
{
	va_list VaList ;
	TCHAR String[ 2048 ] ;

	va_start( VaList, FormatString ) ;
	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;
	va_end( VaList ) ;

	DrawZBuffer_Pre( WriteZMode );
	NS_DrawStringToHandle(  x,  y, String,  GetColor( 255,255,255 ), FontHandle, 0, FALSE );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ďw蕶`悷
extern int NS_DrawFormatVStringToHandleToZBuffer( int x, int y, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */, const TCHAR *FormatString, ... )
{
	va_list VaList ;
	TCHAR String[ 2048 ] ;

	va_start( VaList, FormatString ) ;
	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;
	va_end( VaList ) ;

	DrawZBuffer_Pre( WriteZMode );
	NS_DrawVStringToHandle(  x,  y, String,  GetColor( 255,255,255 ), FontHandle, 0 );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ĕ̊g`
extern int NS_DrawExtendStringToZBuffer( int x, int y, double ExRateX, double ExRateY, const TCHAR *String, int WriteZMode /* DX_ZWRITE_MASK  */ )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawExtendString(  x,  y,  ExRateX,  ExRateY, String,  GetColor( 255,255,255 ),  GetColor( 0,0,0 ) );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ĕ̊g`
extern int NS_DrawExtendNStringToZBuffer( int x, int y, double ExRateX, double ExRateY, const TCHAR *String, size_t StringLength, int WriteZMode /* DX_ZWRITE_MASK  */ )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawExtendNString(  x,  y,  ExRateX,  ExRateY, String, StringLength,  GetColor( 255,255,255 ),  GetColor( 0,0,0 ) );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ĕ̊g`
extern int NS_DrawExtendVStringToZBuffer( int x, int y, double ExRateX, double ExRateY, const TCHAR *String, int WriteZMode /* DX_ZWRITE_MASK  */ )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawExtendVString(  x,  y,  ExRateX,  ExRateY, String,  GetColor( 255,255,255 ),  GetColor( 0,0,0 ) );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ĕ̊g`
extern int NS_DrawExtendNVStringToZBuffer( int x, int y, double ExRateX, double ExRateY, const TCHAR *String, size_t StringLength, int WriteZMode /* DX_ZWRITE_MASK  */ )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawExtendNVString(  x,  y,  ExRateX,  ExRateY, String, StringLength,  GetColor( 255,255,255 ),  GetColor( 0,0,0 ) );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ĕg`悷
extern int NS_DrawExtendStringToHandleToZBuffer( int x, int y, double ExRateX, double ExRateY, const TCHAR *String, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawExtendStringToHandle(  x,  y,  ExRateX,  ExRateY, String,  GetColor( 255,255,255 ),  FontHandle,  GetColor( 0,0,0 ) ,  VerticalFlag );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ĕg`悷
extern int NS_DrawExtendNStringToHandleToZBuffer( int x, int y, double ExRateX, double ExRateY, const TCHAR *String, size_t StringLength, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawExtendNStringToHandle(  x,  y,  ExRateX,  ExRateY, String, StringLength,  GetColor( 255,255,255 ),  FontHandle,  GetColor( 0,0,0 ) ,  VerticalFlag );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ĕg`悷
extern int NS_DrawExtendVStringToHandleToZBuffer( int x, int y, double ExRateX, double ExRateY, const TCHAR *String, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawExtendVStringToHandle(  x,  y,  ExRateX,  ExRateY, String,  GetColor( 255,255,255 ),  FontHandle,  GetColor( 0,0,0 ) );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ĕg`悷
extern int NS_DrawExtendNVStringToHandleToZBuffer( int x, int y, double ExRateX, double ExRateY, const TCHAR *String, size_t StringLength, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawExtendNVStringToHandle(  x,  y,  ExRateX,  ExRateY, String, StringLength,  GetColor( 255,255,255 ),  FontHandle,  GetColor( 0,0,0 ) );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ďw蕶g`悷
extern int NS_DrawExtendFormatStringToZBuffer( int x, int y, double ExRateX, double ExRateY, int WriteZMode /* DX_ZWRITE_MASK  */, const TCHAR *FormatString, ... )
{
	va_list VaList ;
	TCHAR String[ 2048 ] ;

	va_start( VaList, FormatString ) ;
	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;
	va_end( VaList ) ;

	DrawZBuffer_Pre( WriteZMode );
	NS_DrawExtendString(  x,  y, ExRateX, ExRateY, String,  GetColor( 255,255,255 ), 0 );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ďw蕶g`悷
extern int NS_DrawExtendFormatVStringToZBuffer( int x, int y, double ExRateX, double ExRateY, int WriteZMode /* DX_ZWRITE_MASK  */, const TCHAR *FormatString, ... )
{
	va_list VaList ;
	TCHAR String[ 2048 ] ;

	va_start( VaList, FormatString ) ;
	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;
	va_end( VaList ) ;

	DrawZBuffer_Pre( WriteZMode );
	NS_DrawExtendVString(  x,  y, ExRateX, ExRateY, String,  GetColor( 255,255,255 ), 0 );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ďw蕶g`悷
extern int NS_DrawExtendFormatStringToHandleToZBuffer( int x, int y, double ExRateX, double ExRateY, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */, const TCHAR *FormatString, ... )
{
	va_list VaList ;
	TCHAR String[ 2048 ] ;

	va_start( VaList, FormatString ) ;
	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;
	va_end( VaList ) ;

	DrawZBuffer_Pre( WriteZMode );
	NS_DrawExtendStringToHandle(  x,  y, ExRateX, ExRateY, String,  GetColor( 255,255,255 ), FontHandle, 0, FALSE );
	DrawZBuffer_Post();

	// I
	return 0;
}

// yobt@ɑ΂ďw蕶g`悷
extern int NS_DrawExtendFormatVStringToHandleToZBuffer( int x, int y, double ExRateX, double ExRateY, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */, const TCHAR *FormatString, ... )
{
	va_list VaList ;
	TCHAR String[ 2048 ] ;

	va_start( VaList, FormatString ) ;
	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;
	va_end( VaList ) ;

	DrawZBuffer_Pre( WriteZMode );
	NS_DrawExtendVStringToHandle(  x,  y, ExRateX, ExRateY, String,  GetColor( 255,255,255 ), FontHandle, 0 );
	DrawZBuffer_Post();

	// I
	return 0;
}

// ftHgtHgnhgpĂyobt@ɑ΂ĕ]`悷
extern int NS_DrawRotaStringToZBuffer( int x, int y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag , const TCHAR *String )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawRotaString(  x,  y,  ExRateX,  ExRateY, RotCenterX, RotCenterY, RotAngle,  GetColor( 255,255,255 ), GetColor( 0,0,0 ), VerticalFlag, String ) ;
	DrawZBuffer_Post();

	// I
	return 0;
}

// ftHgtHgnhgpĂyobt@ɑ΂ĕ]`悷
extern int NS_DrawRotaNStringToZBuffer( int x, int y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag , const TCHAR *String, size_t StringLength )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawRotaNString(  x,  y,  ExRateX,  ExRateY, RotCenterX, RotCenterY, RotAngle,  GetColor( 255,255,255 ), GetColor( 0,0,0 ), VerticalFlag, String, StringLength ) ;
	DrawZBuffer_Post();

	// I
	return 0;
}

// tHgnhgpĂyobt@ɑ΂ĕ]`悷
extern int NS_DrawRotaStringToHandleToZBuffer( int x, int y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag , const TCHAR *String )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawRotaStringToHandle(  x,  y,  ExRateX,  ExRateY, RotCenterX, RotCenterY, RotAngle,  GetColor( 255,255,255 ), FontHandle, GetColor( 0,0,0 ), VerticalFlag, String ) ;
	DrawZBuffer_Post();

	// I
	return 0;
}

// tHgnhgpĂyobt@ɑ΂ĕ]`悷
extern int NS_DrawRotaNStringToHandleToZBuffer( int x, int y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag , const TCHAR *String, size_t StringLength )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawRotaNStringToHandle(  x,  y,  ExRateX,  ExRateY, RotCenterX, RotCenterY, RotAngle,  GetColor( 255,255,255 ), FontHandle, GetColor( 0,0,0 ), VerticalFlag, String, StringLength ) ;
	DrawZBuffer_Post();

	// I
	return 0;
}

// ftHgtHgnhgpĂyobt@ɑ΂ďw蕶]`悷
extern int NS_DrawRotaFormatStringToZBuffer( int x, int y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag, const TCHAR *FormatString , ... )
{
	va_list VaList ;
	TCHAR String[ 2048 ] ;

	va_start( VaList, FormatString ) ;
	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;
	va_end( VaList ) ;

	DrawZBuffer_Pre( WriteZMode ) ;
	NS_DrawRotaString(  x,  y,  ExRateX,  ExRateY, RotCenterX, RotCenterY, RotAngle,  GetColor( 255,255,255 ), GetColor( 0,0,0 ), VerticalFlag, String ) ;
	DrawZBuffer_Post();

	// I
	return 0;
}

// tHgnhgpĂyobt@ɑ΂ďw蕶]`悷
extern int NS_DrawRotaFormatStringToHandleToZBuffer( int x, int y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag, const TCHAR *FormatString, ... )
{
	va_list VaList ;
	TCHAR String[ 2048 ] ;

	va_start( VaList, FormatString ) ;
	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;
	va_end( VaList ) ;

	DrawZBuffer_Pre( WriteZMode ) ;
	NS_DrawRotaStringToHandle(  x,  y,  ExRateX,  ExRateY, RotCenterX, RotCenterY, RotAngle,  GetColor( 255,255,255 ), FontHandle, GetColor( 0,0,0 ), VerticalFlag, String ) ;
	DrawZBuffer_Post();

	// I
	return 0;
}


// ftHgtHgnhgpĂyobt@ɑ΂ĕό``悷
extern int NS_DrawModiStringToZBuffer( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag , const TCHAR *String )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawModiString( x1, y1, x2, y2, x3, y3, x4, y4,  GetColor( 255,255,255 ), GetColor( 0,0,0 ), VerticalFlag, String ) ;
	DrawZBuffer_Post();

	// I
	return 0;
}

// ftHgtHgnhgpĂyobt@ɑ΂ĕό``悷
extern int NS_DrawModiNStringToZBuffer( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag , const TCHAR *String, size_t StringLength )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawModiNString( x1, y1, x2, y2, x3, y3, x4, y4,  GetColor( 255,255,255 ), GetColor( 0,0,0 ), VerticalFlag, String, StringLength ) ;
	DrawZBuffer_Post();

	// I
	return 0;
}

// tHgnhgpĂyobt@ɑ΂ĕό``悷
extern int NS_DrawModiStringToHandleToZBuffer( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag , const TCHAR *String )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawModiStringToHandle(  x1, y1, x2, y2, x3, y3, x4, y4,  GetColor( 255,255,255 ), FontHandle, GetColor( 0,0,0 ), VerticalFlag, String ) ;
	DrawZBuffer_Post();

	// I
	return 0;
}

// tHgnhgpĂyobt@ɑ΂ĕό``悷
extern int NS_DrawModiNStringToHandleToZBuffer( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag , const TCHAR *String, size_t StringLength )
{
	DrawZBuffer_Pre( WriteZMode );
	NS_DrawModiNStringToHandle(  x1, y1, x2, y2, x3, y3, x4, y4,  GetColor( 255,255,255 ), FontHandle, GetColor( 0,0,0 ), VerticalFlag, String, StringLength ) ;
	DrawZBuffer_Post();

	// I
	return 0;
}

// ftHgtHgnhgpĂyobt@ɑ΂ďw蕶ό``悷
extern int NS_DrawModiFormatStringToZBuffer( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag, const TCHAR *FormatString , ... )
{
	va_list VaList ;
	TCHAR String[ 2048 ] ;

	va_start( VaList, FormatString ) ;
	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;
	va_end( VaList ) ;

	DrawZBuffer_Pre( WriteZMode ) ;
	NS_DrawModiString(  x1, y1, x2, y2, x3, y3, x4, y4,  GetColor( 255,255,255 ), GetColor( 0,0,0 ), VerticalFlag, String ) ;
	DrawZBuffer_Post();

	// I
	return 0;
}

// tHgnhgpĂyobt@ɑ΂ďw蕶ό``悷
extern int NS_DrawModiFormatStringToHandleToZBuffer( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag, const TCHAR *FormatString, ... )
{
	va_list VaList ;
	TCHAR String[ 2048 ] ;

	va_start( VaList, FormatString ) ;
	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;
	va_end( VaList ) ;

	DrawZBuffer_Pre( WriteZMode ) ;
	NS_DrawModiStringToHandle(  x1, y1, x2, y2, x3, y3, x4, y4,  GetColor( 255,255,255 ), FontHandle, GetColor( 0,0,0 ), VerticalFlag, String ) ;
	DrawZBuffer_Post();

	// I
	return 0;
}

// ftHgtHgnhgpĂyobt@ɑ΂ďw蕶`悷
extern int DrawFormatStringToZBuffer_VaList( int x, int y, int WriteZMode /* DX_ZWRITE_MASK  */ , const TCHAR *FormatString, va_list VaList )
{
	TCHAR String[ 2048 ] ;

	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;

	DrawZBuffer_Pre( WriteZMode );
	NS_DrawString(  x,  y, String,  GetColor( 255,255,255 ), 0 );
	DrawZBuffer_Post();

	// I
	return 0;
}

// ftHgtHgnhgpĂyobt@ɑ΂ďw蕶`悷( c )
extern int DrawFormatVStringToZBuffer_VaList( int x, int y, int WriteZMode /* DX_ZWRITE_MASK  */ , const TCHAR *FormatString, va_list VaList )
{
	TCHAR String[ 2048 ] ;

	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;

	DrawZBuffer_Pre( WriteZMode );
	NS_DrawVString(  x,  y, String,  GetColor( 255,255,255 ), 0 );
	DrawZBuffer_Post();

	// I
	return 0;
}

// ftHgtHgnhgpĂyobt@ɑ΂ďw蕶g`悷
extern int DrawExtendFormatStringToZBuffer_VaList( int x, int y, double ExRateX, double ExRateY, int WriteZMode /* DX_ZWRITE_MASK  */ , const TCHAR *FormatString, va_list VaList )
{
	TCHAR String[ 2048 ] ;

	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;

	DrawZBuffer_Pre( WriteZMode );
	NS_DrawExtendString(  x,  y, ExRateX, ExRateY, String,  GetColor( 255,255,255 ), 0 );
	DrawZBuffer_Post();

	// I
	return 0;
}

// ftHgtHgnhgpĂyobt@ɑ΂ďw蕶g`悷( c )
extern int DrawExtendFormatVStringToZBuffer_VaList( int x, int y, double ExRateX, double ExRateY, int WriteZMode /* DX_ZWRITE_MASK  */ , const TCHAR *FormatString, va_list VaList )
{
	TCHAR String[ 2048 ] ;

	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;

	DrawZBuffer_Pre( WriteZMode );
	NS_DrawExtendVString(  x,  y, ExRateX, ExRateY, String,  GetColor( 255,255,255 ), 0 );
	DrawZBuffer_Post();

	// I
	return 0;
}

// ftHgtHgnhgpĂyobt@ɑ΂ďw蕶]`悷
extern int DrawRotaFormatStringToZBuffer_VaList( int x, int y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag , const TCHAR *FormatString , va_list VaList )
{
	TCHAR String[ 2048 ] ;

	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;

	DrawZBuffer_Pre( WriteZMode ) ;
	NS_DrawRotaString(  x,  y,  ExRateX,  ExRateY, RotCenterX, RotCenterY, RotAngle,  GetColor( 255,255,255 ), GetColor( 0,0,0 ), VerticalFlag, String ) ;
	DrawZBuffer_Post();

	// I
	return 0;
}

// ftHgtHgnhgpĂyobt@ɑ΂ďw蕶ό``悷
extern int DrawModiFormatStringToZBuffer_VaList( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag , const TCHAR *FormatString , va_list VaList )
{
	TCHAR String[ 2048 ] ;

	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;

	DrawZBuffer_Pre( WriteZMode ) ;
	NS_DrawModiString(  x1, y1, x2, y2, x3, y3, x4, y4,  GetColor( 255,255,255 ), GetColor( 0,0,0 ), VerticalFlag, String ) ;
	DrawZBuffer_Post();

	// I
	return 0;
}

// tHgnhgpĂyobt@ɑ΂ďw蕶`悷
extern int DrawFormatStringToHandleToZBuffer_VaList( int x, int y, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , const TCHAR *FormatString, va_list VaList )
{
	TCHAR String[ 2048 ] ;

	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;

	DrawZBuffer_Pre( WriteZMode );
	NS_DrawStringToHandle(  x,  y, String,  GetColor( 255,255,255 ), FontHandle, 0, FALSE );
	DrawZBuffer_Post();

	// I
	return 0;
}

// tHgnhgpĂyobt@ɑ΂ďw蕶`悷( c )
extern int DrawFormatVStringToHandleToZBuffer_VaList( int x, int y, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , const TCHAR *FormatString, va_list VaList )
{
	TCHAR String[ 2048 ] ;

	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;

	DrawZBuffer_Pre( WriteZMode );
	NS_DrawVStringToHandle(  x,  y, String,  GetColor( 255,255,255 ), FontHandle, 0 );
	DrawZBuffer_Post();

	// I
	return 0;
}

// tHgnhgpĂyobt@ɑ΂ďw蕶g`悷
extern int DrawExtendFormatStringToHandleToZBuffer_VaList( int x, int y, double ExRateX, double ExRateY, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , const TCHAR *FormatString, va_list VaList )
{
	TCHAR String[ 2048 ] ;

	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;

	DrawZBuffer_Pre( WriteZMode );
	NS_DrawExtendStringToHandle(  x,  y, ExRateX, ExRateY, String,  GetColor( 255,255,255 ), FontHandle, 0, FALSE );
	DrawZBuffer_Post();

	// I
	return 0;
}

// tHgnhgpĂyobt@ɑ΂ďw蕶g`悷( c )
extern int DrawExtendFormatVStringToHandleToZBuffer_VaList( int x, int y, double ExRateX, double ExRateY, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , const TCHAR *FormatString, va_list VaList )
{
	TCHAR String[ 2048 ] ;

	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;

	DrawZBuffer_Pre( WriteZMode );
	NS_DrawExtendVStringToHandle(  x,  y, ExRateX, ExRateY, String,  GetColor( 255,255,255 ), FontHandle, 0 );
	DrawZBuffer_Post();

	// I
	return 0;
}

// tHgnhgpĂyobt@ɑ΂ďw蕶]`悷
extern int DrawRotaFormatStringToHandleToZBuffer_VaList( int x, int y, double ExRateX, double ExRateY, double RotCenterX, double RotCenterY, double RotAngle, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag, const TCHAR *FormatString, va_list VaList )
{
	TCHAR String[ 2048 ] ;

	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;

	DrawZBuffer_Pre( WriteZMode ) ;
	NS_DrawRotaStringToHandle(  x,  y,  ExRateX,  ExRateY, RotCenterX, RotCenterY, RotAngle,  GetColor( 255,255,255 ), FontHandle, GetColor( 0,0,0 ), VerticalFlag, String ) ;
	DrawZBuffer_Post();

	// I
	return 0;
}

// tHgnhgpĂyobt@ɑ΂ďw蕶ό``悷
extern int DrawModiFormatStringToHandleToZBuffer_VaList( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int FontHandle, int WriteZMode /* DX_ZWRITE_MASK  */ , int VerticalFlag, const TCHAR *FormatString, va_list VaList )
{
	TCHAR String[ 2048 ] ;

	_TVSNPRINTF( String, sizeof( String ) / sizeof( TCHAR ), FormatString, VaList ) ;

	DrawZBuffer_Pre( WriteZMode ) ;
	NS_DrawModiStringToHandle(  x1, y1, x2, y2, x3, y3, x4, y4,  GetColor( 255,255,255 ), FontHandle, GetColor( 0,0,0 ), VerticalFlag, String ) ;
	DrawZBuffer_Post();

	// I
	return 0;
}

#endif // DX_NON_FONT
























// {C[W`

// {C[Wf[^`悷
extern	int		NS_DrawBaseImage( int x, int y, BASEIMAGE *BaseImage )
{
	int TempHandle ;

/*
	if( NS_GetActiveGraph() == DX_SCREEN_BACK )
	{
		DWORD Pitch;
		int Width, Height;
		void *Image;
		COLORDATA *ColorData;
		BASEIMAGE DestImage;

		NS_GetDrawScreenSize( &Width, &Height ) ;

		NS_GraphLock( DX_SCREEN_BACK, (int *)&Pitch, &Image, &ColorData ) ;
		DestImage.ColorData = *ColorData;
		DestImage.Width     = Width;
		DestImage.Height    = Height;
		DestImage.Pitch     = Pitch;
		DestImage.GraphData = Image;

		NS_BltBaseImage( 0, 0, BaseImage->Width, BaseImage->Height, x, y, BaseImage, &DestImage ) ;

		NS_GraphUnLock( DX_SCREEN_BACK ) ;
	}
	else
*/
	{
		TempHandle = Graphics_Image_CreateGraphFromGraphImageBase( BaseImage, NULL, TRUE, FALSE ) ;
		NS_DrawGraph( x, y, TempHandle, BaseImage->ColorData.AlphaWidth ? TRUE : FALSE ) ;
		NS_DeleteGraph( TempHandle, FALSE ) ;
	}

	return 0 ;
}




















// {C[Wf[^\̊֌W

// `Ώۂ̉ʂẅ̃OtBbN{C[Wf[^ɓ]
extern int NS_GetDrawScreenBaseImage( int x1, int y1, int x2, int y2, BASEIMAGE *BaseImage )
{
	return NS_GetDrawScreenBaseImageDestPos( x1, y1, x2, y2, BaseImage, 0, 0 ) ;
}

// `Ώۂ̉ʂẅ{C[Wf[^ɓ]( ]Ww )
extern	int NS_GetDrawScreenBaseImageDestPos( int x1, int y1, int x2, int y2, BASEIMAGE *BaseImage, int DestX, int DestY )
{
	RECT SrcRect ;
	BASEIMAGE BufferImage ;

	// W`FbN
	if( x1 < 0 || y1 < 0 || x1 >= x2 || y1 >= y2 )
	{
		return -1 ;
	}

	// 荞݃TCYƎ荞ݐ悪摜TCY傫ꍇ̓G[
	if( BaseImage->Width < DestX + x2 - x1 || BaseImage->Height < DestY + y2 - y1 )
	{
		return -1 ;
	}

	// `obt@bN
	SrcRect.left   = x1 ;
	SrcRect.right  = x2 ;
	SrcRect.top    = y1 ;
	SrcRect.bottom = y2 ;
	if( Graphics_Screen_LockDrawScreen( &SrcRect, &BufferImage, -1, -1, -1, TRUE, 0 ) < 0 )
	{
		return -1 ;
	}

//	// 荞݃TCYƉ摜TCYႤꍇ̓G[
//	if( BaseImage->Width != BufferImage.Width || BaseImage->Height != BufferImage.Height ) return -1 ;

	// f[^]
	NS_BltBaseImage2( DestX, DestY, &BufferImage, BaseImage ) ;

	// `obt@AbN
	Graphics_Screen_UnlockDrawScreen() ;

	// I
	return 0 ;
}























// OtBbN֘Ȁƌn

// OtBbNXVXȅ
extern int Graphics_Initialize( void )
{
	// ɏς݂̏ꍇ͉Ȃ
	if( GSYS.InitializeFlag == TRUE ) return 0 ;

	// ʂ̐ݒ
	if( GSYS.Screen.MainScreenSizeX == 0 || GSYS.Screen.MainScreenSizeY == 0 )
	{
		Graphics_Screen_SetMainScreenSize( DEFAULT_SCREEN_SIZE_X, DEFAULT_SCREEN_SIZE_Y ) ;
	}

	// SetUserScreenImage gpĂꍇ̓J[rbg[x킹
	if( GSYS.Screen.UserScreenImage != NULL )
	{
		if( GSYS.Screen.UserScreenImagePixelFormat == DX_USER_SCREEN_PIXEL_FORMAT_R5G6B5 ||
			GSYS.Screen.UserScreenImagePixelFormat == DX_USER_SCREEN_PIXEL_FORMAT_R5G5B5X1 ||
			GSYS.Screen.UserScreenImagePixelFormat == DX_USER_SCREEN_PIXEL_FORMAT_X1R5G5B5 )
		{
			GSYS.Screen.MainScreenColorBitDepth = 16 ;
		}
		else
		{
			GSYS.Screen.MainScreenColorBitDepth = 32 ;
		}
	}

	// J[rbg[xݒ肳ĂȂftHglݒ肷
	if( GSYS.Screen.MainScreenColorBitDepth == 0 )
	{
		GSYS.Screen.MainScreenColorBitDepth = DEFAULT_COLOR_BITDEPTH ;
		SetMemImgDefaultColorType( 0 ) ;
	}

	// OtBbNnhǗ̏
	InitializeHandleManage( DX_HANDLETYPE_GRAPH, sizeof( IMAGEDATA ), MAX_IMAGE_NUM, Graphics_Image_InitializeHandle, Graphics_Image_TerminateHandle, L"Graph" ) ;

	// VF[_[nhǗ̏
	InitializeHandleManage( DX_HANDLETYPE_SHADER, sizeof( SHADERHANDLEDATA ) + sizeof( SHADERHANDLEDATA_PF ) , MAX_SHADER_NUM, Graphics_Shader_InitializeHandle, Graphics_Shader_TerminateHandle, L"Shader" ) ;

	// VF[_[p萔obt@nhǗ̏
	InitializeHandleManage( DX_HANDLETYPE_SHADER_CONSTANT_BUFFER, sizeof( SHADERCONSTANTBUFFERHANDLEDATA ) + sizeof( SHADERCONSTANTBUFFERHANDLEDATA_PF ) , MAX_CONSTANT_BUFFER_NUM, Graphics_ShaderConstantBuffer_InitializeHandle, Graphics_ShaderConstantBuffer_TerminateHandle, L"ShaderConstantBuffer" ) ;

	// _obt@nhǗ̏
	InitializeHandleManage( DX_HANDLETYPE_VERTEX_BUFFER, sizeof( VERTEXBUFFERHANDLEDATA ) + sizeof( VERTEXBUFFERHANDLEDATA_PF ), MAX_VERTEX_BUFFER_NUM, Graphics_VertexBuffer_InitializeHandle, Graphics_VertexBuffer_TerminateHandle, L"VertexBuffer" ) ;

	// CfbNXobt@nhǗ̏
	InitializeHandleManage( DX_HANDLETYPE_INDEX_BUFFER, sizeof( INDEXBUFFERHANDLEDATA ) + sizeof( INDEXBUFFERHANDLEDATA_PF ), MAX_INDEX_BUFFER_NUM, Graphics_IndexBuffer_InitializeHandle, Graphics_IndexBuffer_TerminateHandle, L"IndexBuffer" ) ;

	// VhE}bvnhǗ̏
	InitializeHandleManage( DX_HANDLETYPE_SHADOWMAP, sizeof( SHADOWMAPDATA ) + sizeof( SHADOWMAPDATA_PF ), MAX_SHADOWMAP_NUM, Graphics_ShadowMap_InitializeHandle, Graphics_ShadowMap_TerminateHandle, L"ShadowMap" ) ;

	// `揈̊ˑ̏̂P
	if( Graphics_Initialize_Timing0_PF() < 0 )
	{
		goto ERR ;
	}

	// ς݃tO𗧂Ă
	GSYS.InitializeFlag = TRUE ;

	// n[hEGAANZ[^gpłꍇ
	// n[hEGAANZ[^̏s
	if( GSYS.Setting.ValidHardware == TRUE )
	{
		Graphics_Hardware_Initialize_PF() ;

		// SetUserScreenImage ŉʂݒ肳ĂāAsNZtH[}bg
		// \tgEFA_O[hɑΉĂꍇ̓\tgEFA_Ȍs
		if( GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode )
		{
			Graphics_Software_Initialize() ;
		}
	}
	else
	// ȊȌꍇ̓\tgEGA_Ȍs
	{
		Graphics_Software_Initialize() ;
	}

	// OtBbN`ݒ֌W̏
	Graphics_DrawSetting_Initialize() ;

	// MEMIMG ̏
	InitializeMemImgManage() ;

#ifndef DX_NON_FONT
	// tHg̏s
	InitFontManage() ;
#endif

#ifndef DX_NON_MASK
	// }XN̏
	Mask_Initialize() ;
#endif

	// `揈̊ˑ̏̂Q
	if( Graphics_Initialize_Timing1_PF() < 0 )
	{
		goto ERR ;
	}

	// GetFPS ̒l̈艻ׂ̈ScreenFlip6قǎs
	{
		int i ;
		for( i = 0 ; i < 6 ; i ++ )
		{
			NS_ClearDrawScreen( NULL ) ;

			// ܂cwCȕIĂȂ̂Ŋˑ֐𒼐ڌĂ
			GSYS.Screen.ScreenFlipFlag = TRUE ;
			Graphics_ScreenFlipBase_PF() ;
			GSYS.Screen.ScreenFlipFlag = FALSE ;

			// ScreenFlip Ă΂ꂽԂۑ
			Graphics_Screen_UpdateFlipTime() ;
		}
	}

	// I
	return 0 ;

	// G[
ERR:
	Graphics_Terminate() ;

	return -1;
}

// OtBbNVXěn
extern int Graphics_Terminate( void )
{
#ifndef DX_NON_FONT
	// tHgLbV̊ǗnI
	TermFontManage() ;
#endif

	// Ɍnς݂̏ꍇ͉Ȃ
	if( GSYS.InitializeFlag == FALSE ) return 0 ;

	// ntO𗧂Ă
	GSYS.TerminateNowFlag = TRUE ;

#ifndef DX_NON_MASK
	// }XŇn
	Mask_Terminate() ;
#endif

#ifndef DX_NON_MODEL
	// ׂẴf폜
	NS_MV1InitModel() ;
	MV1InitModelBase() ;
#endif

#ifndef DX_NON_LIVE2D_CUBISM4
	// ׂĂLive2Df폜
	NS_Live2D_InitModel() ;
#endif

	// SẲ摜폜
	NS_InitGraph( FALSE ) ;

	// ׂĂ̒_f[^ƃCfbNXf[^폜
	NS_InitVertexBuffer() ;
	NS_InitIndexBuffer() ;

	// SẴVF[_[p萔obt@폜
	NS_InitShaderConstantBuffer() ;

	// SẴVF[_[폜
	NS_InitShader() ;

	// CgSč폜
	NS_DeleteLightHandleAll() ;
	NS_DeleteLightHandle( GSYS.Light.DefaultHandle ) ;
	GSYS.Light.DefaultHandle = -1 ;

	// \tgEGA_O@\̌n
	Graphics_Software_Terminate() ;

	// `揈̊ˑ̌n
	Graphics_Terminate_PF() ;

	// _ꎞIɕۑ郁̈̉
	if( GSYS.Resource.TempVertexBuffer )
	{
		DXFREE( GSYS.Resource.TempVertexBuffer ) ;
		GSYS.Resource.TempVertexBuffer = NULL ;
		GSYS.Resource.TempVertexBufferSize = 0 ;
	}

	// DrawCubeSet3Dp̒_ꎞIɕۑ郁̈̉
	{
		int i ;
		for( i = 0 ; i < 2 ; i ++ )
		{
			if( GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ i ] )
			{
				DXFREE( GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ i ] ) ;
				GSYS.Resource.DrawCubeSet3DWorkVertexBuffer[ i ] = NULL ;
			}
		}
		for( i = 0 ; i < 3 ; i ++ )
		{
			if( GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ i ] )
			{
				DXFREE( GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ i ] ) ;
				GSYS.Resource.DrawCubeSet3DWorkIndexBuffer[ i ] = NULL ;
			}
		}
	}

	// VhE}bvnhǗ̌n
	TerminateHandleManage( DX_HANDLETYPE_SHADOWMAP ) ;

	// _obt@nhǗ̌n
	TerminateHandleManage( DX_HANDLETYPE_VERTEX_BUFFER ) ;

	// CfbNXobt@nhǗ̌n
	TerminateHandleManage( DX_HANDLETYPE_INDEX_BUFFER ) ;

	// VF[_[nhǗ̌n
	TerminateHandleManage( DX_HANDLETYPE_SHADER ) ;

	// VF[_[p萔obt@nhǗ̌n
	TerminateHandleManage( DX_HANDLETYPE_SHADER_CONSTANT_BUFFER ) ;

	// OtBbNnhǗ̌n
	TerminateHandleManage( DX_HANDLETYPE_GRAPH ) ;

	// ėpobt@̉
	Graphics_Other_TerminateCommonBuffer() ;

	// ntO|
	GSYS.TerminateNowFlag = FALSE ;

	// ς݃tO|
	GSYS.InitializeFlag = FALSE ;

	// I
	return 0 ;
}

// OtBbNXVXe̕AA͕ύXt̍ăZbgAbvs
extern int Graphics_RestoreOrChangeSetupGraphSystem( int Change, int ScreenSizeX, int ScreenSizeY, int ColorBitDepth, int RefreshRate )
{
	int Result ;

	// ˑ̏s
	Result = Graphics_RestoreOrChangeSetupGraphSystem_PF( Change, ScreenSizeX, ScreenSizeY, ColorBitDepth, RefreshRate ) ;

	// [r[OtBbN̍Đ
	if( DxSysData.NotDrawFlag == FALSE )
	{
#ifndef DX_NON_MOVIE
		RestoreMovieAll() ;
#endif
	}


	// I
	return Result ;
}























// ʊ֌W֐

// tXN[[h̃[h̃`FbNgp𑜓x̌s
extern	int		Graphics_Screen_SetupFullScreenModeInfo( void )
{
	int             DispModeNum ;
	int             i ;
	int				IntMulNum ;
	int             ColorBitDepthResolutionMatchIndex ;
	int             ColorBitDepthResolutionMatchIntMulNum ;
	int             ResolutionMatchIndex ;
	int             ResolutionMatchIntMulNum ;
	int             RefreshRateColorBitDepthResolutionMatchIndex ;
	int             RefreshRateColorBitDepthResolutionMatchIntMulNum ;
	DISPLAYMODEDATA DispModeData = { 0 } ;
	int				UseDisplayIndex ;

	// ʉ𑜓xݒ肳ĂȂftHglZbg
	if( GSYS.Screen.MainScreenSizeX == 0 || GSYS.Screen.MainScreenSizeY == 0 )
	{
		Graphics_Screen_SetMainScreenSize( DEFAULT_SCREEN_SIZE_X, DEFAULT_SCREEN_SIZE_Y ) ;
	}

	// ʏ񂪃ZbgAbvĂȂZbgAbv
	if( GSYS.Screen.DisplayInfo == NULL )
	{
		Graphics_SetupDisplayInfo_PF() ;
	}

	// gpfBXvCԍ
	UseDisplayIndex = GSYS.Screen.ValidUseDisplayIndex ? GSYS.Screen.UseDisplayIndex : GSYS.Screen.PrimaryDisplayIndex ;

	// ʂ̃J[rbg[xݒ肳ĂȂftHglZbg
	if( GSYS.Screen.MainScreenColorBitDepth == 0 )
	{
		GSYS.Screen.MainScreenColorBitDepth = DEFAULT_COLOR_BITDEPTH ;
		SetMemImgDefaultColorType( 0 ) ;
	}

	GSYS.Screen.FullScreenResolutionModeAct = GSYS.Screen.FullScreenResolutionMode ;

LABEL_FULLSCREENMODE_SWITCH :
	switch( GSYS.Screen.FullScreenResolutionModeAct )
	{
	case DX_FSRESOLUTIONMODE_NATIVE :
		// w̉ʃ[hɑΉĂ邩ׂ
		DispModeNum = NS_GetDisplayModeNum( UseDisplayIndex ) ;
		ResolutionMatchIndex                               = -1 ;
		ResolutionMatchIntMulNum                           = -1 ;
		ColorBitDepthResolutionMatchIndex                  = -1 ;
		ColorBitDepthResolutionMatchIntMulNum              = -1 ;
		RefreshRateColorBitDepthResolutionMatchIndex       = -1 ;
		RefreshRateColorBitDepthResolutionMatchIntMulNum   = -1 ;
		for( i = 0 ; i < DispModeNum ; i ++ )
		{
			DispModeData = NS_GetDisplayMode( i, UseDisplayIndex ) ;

			// w̉𑜓xƈvĂ邩AႵ͎w̉𑜓x̐{̉𑜓xǂŕ
			if( DispModeData.Width  % GSYS.Screen.MainScreenSizeX == 0 &&
				DispModeData.Height % GSYS.Screen.MainScreenSizeY == 0 &&
				( DispModeData.Width  / GSYS.Screen.MainScreenSizeX == DispModeData.Height / GSYS.Screen.MainScreenSizeY ) )
			{
				// w̉𑜓x̉{Zo
				IntMulNum = DispModeData.Width  / GSYS.Screen.MainScreenSizeX ;

				// ŏɌʃ[hAႵ͍܂Ōʃ[h𑜓x{ꍇ͋L
				if( ResolutionMatchIntMulNum < 0 || IntMulNum < ResolutionMatchIntMulNum )
				{
					ResolutionMatchIndex     = i ;
					ResolutionMatchIntMulNum = IntMulNum ;
				}

				// w̃J[rbg[xƈvĂ邩ǂŕ
				if( GSYS.Screen.MainScreenColorBitDepth == DispModeData.ColorBitDepth )
				{
					// ŏɌʃ[hAႵ͍܂Ōʃ[h𑜓x{ꍇ͋L
					if( ColorBitDepthResolutionMatchIntMulNum < 0 || IntMulNum < ColorBitDepthResolutionMatchIntMulNum )
					{
						ColorBitDepthResolutionMatchIndex     = i ;
						ColorBitDepthResolutionMatchIntMulNum = IntMulNum ;
					}

					// tbV[g̎w肪Aw̃tbV[gƈvĂ邩ǂŕ
					if( GSYS.Screen.MainScreenRefreshRate == 0 ||
						GSYS.Screen.MainScreenRefreshRate == DispModeData.RefreshRate )
					{
						// ŏɌʃ[hAႵ͍܂Ōʃ[h𑜓x{ꍇ͋L
						if( RefreshRateColorBitDepthResolutionMatchIntMulNum < 0 || IntMulNum < RefreshRateColorBitDepthResolutionMatchIntMulNum )
						{
							RefreshRateColorBitDepthResolutionMatchIndex     = i ;
							RefreshRateColorBitDepthResolutionMatchIntMulNum = IntMulNum ;

							// 𑜓x{P̂Ƃ́Aw̉ʃ[hɊSɈvĂƂƂȂ̂ŁA[v甲
							if( IntMulNum == 1 )
							{
								break ;
							}
						}
					}
				}
			}
		}

		// 𑜓xwʂAႵ͐{ŁAtbV[gEJ[rbg[xw̒ʂ̉ʃ[hꍇ́Aɂ
		if( RefreshRateColorBitDepthResolutionMatchIndex != -1 )
		{
			GSYS.Screen.FullScreenUseDispModeData = NS_GetDisplayMode( RefreshRateColorBitDepthResolutionMatchIndex, UseDisplayIndex ) ;
		}
		else
		// 𑜓xwʂAႵ͐{ŁAJ[rbg[xwʂ̉ʃ[hꍇ́Aɂ
		if( ColorBitDepthResolutionMatchIndex != -1 )
		{
			GSYS.Screen.FullScreenUseDispModeData = NS_GetDisplayMode( ColorBitDepthResolutionMatchIndex, UseDisplayIndex ) ;
		}
		else
		// 𑜓xwʂAႵ͐{̉ʃ[hꍇ́Aɂ
		if( ResolutionMatchIndex != -1 )
		{
			GSYS.Screen.FullScreenUseDispModeData = NS_GetDisplayMode( ResolutionMatchIndex, UseDisplayIndex ) ;
		}
		else
		// 𑜓xwʂAႵ͐{̉ʃ[hꍇ̓tXN[𑜓x[h DX_FSRESOLUTIONMODE_DESKTOP ɕύX
		{
			GSYS.Screen.FullScreenResolutionModeAct = DX_FSRESOLUTIONMODE_DESKTOP ;
			goto LABEL_FULLSCREENMODE_SWITCH ;
		}

		// ʃ[hwɊSvĂȂꍇ́AtXN[𑜓x[h DX_FSRESOLUTIONMODE_MAXIMUM ɂ
		if( RefreshRateColorBitDepthResolutionMatchIndex == -1 || 
			RefreshRateColorBitDepthResolutionMatchIntMulNum != 1 )
		{
			GSYS.Screen.FullScreenResolutionModeAct = DX_FSRESOLUTIONMODE_MAXIMUM ;
		}
		break ;

	case DX_FSRESOLUTIONMODE_DESKTOP :
		if( GSYS.Screen.DisplayInfo == NULL )
		{
			// fBXvC̎擾Ɏs DX_FSRESOLUTIONMODE_MAXIMUM gp
			if( Graphics_SetupDisplayInfo_PF() < 0 )
			{
				GSYS.Screen.FullScreenResolutionModeAct = DX_FSRESOLUTIONMODE_MAXIMUM ;
				goto LABEL_FULLSCREENMODE_SWITCH ;
			}
		}

		// w̉𑜓xfXNgbvʂ荂ꍇ DX_FSRESOLUTIONMODE_MAXIMUM ɕύX
		if( GSYS.Screen.DisplayInfo[ UseDisplayIndex ].DesktopSizeX < GSYS.Screen.MainScreenSizeX ||
			GSYS.Screen.DisplayInfo[ UseDisplayIndex ].DesktopSizeY < GSYS.Screen.MainScreenSizeY )
		{
			GSYS.Screen.FullScreenResolutionModeAct = DX_FSRESOLUTIONMODE_MAXIMUM ;
			goto LABEL_FULLSCREENMODE_SWITCH ;
		}

		// fXNgbṽTCYZbg
		GSYS.Screen.FullScreenUseDispModeData.Width         = GSYS.Screen.DisplayInfo[ UseDisplayIndex ].DesktopSizeX ;
		GSYS.Screen.FullScreenUseDispModeData.Height        = GSYS.Screen.DisplayInfo[ UseDisplayIndex ].DesktopSizeY ;
		GSYS.Screen.FullScreenUseDispModeData.ColorBitDepth = GSYS.Screen.DisplayInfo[ UseDisplayIndex ].DesktopColorBitDepth ;
		GSYS.Screen.FullScreenUseDispModeData.RefreshRate   = GSYS.Screen.DisplayInfo[ UseDisplayIndex ].DesktopRefreshRate ;
		break ;

	case DX_FSRESOLUTIONMODE_MAXIMUM :
		// ő𑜓x擾
		{
			int MatchDispModeIndex ;
			int MatchDispModeWidth ;
			int MatchDispModeHeight ;
			int MaxResDispModeIndex ;
			int MaxResDispModeWidth ;
			int MaxResDispModeHeight ;
			int MaxResFullColorDispModeIndex ;
			int MaxResFullColorDispModeWidth ;
			int MaxResFullColorDispModeHeight ;

			MatchDispModeIndex            = -1 ;
			MaxResDispModeIndex           = -1 ;
			MaxResFullColorDispModeIndex  = -1 ;
			MatchDispModeWidth            = 0 ;
			MatchDispModeHeight           = 0 ;
			MaxResDispModeWidth           = 0 ;
			MaxResDispModeHeight          = 0 ;
			MaxResFullColorDispModeWidth  = 0 ;
			MaxResFullColorDispModeHeight = 0 ;

			DispModeNum = NS_GetDisplayModeNum( 0 ) ;
			for( i = 0 ; i < DispModeNum ; i ++ )
			{
				DispModeData = NS_GetDisplayMode( i, UseDisplayIndex ) ;

				if(   GSYS.Screen.MainScreenColorBitDepth == DispModeData.ColorBitDepth &&
					( GSYS.Screen.MainScreenRefreshRate == 0 ||
					  GSYS.Screen.MainScreenRefreshRate == DispModeData.RefreshRate ) && 
					( MatchDispModeIndex == -1 ||
					DispModeData.Width * DispModeData.Height > MatchDispModeWidth * MatchDispModeHeight ) )
				{
					MatchDispModeIndex = i ;
					MatchDispModeWidth  = DispModeData.Width ;
					MatchDispModeHeight = DispModeData.Height ;
				}

				if( MaxResDispModeIndex == -1 ||
					DispModeData.Width * DispModeData.Height > MaxResDispModeWidth * MaxResDispModeHeight )
				{
					MaxResDispModeIndex = i ;
					MaxResDispModeWidth  = DispModeData.Width ;
					MaxResDispModeHeight = DispModeData.Height ;
				}

				if( DispModeData.ColorBitDepth == GSYS.Screen.MainScreenColorBitDepth &&
					( MaxResFullColorDispModeIndex == -1 ||
					DispModeData.Width * DispModeData.Height > MaxResFullColorDispModeWidth * MaxResFullColorDispModeHeight ) )
				{
					MaxResFullColorDispModeIndex = i ;
					MaxResFullColorDispModeWidth  = DispModeData.Width ;
					MaxResFullColorDispModeHeight = DispModeData.Height ;
				}
			}

			if( MaxResDispModeWidth * MaxResDispModeHeight <= MaxResFullColorDispModeWidth * MaxResFullColorDispModeHeight )
			{
				GSYS.Screen.FullScreenUseDispModeData = NS_GetDisplayMode( MaxResFullColorDispModeIndex, UseDisplayIndex ) ;
			}
			else
			if( MaxResDispModeWidth * MaxResDispModeHeight <= MatchDispModeWidth * MatchDispModeHeight )
			{
				GSYS.Screen.FullScreenUseDispModeData = NS_GetDisplayMode( MatchDispModeIndex, UseDisplayIndex ) ;
			}
			else
			if( MaxResDispModeIndex > 0 )
			{
				GSYS.Screen.FullScreenUseDispModeData = NS_GetDisplayMode( MaxResDispModeIndex, UseDisplayIndex ) ;
			}
			else
			{
				GSYS.Screen.FullScreenUseDispModeData = NS_GetDisplayMode( 0, UseDisplayIndex ) ;
			}
		}
		break ;
	}

	// I
	return 0 ;
}

// GSYS.Screen.FullScreenScalingDestRect ̒lZbgAbv
extern	int		Graphics_Screen_SetupFullScreenScalingDestRect( void )
{
	// DX_FSRESOLUTIONMODE_NATIVE ȊȌꍇ͂œ]`̎Zo
	switch( GSYS.Screen.FullScreenResolutionModeAct )
	{
	case DX_FSRESOLUTIONMODE_NATIVE :
		break ;

	case DX_FSRESOLUTIONMODE_MAXIMUM :
	case DX_FSRESOLUTIONMODE_DESKTOP :
		// TuobNobt@̓esNZ̏cPFPɕۂobNobt@ɍő܂Ŋg債ē]`̎Zo
		{
			int DestSizeX ;
			int DestSizeY ;
			int ScalingSizeX ;
			int ScalingSizeY ;
			static int DestSizeXBackup = -1000 ;
			static int DestSizeYBackup = -1000 ;
			static int ScalingSizeXBackup = -1000 ;
			static int ScalingSizeYBackup = -1000 ;
			static int MainScreenSizeXBackup = -1000 ;
			static int MainScreenSizeYBackup = -1000 ;

			// ]̃TCYZbg
			if( GSYS.Screen.FullScreenResolutionModeAct == DX_FSRESOLUTIONMODE_DESKTOP )
			{
				GRAPHICSSYS_DISPLAYINFO *DisplayInfo ;

				if( GSYS.Screen.DisplayInfo == NULL )
				{
					return -1 ;
				}

				DisplayInfo = &GSYS.Screen.DisplayInfo[ GSYS.Screen.ValidUseDisplayIndex ? GSYS.Screen.UseDisplayIndex : GSYS.Screen.PrimaryDisplayIndex ] ;
				DestSizeX = DisplayInfo->DesktopSizeX ;
				DestSizeY = DisplayInfo->DesktopSizeY ;

				if( DestSizeXBackup != DestSizeX || DestSizeYBackup != DestSizeY )
				{
					DestSizeXBackup = DestSizeX ;
					DestSizeYBackup = DestSizeY ;
//					DXST_LOGFILEFMT_ADDUTF16LE(( "\x11\xff\x20\x00\x20\x00\x44\x00\x65\x00\x73\x00\x74\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x58\x00\x3a\x00\x25\x00\x64\x00\x20\x00\x20\x00\x44\x00\x65\x00\x73\x00\x74\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x59\x00\x3a\x00\x25\x00\x64\x00\x00"/*@ L"P  DestSizeX:%d  DestSizeY:%d" @*/, DestSizeX, DestSizeY )) ;
				}
			}
			else
			{
				DestSizeX = GSYS.Screen.FullScreenUseDispModeData.Width ;
				DestSizeY = GSYS.Screen.FullScreenUseDispModeData.Height ;

				if( DestSizeXBackup != DestSizeX || DestSizeYBackup != DestSizeY )
				{
					DestSizeXBackup = DestSizeX ;
					DestSizeYBackup = DestSizeY ;
//					DXST_LOGFILEFMT_ADDUTF16LE(( "\x12\xff\x20\x00\x20\x00\x44\x00\x65\x00\x73\x00\x74\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x58\x00\x3a\x00\x25\x00\x64\x00\x20\x00\x20\x00\x44\x00\x65\x00\x73\x00\x74\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x59\x00\x3a\x00\x25\x00\x64\x00\x00"/*@ L"Q  DestSizeX:%d  DestSizeY:%d" @*/, DestSizeX, DestSizeY )) ;
				}
			}

			// ]̃TCY
			ScalingSizeX = DestSizeY * GSYS.Screen.MainScreenSizeX / GSYS.Screen.MainScreenSizeY ;
			if( ScalingSizeX < DestSizeX )
			{
				ScalingSizeY = DestSizeY ;
			}
			else
			{
				ScalingSizeX = DestSizeX ;
				ScalingSizeY = DestSizeX * GSYS.Screen.MainScreenSizeY / GSYS.Screen.MainScreenSizeX ;
			}

			if( ScalingSizeXBackup != ScalingSizeX ||
				ScalingSizeYBackup != ScalingSizeY ||
				MainScreenSizeXBackup != GSYS.Screen.MainScreenSizeX ||
				MainScreenSizeYBackup != GSYS.Screen.MainScreenSizeY )
			{
				ScalingSizeXBackup = ScalingSizeX ;
				ScalingSizeYBackup = ScalingSizeY ;
				MainScreenSizeXBackup = GSYS.Screen.MainScreenSizeX ;
				MainScreenSizeYBackup = GSYS.Screen.MainScreenSizeY ;
//				DXST_LOGFILEFMT_ADDUTF16LE(( "\x53\x00\x63\x00\x61\x00\x6c\x00\x69\x00\x6e\x00\x67\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x58\x00\x3a\x00\x25\x00\x64\x00\x00\x30\x53\x00\x63\x00\x61\x00\x6c\x00\x69\x00\x6e\x00\x67\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x59\x00\x3a\x00\x25\x00\x64\x00\x20\x00\x20\x00\x4d\x00\x61\x00\x69\x00\x6e\x00\x53\x00\x63\x00\x72\x00\x65\x00\x65\x00\x6e\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x58\x00\x3a\x00\x25\x00\x64\x00\x20\x00\x20\x00\x4d\x00\x61\x00\x69\x00\x6e\x00\x53\x00\x63\x00\x72\x00\x65\x00\x65\x00\x6e\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x59\x00\x3a\x00\x25\x00\x64\x00\x00"/*@ L"ScalingSizeX:%d@ScalingSizeY:%d  MainScreenSizeX:%d  MainScreenSizeY:%d" @*/,
//					ScalingSizeX, ScalingSizeY,
//					GSYS.Screen.MainScreenSizeX, GSYS.Screen.MainScreenSizeY )) ;
			}

			// ]̋`
			GSYS.Screen.FullScreenScalingDestRect.left   = ( DestSizeX - ScalingSizeX ) / 2 ;
			GSYS.Screen.FullScreenScalingDestRect.top    = ( DestSizeY - ScalingSizeY ) / 2 ;
			GSYS.Screen.FullScreenScalingDestRect.right  = GSYS.Screen.FullScreenScalingDestRect.left + ScalingSizeX ;
			GSYS.Screen.FullScreenScalingDestRect.bottom = GSYS.Screen.FullScreenScalingDestRect.top  + ScalingSizeY ;
		}
		break ;
	}

	// I
	return 0 ;
}

// XN[WTuobNobt@[Wɕϊ
extern int Graphics_Screen_ScreenPosConvSubBackbufferPos( int ScreenPosX, int ScreenPosY, int *BackBufferPosX, int *BackBufferPosY )
{
	ScreenPosX -= GSYS.Screen.FullScreenDesktopRect.left ;
	ScreenPosY -= GSYS.Screen.FullScreenDesktopRect.top ;

	switch( GSYS.Screen.FullScreenResolutionModeAct )
	{
	case DX_FSRESOLUTIONMODE_NATIVE :
		if( BackBufferPosX != NULL )
		{
			*BackBufferPosX = ScreenPosX ;
		}

		if( BackBufferPosY != NULL )
		{
			*BackBufferPosY = ScreenPosY ;
		}
		break ;

	case DX_FSRESOLUTIONMODE_MAXIMUM :
	case DX_FSRESOLUTIONMODE_DESKTOP :
		if( Graphics_Screen_SetupFullScreenScalingDestRect() < 0 )
		{
			return -1 ;
		}

		if( BackBufferPosX != NULL )
		{
			*BackBufferPosX = ( ScreenPosX - GSYS.Screen.FullScreenScalingDestRect.left ) * GSYS.Screen.MainScreenSizeX / ( GSYS.Screen.FullScreenScalingDestRect.right  - GSYS.Screen.FullScreenScalingDestRect.left ) ;
		}

		if( BackBufferPosY != NULL )
		{
			*BackBufferPosY = ( ScreenPosY - GSYS.Screen.FullScreenScalingDestRect.top  ) * GSYS.Screen.MainScreenSizeY / ( GSYS.Screen.FullScreenScalingDestRect.bottom - GSYS.Screen.FullScreenScalingDestRect.top ) ;
		}
		break ;
	}

	return 0 ;
}

// TuobNobt@[WXN[Wɕϊ
extern int Graphics_Screen_SubBackbufferPosConvScreenPos( int BackBufferPosX, int BackBufferPosY, int *ScreenPosX, int *ScreenPosY )
{
	switch( GSYS.Screen.FullScreenResolutionModeAct )
	{
	case DX_FSRESOLUTIONMODE_NATIVE :
		if( ScreenPosX != NULL )
		{
			*ScreenPosX = BackBufferPosX ;
		}

		if( ScreenPosY != NULL )
		{
			*ScreenPosY = BackBufferPosY ;
		}
		break ;

	case DX_FSRESOLUTIONMODE_MAXIMUM :
	case DX_FSRESOLUTIONMODE_DESKTOP :
		if( Graphics_Screen_SetupFullScreenScalingDestRect() < 0 )
		{
			return -1 ;
		}

		if( ScreenPosX != NULL )
		{
			*ScreenPosX = BackBufferPosX * ( GSYS.Screen.FullScreenScalingDestRect.right  - GSYS.Screen.FullScreenScalingDestRect.left ) / GSYS.Screen.MainScreenSizeX + GSYS.Screen.FullScreenScalingDestRect.left ;
		}

		if( ScreenPosY != NULL )
		{
			*ScreenPosY = BackBufferPosY * ( GSYS.Screen.FullScreenScalingDestRect.bottom - GSYS.Screen.FullScreenScalingDestRect.top  ) / GSYS.Screen.MainScreenSizeY + GSYS.Screen.FullScreenScalingDestRect.top ;
		}
		break ;
	}

	return 0 ;
}

// Cʂ̂yobt@̐ݒύX
extern int Graphics_Screen_SetZBufferMode( int ZBufferSizeX, int ZBufferSizeY, int ZBufferBitDepth )
{
	return Graphics_Hardware_SetZBufferMode_PF( ZBufferSizeX, ZBufferSizeY, ZBufferBitDepth ) ;
}

// ݒɊÂĎgpyobt@Zbg
extern int Graphics_Screen_SetupUseZBuffer( void )
{
	return Graphics_Hardware_SetupUseZBuffer_PF() ;
}

// Cʂ̃TCYlύX
extern void Graphics_Screen_SetMainScreenSize( int SizeX, int SizeY )
{
	GSYS.Screen.MainScreenSizeX = SizeX ;
	GSYS.Screen.MainScreenSizeY = SizeY ;

	GSYS.Screen.MainScreenSizeX_Result = GSYS.Screen.MainScreenSizeX == 0 ? DEFAULT_SCREEN_SIZE_X : GSYS.Screen.MainScreenSizeX ;
	GSYS.Screen.MainScreenSizeY_Result = GSYS.Screen.MainScreenSizeY == 0 ? DEFAULT_SCREEN_SIZE_Y : GSYS.Screen.MainScreenSizeY ;

	SetMathScreenSize( GSYS.Screen.MainScreenSizeX_Result, GSYS.Screen.MainScreenSizeY_Result ) ;
}

// ʃ[h̕ύXQ
extern int Graphics_Screen_ChangeMode( int ScreenSizeX, int ScreenSizeY, int ColorBitDepth, int ChangeWindowFlag, int RefreshRate )
{
	int BackScSizeX, BackScSizeY, BackScColorBitDepth, BackRefreshRate ;
	int Ret = DX_CHANGESCREEN_OK ;
	int InitFlag ;
#ifndef DX_NON_FONT
	wchar_t FontName[ 128 ] ;
	int FontSize     = 0 ;
	int FontThick    = 0 ;
	int FontType     = 0 ;
	int FontCharSet  = 0 ;
	int FontEdgeSize = 0 ;
	int FontItalic   = 0 ;
	int FontSpace    = 0 ;
	int FontUse      = 0 ;
#endif // DX_NON_FONT
	int Result ;
	int i ;

	// Graphics_Screen_ChangeModestO𗧂Ă
	GSYS.Screen.Graphics_Screen_ChangeModeFlag = TRUE ;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// ɏς݂ǂ擾Ă
	InitFlag = GSYS.InitializeFlag ;

	// -1 ͊̒lőp
	if( ScreenSizeX		== -1 ) ScreenSizeX   = GSYS.Screen.MainScreenSizeX ;
	if( ScreenSizeY		== -1 ) ScreenSizeY   = GSYS.Screen.MainScreenSizeY ;
	if( ColorBitDepth	== -1 ) ColorBitDepth = GSYS.Screen.MainScreenColorBitDepth ;
	if( RefreshRate		== -1 ) RefreshRate   = GSYS.Screen.MainScreenRefreshRate ;

	// ȑOƉʃ[hSꍇ͉I
	if( ScreenSizeX      == GSYS.Screen.MainScreenSizeX &&
		ScreenSizeY      == GSYS.Screen.MainScreenSizeY &&
		ColorBitDepth    == GSYS.Screen.MainScreenColorBitDepth &&
		ChangeWindowFlag == FALSE &&
		RefreshRate      == GSYS.Screen.MainScreenRefreshRate )
	{
		goto END ;
	}

	DXST_LOGFILE_ADDUTF16LE( "\x3b\x75\x62\x97\xe2\x30\xfc\x30\xc9\x30\x09\x59\xf4\x66\xe6\x51\x06\x74\x92\x30\x8b\x95\xcb\x59\x57\x30\x7e\x30\x59\x30\x0a\x00\x00"/*@ L"ʃ[hύXJn܂\n" @*/ ) ;
	DXST_LOGFILE_TABADD ;

#ifndef DX_NON_FONT

	// ɏĂtHg̏ƂĂ
	if( InitFlag && NS_CheckFontHandleValid( NS_GetDefaultFontHandle() ) )
	{
		GetFontStateToHandle_WCHAR_T( FontName, &FontSize, &FontThick, DX_DEFAULT_FONT_HANDLE, &FontType, &FontCharSet, &FontEdgeSize, &FontItalic ) ;
		FontSpace = NS_GetFontSpaceToHandle( DX_DEFAULT_FONT_HANDLE ) ;
		FontUse = TRUE ;
	}

#endif // DX_NON_FONT

	// ̉ʃ[h̃p[^ƂĂ
	GSYS.Screen.Graphics_Screen_Change_BackScreenW = GSYS.Screen.MainScreenSizeX ;
	GSYS.Screen.Graphics_Screen_Change_BackScreenH = GSYS.Screen.MainScreenSizeY ;
	BackScSizeX			= GSYS.Screen.MainScreenSizeX ; 
	BackScSizeY			= GSYS.Screen.MainScreenSizeY ;
	BackScColorBitDepth	= GSYS.Screen.MainScreenColorBitDepth ;
	BackRefreshRate		= GSYS.Screen.MainScreenRefreshRate ;

	// cwCȕO͎słȂ
	if( DxSysData.DxLib_RunInitializeFlag == FALSE && DxSysData.DxLib_InitializeFlag == FALSE )
	{
		goto END ;
	}

	// ʃ[hύXɃOtBbNXVXeZbg邩ǂŏ𕪊
	if( GSYS.Setting.ChangeScreenModeNotGraphicsSystemFlag )
	{
		// ZbgȂꍇ

#ifdef WINDOWS_DESKTOP_OS
		// EChE[h̏ꍇ͎w̉𑜓xfXNgbṽTCY𒴂ĂȂǂ𒲂ׂ
		if( NS_GetWindowModeFlag() == TRUE )
		{
			GRAPHICSSYS_DISPLAYINFO *DisplayInfo ;

			// ʏ񂪃ZbgAbvĂȂZbgAbv
			if( GSYS.Screen.DisplayInfo == NULL )
			{
				Graphics_SetupDisplayInfo_PF() ;
			}

			// fBXvC̎w肪ꍇ͎w̃fBXvC̃TCŶ݂`FbN
			if( GSYS.Screen.ValidUseDisplayIndex )
			{
				DisplayInfo = &GSYS.Screen.DisplayInfo[ GSYS.Screen.UseDisplayIndex ] ;
				if( DisplayInfo->DesktopSizeX < ScreenSizeX || DisplayInfo->DesktopSizeY < ScreenSizeY )
				{
					goto END ;
				}
			}
			else
			{
				// Ȃꍇ͑SẴfBXvC̍őTCYƔr
				int MaxWidth = 0, MaxHeight = 0 ;
				for( i = 0 ; i < GSYS.Screen.DisplayNum ; i ++ )
				{
					DisplayInfo = &GSYS.Screen.DisplayInfo[ i ] ;
					if( i == 0 )
					{
						MaxWidth  = DisplayInfo->DesktopSizeX ;
						MaxHeight = DisplayInfo->DesktopSizeY ;
					}
					else
					{
						if( MaxWidth < DisplayInfo->DesktopSizeX )
						{
							MaxWidth = DisplayInfo->DesktopSizeX ;
						}
						if( MaxHeight < DisplayInfo->DesktopSizeY )
						{
							MaxHeight = DisplayInfo->DesktopSizeY ;
						}
					}
				}
				if( ScreenSizeX > MaxWidth || ScreenSizeY > MaxHeight )
				{
					goto END ;
				}
			}
		}
#endif // WINDOWS_DESKTOP_OS

		// `FW
		Graphics_RestoreOrChangeSetupGraphSystem( TRUE, ScreenSizeX, ScreenSizeY, ColorBitDepth, RefreshRate ) ;

		// \tgEGA_ȌꍇŌnƏs
		if( GSYS.Setting.ValidHardware == FALSE || GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode )
		{
			Graphics_Software_Terminate() ;
			Graphics_Software_Initialize() ;
		}

#ifdef WINDOWS_DESKTOP_OS
		// EChEX^CZbg
		if( NS_GetWindowModeFlag() == TRUE )
		{
			SetWindowStyle() ;
		}
#endif // WINDOWS_DESKTOP_OS

		DXST_LOGFILE_TABSUB ;
		DXST_LOGFILE_ADDUTF16LE( "\x3b\x75\x62\x97\xe2\x30\xfc\x30\xc9\x30\x09\x59\xf4\x66\xe6\x51\x06\x74\x6f\x30\x63\x6b\x38\x5e\x6b\x30\x42\x7d\x86\x4e\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"ʃ[hύX͐ɏI܂\n" @*/ ) ;
	}
	else
	// ʃ[h̕ύX̓TuobNobt@̕ύX݂̂ōsꍇ͏𕪊
	if( GSYS.HardInfo.ChangeGraphModeOnlyChangeSubBackbuffer )
	{
		// ׂẲ摜nh폜
		NS_InitGraph( FALSE ) ;

#ifndef DX_NON_FONT
		// ׂẴtHgnh폜
		NS_InitFontToHandle() ;
#endif // DX_NON_FONT

#ifndef DX_NON_MASK
		// ׂẴ}XNnh폜
		NS_InitMask() ;
#endif // DX_NON_MASK

#ifndef DX_NON_MODEL
		// ׂẴfnh폜
		NS_MV1InitModel() ;
#endif // DX_NON_MODEL

#ifndef DX_NON_LIVE2D_CUBISM4
		// ׂĂLive2Dfnh폜
		NS_Live2D_InitModel() ;
#endif // DX_NON_LIVE2D_CUBISM4

#ifndef DX_NON_SOFTIMAGE
		// ׂẴ\tgEGAC[Wnh폜
		NS_InitSoftImage() ;
#endif // DX_NON_SOFTIMAGE

		// ׂĂ̒_f[^ƃCfbNXf[^폜
		NS_InitVertexBuffer() ;
		NS_InitIndexBuffer() ;

		// SẴVF[_[p萔obt@폜
		NS_InitShaderConstantBuffer() ;

		// SẴVF[_[폜
		NS_InitShader() ;

		// CgSč폜
		NS_DeleteLightHandleAll() ;

		// `FW
		Graphics_RestoreOrChangeSetupGraphSystem( TRUE, ScreenSizeX, ScreenSizeY, ColorBitDepth, RefreshRate ) ;

		// \tgEGA_ȌꍇŌnƏs
		if( GSYS.Setting.ValidHardware == FALSE || GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode )
		{
			Graphics_Software_Terminate() ;
			Graphics_Software_Initialize() ;
		}

		// OtBbNXݒ̏
		NS_SetDrawScreen( DX_SCREEN_FRONT ) ;
		NS_SetDrawArea( 0, 0, ScreenSizeX, ScreenSizeY ) ;
		NS_SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 255 ) ;
		NS_SetDrawBright( 255, 255, 255 ) ;
		NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;
		NS_SetBlendGraphParam( -1, 0 ) ;

		DXST_LOGFILE_TABSUB ;
		DXST_LOGFILE_ADDUTF16LE( "\x3b\x75\x62\x97\xe2\x30\xfc\x30\xc9\x30\x09\x59\xf4\x66\xe6\x51\x06\x74\x6f\x30\x63\x6b\x38\x5e\x6b\x30\x42\x7d\x86\x4e\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"ʃ[hύX͐ɏI܂\n" @*/ ) ;
	}
	else
	{
		// Zbgꍇ

		// OtBNXVXȅI
		if( GSYS.InitializeFlag )
		{
			Graphics_Terminate() ;
		}

		// ʃ[h̃Zbg
		Graphics_Screen_SetMainScreenSize( ScreenSizeX, ScreenSizeY ) ;
		GSYS.Screen.FullScreenResolutionModeAct = GSYS.Screen.FullScreenResolutionMode ;
		GSYS.Screen.MainScreenColorBitDepth     = ColorBitDepth ;
		GSYS.Screen.MainScreenRefreshRate       = RefreshRate ;
		SetMemImgDefaultColorType( ColorBitDepth == 32 ? 1 : 0 ) ;

#ifndef DX_NON_FONT
		// ftHgtHg̐ݒZbg
		if( FontUse == TRUE )
		{
			SetDefaultFontState_WCHAR_T( FontName, FontSize, FontThick, FontType, FontCharSet, FontEdgeSize, FontItalic ) ;
			NS_SetFontSpace( FontSpace ) ;
		}
#endif // DX_NON_FONT

		// OtBbNVXe̍ď
		Result = Graphics_Initialize() ;

		// sꍇ̏
		if( Result == -1 )
		{
			// G[ꍇŉʃ[h 320x240 ꍇ
			// [ 320x240 [hŎ
			if( GSYS.Screen.MainScreenSizeX == 320 && GSYS.Screen.MainScreenSizeY == 240 )
			{
				Graphics_Screen_SetMainScreenSize( 640, 480 ) ;
				NS_SetEmulation320x240( TRUE ) ;
				Result = Graphics_Initialize() ;
			}

			// G[ꍇ͌̉ʃ[hɖ߂
			if( Result == -1 )
			{
				Graphics_Screen_SetMainScreenSize( BackScSizeX, BackScSizeY ) ;
				GSYS.Screen.MainScreenColorBitDepth = BackScColorBitDepth ;
				GSYS.Screen.MainScreenRefreshRate   = BackRefreshRate ;
				SetMemImgDefaultColorType( BackScColorBitDepth == 32 ? 1 : 0 ) ;
				if( Graphics_Initialize() == -1 )
				{
					// łʖڂꍇ͂cwCũftHg̉ʃ[hɕύX
					Graphics_Screen_SetMainScreenSize( DEFAULT_SCREEN_SIZE_X, DEFAULT_SCREEN_SIZE_Y ) ;
					GSYS.Screen.MainScreenColorBitDepth = DEFAULT_COLOR_BITDEPTH ;
					GSYS.Screen.MainScreenRefreshRate   = 0 ;
					SetMemImgDefaultColorType( 0 ) ;
					if( Graphics_Initialize() == -1 )
					{
						// łʖڂꍇ640x480 32bit 
						Graphics_Screen_SetMainScreenSize( DEFAULT_SCREEN_SIZE_X, DEFAULT_SCREEN_SIZE_Y ) ;
						GSYS.Screen.MainScreenColorBitDepth = 32 ;
						GSYS.Screen.MainScreenRefreshRate   = 0 ;
						SetMemImgDefaultColorType( 0 ) ;
						if( Graphics_Initialize() == -1 )
						{
							Ret = -1 ;
							DXST_LOGFILE_ADDUTF16LE( "\x88\x4e\x1f\x67\x5b\x30\x6c\x30\x3b\x75\x62\x97\xe2\x30\xfc\x30\xc9\x30\x09\x59\xf4\x66\x0d\x4e\xfd\x80\xfe\x73\x61\x8c\x4c\x30\x77\x8d\x4d\x30\x7e\x30\x57\x30\x5f\x30\x32\x00\x0a\x00\x00"/*@ L"\ʉʃ[hύXs\ۂN܂2\n" @*/ ) ;
							goto END ;
						}
					}
				}
			}
		}

#ifdef WINDOWS_DESKTOP_OS
		// EChEX^CZbg
		if( NS_GetWindowModeFlag() == TRUE /*|| GSYS.Setting.ValidHardware == FALSE*/ )
		{
			SetWindowStyle() ;
		}
#endif // WINDOWS_DESKTOP_OS

		DXST_LOGFILE_TABSUB ;
		DXST_LOGFILE_ADDUTF16LE( "\x3b\x75\x62\x97\xe2\x30\xfc\x30\xc9\x30\x09\x59\xf4\x66\xe6\x51\x06\x74\x6f\x30\x63\x6b\x38\x5e\x6b\x30\x42\x7d\x86\x4e\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"ʃ[hύX͐ɏI܂\n" @*/ ) ;

		// bZ[W
		NS_ProcessMessage() ;

		// `̐ݒ肵Ȃ
		NS_SetRenderTargetToShader( 0, GSYS.DrawSetting.TargetScreen[ 0 ], GSYS.DrawSetting.TargetScreenSurface[ 0 ], GSYS.DrawSetting.TargetScreenMipLevel[ 0 ] ) ;
		for( i = 1 ; i < GSYS.HardInfo.RenderTargetNum ; i ++ )
		{
			NS_SetRenderTargetToShader( i, -1, 0, 0 ) ;
		}
	}

#ifdef WINDOWS_DESKTOP_OS
	// hbOhbv̐ݒ
	RefreshDragFileValidFlag() ;
#endif // WINDOWS_DESKTOP_OS

END:
	// Graphics_Screen_ChangeMode stO|
	GSYS.Screen.Graphics_Screen_ChangeModeFlag = FALSE ;

	// I
	return Ret ;
}

// `obt@bN
extern int Graphics_Screen_LockDrawScreen( RECT *LockRect, BASEIMAGE *BaseImage, int TargetScreen, int TargetScreenSurface, int TargetScreenMipLevel, int ReadOnly, int TargetScreenTextureNo )
{
	IMAGEDATA *TargImage ;
	int TargetScreenWidth ;
	int TargetScreenHeight ;

	// `̉摜f[^AhX擾
	if( TargetScreen == -1 )
	{
		TargetScreen         = GSYS.DrawSetting.TargetScreen[ 0 ] ;
		TargetScreenSurface  = GSYS.DrawSetting.TargetScreenSurface[ 0 ] ;
		TargetScreenMipLevel = GSYS.DrawSetting.TargetScreenMipLevel[ 0 ] ;
	}
	else
	{
		if( TargetScreenSurface == -1 )
		{
			TargetScreenSurface = 0 ;
		}

		if( TargetScreenMipLevel == -1 )
		{
			TargetScreenMipLevel = 0 ;
		}
	}
	if( GRAPHCHKFULL( TargetScreen, TargImage ) )
	{
		TargImage          = NULL ;
		TargetScreenWidth  = GSYS.DrawSetting.DrawSizeX ;
		TargetScreenHeight = GSYS.DrawSetting.DrawSizeY ;
	}
	else
	{
		Graphics_Image_CalcMipSize( TargImage->WidthI, TargImage->HeightI, TargetScreenMipLevel, &TargetScreenWidth, &TargetScreenHeight ) ;
	}

	// `̃f[^sꍇG[
	if( LockRect->left < 0 || LockRect->left >= LockRect->right  ||
		LockRect->top  < 0 || LockRect->top  >= LockRect->bottom ||
		LockRect->right  > TargetScreenWidth ||
		LockRect->bottom > TargetScreenHeight ) return -1 ;

	// n[hEGAgpĂ邩ǂŏ𕪊
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		// n[hEFAANZ[^gpꍇ
		if( Graphics_Hardware_LockDrawScreenBuffer_PF( LockRect, BaseImage, TargetScreen, TargImage, TargetScreenSurface, TargetScreenMipLevel, ReadOnly, TargetScreenTextureNo ) < 0 )
		{
			return -1 ;
		}
	}
	else
	{
		int Width, Height ;

		// \tgEGA_Ȍꍇ

		Width  = LockRect->right  - LockRect->left ;
		Height = LockRect->bottom - LockRect->top ;

		// f[^Zbg
		if( TargImage )
		{
			BaseImage->ColorData = *TargImage->Soft.MemImg.Base->ColorDataP ;
			BaseImage->Pitch     = ( int )TargImage->Soft.MemImg.Base->Pitch ;
			BaseImage->GraphData = ( BYTE * )TargImage->Soft.MemImg.UseImage + BaseImage->ColorData.PixelByte * LockRect->left + BaseImage->Pitch * LockRect->top ;
		}
		else
		{
			BaseImage->ColorData = *GSYS.SoftRender.MainBufferMemImg.Base->ColorDataP ;
			BaseImage->Pitch     = ( int )GSYS.SoftRender.MainBufferMemImg.Base->Pitch ;
			BaseImage->GraphData = ( BYTE * )GSYS.SoftRender.MainBufferMemImg.UseImage + BaseImage->ColorData.PixelByte * LockRect->left + BaseImage->Pitch * LockRect->top ;
		}
		BaseImage->Width          = Width ;
		BaseImage->Height         = Height ;
		BaseImage->MipMapCount    = 0 ;
		BaseImage->GraphDataCount = 0 ;
	}

	// bNtO𗧂Ă
	GSYS.Screen.DrawScreenBufferLockFlag = TRUE ;

	// I
	return 0 ;
}

// `obt@AbN
extern int Graphics_Screen_UnlockDrawScreen( void )
{
	// bNĂȂ牽ɏI
	if( GSYS.Screen.DrawScreenBufferLockFlag == FALSE ) return 0 ;

	// n[hEGAgpĂ邩ǂŏ𕪊
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		Graphics_Hardware_UnlockDrawScreenBuffer_PF() ;
	}
	else
	{
	}

	// bNtO|
	GSYS.Screen.DrawScreenBufferLockFlag = FALSE ;

	return 0 ;
}

// ScreenFlipTime̍XV
static void Graphics_Screen_UpdateFlipTime( void )
{
	// ScreenFlip Ă΂ꂽԂۑ
	GSYS.PerformanceInfo.ScreenFlipTime[ 1 ] = GSYS.PerformanceInfo.ScreenFlipTime[ 0 ] ;
	GSYS.PerformanceInfo.ScreenFlipTime[ 0 ] = NS_GetNowSysPerformanceCount() ;
}

// ʂƕ\ʂ
// \ʂʂ̃XP[Ȍꍇ́ACopyRect ̓Rs[` )
extern int Graphics_Screen_FlipBase( void )
{
	static int EndFlag = FALSE ;
	int Result = 0 ;

	GSYS.Screen.ScreenFlipFlag = TRUE ;

	// tOĂȂɂI
	if( EndFlag )
	{
		goto END ;
	}

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE || DxLib_GetEndRequest() )
	{
		goto ERR ;
	}

	// tXN[}XNsĂꍇ̓}XN`̌ʂ𔽉f
	MASK_FULLSCREEN_MASKUPDATE

#if !defined( DX_NON_LOG ) && !defined( DX_NON_PRINTF_DX )
	// Oo͂sݒ̏ꍇ̂݃Oo͂s
	if( NS_GetLogDrawFlag() )
	{
		int BlendMode, BlendParam, RedBright, GreenBright, BlueBright ;
		RECT DrawRect ;

		BlendMode   = GSYS.DrawSetting.BlendMode ;
		BlendParam  = GSYS.DrawSetting.BlendParam ;
		DrawRect    = GSYS.DrawSetting.DrawArea ;
		RedBright   = GSYS.DrawSetting.DrawBright.Red ;
		GreenBright = GSYS.DrawSetting.DrawBright.Green ;
		BlueBright  = GSYS.DrawSetting.DrawBright.Blue ;

		NS_SetDrawArea( 0, 0, GSYS.Screen.MainScreenSizeX, GSYS.Screen.MainScreenSizeY ) ;

		// `惂[hm[uhɃZbg
		NS_SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0 ) ;

		// PxPOOɃZbg
		NS_SetDrawBright( 255,255,255 ) ;

		// tOĂ
		EndFlag = TRUE ;

		// O`
		DrawLog() ;

		// tO|
		EndFlag = FALSE ;

		// ݒɖ߂
		NS_SetDrawArea( DrawRect.left, DrawRect.top, DrawRect.right, DrawRect.bottom ) ; 
		NS_SetDrawBlendMode( BlendMode, BlendParam ) ;
		NS_SetDrawBright( RedBright, GreenBright, BlueBright ) ;
	}
#endif

	// ˑ
	Result = Graphics_ScreenFlipBase_PF() ;

	// ScreenFlip Ă΂ꂽԂۑ
	Graphics_Screen_UpdateFlipTime() ;

	// `R[񐔂̏
	GSYS.PerformanceInfo.PrevFrameDrawCallCount = GSYS.PerformanceInfo.NowFrameDrawCallCount ;
	GSYS.PerformanceInfo.NowFrameDrawCallCount = 0 ;


END:
	GSYS.Screen.ScreenFlipFlag = FALSE ;

	// I
	return Result ;


ERR:
	GSYS.Screen.ScreenFlipFlag = FALSE ;

	// G[I
	return -1 ;
}




















// 摜֌W֐

// tH[}bgZbgAbv
extern int Graphics_Image_SetupFormatDesc( 
	IMAGEFORMATDESC *Format,
	SETUP_GRAPHHANDLE_GPARAM *GParam,
	int Width,
	int Height,
	int AlphaValidFlag,
	int UsePaletteFlag,
	int PaletteBitDepth,
	int BaseFormat,
	int MipMapCount
)
{
	// tH[}bg
	_MEMSET( Format, 0, sizeof( *Format ) ) ;

	// eNX`tH[}bgǂZbg
	Format->TextureFlag = ( unsigned char )( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ) ;

	// DirectX ǗeNX`ɂȂǂZbg
	Format->UseManagedTextureFlag = ( unsigned char )GParam->UseManagedTextureFlag ;

	// L[u}bvǂZbg
	Format->CubeMapTextureFlag = ( unsigned char )GParam->CubeMapTextureCreateFlag ;

	// jAzũeNX`gp邩ǂZbg
	Format->UseLinearMapTextureFlag = ( unsigned char )GParam->UseLinearMapTextureFlag ;

	// eNX`tH[}bgڎwZbg
	Format->PlatformTextureFormat = ( unsigned char )GParam->PlatformTextureFormat ;

	// {tH[}bg̃Zbg
	Format->BaseFormat = ( unsigned char )BaseFormat ;

	// ~bv}bv̐ۑ
	if( MipMapCount != -1 )
	{
		Format->MipMapCount = ( unsigned char )MipMapCount ;
	}
	else
	{
		if( GParam->MipMapCount == -1 )
		{
			int tx, ty ;

			tx = Width ;
			ty = Height ;
			Format->MipMapCount = 1 ;
			for(;;)
			{
				if( tx == 1 && ty == 1 ) break ;
				Format->MipMapCount ++ ;
				tx /= 2 ;
				ty /= 2 ;
				if( tx == 0 ) tx = 1 ;
				if( ty == 0 ) ty = 1 ;
			}
		}
		else
		{
			Format->MipMapCount = ( unsigned char )( GParam->MipMapCount == 0 ? 1 : GParam->MipMapCount ) ;
		}
	}

	// `\摜ǂŏ𕪊
	if( GParam->DrawValidImageCreateFlag == TRUE )
	{
		// `\ȏꍇ̓At@eXgAuhOtBbN͖ŁA
		// At@`lǂ GSYS.CreateImage.DrawValidAlphaFlag ̒lɏ]
		// {tH[}bg͋I DX_BASEIMAGE_FORMAT_NORMAL
		Format->DrawValidFlag         = TRUE ;
		Format->AlphaChFlag           = ( unsigned char )GParam->DrawValidAlphaImageCreateFlag ;
		Format->AlphaTestFlag         = FALSE ;		// `\ȏꍇ̓At@eXg͖
		Format->BlendGraphFlag        = FALSE ;		// `\ȏꍇ̓uh摜
		Format->UseManagedTextureFlag = FALSE ;
		Format->MipMapCount           = 1 ;
	}
	else
	{
		// `\w肪ꍇ̓At@`lt邩ǂ͈
		// At@eXgt邩ǂ GSYS.CreateImage.AlphaTestFlag 
		// uh摜ɂ邩ǂ GSYS.CreateImage.BlendImageFlag ɏ]
		Format->DrawValidFlag  = FALSE ;
		Format->AlphaChFlag    = ( unsigned char )AlphaValidFlag ;
		Format->AlphaTestFlag  = ( unsigned char )GParam->AlphaTestImageCreateFlag ;
		Format->BlendGraphFlag = ( unsigned char )GParam->BlendImageCreateFlag ;
	}

	// eNX`ǂŏ𕪊
	if( Format->TextureFlag == TRUE )
	{
		// eNX`̏ꍇ

		// J[rbg[x̌
		Format->ColorBitDepth   = ( unsigned char )( GParam->CreateImageColorBitDepth == 0 ? ( AlphaValidFlag == TRUE ? 32 : GSYS.Screen.MainScreenColorBitDepth ) : GParam->CreateImageColorBitDepth ) ;
		Format->ChannelNum      = ( unsigned char )GParam->CreateImageChannelNum ;
		Format->ChannelBitDepth = ( unsigned char )( GParam->CreateImageChannelNum > 0 ? GParam->CreateImageChannelBitDepth : 0 ) ;
		Format->FloatTypeFlag   = ( unsigned char )GParam->FloatTypeGraphCreateFlag ;
		Format->SystemMemFlag   = FALSE ;

		// At@`l̏ꍇ̓At@eXg͖
		if( Format->AlphaChFlag )
		{
			Format->AlphaTestFlag = FALSE ;
		}

		// uh摜̏ꍇ̓tH[}bg͌Œ肳
		if( Format->BlendGraphFlag == TRUE )
		{
			Format->ColorBitDepth = 32 ;
			Format->AlphaTestFlag = FALSE ;
			Format->AlphaChFlag   = TRUE ;
			Format->DrawValidFlag = FALSE ;
		}
		else
		// `\摜̏ꍇ̓`lƃ`lӂ̃rbgA_^ǂȂǂݒ肷
		if( GParam->DrawValidImageCreateFlag == TRUE )
		{
			Format->MipMapCount     = ( unsigned char )( GParam->CreateDrawValidGraphMipLevels > 0 ? GParam->CreateDrawValidGraphMipLevels : 1 ) ;
			Format->ChannelNum      = ( unsigned char )GParam->CreateDrawValidGraphChannelNum ;
			Format->ChannelBitDepth = ( unsigned char )GParam->CreateImageChannelBitDepth ;
			Format->FloatTypeFlag   = ( unsigned char )GParam->DrawValidFloatTypeGraphCreateFlag ;
			Format->MSSamples       = ( unsigned char )GParam->DrawValidMSSamples ;
			Format->MSQuality       = ( unsigned char )GParam->DrawValidMSQuality ;
		}
		else
		// uh摜ł`\摜łȂꍇ̂݃pbg摜gpł
		if( UsePaletteFlag )
		{
			Format->ColorBitDepth = ( unsigned char )( PaletteBitDepth == 4 ? 4 : 8 ) ;
		}
	}
	else
	{
		// eNX`ł͂Ȃꍇ
		Format->BaseFormat            = DX_BASEIMAGE_FORMAT_NORMAL ;
		Format->ColorBitDepth         = ( unsigned char )( GParam->CreateImageColorBitDepth == 0 ? GSYS.Screen.MainScreenColorBitDepth : GParam->CreateImageColorBitDepth ) ;
		Format->ChannelNum            = 0 ;
		Format->ChannelBitDepth       = 0 ;
		Format->FloatTypeFlag         = FALSE ;
		Format->SystemMemFlag         = TRUE ;
		Format->CubeMapTextureFlag    = FALSE ;
		Format->UsePaletteFlag        = ( unsigned char )UsePaletteFlag ;
		Format->UseManagedTextureFlag = FALSE ;		// DirectX ̊Ǘ
		Format->AlphaTestFlag         = FALSE ;		// At@eXg͖
		Format->DrawValidFlag         = ( unsigned char )( Format->BlendGraphFlag ? FALSE : TRUE ) ;	// ʂ̉摜̏ꍇ̓uh摜ł͂ȂΕ`\@ 
		Format->MipMapCount           = 0 ;
		Format->MSSamples             = 0 ;
		Format->MSQuality             = 0 ;
	}

	// I
	return 0 ;
}

// foCXXgɍ폜tOĂOtBbN폜
extern int Graphics_Image_DeleteDeviceLostDelete( void )
{
	int i ;
	IMAGEDATA *Image ;

	if( HandleManageArray[ DX_HANDLETYPE_GRAPH ].InitializeFlag )
	{
		for( i = HandleManageArray[ DX_HANDLETYPE_GRAPH ].AreaMin ; i <= HandleManageArray[ DX_HANDLETYPE_GRAPH ].AreaMax ; i ++ )
		{
			Image = ( IMAGEDATA * )HandleManageArray[ DX_HANDLETYPE_GRAPH ].Handle[ i ] ;

			if( Image == NULL ) continue ;
			if( Image->Orig == NULL ) continue ;
			if( Image->DeviceLostDeleteFlag == FALSE ) continue ;

			SubHandle( Image->HandleInfo.Handle ) ;
		}
	}

	// I
	return 0 ;
}

// lr``gp`\摜ǂ𒲂ׂ( TRUE:MSAA摜  FALSE:MSAA摜ł͂Ȃ )
extern int Graphics_Image_CheckMultiSampleDrawValid( int GrHandle )
{
	IMAGEDATA *Image ;

	if( GRAPHCHKFULL( GrHandle, Image ) )
		return FALSE ;

	if( Image->Orig->FormatDesc.TextureFlag == FALSE )
		return FALSE ;

	return Image->Orig->FormatDesc.MSSamples != 0 ? TRUE : FALSE ;
}

// VOtBbNnhmۂ
extern int Graphics_Image_AddHandle( int ASyncThread )
{
	return AddHandle( DX_HANDLETYPE_GRAPH, ASyncThread, -1 );
}

// OtBbNnh
extern int Graphics_Image_SetupHandle_UseGParam(
	SETUP_GRAPHHANDLE_GPARAM *GParam,
	int GrHandle,
	int Width,
	int Height,
	int /*TextureFlag*/,
	int AlphaValidFlag,
	int UsePaletteFlag,
	int PaletteBitDepth,
	int BaseFormat,
	int MipMapCount,
	int ASyncThread
) 
{
	IMAGEDATA					*Image ;
	IMAGEDATA_ORIG				*Orig ;
	int							IsTex ;
	int							IsDXT ;
	int							DivXNum ;
	int							DivYNum ;
	int							DivNum = 0 ;
	short						TexSizeX[ 256 ] ;
	short						TexSizeY[ 256 ] ;
	short						TexPosX[ 256 ] ;
	short						TexPosY[ 256 ] ;
	short						XList[ 32 ] ;
	short						YList[ 32 ] ;
	int							XPos ;
	int							YPos ;
	int							BaseAllocSize ;
	unsigned int				AllocSize ;
	int							i ;
	int							j ;
	IMAGEDATA_ORIG_HARD_TEX	*OrigTex ;
	IMAGEFORMATDESC				Format ;
	IMAGEDATA_ORIG_HARD_TEX_PF	*OrigTexPF ;

	// AhX̎擾
	if( GRAPHCHK_ASYNC( GrHandle, Image ) )
	{
		return -1 ;
	}

	// eNX`ǂ肷
	IsTex = GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ;

	// tH[}bgZbg
	Graphics_Image_SetupFormatDesc( &Format, GParam, Width, Height, AlphaValidFlag, UsePaletteFlag, PaletteBitDepth, BaseFormat, MipMapCount ) ;

	// DXTkǂZbg
	IsDXT =
		( Format.BaseFormat == DX_BASEIMAGE_FORMAT_DXT1 ||
		  Format.BaseFormat == DX_BASEIMAGE_FORMAT_DXT2 ||
		  Format.BaseFormat == DX_BASEIMAGE_FORMAT_DXT3 ||
		  Format.BaseFormat == DX_BASEIMAGE_FORMAT_DXT4 ||
		  Format.BaseFormat == DX_BASEIMAGE_FORMAT_DXT5 ||
		  Format.BaseFormat == DX_BASEIMAGE_FORMAT_BC7_UNORM ||
		  Format.BaseFormat == DX_BASEIMAGE_FORMAT_BC7_UNORM_SRGB ) ? TRUE : FALSE ;

	// eNX`̏ꍇ͉ɂȂ邩ׂ
	if( IsTex )
	{
		// 𒲂ׂ̂̓[U[w̃eNX`ł͂Ȃꍇ̂
		if( GParam->UserPlatformTexture != NULL )
		{
			DivNum = 1 ;
		}
		else
		{
			int IsPow2 = FALSE ;

	//		// `ɂł摜̏ꍇ͂Q̏搔TCYɂȂ
	//		if( Format.DrawValidFlag )
	//		{
	//			IsPow2 = FALSE ;
	//		}

			// 쐬eNX`̃TCYXgAbv
	//		DivXNum = Graphics_Image_ListUpTexSize( Width,  XList, Format.DrawValidFlag | Format.BlendGraphFlag | GParam->NotUseDivFlag, Format.DrawValidFlag == FALSE, GParam->UserMaxTextureSize ) ;
	//		DivYNum = Graphics_Image_ListUpTexSize( Height, YList, Format.DrawValidFlag | Format.BlendGraphFlag | GParam->NotUseDivFlag, Format.DrawValidFlag == FALSE, GParam->UserMaxTextureSize ) ;
			// fbg傫ȂĂ̂ŁA{IɍőeNX`[TCYɎ܂͂Pōς܂悤ɏύX
			DivXNum = Graphics_Image_ListUpTexSize( Width,  XList, TRUE, IsPow2, GParam->UserMaxTextureSize, IsDXT ) ;
			DivYNum = Graphics_Image_ListUpTexSize( Height, YList, TRUE, IsPow2, GParam->UserMaxTextureSize, IsDXT ) ;

			// Zbg
			DivNum = DivXNum * DivYNum ;

			// `\̏ꍇłPɎ܂Ȃꍇ̓G[
			if( Format.DrawValidFlag && DivNum > 1 )
			{
				goto ERR ;
			}

			// ʒuƃTCYZbg
			YPos = 0 ;
			for( i = 0 ; i < DivYNum ; i ++ )
			{
				XPos = 0 ;
				for( j = 0 ; j < DivXNum ; j ++ )
				{
					TexPosX[ i * DivXNum + j ] = ( short )XPos ;
					TexPosY[ i * DivXNum + j ] = ( short )YPos ;

					TexSizeX[ i * DivXNum + j ] = XList[ j ] ;
					TexSizeY[ i * DivXNum + j ] = YList[ i ] ;

					XPos += XList[ j ] ;
				}
				YPos += YList[ i ] ;
			}

			// n[hEFAɉăeNX`𐳕`ɂ
			if( GSYS.HardInfo.TextureSquareOnly )
			{
				int Size ;
				int DNum ;
				int MotoDivNum ;
				int PosX ;
				int PosY ;

				MotoDivNum = DivXNum * DivYNum ;
				for( i = 0 ; i < MotoDivNum ; i ++ )
				{
					if( TexSizeX[ i ] != TexSizeY[ i ] )
					{
						if( TexSizeX[ i ] < TexSizeY[ i ] )
						{
							Size = TexSizeX[ i ] ;
							DNum = TexSizeY[ i ] / TexSizeX[ i ] ;
							TexSizeY[ i ] = ( short )Size ;
							PosX = TexPosX[ i ] ;
							PosY = TexPosY[ i ] ;
							for( j = 0 ; j < DNum - 1 ; j ++ )
							{
								TexSizeX[ DivNum + j ] = ( short )Size ;
								TexSizeY[ DivNum + j ] = ( short )Size ;
								TexPosX[ DivNum + j ] = ( short )PosX ;
								TexPosY[ DivNum + j ] = ( short )( PosY + Size * ( j + 1 ) ) ;
							}
							DivNum += DNum - 1 ;
						}
						else
						{
							Size = TexSizeY[ i ] ;
							DNum = TexSizeX[ i ] / TexSizeY[ i ] ;
							TexSizeX[ i ] = ( short )Size ;
							PosX = TexPosX[ i ] ;
							PosY = TexPosY[ i ] ;
							for( j = 0 ; j < DNum - 1 ; j ++ )
							{
								TexSizeY[ DivNum + j ] = ( short )Size ;
								TexSizeX[ DivNum + j ] = ( short )Size ;
								TexPosY[ DivNum + j ] = ( short )PosY ;
								TexPosX[ DivNum + j ] = ( short )( PosX + Size * ( j + 1 ) ) ;
							}
							DivNum += DNum - 1 ;
						}
					}
				}
			}
		}
	}

	// mۃ̊m
	BaseAllocSize = sizeof( IMAGEDATA_ORIG ) - ( ( sizeof( IMAGEDATA_ORIG_SOFT ) > sizeof( IMAGEDATA_ORIG_HARD ) ? sizeof( IMAGEDATA_ORIG_SOFT ) : sizeof( IMAGEDATA_ORIG_HARD ) ) ) ;
	if( IsTex )
	{
		AllocSize = sizeof( IMAGEDATA_ORIG_HARD ) + ( DivNum - 4 ) * sizeof( IMAGEDATA_ORIG_HARD_TEX ) + DivNum * sizeof( IMAGEDATA_ORIG_HARD_TEX_PF ) ;
	}
	else
	{
		AllocSize = sizeof( IMAGEDATA_ORIG_SOFT ) ;
	}

	// IWi摜\̗p̃̊m
	Image->Orig = ( IMAGEDATA_ORIG * )DXCALLOC( AllocSize + BaseAllocSize ) ;
	if( Image->Orig == NULL )
	{
		DXST_LOGFILE_ADDUTF16LE( "\xb0\x30\xe9\x30\xd5\x30\xa3\x30\xc3\x30\xaf\x30\x6e\x30\xaa\x30\xea\x30\xb8\x30\xca\x30\xeb\x30\x3b\x75\xcf\x50\xc7\x30\xfc\x30\xbf\x30\xdd\x4f\x58\x5b\x28\x75\xe1\x30\xe2\x30\xea\x30\x6e\x30\xba\x78\xdd\x4f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"OtBbÑIWi摜f[^ۑp̊mۂɎs܂\n" @*/ ) ;
		goto ERR ;
	}
	Orig = Image->Orig ;

	// eNX`̏ꍇ͊ˑf[^̃AhXZbg
	if( IsTex )
	{
		OrigTexPF = ( IMAGEDATA_ORIG_HARD_TEX_PF * )( ( BYTE * )Orig + BaseAllocSize + sizeof( IMAGEDATA_ORIG_HARD ) + ( DivNum - 4 ) * sizeof( IMAGEDATA_ORIG_HARD_TEX ) ) ;
		OrigTex   = Orig->Hard.Tex ;
		for( i = 0; i < DivNum; i++, OrigTex++, OrigTexPF++ )
		{
			OrigTex->PF = OrigTexPF ;
		}
	}

#ifndef DX_NON_MOVIE
	// [r[nh͖
	Orig->MovieHandle = -1 ;
#endif

	// tH[}bgZbg
	Orig->FormatDesc = Format ;

	// ߐFZbg
	Orig->TransCode = GParam->TransColor ;

	// ˑeNX`̃Zbg
	Orig->UserPlatformTexture = GParam->UserPlatformTexture ;

	// InitGraph ō폜邩ǂZbg
	Image->NotInitGraphDelete = GParam->NotInitGraphDelete ;
	Image->NotInitGraphDeleteUser = GParam->NotInitGraphDeleteUser ;

	// ƍۑ
	Image->UseOrigXI    = 0 ;
	Image->UseOrigXF    = 0.0f ;
	Image->UseOrigYI    = 0 ;
	Image->UseOrigYF    = 0.0f ;
	Image->WidthI       = Width ;
	Image->WidthF       = ( float )Width ;
	Image->HeightI      = Height ;
	Image->HeightF      = ( float )Height ;
	Image->Orig->Width  = Width ;
	Image->Orig->Height = Height ;

	// QƐ
	Image->Orig->RefCount = 1 ;

	// IWi摜̏
	if( Orig->FormatDesc.TextureFlag )
	{
		// eNX`̏ꍇ

		// tH[}bǧ
		Orig->ColorFormat = NS_GetTexFormatIndex( &Orig->FormatDesc ) ;

		// eNX`ɍ킹ăeNX`񃊃Xgp̃mۂ
		Orig->Hard.TexNum = DivNum ;

		// ~bv}bv̐Zbg
//		Orig->Hard.MipMap = Orig->FormatDesc.DrawValidFlag ? FALSE : GRH.MipMapFlag ;
/*		if( Orig->ColorFormat == DX_GRAPHICSIMAGE_FORMAT_3D_DXT1 ||
			Orig->ColorFormat == DX_GRAPHICSIMAGE_FORMAT_3D_DXT2 ||
			Orig->ColorFormat == DX_GRAPHICSIMAGE_FORMAT_3D_DXT3 ||
			Orig->ColorFormat == DX_GRAPHICSIMAGE_FORMAT_3D_DXT4 ||
			Orig->ColorFormat == DX_GRAPHICSIMAGE_FORMAT_3D_DXT5 )
		{
			Orig->Hard.MipMapCount = 1 ;
		}
		else*/
		{
			Orig->Hard.MipMapCount = Format.MipMapCount ;
		}

		// 肵eNX`[TCYŃeNX`[
		OrigTex = Orig->Hard.Tex ;
		if( GParam->UserPlatformTexture != NULL )
		{
			OrigTex->UseWidth  = Orig->Width ;
			OrigTex->UseHeight = Orig->Height ;

			OrigTex->OrigPosX = 0 ;
			OrigTex->OrigPosY = 0 ;

			OrigTex->TexWidth  = Orig->Width ;
			OrigTex->TexHeight = Orig->Height ;
		}
		else
		{
			for( i = 0 ; i < DivNum ; i ++, OrigTex ++ )
			{
				OrigTex->UseWidth  = Orig->Width  - TexPosX[ i ] ;
				OrigTex->UseHeight = Orig->Height - TexPosY[ i ] ;
				if( OrigTex->UseWidth  > TexSizeX[ i ] ) OrigTex->UseWidth  = TexSizeX[ i ] ; 
				if( OrigTex->UseHeight > TexSizeY[ i ] ) OrigTex->UseHeight = TexSizeY[ i ] ;

				OrigTex->OrigPosX = TexPosX[ i ] ;
				OrigTex->OrigPosY = TexPosY[ i ] ;

				OrigTex->TexWidth  = TexSizeX[ i ] ;
				OrigTex->TexHeight = TexSizeY[ i ] ;
			}
		}

/*
		// `\ŉ𑜓xobNobt@ȏ̏ꍇ͐p̂yobt@
		if( Orig->FormatDesc.DrawValidFlag &&
			( Orig->Hard.Tex[ 0 ].TexWidth  > GSYS.Screen.MainScreenSizeX ||
			  Orig->Hard.Tex[ 0 ].TexHeight > GSYS.Screen.MainScreenSizeY ) )
		{
			Orig->ZBufferFlag = TRUE ;
		}
*/
		// `\ȏꍇłyobt@쐬tOĂꍇ͂yobt@
		if( Orig->FormatDesc.DrawValidFlag && GParam->DrawValidGraphCreateZBufferFlag )
		{
			Orig->ZBufferFlag = TRUE ;
			switch( GParam->CreateDrawValidGraphZBufferBitDepth )
			{
			default :
			case 16 : Orig->ZBufferBitDepthIndex = ZBUFFER_FORMAT_16BIT ; break ;
			case 24 : Orig->ZBufferBitDepthIndex = ZBUFFER_FORMAT_24BIT ; break ;
			case 32 : Orig->ZBufferBitDepthIndex = ZBUFFER_FORMAT_32BIT ; break ;
			}
		}

		// eNX`̍쐬
		if( Graphics_Hardware_CreateOrigTexture_PF( Orig, ASyncThread ) == -1 )
		{
			goto ERR ;
		}
	}
	else
	{
		// eNX`ł͂Ȃꍇ

		// uhp摜̏ꍇƂȊOŏ𕪊
		if( Orig->FormatDesc.BlendGraphFlag == TRUE )
		{
			// C[W̍쐬
			if( InitializeMemImg( &Orig->Soft.MemImg, Orig->Width, Orig->Height, -1, 0, 2, FALSE, FALSE, FALSE ) < 0 )
			{
				DXST_LOGFILE_ADDUTF16LE( "\xd6\x30\xec\x30\xf3\x30\xc9\x30\x3b\x75\xcf\x50\x28\x75\xe1\x30\xe2\x30\xea\x30\xa4\x30\xe1\x30\xfc\x30\xb8\x30\x6e\x30\x5c\x4f\x10\x62\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"uh摜pC[W̍쐬Ɏs܂\n" @*/ ) ;
				goto ERR ;
			}
		}
		else
		{
			DWORD TransColor ;

			// sNZtH[}bg̃CfbNXZbg
			if( Orig->FormatDesc.ColorBitDepth == 16 )
			{
				if( Orig->FormatDesc.AlphaChFlag )	Orig->ColorFormat = DX_GRAPHICSIMAGE_FORMAT_X8A8R5G6B5 ;
				else								Orig->ColorFormat = DX_GRAPHICSIMAGE_FORMAT_R5G6B5 ;
			}
			else
			{
				if( Orig->FormatDesc.AlphaChFlag )	Orig->ColorFormat = DX_GRAPHICSIMAGE_FORMAT_A8R8G8B8 ;
				else								Orig->ColorFormat = DX_GRAPHICSIMAGE_FORMAT_X8R8G8B8 ;
			}
			
			if( Orig->FormatDesc.UsePaletteFlag == TRUE )
			{
				TransColor = 0xffff ;
			}
			else
			{
				TransColor = NS_GetColor3( 
						GetMemImgColorData( Orig->FormatDesc.ColorBitDepth == 16 ? 0 : 1, ( int )Orig->FormatDesc.AlphaChFlag, FALSE ),
						( int )( ( GSYS.CreateImage.TransColor >> 16 ) & 0xff ),
						( int )( ( GSYS.CreateImage.TransColor >> 8  ) & 0xff ),
						( int )( ( GSYS.CreateImage.TransColor >> 0  ) & 0xff ),
						0xff ) ;
			}

			// C[W̍쐬
			if( InitializeMemImg(
					&Orig->Soft.MemImg,
					Orig->Width,
					Orig->Height,
					-1,
					TransColor,
					Orig->FormatDesc.ColorBitDepth == 16 ? 0 : 1,
					Orig->FormatDesc.UsePaletteFlag,
					Orig->FormatDesc.AlphaChFlag,
					FALSE
				) < 0 )
			{
				DXST_LOGFILE_ADDUTF16LE( "\xe1\x30\xe2\x30\xea\x30\xa4\x30\xe1\x30\xfc\x30\xb8\x30\x6e\x30\x5c\x4f\x10\x62\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"C[W̍쐬Ɏs܂\n" @*/ ) ;
				goto ERR ;
			}
		}
	}

	// `̏
	if( Graphics_Image_InitializeDrawInfo( GrHandle, FALSE, ASyncThread ) < 0 )
	{
		goto ERR ;
	}

	// I
	return 0 ;

	// G[I
ERR :
//	NS_DeleteGraph( GrHandle ) ;

	return -1 ;
}

// w̃eNX`[TCY肭
extern int Graphics_Image_ListUpTexSize( int Size, short *SizeList, int NotDivFlag, int Pow2Flag, int MaxTextureSize, int IsDXT )
{
	int DivNum ;
	int TexSize, GraphSize, MinTexSize, MaxTexSize ;

	// ŏTCYƍőTCYZbg
	MinTexSize = IsDXT ? 4 : MIN_TEXTURE_SIZE ;
	MaxTexSize = MaxTextureSize != 0 ? MaxTextureSize : GSYS.HardInfo.MaxTextureSize ;

	// Q̂ł͂Ȃėǂꍇ͎w̃TCYőeNX`TCYȉ炻̂܂ܕԂ
	if( Pow2Flag == FALSE && ( GSYS.HardInfo.TextureSizePow2 == FALSE || GSYS.HardInfo.TextureSizeNonPow2Conditional ) )
	{
		if( Size <= MaxTexSize )
		{
			if( SizeList )
			{
				// DXT k̏ꍇ 4 ̔{ɂ
				if( IsDXT )
				{
					SizeList[ 0 ] = ( short )( ( Size + 3 ) / 4 * 4 ) ;
				}
				else
				{
					SizeList[ 0 ] = ( short )Size ;
				}
			}
			return 1 ;
		}
	}

	// sŏTCỸeNX`菬ꍇ͍ŏTCYZbgĂPԂ
	if( MinTexSize >= Size )
	{
		if( SizeList ) SizeList[ 0 ] = ( short )MinTexSize ;
		return 1 ;
	}

	// Pԍŏ̃eNX`[͎wTCYɎ܂o邾傫eNX`[ɂ
	DivNum = 0 ;
	TexSize = MaxTexSize ;
	while( TexSize > MinTexSize )
	{
		if( TexSize <= Size ) break ;
		TexSize >>= 1 ;
	}

	// sȂꍇ͈ꖇŎ߂ꍇ͎߂ďI
	if( NotDivFlag != FALSE )
	{
		if( ( TexSize << 1 ) <= MaxTexSize )
		{
			if( TexSize < Size ) TexSize <<= 1 ;
			if( SizeList ) SizeList[ 0 ] = ( short )TexSize ;
			return 1 ;
		}
	}
	else
	// sw̏ꍇł쐬摜̃TCY
	// ʂƓA[U[w̃TCYꍇ
	// ȂׂsȂ
	if( MaxTextureSize == 0 )
	{
		if( Size <= GSYS.Screen.MainScreenSizeX )
		{
			if( ( TexSize << 1 ) <= MaxTexSize )
			{
				if( TexSize < Size ) TexSize <<= 1 ;
				if( SizeList ) SizeList[ 0 ] = ( short )TexSize ;
				return 1 ;
			}
		}
	}

	// 
	GraphSize = Size ;
	for(;;)
	{
		if( SizeList ) SizeList[ DivNum ] = ( short )TexSize ;
		GraphSize -= TexSize ;

		if( GraphSize <= 0 ) break ;

		// eNX`[TCYQ{ɂقꍇ𔻒
		if( ( GraphSize > TexSize * 3 / 4 ) && ( TexSize < MaxTexSize ) )
		{
			if( SizeList ) SizeList[ DivNum ] = ( short )( TexSize << 1 ) ;
			break ;
		}
		else
		{
			// eNX`[̃TCYcOtBbNTCYɍ킹ĕ␳
			if( GraphSize < TexSize )
			{
				while( GraphSize < TexSize  &&  TexSize > MinTexSize )
				{
					TexSize = TexSize >> 1 ;
				}
				DivNum ++ ; 
				continue ;
			}
		}
		DivNum ++ ;
	}

	// Ō̃TCYAŌ̈ÕTCYƓꍇ
	// Ō̈ÕTCYQ{ɂĕ炷
	if( DivNum > 0 && SizeList[ DivNum - 1 ] == SizeList[ DivNum ] &&
		( SizeList[ DivNum - 1 ] << 1 ) <= MaxTexSize )
	{
		DivNum -- ;
		SizeList[ DivNum ] <<= 1 ;
	}

	// Ԃ
	return DivNum + 1 ;
}

// OtBbNnh̏
extern int Graphics_Image_InitializeHandle( HANDLEINFO * /*HandleInfo*/ )
{
	// I
	return 0 ;
}

// OtBbNnȟn
extern int Graphics_Image_TerminateHandle( HANDLEINFO *HandleInfo )
{
	IMAGEDATA *Image = ( IMAGEDATA * )HandleInfo ;
	int i ;

	// `ɂȂĂ`\ʂɂ
	for( i = 0 ; i < GSYS.HardInfo.RenderTargetNum ; i ++ )
	{
		if( GSYS.DrawSetting.TargetScreen[ i ] == Image->HandleInfo.Handle )
		{
			NS_SetRenderTargetToShader( i, ( int )( i == 0 ? ( int )DX_SCREEN_FRONT : -1 ), 0, 0 ) ;
		}
	}

	// `yobt@ɂȂĂ`𗠉ʂɂ
	if( GSYS.DrawSetting.TargetZBuffer == Image->HandleInfo.Handle )
	{
		NS_SetDrawZBuffer( DX_SCREEN_BACK ) ;
	}

	// IWif[^ꍇ̓IWif[^̉s
	if( Image->Orig )
	{
		// eNX`ǂŏ𕪊
		if( Image->Orig->FormatDesc.TextureFlag )
		{
			// eNX`̏ꍇ
		}
		else
		{
			// eNX`ł͖ꍇ

			// `p MEMIMG ̌n
			TerminateMemImg( &Image->Soft.MemImg ) ;
		}

		// IWif[^̎QƐfNg
		Image->Orig->RefCount -- ;

		// OɂȂIWif[^̉s
		if( Image->Orig->RefCount == 0 )
		{
			// yobt@
			//ReleaseOrigZBuffer_PF( Image->Orig ) ;

			// [r[OtBbNꍇ̌ns
#ifndef DX_NON_MOVIE
			CloseMovie( Image->Orig->MovieHandle ) ;
#endif

			// eNX`ǂŏ𕪊
			if( Image->Orig->FormatDesc.TextureFlag )
			{
				// eNX`̏ꍇ

				// eNX`IuWFNg̉
				Graphics_Hardware_ReleaseOrigTexture_PF( Image->Orig ) ;
			}
			else
			{
				// eNX`ł͖ꍇ

				// MEMIMG 
				TerminateMemImg( &Image->Orig->Soft.MemImg ) ;
			}

			// IWi摜f[^pɊmۂ̈J
			DXFREE( Image->Orig ) ;
		}

		Image->Orig = NULL ;
	}

	// tJ[C[Wꍇ͉
	if( Image->FullColorImage != NULL )
	{
		DXFREE( Image->FullColorImage ) ;
		Image->FullColorImage = NULL ;
	}

	// bNC[Wꍇ͉
	if( Image->LockImage != NULL )
	{
		DXFREE( Image->LockImage ) ;
		Image->LockImage = NULL ;
	}

	// t@CۑpɃmۂĂꍇ͉
	Graphics_Image_SetGraphBaseInfo( Image->HandleInfo.Handle, NULL, NULL, NULL, NULL, NULL, 0, NULL, 0, NULL, NULL, FALSE, FALSE, FALSE, -1, FALSE ) ;

	// ɗĂtOւ̃|C^Lłꍇ͗Ă
	if( Image->LostFlag != NULL )
		*Image->LostFlag = TRUE ;

	// I
	return 0 ;
}

// w蕔𔲂oOtBbNnh
extern int Graphics_Image_InitializeDerivationHandle( int GrHandle, int IsFloat, int SrcXI, float SrcXF, int SrcYI, float SrcYF, int WidthI, float WidthF, int HeightI, float HeightF, int SrcGrHandle, int ASyncThread )
{
	IMAGEDATA *Image, *SrcImage ;
	IMAGEDATA_ORIG *Orig ;

	// AhX̎擾
	if( ASyncThread )
	{
		if( GRAPHCHK_ASYNC( GrHandle, Image ) ||
			GRAPHCHK_ASYNC( SrcGrHandle, SrcImage ) )
			return -1 ;
	}
	else
	{
		if( GRAPHCHK( GrHandle, Image ) )
			return -1 ;

		if( GRAPHCHK( SrcGrHandle, SrcImage ) )
			return -1 ;
	}
	Orig = SrcImage->Orig ;

	// IWi摜̎QƐCNg
	Image->Orig = Orig ;
	Orig->RefCount ++ ;

	// t@C̏Rs[
	Graphics_Image_SetName( GrHandle, NULL, FALSE, FALSE, FALSE, SrcGrHandle, ASyncThread ) ;
	Image->UseBaseXI = SrcImage->UseBaseXI + SrcXI ;
	Image->UseBaseXF = SrcImage->UseBaseXF + SrcXF ;
	Image->UseBaseYI = SrcImage->UseBaseYI + SrcYI ;
	Image->UseBaseYF = SrcImage->UseBaseYF + SrcYF ;

	// IWi摜̎QƍWZbg
	Image->UseOrigXI = SrcImage->UseOrigXI + SrcXI ;
	Image->UseOrigXF = SrcImage->UseOrigXF + SrcXF ;
	Image->UseOrigYI = SrcImage->UseOrigYI + SrcYI ;
	Image->UseOrigYF = SrcImage->UseOrigYF + SrcYF ;

	// TCYۑ
	Image->WidthI = WidthI ;
	Image->WidthF = WidthF ;
	Image->HeightI = HeightI ;
	Image->HeightF = HeightF ;

	// InitGraph ō폜邩ǂۑ
	Image->NotInitGraphDelete = SrcImage->NotInitGraphDelete ;
	Image->NotInitGraphDeleteUser = SrcImage->NotInitGraphDeleteUser ;

	//`̏
	Graphics_Image_InitializeDrawInfo( GrHandle, IsFloat, ASyncThread ) ;

	// I
	return 0 ;
}

// OtBbNnh̕`
extern int Graphics_Image_InitializeDrawInfo( int GrHandle, int IsFloat, int ASyncThread )
{
	IMAGEDATA				*Image ;
	IMAGEDATA_ORIG			*Orig ;
	IMAGEDATA_ORIG_HARD_TEX	*OrigTex ;
	IMAGEDATA_HARD_DRAW		*DrawTex ;
	int						i ;
	int						Num ;
	int						Size ;
	int						Handle ;
	bool					List[ 256 ] ;
	float					d ;

	// AhX̎擾
	if( ASyncThread )
	{
		if( GRAPHCHK_ASYNC( GrHandle, Image ) )
		{
			return -1 ;
		}
	}
	else
	{
		if( GRAPHCHK( GrHandle, Image ) )
		{
			return -1 ;
		}
	}
	Orig   = Image->Orig ;
	Handle = Image->HandleInfo.Handle ;

	// {mۃ̎Zo
	Size = sizeof( IMAGEDATA ) - ( ( sizeof( IMAGEDATA_SOFT ) > sizeof( IMAGEDATA_HARD ) ? sizeof( IMAGEDATA_SOFT ) : sizeof( IMAGEDATA_HARD ) ) ) ;

	// eNX`ǂŏ𕪊
	if( Orig->FormatDesc.TextureFlag )
	{
		// eNX`̏ꍇ

		// 摜镔̐𐔂
		OrigTex = Orig->Hard.Tex ;
		Num = 0 ;
		for( i = 0 ; i < Orig->Hard.TexNum ; i ++, OrigTex ++ )
		{
			if( IsFloat )
			{
				if(
					(
					  (
						OrigTex->OrigPosX <= Image->UseOrigXF  &&
						OrigTex->OrigPosX + OrigTex->UseWidth  > Image->UseOrigXF
					  ) ||
					  (
						Image->UseOrigXF  <= OrigTex->OrigPosX &&
						Image->UseOrigXF  + Image->WidthF      > OrigTex->OrigPosX
					  )
					) &&
					(
					  (
						OrigTex->OrigPosY <= Image->UseOrigYF  &&
						OrigTex->OrigPosY + OrigTex->UseHeight > Image->UseOrigYF
					  ) ||
					  (
						Image->UseOrigYF  <= OrigTex->OrigPosY &&
						Image->UseOrigYF  + Image->HeightF     > OrigTex->OrigPosY
					  )
					)
				  )
				{
					Num ++ ;
					List[ i ] = true ;
				}
				else
				{
					List[ i ] = false ;
				}
			}
			else
			{
				if(
					(
					  (
						OrigTex->OrigPosX <= Image->UseOrigXI  &&
						OrigTex->OrigPosX + OrigTex->UseWidth  > Image->UseOrigXI
					  ) ||
					  (
						Image->UseOrigXI  <= OrigTex->OrigPosX &&
						Image->UseOrigXI  + Image->WidthI      > OrigTex->OrigPosX
					  )
					) &&
					(
					  (
						OrigTex->OrigPosY <= Image->UseOrigYI  &&
						OrigTex->OrigPosY + OrigTex->UseHeight > Image->UseOrigYI
					  ) ||
					  (
						Image->UseOrigYI  <= OrigTex->OrigPosY &&
						Image->UseOrigYI  + Image->HeightI     > OrigTex->OrigPosY
					  )
					)
				  )
				{
					Num ++ ;
					List[ i ] = true ;
				}
				else
				{
					List[ i ] = false ;
				}
			}
		}

		// 镔Ȍꍇ̓G[
		if( Num == 0 )
		{
			DXST_LOGFILE_ADDUTF16LE( "\xc6\x30\xaf\x30\xb9\x30\xc1\x30\xe3\x30\xcf\x63\x3b\x75\xc5\x60\x31\x58\x6e\x30\x5c\x4f\x10\x62\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"eNX``̍쐬Ɏs܂\n" @*/ ) ;
			return -1 ;
		}

		// `i[郁̈悪Ȃꍇ͍Ċm
		if( Num > 4 )
		{
			if( ReallocHandle( Handle, Size + sizeof( IMAGEDATA_HARD ) + ( Num - 4 ) * sizeof( IMAGEDATA_HARD_DRAW ) ) < 0 )
			{
				DXST_LOGFILE_ADDUTF16LE( "\x3b\x75\xcf\x50\xcf\x63\x3b\x75\xc5\x60\x31\x58\x3c\x68\x0d\x7d\x28\x75\xe1\x30\xe2\x30\xea\x30\x6e\x30\xba\x78\xdd\x4f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"摜`i[p̊mۂɎs܂\n" @*/ ) ;
				return -1 ;
			}
			Image = ( IMAGEDATA * )GetHandleInfo( Handle ) ;
			Orig = Image->Orig ;
		}

		Image->Hard.DrawNum = Num ;

		// `Zbg
		d = Image->HeightF / Image->WidthF ;
		OrigTex = Orig->Hard.Tex ;
		DrawTex = Image->Hard.Draw ;
		Num     = 0 ;
		for( i = 0 ; i < Orig->Hard.TexNum ; i ++, OrigTex ++ )
		{
			if( List[ i ] == false ) continue ;

			// gpIWi摜eNX`̃AhXZbg
			DrawTex->Tex = OrigTex ;

			// IWi摜eNX`̂ǂ̕gp邩AȂǂ̏Zbg
			if( IsFloat )
			{
				if( OrigTex->OrigPosX > Image->UseOrigXF )
				{
					DrawTex->DrawPosXF = OrigTex->OrigPosX - Image->UseOrigXF ;
					DrawTex->UsePosXF  = 0.0f ;

					if( OrigTex->OrigPosX + OrigTex->UseWidth > Image->UseOrigXF + Image->WidthF )
					{
						DrawTex->WidthF = Image->UseOrigXF + Image->WidthF - OrigTex->OrigPosX ;
					}
					else
					{
						DrawTex->WidthF = ( float )OrigTex->UseWidth ;
					}
				}
				else
				{
					DrawTex->DrawPosXF = 0.0f ;
					DrawTex->UsePosXF  = Image->UseOrigXF - OrigTex->OrigPosX ;

					if( OrigTex->OrigPosX + OrigTex->UseWidth > Image->UseOrigXF + Image->WidthF )
					{
						DrawTex->WidthF = Image->WidthF ;
					}
					else
					{
						DrawTex->WidthF = OrigTex->OrigPosX + OrigTex->UseWidth - Image->UseOrigXF ;
					}
				}

				if( OrigTex->OrigPosY > Image->UseOrigYF )
				{
					DrawTex->DrawPosYF = OrigTex->OrigPosY - Image->UseOrigYF ;
					DrawTex->UsePosYF  = 0.0f ;

					if( OrigTex->OrigPosY + OrigTex->UseHeight > Image->UseOrigYF + Image->HeightF )
					{
						DrawTex->HeightF = Image->UseOrigYF + Image->HeightF - OrigTex->OrigPosY ;
					}
					else
					{
						DrawTex->HeightF = ( float )OrigTex->UseHeight ;
					}
				}
				else
				{
					DrawTex->DrawPosYF = 0.0f ;
					DrawTex->UsePosYF  = Image->UseOrigYF - OrigTex->OrigPosY ;

					if( OrigTex->OrigPosY + OrigTex->UseHeight > Image->UseOrigYF + Image->HeightF )
					{
						DrawTex->HeightF = Image->HeightF ;
					}
					else
					{
						DrawTex->HeightF = OrigTex->OrigPosY + OrigTex->UseHeight - Image->UseOrigYF ;
					}
				}

				// l̊o
				{
					float lTempWidthF ;
					float lTempHeightF ;

					DrawTex->DrawPosXI = _FTOL( DrawTex->DrawPosXF ) ;
					DrawTex->DrawPosYI = _FTOL( DrawTex->DrawPosYF ) ;
					DrawTex->UsePosXI  = _FTOL( DrawTex->UsePosXF  ) ;
					DrawTex->UsePosYI  = _FTOL( DrawTex->UsePosYF  ) ;

					lTempWidthF  = ( DrawTex->UsePosXF + DrawTex->WidthF  ) - DrawTex->UsePosXI ;
					lTempHeightF = ( DrawTex->UsePosYF + DrawTex->HeightF ) - DrawTex->UsePosYI ;
					DrawTex->WidthI  = _FTOL( lTempWidthF ) ;
					DrawTex->HeightI = _FTOL( lTempHeightF ) ;

					if( lTempWidthF - DrawTex->WidthI > 0.01f )
					{
						DrawTex->WidthI ++ ;
						if( DrawTex->UsePosXI + DrawTex->WidthI > OrigTex->UseWidth )
						{
							DrawTex->WidthI = OrigTex->UseWidth - ( DrawTex->UsePosXI + DrawTex->WidthI ) ;
						}
					}

					if( lTempHeightF - DrawTex->HeightI > 0.01f )
					{
						DrawTex->HeightI ++ ;
						if( DrawTex->UsePosYI + DrawTex->HeightI > OrigTex->UseHeight )
						{
							DrawTex->HeightI = OrigTex->UseHeight - ( DrawTex->UsePosYI + DrawTex->HeightI ) ;
						}
					}
				}
			}
			else
			{
				if( OrigTex->OrigPosX > Image->UseOrigXI )
				{
					DrawTex->DrawPosXI = OrigTex->OrigPosX - Image->UseOrigXI ;
					DrawTex->UsePosXI  = 0 ;

					if( OrigTex->OrigPosX + OrigTex->UseWidth > Image->UseOrigXI + Image->WidthI )
					{
						DrawTex->WidthI = Image->UseOrigXI + Image->WidthI - OrigTex->OrigPosX ;
					}
					else
					{
						DrawTex->WidthI = OrigTex->UseWidth ;
					}
				}
				else
				{
					DrawTex->DrawPosXI = 0 ;
					DrawTex->UsePosXI  = Image->UseOrigXI - OrigTex->OrigPosX ;

					if( OrigTex->OrigPosX + OrigTex->UseWidth > Image->UseOrigXI + Image->WidthI )
					{
						DrawTex->WidthI = Image->WidthI ;
					}
					else
					{
						DrawTex->WidthI = OrigTex->OrigPosX + OrigTex->UseWidth - Image->UseOrigXI ;
					}
				}

				if( OrigTex->OrigPosY > Image->UseOrigYI )
				{
					DrawTex->DrawPosYI = OrigTex->OrigPosY - Image->UseOrigYI ;
					DrawTex->UsePosYI  = 0 ;

					if( OrigTex->OrigPosY + OrigTex->UseHeight > Image->UseOrigYI + Image->HeightI )
					{
						DrawTex->HeightI = Image->UseOrigYI + Image->HeightI - OrigTex->OrigPosY ;
					}
					else
					{
						DrawTex->HeightI = OrigTex->UseHeight ;
					}
				}
				else
				{
					DrawTex->DrawPosYI = 0 ;
					DrawTex->UsePosYI  = Image->UseOrigYI - OrigTex->OrigPosY ;

					if( OrigTex->OrigPosY + OrigTex->UseHeight > Image->UseOrigYI + Image->HeightI )
					{
						DrawTex->HeightI = Image->HeightI ;
					}
					else
					{
						DrawTex->HeightI = OrigTex->OrigPosY + OrigTex->UseHeight - Image->UseOrigYI ;
					}
				}

				// _l̃Zbg
				{
					DrawTex->DrawPosXF = ( float )DrawTex->DrawPosXI ;
					DrawTex->DrawPosYF = ( float )DrawTex->DrawPosYI ;
					DrawTex->UsePosXF  = ( float )DrawTex->UsePosXI ;
					DrawTex->UsePosYF  = ( float )DrawTex->UsePosYI ;
					DrawTex->WidthF    = ( float )DrawTex->WidthI ;
					DrawTex->HeightF   = ( float )DrawTex->HeightI ;
				}
			}

			// Zogp񂩂璸_f[^Ɏgpl̊o
			DrawTex->Vertex[ 0 ].x =   DrawTex->DrawPosXF ;
			DrawTex->Vertex[ 1 ].x = ( DrawTex->DrawPosXF + DrawTex->WidthF ) ;
			DrawTex->Vertex[ 2 ].x =   DrawTex->DrawPosXF ;
			DrawTex->Vertex[ 3 ].x = ( DrawTex->DrawPosXF + DrawTex->WidthF ) ;

			DrawTex->Vertex[ 0 ].y =   DrawTex->DrawPosYF ;
			DrawTex->Vertex[ 1 ].y =   DrawTex->DrawPosYF ;
			DrawTex->Vertex[ 2 ].y = ( DrawTex->DrawPosYF + DrawTex->HeightF ) ;
			DrawTex->Vertex[ 3 ].y = ( DrawTex->DrawPosYF + DrawTex->HeightF ) ;

			DrawTex->Vertex[ 0 ].u =   DrawTex->UsePosXF                     / ( float )OrigTex->TexWidth ;
			DrawTex->Vertex[ 1 ].u = ( DrawTex->UsePosXF + DrawTex->WidthF ) / ( float )OrigTex->TexWidth ;
			DrawTex->Vertex[ 2 ].u =   DrawTex->UsePosXF                     / ( float )OrigTex->TexWidth ;
			DrawTex->Vertex[ 3 ].u = ( DrawTex->UsePosXF + DrawTex->WidthF ) / ( float )OrigTex->TexWidth ;

			DrawTex->Vertex[ 0 ].v =   DrawTex->UsePosYF                      / ( float )OrigTex->TexHeight ;
			DrawTex->Vertex[ 1 ].v =   DrawTex->UsePosYF                      / ( float )OrigTex->TexHeight ;
			DrawTex->Vertex[ 2 ].v = ( DrawTex->UsePosYF + DrawTex->HeightF ) / ( float )OrigTex->TexHeight ;
			DrawTex->Vertex[ 3 ].v = ( DrawTex->UsePosYF + DrawTex->HeightF ) / ( float )OrigTex->TexHeight ;

			// _^CṽZbg
			DrawTex->VertType[ 0 ] = ( unsigned char )( DrawTex->Vertex[ 0 ].y <= Image->HeightF - ( d * DrawTex->Vertex[ 0 ].x ) ? 1 : 0 ) ;
			DrawTex->VertType[ 1 ] = ( unsigned char )( DrawTex->Vertex[ 1 ].y <= Image->HeightF - ( d * DrawTex->Vertex[ 1 ].x ) ? 1 : 0 ) ;
			DrawTex->VertType[ 2 ] = ( unsigned char )( DrawTex->Vertex[ 2 ].y <= Image->HeightF - ( d * DrawTex->Vertex[ 2 ].x ) ? 1 : 0 ) ;
			DrawTex->VertType[ 3 ] = ( unsigned char )( DrawTex->Vertex[ 3 ].y <= Image->HeightF - ( d * DrawTex->Vertex[ 3 ].x ) ? 1 : 0 ) ;

			DrawTex ++ ;
		}
	}
	else
	{
		// eNX`ł͂Ȃꍇ

		// `p MEMIMG ̏
		DerivationMemImg( &Image->Soft.MemImg, &Orig->Soft.MemImg, Image->UseOrigXI, Image->UseOrigYI, Image->WidthI, Image->HeightI ) ;
	}

	// I
	return 0 ;
}

// OtBbNnhLǂ𒲂ׂ( TRUE:L  FALSE: )
extern	int Graphics_Image_IsValidHandle( int GrHandle )
{
	IMAGEDATA *Image ;

	// G[
	if( GRAPHCHKFULL( GrHandle, Image ) )
		return FALSE ;

	// I
	return TRUE ;
}

// GraphImage f[^TCYoAɍOtBbNnh쐬
extern int Graphics_Image_CreateDXGraph_UseGParam(
	SETUP_GRAPHHANDLE_GPARAM *GParam,
	int GrHandle,
	const BASEIMAGE *RgbBaseImage,
	const BASEIMAGE *AlphaBaseImage,
	int TextureFlag,
	int ASyncThread
)
{
	SETUP_GRAPHHANDLE_GPARAM TempGParam ;

	if( GSYS.InitializeFlag == FALSE ) return -1 ;

	if( ASyncThread == FALSE )
	{
		CheckActiveState() ;
	}

	// ̃OtBbÑTCYꍇ̓G[
	if( AlphaBaseImage != NULL && ( RgbBaseImage->Width != AlphaBaseImage->Width || RgbBaseImage->Height != AlphaBaseImage->Height ) )
		return -1 ;

	// L[u}bveNX`쐬邩ǂZbg
	GParam->CubeMapTextureCreateFlag = RgbBaseImage->GraphDataCount == CUBEMAP_SURFACE_NUM ? TRUE : FALSE ;

	// nh̏
	{
		int UsePaletteFlag ;
		int PaletteColorBitDepth = 0 ;

		// pbgeNX`gp邩ǂZbg
		UsePaletteFlag = RgbBaseImage->ColorData.PixelByte  == 1 && 
						 ( ( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE ) || RgbBaseImage->ColorData.AlphaWidth == 0 ) &&
						 AlphaBaseImage == NULL &&
						 GParam->NotUsePaletteGraphFlag == FALSE ;

		// OtBbNXfoCX4bitpbgeNX`ɑΉĂꍇŁA8bitJ[̏ꍇ
		// gpĂőpbgԍ 4bit Ɏ܂邩ǂ𒲂ׁA܂ꍇ 4bit pbgeNX`ɂ
		if( UsePaletteFlag )
		{
			if( GSYS.HardInfo.Support4bitPaletteTexture &&
				RgbBaseImage->ColorData.ColorBitDepth == 8 )
			{
				if( RgbBaseImage->ColorData.MaxPaletteNo == 0 || RgbBaseImage->ColorData.MaxPaletteNo == 255 )
				{
					PaletteColorBitDepth = NS_GetBaseImageUseMaxPaletteNo( RgbBaseImage ) < 16 ? 4 : 8 ;
				}
				else
				{
					PaletteColorBitDepth = RgbBaseImage->ColorData.MaxPaletteNo < 16 ? 4 : 8 ;
				}
			}
			else
			{
				PaletteColorBitDepth = 8 ;
			}
		}

		// BaseImage ̃J[Ń`l`lrbgw肳Ăꍇ GParam ɒl𔽉f
		if( RgbBaseImage->ColorData.ChannelNum != 0 &&
			RgbBaseImage->ColorData.ChannelBitDepth != 0 )
		{
			TempGParam                                   = *GParam ;
			TempGParam.DrawValidImageCreateFlag          = GParam->DrawValidImageCreateFlag ;
			TempGParam.CreateImageChannelBitDepth        = RgbBaseImage->ColorData.ChannelBitDepth ;
			if( GParam->DrawValidImageCreateFlag )
			{
				TempGParam.DrawValidFloatTypeGraphCreateFlag	= RgbBaseImage->ColorData.FloatTypeFlag ;
				TempGParam.CreateDrawValidGraphChannelNum		= RgbBaseImage->ColorData.ChannelNum ;
			}
			else
			{
				TempGParam.FloatTypeGraphCreateFlag				= RgbBaseImage->ColorData.FloatTypeFlag ;
				TempGParam.CreateImageChannelNum				= RgbBaseImage->ColorData.ChannelNum ;
			}

			GParam = &TempGParam ;
		}

		if( Graphics_Image_SetupHandle_UseGParam(
				GParam,
				GrHandle,
				RgbBaseImage->Width, RgbBaseImage->Height, TextureFlag,
				RgbBaseImage->ColorData.AlphaWidth != 0 || AlphaBaseImage != NULL,
				UsePaletteFlag,
				PaletteColorBitDepth,
				RgbBaseImage->ColorData.Format,
				RgbBaseImage->MipMapCount == 0 ? -1 : RgbBaseImage->MipMapCount,
				ASyncThread ) == -1 )
			return -1 ;
	}

	// I
	return 0 ;
}

// DerivationGraph ̃O[oϐɃANZXȂo[W
extern int Graphics_Image_DerivationGraph_UseGParam(
	int IsFloat,
	int SrcXI,   float SrcXF,
	int SrcYI,   float SrcYF,
	int WidthI,  float WidthF,
	int HeightI, float HeightF,
	int SrcGraphHandle,
	int ASyncThread
)
{
	int NewGraphHandle ;
	int Result ;

	// VȃOtBbNf[^̒ǉ
	NewGraphHandle = Graphics_Image_AddHandle( ASyncThread ) ;
	if( NewGraphHandle == -1 )
	{
		return -1 ;
	}

	Result = Graphics_Image_DerivationGraphBase( NewGraphHandle, IsFloat, SrcXI, SrcXF, SrcYI, SrcYF, WidthI, WidthF, HeightI, HeightF, SrcGraphHandle, ASyncThread ) ;
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		DecASyncLoadCount( NewGraphHandle ) ;
	}
#endif // DX_NON_ASYNCLOAD
	if( Result < 0 )
	{
		NS_DeleteGraph( NewGraphHandle, FALSE ) ;
		return -1 ;
	}

	// nhԂ
	return NewGraphHandle ;
}

#ifndef DX_NON_MOVIE

extern int Graphics_Image_OpenMovie_UseGParam(
	LOADGRAPH_GPARAM *GParam,
	int GrHandle,
	const wchar_t *GraphName,
	const void *FileImage,
	size_t FileImageSize,
	int TextureFlag,
	int SurfaceMode,
	int /*ImageSizeGetOnly*/,
	int ASyncThread
)
{
	int MovieHandle ;
	int Width, Height ;
	MOVIEGRAPH *Movie;
	IMAGEDATA *Image ;

	// [r[OtBbNƂĈƂĂ݂
	MovieHandle = OpenMovie_UseGParam( GrHandle, &GParam->OpenMovieGParam, GraphName, FileImage, FileImageSize, &Width, &Height, SurfaceMode, FALSE, ASyncThread ) ;
	if( MovieHandle < 0 )
	{
		DXST_LOGFILEFMT_ADDW(( L"Image File Load Error : %s \n", GraphName )) ;
		return -1 ;
	}

	Movie = GetMovieData( MovieHandle );

	// ʂ̃J[rbgfvXƑΉ悤ɃZbgAyтuq`lgpZbg
	GParam->CreateGraphGParam.InitHandleGParam.CreateImageColorBitDepth = NS_GetColorBitDepth() ;
#ifndef DX_NON_DSHOW_MOVIE
	#ifndef DX_NON_OGGTHEORA
		GParam->CreateGraphGParam.InitHandleGParam.AlphaChannelImageCreateFlag = Movie->A8R8G8B8Flag && Movie->TheoraFlag == FALSE && Movie->PF.pMovieImage != NULL && Movie->PF.pMovieImage->ImageType == 1 ;
	#else // DX_NON_OGGTHEORA
		GParam->CreateGraphGParam.InitHandleGParam.AlphaChannelImageCreateFlag = Movie->A8R8G8B8Flag && Movie->PF.pMovieImage->ImageType == 1 ;
	#endif // DX_NON_OGGTHEORA
#else // DX_NON_DSHOW_MOVIE
	GParam->CreateGraphGParam.InitHandleGParam.AlphaChannelImageCreateFlag = FALSE ;
#endif // DX_NON_DSHOW_MOVIE
	GParam->CreateGraphGParam.InitHandleGParam.CreateImageChannelNum = 0 ;
	GParam->CreateGraphGParam.InitHandleGParam.CreateImageChannelBitDepth = 0 ;
	GParam->CreateGraphGParam.InitHandleGParam.NotUseDivFlag = TRUE ;
	GParam->CreateGraphGParam.InitHandleGParam.AlphaTestImageCreateFlag = FALSE ;
	GParam->CreateGraphGParam.InitHandleGParam.CubeMapTextureCreateFlag = FALSE ;
	GParam->CreateGraphGParam.InitHandleGParam.UseManagedTextureFlag = FALSE ;
	GParam->CreateGraphGParam.InitHandleGParam.MipMapCount = 0 ;
	GParam->CreateGraphGParam.InitHandleGParam.UseLinearMapTextureFlag = TRUE ;
	GParam->CreateGraphGParam.InitHandleGParam.PlatformTextureFormat = 0 ;
#ifndef DX_NON_OGGTHEORA
	if( Movie->TheoraFlag && /* Movie->RightAlpha == FALSE && */ GSYS.HardInfo.OggTheoraUseDrawValidGraph )
	{
		GParam->CreateGraphGParam.InitHandleGParam.DrawValidImageCreateFlag = TRUE ;
		GParam->CreateGraphGParam.InitHandleGParam.DrawValidAlphaImageCreateFlag = FALSE ;
		GParam->CreateGraphGParam.InitHandleGParam.DrawValidFloatTypeGraphCreateFlag = FALSE ;
		GParam->CreateGraphGParam.InitHandleGParam.DrawValidGraphCreateZBufferFlag = FALSE ;
		GParam->CreateGraphGParam.InitHandleGParam.CreateDrawValidGraphMipLevels = 0 ;
		GParam->CreateGraphGParam.InitHandleGParam.CreateDrawValidGraphChannelNum = 0 ;
		GParam->CreateGraphGParam.InitHandleGParam.CreateDrawValidGraphZBufferBitDepth = 0 ;
		GParam->CreateGraphGParam.InitHandleGParam.DrawValidMSSamples = 0 ;
		GParam->CreateGraphGParam.InitHandleGParam.DrawValidMSQuality = 0 ;
	}
	else
#endif // DX_NON_OGGTHEORA
	if( Movie->RightAlpha == FALSE && GSYS.HardInfo.UseShader && ( Movie->A8R8G8B8Flag == FALSE
#ifndef DX_NON_DSHOW_MOVIE
		|| ( Movie->PF.pMovieImage != NULL && Movie->PF.pMovieImage->ImageType != 1 )
#endif // DX_NON_DSHOW_MOVIE
		) )
	{
		GParam->CreateGraphGParam.InitHandleGParam.DrawValidImageCreateFlag = TRUE ;
		GParam->CreateGraphGParam.InitHandleGParam.DrawValidAlphaImageCreateFlag = FALSE ;
		GParam->CreateGraphGParam.InitHandleGParam.DrawValidFloatTypeGraphCreateFlag = FALSE ;
		GParam->CreateGraphGParam.InitHandleGParam.DrawValidGraphCreateZBufferFlag = FALSE ;
		GParam->CreateGraphGParam.InitHandleGParam.CreateDrawValidGraphMipLevels = 0 ;
		GParam->CreateGraphGParam.InitHandleGParam.CreateDrawValidGraphChannelNum = 0 ;
		GParam->CreateGraphGParam.InitHandleGParam.CreateDrawValidGraphZBufferBitDepth = 0 ;
		GParam->CreateGraphGParam.InitHandleGParam.DrawValidMSSamples = 0 ;
		GParam->CreateGraphGParam.InitHandleGParam.DrawValidMSQuality = 0 ;
	}

	// p[^̃JX^}CY
	OpenMovie_CustomGraphHandleGParam_PF( Movie, &GParam->CreateGraphGParam.InitHandleGParam ) ;

	// ǂ݂񂾃rbg}bṽTCỸOtBbNf[^쐬
	// E`lƂĈꍇ̓`lt摜ɂ
	if( Graphics_Image_SetupHandle_UseGParam(
			&GParam->CreateGraphGParam.InitHandleGParam,
			GrHandle,
			Movie->RightAlpha ? Width / 2 : Width,
			Height,
			TextureFlag,
			Movie->RightAlpha || GParam->CreateGraphGParam.InitHandleGParam.AlphaChannelImageCreateFlag,
			FALSE,
			0,
			DX_BASEIMAGE_FORMAT_NORMAL,
			-1,
			ASyncThread
		) == -1 )
	{
		DXST_LOGFILEFMT_ADDW(( L"Graph Handle Setup Error : %s", GraphName )) ;
		return -1 ;
	}

	Image = Graphics_Image_GetData( GrHandle, ASyncThread ) ;
	if( Image )
	{
		// [r[̃nhZbg
		Image->Orig->MovieHandle = MovieHandle ;

		// R[obN֐Zbg
		SetCallbackMovie( MovieHandle, ( void (*)( MOVIEGRAPH *, void * ) )Graphics_Image_UpdateGraphMovie, ( void * )( DWORD_PTR )GrHandle ) ;
	}

	// I
	return 0 ;
}

#endif // DX_NON_MOVIE

// OtBbNnh쐬Ȃ DerivationGraph
extern int Graphics_Image_DerivationGraphBase( int GrHandle, int IsFloat, int SrcXI, float SrcXF, int SrcYI, float SrcYF, int WidthI, float WidthF, int HeightI, float HeightF, int SrcGraphHandle, int ASyncThread )
{
	IMAGEDATA *Image ;

//	if( GSYS.NotDrawFlag == TRUE ) return 0 ;

	// G[
	if( ASyncThread )
	{
		if( GRAPHCHK_ASYNC( SrcGraphHandle, Image ) )
			return -1 ;
	}
	else
	{
		if( GRAPHCHK( SrcGraphHandle, Image ) )
			return -1 ;
	}

	// ␳
	if( SrcXI < 0 || SrcYI < 0 || SrcXI >= Image->WidthI || SrcYI >= Image->HeightI ||
		SrcXF < 0 || SrcYF < 0 || SrcXF >= Image->WidthF || SrcYF >= Image->HeightF ) return -1 ;
	if( SrcXI + WidthI  > Image->WidthI  ) WidthI  = Image->WidthI  - SrcXI ;
	if( SrcXF + WidthF  > Image->WidthF  ) WidthF  = Image->WidthF  - SrcXF ;
	if( SrcYI + HeightI > Image->HeightI ) HeightI = Image->HeightI - SrcYI ;
	if( SrcYF + HeightF > Image->HeightF ) HeightF = Image->HeightF - SrcYF ;

	// oOtBbN̏
	if( Graphics_Image_InitializeDerivationHandle( GrHandle, IsFloat, SrcXI, SrcXF, SrcYI, SrcYF, WidthI, WidthF, HeightI, HeightF, SrcGraphHandle, ASyncThread ) == -1 )
		return -1 ;

	// I
	return 0 ;
}

// Graphics_Image_SetGraphBaseInfo ̃O[oϐɃANZXȂo[W
extern int Graphics_Image_SetBaseInfo_UseGParam(
	SETGRAPHBASEINFO_GPARAM *GParam,
	int GrHandle,
	const wchar_t *FileName,
	const COLORDATA *BmpColorData,
	HBITMAP RgbBmp,
	HBITMAP AlphaBmp,
	const void *MemImage,
	int MemImageSize,
	const void *AlphaMemImage,
	int AlphaMemImageSize,
	const BASEIMAGE *BaseImage,
	const BASEIMAGE *AlphaBaseImage,
	int ReverseFlag,
	int ConvertPremultipliedAlpha,
	int NotUseTransColor,
	int UnionGrHandle,
	int ASyncThread
)
{
	IMAGEDATA *Image, *SrcImage = NULL ;
	wchar_t Path[ 1024 ] ;
	int Len ;

	if( ASyncThread )
	{
		if( GRAPHCHK_ASYNC( GrHandle, Image ) )
			return -1 ;
		GRAPHCHKFULL_ASYNC( UnionGrHandle, SrcImage ) ;
	}
	else
	{
		if( GRAPHCHK( GrHandle, Image ) )
			return -1 ;
		GRAPHCHKFULL( UnionGrHandle, SrcImage ) ;
	}

	// Ƀt@CpXp̃mۂĂ
	if( Image->ReadBase )
	{
		Image->ReadBase->RefCount -- ;
		if( Image->ReadBase->RefCount == 0 )
		{
			DXFREE( Image->ReadBase ) ;
			Image->ReadBase = NULL ;
		}
	}

	// rbg}bvLȏꍇ BASEIMAGE \̂\z
	if( RgbBmp )
	{
#ifdef WINDOWS_DESKTOP_OS
		BITMAP BitmapInfo ;
		BITMAP AlphaBitmapInfo ;
		BASEIMAGE BmpImage ;
		BASEIMAGE AlphaBmpImage ;

		SETUP_WIN_API

		WinAPIData.Win32Func.GetObjectAFunc( RgbBmp, sizeof( BITMAP ), ( void * )&BitmapInfo ) ;
		_MEMSET( &BmpImage, 0, sizeof( BASEIMAGE ) ) ;
		BmpImage.GraphData = BitmapInfo.bmBits ;
		BmpImage.Width = BitmapInfo.bmWidth ;
		BmpImage.Height = BitmapInfo.bmHeight ;
		BmpImage.Pitch = ( BmpImage.Pitch + 3 ) / 4 * 4 ;
		_MEMCPY( &BmpImage.ColorData, BmpColorData, sizeof( COLORDATA ) ) ; 
		BaseImage = &BmpImage ;

		if( AlphaBmp )
		{
			WinAPIData.Win32Func.GetObjectAFunc( AlphaBmp, sizeof( BITMAP ), ( void * )&AlphaBitmapInfo ) ;
			_MEMSET( &AlphaBmpImage, 0, sizeof( BASEIMAGE ) ) ;
			AlphaBmpImage.GraphData = AlphaBitmapInfo.bmBits ;
			AlphaBmpImage.Width = AlphaBitmapInfo.bmWidth ;
			AlphaBmpImage.Height = AlphaBitmapInfo.bmHeight ;
			AlphaBmpImage.Pitch = ( AlphaBmpImage.Pitch + 3 ) / 4 * 4 ;
			_MEMCPY( &AlphaBmpImage.ColorData, BmpColorData, sizeof( COLORDATA ) ) ; 
			AlphaBaseImage = &AlphaBmpImage ;
		}
#else // WINDOWS_DESKTOP_OS
		return -1 ;
#endif // WINDOWS_DESKTOP_OS
	}

	// f[^̏񂪈؂ȂAobNAbvۂtOĂꍇ̓obNAbvȂ
	if( GParam->NotGraphBaseDataBackupFlag || ( FileName == NULL && MemImage == NULL && BaseImage == NULL && SrcImage == NULL ) )
	{
		Image->ReadBase = NULL ;
	}
	else
	{
		// Lnh̎w肪ꍇ͋LZbg
		if( SrcImage != NULL )
		{
			// t@C̃AhXႤ
			Image->ReadBase = SrcImage->ReadBase ;

			// QƐ𑝂₷
			if( SrcImage->ReadBase )
			{
				SrcImage->ReadBase->RefCount ++ ;
			}
		}
		else
		{
			// t@CLȏꍇ̓t@Cۑ
			if( FileName )
			{
				// tpX擾
				ConvertFullPathW_( FileName, Path, sizeof( Path ) ) ;

				// t@Cۑp̃m
				Len = ( int )_WCSLEN( Path ) ;
				Image->ReadBase = ( IMAGEDATA_READBASE * )DXCALLOC( sizeof( IMAGEDATA_READBASE ) + ( Len + 1 ) * sizeof( wchar_t ) ) ;
				if( Image->ReadBase == NULL )
				{
					DXST_LOGFILE_ADDUTF16LE( "\xe2\x8e\x01\x90\x59\x30\x8b\x30\x3b\x75\xcf\x50\xd5\x30\xa1\x30\xa4\x30\xeb\x30\x6e\x30\xd5\x30\xa1\x30\xa4\x30\xeb\x30\x0d\x54\x92\x30\xdd\x4f\x58\x5b\x59\x30\x8b\x30\xe1\x30\xe2\x30\xea\x30\x18\x98\xdf\x57\x6e\x30\xba\x78\xdd\x4f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"]摜t@C̃t@Cۑ郁̈̊mۂɎs܂\n" @*/ ) ;
					return -1 ;
				}
				Image->ReadBase->FileName = ( wchar_t * )( Image->ReadBase + 1 ) ;

				// t@CpXۑ
				_MEMCPY( Image->ReadBase->FileName, Path, ( Len + 1 ) * sizeof( wchar_t ) ) ;
			}
			else
			// C[WLȏꍇ̓C[Wۑ
			if( MemImage )
			{
				// C[Wۑp̃m
				Image->ReadBase = ( IMAGEDATA_READBASE * )DXALLOC( sizeof( IMAGEDATA_READBASE ) + MemImageSize + AlphaMemImageSize ) ;
				if( Image->ReadBase == NULL )
				{
					DXST_LOGFILE_ADDUTF16LE( "\xe2\x8e\x01\x90\x59\x30\x8b\x30\x3b\x75\xcf\x50\xc7\x30\xfc\x30\xbf\x30\x92\x30\xdd\x4f\x58\x5b\x59\x30\x8b\x30\xe1\x30\xe2\x30\xea\x30\x18\x98\xdf\x57\x6e\x30\xba\x78\xdd\x4f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"]摜f[^ۑ郁̈̊mۂɎs܂\n" @*/ ) ;
					return -1 ;
				}
				_MEMSET( Image->ReadBase, 0, sizeof( IMAGEDATA_READBASE ) ) ;

				// C[Wۑ
				Image->ReadBase->MemImage = Image->ReadBase + 1 ;
				Image->ReadBase->MemImageSize = MemImageSize ;
				_MEMCPY( Image->ReadBase->MemImage, MemImage, ( size_t )MemImageSize ) ;

				if( AlphaMemImage )
				{
					Image->ReadBase->AlphaMemImage = ( BYTE * )Image->ReadBase->MemImage + MemImageSize ;
					Image->ReadBase->AlphaMemImageSize = AlphaMemImageSize ;
					_MEMCPY( Image->ReadBase->AlphaMemImage, AlphaMemImage, ( size_t )AlphaMemImageSize ) ;
				}
			}
			else
			// {C[Wf[^Lȏꍇ͊{C[Wf[^ۑ
			if( BaseImage )
			{
				unsigned int ImageSize, AlphaImageSize = 0 ;
				unsigned int AllocSize ;

				ImageSize =  ( unsigned int )NS_GetBaseImageGraphDataSize( BaseImage ) ;
				AllocSize = ImageSize + sizeof( BASEIMAGE ) ;
				if( AlphaBaseImage )
				{
					AlphaImageSize = ( unsigned int )NS_GetBaseImageGraphDataSize( AlphaBaseImage ) ;
					AllocSize += AlphaImageSize + sizeof( BASEIMAGE ) ;
				}

				// {C[Wۑp̃m
				Image->ReadBase = ( IMAGEDATA_READBASE * )DXALLOC( sizeof( IMAGEDATA_READBASE ) + AllocSize ) ;
				if( Image->ReadBase == NULL )
				{
					DXST_LOGFILE_ADDUTF16LE( "\xe2\x8e\x01\x90\x59\x30\x8b\x30\xfa\x57\x2c\x67\xa4\x30\xe1\x30\xfc\x30\xb8\x30\x92\x30\xdd\x4f\x58\x5b\x59\x30\x8b\x30\xe1\x30\xe2\x30\xea\x30\x18\x98\xdf\x57\x6e\x30\xba\x78\xdd\x4f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"]{C[Wۑ郁̈̊mۂɎs܂\n" @*/ ) ;
					return -1 ;
				}
				_MEMSET( Image->ReadBase, 0, sizeof( IMAGEDATA_READBASE ) ) ;

				// {C[Wɕۑ
				Image->ReadBase->BaseImage = ( BASEIMAGE * )( Image->ReadBase + 1 ) ;
				_MEMCPY( Image->ReadBase->BaseImage, BaseImage, sizeof( BASEIMAGE ) ) ;
				Image->ReadBase->BaseImage->GraphData = Image->ReadBase->BaseImage + 1 ;
				_MEMCPY( Image->ReadBase->BaseImage->GraphData, BaseImage->GraphData, ImageSize ) ;

				if( AlphaBaseImage )
				{
					Image->ReadBase->AlphaBaseImage = ( BASEIMAGE * )( ( BYTE * )Image->ReadBase->BaseImage->GraphData + ImageSize ) ;
					_MEMCPY( Image->ReadBase->AlphaBaseImage, AlphaBaseImage, sizeof( BASEIMAGE ) ) ;
					Image->ReadBase->AlphaBaseImage->GraphData = Image->ReadBase->AlphaBaseImage + 1 ;
					_MEMCPY( Image->ReadBase->AlphaBaseImage->GraphData, AlphaBaseImage->GraphData, AlphaImageSize ) ;
				}
			}

			// ]tOۑ
			Image->ReadBase->ReverseFlag = ReverseFlag ;

			// Zς݃ϊtOۑ
			Image->ReadBase->ConvertPremultipliedAlpha = ConvertPremultipliedAlpha ;

			// ߐFgpǂۑ
			Image->ReadBase->NotUseTransColor = NotUseTransColor ;

			// QƐPɂ
			Image->ReadBase->RefCount = 1 ;
		}
	}

	// I
	return 0 ;
}

// 摜̌f[^̏ۑ
extern int Graphics_Image_SetGraphBaseInfo(
	int GrHandle,
	const wchar_t *FileName,
	const COLORDATA *BmpColorData,
	HBITMAP RgbBmp,
	HBITMAP AlphaBmp,
	const void *MemImage,
	int MemImageSize,
	const void *AlphaMemImage,
	int AlphaMemImageSize,
	const BASEIMAGE *BaseImage,
	const BASEIMAGE *AlphaBaseImage,
	int ReverseFlag,
	int ConvertPremultipliedAlpha,
	int NotUseTransColor,
	int UnionGrHandle,
	int ASyncThread
)
{
	SETGRAPHBASEINFO_GPARAM GParam ;

	Graphics_Image_InitSetGraphBaseInfoGParam( &GParam ) ;

	return Graphics_Image_SetBaseInfo_UseGParam( &GParam, GrHandle, FileName, BmpColorData, RgbBmp, AlphaBmp, MemImage, MemImageSize,
										AlphaMemImage, AlphaMemImageSize, BaseImage, AlphaBaseImage, ReverseFlag, ConvertPremultipliedAlpha, NotUseTransColor, UnionGrHandle, ASyncThread ) ;
}

// ̃t@C摜ǂݍ񂾏ꍇ̃t@CpXZbg
extern int Graphics_Image_SetName( int GrHandle, const wchar_t *GraphName, int ReverseFlag, int ConvertPremultipliedAlpha, int NotUseTransColor, int UnionGrHandle, int ASyncThread )
{
	return Graphics_Image_SetGraphBaseInfo( GrHandle, GraphName, NULL, NULL, NULL, NULL, 0, NULL, 0, NULL, NULL, ReverseFlag, ConvertPremultipliedAlpha, NotUseTransColor, UnionGrHandle, ASyncThread ) ;
}

// FillGraph ̃O[oϐɃANZXȂo[W
extern int Graphics_Image_FillGraph_UseGParam(
	int GrHandle,
	int Red,
	int Green,
	int Blue,
	int Alpha,
	int ASyncThread
)
{
	IMAGEDATA *Image ;
//	IMAGEDATA_ORIG *Orig ;
	RECT Rect ;

	// G[
	if( ASyncThread )
	{
		if( GRAPHCHK_ASYNC( GrHandle, Image ) )
			return -1 ;
	}
	else
	{
		if( GRAPHCHK( GrHandle, Image ) )
			return -1 ;
	}
//	Orig = Image->Orig ;

	// h摜̏ꍇ NS_FillRectGraph gp
	if( Image->Orig->Width != Image->WidthI ||
		Image->Orig->Height != Image->HeightI )
	{
		return NS_FillRectGraph( GrHandle, 0, 0, Image->WidthI, Image->HeightI, Red, Green, Blue, Alpha ) ;
	}

	// l̕␳
	if( Red   < 0 ) Red   = 0 ; else if( Red   > 255 ) Red   = 255 ;
	if( Green < 0 ) Green = 0 ; else if( Green > 255 ) Green = 255 ;
	if( Blue  < 0 ) Blue  = 0 ; else if( Blue  > 255 ) Blue  = 255 ;
	if( Alpha < 0 ) Alpha = 0 ; else if( Alpha > 255 ) Alpha = 255 ;

	// eNX`ǂŏ𕪊
	if( Image->Orig->FormatDesc.TextureFlag )
	{
		int Result ;

		// eNX`̏ꍇ
		Result = Graphics_Hardware_FillGraph_PF( Image, Red, Green, Blue, Alpha, ASyncThread ) ;

		// ߂lQꍇ͕Ws
		if( Result == 2 )
		{
			BASEIMAGE TempImage ;

			if( NS_CreateARGB8ColorBaseImage( Image->WidthI, Image->HeightI, &TempImage ) == 0 )
			{
				NS_FillBaseImage( &TempImage, Red, Green, Blue, Alpha ) ;
				NS_BltBmpOrGraphImageToGraph( NULL, NULL, NULL, FALSE, &TempImage, NULL, 0, 0, GrHandle ) ;
				NS_ReleaseBaseImage( &TempImage ) ;
			}
			else
			{
				return -1 ;
			}
		}
		else
		if( Result < 0 )
		{
			return -1 ;
		}
	}
	else
	{
		// eNX`ł͂Ȃꍇ

		// DrawFillBoxMemImg œhԂ
		Rect.left   = 0 ;
		Rect.top    = 0 ;
		Rect.right  = Image->WidthI ;
		Rect.bottom = Image->HeightI ;
		DrawFillBoxMemImg( &Image->Soft.MemImg, &Rect, NS_GetColor( Red, Green, Blue ) ) ; 
	}

	// I
	return 0 ;
}

#ifndef DX_NON_MOVIE

// [r[摜XV
extern void Graphics_Image_UpdateGraphMovie( MOVIEGRAPH *Movie, DWORD_PTR GrHandle )
{
	IMAGEDATA *Image ;
//	IMAGEDATA_ORIG *Orig ;

	if( GRAPHCHK( ( LONG_PTR )GrHandle, Image ) )
		return;
//	Orig = Image->Orig ;

	// eNX`ǂŏ𕪊
	if( Image->Orig->FormatDesc.TextureFlag )
	{
		// eNX`̏ꍇ

	//	D_DDSURFACEDESC2 SrcDesc ;
		BASEIMAGE MovieImage, AlphaBaseImage ;
		RECT SrcRect ;

		// [r[C[W̍\z
#ifndef DX_NON_OGGTHEORA
		// Ogg Theora gpĂꍇ͂ōXV
		if( Movie->TheoraFlag )
		{
//			if( Movie->RightAlpha == TRUE )
//			{
//				if( TheoraDecode_SetupImage( Movie->TheoraHandle, 1, 0, 0 ) == 0 )
//				{
//					return ;
//				}
//			}
//			else
			if( TheoraDecode_GetYUVImage( Movie->TheoraHandle ) != NULL )
			{
				if( TheoraDecode_SetupImage( Movie->TheoraHandle, 0, 0, 1 ) == 0 )
				{
					if( Movie->TheoraSetupGraphHandleImage )
					{
						return ;
					}
				}
			}
			else
			if( GSYS.HardInfo.UseShader && Movie->NotUseYUVFormatSurfaceFlag == FALSE )
			{
				if( TheoraDecode_SetupImage( Movie->TheoraHandle, 0, 1, 0 ) == 0 )
				{
					if( Movie->TheoraSetupGraphHandleImage )
					{
						return ;
					}
				}
			}
			else
			{
				if( TheoraDecode_SetupImage( Movie->TheoraHandle, 1, 0, 0 ) == 0 )
				{
					if( Movie->TheoraSetupGraphHandleImage )
					{
						return ;
					}
				}
			}
		}

		// Theora gpĂāA摜̉EAt@ł͂ȂA YUY2 tH[}bggpĂ邩ŏ𕪊
		if( Movie->TheoraFlag && Movie->RightAlpha == FALSE && TheoraDecode_GetYUVImage( Movie->TheoraHandle ) != NULL )
		{
			Graphics_Hardware_UpdateGraphMovie_TheoraYUV_PF( Movie, Image ) ;
			Movie->TheoraSetupGraphHandleImage = TRUE ;
		}
		else
		// Theora gpĂāA摜̉EAt@ł͂ȂAVF[_[gpłꍇ͏𕪊
		if( Movie->TheoraFlag && Movie->NotUseYUVFormatSurfaceFlag == FALSE && GSYS.HardInfo.UseShader )
		{
			// tB^[gpRGBJ[ɕϊ
			if( Movie->RightAlpha )
			{
				NS_GraphFilterRectBlt(
					TheoraDecode_GetYGrHandle( Movie->TheoraHandle ),
					( int )GrHandle,
					0, 0, Movie->Width / 2, Movie->Height, 0, 0,
					DX_GRAPH_FILTER_Y2UV1_TO_RGB_RRA,
					TheoraDecode_GetUVGrHandle( Movie->TheoraHandle )
				) ;
			}
			else
			{
				NS_GraphFilterBlt(
					TheoraDecode_GetYGrHandle( Movie->TheoraHandle ),
					( int )GrHandle,
					DX_GRAPH_FILTER_Y2UV1_TO_RGB, 
					TheoraDecode_GetUVGrHandle( Movie->TheoraHandle )
				) ;
			}
			Movie->TheoraSetupGraphHandleImage = TRUE ;
		}
		else
#endif
#ifndef DX_NON_FILTER
		if( Movie->YGrHandle >= 0 )
		{
			// tB^[gpRGBJ[ɕϊ
			NS_GraphFilterBlt(
				Movie->YGrHandle,
				( int )GrHandle,
				DX_GRAPH_FILTER_Y2UV1_TO_RGB, 
				Movie->UVGrHandle
			) ;
		}
		else
#endif // DX_NON_FILTER
		if( Movie->UseNowImage != NULL )
		{
			// [r[̃C[W쐬
			MovieImage = *Movie->UseNowImage ;
			
			// EAt@̏ꍇ̓At@]鏀
			if( Movie->RightAlpha )
			{
				MovieImage.Width /= 2;
				AlphaBaseImage = MovieImage;
				AlphaBaseImage.GraphData = (BYTE *)MovieImage.GraphData + MovieImage.Width * MovieImage.ColorData.PixelByte ;
			}

			// ]`Zbg
			SETRECT( SrcRect, Image->UseOrigXI, Image->UseOrigYI, Image->UseOrigXI + Image->WidthI, Image->UseOrigYI + Image->HeightI ) ;

			// ĂeNX`[ɓ\t
			Graphics_Image_BltBmpOrBaseImageToGraph3(
				&SrcRect,
				0,
				0,
				( int )GrHandle,
				&MovieImage,
				Movie->RightAlpha ? &AlphaBaseImage : NULL,
				FALSE,
				FALSE,
				FALSE ) ;
		}
	}
	else
	{
		// eNX`ł͖ꍇ
		MEMIMG *MemImg ;

		MemImg = &Image->Soft.MemImg ;

#ifndef DX_NON_OGGTHEORA
		// Ogg Theora gpĂꍇ͂ōXV
		if( Movie->TheoraFlag )
		{
			if( TheoraDecode_SetupImage( Movie->TheoraHandle, 1, 0, 0 ) == 0 )
			{
				if( Movie->TheoraSetupGraphHandleImage )
				{
					return ;
				}
				Movie->TheoraSetupGraphHandleImage = TRUE ;
			}
		}
#endif

		// sNZtH[}bgႤAEAt@ƂĈꍇ̓J[}b`O]s
		if( Movie->SurfaceMode == DX_MOVIESURFACE_FULLCOLOR ||
			MemImg->Base->ColorDataP->ColorBitDepth != Movie->UseNowImage->ColorData.ColorBitDepth ||
			Movie->RightAlpha == 1 )
		{
			// EAt@ł͂Ȃꍇ͊ȈՓ]
			if( Movie->RightAlpha == 0 )
			{
				BltBaseImageToMemImg(
					Movie->UseNowImage,
					NULL,
					MemImg,
					0,
					0,
					Image->WidthI,
					Image->HeightI,
					0,
					0,
					FALSE ) ;
			}
			else
			{
				// EAt@̏ꍇ͒ʏ]
				BASEIMAGE MovieImage, AlphaBaseImage;
//				RECT SrcRect ;

//				SETRECT( SrcRect, 0, 0, Image->WidthI, Image->HeightI ) ;
				MovieImage.ColorData	= Movie->UseNowImage->ColorData ;
				MovieImage.GraphData	= Movie->UseNowImage->GraphData ;
				MovieImage.Pitch		= Movie->UseNowImage->Pitch ;
				MovieImage.Width		= Movie->UseNowImage->Width / 2;
				MovieImage.Height		= Movie->UseNowImage->Height ;

				AlphaBaseImage = MovieImage;
				AlphaBaseImage.GraphData = (BYTE *)MovieImage.GraphData + MovieImage.Width * MovieImage.ColorData.PixelByte ;

				// OtBbN̓]
				BltBaseImageToMemImg(
					&MovieImage,
					&AlphaBaseImage,
					MemImg,
					0,
					0,
					Image->WidthI,
					Image->HeightI,
					0,
					0,
					FALSE ) ;
			}
		}
		else
		{
			// ]vO
			void *DestP, *SrcP ;
			int SrcAddPitch, DestAddPitch ;
			int DwMoveSetNum, NokoriMoveSetNum ;
			int MoveLineByte, ColorBitDepth ;
			int PixelByte ;
			int BltHeight ;

			// ]郉CZbg
			BltHeight = Movie->Height ;

			// FrbgZbg
			ColorBitDepth = NS_GetColorBitDepth() ;

			// Phbg̃oCg擾
			PixelByte = ColorBitDepth / 8 ;

			// PC̓]TCYZbg
			MoveLineByte = Movie->Width * PixelByte ;

			// ]AAhXZbg
			DestP = MemImg->UseImage ;
			SrcP = Movie->UseNowImage->GraphData ;

			// PC]A̓]AhX܂ł̃oCgvZ
			DestAddPitch = ( int )( MemImg->Base->Pitch - MoveLineByte ) ;
			SrcAddPitch  = Movie->UseNowImage->Pitch - MoveLineByte ;

			// SoCg]Ǎ゠܂]sNZ邩Zo
			DwMoveSetNum = MoveLineByte / 4 ;
			NokoriMoveSetNum = ( MoveLineByte - DwMoveSetNum * 4 ) / PixelByte ;

			// ]
#ifndef DX_NON_INLINE_ASM
			_asm{
				PUSHF
				CLD
				MOV		EDI, DestP
				MOV		ESI, SrcP
				MOV		EAX, DestAddPitch
				MOV		EBX, SrcAddPitch
				MOV		EDX, BltHeight
				CMP		ColorBitDepth, 8
				JZ		CB8
				CMP		ColorBitDepth, 16
				JZ		CB16


			CB32:
				MOV		ECX, DwMoveSetNum
				REP		MOVSD
				ADD		EDI, DestAddPitch
				ADD		ESI, SrcAddPitch
				DEC		EDX
				JNZ		CB32
				JMP		END_


			CB16:
				MOV		ECX, DwMoveSetNum
				TEST	ECX, 0xffffffff
				JZ		B161
				REP		MOVSD
			B161:
				MOV		ECX, NokoriMoveSetNum
				TEST	ECX, 0xffffffff
				JZ		B162
				REP		MOVSW
			B162:
				ADD		EDI, DestAddPitch
				ADD		ESI, SrcAddPitch
				DEC		EDX
				JNZ		CB16
				JMP		END_


			CB8:
				MOV		ECX, DwMoveSetNum
				TEST	ECX, 0xffffffff
				JZ		B81
				REP		MOVSD
			B81:
				MOV		ECX, NokoriMoveSetNum
				TEST	ECX, 0xffffffff
				JZ		B82
				REP		MOVSB
			B82:
				ADD		EDI, DestAddPitch
				ADD		ESI, SrcAddPitch
				DEC		EDX
				JNZ		CB8
				JMP		END_

			END_:
				POPF
			}
#else
			int i, j ;
			BYTE *DestBP, *SrcBP ;

			DestBP = ( BYTE * )DestP ;
			SrcBP = ( BYTE * )SrcP ;
			switch( ColorBitDepth )
			{
			case 8 :
				for( i = BltHeight ; i > 0 ; i -- )
				{
					for( j = DwMoveSetNum ; j > 0 ; j --, DestBP += 4, SrcBP += 4 )
					{
						*( ( DWORD * )DestBP ) = *( ( DWORD * )SrcBP ) ;
					}
					for( j = NokoriMoveSetNum ; j > 0 ; j --, DestBP ++, SrcBP ++ )
					{
						*DestBP = *SrcBP ;
					}
					DestBP += DestAddPitch ;
					SrcBP += SrcAddPitch ;
				}
				break ;

			case 16 :
				for( i = BltHeight ; i > 0 ; i -- )
				{
					for( j = DwMoveSetNum ; j > 0 ; j --, DestBP += 4, SrcBP += 4 )
					{
						*( ( DWORD * )DestBP ) = *( ( DWORD * )SrcBP ) ;
					}
					for( j = NokoriMoveSetNum ; j > 0 ; j --, DestBP += 2, SrcBP += 2 )
					{
						*( ( WORD * )DestBP ) = *( ( WORD * )SrcBP ) ;
					}
					DestBP += DestAddPitch ;
					SrcBP += SrcAddPitch ;
				}
				break ;

			case 32 :
				for( i = BltHeight ; i > 0 ; i -- )
				{
					for( j = DwMoveSetNum ; j > 0 ; j --, DestBP += 4, SrcBP += 4 )
					{
						*( ( DWORD * )DestBP ) = *( ( DWORD * )SrcBP ) ;
					}
					DestBP += DestAddPitch ;
					SrcBP += SrcAddPitch ;
				}
				break ;
			}
#endif
		}
	}
}

#endif

// w MipLevel ̃TCYvZ
extern int Graphics_Image_CalcMipSize( int OrigWidth, int OrigHeight, int MipLevel, int *CalcWidth, int *CalcHeight )
{
	int i ;

	for( i = 0 ; i < MipLevel ; i ++ )
	{
		OrigWidth  /= 2 ;
		OrigHeight /= 2 ;
	}
	if( OrigWidth <= 0 )
	{
		OrigWidth = 1 ;
	}
	if( OrigHeight <= 0 )
	{
		OrigHeight = 1 ;
	}

	if( CalcWidth != NULL )
	{
		*CalcWidth = OrigWidth ;
	}

	if( CalcHeight != NULL )
	{
		*CalcHeight = OrigHeight ;
	}

	return 0 ;
}

// BltBmpOrGraphImageToGraph ̓֐
extern int Graphics_Image_BltBmpOrGraphImageToGraphBase(
	const BASEIMAGE		*RgbBaseImage,
	const BASEIMAGE		*AlphaBaseImage,
	      int			CopyPointX,
	      int			CopyPointY,
	      int			GrHandle,
	      int			UseTransColorConvAlpha,
	      int			ASyncThread
)
{
	IMAGEDATA		*Image ;
	IMAGEDATA_ORIG	*Orig ;
	RECT			SrcRect ;

	if( GSYS.InitializeFlag == FALSE )
	{
		return -1 ;
	}

	// G[
	if( ASyncThread )
	{
		if( GRAPHCHK_ASYNC( GrHandle, Image ) )
			return -1 ;
	}
	else
	{
		if( GRAPHCHK( GrHandle, Image ) )
			return -1 ;
	}
	Orig = Image->Orig ;

	// ]`̏
	SrcRect.left   = CopyPointX ;
	SrcRect.top    = CopyPointY ;
	SrcRect.right  = CopyPointX + RgbBaseImage->Width ;
	SrcRect.bottom = CopyPointY + RgbBaseImage->Height ;

	// gp̈ۑ
	Image->UseBaseXI =          SrcRect.left ;
	Image->UseBaseXF = ( float )SrcRect.left ;
	Image->UseBaseYI =          SrcRect.top ; 
	Image->UseBaseYF = ( float )SrcRect.top ; 

	// 摜̓]
	return Graphics_Image_BltBmpOrBaseImageToGraph3(
				&SrcRect,
				0,
				0,
				GrHandle,
				RgbBaseImage,
				AlphaBaseImage,
				Orig->FormatDesc.BlendGraphFlag,
				UseTransColorConvAlpha,
				FALSE,
				ASyncThread
			) ;
}

// BltBmpOrGraphImageToGraph2 ̓֐
extern int Graphics_Image_BltBmpOrGraphImageToGraph2Base(
	const BASEIMAGE		*RgbBaseImage,
	const BASEIMAGE		*AlphaBaseImage,
	const RECT			*SrcRect,
	      int			DestX,
	      int			DestY,
	      int			GrHandle,
	      int			UseTransColorConvAlpha,
	      int			ASyncThread
)
{
	IMAGEDATA		*Image ;
	IMAGEDATA_ORIG *Orig ;

	if( GSYS.InitializeFlag == FALSE )
	{
		return -1 ;
	}

	// G[
	if( ASyncThread )
	{
		if( GRAPHCHK_ASYNC( GrHandle, Image ) )
			return -1 ;
	}
	else
	{
		if( GRAPHCHK( GrHandle, Image ) )
			return -1 ;
	}
	Orig = Image->Orig ;

	// gp̈ۑ
	Image->UseBaseXI =            SrcRect->left - DestX   ;
	Image->UseBaseXF = ( float )( SrcRect->left - DestX ) ;
	Image->UseBaseYI =            SrcRect->top  - DestY   ; 
	Image->UseBaseYF = ( float )( SrcRect->top  - DestY ) ; 

	// 摜̓]
	return Graphics_Image_BltBmpOrBaseImageToGraph3(
				SrcRect,
				DestX,
				DestY,
				GrHandle,
				RgbBaseImage,
				AlphaBaseImage, 
				Orig->FormatDesc.BlendGraphFlag,
				UseTransColorConvAlpha,
				FALSE,
				ASyncThread
			) ;
}

// BltBmpOrGraphImageToDivGraph ̓֐
extern int Graphics_Image_BltBmpOrGraphImageToDivGraphBase(
	const BASEIMAGE	*RgbBaseImage,
	const BASEIMAGE	*AlphaBaseImage,
	      int		AllNum,
	      int		XNum,
	      int		/*YNum*/,
		  int		/*IsFloat*/,
	      int		WidthI,
	      float		WidthF,
	      int		HeightI,
	      float		HeightF,
	      int		StrideWI,
	      float		StrideWF,
	      int		StrideHI,
	      float		StrideHF,
	const int		*GrHandle,
	      int		ReverseFlag,
	      int		UseTransColorConvAlpha,
	      int		ASyncThread
)
{
	IMAGEDATA		*Image ;
	IMAGEDATA		*DivImage ;
	IMAGEDATA_ORIG	*Orig ;
	RECT			Rect ;
	int				i ;
	int				Count ;
	int				x ;
	int				y ;

	if( GSYS.InitializeFlag == FALSE )
	{
		return -1 ;
	}

	// G[
	if( ASyncThread )
	{
		if( GRAPHCHK_ASYNC( GrHandle[ 0 ], Image ) )
			return -1 ;
	}
	else
	{
		if( GRAPHCHK( GrHandle[ 0 ], Image ) )
			return -1 ;
	}
	Orig = Image->Orig ;

	// ŏ̉摜Ƀt@CZbg
	Image->UseBaseXI = 0    ;
	Image->UseBaseXF = 0.0f ;
	Image->UseBaseYI = 0    ;
	Image->UseBaseYF = 0.0f ;

	// t@CɏZbgȂ炷ׂẲ摜
	// IWi摜gpĂ邩ׂ
	Count = 1 ;
	x     = 0 ;
	y     = 0 ;
	for( i = 1 ; i < AllNum ; i ++ )
	{
		// 摜̃AhX擾
		if( ASyncThread )
		{
			if( GRAPHCHK_ASYNC( GrHandle[ i ], DivImage ) )
				return -1 ;
		}
		else
		{
			if( GRAPHCHK( GrHandle[ i ], DivImage ) )
				return -1 ;
		}

		// IWi摜gpĂ邩ǂׂ
		if( DivImage->Orig == Orig ) Count ++ ;

		// t@CZbg
		if( ReverseFlag )
		{
			DivImage->UseBaseXI = ( ( XNum - 1 ) - x ) * StrideWI ;
			DivImage->UseBaseXF = ( ( XNum - 1 ) - x ) * StrideWF ;
		}
		else
		{
			DivImage->UseBaseXI = x * StrideWI ;
			DivImage->UseBaseXF = x * StrideWF ;
		}
		DivImage->UseBaseYI = y * StrideHI ;
		DivImage->UseBaseYF = y * StrideHF ;
		x ++ ;
		if( x == XNum )
		{
			x = 0 ;
			y ++ ;
		}
	}

	// ׂẴOtBbNnhIWi摜
	// gpĂ邩ǂŏ𕪊
	if( AllNum == Count )
	{
		// IWi摜gpĂꍇ

		// IWi摜ŏ̃OtBbNnhɓ]
		Rect.left   = 0 ;
		Rect.right  = Image->Orig->Width ;
		Rect.top    = 0 ;
		Rect.bottom = Image->Orig->Height ;
		Graphics_Image_BltBmpOrBaseImageToGraph3(
			&Rect,
			0, 0,
			GrHandle[ 0 ],
			RgbBaseImage, AlphaBaseImage,
			Orig->FormatDesc.BlendGraphFlag,
			UseTransColorConvAlpha,
			TRUE,
			ASyncThread
		) ;
	}
	else
	{
		// IWi摜gpĂȂꍇ

		// ׂẴOtBbNnhɌʂɓ]
		for( i = 0 ; i < AllNum ; i ++ )
		{
			// 摜̃AhX擾
			if( ASyncThread )
			{
				if( GRAPHCHK_ASYNC( GrHandle[ i ], DivImage ) )
					return -1 ;
			}
			else
			{
				if( GRAPHCHK( GrHandle[ i ], DivImage ) )
					return -1 ;
			}

			// ]`̃Zbg
			Rect.left   = DivImage->UseBaseXI ;
			Rect.top    = DivImage->UseBaseYI ;
			Rect.right  = Rect.left + DivImage->WidthI ;
			Rect.bottom = Rect.top  + DivImage->HeightI ;

			// 摜]
			Graphics_Image_BltBmpOrBaseImageToGraph3(
				&Rect,
				0, 0,
				GrHandle[ i ],
				RgbBaseImage, AlphaBaseImage,
				Orig->FormatDesc.BlendGraphFlag,
				UseTransColorConvAlpha,
				FALSE,
				ASyncThread
			) ;
		}
	}

	// I
	return 0 ;
}

// OtBbNnhɉ摜f[^]邽߂̊֐
extern int Graphics_Image_BltBmpOrBaseImageToGraph3(
	const RECT		*SrcRect,
	      int		DestX,
	      int		DestY,
	      int		GrHandle,
	const BASEIMAGE	*RgbBaseImage,
	const BASEIMAGE	*AlphaBaseImage,
	      int		RedIsAlphaFlag,
	      int		UseTransColorConvAlpha,
	      int		TargetOrig,
	      int		ASyncThread
)
{
	IMAGEDATA		*Image ;
	IMAGEDATA_ORIG	*Orig ;
	RECT			SrcRectTemp = *SrcRect ;
	int				SrcWidth ;
	int				SrcHeight ;
	int				TempBaseRGBIsDXT = FALSE ;
	int				TempBaseAlphaIsDXT = FALSE ;
	BASEIMAGE		TempBaseRGB ;
	BASEIMAGE		TempBaseAlpha ;
	int				RequiredReleaseBaseRGB = FALSE ;
	int				RequiredReleaseBaseAlpha = FALSE ;

	if( GSYS.InitializeFlag == FALSE )
	{
		return -1 ;
	}

	// G[
	if( ASyncThread )
	{
		if( GRAPHCHK_ASYNC( GrHandle, Image ) )
			return -1 ;
	}
	else
	{
		if( GRAPHCHK( GrHandle, Image ) )
			return -1 ;
	}
	Orig = Image->Orig ;

	// ]̏Zbg
	_MEMSET( &TempBaseAlpha, 0, sizeof( TempBaseAlpha ) ) ;
	RequiredReleaseBaseRGB   = FALSE ;
	RequiredReleaseBaseAlpha = FALSE ;

	TempBaseRGB.GraphData      = RgbBaseImage->GraphData ;
	TempBaseRGB.Width          = RgbBaseImage->Width ;
	TempBaseRGB.Height         = RgbBaseImage->Height ;
	TempBaseRGB.Pitch          = RgbBaseImage->Pitch ;
	TempBaseRGB.ColorData      = RgbBaseImage->ColorData ;
	TempBaseRGB.MipMapCount    = RgbBaseImage->MipMapCount ;
	TempBaseRGB.GraphDataCount = RgbBaseImage->GraphDataCount ;

	TempBaseRGBIsDXT =
		( TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT1 ||
		  TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT2 ||
		  TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT3 ||
		  TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT4 ||
		  TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT5 ||
		  TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_BC7_UNORM ||
		  TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_BC7_UNORM_SRGB ) ? TRUE : FALSE ;

	// DXT k̏ꍇ͓]̉摜 4 ̔{ƂȂ
	if( TempBaseRGBIsDXT )
	{
		TempBaseRGB.Width  = ( TempBaseRGB.Width  + 3 ) / 4 * 4 ;
		TempBaseRGB.Height = ( TempBaseRGB.Height + 3 ) / 4 * 4 ;
	}

	if( AlphaBaseImage )
	{
		TempBaseAlpha.GraphData      = AlphaBaseImage->GraphData ;
		TempBaseAlpha.Width          = AlphaBaseImage->Width ;
		TempBaseAlpha.Height         = AlphaBaseImage->Height ;
		TempBaseAlpha.Pitch          = AlphaBaseImage->Pitch ;
		TempBaseAlpha.ColorData      = AlphaBaseImage->ColorData ;
		TempBaseAlpha.MipMapCount    = AlphaBaseImage->MipMapCount ;
		TempBaseAlpha.GraphDataCount = AlphaBaseImage->GraphDataCount ;

		TempBaseAlphaIsDXT =
			( TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT1 ||
			  TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT2 ||
			  TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT3 ||
			  TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT4 ||
			  TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT5 ||
			  TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_BC7_UNORM ||
			  TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_BC7_UNORM_SRGB ) ? TRUE : FALSE ;

		// DXT k̏ꍇ͓]̉摜 4 ̔{ƂȂ
		if( TempBaseAlphaIsDXT )
		{
			TempBaseAlpha.Width  = ( TempBaseAlpha.Width  + 3 ) / 4 * 4 ;
			TempBaseAlpha.Height = ( TempBaseAlpha.Height + 3 ) / 4 * 4 ;
		}
	}

	// ]L[u}bvœ]悪L[u}bvł͂Ȃꍇ̓G[
	if( ( TempBaseRGB.GraphDataCount          != 0 ) !=
		( Orig->FormatDesc.CubeMapTextureFlag != 0 ) )
	{
		return -1 ;
	}

	// ]vZĂ
	if( TempBaseRGBIsDXT )
	{
		SrcRectTemp.left   = ( SrcRectTemp.left   + 3 ) / 4 * 4 ;
		SrcRectTemp.top    = ( SrcRectTemp.top    + 3 ) / 4 * 4 ;
		SrcRectTemp.right  = ( SrcRectTemp.right  + 3 ) / 4 * 4 ;
		SrcRectTemp.bottom = ( SrcRectTemp.bottom + 3 ) / 4 * 4 ;
	}
	SrcWidth  = SrcRectTemp.right  - SrcRectTemp.left ;
	SrcHeight = SrcRectTemp.bottom - SrcRectTemp.top ;
	if( SrcWidth <= 0 || SrcHeight <= 0 )
	{
		return 0 ;
	}

	// BASEIMAGE  DXT ŁA]悪 DXT ł͖ꍇ͂ŕWtH[}bgɕϊ
	{
		int RgbConvFlag   = FALSE ;
		int AlphaConvFlag = FALSE ;
		int Hr1 = 0 ;
		int Hr2 = 0 ;

		// eNX`ł͂Ȃꍇ͂cwstH[}bg̏ꍇ͕WtH[}bgɕϊ
		if( Orig->FormatDesc.TextureFlag == FALSE )
		{
			if( TempBaseRGBIsDXT )
			{
				RgbConvFlag = TRUE ;
			}

			if( TempBaseAlpha.GraphData != NULL )
			{
				if( TempBaseAlphaIsDXT )
				{
					AlphaConvFlag = TRUE ;
				}
			}
		}
		else
		{
			Graphics_CheckRequiredNormalImageConv_BaseImageFormat_PF(
				Orig,
				TempBaseRGB.ColorData.Format,
				&RgbConvFlag,
				TempBaseAlpha.GraphData != NULL ? TempBaseAlpha.ColorData.Format : -1,
				&AlphaConvFlag
			) ;
		}

		if( RgbConvFlag == TRUE )
		{
			Hr1 = ConvertNormalFormatBaseImage( &TempBaseRGB, FALSE ) ;
			if( Hr1 == 0 )
			{
				RequiredReleaseBaseRGB = TRUE ;
			}
		}

		if( AlphaConvFlag == TRUE )
		{
			Hr2 = ConvertNormalFormatBaseImage( &TempBaseAlpha, FALSE ) ;
			if( Hr2 == 0 )
			{
				RequiredReleaseBaseAlpha = TRUE ;
			}
		}

		if( Hr1 < 0 || Hr2 < 0 )
		{
			DXST_LOGFILE_ADDUTF16LE( "\x19\x6a\x96\x6e\xa4\x30\xe1\x30\xfc\x30\xb8\x30\x28\x75\x6e\x30\xe1\x30\xe2\x30\xea\x30\xba\x78\xdd\x4f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"WC[Wp̃mۂɎs܂\n" @*/ ) ;
			goto ERR ;
		}
	}

	// eNX`ǂŏ𕪊
	if( Orig->FormatDesc.TextureFlag )
	{
		// eNX`̏ꍇ@ˑ֐Ă
		if( Graphics_Hardware_BltBmpOrBaseImageToGraph3_PF(
			&SrcRectTemp,
			DestX,
			DestY,
			GrHandle,
			&TempBaseRGB,
			&TempBaseAlpha,
			RedIsAlphaFlag,
			UseTransColorConvAlpha,
			TargetOrig,
			ASyncThread ) < 0 )
		{
			goto ERR ;
		}
	}
	else
	{
		// eNX`ł͂Ȃꍇ

		// MEMIMG ̓]֐g߂̏s

		// IWi摜Ώۂǂŏ𕪊
		if( TargetOrig == TRUE )
		{
			// IWi摜Ώۂ̏ꍇ

			// TCY̕␳
			if( DestX + SrcWidth  > ( int )Orig->Soft.MemImg.Width  )
			{
				SrcWidth  = ( int )( Orig->Soft.MemImg.Width  - DestX ) ;
			}

			if( DestY + SrcHeight > ( int )Orig->Soft.MemImg.Height )
			{
				SrcHeight = ( int )( Orig->Soft.MemImg.Height - DestY ) ;
			}

			if( SrcWidth <= 0 || SrcHeight <= 0 )
			{
				goto ERR ;
			}

			// 摜̓]
			BltBaseImageToMemImg(
				&TempBaseRGB,
				TempBaseAlpha.GraphData == NULL ? NULL : &TempBaseAlpha,
				&Orig->Soft.MemImg,
				SrcRectTemp.left,
				SrcRectTemp.top,
				SrcWidth,
				SrcHeight,
				DestX,
				DestY,
				UseTransColorConvAlpha
			) ;
		}
		else
		{
			// IWi摜Ώۂł͂Ȃꍇ

			// TCY̕␳
			if( DestX + SrcWidth  > Image->WidthI  )
			{
				SrcWidth  = Image->WidthI  - DestX ;
			}

			if( DestY + SrcHeight > Image->HeightI )
			{
				SrcHeight = Image->HeightI - DestY ;
			}

			if( SrcWidth <= 0 || SrcHeight <= 0 ) 
			{
				goto ERR ;
			}

			// 摜̓]
			BltBaseImageToMemImg(
				&TempBaseRGB,
				TempBaseAlpha.GraphData == NULL ? NULL : &TempBaseAlpha,
				&Orig->Soft.MemImg,
				SrcRectTemp.left,
				SrcRectTemp.top,
				SrcWidth,
				SrcHeight,
				Image->UseOrigXI + DestX,
				Image->UseOrigYI + DestY,
				UseTransColorConvAlpha
			) ;
		}

		// pbg摜̏ꍇ͓ߐFR[h𒲐
		if( Orig->FormatDesc.UsePaletteFlag == TRUE && Orig->Soft.MemImg.Base->Palette )
		{
			int   i ;
			DWORD TransCode ;

			// ߐF̎擾
			TransCode = NS_GetColor3( 
					GetMemImgColorData( Orig->FormatDesc.ColorBitDepth == 16 ? 0 : 1, Orig->FormatDesc.AlphaChFlag, FALSE ),
					( int )( ( GSYS.CreateImage.TransColor >> 16 ) & 0xff ),
					( int )( ( GSYS.CreateImage.TransColor >> 8  ) & 0xff ),
					( int )( ( GSYS.CreateImage.TransColor >> 0  ) & 0xff ),
					0xff ) ;

			// w̃J[pbg̒ɂ炻𓧉ߐFɂ
			if( Orig->Soft.MemImg.Base->ColorType == 1 )
			{
				TransCode &= 0xffffff;
				for( i = 0 ; i < 256 ; i ++ )
				{
					if( ( Orig->Soft.MemImg.Base->Palette[i] & 0xffffff ) == TransCode )
					{
						break ;
					}
				}
			}
			else
			{
				TransCode &= 0xffff;
				for( i = 0 ; i < 256 ; i ++ )
				{
					if( ((WORD *)Orig->Soft.MemImg.Base->Palette)[i] == TransCode )
					{
						break ;
					}
				}
			}

			if( i == 256 )
			{
				i = 0 ;
			}

			Orig->Soft.MemImg.Base->TransColor = ( unsigned int )i ;
		}
	}

	if( RequiredReleaseBaseRGB )
	{
		ReleaseBaseImage( &TempBaseRGB ) ;
	}

	if( RequiredReleaseBaseAlpha )
	{
		ReleaseBaseImage( &TempBaseAlpha ) ;
	}

	// I
	return 0 ;

	// G[I
ERR :

	if( RequiredReleaseBaseRGB )
	{
		ReleaseBaseImage( &TempBaseRGB ) ;
	}

	if( RequiredReleaseBaseAlpha )
	{
		ReleaseBaseImage( &TempBaseAlpha ) ;
	}

	return -1 ;
}

// w̃IWi摜ɓ]`쐬
// ߂l  -1:͈͊O   0:I
extern	int		Graphics_Image_BltBmpOrBaseImageToGraph3_Make_OrigTex_MoveRect(
	const IMAGEDATA_ORIG_HARD_TEX	*OrigTex,
	const RECT						*SrcRect,
		  int						SrcWidth,
		  int						SrcHeight,
	      int						DestX,
	      int						DestY,
	      RECT						*DestRect,
	      RECT						*MoveRect,
		  int						IsDXT
)
{
	// ͈͊O牽Ȃ
	if( OrigTex->OrigPosX >= DestX + SrcWidth  ||
		OrigTex->OrigPosY >= DestY + SrcHeight ||
		DestX >= OrigTex->OrigPosX + OrigTex->UseWidth ||
		DestY >= OrigTex->OrigPosY + OrigTex->UseHeight )
	{
		return -1 ;
	}

	// bN]͈͂Ɠ]͈͂̊m
	if( OrigTex->OrigPosX > DestX )
	{
		DestRect->left = 0 ;
		MoveRect->left = OrigTex->OrigPosX - DestX ;
	}
	else
	{
		DestRect->left = DestX - OrigTex->OrigPosX ;
		MoveRect->left = 0 ;
	}

	if( OrigTex->OrigPosX + OrigTex->UseWidth < DestX + SrcWidth )
	{
		DestRect->right = OrigTex->UseWidth ;
		MoveRect->right = ( OrigTex->OrigPosX + OrigTex->UseWidth ) - DestX ;
	}
	else
	{
		DestRect->right = ( DestX + SrcWidth ) - OrigTex->OrigPosX ;
		MoveRect->right = SrcWidth ;
	}

	if( OrigTex->OrigPosY > DestY )
	{
		DestRect->top = 0 ;
		MoveRect->top = OrigTex->OrigPosY - DestY ;
	}
	else
	{
		DestRect->top = DestY - OrigTex->OrigPosY ;
		MoveRect->top = 0 ;
	}

	if( OrigTex->OrigPosY + OrigTex->UseHeight < DestY + SrcHeight )
	{
		DestRect->bottom = OrigTex->UseHeight ;
		MoveRect->bottom = ( OrigTex->OrigPosY + OrigTex->UseHeight ) - DestY ;
	}
	else
	{
		DestRect->bottom = ( DestY + SrcHeight ) - OrigTex->OrigPosY ;
		MoveRect->bottom = SrcHeight ;
	}

	// 摜̓]̈lZ
	MoveRect->left   += SrcRect->left ;
	MoveRect->top    += SrcRect->top ;
	MoveRect->right  += SrcRect->left ;
	MoveRect->bottom += SrcRect->top ;

	// DXT `̏ꍇ 4 ̔{ɕ␳
	if( IsDXT )
	{
		DestRect->left   = ( DestRect->left   + 3 ) / 4 * 4 ;
		DestRect->top    = ( DestRect->top    + 3 ) / 4 * 4 ;
		DestRect->right  = ( DestRect->right  + 3 ) / 4 * 4 ;
		DestRect->bottom = ( DestRect->bottom + 3 ) / 4 * 4 ;

		MoveRect->left   = ( MoveRect->left   + 3 ) / 4 * 4 ;
		MoveRect->top    = ( MoveRect->top    + 3 ) / 4 * 4 ;
		MoveRect->right  = ( MoveRect->right  + 3 ) / 4 * 4 ;
		MoveRect->bottom = ( MoveRect->bottom + 3 ) / 4 * 4 ;
	}

	// I
	return 0 ;
}

// w̕`p摜ɓ]`쐬
// ߂l  -1:͈͊O   0:I
extern	int		Graphics_Image_BltBmpOrBaseImageToGraph3_Make_DrawTex_MoveRect(
	const IMAGEDATA_HARD_DRAW		*DrawTex,
	const RECT						*SrcRect,
		  int						SrcWidth,
		  int						SrcHeight,
	      int						DestX,
	      int						DestY,
	      RECT						*DestRect,
	      RECT						*MoveRect,
		  int						IsDXT
)
{
	// ͈͊O牽Ȃ
	if( DrawTex->DrawPosXI >= DestX + SrcWidth ||
		DrawTex->DrawPosYI >= DestY + SrcHeight ||
		DestX >= DrawTex->DrawPosXI + DrawTex->WidthI ||
		DestY >= DrawTex->DrawPosYI + DrawTex->HeightI )
	{
		return -1 ;
	}

	// bN]͈͂Ɠ]͈͂̊m
	if( DrawTex->DrawPosXI > DestX )
	{
		DestRect->left = 0 ;
		MoveRect->left = DrawTex->DrawPosXI - DestX ;
	}
	else
	{
		DestRect->left = DestX - DrawTex->DrawPosXI ;
		MoveRect->left = 0 ;
	}

	if( DrawTex->DrawPosXI + DrawTex->WidthI < DestX + SrcWidth )
	{
		DestRect->right = DrawTex->WidthI ;
		MoveRect->right = ( DrawTex->DrawPosXI + DrawTex->WidthI ) - DestX ;
	}
	else
	{
		DestRect->right = ( DestX + SrcWidth ) - DrawTex->DrawPosXI ;
		MoveRect->right = SrcWidth ;
	}

	if( DrawTex->DrawPosYI > DestY )
	{
		DestRect->top = 0 ;
		MoveRect->top = DrawTex->DrawPosYI - DestY ;
	}
	else
	{
		DestRect->top = DestY - DrawTex->DrawPosYI ;
		MoveRect->top = 0 ;
	}

	if( DrawTex->DrawPosYI + DrawTex->HeightI < DestY + SrcHeight )
	{
		DestRect->bottom = DrawTex->HeightI ;
		MoveRect->bottom = ( DrawTex->DrawPosYI + DrawTex->HeightI ) - DestY ;
	}
	else
	{
		DestRect->bottom = ( DestY + SrcHeight ) - DrawTex->DrawPosYI ;
		MoveRect->bottom = SrcHeight ;
	}

	// eNX`̎ẅlZ
	DestRect->left   += DrawTex->UsePosXI ;
	DestRect->top    += DrawTex->UsePosYI ;
	DestRect->right  += DrawTex->UsePosXI ;
	DestRect->bottom += DrawTex->UsePosYI ;

	// 摜̓]̈lZ
	MoveRect->left   += SrcRect->left ;
	MoveRect->top    += SrcRect->top ;
	MoveRect->right  += SrcRect->left ;
	MoveRect->bottom += SrcRect->top ;

	// DXT `̏ꍇ 4 ̔{ɕ␳
	if( IsDXT )
	{
		DestRect->left   = ( DestRect->left   + 3 ) / 4 * 4 ;
		DestRect->top    = ( DestRect->top    + 3 ) / 4 * 4 ;
		DestRect->right  = ( DestRect->right  + 3 ) / 4 * 4 ;
		DestRect->bottom = ( DestRect->bottom + 3 ) / 4 * 4 ;

		MoveRect->left   = ( MoveRect->left   + 3 ) / 4 * 4 ;
		MoveRect->top    = ( MoveRect->top    + 3 ) / 4 * 4 ;
		MoveRect->right  = ( MoveRect->right  + 3 ) / 4 * 4 ;
		MoveRect->bottom = ( MoveRect->bottom + 3 ) / 4 * 4 ;
	}

	// I
	return 0 ;
}

// `\摜obNobt@ẅ̃OtBbN擾
extern	int Graphics_Image_GetDrawScreenGraphBase( int TargetScreen, int TargetScreenSurface, int TargetScreenMipLevel, int x1, int y1, int x2, int y2, int destX, int destY, int GrHandle )
{
	IMAGEDATA *Image, *TargImage ;
//	IMAGEDATA_HARD_DRAW *DrawTex ;
	int Width, Height ;
//	int i ;
	int TargetScreenWidth ;
	int TargetScreenHeight ;
	RECT Rect ;
//	RECT DestBaseRect ;
//	HRESULT hr ;

	// G[
	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;

	// `̉摜f[^AhX擾
	if( GRAPHCHKFULL( TargetScreen, TargImage ) )
	{
		TargImage = NULL ;
		TargetScreenWidth  = GSYS.DrawSetting.DrawSizeX ;
		TargetScreenHeight = GSYS.DrawSetting.DrawSizeY ;
	}
	else
	{
		TargetScreenWidth  = TargImage->WidthI ;
		TargetScreenHeight = TargImage->HeightI ;
	}

	// `̃f[^sꍇG[
	if( x1 < 0 || x1 >= x2 ||
		y1 < 0 || y1 >= y2 ||
		x2 > TargetScreenWidth ||
		y2 > TargetScreenHeight ) return -1 ;

	// 荞ݐ悪摜͂ݏoĂG[
	Width  = x2 - x1 ;
	Height = y2 - y1 ;
	if( Image->WidthI < Width + destX || Image->HeightI < Height + destY ) return -1 ;
//	DestBaseRect.left   = destX ;
//	DestBaseRect.top    = destY ;
//	DestBaseRect.right  = destX + Width ;
//	DestBaseRect.bottom = destY + Height ;

	// eNX`ǂŏ𕪊
	if( Image->Orig->FormatDesc.TextureFlag )
	{
		// eNX`̏ꍇ
		if( Graphics_Hardware_GetDrawScreenGraphBase_PF( Image, TargImage, TargetScreen, TargetScreenSurface, TargetScreenMipLevel, TargetScreenWidth, TargetScreenHeight, x1, y1, x2, y2, destX, destY ) < 0 )
		{
			return -1 ;
		}
	}
	else
	{
		// \tgEGA_Ȍꍇ

		// `Ώۂ]
		Rect.left   = x1 ;
		Rect.top    = y1 ;
		Rect.right  = x2 ;
		Rect.bottom = y2 ;
		BltMemImg( &Image->Soft.MemImg, TargImage ? &TargImage->Soft.MemImg : &GSYS.SoftRender.MainBufferMemImg, &Rect, destX, destY ) ;
	}

	// I
	return 0 ;
}

// OtBbÑf[^CfbNXlo
extern IMAGEDATA *Graphics_Image_GetData( int GrHandle, int ASyncThread )
{
	IMAGEDATA *Image ;

	// G[
	if( ASyncThread )
	{
		if( GRAPHCHK_ASYNC( GrHandle, Image ) )
			return NULL ;
	}
	else
	{
		if( GRAPHCHK( GrHandle, Image ) )
			return NULL ;
	}

	return Image ;
}

// ^̃eNX`̃nh擾
extern int Graphics_Image_GetWhiteTexHandle( void )
{
	if( GSYS.Resource.WhiteTexHandle <= 0 )
	{
		LOADGRAPH_GPARAM GParam ;
		BASEIMAGE BaseImage ;

		NS_CreateARGB8ColorBaseImage( 8, 8, &BaseImage ) ;
		_MEMSET( BaseImage.GraphData, 0xff, BaseImage.Pitch * 8 ) ;

		Graphics_Image_InitLoadGraphGParam( &GParam ) ;
		Graphics_Image_InitSetupGraphHandleGParam_Normal_NonDrawValid( &GParam.CreateGraphGParam.InitHandleGParam, 16, TRUE, FALSE ) ;
		GParam.CreateGraphGParam.InitHandleGParam.TransColor = ( BYTE )255 << 16 | ( BYTE )0 << 8 | ( BYTE )255 ;
		GSYS.Resource.WhiteTexHandle = Graphics_Image_CreateGraphFromGraphImage_UseGParam( &GParam, FALSE, GSYS.Resource.WhiteTexHandle, &BaseImage, NULL ) ;
		NS_SetDeleteHandleFlag( GSYS.Resource.WhiteTexHandle, &GSYS.Resource.WhiteTexHandle ) ;
		NS_SetDeviceLostDeleteGraphFlag( GSYS.Resource.WhiteTexHandle, TRUE ) ;

		NS_ReleaseBaseImage( &BaseImage ) ;
	}

	return GSYS.Resource.WhiteTexHandle ;
}

// _ȕɉ]ׂ̃mCYeNX`̃nh擾
extern int Graphics_Image_GetRandomKernelRotationTexHandle( void )
{
	if( GSYS.Resource.RandomKernelRotationTexHandle <= 0 )
	{
		LOADGRAPH_GPARAM GParam ;
		BASEIMAGE BaseImage ;
		int W = 4 ;
		int H = 4 ;
		int Size = W * H ;
		BYTE *Src ;
		BYTE *Dest ;
		int i ;

		NS_CreateARGBF32ColorBaseImage( W, H, &BaseImage ) ;
		Src = RandomKernelRotationTextureImage ;
		Dest = ( BYTE * )BaseImage.GraphData ;
		for( i = 0 ; i < Size ; i ++, Src += 4, Dest += 16 )
		{
			Dest[ 0 ] = Dest[ 4 ] = Dest[  8 ] = Src[ 0 ] ;
			Dest[ 1 ] = Dest[ 5 ] = Dest[  9 ] = Src[ 1 ] ;
			Dest[ 2 ] = Dest[ 6 ] = Dest[ 10 ] = Src[ 2 ] ;
			Dest[ 3 ] = Dest[ 7 ] = Dest[ 11 ] = Src[ 3 ] ;
			Dest[ 12 ] = 0x00 ;
			Dest[ 13 ] = 0x00 ;
			Dest[ 14 ] = 0x80 ;
			Dest[ 15 ] = 0x3f ;
		}

		Graphics_Image_InitLoadGraphGParam( &GParam ) ;
		Graphics_Image_InitSetupGraphHandleGParam_Normal_NonDrawValid( &GParam.CreateGraphGParam.InitHandleGParam ) ;
		GParam.CreateGraphGParam.InitHandleGParam.AlphaTestImageCreateFlag = FALSE ;
		GParam.CreateGraphGParam.InitHandleGParam.AlphaChannelImageCreateFlag = FALSE ;
		GParam.CreateGraphGParam.InitHandleGParam.FloatTypeGraphCreateFlag = TRUE ;
		GParam.CreateGraphGParam.InitHandleGParam.CreateImageChannelNum = 4 ;
		GParam.CreateGraphGParam.InitHandleGParam.CreateImageChannelBitDepth = 32 ;
		GSYS.Resource.RandomKernelRotationTexHandle = Graphics_Image_CreateGraphFromGraphImage_UseGParam( &GParam, FALSE, GSYS.Resource.RandomKernelRotationTexHandle, &BaseImage, NULL ) ;
		NS_SetDeleteHandleFlag( GSYS.Resource.RandomKernelRotationTexHandle, &GSYS.Resource.RandomKernelRotationTexHandle ) ;
		NS_SetDeviceLostDeleteGraphFlag( GSYS.Resource.RandomKernelRotationTexHandle, TRUE ) ;

		NS_ReleaseBaseImage( &BaseImage ) ;
	}

	return GSYS.Resource.RandomKernelRotationTexHandle ;
}

// A`GCAXt̐`悷邽߂̃eNX`nh擾
extern int Graphics_Image_GetLineTexHandle( int IsPMA )
{
	if( IsPMA )
	{
		if( GSYS.Resource.LineTexHandle_PMA <= 0 )
		{
			LOADGRAPH_GPARAM GParam ;
			BASEIMAGE BaseImage ;
			BYTE *ImageBase ;
			BYTE *Image ;
			DWORD Pitch ;
			int i, j, k ;

			NS_CreateARGB8ColorBaseImage( 8, 8, &BaseImage ) ;
			ImageBase = ( BYTE * )BaseImage.GraphData ;
			Pitch = ( DWORD )BaseImage.Pitch ;
			k = 0 ;
			for( i = 0 ; i < 8; i ++, ImageBase += Pitch )
			{
				Image = ImageBase ;
				for( j = 0 ; j < 8 ; j ++, Image += 4, k++ )
				{
					Image[ 0 ] = LineTexTga8x8TextureImage[ k ] ;
					Image[ 1 ] = LineTexTga8x8TextureImage[ k ] ;
					Image[ 2 ] = LineTexTga8x8TextureImage[ k ] ;
					Image[ 3 ] = LineTexTga8x8TextureImage[ k ] ;
				}
			}

			Graphics_Image_InitLoadGraphGParam( &GParam ) ;
			Graphics_Image_InitSetupGraphHandleGParam_Normal_NonDrawValid( &GParam.CreateGraphGParam.InitHandleGParam, 16, TRUE, FALSE ) ;
			GParam.CreateGraphGParam.InitHandleGParam.TransColor = ( BYTE )255 << 16 | ( BYTE )0 << 8 | ( BYTE )255 ;
			GSYS.Resource.LineTexHandle_PMA = Graphics_Image_CreateGraphFromGraphImage_UseGParam( &GParam, FALSE, GSYS.Resource.LineTexHandle_PMA, &BaseImage, NULL ) ;
			NS_SetDeleteHandleFlag( GSYS.Resource.LineTexHandle_PMA, &GSYS.Resource.LineTexHandle_PMA ) ;
			NS_SetDeviceLostDeleteGraphFlag( GSYS.Resource.LineTexHandle_PMA, TRUE ) ;

			NS_ReleaseBaseImage( &BaseImage ) ;
		}

		return GSYS.Resource.LineTexHandle_PMA ;
	}
	else
	{
		if( GSYS.Resource.LineTexHandle <= 0 )
		{
			LOADGRAPH_GPARAM GParam ;
			BASEIMAGE BaseImage ;
			BYTE *ImageBase ;
			BYTE *Image ;
			DWORD Pitch ;
			int i, j, k ;

			NS_CreateARGB8ColorBaseImage( 8, 8, &BaseImage ) ;
			ImageBase = ( BYTE * )BaseImage.GraphData ;
			Pitch = ( DWORD )BaseImage.Pitch ;
			k = 0 ;
			for( i = 0 ; i < 8; i ++, ImageBase += Pitch )
			{
				Image = ImageBase ;
				for( j = 0 ; j < 8 ; j ++, Image += 4, k++ )
				{
					Image[ 0 ] = 0xff ;
					Image[ 1 ] = 0xff ;
					Image[ 2 ] = 0xff ;
					Image[ 3 ] = LineTexTga8x8TextureImage[ k ] ;
				}
			}

			Graphics_Image_InitLoadGraphGParam( &GParam ) ;
			Graphics_Image_InitSetupGraphHandleGParam_Normal_NonDrawValid( &GParam.CreateGraphGParam.InitHandleGParam, 16, TRUE, FALSE ) ;
			GParam.CreateGraphGParam.InitHandleGParam.TransColor = ( BYTE )255 << 16 | ( BYTE )0 << 8 | ( BYTE )255 ;
			GSYS.Resource.LineTexHandle = Graphics_Image_CreateGraphFromGraphImage_UseGParam( &GParam, FALSE, GSYS.Resource.LineTexHandle, &BaseImage, NULL ) ;
			NS_SetDeleteHandleFlag( GSYS.Resource.LineTexHandle, &GSYS.Resource.LineTexHandle ) ;
			NS_SetDeviceLostDeleteGraphFlag( GSYS.Resource.LineTexHandle, TRUE ) ;

			NS_ReleaseBaseImage( &BaseImage ) ;
		}

		return GSYS.Resource.LineTexHandle ;
	}
}

// A`GCAXt̐`悷邽߂̃eNX`nh擾( 1sNZp )
extern int Graphics_Image_GetLineOneThicknessTexHandle( int IsPMA )
{
	if( IsPMA )
	{
		if( GSYS.Resource.LineOneThicknessTexHandle_PMA <= 0 )
		{
			LOADGRAPH_GPARAM GParam ;
			BASEIMAGE BaseImage ;
			BYTE *ImageBase ;
			BYTE *Image ;
			DWORD Pitch ;
			int i, j, k ;

			NS_CreateARGB8ColorBaseImage( 8, 8, &BaseImage ) ;
			ImageBase = ( BYTE * )BaseImage.GraphData ;
			Pitch = ( DWORD )BaseImage.Pitch ;
			k = 0 ;
			for( i = 0 ; i < 8; i ++, ImageBase += Pitch )
			{
				Image = ImageBase ;
				for( j = 0 ; j < 8 ; j ++, Image += 4, k++ )
				{
					Image[ 0 ] = LineOneThicknessTexTga8x8TextureImage[ k ] ;
					Image[ 1 ] = LineOneThicknessTexTga8x8TextureImage[ k ] ;
					Image[ 2 ] = LineOneThicknessTexTga8x8TextureImage[ k ] ;
					Image[ 3 ] = LineOneThicknessTexTga8x8TextureImage[ k ] ;
				}
			}

			Graphics_Image_InitLoadGraphGParam( &GParam ) ;
			Graphics_Image_InitSetupGraphHandleGParam_Normal_NonDrawValid( &GParam.CreateGraphGParam.InitHandleGParam, 16, TRUE, FALSE ) ;
			GParam.CreateGraphGParam.InitHandleGParam.TransColor = ( BYTE )255 << 16 | ( BYTE )0 << 8 | ( BYTE )255 ;
			GSYS.Resource.LineOneThicknessTexHandle_PMA = Graphics_Image_CreateGraphFromGraphImage_UseGParam( &GParam, FALSE, GSYS.Resource.LineOneThicknessTexHandle_PMA, &BaseImage, NULL ) ;
			NS_SetDeleteHandleFlag( GSYS.Resource.LineOneThicknessTexHandle_PMA, &GSYS.Resource.LineOneThicknessTexHandle_PMA ) ;
			NS_SetDeviceLostDeleteGraphFlag( GSYS.Resource.LineOneThicknessTexHandle_PMA, TRUE ) ;

			NS_ReleaseBaseImage( &BaseImage ) ;
		}

		return GSYS.Resource.LineOneThicknessTexHandle_PMA ;
	}
	else
	{
		if( GSYS.Resource.LineOneThicknessTexHandle <= 0 )
		{
			LOADGRAPH_GPARAM GParam ;
			BASEIMAGE BaseImage ;
			BYTE *ImageBase ;
			BYTE *Image ;
			DWORD Pitch ;
			int i, j, k ;

			NS_CreateARGB8ColorBaseImage( 8, 8, &BaseImage ) ;
			ImageBase = ( BYTE * )BaseImage.GraphData ;
			Pitch = ( DWORD )BaseImage.Pitch ;
			k = 0 ;
			for( i = 0 ; i < 8; i ++, ImageBase += Pitch )
			{
				Image = ImageBase ;
				for( j = 0 ; j < 8 ; j ++, Image += 4, k++ )
				{
					Image[ 0 ] = 0xff ;
					Image[ 1 ] = 0xff ;
					Image[ 2 ] = 0xff ;
					Image[ 3 ] = LineOneThicknessTexTga8x8TextureImage[ k ] ;
				}
			}

			Graphics_Image_InitLoadGraphGParam( &GParam ) ;
			Graphics_Image_InitSetupGraphHandleGParam_Normal_NonDrawValid( &GParam.CreateGraphGParam.InitHandleGParam, 16, TRUE, FALSE ) ;
			GParam.CreateGraphGParam.InitHandleGParam.TransColor = ( BYTE )255 << 16 | ( BYTE )0 << 8 | ( BYTE )255 ;
			GSYS.Resource.LineOneThicknessTexHandle = Graphics_Image_CreateGraphFromGraphImage_UseGParam( &GParam, FALSE, GSYS.Resource.LineOneThicknessTexHandle, &BaseImage, NULL ) ;
			NS_SetDeleteHandleFlag( GSYS.Resource.LineOneThicknessTexHandle, &GSYS.Resource.LineOneThicknessTexHandle ) ;
			NS_SetDeviceLostDeleteGraphFlag( GSYS.Resource.LineOneThicknessTexHandle, TRUE ) ;

			NS_ReleaseBaseImage( &BaseImage ) ;
		}

		return GSYS.Resource.LineOneThicknessTexHandle ;
	}
}

// A`GCAXt̐``悷邽߂̃eNX`nh擾
extern int Graphics_Image_GetLineBoxTexHandle( int IsPMA )
{
	if( IsPMA )
	{
		if( GSYS.Resource.LineBoxTexHandle_PMA <= 0 )
		{
			LOADGRAPH_GPARAM GParam ;
			BASEIMAGE BaseImage ;
			BYTE *ImageBase ;
			BYTE *Image ;
			DWORD Pitch ;
			int i, j, k ;

			NS_CreateARGB8ColorBaseImage( 16, 16, &BaseImage ) ;
			ImageBase = ( BYTE * )BaseImage.GraphData ;
			Pitch = ( DWORD )BaseImage.Pitch ;
			k = 0 ;
			for( i = 0 ; i < 16; i ++, ImageBase += Pitch )
			{
				Image = ImageBase ;
				for( j = 0 ; j < 16 ; j ++, Image += 4, k++ )
				{
					Image[ 0 ] = LineBoxTexTga16x16TextureImage[ k ] ;
					Image[ 1 ] = LineBoxTexTga16x16TextureImage[ k ] ;
					Image[ 2 ] = LineBoxTexTga16x16TextureImage[ k ] ;
					Image[ 3 ] = LineBoxTexTga16x16TextureImage[ k ] ;
				}
			}

			Graphics_Image_InitLoadGraphGParam( &GParam ) ;
			Graphics_Image_InitSetupGraphHandleGParam_Normal_NonDrawValid( &GParam.CreateGraphGParam.InitHandleGParam, 16, TRUE, FALSE ) ;
			GParam.CreateGraphGParam.InitHandleGParam.TransColor = ( BYTE )255 << 16 | ( BYTE )0 << 8 | ( BYTE )255 ;
			GSYS.Resource.LineBoxTexHandle_PMA = Graphics_Image_CreateGraphFromGraphImage_UseGParam( &GParam, FALSE, GSYS.Resource.LineBoxTexHandle_PMA, &BaseImage, NULL ) ;
			NS_SetDeleteHandleFlag( GSYS.Resource.LineBoxTexHandle_PMA, &GSYS.Resource.LineBoxTexHandle_PMA ) ;
			NS_SetDeviceLostDeleteGraphFlag( GSYS.Resource.LineBoxTexHandle_PMA, TRUE ) ;

			NS_ReleaseBaseImage( &BaseImage ) ;
		}

		return GSYS.Resource.LineBoxTexHandle_PMA ;
	}
	else
	{
		if( GSYS.Resource.LineBoxTexHandle <= 0 )
		{
			LOADGRAPH_GPARAM GParam ;
			BASEIMAGE BaseImage ;
			BYTE *ImageBase ;
			BYTE *Image ;
			DWORD Pitch ;
			int i, j, k ;

			NS_CreateARGB8ColorBaseImage( 16, 16, &BaseImage ) ;
			ImageBase = ( BYTE * )BaseImage.GraphData ;
			Pitch = ( DWORD )BaseImage.Pitch ;
			k = 0 ;
			for( i = 0 ; i < 16; i ++, ImageBase += Pitch )
			{
				Image = ImageBase ;
				for( j = 0 ; j < 16 ; j ++, Image += 4, k++ )
				{
					Image[ 0 ] = 0xff ;
					Image[ 1 ] = 0xff ;
					Image[ 2 ] = 0xff ;
					Image[ 3 ] = LineBoxTexTga16x16TextureImage[ k ] ;
				}
			}

			Graphics_Image_InitLoadGraphGParam( &GParam ) ;
			Graphics_Image_InitSetupGraphHandleGParam_Normal_NonDrawValid( &GParam.CreateGraphGParam.InitHandleGParam, 16, TRUE, FALSE ) ;
			GParam.CreateGraphGParam.InitHandleGParam.TransColor = ( BYTE )255 << 16 | ( BYTE )0 << 8 | ( BYTE )255 ;
			GSYS.Resource.LineBoxTexHandle = Graphics_Image_CreateGraphFromGraphImage_UseGParam( &GParam, FALSE, GSYS.Resource.LineBoxTexHandle, &BaseImage, NULL ) ;
			NS_SetDeleteHandleFlag( GSYS.Resource.LineBoxTexHandle, &GSYS.Resource.LineBoxTexHandle ) ;
			NS_SetDeviceLostDeleteGraphFlag( GSYS.Resource.LineBoxTexHandle, TRUE ) ;

			NS_ReleaseBaseImage( &BaseImage ) ;
		}

		return GSYS.Resource.LineBoxTexHandle ;
	}
}

// A`GCAXt̐``悷邽߂̃eNX`nh擾( 1sNZp )
extern int Graphics_Image_GetLineBoxOneThicknessTexHandle( int IsPMA )
{
	if( IsPMA )
	{
		if( GSYS.Resource.LineBoxOneThicknessTexHandle_PMA <= 0 )
		{
			LOADGRAPH_GPARAM GParam ;
			BASEIMAGE BaseImage ;
			BYTE *ImageBase ;
			BYTE *Image ;
			DWORD Pitch ;
			int i, j, k ;

			NS_CreateARGB8ColorBaseImage( 16, 16, &BaseImage ) ;
			ImageBase = ( BYTE * )BaseImage.GraphData ;
			Pitch = ( DWORD )BaseImage.Pitch ;
			k = 0 ;
			for( i = 0 ; i < 16; i ++, ImageBase += Pitch )
			{
				Image = ImageBase ;
				for( j = 0 ; j < 16 ; j ++, Image += 4, k++ )
				{
					Image[ 0 ] = LineBoxOneThicknessTexTga16x16TextureImage[ k ] ;
					Image[ 1 ] = LineBoxOneThicknessTexTga16x16TextureImage[ k ] ;
					Image[ 2 ] = LineBoxOneThicknessTexTga16x16TextureImage[ k ] ;
					Image[ 3 ] = LineBoxOneThicknessTexTga16x16TextureImage[ k ] ;
				}
			}

			Graphics_Image_InitLoadGraphGParam( &GParam ) ;
			Graphics_Image_InitSetupGraphHandleGParam_Normal_NonDrawValid( &GParam.CreateGraphGParam.InitHandleGParam, 16, TRUE, FALSE ) ;
			GParam.CreateGraphGParam.InitHandleGParam.TransColor = ( BYTE )255 << 16 | ( BYTE )0 << 8 | ( BYTE )255 ;
			GSYS.Resource.LineBoxOneThicknessTexHandle_PMA = Graphics_Image_CreateGraphFromGraphImage_UseGParam( &GParam, FALSE, GSYS.Resource.LineBoxOneThicknessTexHandle_PMA, &BaseImage, NULL ) ;
			NS_SetDeleteHandleFlag( GSYS.Resource.LineBoxOneThicknessTexHandle_PMA, &GSYS.Resource.LineBoxOneThicknessTexHandle_PMA ) ;
			NS_SetDeviceLostDeleteGraphFlag( GSYS.Resource.LineBoxOneThicknessTexHandle_PMA, TRUE ) ;

			NS_ReleaseBaseImage( &BaseImage ) ;
		}

		return GSYS.Resource.LineBoxOneThicknessTexHandle_PMA ;
	}
	else
	{
		if( GSYS.Resource.LineBoxOneThicknessTexHandle <= 0 )
		{
			LOADGRAPH_GPARAM GParam ;
			BASEIMAGE BaseImage ;
			BYTE *ImageBase ;
			BYTE *Image ;
			DWORD Pitch ;
			int i, j, k ;

			NS_CreateARGB8ColorBaseImage( 16, 16, &BaseImage ) ;
			ImageBase = ( BYTE * )BaseImage.GraphData ;
			Pitch = ( DWORD )BaseImage.Pitch ;
			k = 0 ;
			for( i = 0 ; i < 16; i ++, ImageBase += Pitch )
			{
				Image = ImageBase ;
				for( j = 0 ; j < 16 ; j ++, Image += 4, k++ )
				{
					Image[ 0 ] = 0xff ;
					Image[ 1 ] = 0xff ;
					Image[ 2 ] = 0xff ;
					Image[ 3 ] = LineBoxOneThicknessTexTga16x16TextureImage[ k ] ;
				}
			}

			Graphics_Image_InitLoadGraphGParam( &GParam ) ;
			Graphics_Image_InitSetupGraphHandleGParam_Normal_NonDrawValid( &GParam.CreateGraphGParam.InitHandleGParam, 16, TRUE, FALSE ) ;
			GParam.CreateGraphGParam.InitHandleGParam.TransColor = ( BYTE )255 << 16 | ( BYTE )0 << 8 | ( BYTE )255 ;
			GSYS.Resource.LineBoxOneThicknessTexHandle = Graphics_Image_CreateGraphFromGraphImage_UseGParam( &GParam, FALSE, GSYS.Resource.LineBoxOneThicknessTexHandle, &BaseImage, NULL ) ;
			NS_SetDeleteHandleFlag( GSYS.Resource.LineBoxOneThicknessTexHandle, &GSYS.Resource.LineBoxOneThicknessTexHandle ) ;
			NS_SetDeviceLostDeleteGraphFlag( GSYS.Resource.LineBoxOneThicknessTexHandle, TRUE ) ;

			NS_ReleaseBaseImage( &BaseImage ) ;
		}

		return GSYS.Resource.LineBoxOneThicknessTexHandle ;
	}
}

// MakeGraph ̎֐
static int Graphics_Image_MakeGraph_Static(
	SETUP_GRAPHHANDLE_GPARAM *GParam,
	int GrHandle,
	int SizeX,
	int SizeY,
	int NotUse3DFlag,
	int UsePaletteFlag,
	int PaletteBitDepth,
	int AlphaValidFlag,
	int ASyncThread
)
{
	// nh̏
	if( Graphics_Image_SetupHandle_UseGParam(
			GParam,
			GrHandle,
			SizeX,
			SizeY,
			!NotUse3DFlag,
			AlphaValidFlag,
			UsePaletteFlag,
			PaletteBitDepth,
			DX_BASEIMAGE_FORMAT_NORMAL,
			-1,
			ASyncThread
		) == -1 )
		return -1 ;

	// I
	return 0 ;
}

#ifndef DX_NON_ASYNCLOAD

// MakeGraph ̔񓯊ǂݍ݃XbhĂ΂֐
static void Graphics_Image_MakeGraph_ASync( ASYNCLOADDATA_COMMON *AParam )
{
	SETUP_GRAPHHANDLE_GPARAM *GParam ;
	int GrHandle ;
	int SizeX ;
	int SizeY ;
	int NotUse3DFlag ;
	int UsePaletteFlag ;
	int PaletteBitDepth ;
	int AlphaValidFlag ;
	int Addr ;
	int Result ;
	IMAGEDATA *Image ;

	Addr = 0 ;
	GParam = ( SETUP_GRAPHHANDLE_GPARAM * )GetASyncLoadParamStruct( AParam->Data, &Addr ) ;
	GrHandle = GetASyncLoadParamInt( AParam->Data, &Addr ) ;
	SizeX = GetASyncLoadParamInt( AParam->Data, &Addr ) ;
	SizeY = GetASyncLoadParamInt( AParam->Data, &Addr ) ;
	NotUse3DFlag = GetASyncLoadParamInt( AParam->Data, &Addr ) ;
	UsePaletteFlag = GetASyncLoadParamInt( AParam->Data, &Addr ) ;
	PaletteBitDepth = GetASyncLoadParamInt( AParam->Data, &Addr ) ;
	AlphaValidFlag = GetASyncLoadParamInt( AParam->Data, &Addr ) ;

	Result = Graphics_Image_MakeGraph_Static( GParam, GrHandle, SizeX, SizeY, NotUse3DFlag, UsePaletteFlag, PaletteBitDepth, AlphaValidFlag, TRUE ) ;

	if( !GRAPHCHK_ASYNC( GrHandle, Image ) )
	{
	 	Image->HandleInfo.ASyncLoadResult = Result ;
	}

	DecASyncLoadCount( GrHandle ) ;
	if( Result < 0 )
	{
		NS_DeleteGraph( GrHandle, FALSE ) ;
	}
}
#endif // DX_NON_ASYNCLOAD

// ̃OtBbNnh쐬֐
extern int Graphics_Image_MakeGraph_UseGParam(
	SETUP_GRAPHHANDLE_GPARAM *GParam,
	int SizeX,
	int SizeY,
	int NotUse3DFlag,
	int UsePaletteFlag,
	int PaletteBitDepth,
	int ASyncLoadFlag,
	int ASyncThread
)
{
	int GrHandle ;

	CheckActiveState() ;

	// nh̍쐬
	GrHandle = Graphics_Image_AddHandle( ASyncThread ) ;
	if( GrHandle == -1 )
	{
		return -1 ;
	}

#ifndef DX_NON_ASYNCLOAD
	if( ASyncLoadFlag && ASyncThread == FALSE )
	{
		ASYNCLOADDATA_COMMON *AParam = NULL ;
		int Addr ;

		// p[^ɕKvȃ̃TCYZo
		Addr = 0 ;
		AddASyncLoadParamStruct( NULL, &Addr, GParam, sizeof( *GParam ) ) ;
		AddASyncLoadParamInt( NULL, &Addr, GrHandle ) ;
		AddASyncLoadParamInt( NULL, &Addr, SizeX ) ;
		AddASyncLoadParamInt( NULL, &Addr, SizeY ) ;
		AddASyncLoadParamInt( NULL, &Addr, NotUse3DFlag ) ;
		AddASyncLoadParamInt( NULL, &Addr, UsePaletteFlag ) ;
		AddASyncLoadParamInt( NULL, &Addr, PaletteBitDepth ) ;
		AddASyncLoadParamInt( NULL, &Addr, GParam->AlphaChannelImageCreateFlag ) ;

		// ̊m
		AParam = AllocASyncLoadDataMemory( Addr ) ;
		if( AParam == NULL )
			goto ERR ;

		// ɕKvȏZbg
		AParam->ProcessFunction = Graphics_Image_MakeGraph_ASync ;
		Addr = 0 ;
		AddASyncLoadParamStruct( AParam->Data, &Addr, GParam, sizeof( *GParam ) ) ;
		AddASyncLoadParamInt( AParam->Data, &Addr, GrHandle ) ;
		AddASyncLoadParamInt( AParam->Data, &Addr, SizeX ) ;
		AddASyncLoadParamInt( AParam->Data, &Addr, SizeY ) ;
		AddASyncLoadParamInt( AParam->Data, &Addr, NotUse3DFlag ) ;
		AddASyncLoadParamInt( AParam->Data, &Addr, UsePaletteFlag ) ;
		AddASyncLoadParamInt( AParam->Data, &Addr, PaletteBitDepth ) ;
		AddASyncLoadParamInt( AParam->Data, &Addr, GParam->AlphaChannelImageCreateFlag ) ;

		// f[^ǉ
		if( AddASyncLoadData( AParam ) < 0 )
		{
			DXFREE( AParam ) ;
			AParam = NULL ;
			goto ERR ;
		}

		// 񓯊ǂݍ݃JEgCNg
		IncASyncLoadCount( GrHandle, AParam->Index ) ;
	}
	else
#endif // DX_NON_ASYNCLOAD
	{
		if( Graphics_Image_MakeGraph_Static( GParam, GrHandle, SizeX, SizeY, NotUse3DFlag, UsePaletteFlag, PaletteBitDepth, GParam->AlphaChannelImageCreateFlag, ASyncThread ) < 0 )
		{
			goto ERR ;
		}
	}

#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		DecASyncLoadCount( GrHandle ) ;
	}
#endif // DX_NON_ASYNCLOAD

	// I
	return GrHandle ;

ERR :
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		DecASyncLoadCount( GrHandle ) ;
	}
#endif // DX_NON_ASYNCLOAD

	NS_DeleteGraph( GrHandle, FALSE ) ;

	return -1 ;
}

// CreateGraph ̎֐
static int Graphics_Image_CreateGraph_Static(
	LOADGRAPH_PARAM *Param,
	int ASyncThread
)
{
	char    FullPath_UTF16LE[ 2048 ] ;
	int Result = 0 ;
	CREATEGRAPH_LOADBASEIMAGE_PARAM LParam ;

	// 摜f[^̓ǂݍ
	Graphics_Image_CreateGraph_LoadBaseImage( Param, &LParam ) ;

	if( LParam.LoadHr == -1 ) 
	{
		// ēǂݍ݂ł͂Ȃꍇ̓[r[̉\
		if( Param->ReCreateFlag == FALSE && ( Param->FileName != NULL || Param->RgbMemImage != NULL ) )
		{
#ifndef DX_NON_MOVIE
			// t@C̏ꍇ̓t@C邩mF
			if( Param->FileName != NULL )
			{
				DWORD_PTR fp ;

				fp = DX_FOPEN( Param->FileName ) ;
				if( fp == 0 )
				{
					wchar_t FullPath_WCHAR_T[ 1024 ] ;

					ConvertFullPathW_( Param->FileName, FullPath_WCHAR_T, sizeof( FullPath_WCHAR_T ) ) ;
					ConvString( ( const char * )FullPath_WCHAR_T, -1, WCHAR_T_CHARCODEFORMAT, FullPath_UTF16LE, sizeof( FullPath_UTF16LE ), DX_CHARCODEFORMAT_UTF16LE ) ;

					DXST_LOGFILEFMT_ADDUTF16LE(( "\x3b\x75\xcf\x50\xd5\x30\xa1\x30\xa4\x30\xeb\x30\x20\x00\x25\x00\x73\x00\x20\x00\x4c\x30\x42\x30\x8a\x30\x7e\x30\x5b\x30\x93\x30\x00"/*@ L"摜t@C %s ܂" @*/, FullPath_UTF16LE )) ;
					return -1 ;
				}
				DX_FCLOSE( fp ) ;
			}

			// ̃I[v݂
			if( Graphics_Image_OpenMovie_UseGParam( &Param->GParam, Param->GrHandle, Param->FileName, Param->RgbMemImage, Param->RgbMemImageSize, Param->TextureFlag, Param->SurfaceMode, FALSE, ASyncThread ) < 0 )
			{
				return -1 ;
			}

			// 摜NA
			NS_FillGraph( Param->GrHandle, 0, 0, 0, 0 ) ;

			// I
			return 0 ;
#else	// DX_NON_MOVIE
			{
				if( Param->FileName != NULL )
				{
					ConvString( ( const char * )Param->FileName, -1, WCHAR_T_CHARCODEFORMAT, FullPath_UTF16LE, sizeof( FullPath_UTF16LE ), DX_CHARCODEFORMAT_UTF16LE ) ;
					DXST_LOGFILEFMT_ADDUTF16LE(( "\x3b\x75\xcf\x50\xd5\x30\xa1\x30\xa4\x30\xeb\x30\x20\x00\x25\x00\x73\x00\x20\x00\x6e\x30\xaa\x30\xfc\x30\xd7\x30\xf3\x30\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"摜t@C %s ̃I[vɎs܂" @*/, FullPath_UTF16LE )) ;
				}
				return -1 ;
			}
#endif	// DX_NON_MOVIE
		}
		else
		{
			return -1 ;
		}
	}

	// OtBbNnh쐬
	Result = Graphics_Image_CreateGraphFromGraphImageBase_UseGParam(
				&Param->GParam.CreateGraphGParam,
				Param->ReCreateFlag,
				Param->GrHandle,
				LParam.UseRgbBaseImage,
				LParam.UseAlphaBaseImage,
				Param->TextureFlag,
				ASyncThread
			) ;

	// t@CpXZbg
	if( Result == 0 )
	{
		Graphics_Image_SetBaseInfo_UseGParam(
			&Param->GParam.SetGraphBaseInfoGParam,
			Param->GrHandle,
			Param->FileName,
			NULL,
			NULL,
			NULL,
			Param->RgbMemImage,
			Param->RgbMemImageSize,
			Param->AlphaMemImage,
			Param->AlphaMemImageSize,
			LParam.UseRgbBaseImage,
			LParam.UseAlphaBaseImage,
			Param->ReverseFlag,
			Param->GParam.LoadBaseImageGParam.ConvertPremultipliedAlpha,
			Param->GParam.CreateGraphGParam.NotUseTransColor,
			-1,
			ASyncThread
		) ;
	}

	// ǂݍ񂾃OtBbŇn
	Graphics_Image_CreateGraph_TerminateBaseImage( Param, &LParam ) ;

	// I
	return Result ;
}

#ifndef DX_NON_ASYNCLOAD

// CreateGraph ̔񓯊ǂݍ݃XbhĂ΂֐
static void Graphics_Image_CreateGraph_ASync( ASYNCLOADDATA_COMMON *AParam )
{
	LOADGRAPH_PARAM *Param ;
	int Addr ;
	int Result ;
	IMAGEDATA *Image ;

	Addr = 0 ;
	Param = ( LOADGRAPH_PARAM * )GetASyncLoadParamStruct( AParam->Data, &Addr ) ;

	if( Param->FileName != NULL )
	{
		Param->FileName = GetASyncLoadParamString( AParam->Data, &Addr ) ;
	}

	if( Param->RgbBaseImage != NULL )
	{
		Param->RgbBaseImage = ( BASEIMAGE * )GetASyncLoadParamStruct( AParam->Data, &Addr ) ;
	}

	if( Param->AlphaBaseImage != NULL )
	{
		Param->AlphaBaseImage = ( BASEIMAGE * )GetASyncLoadParamStruct( AParam->Data, &Addr ) ;
	}

	Result = Graphics_Image_CreateGraph_Static( Param, TRUE ) ;
	if( !GRAPHCHK_ASYNC( Param->GrHandle, Image ) )
	{
	 	Image->HandleInfo.ASyncLoadResult = Result ;
	}

	DecASyncLoadCount( Param->GrHandle ) ;
	if( Param->ReCreateFlag == FALSE )
	{
		if( Result < 0 )
		{
			NS_DeleteGraph( Param->GrHandle, FALSE ) ;
		}
	}
}
#endif // DX_NON_ASYNCLOAD

// CreateGraph ̃O[oϐɃANZXȂo[W
extern int Graphics_Image_CreateGraph_UseGParam( 
	LOADGRAPH_PARAM *Param,
	int ASyncLoadFlag,
	int ASyncThread
)
{
	if( ASyncThread == FALSE )
	{
		CheckActiveState() ;
	}

	if( Param->ReCreateFlag == FALSE )
	{
		Param->GrHandle = Graphics_Image_AddHandle( ASyncThread ) ;
		if( Param->GrHandle < 0 )
		{
			return -1 ;
		}
	}
	else
	{
#ifndef DX_NON_ASYNCLOAD
		if( NS_CheckHandleASyncLoad( Param->GrHandle ) > 0 )
		{
			return -1 ;
		}

		// 񓯊ǂݍ݃JEgCNg
		if( ASyncThread )
		{
			IncASyncLoadCount( Param->GrHandle, -1 ) ;
		}
#endif // DX_NON_ASYNCLOAD
	}

#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread == FALSE && ASyncLoadFlag )
	{
		ASYNCLOADDATA_COMMON *AParam = NULL ;
		int Addr ;
		wchar_t FullPath[ 1024 ] ;

		// p[^ɕKvȃ̃TCYZo
		Addr = 0 ;
		AddASyncLoadParamStruct( NULL, &Addr, Param, sizeof( *Param ) ) ;
		if( Param->FileName != NULL )
		{
			ConvertFullPathW_( Param->FileName, FullPath, sizeof( FullPath ) ) ;
			AddASyncLoadParamString( NULL, &Addr, FullPath ) ; 
		}
		if( Param->RgbBaseImage != NULL )
		{
			AddASyncLoadParamStruct( NULL, &Addr, Param->RgbBaseImage, sizeof( *Param->RgbBaseImage ) ) ;
		}
		if( Param->AlphaBaseImage != NULL )
		{
			AddASyncLoadParamStruct( NULL, &Addr, Param->AlphaBaseImage, sizeof( *Param->AlphaBaseImage ) ) ;
		}

		// ̊m
		AParam = AllocASyncLoadDataMemory( Addr ) ;
		if( AParam == NULL )
			goto ERR ;

		// ɕKvȏZbg
		AParam->ProcessFunction = Graphics_Image_CreateGraph_ASync ;
		Addr = 0 ;
		AddASyncLoadParamStruct( AParam->Data, &Addr, Param, sizeof( *Param ) ) ;
		if( Param->FileName != NULL )
		{
			AddASyncLoadParamString( AParam->Data, &Addr, FullPath ) ; 
		}
		if( Param->RgbBaseImage != NULL )
		{
			AddASyncLoadParamStruct( AParam->Data, &Addr, Param->RgbBaseImage, sizeof( *Param->RgbBaseImage ) ) ;
		}
		if( Param->AlphaBaseImage != NULL )
		{
			AddASyncLoadParamStruct( AParam->Data, &Addr, Param->AlphaBaseImage, sizeof( *Param->AlphaBaseImage ) ) ;
		}

		// f[^ǉ
		if( AddASyncLoadData( AParam ) < 0 )
		{
			DXFREE( AParam ) ;
			AParam = NULL ;
			goto ERR ;
		}

		// 񓯊ǂݍ݃JEgCNg
		IncASyncLoadCount( Param->GrHandle, AParam->Index ) ;
	}
	else
#endif // DX_NON_ASYNCLOAD
	{
		if( Graphics_Image_CreateGraph_Static( Param, ASyncThread ) < 0 )
		{
			goto ERR ;
		}
	}

#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		DecASyncLoadCount( Param->GrHandle ) ;
	}
#endif // DX_NON_ASYNCLOAD

	// I
	return Param->ReCreateFlag == FALSE ? Param->GrHandle : 0 ;

ERR :
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		DecASyncLoadCount( Param->GrHandle ) ;
	}
#endif // DX_NON_ASYNCLOAD

	if( Param->ReCreateFlag == FALSE )
	{
		NS_DeleteGraph( Param->GrHandle, FALSE ) ;
		Param->GrHandle = -1 ;
	}

	return -1 ;
}


// Graphics_Image_CreateDivGraph ̎֐
static int Graphics_Image_CreateDivGraph_Static(
	LOADGRAPH_PARAM *Param,
	int ASyncThread
)
{
	int Result ;
	int i ;
	CREATEGRAPH_LOADBASEIMAGE_PARAM LParam ;

	// 摜f[^̓ǂݍ
	Graphics_Image_CreateGraph_LoadBaseImage( Param, &LParam ) ;
	if( LParam.LoadHr == -1 )
	{
		if( Param->FileName != NULL )
		{
			wchar_t FullPath_WCHAR_T[ 1024 ] ;
			char    FullPath_UTF16LE[ 2048 ] ;

			ConvertFullPathW_( Param->FileName, FullPath_WCHAR_T, sizeof( FullPath_WCHAR_T ) ) ;
			ConvString( ( const char * )FullPath_WCHAR_T, -1, WCHAR_T_CHARCODEFORMAT, FullPath_UTF16LE, sizeof( FullPath_UTF16LE ), DX_CHARCODEFORMAT_UTF16LE ) ;

			DXST_LOGFILEFMT_ADDUTF16LE(( "\x3b\x75\xcf\x50\xd5\x30\xa1\x30\xa4\x30\xeb\x30\x20\x00\x25\x00\x73\x00\x20\x00\x6e\x30\xed\x30\xfc\x30\xc9\x30\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"摜t@C %s ̃[hɎs܂" @*/, FullPath_UTF16LE )) ;
		}
		return -1 ;
	}

	// OtBbNnh쐬
	Result = Graphics_Image_CreateDivGraphFromGraphImageBase_UseGParam(
				&Param->GParam.CreateGraphGParam,
				Param->ReCreateFlag,
				Param->BaseHandle,
				LParam.UseRgbBaseImage,
				LParam.UseAlphaBaseImage,
				Param->AllNum,
				Param->XNum,
				Param->YNum,
				Param->IsFloat,
				Param->SizeXI,
				Param->SizeXF,
				Param->SizeYI,
				Param->SizeYF,
				Param->StrideXI,
				Param->StrideXF,
				Param->StrideYI,
				Param->StrideYF,
				Param->HandleArray,
				Param->TextureFlag,
				Param->ReverseFlag,
				ASyncThread
			) ;

	// t@CpXZbg
	if( Result == 0 )
	{
		Graphics_Image_SetBaseInfo_UseGParam(
			&Param->GParam.SetGraphBaseInfoGParam,
			Param->HandleArray[ 0 ],
			Param->FileName,
			NULL,
			NULL,
			NULL,
			Param->RgbMemImage,
			Param->RgbMemImageSize,
			Param->AlphaMemImage,
			Param->AlphaMemImageSize,
			LParam.UseRgbBaseImage,
			LParam.UseAlphaBaseImage,
			Param->ReverseFlag,
			Param->GParam.LoadBaseImageGParam.ConvertPremultipliedAlpha,
			Param->GParam.CreateGraphGParam.NotUseTransColor,
			-1,
			ASyncThread
		) ;
		for( i = 1 ; i < Param->AllNum ; i ++ )
		{
			Graphics_Image_SetBaseInfo_UseGParam(
				&Param->GParam.SetGraphBaseInfoGParam,
				Param->HandleArray[ i ],
				NULL,
				NULL,
				NULL,
				NULL,
				NULL,
				0,
				NULL,
				0,
				NULL,
				NULL,
				FALSE,
				FALSE,
				FALSE,
				Param->HandleArray[ 0 ],
				ASyncThread
			) ;
		}
	}
	else
	{
		wchar_t FullPath_WCHAR_T[ 1024 ] ;
		char    FullPath_UTF16LE[ 2048 ] ;

		ConvertFullPathW_( Param->FileName, FullPath_WCHAR_T, sizeof( FullPath_WCHAR_T ) ) ;
		ConvString( ( const char * )FullPath_WCHAR_T, -1, WCHAR_T_CHARCODEFORMAT, FullPath_UTF16LE, sizeof( FullPath_UTF16LE ), DX_CHARCODEFORMAT_UTF16LE ) ;

		DXST_LOGFILEFMT_ADDUTF16LE(( "\x3b\x75\xcf\x50\xd5\x30\xa1\x30\xa4\x30\xeb\x30\x20\x00\x25\x00\x73\x00\x20\x00\x6e\x30\x06\x52\x72\x52\xad\x8a\x7f\x30\xbc\x8f\x7f\x30\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"摜t@C %s ̕ǂݍ݂Ɏs܂" @*/, FullPath_UTF16LE )) ;
	}

	// ǂݍ񂾃OtBbŇn
	Graphics_Image_CreateGraph_TerminateBaseImage( Param, &LParam ) ;

	// I
	return Result ;
}

#ifndef DX_NON_ASYNCLOAD

// Graphics_Image_CreateDivGraph ̔񓯊ǂݍ݃XbhĂ΂֐
static void Graphics_Image_CreateDivGraph_ASync( ASYNCLOADDATA_COMMON *AParam )
{
	LOADGRAPH_PARAM *Param ;
	int Addr ;
	int i ;
	int Result ;
	IMAGEDATA *Image ;

	Addr = 0 ;
	Param = ( LOADGRAPH_PARAM * )GetASyncLoadParamStruct( AParam->Data, &Addr ) ;

	Param->HandleArray = ( int * )GetASyncLoadParamStruct( AParam->Data, &Addr ) ;

	if( Param->FileName != NULL )
	{
		Param->FileName = GetASyncLoadParamString( AParam->Data, &Addr ) ;
	}

	if( Param->RgbBaseImage != NULL )
	{
		Param->RgbBaseImage = ( BASEIMAGE * )GetASyncLoadParamStruct( AParam->Data, &Addr ) ;
	}

	if( Param->AlphaBaseImage != NULL )
	{
		Param->AlphaBaseImage = ( BASEIMAGE * )GetASyncLoadParamStruct( AParam->Data, &Addr ) ;
	}

	Result = Graphics_Image_CreateDivGraph_Static( Param, TRUE ) ;

	if( !GRAPHCHK_ASYNC( Param->BaseHandle, Image ) )
	{
	 	Image->HandleInfo.ASyncLoadResult = Result ;
	}
	DecASyncLoadCount( Param->BaseHandle ) ;
	for( i = 0 ; i < Param->AllNum ; i ++ )
	{
		if( !GRAPHCHK_ASYNC( Param->HandleArray[ i ], Image ) )
		{
	 		Image->HandleInfo.ASyncLoadResult = Result ;
		}
		DecASyncLoadCount( Param->HandleArray[ i ] ) ;
	}

	if( Param->ReCreateFlag == FALSE )
	{
		NS_DeleteGraph( Param->BaseHandle, FALSE ) ;
		if( Result < 0 )
		{
			for( i = 0 ; i < Param->AllNum ; i ++ )
			{
				NS_DeleteGraph( Param->HandleArray[ i ], FALSE ) ;
				Param->HandleArray[ i ] = -1 ;
			}
		}
	}
}
#endif // DX_NON_ASYNCLOAD

// 摜𕪊ăOtBbNnh쐬֐
extern int Graphics_Image_CreateDivGraph_UseGParam( 
	LOADGRAPH_PARAM *Param,
	int ASyncLoadFlag,
	int ASyncThread
)
{
	int i ;

	CheckActiveState() ;

	if( Param->AllNum == 0 )
		return -1 ;

	Param->BaseHandle = -1 ;
	if( Param->ReCreateFlag == FALSE )
	{
		// OtBbNnh̍쐬
		_MEMSET( Param->HandleArray, 0, sizeof( int ) * Param->AllNum ) ;
		for( i = 0 ; i < Param->AllNum ; i ++ )
		{
			Param->HandleArray[ i ] = Graphics_Image_AddHandle( ASyncThread ) ;
			if( Param->HandleArray[ i ] < 0 )
			{
				goto ERR ;
			}
		}
		Param->BaseHandle = Graphics_Image_AddHandle( ASyncThread ) ;
		if( Param->BaseHandle < 0 )
		{
			goto ERR ;
		}
	}
	else
	{
#ifndef DX_NON_ASYNCLOAD
		for( i = 0 ; i < Param->AllNum ; i ++ )
		{
			if( NS_CheckHandleASyncLoad( Param->HandleArray[ i ] ) > 0 )
			{
				return -1 ;
			}
		}

		// 񓯊ǂݍ݃JEgCNg
		if( ASyncThread )
		{
			IncASyncLoadCount( Param->BaseHandle, -1 ) ;
			for( i = 0 ; i < Param->AllNum ; i ++ )
			{
				IncASyncLoadCount( Param->HandleArray[ i ], -1 ) ;
			}
		}
#endif // DX_NON_ASYNCLOAD
	}

#ifndef DX_NON_ASYNCLOAD
	if( ASyncLoadFlag )
	{
		ASYNCLOADDATA_COMMON *AParam = NULL ;
		int Addr ;

		// p[^ɕKvȃ̃TCYZo
		Addr = 0 ;
		AddASyncLoadParamStruct( NULL, &Addr, Param, sizeof( *Param ) ) ;
		AddASyncLoadParamStruct( NULL, &Addr, Param->HandleArray, ( int )( sizeof( int ) * Param->AllNum ) ) ;
		if( Param->FileName != NULL )
		{
			AddASyncLoadParamString( NULL, &Addr, Param->FileName ) ; 
		}
		if( Param->RgbBaseImage != NULL )
		{
			AddASyncLoadParamStruct( NULL, &Addr, Param->RgbBaseImage, sizeof( *Param->RgbBaseImage ) ) ;
		}
		if( Param->AlphaBaseImage != NULL )
		{
			AddASyncLoadParamStruct( NULL, &Addr, Param->AlphaBaseImage, sizeof( *Param->AlphaBaseImage ) ) ;
		}

		// ̊m
		AParam = AllocASyncLoadDataMemory( Addr ) ;
		if( AParam == NULL )
			goto ERR ;

		// ɕKvȏZbg
		AParam->ProcessFunction = Graphics_Image_CreateDivGraph_ASync ;
		Addr = 0 ;
		AddASyncLoadParamStruct( AParam->Data, &Addr, Param, sizeof( *Param ) ) ;
		AddASyncLoadParamStruct( AParam->Data, &Addr, Param->HandleArray, ( int )( sizeof( int ) * Param->AllNum ) ) ;
		if( Param->FileName != NULL )
		{
			AddASyncLoadParamString( AParam->Data, &Addr, Param->FileName ) ; 
		}
		if( Param->RgbBaseImage != NULL )
		{
			AddASyncLoadParamStruct( AParam->Data, &Addr, Param->RgbBaseImage, sizeof( *Param->RgbBaseImage ) ) ;
		}
		if( Param->AlphaBaseImage != NULL )
		{
			AddASyncLoadParamStruct( AParam->Data, &Addr, Param->AlphaBaseImage, sizeof( *Param->AlphaBaseImage ) ) ;
		}

		// f[^ǉ
		if( AddASyncLoadData( AParam ) < 0 )
		{
			DXFREE( AParam ) ;
			AParam = NULL ;
			goto ERR ;
		}

		// 񓯊ǂݍ݃JEgCNg
		for( i = 0 ; i < Param->AllNum ; i ++ )
			IncASyncLoadCount( Param->HandleArray[ i ], AParam->Index ) ;
		IncASyncLoadCount( Param->BaseHandle, AParam->Index ) ;
	}
	else
#endif // DX_NON_ASYNCLOAD
	{
		if( Graphics_Image_CreateDivGraph_Static( Param, FALSE ) < 0 )
			goto ERR ;

		if( Param->ReCreateFlag == FALSE )
		{
			NS_DeleteGraph( Param->BaseHandle, FALSE ) ;
		}
	}

#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		// 񓯊ǂݍ݃JEgfNg
		DecASyncLoadCount( Param->BaseHandle ) ;
		for( i = 0 ; i < Param->AllNum ; i ++ )
		{
			DecASyncLoadCount( Param->HandleArray[ i ] ) ;
		}
	}
#endif // DX_NON_ASYNCLOAD

	// I
	return 0 ;

ERR :
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		// 񓯊ǂݍ݃JEgfNg
		DecASyncLoadCount( Param->BaseHandle ) ;
		for( i = 0 ; i < Param->AllNum ; i ++ )
		{
			DecASyncLoadCount( Param->HandleArray[ i ] ) ;
		}
	}
#endif // DX_NON_ASYNCLOAD

	if( Param->ReCreateFlag == FALSE )
	{
		for( i = 0 ; i < Param->AllNum ; i ++ )
		{
			NS_DeleteGraph( Param->HandleArray[ i ], FALSE ) ;
			Param->HandleArray[ i ] = -1 ;
		}
		NS_DeleteGraph( Param->BaseHandle, FALSE ) ;
	}

	return -1 ;
}


// LoadBmpToGraph ̃O[oϐɃANZXȂo[W
extern int Graphics_Image_LoadBmpToGraph_UseGParam(
	LOADGRAPH_GPARAM *GParam,
	int ReCreateFlag,
	int GrHandle,
	const wchar_t *GraphName,
	int TextureFlag,
	int ReverseFlag,
	int SurfaceMode,
	int ASyncLoadFlag,
	int ASyncThread
)
{
	LOADGRAPH_PARAM Param ;

	_MEMSET( &Param, 0, sizeof( Param ) ) ;
	Param.GParam = *GParam ;
	Param.ReCreateFlag = ReCreateFlag ;
	Param.GrHandle = GrHandle ;

	Param.FileName = GraphName ;

	Param.TextureFlag = TextureFlag ;
	Param.ReverseFlag = ReverseFlag ;
	Param.SurfaceMode = SurfaceMode ;

	return Graphics_Image_CreateGraph_UseGParam( &Param, ASyncLoadFlag, ASyncThread ) ;
}

// LoadBmpToGraph ̃O[oϐɃANZXȂo[W( Visual C++ 6.0 pɈ char ^ɂ̂ )
extern int Graphics_Image_LoadBmpToGraphW_UseGParam(
	LOADGRAPH_GPARAM *GParam,
	int ReCreateFlag,
	int GrHandle,
	const char *GraphNameW,
	int TextureFlag,
	int ReverseFlag,
	int SurfaceMode,
	int ASyncLoadFlag,
	int ASyncThread
)
{
	return Graphics_Image_LoadBmpToGraph_UseGParam( GParam, ReCreateFlag, GrHandle, ( wchar_t * )GraphNameW, TextureFlag, ReverseFlag, SurfaceMode, ASyncLoadFlag, ASyncThread ) ;
}


// LoadDivBmpToGraph ̃O[oϐɃANZXȂo[W
extern int Graphics_Image_LoadDivBmpToGraph_UseGParam(
	LOADGRAPH_GPARAM *GParam,
	int ReCreateFlag,
	const wchar_t *FileName,
	int AllNum,
	int XNum,
	int YNum,
	int IsFloat,
	int   SizeXI,
	float SizeXF,
	int   SizeYI,
	float SizeYF,
	int *HandleArray,
	int TextureFlag,
	int ReverseFlag,
	int   XStrideI,
	float XStrideF,
	int   YStrideI,
	float YStrideF,
	int ASyncLoadFlag,
	int ASyncThread
)
{
	LOADGRAPH_PARAM Param ;

	_MEMSET( &Param, 0, sizeof( Param ) ) ;
	Param.GParam = *GParam ;
	Param.ReCreateFlag = ReCreateFlag ;

	Param.FileName = FileName ;

	Param.AllNum = AllNum ;
	Param.XNum = XNum ;
	Param.YNum = YNum ;
	Param.IsFloat = IsFloat ;
	Param.SizeXI = SizeXI ;
	Param.SizeXF = SizeXF ;
	Param.SizeYI = SizeYI ;
	Param.SizeYF = SizeYF ;
	Param.StrideXI = XStrideI ;
	Param.StrideXF = XStrideF ;
	Param.StrideYI = YStrideI ;
	Param.StrideYF = YStrideF ;
	Param.HandleArray = HandleArray ;
	Param.TextureFlag = TextureFlag ;
	Param.ReverseFlag = ReverseFlag ;

	return Graphics_Image_CreateDivGraph_UseGParam( &Param, ASyncLoadFlag, ASyncThread ) ;
}

// CreateGraphFromMem ̃O[oϐɃANZXȂo[W
extern int Graphics_Image_CreateGraphFromMem_UseGParam( 
	LOADGRAPH_GPARAM *GParam,
	int ReCreateFlag,
	int GrHandle,
	const void *MemImage,
	int MemImageSize,
	const void *AlphaImage,
	int AlphaImageSize,
	int TextureFlag,
	int ReverseFlag,
	int ASyncLoadFlag
)
{
	LOADGRAPH_PARAM Param ;

	_MEMSET( &Param, 0, sizeof( Param ) ) ;
	Param.GParam = *GParam ;
	Param.ReCreateFlag = ReCreateFlag ;
	Param.GrHandle = GrHandle ;

	Param.RgbMemImage = MemImage ;
	Param.RgbMemImageSize = MemImageSize ;
	Param.AlphaMemImage = AlphaImage ;
	Param.AlphaMemImageSize = AlphaImageSize ;

	Param.TextureFlag = TextureFlag ;
	Param.ReverseFlag = ReverseFlag ;
	Param.SurfaceMode = DX_MOVIESURFACE_NORMAL ;

	return Graphics_Image_CreateGraph_UseGParam( &Param, ASyncLoadFlag ) ;
}

// CreateDivGraphFromMem ̃O[oϐɃANZXȂo[W
extern int Graphics_Image_CreateDivGraphFromMem_UseGParam(
	LOADGRAPH_GPARAM *GParam,
	int ReCreateFlag,
	const void *MemImage,
	int MemImageSize,
	int AllNum,
	int XNum,
	int YNum,
	int IsFloat,
	int   SizeXI,
	float SizeXF,
	int   SizeYI,
	float SizeYF,
	int *HandleArray,
	int TextureFlag,
	int ReverseFlag,
	const void *AlphaImage,
	int AlphaImageSize,
	int ASyncLoadFlag,
	int ASyncThread
)
{
	LOADGRAPH_PARAM Param ;

	_MEMSET( &Param, 0, sizeof( Param ) ) ;
	Param.GParam = *GParam ;
	Param.ReCreateFlag = ReCreateFlag ;

	Param.RgbMemImage = MemImage ;
	Param.RgbMemImageSize = MemImageSize ;
	Param.AlphaMemImage = AlphaImage ;
	Param.AlphaMemImageSize = AlphaImageSize ;

	Param.AllNum = AllNum ;
	Param.XNum = XNum ;
	Param.YNum = YNum ;
	Param.IsFloat = IsFloat ;
	Param.SizeXI = SizeXI ;
	Param.SizeXF = SizeXF ;
	Param.SizeYI = SizeYI ;
	Param.SizeYF = SizeYF ;
	Param.HandleArray = HandleArray ;
	Param.TextureFlag = TextureFlag ;
	Param.ReverseFlag = ReverseFlag ;

	return Graphics_Image_CreateDivGraph_UseGParam( &Param, ASyncLoadFlag, ASyncThread ) ;
}

// CreateGraphFromBmp ̃O[oϐɃANZXȂo[W
extern int Graphics_Image_CreateGraphFromBmp_UseGParam(
	LOADGRAPH_GPARAM *GParam,
	int ReCreateFlag,
	int GrHandle,
	const BITMAPINFO *BmpInfo,
	const void *GraphData,
	const BITMAPINFO *AlphaInfo,
	const void *AlphaData,
	int TextureFlag,
	int ReverseFlag,
	int ASyncLoadFlag
)
{
	LOADGRAPH_PARAM Param ;

	_MEMSET( &Param, 0, sizeof( Param ) ) ;
	Param.GParam = *GParam ;
	Param.ReCreateFlag = ReCreateFlag ;
	Param.GrHandle = GrHandle ;

	Param.RgbBmpInfo = BmpInfo ;
	Param.RgbBmpImage = ( void * )GraphData ;
	Param.AlphaBmpInfo = AlphaInfo ;
	Param.AlphaBmpImage = ( void * )AlphaData ;

	Param.TextureFlag = TextureFlag ;
	Param.ReverseFlag = ReverseFlag ;
	Param.SurfaceMode = DX_MOVIESURFACE_NORMAL ;

	return Graphics_Image_CreateGraph_UseGParam( &Param, ASyncLoadFlag ) ;
}

// CreateDivGraphFromBmp ̃O[oϐɃANZXȂo[W
extern int Graphics_Image_CreateDivGraphFromBmp_UseGParam(
	LOADGRAPH_GPARAM *GParam,
	int ReCreateFlag,
	const BITMAPINFO *BmpInfo,
	const void *GraphData,
	int AllNum,
	int XNum,
	int YNum,
	int IsFloat,
	int   SizeXI,
	float SizeXF,
	int   SizeYI,
	float SizeYF,
	int *HandleArray,
	int TextureFlag,
	int ReverseFlag,
	const BITMAPINFO *AlphaInfo,
	const void *AlphaData,
	int ASyncLoadFlag
)
{
	LOADGRAPH_PARAM Param ;

	_MEMSET( &Param, 0, sizeof( Param ) ) ;
	Param.GParam = *GParam ;
	Param.ReCreateFlag = ReCreateFlag ;

	Param.RgbBmpInfo = BmpInfo ;
	Param.RgbBmpImage = ( void * )GraphData ;
	Param.AlphaBmpInfo = AlphaInfo ;
	Param.AlphaBmpImage = ( void * )AlphaData ;

	Param.AllNum = AllNum ;
	Param.XNum = XNum ;
	Param.YNum = YNum ;
	Param.IsFloat = IsFloat ;
	Param.SizeXI = SizeXI ;
	Param.SizeXF = SizeXF ;
	Param.SizeYI = SizeYI ;
	Param.SizeYF = SizeYF ;
	Param.HandleArray = HandleArray ;
	Param.TextureFlag = TextureFlag ;
	Param.ReverseFlag = ReverseFlag ;

	return Graphics_Image_CreateDivGraph_UseGParam( &Param, ASyncLoadFlag, FALSE ) ;
}

// CreateGraphFromGraphImage ̃O[oϐɃANZXȂo[W
extern int Graphics_Image_CreateGraphFromGraphImage_UseGParam(
	LOADGRAPH_GPARAM *GParam,
	int ReCreateFlag,
	int GrHandle,
	const BASEIMAGE *BaseImage,
	const BASEIMAGE *AlphaBaseImage,
	int TextureFlag,
	int ReverseFlag,
	int ASyncLoadFlag,
	int ASyncThread
)
{
	LOADGRAPH_PARAM Param ;

	_MEMSET( &Param, 0, sizeof( Param ) ) ;
	Param.GParam = *GParam ;
	Param.ReCreateFlag = ReCreateFlag ;
	Param.GrHandle = GrHandle ;

	Param.RgbBaseImage = ( BASEIMAGE * )BaseImage ;
	Param.AlphaBaseImage = ( BASEIMAGE * )AlphaBaseImage ;

	Param.TextureFlag = TextureFlag ;
	Param.ReverseFlag = ReverseFlag ;
	Param.SurfaceMode = DX_MOVIESURFACE_NORMAL ;

	return Graphics_Image_CreateGraph_UseGParam( &Param, ASyncLoadFlag, ASyncThread ) ;
}

// CreateDivGraphFromGraphImage ̃O[oϐɃANZXȂo[W
extern int Graphics_Image_CreateDivGraphFromGraphImage_UseGParam(
	LOADGRAPH_GPARAM *GParam,
	int ReCreateFlag,
	const BASEIMAGE *BaseImage,
	const BASEIMAGE *AlphaBaseImage,
	int AllNum,
	int XNum,
	int YNum,
	int IsFloat,
	int   SizeXI,
	float SizeXF,
	int   SizeYI,
	float SizeYF,
	int *HandleArray,
	int TextureFlag,
	int ReverseFlag,
	int ASyncLoadFlag
)
{
	LOADGRAPH_PARAM Param ;

	_MEMSET( &Param, 0, sizeof( Param ) ) ;
	Param.GParam = *GParam ;
	Param.ReCreateFlag = ReCreateFlag ;

	Param.RgbBaseImage = ( BASEIMAGE * )BaseImage ;
	Param.AlphaBaseImage = ( BASEIMAGE * )AlphaBaseImage ;

	Param.AllNum = AllNum ;
	Param.XNum = XNum ;
	Param.YNum = YNum ;
	Param.IsFloat = IsFloat ;
	Param.SizeXI = SizeXI ;
	Param.SizeXF = SizeXF ;
	Param.SizeYI = SizeYI ;
	Param.SizeYF = SizeYF ;
	Param.HandleArray = HandleArray ;
	Param.TextureFlag = TextureFlag ;
	Param.ReverseFlag = ReverseFlag ;

	return Graphics_Image_CreateDivGraph_UseGParam( &Param, ASyncLoadFlag, FALSE ) ;
}

// Graphics_Image_CreateGraphFromGraphImageBase ̃O[oϐɃANZXȂo[W
extern int Graphics_Image_CreateGraphFromGraphImageBase_UseGParam(
	CREATE_GRAPHHANDLE_AND_BLTGRAPHIMAGE_GPARAM *GParam,
	int ReCreateFlag,
	int GrHandle,
	BASEIMAGE *BaseImage,
	const BASEIMAGE *AlphaBaseImage,
	int TextureFlag,
	int ASyncThread
)
{
	int SizeX, SizeY ;
	int UseTempImage = FALSE ;
	BASEIMAGE TempImage ;
	int Result ;

	// č쐬ł͂Ȃꍇ͉摜̓ߐF̏s
	if( ReCreateFlag == FALSE )
	{
		// ߐFJ[gpOƂ摜ɂꍇ́AœߐFJ[O摜쐬
		if( GParam->UseTransColorGraphCreateFlag && GParam->NotUseTransColor == FALSE )
		{
			int w, h, i, j, r, g, b, a, r2, g2, b2, a2, tr, tg, tb, useAlpha;

			w = BaseImage->Width;
			h = BaseImage->Height;
			tr = ( int )( ( GParam->InitHandleGParam.TransColor >> 16 ) & 0xff ) ;
			tg = ( int )( ( GParam->InitHandleGParam.TransColor >>  8 ) & 0xff ) ;
			tb = ( int )( ( GParam->InitHandleGParam.TransColor >>  0 ) & 0xff ) ;
			useAlpha = BaseImage->ColorData.AlphaWidth != 0;
			if( NS_CreateARGB8ColorBaseImage( w, h, &TempImage ) == 0 )
			{
				// ߐF̃`FbNsȂ摜]
				for( i = 0; i < h; i++ )
				{
					for( j = 0; j < w; j++ )
					{
						NS_GetPixelBaseImage(      BaseImage, j, i, &r, &g, &b, &a );
						NS_SetPixelBaseImage( &TempImage, j, i,  r,  g,  b, r == tr && g == tg && b == tb ? 0 : ( useAlpha ? a : 255 ) );
					}
				}

				// ߐFł͂Ȃ̐F𓧉ߐF̕ɑ
				for( i = 0; i < h; i++ )
				{
					for( j = 0; j < w; j++ )
					{
						NS_GetPixelBaseImage( BaseImage, j, i, &r, &g, &b, &a );
						if( r != tr || g != tg || b != tb )
						{
							if( j >    0 ){ NS_GetPixelBaseImage( BaseImage, j-1, i  ,&r2,&g2,&b2,&a2); if( r2 == tr && g2 == tg && b2 == tb ) NS_SetPixelBaseImage( &TempImage, j-1, i  ,r,g,b,0); }
							if( i >    0 ){ NS_GetPixelBaseImage( BaseImage, j  , i-1,&r2,&g2,&b2,&a2); if( r2 == tr && g2 == tg && b2 == tb ) NS_SetPixelBaseImage( &TempImage, j  , i-1,r,g,b,0); }
							if( j < w -1 ){ NS_GetPixelBaseImage( BaseImage, j+1, i  ,&r2,&g2,&b2,&a2); if( r2 == tr && g2 == tg && b2 == tb ) NS_SetPixelBaseImage( &TempImage, j+1, i  ,r,g,b,0); }
							if( i < h -1 ){ NS_GetPixelBaseImage( BaseImage, j  , i+1,&r2,&g2,&b2,&a2); if( r2 == tr && g2 == tg && b2 == tb ) NS_SetPixelBaseImage( &TempImage, j  , i+1,r,g,b,0); }
						}
					}
				}

				// VC[W̏Zbg
				BaseImage = &TempImage;

				// 摜gpĂtO𗧂Ă
				UseTempImage = TRUE ;
			}
		}
	}

	// Ȃ̋@\tĂȂrbg̃}XNZbg
	// (NoneMask ͓rꂽoϐȂ̂ŁAʌ݊邽߂ɁEEE)
	NS_SetColorDataNoneMask( ( COLORDATA * )&BaseImage->ColorData ) ;
	if( AlphaBaseImage != NULL ) NS_SetColorDataNoneMask( ( COLORDATA * )&AlphaBaseImage->ColorData ) ;

	// č쐬̏ꍇ̓TCYꂩ`FbN
	if( ReCreateFlag )
	{
		// TCYG[
		if( NS_GetGraphSize( GrHandle, &SizeX, &SizeY ) == -1 )
		{
			return -1 ;
		}

		if( SizeX != BaseImage->Width || SizeY != BaseImage->Height )
		{
			return -1 ;
		}

		if( AlphaBaseImage != NULL && ( SizeX != AlphaBaseImage->Width || SizeY != AlphaBaseImage->Height ) )
		{
			return -1 ;
		}

		LUTRANS_RE_GPARAM( GParam, BaseImage, GrHandle )

		Result = 0 ;
	}
	else
	{
		LUTRANS_GPARAM( GParam, BaseImage ) ;

		// OtBbNnh쐬
		Result = Graphics_Image_CreateDXGraph_UseGParam( &GParam->InitHandleGParam, GrHandle, BaseImage, AlphaBaseImage, TextureFlag, ASyncThread ) ;
	}

	if( Result != -1 )
	{
		Graphics_Image_BltBmpOrGraphImageToGraphBase(
			BaseImage,
			AlphaBaseImage,
			0,
			0,
			GrHandle,
			GParam->NotUseTransColor ? FALSE : TRUE,
			ASyncThread
		) ;
	}

	// 摜gpĂꍇ͉
	if( UseTempImage )
	{
		NS_ReleaseBaseImage( &TempImage );
	}

	// sԂ
	return Result ;
}

// Graphics_Image_CreateDivGraphFromGraphImageBase ̃O[oϐɃANZXȂo[W
extern int Graphics_Image_CreateDivGraphFromGraphImageBase_UseGParam(
	CREATE_GRAPHHANDLE_AND_BLTGRAPHIMAGE_GPARAM *GParam,
	int ReCreateFlag,
	int BaseHandle,
	BASEIMAGE *BaseImage,
	const BASEIMAGE *AlphaBaseImage,
	int AllNum,
	int XNum,
	int YNum,
	int IsFloat,
	int   SizeXI,
	float SizeXF,
	int   SizeYI,
	float SizeYF,
	int   StrideXI,
	float StrideXF,
	int   StrideYI,
	float StrideYF,
	int *HandleArray,
	int TextureFlag,
	int ReverseFlag,
	int ASyncThread
)
{
	int Result ;
	int GrSizeX, GrSizeY ;

	if( StrideXI == 0 )
	{
		StrideXI = SizeXI ;
	}

	if( StrideYI == 0 )
	{
		StrideYI = SizeYI ;
	}

	if( StrideXF == 0.0f )
	{
		StrideXF = SizeXF ;
	}

	if( StrideYF == 0.0f )
	{
		StrideYF = SizeYF ;
	}

	if( ReCreateFlag == FALSE )
	{
		int i, j, k ;
		int basexI, addxI ;
		float basexF, addxF ;

		// ʂɃOtBbN쐬
		if( Graphics_Image_CreateGraphFromGraphImageBase_UseGParam( GParam, FALSE, BaseHandle, BaseImage, AlphaBaseImage, TextureFlag, ASyncThread ) < 0 )
			return -1 ;

		if( ReverseFlag == TRUE )
		{
			basexI = ( XNum - 1 ) * StrideXI ;
			basexF = ( XNum - 1 ) * StrideXF ;
			addxI = -StrideXI ;
			addxF = -StrideXF ;
		}
		else
		{
			basexI = 0 ;
			basexF = 0 ;
			addxI = StrideXI ;
			addxF = StrideXF ;
		}

		// w̖ɕ
		k = 0 ;
		for( i = 0 ; k < AllNum && i < YNum ; i ++ )
		{
			for( j = 0 ; k < AllNum && j < XNum ; j ++, k ++ )
			{
				// TCỸ`FbN
				if( ( BaseImage->Width  < basexI   + addxI * j + StrideXI ) ||
					( BaseImage->Height < StrideYI         * i + StrideYI ) )
				{
					DXST_LOGFILE_ADDUTF16LE( "\xb0\x30\xe9\x30\xd5\x30\xa3\x30\xc3\x30\xaf\x30\x6e\x30\x06\x52\x72\x52\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x02\x30\x06\x52\x72\x52\x8c\x5f\x6e\x30\xcf\x7d\xb5\x30\xa4\x30\xba\x30\x4c\x30\x06\x52\x72\x52\x43\x51\x6e\x30\x3b\x75\xcf\x50\x88\x30\x8a\x30\x82\x30\x27\x59\x4d\x30\x44\x30\x07\x63\x9a\x5b\x6b\x30\x6a\x30\x63\x30\x66\x30\x57\x30\x7e\x30\x63\x30\x66\x30\x44\x30\x7e\x30\x59\x30\x02\x30\x20\x00\x69\x00\x6e\x00\x20\x00\x43\x00\x72\x00\x65\x00\x61\x00\x74\x00\x65\x00\x44\x00\x69\x00\x76\x00\x47\x00\x72\x00\x61\x00\x70\x00\x68\x00\x46\x00\x72\x00\x6f\x00\x6d\x00\x47\x00\x72\x00\x61\x00\x70\x00\x68\x00\x49\x00\x6d\x00\x61\x00\x67\x00\x65\x00\x0a\x00\x00"/*@ L"OtBbN̕Ɏs܂B̑TCỶ摜傫wɂȂĂ܂Ă܂B in CreateDivGraphFromGraphImage\n" @*/ ) ;
					return -1 ;
				}

				if( Graphics_Image_DerivationGraphBase(
						HandleArray[ k ],
						IsFloat,
						basexI + addxI * j,
						basexF + addxF * j,
						StrideYI * i,
						StrideYF * i,
						SizeXI,
						SizeXF,
						SizeYI,
						SizeYF,
						BaseHandle,
						ASyncThread ) < 0 )
				{
					DXST_LOGFILE_ADDUTF16LE( "\xb0\x30\xe9\x30\xd5\x30\xa3\x30\xc3\x30\xaf\x30\x6e\x30\x06\x52\x72\x52\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x20\x00\x69\x00\x6e\x00\x20\x00\x43\x00\x72\x00\x65\x00\x61\x00\x74\x00\x65\x00\x44\x00\x69\x00\x76\x00\x47\x00\x72\x00\x61\x00\x70\x00\x68\x00\x46\x00\x72\x00\x6f\x00\x6d\x00\x47\x00\x72\x00\x61\x00\x70\x00\x68\x00\x49\x00\x6d\x00\x61\x00\x67\x00\x65\x00\x0a\x00\x00"/*@ L"OtBbN̕Ɏs܂ in CreateDivGraphFromGraphImage\n" @*/ ) ;
					return -1 ;
				}
			}
		}
		Result = 0 ;
	}
	else
	{
		// Ȃ̋@\tĂȂrbg̃}XNZbg
		// (NoneMask ͓rꂽoϐȂ̂ŁAʌ݊邽߂ɁEEE)
		NS_SetColorDataNoneMask( ( COLORDATA * )&BaseImage->ColorData ) ;
		if( AlphaBaseImage != NULL ) NS_SetColorDataNoneMask( ( COLORDATA * )&AlphaBaseImage->ColorData ) ;

		// TCYG[
		if( NS_GetGraphSize( HandleArray[ 0 ], &GrSizeX, &GrSizeY ) == -1 ) return -1 ;
		if( BaseImage->Width < XNum * StrideXI || BaseImage->Height < YNum * StrideYI ) return -1 ;
		if( AlphaBaseImage != NULL && ( AlphaBaseImage->Width != BaseImage->Width || AlphaBaseImage->Height != BaseImage->Height ) ) return -1 ;

		LUTRANS_RE_DIV_GPARAM( GParam, BaseImage, HandleArray, AllNum )

		// OtBbNOtBbNnhɓ]
		Result = Graphics_Image_BltBmpOrGraphImageToDivGraphBase(
				BaseImage,
				AlphaBaseImage,
				AllNum,
				XNum,
				YNum,
				IsFloat,
				SizeXI,
				SizeXF,
				SizeYI,
				SizeYF,
				StrideXI,
				StrideXF,
				StrideYI,
				StrideYF,
				HandleArray,
				ReverseFlag,
				GParam->NotUseTransColor ? FALSE : TRUE,
				ASyncThread
		) ; 
	}

	// I
	return Result ;
}

// CreateGraphFromGraphImage ̓֐
extern int Graphics_Image_CreateGraphFromGraphImageBase( BASEIMAGE *BaseImage, const BASEIMAGE *AlphaBaseImage, int TextureFlag, int ASyncThread )
{
	CREATE_GRAPHHANDLE_AND_BLTGRAPHIMAGE_GPARAM GParam ;
	int GrHandle ;
	int Result ;

	CheckActiveState() ;

	GrHandle = Graphics_Image_AddHandle( ASyncThread ) ;
	if( GrHandle == -1 )
	{
		return -1 ;
	}

	Graphics_Image_InitCreateGraphHandleAndBltGraphImageGParam( &GParam ) ;

	Result = Graphics_Image_CreateGraphFromGraphImageBase_UseGParam( &GParam, FALSE, GrHandle, BaseImage, AlphaBaseImage, TextureFlag, FALSE ) ;
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		DecASyncLoadCount( GrHandle ) ;
	}
#endif // DX_NON_ASYNCLOAD
	if( Result < 0 )
	{
		NS_DeleteGraph( GrHandle, FALSE ) ;
		return -1 ;
	}

	return GrHandle ;
}

// CreateDivGraphFromGraphImage ̓֐
extern int Graphics_Image_CreateDivGraphFromGraphImageBase(
	BASEIMAGE *BaseImage,
	const BASEIMAGE *AlphaBaseImage,
	int AllNum,
	int XNum,
	int YNum,
	int IsFloat,
	int   SizeXI,
	float SizeXF,
	int   SizeYI,
	float SizeYF,
	int *HandleArray,
	int TextureFlag,
	int ReverseFlag
)
{
	int BaseHandle, i ;
	CREATE_GRAPHHANDLE_AND_BLTGRAPHIMAGE_GPARAM GParam ;

	// OtBbNnh̒l
	for( i = 0 ; i < AllNum ; i ++ )
	{
		HandleArray[ i ] = -1 ;
	}

	// {OtBbNnh̍쐬
	BaseHandle = Graphics_Image_AddHandle( FALSE ) ;
	if( BaseHandle == -1 )
	{
		return -1 ;
	}

	// OtBbNnh̍쐬
	_MEMSET( HandleArray, 0, AllNum * sizeof( int ) ) ;
	for( i = 0 ; i < AllNum ; i ++ )
	{
		HandleArray[ i ] = Graphics_Image_AddHandle( FALSE ) ;
		if( HandleArray[ i ] == -1 )
		{
			goto ERR ;
		}
	}

	// pf[^̏
	Graphics_Image_InitCreateGraphHandleAndBltGraphImageGParam( &GParam ) ;

	// OtBbNnh̍쐬
	if( Graphics_Image_CreateDivGraphFromGraphImageBase_UseGParam( &GParam, FALSE, BaseHandle, BaseImage, AlphaBaseImage, AllNum, XNum, YNum, IsFloat, SizeXI, SizeXF, SizeYI, SizeYF, 0, 0.0f, 0, 0.0f, HandleArray, TextureFlag, ReverseFlag, FALSE ) < 0 )
		goto ERR ;
	
	// ƂȂnh
	NS_DeleteGraph( BaseHandle, FALSE ) ;

	// I
	return 0 ;
	
ERR :
	for( i = 0 ; i < AllNum ; i ++ )
	{
		NS_DeleteGraph( HandleArray[ i ], FALSE ) ;
	}
	NS_DeleteGraph( BaseHandle, FALSE ) ;

	// G[I	
	return -1 ;
}

// ReCreateGraphFromGraphImage ̓֐
extern int Graphics_Image_ReCreateGraphFromGraphImageBase( BASEIMAGE *BaseImage, const BASEIMAGE *AlphaBaseImage, int GrHandle, int TextureFlag )
{
	CREATE_GRAPHHANDLE_AND_BLTGRAPHIMAGE_GPARAM GParam ;
	int Result ;

	CheckActiveState() ;

	Graphics_Image_InitCreateGraphHandleAndBltGraphImageGParam( &GParam ) ;

	Result = Graphics_Image_CreateGraphFromGraphImageBase_UseGParam( &GParam, TRUE, GrHandle, BaseImage, AlphaBaseImage, TextureFlag, FALSE ) ;

	return Result ;
}

// ReCreateDivGraphFromGraphImage ̓֐
extern int Graphics_Image_ReCreateDivGraphFromGraphImageBase( BASEIMAGE *BaseImage, const BASEIMAGE *AlphaBaseImage, int AllNum, int XNum, int YNum, int IsFloat, int SizeXI, float SizeXF, int SizeYI, float SizeYF, const int *HandleArray, int TextureFlag, int ReverseFlag )
{
	CREATE_GRAPHHANDLE_AND_BLTGRAPHIMAGE_GPARAM GParam ;
	int Result ;

	CheckActiveState() ;

	Graphics_Image_InitCreateGraphHandleAndBltGraphImageGParam( &GParam ) ;

	Result = Graphics_Image_CreateDivGraphFromGraphImageBase_UseGParam( &GParam, TRUE, -1, BaseImage, AlphaBaseImage, AllNum, XNum, YNum, IsFloat, SizeXI, SizeXF, SizeYI, SizeYF, 0, 0.0f, 0, 0.0f, ( int * )HandleArray, TextureFlag, ReverseFlag, FALSE ) ;

	// I
	return Result ;
}

// CREATE_GRAPHHANDLE_AND_BLTGRAPHIMAGE_GPARAM ̃f[^Zbg
extern void Graphics_Image_InitCreateGraphHandleAndBltGraphImageGParam( CREATE_GRAPHHANDLE_AND_BLTGRAPHIMAGE_GPARAM *GParam )
{
	Graphics_Image_InitSetupGraphHandleGParam( &GParam->InitHandleGParam ) ;

	GParam->UseTransColorGraphCreateFlag	= GSYS.CreateImage.UseTransColorFlag ;
	GParam->NotUseTransColor				= GSYS.CreateImage.NotUseTransColor ;
	GParam->LeftUpColorIsTransColorFlag		= GSYS.CreateImage.LeftUpColorIsTransColorFlag ;
}

// SETUP_GRAPHHANDLE_GPARAM ̃f[^Zbg
extern void Graphics_Image_InitSetupGraphHandleGParam( SETUP_GRAPHHANDLE_GPARAM *GParam )
{
	GParam->TransColor							= GSYS.CreateImage.TransColor ;

	GParam->CreateImageColorBitDepth			= GSYS.CreateImage.ColorBitDepth ;
	GParam->FloatTypeGraphCreateFlag			= FALSE ;
	GParam->CreateImageChannelNum				= 0 ;
	GParam->CreateImageChannelBitDepth			= GSYS.CreateImage.ChannelBitDepth ;
	GParam->AlphaTestImageCreateFlag			= GSYS.CreateImage.AlphaTestFlag ;
	GParam->AlphaChannelImageCreateFlag			= GSYS.CreateImage.AlphaChannelFlag ;
	GParam->CubeMapTextureCreateFlag			= GSYS.CreateImage.CubeMapFlag ;
	GParam->BlendImageCreateFlag				= GSYS.CreateImage.BlendImageFlag ;
	GParam->UseManagedTextureFlag				= GSYS.CreateImage.NotUseManagedTextureFlag ? FALSE : TRUE ;
	GParam->UseLinearMapTextureFlag				= FALSE ;
	GParam->PlatformTextureFormat				= GSYS.CreateImage.PlatformTextureFormat ;

	GParam->DrawValidImageCreateFlag			= GSYS.CreateImage.DrawValidFlag ;
	GParam->DrawValidAlphaImageCreateFlag		= GSYS.CreateImage.DrawValidAlphaFlag ;
	GParam->DrawValidFloatTypeGraphCreateFlag	= GSYS.CreateImage.DrawValidFloatTypeFlag ;
	GParam->DrawValidGraphCreateZBufferFlag		= GSYS.CreateImage.NotDrawValidCreateZBufferFlag ? FALSE : TRUE ;
	GParam->CreateDrawValidGraphZBufferBitDepth	= GSYS.CreateImage.DrawValidZBufferBitDepth ;
	GParam->CreateDrawValidGraphMipLevels		= GSYS.CreateImage.DrawValidMipLevels ;
	GParam->CreateDrawValidGraphChannelNum		= GSYS.CreateImage.DrawValidChannelNum ;
	GParam->DrawValidMSSamples					= GSYS.CreateImage.DrawValidMSSamples ;
	GParam->DrawValidMSQuality					= GSYS.CreateImage.DrawValidMSQuality ;

	GParam->MipMapCount							= GSYS.CreateImage.MipMapCount ;
	GParam->UserMaxTextureSize					= GSYS.CreateImage.UserMaxTextureSize ;
	GParam->NotUseDivFlag						= GSYS.CreateImage.NotUseDivFlag ;
	GParam->NotUseAlphaImageLoadFlag			= GSYS.CreateImage.NotUseAlphaImageLoadFlag ;
	GParam->NotUsePaletteGraphFlag				= GSYS.CreateImage.NotUsePaletteGraphFlag ;
	GParam->NotInitGraphDelete					= FALSE ;
	GParam->NotInitGraphDeleteUser				= GSYS.CreateImage.NotInitGraphDeleteUserFlag ;

	GParam->UserPlatformTexture					= NULL ;
}

extern void Graphics_Image_InitSetupGraphHandleGParam_Normal_NonDrawValid( SETUP_GRAPHHANDLE_GPARAM *GParam, int BitDepth, int AlphaChannel, int AlphaTest )
{
	GParam->TransColor							= 0x00ff00ff ;

	GParam->CreateImageColorBitDepth			= BitDepth ;
	GParam->FloatTypeGraphCreateFlag			= FALSE ;
	GParam->CreateImageChannelNum				= 0 ;
	GParam->CreateImageChannelBitDepth			= 0 ;
	GParam->AlphaTestImageCreateFlag			= AlphaTest ;
	GParam->AlphaChannelImageCreateFlag			= AlphaChannel ;
	GParam->CubeMapTextureCreateFlag			= FALSE ;
	GParam->BlendImageCreateFlag				= FALSE ;
	GParam->UseManagedTextureFlag				= TRUE ;
	GParam->UseLinearMapTextureFlag				= FALSE ;
	GParam->PlatformTextureFormat				= 0 ;

	GParam->DrawValidImageCreateFlag			= FALSE ;
	GParam->DrawValidAlphaImageCreateFlag		= FALSE ;
	GParam->DrawValidFloatTypeGraphCreateFlag	= FALSE ;
	GParam->DrawValidGraphCreateZBufferFlag		= FALSE ;
	GParam->CreateDrawValidGraphMipLevels		= 0 ;
	GParam->CreateDrawValidGraphChannelNum		= 0 ;
	GParam->CreateDrawValidGraphZBufferBitDepth	= 0 ;
	GParam->DrawValidMSSamples					= 0 ;
	GParam->DrawValidMSQuality					= 0 ;

	GParam->MipMapCount							= 1 ;
	GParam->UserMaxTextureSize					= 0 ;
	GParam->NotUseDivFlag						= TRUE ;
	GParam->NotUseAlphaImageLoadFlag			= TRUE ;
	GParam->NotUsePaletteGraphFlag				= FALSE ;
	GParam->NotInitGraphDelete					= FALSE ;
	GParam->NotInitGraphDeleteUser				= FALSE ;

	GParam->UserPlatformTexture					= NULL ;
}

extern void Graphics_Image_InitSetupGraphHandleGParam_Normal_DrawValid_NoneZBuffer( SETUP_GRAPHHANDLE_GPARAM *GParam, int BitDepth, int AlphaChannel )
{
	GParam->TransColor							= 0x00ff00ff ;

	GParam->CreateImageColorBitDepth			= BitDepth ;
	GParam->FloatTypeGraphCreateFlag			= FALSE ;
	GParam->CreateImageChannelNum				= 0 ;
	GParam->CreateImageChannelBitDepth			= 0 ;
	GParam->AlphaTestImageCreateFlag			= FALSE ;
	GParam->AlphaChannelImageCreateFlag			= AlphaChannel ;
	GParam->CubeMapTextureCreateFlag			= FALSE ;
	GParam->BlendImageCreateFlag				= FALSE ;
	GParam->UseManagedTextureFlag				= FALSE ;
	GParam->UseLinearMapTextureFlag				= FALSE ;
	GParam->PlatformTextureFormat				= 0 ;

	GParam->DrawValidImageCreateFlag			= TRUE ;
	GParam->DrawValidAlphaImageCreateFlag		= AlphaChannel ;
	GParam->DrawValidFloatTypeGraphCreateFlag	= FALSE ;
	GParam->DrawValidGraphCreateZBufferFlag		= FALSE ;
	GParam->CreateDrawValidGraphMipLevels		= 0 ;
	GParam->CreateDrawValidGraphChannelNum		= 0 ;
	GParam->CreateDrawValidGraphZBufferBitDepth	= 0 ;
	GParam->DrawValidMSSamples					= 0 ;
	GParam->DrawValidMSQuality					= 0 ;

	GParam->MipMapCount							= 1 ;
	GParam->UserMaxTextureSize					= 0 ;
	GParam->NotUseDivFlag						= TRUE ;
	GParam->NotUseAlphaImageLoadFlag			= TRUE ;
	GParam->NotUsePaletteGraphFlag				= FALSE ;
	GParam->NotInitGraphDelete					= FALSE ;
	GParam->NotInitGraphDeleteUser				= FALSE ;

	GParam->UserPlatformTexture					= NULL ;
}

// SETGRAPHBASEINFO_GPARAM ̃f[^Zbg
extern void Graphics_Image_InitSetGraphBaseInfoGParam( SETGRAPHBASEINFO_GPARAM *GParam )
{
	GParam->NotGraphBaseDataBackupFlag = GSYS.CreateImage.NotGraphBaseDataBackupFlag ;
}

// LOADGRAPH_GPARAM ̃f[^Zbg
extern void Graphics_Image_InitLoadGraphGParam( LOADGRAPH_GPARAM *GParam )
{
	InitLoadBaseImageGParam( &GParam->LoadBaseImageGParam, FALSE ) ;
#ifndef DX_NON_MOVIE
	Graphics_Image_InitOpenMovieGParam( &GParam->OpenMovieGParam ) ;
#endif
	Graphics_Image_InitCreateGraphHandleAndBltGraphImageGParam( &GParam->CreateGraphGParam ) ;
	Graphics_Image_InitSetGraphBaseInfoGParam( &GParam->SetGraphBaseInfoGParam ) ;
}























// `ݒ֌W֐

// OtBbN`ݒ֌W̏
extern	int		Graphics_DrawSetting_Initialize( void )
{
	int i ;

//	int NotDrawFlag                            = GSYS.NotDrawFlag ;
//	int NotUseBasicGraphDraw3DDeviceMethodFlag = GSYS.DrawSetting.NotUseBasicGraphDraw3DDeviceMethodFlag ;
//	int PreSetWaitVSyncFlag                    = GSYS.Screen.PreSetWaitVSyncFlag ;
//	int NotGraphBaseDataBackupFlag             = GSYS.CreateImage.NotGraphBaseDataBackupFlag ;
//	int NotUseManagedTextureFlag               = GSYS.CreateImage.NotUseManagedTextureFlag ;
	RECT OriginalDrawRect                      = GSYS.DrawSetting.OriginalDrawRect ;
	int Large3DPositionSupport                 = GSYS.DrawSetting.Large3DPositionSupport ;

	// [
	_MEMSET( &GSYS.DrawSetting, 0, sizeof( GSYS.DrawSetting ) ) ;
	_MEMSET( &GSYS.Camera,      0, sizeof( GSYS.Camera      ) ) ;
//	_MEMSET( &GSYS.CreateImage, 0, sizeof( GSYS.CreateImage ) ) ;

//	GSYS.NotDrawFlag						     = NotDrawFlag ;
//	GSYS.DrawSetting.NotUseBasicGraphDraw3DDeviceMethodFlag = NotUseBasicGraphDraw3DDeviceMethodFlag ;
//	GSYS.Screen.PreSetWaitVSyncFlag             = PreSetWaitVSyncFlag ;
//	GSYS.CreateImage.NotGraphBaseDataBackupFlag = NotGraphBaseDataBackupFlag ;
//	GSYS.CreateImage.NotUseManagedTextureFlag   = NotUseManagedTextureFlag ;
	GSYS.DrawSetting.OriginalDrawRect           = OriginalDrawRect ;
	GSYS.DrawSetting.Large3DPositionSupport     = Large3DPositionSupport ;

	// eNX`AhX[h̏ݒ
	for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++ )
	{
		if( GSYS.DrawSetting.TexAddressModeU[ i ] == 0 )
			GSYS.DrawSetting.TexAddressModeU[ i ] = DX_TEXADDRESS_CLAMP ;
		if( GSYS.DrawSetting.TexAddressModeV[ i ] == 0 )
			GSYS.DrawSetting.TexAddressModeV[ i ] = DX_TEXADDRESS_CLAMP ;
		if( GSYS.DrawSetting.TexAddressModeW[ i ] == 0 )
			GSYS.DrawSetting.TexAddressModeW[ i ] = DX_TEXADDRESS_CLAMP ;
	}

	// uh摜͐ݒ肳ĂȂԂɂ
	GSYS.DrawSetting.BlendGraph = -1 ;

	// yobt@̏ݒ
	GSYS.DrawSetting.EnableZBufferFlag2D = FALSE ;
	GSYS.DrawSetting.WriteZBufferFlag2D  = FALSE ;
	GSYS.DrawSetting.EnableZBufferFlag3D = FALSE ;
	GSYS.DrawSetting.WriteZBufferFlag3D  = FALSE ;

	// Cg̐ݒn[hEGAANZ[^ɔf悤ɃtOZbg
	GSYS.Light.HardwareChange = TRUE ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// `ylZbg
	GSYS.DrawSetting.DrawZ = 0.2f;

	// yr[hZbg
	GSYS.DrawSetting.ZBufferCmpType2D = DX_CMP_LESSEQUAL;
	GSYS.DrawSetting.ZBufferCmpType3D = DX_CMP_LESSEQUAL;

	// ̓eNX`T[tFX쐬
//	GSYS.TextureImageCreateFlag = TRUE ;

	// ߐFɃAt@eXggp
	GSYS.CreateImage.AlphaTestFlag = TRUE ;
	BASEIM.AlphaTestImageCreateFlag = TRUE ;

	// `惂[hlAXglCo[ɃZbg
	GSYS.DrawSetting.DrawMode = DX_DRAWMODE_NEAREST ;

	// őٕPɃZbg
	GSYS.DrawSetting.MaxAnisotropy = 1 ;

	// tB[h̓|S`
	GSYS.DrawSetting.FillMode = DX_FILL_SOLID ;

	// uh[huhɃZbg
	GSYS.DrawSetting.BlendMode = DX_BLENDMODE_NOBLEND ;

	// At@eXg[h̓ftHg
	GSYS.DrawSetting.AlphaTestMode = -1 ;

	// `PxZbg
	NS_SetDrawBright( 255, 255, 255 ) ;
//	GSYS.DrawSetting.bDrawBright = 0xffffff ;

	// ZFZbg
	NS_SetDrawAddColor( 0, 0, 0 ) ;

	// tHȌݒ
	NS_SetFogMode( DX_FOGMODE_LINEAR ) ;
	NS_SetFogColor( 255, 255, 255 ) ;
	NS_SetFogStartEnd( 0.0f, 1500.0f ) ;

	// gpsNZtH[}bgZbg
//	SetCreateGraphColorBitDepth( COLORBITDEPTH ) ;
	NS_SetCreateGraphColorBitDepth( 0 ) ;

#ifndef DX_NON_MASK
	// }XN͎gpɃZbg
	MASKD.MaskUseFlag = TRUE ;
	MASKD.MaskValidFlag = FALSE ;
#endif

	// `XN[̈Zbg
	GSYS.DrawSetting.TargetScreen[ 0 ] = DX_SCREEN_BACK ;
	GSYS.DrawSetting.TargetScreenSurface[ 0 ] = 0 ;
	GSYS.DrawSetting.TargetScreenMipLevel[ 0 ] = 0 ;
	NS_SetDrawScreen( DX_SCREEN_FRONT ) ;

	// `\̈ݒ
	{
		int Width, Height ;

		NS_GetGraphSize( GSYS.DrawSetting.TargetScreen[ 0 ], &Width, &Height ) ;
		NS_SetDrawArea( 0, 0, Width, Height ) ;
	}

	// Wuhɂ
//	NS_SetDrawBlendMode( DX_BLENDMODE_ALPHA, 255 ) ;
	
	// `\ȏԂɂ
//	GSYS.NotDrawFlag = FALSE ;

	// ftHg̃Cg쐬
	{
		VECTOR Dir ;

		Dir.x =  1.0f ;
		Dir.y = -1.0f ;
		Dir.z =  1.0f ;
		GSYS.Light.DefaultHandle = NS_CreateDirLightHandle( Dir ) ;
	}

	// esɒPʍs̃Zbg
	CreateIdentityMatrixD( &GSYS.DrawSetting._2DMatrix ) ;
	CreateIdentityMatrix(  &GSYS.DrawSetting._2DMatrixF ) ;
	CreateIdentityMatrixD( &GSYS.DrawSetting.WorldMatrix ) ;
	CreateIdentityMatrix(  &GSYS.DrawSetting.WorldMatrixF ) ;
	CreateIdentityMatrixD( &GSYS.DrawSetting.ViewMatrix ) ;
	CreateIdentityMatrix(  &GSYS.DrawSetting.ViewMatrixF ) ;
	CreateIdentityMatrixD( &GSYS.DrawSetting.ProjectionMatrix ) ;
	CreateIdentityMatrix(  &GSYS.DrawSetting.ProjectionMatrixF ) ;
	CreateIdentityMatrixD( &GSYS.DrawSetting.Direct3DViewportMatrix ) ;
	CreateIdentityMatrix(  &GSYS.DrawSetting.Direct3DViewportMatrixF ) ;
	CreateIdentityMatrixD( &GSYS.DrawSetting.Direct3DViewportMatrixAnti ) ;
	CreateIdentityMatrix(  &GSYS.DrawSetting.Direct3DViewportMatrixAntiF ) ;
	CreateIdentityMatrixD( &GSYS.DrawSetting.ViewportMatrix ) ;
	CreateIdentityMatrix(  &GSYS.DrawSetting.ViewportMatrixF ) ;
	CreateIdentityMatrixD( &GSYS.DrawSetting.Blend3DMatrix ) ;
	CreateIdentityMatrix(  &GSYS.DrawSetting.Blend3DMatrixF ) ;
	CreateIdentityMatrixD( &GSYS.DrawSetting.InverseBlend3DMatrix ) ;
	CreateIdentityMatrix(  &GSYS.DrawSetting.InverseBlend3DMatrixF ) ;
	CreateIdentityMatrixD( &GSYS.DrawSetting.WorldViewMatrix ) ;
	CreateIdentityMatrixD( &GSYS.DrawSetting.ViewProjectionViewportMatrix ) ;
	CreateIdentityMatrixD( &GSYS.DrawSetting.BillboardMatrix ) ;
	CreateIdentityMatrix(  &GSYS.DrawSetting.BillboardMatrixF ) ;
	CreateIdentityMatrixD( &GSYS.DrawSetting.ConvScreenPosToWorldPosMatrix ) ;
	CreateIdentityMatrix(  &GSYS.DrawSetting.TextureAddressTransformMatrix ) ;

	// ˉes̐ݒ
	GSYS.DrawSetting.ProjectionMatrixMode = 0 ;
	GSYS.DrawSetting.ProjNear             = 10.0 ;
	GSYS.DrawSetting.ProjFar              = 10000.0 ;
	GSYS.DrawSetting.ProjDotAspect        = 1.0 ;
	GSYS.DrawSetting.ProjFov              = DEFAULT_FOV ;
	GSYS.DrawSetting.ProjSize             = 1.0 ;
	CreateIdentityMatrixD( &GSYS.DrawSetting.ProjMatrix ) ;

	// }eȀlZbg
	GSYS.Light.ChangeMaterial    = 1 ;
	GSYS.Light.Material.Diffuse  = GetColorF( 0.8f, 0.8f, 0.8f, 1.0f ) ;
	GSYS.Light.Material.Specular = GetColorF( 0.8f, 0.8f, 0.8f, 0.0f ) ;
	GSYS.Light.Material.Ambient  = GetColorF( 0.0f, 0.0f, 0.0f, 0.0f ) ;
	GSYS.Light.Material.Emissive = GetColorF( 0.0f, 0.0f, 0.0f, 0.0f ) ;
	GSYS.Light.Material.Power    = 20.0f ;

	// Rc`XP[l
	GSYS.DrawSetting.Draw3DScale = 1.0f ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// I
	return 0 ;
}

// ⏕֐
extern void FASTCALL Graphics_DrawSetting_BlendModeSub_Pre( RECT *DrawRect )
{
	DWORD Bright ;
	DWORD Cr ;
	int   BlendParam ;

	Cr         = NS_GetColor( 255,255,255 ) ;
	Bright     = GSYS.DrawSetting.bDrawBright ;
	BlendParam = GSYS.DrawSetting.BlendParam ;

	Graphics_DrawSetting_SetDrawBrightToOneParam( 0xffffff ) ;
	NS_SetDrawBlendMode( DX_BLENDMODE_SUB, 255 ) ;

	Graphics_Hardware_DrawFillBox_PF( DrawRect->left, DrawRect->top, DrawRect->right, DrawRect->bottom, Cr ) ;

	Graphics_DrawSetting_SetDrawBrightToOneParam( Bright ) ;
	NS_SetDrawBlendMode( DX_BLENDMODE_SUB2, BlendParam ) ;
}

extern void FASTCALL Graphics_DrawSetting_BlendModeSub_Post( RECT *DrawRect )
{
	DWORD Bright ;
	DWORD Cr ;
	int   BlendParam ;

	Cr         = NS_GetColor( 255,255,255 ) ;
	Bright     = GSYS.DrawSetting.bDrawBright ;
	BlendParam = GSYS.DrawSetting.BlendParam ;

	Graphics_DrawSetting_SetDrawBrightToOneParam( 0xffffff ) ;
	NS_SetDrawBlendMode( DX_BLENDMODE_SUB, 255 ) ; 
	
	Graphics_Hardware_DrawFillBox_PF( DrawRect->left, DrawRect->top, DrawRect->right, DrawRect->bottom, Cr ) ;

	Graphics_DrawSetting_SetDrawBrightToOneParam( Bright ) ;
	NS_SetDrawBlendMode( DX_BLENDMODE_SUB, BlendParam ) ;
}

// SetBlendGraphParam ̉ϒp[^t
extern int Graphics_DrawSetting_SetBlendGraphParamBase( int BlendGraph, int BlendType, va_list ParamList )
{
	IMAGEDATA *BlendImage ;
	int Param[ 16 ] ;

	// uh摜 -1 uh摜~߂Ƃ
	if( BlendGraph <= 0 )
	{
		BlendImage = NULL ;
		GSYS.DrawSetting.BlendGraph = -1 ;
	}
	else
	{
		// G[
		if( GRAPHCHK( BlendGraph, BlendImage ) )
			return -1 ;
		GSYS.DrawSetting.BlendGraph = BlendGraph ;
	}

	CheckActiveState() ;

	if( BlendImage != NULL )
	{
		switch( BlendType )
		{
		case DX_BLENDGRAPHTYPE_NORMAL :
			int FadeRatio ;

			FadeRatio = va_arg( ParamList, int ) ;

			if( FadeRatio > 255 ) FadeRatio = 255 ;
			else
			if( FadeRatio < 0   ) FadeRatio = 0   ;

			Param[ 0 ] = FadeRatio ;
			break ;

		case DX_BLENDGRAPHTYPE_WIPE :
			int BorderRange ;
			int BorderParam ;

			BorderParam = va_arg( ParamList, int ) ;
			BorderRange = va_arg( ParamList, int ) ;

			if( BorderRange > 255 ) BorderRange = 255 ;
			else
			if( BorderRange < 0   ) BorderRange = 0   ;

			if( BorderParam > 255 ) BorderParam = 255 ;
			else
			if( BorderParam < 0	  ) BorderParam = 0   ;
			
			Param[ 0 ] = GSYS.DrawSetting.BlendGraphBorderParam = BorderParam ;
			Param[ 1 ] = GSYS.DrawSetting.BlendGraphBorderRange = BorderRange ;

			// Direct3D gpĂȂꍇ̂ݏ𕪊
			if( GSYS.Setting.ValidHardware == FALSE || GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode )
			{
				// MEMIMG VXeւ̐ݒ
				SetBlendGraphParamMemImg( BorderParam, BorderRange ) ;
			}
			break ;

		case DX_BLENDGRAPHTYPE_ALPHA :
			break ;
		}
	}

	// n[hEGAANZ[VgpĂ邩ǂŏ𕪊
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		// n[hEGAANZ[VgpĂꍇ̏
		Graphics_Hardware_SetBlendGraphParamBase_PF( BlendImage, BlendType, Param ) ;
	}
	else
	{
		// n[hEGAANZ[VgpĂȂꍇ̏

		// uhOtBbÑAhXݒ
		GSYS.SoftRender.BlendMemImg = GSYS.DrawSetting.BlendGraph <= 0 ? NULL : &BlendImage->Orig->Soft.MemImg ;
	}

	// I
	return 0 ;
}

// `ɐlނǂ̃tOXV
extern	int Graphics_DrawSetting_RefreshAlphaChDrawMode( void )
{
	return Graphics_Hardware_RefreshAlphaChDrawMode_PF() ;
}

// {f[^ɐݒ肳ĂQcsn[hEGAɔf
extern void Graphics_DrawSetting_ApplyLib2DMatrixToHardware( void )
{
	if( GSYS.Setting.ValidHardware == FALSE || GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode ) return ;

	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE )
	{
		// `ҋ@Ă`敨`
		DRAWSTOCKINFO

		// Graphics_Hardware_SetTransformToProjection_PF ĂԑO MatchHardware_2DMatrix  TRUE ɂĂKv
		GSYS.DrawSetting.MatchHardware_2DMatrix = TRUE ;

		// LLĂˉes𖳌ɂ
		GSYS.DrawSetting.MatchHardware3DMatrix = FALSE ;
		GSYS.DrawSetting.MatchHardwareProjectionMatrix = FALSE ;

		// Rcs̎ˉesɂQcsZbg
		Graphics_Hardware_SetTransformToProjection_PF( &GSYS.DrawSetting._2DMatrixF ) ;
	}
}

// {f[^ɐݒ肳ĂRcsn[hEGAɔf
extern void Graphics_DrawSetting_ApplyLib3DMatrixToHardware( int IgnoreWorldMatrix )
{
	if( GSYS.DrawSetting.MatchHardware3DMatrix == TRUE ) return ;

	if( GSYS.Setting.ValidHardware == FALSE || GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode ) return ;

	if( GSYS.DrawSetting.MatchHardwareWorldMatrix == FALSE &&
		IgnoreWorldMatrix == FALSE )
	{
		Graphics_Hardware_DeviceDirect_SetWorldMatrix_PF( &GSYS.DrawSetting.WorldMatrixF ) ;
		GSYS.DrawSetting.MatchHardwareWorldMatrix = TRUE ;
	}

	if( GSYS.DrawSetting.MatchHardwareViewMatrix == FALSE )
	{
		Graphics_Hardware_DeviceDirect_SetViewMatrix_PF( &GSYS.DrawSetting.ViewMatrixF ) ;
		GSYS.DrawSetting.MatchHardwareViewMatrix = TRUE ;
	}

	if( GSYS.DrawSetting.MatchHardwareProjectionMatrix == FALSE )
	{
		// `ҋ@Ă`敨`
		DRAWSTOCKINFO

		// LLĂQcs𖳌ɂ
		GSYS.DrawSetting.MatchHardware_2DMatrix = FALSE ;
		GSYS.DrawSetting.MatchHardwareProjectionMatrix = TRUE ;

		// Rcs̎ˉesZbg
		Graphics_Hardware_SetTransformToProjection_PF( &GSYS.DrawSetting.ProjectionMatrixF ) ;
	}

	if( GSYS.DrawSetting.MatchHardwareTextureAddressTransformMatrix == FALSE )
	{
		Graphics_Hardware_SetTextureAddressTransformMatrix_PF( GSYS.DrawSetting.TextureAddressTransformUse, &GSYS.DrawSetting.TextureAddressTransformMatrix ) ;
		GSYS.DrawSetting.MatchHardwareTextureAddressTransformMatrix = TRUE ;
	}

	GSYS.DrawSetting.MatchHardware3DMatrix = GSYS.DrawSetting.MatchHardwareWorldMatrix == TRUE ? TRUE : FALSE ;
}

// {f[^ɐݒ肳ĂtHOn[hEFAɔf
extern void Graphics_DrawSetting_ApplyLibFogToHardware( void )
{
	Graphics_Hardware_ApplyLigFogToHardware_PF() ;
}

// eNX`WϊsZbg
extern int Graphics_DrawSetting_SetTextureAddressTransformMatrix_Direct( int Use, MATRIX *Matrix, int Stage )
{
	Graphics_Hardware_SetTextureAddressTransformMatrix_PF( Use, Matrix, Stage ) ;
	GSYS.DrawSetting.MatchHardwareTextureAddressTransformMatrix = FALSE ;
	GSYS.DrawSetting.MatchHardware3DMatrix = FALSE ;

	// I
	return 0 ;
}

// [J[hsύX
extern int Graphics_DrawSetting_SetTransformToWorld_Direct( MATRIX *Matrix )
{
	Graphics_Hardware_DeviceDirect_SetWorldMatrix_PF( Matrix ) ;
	GSYS.DrawSetting.MatchHardwareWorldMatrix = FALSE ;
	GSYS.DrawSetting.MatchHardware3DMatrix = FALSE ;

	// I
	return 0 ;
}

// eϊpsZbg
extern	int Graphics_DrawSetting_SetTransformToProjection_Direct( const MATRIX_D *Matrix )
{
	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// f[^ۑ
	GSYS.DrawSetting.ProjectionMatrix = *Matrix ;
	ConvertMatrixDtoF( &GSYS.DrawSetting.ProjectionMatrixF, &GSYS.DrawSetting.ProjectionMatrix ) ;
	GSYS.DrawSetting.ValidBlend3DMatrix = FALSE ;

	// SĂ̂Rcs|킹sXV
	Graphics_DrawSetting_RefreshBlend3DTransformMatrix() ;

	// n[hEGAANZ[Vɐݒ
	if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
	{
		// `ҋ@Ă`敨`
		DRAWSTOCKINFO

		// LLĂQcs𖳌ɂ
		GSYS.DrawSetting.MatchHardware_2DMatrix = FALSE ;
		GSYS.DrawSetting.MatchHardwareProjectionMatrix = TRUE ;

		// Rcs̎ˉesZbg
		Graphics_Hardware_SetTransformToProjection_PF( &GSYS.DrawSetting.ProjectionMatrixF ) ;
	}

	// I
	return 0 ;
}

// SetDrawScreen sɍs`͈͐ݒAJݒs
extern int Graphics_DrawSetting_SetupDefaultDrawAreaAndCamera( int OldScreen )
{
	// `̈XV
	{
		RECT SrcRect ;
		int NewWidth = 0, NewHeight = 0, OldWidth = 0, OldHeight = 0 ;

		NS_GetGraphSize( GSYS.DrawSetting.TargetScreen[ 0 ], &NewWidth, &NewHeight ) ;
		NS_GetGraphSize( OldScreen,                          &OldWidth, &OldHeight ) ;

		SrcRect = GSYS.DrawSetting.DrawArea ;

		if( GSYS.DrawSetting.SetDrawScreenNoSettingResetFlag )
		{
			if( GSYS.DrawSetting.ShadowMapDrawSetupRequest )
			{
				RECT OriginalDrawRect = GSYS.DrawSetting.OriginalDrawRect ;

				NS_SetDrawArea( 0, 0, NewWidth, NewHeight ) ;

				GSYS.DrawSetting.OriginalDrawRect = OriginalDrawRect ;
			}
			else
			{
				NS_SetDrawArea(
					GSYS.DrawSetting.OriginalDrawRect.left,
					GSYS.DrawSetting.OriginalDrawRect.top,
					GSYS.DrawSetting.OriginalDrawRect.right,
					GSYS.DrawSetting.OriginalDrawRect.bottom
				) ;
			}
		}
		else
		{
//			if( GSYS.DrawSetting.ShadowMapDrawSetupRequest || ( NewWidth != OldWidth ) || ( NewHeight != OldHeight ) )
//			{
				NS_SetDrawArea( 0, 0, NewWidth, NewHeight ) ;
//			}
//			else
//			{
//				NS_SetDrawArea( SrcRect.left, SrcRect.top, SrcRect.right, SrcRect.bottom ) ;
//			}
		}
	}
		
	// Rc`揈p̍sݒ̏s
	if( GSYS.DrawSetting.SetDrawScreenNoSettingResetFlag == FALSE )
	{
		MATRIX mat ;
		float D ;

		// hbgAXyNgPDOɖ߂
		NS_SetCameraDotAspect( 1.0f ) ;

		// [hϊs͒Pʍs
		CreateIdentityMatrix( &mat ) ;
		NS_SetTransformToWorld( &mat ) ;

		// CuǗ̃r[|[gsXV
		GSYS.Camera.ScreenCenterX = ( double )GSYS.DrawSetting.DrawSizeX / 2.0 ;
		GSYS.Camera.ScreenCenterY = ( double )GSYS.DrawSetting.DrawSizeY / 2.0 ;
		NS_SetCameraScreenCenterD( GSYS.Camera.ScreenCenterX, GSYS.Camera.ScreenCenterY ) ;

		// r[s z = 0.0 ̎ɒxXN[ŜʂʒuƕJ
		{
			VECTOR up, at, eye ;

			D = ( float )( ( GSYS.DrawSetting.DrawSizeY / 2 ) / DEFAULT_TAN_FOV_HALF ) ;

			eye.x = ( float )GSYS.DrawSetting.DrawSizeX / 2 ;
			eye.y = ( float )GSYS.DrawSetting.DrawSizeY / 2 ;
			eye.z = -D;
			
			at.x = eye.x ;
			at.y = eye.y ;
			at.z = eye.z + 1.0F ;
			
			up.x = 0.0f ;
			up.y = 1.0F ;
			up.z = 0.0f ;
			
			NS_SetCameraPositionAndTargetAndUpVec( eye, at, up ) ;
//			CreateLookAtMatrix( &mat, &eye, &at, &up ) ;
//			NS_SetTransformToView( &mat ) ;
		}

		// vWFNVs͕ʂ
		NS_SetupCamera_Perspective( DEFAULT_FOV ) ;
		NS_SetCameraNearFar( D * 0.1f + DEFAULT_NEAR, D + DEFAULT_FAR ) ;
	}

	return 0 ;
}

// ˉesp[^ɊÂĎˉes\z
extern void Graphics_DrawSetting_RefreshProjectionMatrix( void )
{
	double Aspect = 1.0 ;

	if( GSYS.DrawSetting.ProjectionMatrixMode != 2 )
	{
		Aspect = ( double )GSYS.DrawSetting.DrawSizeY / ( double )GSYS.DrawSetting.DrawSizeX * GSYS.DrawSetting.ProjDotAspect ;
	}

	switch( GSYS.DrawSetting.ProjectionMatrixMode )
	{
	case 0 :	// ߖ@
		CreatePerspectiveFovMatrixD( &GSYS.DrawSetting.ProjMatrix, GSYS.DrawSetting.ProjFov, GSYS.DrawSetting.ProjNear, GSYS.DrawSetting.ProjFar, Aspect ) ;
		break ;

	case 1 :	// ˉe
		CreateOrthoMatrixD( &GSYS.DrawSetting.ProjMatrix, GSYS.DrawSetting.ProjSize, GSYS.DrawSetting.ProjNear, GSYS.DrawSetting.ProjFar, Aspect ) ;
		break ;

	case 2 :	// s񒼎w
		break ;
	}

	// n[hEGAɔf
	Graphics_DrawSetting_SetTransformToProjection_Direct( &GSYS.DrawSetting.ProjMatrix ) ;
}

// Rcp̒_ϊs|킹sXV
extern void Graphics_DrawSetting_RefreshBlend3DTransformMatrix( void )
{
	if( GSYS.DrawSetting.ValidBlend3DMatrix == TRUE ) return ;

	CreateMultiplyMatrixD( &GSYS.DrawSetting.WorldViewMatrix, &GSYS.DrawSetting.WorldMatrix, &GSYS.DrawSetting.ViewMatrix ) ;
	CreateMultiplyMatrixD( &GSYS.DrawSetting.ViewProjectionViewportMatrix, &GSYS.DrawSetting.ViewMatrix, &GSYS.DrawSetting.ProjectionMatrix ) ;
	CreateMultiplyMatrixD( &GSYS.DrawSetting.ViewProjectionViewportMatrix, &GSYS.DrawSetting.ViewProjectionViewportMatrix, &GSYS.DrawSetting.ViewportMatrix ) ;
	CreateMultiplyMatrixD( &GSYS.DrawSetting.Blend3DMatrix, &GSYS.DrawSetting.WorldMatrix, &GSYS.DrawSetting.ViewProjectionViewportMatrix ) ;
	ConvertMatrixDtoF( &GSYS.DrawSetting.Blend3DMatrixF, &GSYS.DrawSetting.Blend3DMatrix ) ;

	GSYS.DrawSetting.BillboardMatrix.m[0][0] = GSYS.DrawSetting.ViewMatrix.m[0][0] ;
	GSYS.DrawSetting.BillboardMatrix.m[0][1] = GSYS.DrawSetting.ViewMatrix.m[1][0] ;
	GSYS.DrawSetting.BillboardMatrix.m[0][2] = GSYS.DrawSetting.ViewMatrix.m[2][0] ;
	GSYS.DrawSetting.BillboardMatrix.m[0][3] = 0.0F ;

	GSYS.DrawSetting.BillboardMatrix.m[1][0] = GSYS.DrawSetting.ViewMatrix.m[0][1] ;
	GSYS.DrawSetting.BillboardMatrix.m[1][1] = GSYS.DrawSetting.ViewMatrix.m[1][1] ;
	GSYS.DrawSetting.BillboardMatrix.m[1][2] = GSYS.DrawSetting.ViewMatrix.m[2][1] ;
	GSYS.DrawSetting.BillboardMatrix.m[1][3] = 0.0F ;

	GSYS.DrawSetting.BillboardMatrix.m[2][0] = GSYS.DrawSetting.ViewMatrix.m[0][2] ;
	GSYS.DrawSetting.BillboardMatrix.m[2][1] = GSYS.DrawSetting.ViewMatrix.m[1][2] ;
	GSYS.DrawSetting.BillboardMatrix.m[2][2] = GSYS.DrawSetting.ViewMatrix.m[2][2] ;
	GSYS.DrawSetting.BillboardMatrix.m[2][3] = 0.0F ;

	GSYS.DrawSetting.BillboardMatrix.m[3][0] = 
	GSYS.DrawSetting.BillboardMatrix.m[3][1] = 
	GSYS.DrawSetting.BillboardMatrix.m[3][2] = 
	GSYS.DrawSetting.BillboardMatrix.m[3][3] = 0.0F ;

	ConvertMatrixDtoF( &GSYS.DrawSetting.BillboardMatrixF, &GSYS.DrawSetting.BillboardMatrix ) ;

	GSYS.DrawSetting.ValidInverseBlend3DMatrix          = FALSE ;
	GSYS.DrawSetting.ValidBlend3DMatrix                 = TRUE ;
	GSYS.DrawSetting.ValidConvScreenPosToWorldPosMatrix = FALSE ;

	if( GSYS.DrawSetting.DrawArea.left == GSYS.DrawSetting.DrawArea.right ||
		GSYS.DrawSetting.DrawArea.top  == GSYS.DrawSetting.DrawArea.bottom )
	{
		_MEMSET( GSYS.DrawSetting.ViewClipPos,   0, sizeof( GSYS.DrawSetting.ViewClipPos   ) ) ;
		_MEMSET( GSYS.DrawSetting.ClippingPlane, 0, sizeof( GSYS.DrawSetting.ClippingPlane ) ) ;
	}
	else
	{
		GSYS.DrawSetting.ViewClipPos[ 0 ][ 0 ][ 0 ] = NS_ConvScreenPosToWorldPosD( VGetD( GSYS.DrawSetting.DrawAreaF.left,  GSYS.DrawSetting.DrawAreaF.top,    0.0 ) ) ;
		GSYS.DrawSetting.ViewClipPos[ 0 ][ 0 ][ 1 ] = NS_ConvScreenPosToWorldPosD( VGetD( GSYS.DrawSetting.DrawAreaF.right, GSYS.DrawSetting.DrawAreaF.top,    0.0 ) ) ;
		GSYS.DrawSetting.ViewClipPos[ 0 ][ 1 ][ 0 ] = NS_ConvScreenPosToWorldPosD( VGetD( GSYS.DrawSetting.DrawAreaF.left,  GSYS.DrawSetting.DrawAreaF.bottom, 0.0 ) ) ;
		GSYS.DrawSetting.ViewClipPos[ 0 ][ 1 ][ 1 ] = NS_ConvScreenPosToWorldPosD( VGetD( GSYS.DrawSetting.DrawAreaF.right, GSYS.DrawSetting.DrawAreaF.bottom, 0.0 ) ) ;
		GSYS.DrawSetting.ViewClipPos[ 1 ][ 0 ][ 0 ] = NS_ConvScreenPosToWorldPosD( VGetD( GSYS.DrawSetting.DrawAreaF.left,  GSYS.DrawSetting.DrawAreaF.top,    1.0 ) ) ;
		GSYS.DrawSetting.ViewClipPos[ 1 ][ 0 ][ 1 ] = NS_ConvScreenPosToWorldPosD( VGetD( GSYS.DrawSetting.DrawAreaF.right, GSYS.DrawSetting.DrawAreaF.top,    1.0 ) ) ;
		GSYS.DrawSetting.ViewClipPos[ 1 ][ 1 ][ 0 ] = NS_ConvScreenPosToWorldPosD( VGetD( GSYS.DrawSetting.DrawAreaF.left,  GSYS.DrawSetting.DrawAreaF.bottom, 1.0 ) ) ;
		GSYS.DrawSetting.ViewClipPos[ 1 ][ 1 ][ 1 ] = NS_ConvScreenPosToWorldPosD( VGetD( GSYS.DrawSetting.DrawAreaF.right, GSYS.DrawSetting.DrawAreaF.bottom, 1.0 ) ) ;

		VECTOR_D Normal ;

		// wy
		Normal = VCrossD( VSubD( GSYS.DrawSetting.ViewClipPos[ 1 ][ 0 ][ 0 ], GSYS.DrawSetting.ViewClipPos[ 0 ][ 0 ][ 0 ] ), VSubD( GSYS.DrawSetting.ViewClipPos[ 0 ][ 1 ][ 0 ], GSYS.DrawSetting.ViewClipPos[ 0 ][ 0 ][ 0 ] ) ) ;
		CreateNormalizePlaneD( &GSYS.DrawSetting.ClippingPlane[ 0 ], &GSYS.DrawSetting.ViewClipPos[ 0 ][ 0 ][ 0 ], &Normal ) ;

		Normal = VCrossD( VSubD( GSYS.DrawSetting.ViewClipPos[ 0 ][ 1 ][ 1 ], GSYS.DrawSetting.ViewClipPos[ 0 ][ 0 ][ 1 ] ), VSubD( GSYS.DrawSetting.ViewClipPos[ 1 ][ 0 ][ 1 ], GSYS.DrawSetting.ViewClipPos[ 0 ][ 0 ][ 1 ] ) ) ;
		CreateNormalizePlaneD( &GSYS.DrawSetting.ClippingPlane[ 1 ], &GSYS.DrawSetting.ViewClipPos[ 0 ][ 0 ][ 1 ], &Normal ) ;

		// xy
		Normal = VCrossD( VSubD( GSYS.DrawSetting.ViewClipPos[ 1 ][ 1 ][ 0 ], GSYS.DrawSetting.ViewClipPos[ 0 ][ 1 ][ 0 ] ), VSubD( GSYS.DrawSetting.ViewClipPos[ 0 ][ 1 ][ 1 ], GSYS.DrawSetting.ViewClipPos[ 0 ][ 1 ][ 0 ] ) ) ;
		CreateNormalizePlaneD( &GSYS.DrawSetting.ClippingPlane[ 2 ], &GSYS.DrawSetting.ViewClipPos[ 0 ][ 1 ][ 0 ], &Normal ) ;

		Normal = VCrossD( VSubD( GSYS.DrawSetting.ViewClipPos[ 0 ][ 0 ][ 1 ], GSYS.DrawSetting.ViewClipPos[ 0 ][ 0 ][ 0 ] ), VSubD( GSYS.DrawSetting.ViewClipPos[ 1 ][ 0 ][ 0 ], GSYS.DrawSetting.ViewClipPos[ 0 ][ 0 ][ 0 ] ) ) ;
		CreateNormalizePlaneD( &GSYS.DrawSetting.ClippingPlane[ 3 ], &GSYS.DrawSetting.ViewClipPos[ 0 ][ 0 ][ 0 ], &Normal ) ;

		// wx
		Normal = VCrossD( VSubD( GSYS.DrawSetting.ViewClipPos[ 0 ][ 1 ][ 0 ], GSYS.DrawSetting.ViewClipPos[ 0 ][ 0 ][ 0 ] ), VSubD( GSYS.DrawSetting.ViewClipPos[ 0 ][ 0 ][ 1 ], GSYS.DrawSetting.ViewClipPos[ 0 ][ 0 ][ 0 ] ) ) ;
		CreateNormalizePlaneD( &GSYS.DrawSetting.ClippingPlane[ 4 ], &GSYS.DrawSetting.ViewClipPos[ 0 ][ 0 ][ 0 ], &Normal ) ;

		Normal = VCrossD( VSubD( GSYS.DrawSetting.ViewClipPos[ 1 ][ 0 ][ 1 ], GSYS.DrawSetting.ViewClipPos[ 1 ][ 0 ][ 0 ] ), VSubD( GSYS.DrawSetting.ViewClipPos[ 1 ][ 1 ][ 0 ], GSYS.DrawSetting.ViewClipPos[ 1 ][ 0 ][ 0 ] ) ) ;
		CreateNormalizePlaneD( &GSYS.DrawSetting.ClippingPlane[ 5 ], &GSYS.DrawSetting.ViewClipPos[ 1 ][ 0 ][ 0 ], &Normal ) ;
	}
}

// gpˉesRcpɂ邩Qcpɂ邩ݒ肷
//extern void Graphics_DrawSetting_SetUse2DProjectionMatrix( int Use2DProjectionMatrix )
//{
//	if( Use2DProjectionMatrix == GSYS.DrawSetting.UseProjectionMatrix2D )
//	{
//		return ;
//	}
//
//	// `ҋ@Ă`敨`
//	DRAWSTOCKINFO
//
//	// tOۑ
//	GSYS.DrawSetting.UseProjectionMatrix2D = Use2DProjectionMatrix ;
//
//	// n[hEGAANZ[Vɐݒ
//	if( GSYS.Setting.ValidHardware )
//	{
//		Graphics_Hardware_SetUse2DProjectionMatrix_PF( Use2DProjectionMatrix ) ;
//	}
//}

// cwCu SetDrawScreen gpĕ`ύXۂ́ÃJݒ`̈𕜌ׂ̏擾鏈s
extern int Graphics_DrawSetting_GetScreenDrawSettingInfo( SCREENDRAWSETTINGINFO *ScreenDrawSettingInfo )
{
	// ef[^ۑ
	ScreenDrawSettingInfo->Use3DFlag			= NS_GetUse3DFlag() ;
	ScreenDrawSettingInfo->UseSysMemFlag		= NS_GetUseSystemMemGraphCreateFlag() ;
	ScreenDrawSettingInfo->BackgroundRed		= GSYS.Screen.BackgroundRed ;
	ScreenDrawSettingInfo->BackgroundGreen		= GSYS.Screen.BackgroundGreen ;
	ScreenDrawSettingInfo->BackgroundBlue		= GSYS.Screen.BackgroundBlue ;
	ScreenDrawSettingInfo->BackgroundAlpha		= GSYS.Screen.BackgroundAlpha ;
	ScreenDrawSettingInfo->DrawBlendMode		= GSYS.DrawSetting.BlendMode ;
	ScreenDrawSettingInfo->DrawBlendParam		= GSYS.DrawSetting.BlendParam ;
	ScreenDrawSettingInfo->DrawMode				= GSYS.DrawSetting.DrawMode ;
	ScreenDrawSettingInfo->WaitVSync			= NS_GetWaitVSyncFlag() ;
	ScreenDrawSettingInfo->DrawScreen			= NS_GetActiveGraph() ;
	ScreenDrawSettingInfo->ViewMatrix           = GSYS.DrawSetting.ViewMatrix ;
	ScreenDrawSettingInfo->ProjectionMatrixMode = GSYS.DrawSetting.ProjectionMatrixMode ;
	ScreenDrawSettingInfo->ProjFov              = GSYS.DrawSetting.ProjFov ;
	ScreenDrawSettingInfo->ProjSize             = GSYS.DrawSetting.ProjSize ;
	ScreenDrawSettingInfo->ProjMatrix           = GSYS.DrawSetting.ProjMatrix ;
	ScreenDrawSettingInfo->ProjNear             = GSYS.DrawSetting.ProjNear ;
	ScreenDrawSettingInfo->ProjFar              = GSYS.DrawSetting.ProjFar ;
	ScreenDrawSettingInfo->ProjDotAspect        = GSYS.DrawSetting.ProjDotAspect ;
	ScreenDrawSettingInfo->ProjectionMatrix     = GSYS.DrawSetting.ProjectionMatrix ;
	ScreenDrawSettingInfo->ViewportMatrix       = GSYS.DrawSetting.ViewportMatrix ;
	ScreenDrawSettingInfo->WorldMatrix          = GSYS.DrawSetting.WorldMatrix ;
	
	// `̈𓾂
	NS_GetDrawArea( &ScreenDrawSettingInfo->DrawRect ) ;

	// I
	return 0 ;
}

// cwCu SetDrawScreen gpĕ`ύXۂ́ÃJݒ`̈𕜌鏈s
extern int Graphics_DrawSetting_SetScreenDrawSettingInfo( const SCREENDRAWSETTINGINFO *ScreenDrawSettingInfo )
{
	// ۑĂݒ𔽉f
	NS_SetBackgroundColor( ScreenDrawSettingInfo->BackgroundRed, ScreenDrawSettingInfo->BackgroundGreen, ScreenDrawSettingInfo->BackgroundBlue, ScreenDrawSettingInfo->BackgroundAlpha ) ;
	NS_SetDrawBlendMode( ScreenDrawSettingInfo->DrawBlendMode, ScreenDrawSettingInfo->DrawBlendParam ) ;
	NS_SetDrawMode( ScreenDrawSettingInfo->DrawMode ) ;
	NS_SetWaitVSyncFlag( ScreenDrawSettingInfo->WaitVSync ) ;
	NS_SetDrawScreen( ScreenDrawSettingInfo->DrawScreen ) ;
	NS_SetUse3DFlag( ScreenDrawSettingInfo->Use3DFlag ) ;
	NS_SetUseSystemMemGraphCreateFlag( ScreenDrawSettingInfo->UseSysMemFlag ) ;
	NS_SetDrawArea( ScreenDrawSettingInfo->DrawRect.left, ScreenDrawSettingInfo->DrawRect.top, ScreenDrawSettingInfo->DrawRect.right, ScreenDrawSettingInfo->DrawRect.bottom ) ;

	NS_SetTransformToWorldD( &ScreenDrawSettingInfo->WorldMatrix );
	NS_SetTransformToViewD( &ScreenDrawSettingInfo->ViewMatrix );
	switch( ScreenDrawSettingInfo->ProjectionMatrixMode )
	{
	case 0 :	// ߖ@
		NS_SetupCamera_PerspectiveD( ScreenDrawSettingInfo->ProjFov ) ;
		break ;

	case 1 :	// ˉe
		NS_SetupCamera_OrthoD( ScreenDrawSettingInfo->ProjSize ) ;
		break ;

	case 2 :	// s񒼎w
		NS_SetupCamera_ProjectionMatrixD( ScreenDrawSettingInfo->ProjMatrix ) ;
		break ;
	}
	NS_SetCameraNearFarD( ScreenDrawSettingInfo->ProjNear, ScreenDrawSettingInfo->ProjFar ) ;
	NS_SetCameraDotAspectD( ScreenDrawSettingInfo->ProjDotAspect ) ;
//	NS_SetTransformToProjection( &ScreenDrawSettingInfo->ProjectionMatrix );
	NS_SetTransformToViewportD( &ScreenDrawSettingInfo->ViewportMatrix );

	// I
	return 0 ;
}
























// `֌W֐

#define DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK									\
	if( y1 >= DrawRect.top && y1 < DrawRect.bottom )							\
	{																			\
		if( ( CirclePos[ y1 ][ 4 ] & 1 ) == 0 || CirclePos[ y1 ][ 0 ] > x1 )	\
		{																		\
			CirclePos[ y1 ][ 4 ] |= 1 ;											\
			CirclePos[ y1 ][ 0 ] = ( short )x1 ;								\
		}																		\
	}

#define DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK									\
	if( y1 >= DrawRect.top && y1 < DrawRect.bottom )							\
	{																			\
		if( ( CirclePos[ y1 ][ 4 ] & 2 ) == 0 || CirclePos[ y1 ][ 1 ] < x1 )	\
		{																		\
			CirclePos[ y1 ][ 4 ] |= 2 ;											\
			CirclePos[ y1 ][ 1 ] = ( short )x1 ;								\
		}																		\
	}

#define DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK									\
	if( y1 >= DrawRect.top && y1 < DrawRect.bottom )							\
	{																			\
		if( ( CirclePos[ y1 ][ 4 ] & 4 ) == 0 || CirclePos[ y1 ][ 2 ] < x1 )	\
		{																		\
			CirclePos[ y1 ][ 4 ] |= 4 ;											\
			CirclePos[ y1 ][ 2 ] = ( short )x1 ;								\
		}																		\
	}

#define DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK									\
	if( y1 >= DrawRect.top && y1 < DrawRect.bottom )							\
	{																			\
		if( ( CirclePos[ y1 ][ 4 ] & 8 ) == 0 || CirclePos[ y1 ][ 3 ] > x1 )	\
		{																		\
			CirclePos[ y1 ][ 4 ] |= 8 ;											\
			CirclePos[ y1 ][ 3 ] = ( short )x1 ;								\
		}																		\
	}

// ̕t~̕`p_擾֐
extern int	Graphics_Draw_GetCircle_ThicknessDrawPosition( int x, int y, int r, int Thickness, short ( *CirclePos )[ 5 ] )
{
	int rmax, rmin ;
	int x1, y1 ;
	int Dx, Dy, F ;
	RECT DrawRect ;

	DrawRect = GSYS.DrawSetting.DrawArea ;

	// ȇZo
	rmax = r + Thickness / 2 ;
	rmin = r - Thickness / 2 ;
	if( rmax - rmin + 1 > Thickness )
	{
		rmin ++ ;
	}

	// O~̍WXg쐬
	{
		// lZbg
		Dx = rmax ; Dy = 0 ; F = -2 * rmax + 3 ;

		// ŏ̓_
		{
			x1 = -Dx + x ; y1 = Dy + y ;
			DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
			x1 = Dx + x ;  
			DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;

			x1 = Dy + x ; y1 = Dx + y ;
			DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
			DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;

			x1 = Dy + x ; y1 = -Dx + y;
			DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
			DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;

			// Wf[^i߂
			if( F >= 0 )
			{
				Dx -- ;
				F -= 4 * Dx ;
			}	

			Dy ++ ;
			F += 4 * Dy + 2 ;
		}

		while( Dx >= Dy )
		{
			x1 = -Dx + x ; y1 = Dy + y ;
			DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
			x1 = Dx + x ;  
			DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;

			x1 = Dy + x ; y1 = Dx + y ;
			DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;
			x1 = -Dy + x ; 
			DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
		
			x1 = Dx + x ; y1 = -Dy + y;
			DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;
			x1 = -Dx + x ; 
			DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;

			x1 = Dy + x ; y1 = -Dx + y;
			DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;
			x1 = -Dy + x ; 
			DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;

			// Wf[^i߂
			if( F >= 0 )
			{
				Dx -- ;
				F -= 4 * Dx ;
			}

			Dy ++ ;
			F += 4 * Dy + 2 ;
		}
	}

	// ~̍WXg쐬
	{
		// lZbg
		Dx = rmin ; Dy = 0 ; F = -2 * rmin + 3 ;

		// ŏ̓_
		{
			x1 = -Dx + x ; y1 = Dy + y ;
			DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
			x1 = Dx + x ;  
			DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;

			x1 = Dy + x ; y1 = Dx + y ;
			DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
			DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;

			x1 = Dy + x ; y1 = -Dx + y;
			DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
			DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;

			// Wf[^i߂
			if( F >= 0 )
			{
				Dx -- ;
				F -= 4 * Dx ;
			}	

			Dy ++ ;
			F += 4 * Dy + 2 ;
		}

		while( Dx >= Dy )
		{
			x1 = -Dx + x ; y1 = Dy + y ;
			DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
			x1 = Dx + x ;  
			DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;

			x1 = Dy + x ; y1 = Dx + y ;
			DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;
			x1 = -Dy + x ; 
			DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
		
			x1 = Dx + x ; y1 = -Dy + y;
			DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;
			x1 = -Dx + x ; 
			DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;

			x1 = Dy + x ; y1 = -Dx + y;
			DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;
			x1 = -Dy + x ; 
			DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;

			// Wf[^i߂
			if( F >= 0 )
			{
				Dx -- ;
				F -= 4 * Dx ;
			}

			Dy ++ ;
			F += 4 * Dy + 2 ;
		}
	}

	// I
	return 0 ;
}

// ̕tȉ~̕`p_擾֐
extern int	Graphics_Draw_GetOval_ThicknessDrawPosition( int x, int y, int rx, int ry, int Thickness, short ( *CirclePos )[ 5 ] )
{
	int x1, y1 ;
	int Dx, Dy, F, H, Df, yc, xc, rc, r ;
	int rxmax, rymax ;
	int rxmin, rymin ;
	RECT DrawRect ;

	DrawRect = GSYS.DrawSetting.DrawArea ;

	// ȇZo
	rxmax = rx + Thickness / 2 ;
	rxmin = rx - Thickness / 2 ;
	if( rxmax - rxmin + 1 > Thickness )
	{
		rxmin ++ ;
	}
	rymax = ry + Thickness / 2 ;
	rymin = ry - Thickness / 2 ;
	if( rymax - rymin + 1 > Thickness )
	{
		rymin ++ ;
	}

	if( rxmin <= 0 || rxmax <= 0 ||
		rymin <= 0 || rymax <= 0 )
	{
		return -1 ;
	}

	// O~̍WXg쐬
	{
		if( rxmax >= rymax )
		{
			// lZbg
			rc = ( rxmax * rxmax ) / rymax ;

			xc = 0 ; yc = 0 ;
			r = rxmax ;
			Df = 1 ;
	
			Dx = r ;
			Dy = 0;
			F = -2 * r + 1 + 2 * 1;
			H = -4 * r + 2 + 1;

			// ŏ̓_`
			{
				x1 = -Dx + x ; y1 = Dy + y ;
				DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
				x1 = Dx + x ;  
				DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;

				Df = 0 ;

				// Wf[^i߂
				if( F < 0 )
				{
					yc += rymax ;
					if( yc >= rc )
					{
						Dy ++ ;
						yc -= rc ;
						Df = 1 ;
					}
					F += 4 * Dy + 2 ;
					H += 4 * Dy;
				}
				else
				{
					Df = 1 ;

					if( H>=0 )
					{
						Dx--;
						F -= 4 * Dx;
						H -= 4 * Dx - 2 ;
					}
					else
					{
						Dx--;	
						yc += rymax ;
						if( yc >= rc )
						{
							Dy ++ ;
							yc -= rc ;
							Df = 1 ;
						}
						F += 4 * Dy - 4 * Dx + 2 ;
						H += 4 * Dy - 4 * Dx + 2 ;
					}
				}
			}

			while( Dx > 0 )
			{
				if( Df )
				{
					x1 = -Dx + x ; y1 = Dy + y ;
					DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
					x1 = Dx + x ;  
					DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;

					x1 = -Dx + x ; y1 = -Dy + y ;
					DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
					x1 = Dx + x ;  
					DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;
				}

				Df = 0 ;

				// Wf[^i߂
				if( F < 0 )
				{
					yc += rymax ;
					if( yc >= rc )
					{
						Dy ++ ;
						yc -= rc ;
						Df = 1 ;
					}
					F += 4 * Dy + 2 ;
					H += 4 * Dy;
				}
				else
				{
					if( H>=0 )
					{
						Dx--;
						F -= 4 * Dx;
						H -= 4 * Dx - 2 ;
					}
					else
					{
						Dx--;	
						yc += rymax ;
						if( yc >= rc )
						{
							Dy ++ ;
							yc -= rc ;
							Df = 1 ;
						}
						F += 4 * Dy - 4 * Dx + 2 ;
						H += 4 * Dy - 4 * Dx + 2 ;
					}
				}
			}

			// Ō̓_`
			x1 = Dx + x ; y1 = -Dy + y;
			DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
			DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;

			x1 = -Dx + x ; y1 = Dy + y;
			DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
			DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;
		}
		else
		{
			// lZbg
			rc = ( rymax * rymax ) / rxmax ;

			xc = 0 ; yc = 0 ;
			r = rymax ;
			Df = 1 ;
	
			Dy = r ;
			Dx = 0;
			F = -2 * r + 1 + 2 * 1;
			H = -4 * r + 2 + 1;

			// ŏ̐`
			{
				// Wf[^i߂
				if( F < 0 )
				{
					xc += rxmax ;
					if( xc >= rc )
					{
						Dx ++ ;
						xc -= rc ;
					}
					F += 4 * Dx + 2 ;
					H += 4 * Dx;
				}
				else
				{
					if( H>=0 )
					{
						Dy--;
						F -= 4 * Dy;
						H -= 4 * Dy - 2 ;
					}
					else
					{
						Dy--;	
						xc += rxmax ;
						if( xc >= rc )
						{
							Dx ++ ;
							xc -= rc ;
						}
						F += 4 * Dx - 4 * Dy + 2 ;
						H += 4 * Dx - 4 * Dy + 2 ;
					}
				}
			}

			while( Dy >= 0 )
			{
				// Wf[^i߂
				if( F < 0 )
				{
					xc += rxmax ;
					if( xc >= rc )
					{
						Dx ++ ;
						xc -= rc ;
					}
					F += 4 * Dx + 2 ;
					H += 4 * Dx;
				}
				else
				{
					x1 = -Dx + x ; y1 = -Dy + y ;
					DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
					x1 = Dx + x ;
					DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;

					x1 = -Dx + x ; y1 = Dy + y ;
					DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
					x1 = Dx + x ;
					DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;

					if( H>=0 )
					{
						Dy--;
						F -= 4 * Dy;
						H -= 4 * Dy - 2 ;
					}
					else
					{
						Dy--;	
						xc += rxmax ;
						if( xc >= rc )
						{
							Dx ++ ;
							xc -= rc ;
						}
						F += 4 * Dx - 4 * Dy + 2 ;
						H += 4 * Dx - 4 * Dy + 2 ;
					}
				}
			}
		}
	}

	// ~̍WXg쐬
	{
		if( rxmin >= rymin )
		{
			// lZbg
			rc = ( rxmin * rxmin ) / rymin ;

			xc = 0 ; yc = 0 ;
			r = rxmin ;
			Df = 1 ;
	
			Dx = r ;
			Dy = 0;
			F = -2 * r + 1 + 2 * 1;
			H = -4 * r + 2 + 1;

			// ŏ̓_`
			{
				x1 = -Dx + x ; y1 = Dy + y ;
				DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
				x1 = Dx + x ;  
				DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;

				Df = 0 ;

				// Wf[^i߂
				if( F < 0 )
				{
					yc += rymin ;
					if( yc >= rc )
					{
						Dy ++ ;
						yc -= rc ;
						Df = 1 ;
					}
					F += 4 * Dy + 2 ;
					H += 4 * Dy;
				}
				else
				{
					Df = 1 ;

					if( H>=0 )
					{
						Dx--;
						F -= 4 * Dx;
						H -= 4 * Dx - 2 ;
					}
					else
					{
						Dx--;	
						yc += rymin ;
						if( yc >= rc )
						{
							Dy ++ ;
							yc -= rc ;
							Df = 1 ;
						}
						F += 4 * Dy - 4 * Dx + 2 ;
						H += 4 * Dy - 4 * Dx + 2 ;
					}
				}
			}

			while( Dx > 0 )
			{
				if( Df )
				{
					x1 = -Dx + x ; y1 = Dy + y ;
					DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
					x1 = Dx + x ;  
					DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;

					x1 = -Dx + x ; y1 = -Dy + y ;
					DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
					x1 = Dx + x ;  
					DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;
				}

				Df = 0 ;

				// Wf[^i߂
				if( F < 0 )
				{
					yc += rymin ;
					if( yc >= rc )
					{
						Dy ++ ;
						yc -= rc ;
						Df = 1 ;
					}
					F += 4 * Dy + 2 ;
					H += 4 * Dy;
				}
				else
				{
					Df = 1 ;

					if( H>=0 )
					{
						Dx--;
						F -= 4 * Dx;
						H -= 4 * Dx - 2 ;
					}
					else
					{
						Dx--;	
						yc += rymin ;
						if( yc >= rc )
						{
							Dy ++ ;
							yc -= rc ;
							Df = 1 ;
						}
						F += 4 * Dy - 4 * Dx + 2 ;
						H += 4 * Dy - 4 * Dx + 2 ;
					}
				}
			}

			// Ō̓_`
			x1 = Dx + x ; y1 = -Dy + y;
			DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
			DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;

			x1 = -Dx + x ; y1 = Dy + y ;
			DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
			DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;
		}
		else
		{
			// lZbg
			rc = ( rymin * rymin ) / rxmin ;

			xc = 0 ; yc = 0 ;
			r = rymin ;
			Df = 2 ;
	
			Dy = r ;
			Dx = 0;
			F = -2 * r + 1 + 2 * 1;
			H = -4 * r + 2 + 1;

			// ŏ̐`
			{
				// Wf[^i߂
				if( F < 0 )
				{
					xc += rxmin ;
					if( xc >= rc )
					{
						Dx ++ ;
						xc -= rc ;
					}
					F += 4 * Dx + 2 ;
					H += 4 * Dx;
				}
				else
				{
					if( H>=0 )
					{
						Dy--;
						F -= 4 * Dy;
						H -= 4 * Dy - 2 ;
					}
					else
					{
						Dy--;	
						xc += rxmin ;
						if( xc >= rc )
						{
							Dx ++ ;
							xc -= rc ;
						}
						F += 4 * Dx - 4 * Dy + 2 ;
						H += 4 * Dx - 4 * Dy + 2 ;
					}
				}
			}

			while( Dy >= 0 )
			{
				// Wf[^i߂
				if( F < 0 )
				{
					xc += rxmin ;
					if( xc >= rc )
					{
						Dx ++ ;
						xc -= rc ;
					}
					F += 4 * Dx + 2 ;
					H += 4 * Dx;
				}
				else
				{
					x1 = -Dx + x ; y1 = -Dy + y ;
					DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
					x1 = Dx + x ;
					DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;

					x1 = -Dx + x ; y1 = Dy + y ;
					DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
					x1 = Dx + x ;
					DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;

					if( H>=0 )
					{
						Dy--;
						F -= 4 * Dy;
						H -= 4 * Dy - 2 ;
					}
					else
					{
						Dy--;	
						xc += rxmin ;
						if( xc >= rc )
						{
							Dx ++ ;
							xc -= rc ;
						}
						F += 4 * Dx - 4 * Dy + 2 ;
						H += 4 * Dx - 4 * Dy + 2 ;
					}
				}
			}
		}
	}

	// I
	return 0 ;
}

// W␳sȂQ|S`s( PeNX`摜̂ݗL )

#define SETDRAWRECTCODE\
	int MaxX, MaxY, MinX, MinY ;\
	int i, ix, iy, Num = Param->QuadrangleNum * 4 ;\
\
	MaxX = 0 ; MaxY = 0 ;\
	MinX = 0xfffffff ; MinY = 0xfffffff ;\
\
	for( i = 0 ; i < Num ; i ++ )\
	{\
		ix = _FTOL( Param->Vertex[ i ].x ) ; iy = _FTOL( Param->Vertex[ i ].y ) ;\
		if( ix > MaxX ) MaxX = ix ; if( iy > MaxY ) MaxY = iy ;\
		if( ix < MinX ) MinX = ix ; if( iy < MinY ) MinY = iy ;\
	}\
\
	SETRECT( DrawRect, MinX - 1, MinY - 1, MaxX + 1, MaxY + 1 ) ;\

extern int Graphics_Draw_DrawSimpleQuadrangleGraphF( const GRAPHICS_DRAW_DRAWSIMPLEQUADRANGLEGRAPHF_PARAM *Param )
{
	IMAGEDATA *Image ;
	IMAGEDATA *BlendImage ;
	int Ret ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE )
	{
		return -1 ;
	}

	// `ݒ肪Ăꍇ͉I
	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
	{
		return 0 ;
	}

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( Param->GraphHandle, Image ) )
	{
		return -1 ;
	}
	BlendImage = NULL ;
	if( GSYS.DrawSetting.BlendGraph > 0 )
	{
		GRAPHCHK( GSYS.DrawSetting.BlendGraph, BlendImage ) ;

		// uheNX`gpꍇA`摜G[
		if( Graphics_Image_CheckBlendGraphSize( Image ) )
		{
			return -1 ;
		}
	}

#ifndef DX_NON_MOVIE
	if( Image->Orig->MovieHandle != -1 )
	{
		UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
	}
#endif

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	DRAW_DEF( 
		Graphics_Hardware_DrawSimpleQuadrangleGraphF_PF( Param, Image, BlendImage ),
		0,
		SETDRAWRECTCODE,
		Ret,
		Image->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE


// W␳sȂP|S`s( PeNX`摜̂ݗL )

#define SETDRAWRECTCODE\
	int MaxX, MaxY, MinX, MinY ;\
	int i, ix, iy ;\
	int VertexNum = Param->TriangleNum * 3 ;\
\
	MaxX = 0 ; MaxY = 0 ;\
	MinX = 0xfffffff ; MinY = 0xfffffff ;\
\
	for( i = 0 ; i < VertexNum ; i ++ )\
	{\
		ix = _FTOL( Param->Vertex[ i ].x ) ;\
		iy = _FTOL( Param->Vertex[ i ].y ) ;\
		if( ix > MaxX ) MaxX = ix ; if( iy > MaxY ) MaxY = iy ;\
		if( ix < MinX ) MinX = ix ; if( iy < MinY ) MinY = iy ;\
	}\
\
	SETRECT( DrawRect, MinX - 1, MinY - 1, MaxX + 1, MaxY + 1 ) ;\

extern int Graphics_Draw_DrawSimpleTriangleGraphF( const GRAPHICS_DRAW_DRAWSIMPLETRIANGLEGRAPHF_PARAM *Param )
{
	IMAGEDATA *Image ;
	IMAGEDATA *BlendImage ;
	int Ret ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE )
	{
		return -1 ;
	}

	// `ݒ肪Ăꍇ͉I
	if( /* GSYS.NotDrawFlag || */ GSYS.DrawSetting.NotDrawFlagInSetDrawArea )
	{
		return 0 ;
	}

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// G[
	if( GRAPHCHK( Param->GraphHandle, Image ) )
	{
		return -1 ;
	}
	BlendImage = NULL ;
	if( GSYS.DrawSetting.BlendGraph > 0 )
	{
		GRAPHCHK( GSYS.DrawSetting.BlendGraph, BlendImage ) ;

		// uheNX`gpꍇA`摜G[
		if( Graphics_Image_CheckBlendGraphSize( Image ) )
		{
			return -1 ;
		}
	}

#ifndef DX_NON_MOVIE
	if( Image->Orig->MovieHandle != -1 )
	{
		UpdateMovie( Image->Orig->MovieHandle, FALSE ) ;
	}
#endif

	// Qcsn[hEGAɔf
	if( GSYS.DrawSetting.MatchHardware_2DMatrix == FALSE && GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )
		Graphics_DrawSetting_ApplyLib2DMatrixToHardware() ;

	// `
	DRAW_DEF( 
		Graphics_Hardware_DrawSimpleTriangleGraphF_PF( Param, Image, BlendImage ),
		0,
		SETDRAWRECTCODE,
		Ret,
		Image->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE



























// J֌W֐

// WWŌ`{bNXJ̎EɓĂ邩ǂ𔻒肷( ߂l TRUE:EɓĂȂ  FALSE:EɓĂ )( CheckPos VECTOR 8̔z̐擪AhXAz̊evfԍ̓e 0:+x +y +z   1:-x +y +z   2:-x -y +z   3:+x -y +z   4:+x -y -z   5:+x +y -z   6:-x +y -z   7:-x -y -z )
extern int Graphics_Camera_CheckCameraViewClip_Box_PosDim( VECTOR *CheckBoxPos )
{
	BYTE clip[ 8 ] ;
	VECTOR *pos ;
	int i ;

	// e_̈ɓĂ邩ǂ𒲂ׂ
	pos = CheckBoxPos ;
	for( i = 0 ; i < 8 ; i ++, pos ++ )
	{
		clip[ i ] = 0 ;
		if( GSYS.DrawSetting.ClippingPlane[ 0 ].x * pos->x + GSYS.DrawSetting.ClippingPlane[ 0 ].y * pos->y + GSYS.DrawSetting.ClippingPlane[ 0 ].z * pos->z + GSYS.DrawSetting.ClippingPlane[ 0 ].w < 0.0f ) clip[ i ] |= CLIP_XM ;
		if( GSYS.DrawSetting.ClippingPlane[ 1 ].x * pos->x + GSYS.DrawSetting.ClippingPlane[ 1 ].y * pos->y + GSYS.DrawSetting.ClippingPlane[ 1 ].z * pos->z + GSYS.DrawSetting.ClippingPlane[ 1 ].w < 0.0f ) clip[ i ] |= CLIP_XP ;
		if( GSYS.DrawSetting.ClippingPlane[ 2 ].x * pos->x + GSYS.DrawSetting.ClippingPlane[ 2 ].y * pos->y + GSYS.DrawSetting.ClippingPlane[ 2 ].z * pos->z + GSYS.DrawSetting.ClippingPlane[ 2 ].w < 0.0f ) clip[ i ] |= CLIP_YM ;
		if( GSYS.DrawSetting.ClippingPlane[ 3 ].x * pos->x + GSYS.DrawSetting.ClippingPlane[ 3 ].y * pos->y + GSYS.DrawSetting.ClippingPlane[ 3 ].z * pos->z + GSYS.DrawSetting.ClippingPlane[ 3 ].w < 0.0f ) clip[ i ] |= CLIP_YP ;
		if( GSYS.DrawSetting.ClippingPlane[ 4 ].x * pos->x + GSYS.DrawSetting.ClippingPlane[ 4 ].y * pos->y + GSYS.DrawSetting.ClippingPlane[ 4 ].z * pos->z + GSYS.DrawSetting.ClippingPlane[ 4 ].w < 0.0f ) clip[ i ] |= CLIP_ZM ;
		if( GSYS.DrawSetting.ClippingPlane[ 5 ].x * pos->x + GSYS.DrawSetting.ClippingPlane[ 5 ].y * pos->y + GSYS.DrawSetting.ClippingPlane[ 5 ].z * pos->z + GSYS.DrawSetting.ClippingPlane[ 5 ].w < 0.0f ) clip[ i ] |= CLIP_ZP ;
		if( clip[ i ] == 0 ) return FALSE ;
	}

	// ǂꂩ̑ɑSĂ̒_Ăꍇ͂POO̈ɓĂȂ
	if( ( ( clip[0] & CLIP_XP ) && ( clip[1] & CLIP_XP ) &&
		  ( clip[2] & CLIP_XP ) && ( clip[3] & CLIP_XP ) &&
		  ( clip[4] & CLIP_XP ) && ( clip[5] & CLIP_XP ) &&
		  ( clip[6] & CLIP_XP ) && ( clip[7] & CLIP_XP ) ) ||
		( ( clip[0] & CLIP_XM ) && ( clip[1] & CLIP_XM ) &&
		  ( clip[2] & CLIP_XM ) && ( clip[3] & CLIP_XM ) &&
		  ( clip[4] & CLIP_XM ) && ( clip[5] & CLIP_XM ) &&
		  ( clip[6] & CLIP_XM ) && ( clip[7] & CLIP_XM ) ) ||
		( ( clip[0] & CLIP_YP ) && ( clip[1] & CLIP_YP ) &&
		  ( clip[2] & CLIP_YP ) && ( clip[3] & CLIP_YP ) &&
		  ( clip[4] & CLIP_YP ) && ( clip[5] & CLIP_YP ) &&
		  ( clip[6] & CLIP_YP ) && ( clip[7] & CLIP_YP ) ) ||
		( ( clip[0] & CLIP_YM ) && ( clip[1] & CLIP_YM ) &&
		  ( clip[2] & CLIP_YM ) && ( clip[3] & CLIP_YM ) &&
		  ( clip[4] & CLIP_YM ) && ( clip[5] & CLIP_YM ) &&
		  ( clip[6] & CLIP_YM ) && ( clip[7] & CLIP_YM ) ) ||
		( ( clip[0] & CLIP_ZP ) && ( clip[1] & CLIP_ZP ) &&
		  ( clip[2] & CLIP_ZP ) && ( clip[3] & CLIP_ZP ) &&
		  ( clip[4] & CLIP_ZP ) && ( clip[5] & CLIP_ZP ) &&
		  ( clip[6] & CLIP_ZP ) && ( clip[7] & CLIP_ZP ) ) ||
		( ( clip[0] & CLIP_ZM ) && ( clip[1] & CLIP_ZM ) &&
		  ( clip[2] & CLIP_ZM ) && ( clip[3] & CLIP_ZM ) &&
		  ( clip[4] & CLIP_ZM ) && ( clip[5] & CLIP_ZM ) &&
		  ( clip[6] & CLIP_ZM ) && ( clip[7] & CLIP_ZM ) ) )
		  return TRUE ;

	// ɂ猩ĂƂ
	return FALSE ;
}

// WWŌ`{bNXJ̎EɓĂ邩ǂ𔻒肷( ߂l TRUE:EɓĂȂ  FALSE:EɓĂ )( CheckPos VECTOR 8̔z̐擪AhXAz̊evfԍ̓e 0:+x +y +z   1:-x +y +z   2:-x -y +z   3:+x -y +z   4:+x -y -z   5:+x +y -z   6:-x +y -z   7:-x -y -z )
extern int Graphics_Camera_CheckCameraViewClip_Box_PosDimD( VECTOR_D *CheckBoxPos )
{
	BYTE clip[ 8 ] ;
	VECTOR_D *pos ;
	int i ;

	// e_̈ɓĂ邩ǂ𒲂ׂ
	pos = CheckBoxPos ;
	for( i = 0 ; i < 8 ; i ++, pos ++ )
	{
		clip[ i ] = 0 ;
		if( GSYS.DrawSetting.ClippingPlane[ 0 ].x * pos->x + GSYS.DrawSetting.ClippingPlane[ 0 ].y * pos->y + GSYS.DrawSetting.ClippingPlane[ 0 ].z * pos->z + GSYS.DrawSetting.ClippingPlane[ 0 ].w < 0.0 ) clip[ i ] |= CLIP_XM ;
		if( GSYS.DrawSetting.ClippingPlane[ 1 ].x * pos->x + GSYS.DrawSetting.ClippingPlane[ 1 ].y * pos->y + GSYS.DrawSetting.ClippingPlane[ 1 ].z * pos->z + GSYS.DrawSetting.ClippingPlane[ 1 ].w < 0.0 ) clip[ i ] |= CLIP_XP ;
		if( GSYS.DrawSetting.ClippingPlane[ 2 ].x * pos->x + GSYS.DrawSetting.ClippingPlane[ 2 ].y * pos->y + GSYS.DrawSetting.ClippingPlane[ 2 ].z * pos->z + GSYS.DrawSetting.ClippingPlane[ 2 ].w < 0.0 ) clip[ i ] |= CLIP_YM ;
		if( GSYS.DrawSetting.ClippingPlane[ 3 ].x * pos->x + GSYS.DrawSetting.ClippingPlane[ 3 ].y * pos->y + GSYS.DrawSetting.ClippingPlane[ 3 ].z * pos->z + GSYS.DrawSetting.ClippingPlane[ 3 ].w < 0.0 ) clip[ i ] |= CLIP_YP ;
		if( GSYS.DrawSetting.ClippingPlane[ 4 ].x * pos->x + GSYS.DrawSetting.ClippingPlane[ 4 ].y * pos->y + GSYS.DrawSetting.ClippingPlane[ 4 ].z * pos->z + GSYS.DrawSetting.ClippingPlane[ 4 ].w < 0.0 ) clip[ i ] |= CLIP_ZM ;
		if( GSYS.DrawSetting.ClippingPlane[ 5 ].x * pos->x + GSYS.DrawSetting.ClippingPlane[ 5 ].y * pos->y + GSYS.DrawSetting.ClippingPlane[ 5 ].z * pos->z + GSYS.DrawSetting.ClippingPlane[ 5 ].w < 0.0 ) clip[ i ] |= CLIP_ZP ;
		if( clip[ i ] == 0 ) return FALSE ;
	}

	// ǂꂩ̑ɑSĂ̒_Ăꍇ͂POO̈ɓĂȂ
	if( ( ( clip[0] & CLIP_XP ) && ( clip[1] & CLIP_XP ) &&
		  ( clip[2] & CLIP_XP ) && ( clip[3] & CLIP_XP ) &&
		  ( clip[4] & CLIP_XP ) && ( clip[5] & CLIP_XP ) &&
		  ( clip[6] & CLIP_XP ) && ( clip[7] & CLIP_XP ) ) ||
		( ( clip[0] & CLIP_XM ) && ( clip[1] & CLIP_XM ) &&
		  ( clip[2] & CLIP_XM ) && ( clip[3] & CLIP_XM ) &&
		  ( clip[4] & CLIP_XM ) && ( clip[5] & CLIP_XM ) &&
		  ( clip[6] & CLIP_XM ) && ( clip[7] & CLIP_XM ) ) ||
		( ( clip[0] & CLIP_YP ) && ( clip[1] & CLIP_YP ) &&
		  ( clip[2] & CLIP_YP ) && ( clip[3] & CLIP_YP ) &&
		  ( clip[4] & CLIP_YP ) && ( clip[5] & CLIP_YP ) &&
		  ( clip[6] & CLIP_YP ) && ( clip[7] & CLIP_YP ) ) ||
		( ( clip[0] & CLIP_YM ) && ( clip[1] & CLIP_YM ) &&
		  ( clip[2] & CLIP_YM ) && ( clip[3] & CLIP_YM ) &&
		  ( clip[4] & CLIP_YM ) && ( clip[5] & CLIP_YM ) &&
		  ( clip[6] & CLIP_YM ) && ( clip[7] & CLIP_YM ) ) ||
		( ( clip[0] & CLIP_ZP ) && ( clip[1] & CLIP_ZP ) &&
		  ( clip[2] & CLIP_ZP ) && ( clip[3] & CLIP_ZP ) &&
		  ( clip[4] & CLIP_ZP ) && ( clip[5] & CLIP_ZP ) &&
		  ( clip[6] & CLIP_ZP ) && ( clip[7] & CLIP_ZP ) ) ||
		( ( clip[0] & CLIP_ZM ) && ( clip[1] & CLIP_ZM ) &&
		  ( clip[2] & CLIP_ZM ) && ( clip[3] & CLIP_ZM ) &&
		  ( clip[4] & CLIP_ZM ) && ( clip[5] & CLIP_ZM ) &&
		  ( clip[6] & CLIP_ZM ) && ( clip[7] & CLIP_ZM ) ) )
		  return TRUE ;

	// ɂ猩ĂƂ
	return FALSE ;
}

// r[s񂩂琅AAPpxZo
extern void Graphics_Camera_CalcCameraRollViewMatrix( void )
{
	VECTOR_D XVec, YVec, ZVec ;
	double Sin, Cos, f ;

	XVec.x = GSYS.DrawSetting.ViewMatrix.m[ 0 ][ 0 ] ;
	XVec.y = GSYS.DrawSetting.ViewMatrix.m[ 1 ][ 0 ] ;
	XVec.z = GSYS.DrawSetting.ViewMatrix.m[ 2 ][ 0 ] ;

	YVec.x = GSYS.DrawSetting.ViewMatrix.m[ 0 ][ 1 ] ;
	YVec.y = GSYS.DrawSetting.ViewMatrix.m[ 1 ][ 1 ] ;
	YVec.z = GSYS.DrawSetting.ViewMatrix.m[ 2 ][ 1 ] ;

	ZVec.x = GSYS.DrawSetting.ViewMatrix.m[ 0 ][ 2 ] ;
	ZVec.y = GSYS.DrawSetting.ViewMatrix.m[ 1 ][ 2 ] ;
	ZVec.z = GSYS.DrawSetting.ViewMatrix.m[ 2 ][ 2 ] ;

	if( ZVec.x < 0.00000001 && ZVec.x > -0.00000001 &&
		ZVec.z < 0.00000001 && ZVec.z > -0.00000001 )
	{
		GSYS.Camera.HRotate = 0.0 ;
		if( ZVec.y < 0.0 )
		{
			GSYS.Camera.VRotate =  DX_PI / 2.0 ;
			GSYS.Camera.TRotate = _ATAN2D( -YVec.x, YVec.z ) ;
		}
		else
		{
			GSYS.Camera.VRotate = -DX_PI / 2.0 ;
			GSYS.Camera.TRotate = _ATAN2D( -YVec.x, -YVec.z ) ;
		}
	}
	else
	{
		if( YVec.y < 0.0 )
		{
			GSYS.Camera.HRotate = _ATAN2D( -ZVec.x, -ZVec.z ) ;

			_SINCOSD( -GSYS.Camera.HRotate, &Sin, &Cos ) ;
			f      = XVec.z * Cos - XVec.x * Sin ;
			XVec.x = XVec.z * Sin + XVec.x * Cos ;
			XVec.z = f ;

			f      = ZVec.z * Cos - ZVec.x * Sin ;
			ZVec.x = ZVec.z * Sin + ZVec.x * Cos ;
			ZVec.z = f ;

			if( ZVec.y > 0.0 )
			{
				GSYS.Camera.VRotate = -_ATAN2D( -ZVec.z,  ZVec.y ) - DX_PI / 2.0 ;
			}
			else
			{
				GSYS.Camera.VRotate =  _ATAN2D( -ZVec.z, -ZVec.y ) + DX_PI / 2.0 ;
			}

			_SINCOSD( -GSYS.Camera.VRotate, &Sin, &Cos ) ;
			f      = XVec.y * Cos - XVec.z * Sin ;
			XVec.z = XVec.y * Sin + XVec.z * Cos ;
			XVec.y = f ;

			f      = ZVec.y * Cos - ZVec.z * Sin ;
			ZVec.z = ZVec.y * Sin + ZVec.z * Cos ;
			ZVec.y = f ;

			GSYS.Camera.TRotate = _ATAN2D( XVec.y, XVec.x ) ;
		}
		else
		{
			GSYS.Camera.HRotate = _ATAN2D( ZVec.x, ZVec.z ) ;

			_SINCOSD( -GSYS.Camera.HRotate, &Sin, &Cos ) ;
			f      = XVec.z * Cos - XVec.x * Sin ;
			XVec.x = XVec.z * Sin + XVec.x * Cos ;
			XVec.z = f ;

			f      = ZVec.z * Cos - ZVec.x * Sin ;
			ZVec.x = ZVec.z * Sin + ZVec.x * Cos ;
			ZVec.z = f ;

			GSYS.Camera.VRotate = _ATAN2D( -ZVec.y, ZVec.z ) ;

			_SINCOSD( -GSYS.Camera.VRotate, &Sin, &Cos ) ;
			f      = XVec.y * Cos - XVec.z * Sin ;
			XVec.z = XVec.y * Sin + XVec.z * Cos ;
			XVec.y = f ;

			f      = ZVec.y * Cos - ZVec.z * Sin ;
			ZVec.z = ZVec.y * Sin + ZVec.z * Cos ;
			ZVec.y = f ;

			GSYS.Camera.TRotate = _ATAN2D( XVec.y, XVec.x ) ;
		}
	}

//	NS_DrawFormatString( 0, 20, NS_GetColor( 255,255,255 ), "H:%.3f V:%.3f T:%.3f", GSYS.Camera.HRotate, GSYS.Camera.VRotate, GSYS.Camera.TRotate ) ;

}






















// Cg֌W֐

// Cgnh̒ǉ
extern int Graphics_Light_AddHandle( void )
{
	LIGHT_HANDLE *pLH, **ppLH ;
	int i ;

	// gpĂȂCgnhT
	if( GSYS.Light.Area != MAX_LIGHT_NUM )
	{
		ppLH = &GSYS.Light.Data[ GSYS.Light.Area ] ;
		i = GSYS.Light.Area ;
	}
	else
	{
		ppLH = GSYS.Light.Data ;
		for( i = 0 ; *ppLH != NULL ; i ++, ppLH ++ ){}
	}

	// f[^̈mۂ
	if( ( pLH = *ppLH = ( LIGHT_HANDLE * )DXCALLOC( sizeof( LIGHT_HANDLE ) ) ) == NULL )
		return DXST_LOGFILE_ADDUTF16LE( "\xe9\x30\xa4\x30\xc8\x30\x28\x75\x6e\x30\xe1\x30\xe2\x30\xea\x30\x6e\x30\xba\x78\xdd\x4f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"Cgp̃̊mۂɎs܂" @*/ ) ;

	// [
	_MEMSET( pLH, 0, sizeof( LIGHT_HANDLE ) ) ;

	// lZbg
	pLH->Param.Ambient.r = 0.33f ;
	pLH->Param.Ambient.g = 0.33f ;
	pLH->Param.Ambient.b = 0.33f ;
	pLH->Param.Ambient.a = 0.33f ;
	pLH->Param.Diffuse.r = 1.00f ;
	pLH->Param.Diffuse.g = 1.00f ;
	pLH->Param.Diffuse.b = 1.00f ;
	pLH->Param.Diffuse.a = 1.00f ;
	pLH->Param.Specular.r = 1.00f ;
	pLH->Param.Specular.g = 1.00f ;
	pLH->Param.Specular.b = 1.00f ;
	pLH->Param.Specular.a = 1.00f ;
	pLH->Param.Attenuation0 = 0.1f ;
	pLH->Param.Attenuation1 = 0.0f ;
	pLH->Param.Attenuation2 = 0.0f ;
	pLH->Param.Falloff = 1.0f ;
	pLH->Param.Theta = 2.0f ;
	pLH->Param.Phi = 2.0f ;
	pLH->Param.Range = 2000.0f ;
	pLH->EnableFlag = FALSE ;
	pLH->SetHardwareIndex = -1 ;
	pLH->HardwareChangeFlag = FALSE ;

	// G[`FbNphc̐ݒ
	pLH->ID = ( unsigned int )GSYS.Light.HandleID ;
	GSYS.Light.HandleID ++ ;
	if( GSYS.Light.HandleID >= ( DX_HANDLECHECK_MASK >> DX_HANDLECHECK_ADDRESS ) )
		GSYS.Light.HandleID = 0 ;

	// nhlZbg
	pLH->Handle = ( int )( i | DX_HANDLETYPE_MASK_LIGHT | ( pLH->ID << DX_HANDLECHECK_ADDRESS ) ) ;

	// Cg̐𑝂₷
	GSYS.Light.Num ++ ;

	// gpĂ郉Cgnh݂͈͂XV
	if( GSYS.Light.Area == i ) GSYS.Light.Area ++ ;

	// Lɂ
	NS_SetLightEnableHandle( pLH->Handle, TRUE ) ;

	// nhԂ
	return pLH->Handle ;
}

// Cg̕ύX𔽉f
extern int Graphics_Light_RefreshState( void )
{
	int i, j, k/*, OldEnableNum*/, OldMaxIndex ;
	LIGHT_HANDLE *pLH ;

	// Cg̐ݒ𔽉f
	Graphics_Hardware_Light_SetUse_PF( GSYS.Light.ProcessDisable ? FALSE : TRUE ) ;

	// ݒ肪ύXĂȂ牽Ȃ
	if( GSYS.Light.HardwareChange == FALSE && GSYS.Light.HardwareRefresh == FALSE )
	{
		return 0 ;
	}

	// LȃCgԂɔf
//	OldEnableNum                      = GSYS.Light.EnableNum ;
	OldMaxIndex                       = GSYS.Light.MaxHardwareEnableIndex ;
	GSYS.Light.EnableNum              = 0 ;
	GSYS.Light.MaxHardwareEnableIndex = -1 ;
	for( k = 3 ; k >= 1 ; k -- )
	{
		for( i = 0, j = 0 ; i < GSYS.Light.Num ; j ++ )
		{
			if( GSYS.Light.Data[ j ] == NULL )
			{
				continue ;
			}
			i ++ ;

			pLH = GSYS.Light.Data[ j ] ;
			if( pLH->EnableFlag == FALSE || pLH->Param.LightType != k )
			{
				continue ;
			}

			if( MAX_HARDWAREENABLELIGHTINDEX_NUM > GSYS.Light.EnableNum )
			{
				GSYS.Light.EnableHardwareIndex[ GSYS.Light.EnableNum ] = j ;
			}

			if( pLH->SetHardwareIndex != GSYS.Light.EnableNum || pLH->HardwareChangeFlag == TRUE || GSYS.Light.HardwareRefresh == TRUE )
			{
				pLH->SetHardwareIndex   = GSYS.Light.EnableNum ;
				pLH->HardwareChangeFlag = FALSE ;
//				D_SetLightParam( pLH->SetHardwareIndex, pLH->EnableFlag, &pLH->Param ) ;
				if( pLH->EnableFlag )
				{
					Graphics_Hardware_Light_SetState_PF( pLH->SetHardwareIndex, &pLH->Param ) ;
				}
				Graphics_Hardware_Light_SetEnable_PF( pLH->SetHardwareIndex, pLH->EnableFlag ) ;
			}
			GSYS.Light.MaxHardwareEnableIndex = GSYS.Light.EnableNum ;
			GSYS.Light.EnableNum ++ ;
		}
	}

	// OLȃCg̐Ȃꍇ͗LȃCgOFFɂ
	for( i = GSYS.Light.MaxHardwareEnableIndex + 1 ; i <= OldMaxIndex ; i ++ )
	{
//		D_SetLightParam( i, FALSE, NULL ) ;
		Graphics_Hardware_Light_SetEnable_PF( i, FALSE ) ;
	}

	// ݒ肪ύXꂽtO|
	GSYS.Light.HardwareChange = FALSE ;

	// ݒ肪ύXꂽǂ̃tO𗧂Ă
	GSYS.ChangeSettingFlag = TRUE ;

	// ݒ̍۔fKvǂ̃tO|
	GSYS.Light.HardwareRefresh = FALSE ;

	// sNZVF[_[ɐݒ肷VhE}bv̏XV
	Graphics_ShadowMap_RefreshPSParam() ;

	// I
	return 0 ;
}






















// VF[_[֌W֐

// VF[_[nh쐬
extern int Graphics_Shader_CreateHandle( int ASyncThread )
{
	if( GSYS.InitializeFlag == FALSE )
		return -1 ;

	// VF[_gȂꍇ͎s
	if( GSYS.HardInfo.UseShader == FALSE )
		return -1 ;

	return AddHandle( DX_HANDLETYPE_SHADER, ASyncThread, -1 ) ;
}

// CreateShader ̎֐
static int Graphics_Shader_CreateHandle_Static(
	int ShaderHandle,
	int ShaderType,
	void *Image,
	int ImageSize,
	int ImageAfterFree,
	int ASyncThread
)
{
	return Graphics_Hardware_Shader_Create_PF( ShaderHandle, ShaderType, Image, ImageSize, ImageAfterFree, ASyncThread ) ;
}

#ifndef DX_NON_ASYNCLOAD

// CreateShader ̔񓯊ǂݍ݃XbhĂ΂֐
static void Graphics_Shader_CreateHandle_ASync( ASYNCLOADDATA_COMMON *AParam )
{
	int   ShaderHandle ;
	int   ShaderType ;
	void *Image ;
	int   ImageSize ;
	int   ImageAfterFree ;
	int   Addr ;
	int   Result ;
	SHADERHANDLEDATA *pShader ;

	Addr = 0 ;
	ShaderHandle   = GetASyncLoadParamInt(   AParam->Data, &Addr ) ;
	ShaderType     = GetASyncLoadParamInt(   AParam->Data, &Addr ) ;
	Image          = GetASyncLoadParamVoidP( AParam->Data, &Addr ) ;
	ImageSize      = GetASyncLoadParamInt(   AParam->Data, &Addr ) ;
	ImageAfterFree = GetASyncLoadParamInt(   AParam->Data, &Addr ) ;

	Result = Graphics_Shader_CreateHandle_Static( ShaderHandle, ShaderType, Image, ImageSize, ImageAfterFree, TRUE ) ;
	if( !SHADERCHK_ASYNC( ShaderHandle, pShader ) )
	{
		pShader->HandleInfo.ASyncLoadResult = Result ;
	}
	DecASyncLoadCount( ShaderHandle ) ;
	if( Result < 0 )
	{
		NS_DeleteShader( ShaderHandle ) ;
	}
}

#endif // DX_NON_ASYNCLOAD

// VF[_[nh쐬
extern int Graphics_Shader_CreateHandle_UseGParam(
	int ShaderType,
	void *Image,
	int ImageSize,
	int ImageAfterFree,
	int ASyncLoadFlag,
	int ASyncThread
)
{
	int ShaderHandle = -1 ;

	// VF[_gȂꍇ͎s
	if( Graphics_Hardware_CheckValid_PF() == 0 || GSYS.HardInfo.UseShader == FALSE )
		return -1 ;

	ShaderHandle = Graphics_Shader_CreateHandle( ASyncThread ) ;
	if( ShaderHandle == -1 )
		goto ERR ;

#ifndef DX_NON_ASYNCLOAD
	if( ASyncLoadFlag && ASyncThread == FALSE )
	{
		ASYNCLOADDATA_COMMON *AParam = NULL ;
		int Addr ;

		// p[^ɕKvȃ̃TCYZo
		Addr = 0 ;
		AddASyncLoadParamInt( NULL, &Addr, ShaderHandle ) ;
		AddASyncLoadParamInt( NULL, &Addr, ShaderType ) ;
		AddASyncLoadParamConstVoidP( NULL, &Addr, Image ) ;
		AddASyncLoadParamInt( NULL, &Addr, ImageSize ) ;
		AddASyncLoadParamInt( NULL, &Addr, ImageAfterFree ) ;

		// ̊m
		AParam = AllocASyncLoadDataMemory( Addr ) ;
		if( AParam == NULL )
			goto ERR ;

		// ɕKvȏZbg
		AParam->ProcessFunction = Graphics_Shader_CreateHandle_ASync ;
		Addr = 0 ;
		AddASyncLoadParamInt( AParam->Data, &Addr, ShaderHandle ) ;
		AddASyncLoadParamInt( AParam->Data, &Addr, ShaderType ) ;
		AddASyncLoadParamConstVoidP( AParam->Data, &Addr, Image ) ;
		AddASyncLoadParamInt( AParam->Data, &Addr, ImageSize ) ;
		AddASyncLoadParamInt( AParam->Data, &Addr, ImageAfterFree ) ;

		// f[^ǉ
		if( AddASyncLoadData( AParam ) < 0 )
		{
			DXFREE( AParam ) ;
			AParam = NULL ;
			goto ERR ;
		}

		// 񓯊ǂݍ݃JEgCNg
		IncASyncLoadCount( ShaderHandle, AParam->Index ) ;
	}
	else
#endif // DX_NON_ASYNCLOAD
	{
		if( Graphics_Shader_CreateHandle_Static( ShaderHandle, ShaderType, Image, ImageSize, ImageAfterFree, ASyncThread ) < 0 )
			goto ERR ;
	}

#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		DecASyncLoadCount( ShaderHandle ) ;
	}
#endif // DX_NON_ASYNCLOAD

	// nhԂ
	return ShaderHandle ;

ERR :
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		DecASyncLoadCount( ShaderHandle ) ;
	}
#endif // DX_NON_ASYNCLOAD

	NS_DeleteShader( ShaderHandle ) ;
	ShaderHandle = -1 ;

	// I
	return -1 ;
}

// LoadShader ̎֐
static int Graphics_Shader_LoadShader_Static( int ShaderHandle, int ShaderType, const wchar_t *FileName, int ASyncThread )
{
	SHADERHANDLEDATA *pShader ;
	DWORD_PTR fp ;
	LONGLONG size ;
	void *buffer ;

	// G[
	if( ASyncThread )
	{
		if( SHADERCHK_ASYNC( ShaderHandle, pShader ) )
			return -1 ;
	}
	else
	{
		if( SHADERCHK( ShaderHandle, pShader ) )
			return -1 ;
	}

	fp = DX_FOPEN( FileName ) ;
	if( fp == 0 ) return -1 ;
	DX_FSEEK( fp, 0, SEEK_END ) ;
	size = DX_FTELL( fp ) ;
	DX_FSEEK( fp, 0, SEEK_SET ) ;
	buffer = DXALLOC( ( size_t )size ) ;
	if( buffer == NULL )
	{
		DXST_LOGFILE_ADDUTF16LE( "\xb7\x30\xa7\x30\xfc\x30\xc0\x30\xfc\x30\x6e\x30\xd0\x30\xa4\x30\xca\x30\xea\x30\xc7\x30\xfc\x30\xbf\x30\x92\x30\x3c\x68\x0d\x7d\x59\x30\x8b\x30\xe1\x30\xe2\x30\xea\x30\x18\x98\xdf\x57\x6e\x30\xba\x78\xdd\x4f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"VF[_[̃oCif[^i[郁̈̊mۂɎs܂\n" @*/ ) ;
		return -1 ;
	}
	DX_FREAD( buffer, size, 1, fp ) ;
	DX_FCLOSE( fp ) ;

	return Graphics_Shader_CreateHandle_Static( ShaderHandle, ShaderType, buffer, ( int )size, TRUE, ASyncThread ) ;
}

#ifndef DX_NON_ASYNCLOAD

// Graphics_Shader_LoadShader ̔񓯊ǂݍ݃XbhĂ΂֐
static void Graphics_Shader_LoadShader_ASync( ASYNCLOADDATA_COMMON *AParam )
{
	int          ShaderHandle ;
	int          ShaderType ;
	const wchar_t *FileName ;
	int          Addr ;
	int          Result ;
	SHADERHANDLEDATA *pShader ;

	Addr = 0 ;
	ShaderHandle = GetASyncLoadParamInt( AParam->Data, &Addr ) ;
	ShaderType   = GetASyncLoadParamInt( AParam->Data, &Addr ) ;
	FileName     = GetASyncLoadParamString( AParam->Data, &Addr ) ;

	Result = Graphics_Shader_LoadShader_Static( ShaderHandle, ShaderType, FileName, TRUE ) ;
	if( !SHADERCHK_ASYNC( ShaderHandle, pShader ) )
	{
		pShader->HandleInfo.ASyncLoadResult = Result ;
	}
	DecASyncLoadCount( ShaderHandle ) ;
	if( Result < 0 )
	{
		NS_DeleteShader( ShaderHandle ) ;
	}
}

#endif // DX_NON_ASYNCLOAD

// VF[_[oCit@Cǂݍ
extern int Graphics_Shader_LoadShader_UseGParam( int ShaderType, const wchar_t *FileName, int ASyncLoadFlag )
{
	int ShaderHandle = -1 ;

	// VF[_gȂꍇ͎s
	if( Graphics_Hardware_CheckValid_PF() == 0 || GSYS.HardInfo.UseShader == FALSE )
		return -1 ;

	ShaderHandle = Graphics_Shader_CreateHandle( FALSE ) ;
	if( ShaderHandle == -1 )
		goto ERR ;

#ifndef DX_NON_ASYNCLOAD
	if( ASyncLoadFlag )
	{
		ASYNCLOADDATA_COMMON *AParam = NULL ;
		int Addr ;
		wchar_t FullPath[ 1024 ] ;

		ConvertFullPathW_( FileName, FullPath, sizeof( FullPath ) ) ;

		// p[^ɕKvȃ̃TCYZo
		Addr = 0 ;
		AddASyncLoadParamInt( NULL, &Addr, ShaderHandle ) ;
		AddASyncLoadParamInt( NULL, &Addr, ShaderType ) ;
		AddASyncLoadParamString( NULL, &Addr, FullPath ) ;

		// ̊m
		AParam = AllocASyncLoadDataMemory( Addr ) ;
		if( AParam == NULL )
			goto ERR ;

		// ɕKvȏZbg
		AParam->ProcessFunction = Graphics_Shader_LoadShader_ASync ;
		Addr = 0 ;
		AddASyncLoadParamInt( AParam->Data, &Addr, ShaderHandle ) ;
		AddASyncLoadParamInt( AParam->Data, &Addr, ShaderType ) ;
		AddASyncLoadParamString( AParam->Data, &Addr, FullPath ) ;

		// f[^ǉ
		if( AddASyncLoadData( AParam ) < 0 )
		{
			DXFREE( AParam ) ;
			AParam = NULL ;
			goto ERR ;
		}

		// 񓯊ǂݍ݃JEgCNg
		IncASyncLoadCount( ShaderHandle, AParam->Index ) ;
	}
	else
#endif // DX_NON_ASYNCLOAD
	{
		if( Graphics_Shader_LoadShader_Static( ShaderHandle, ShaderType, FileName, FALSE ) < 0 )
			goto ERR ;
	}

	// nhԂ
	return ShaderHandle ;

ERR :
	NS_DeleteShader( ShaderHandle ) ;
	ShaderHandle = -1 ;

	// I
	return -1 ;
}

// VF[_[nh̏
extern int Graphics_Shader_InitializeHandle( HANDLEINFO *HandleInfo )
{
	SHADERHANDLEDATA *Shader = ( SHADERHANDLEDATA * )HandleInfo ;

	// ˑf[^̃AhXZbg
	Shader->PF = ( SHADERHANDLEDATA_PF * )( Shader + 1 ) ;

	// I
	return 0 ;
}

// VF[_[nȟn
extern int Graphics_Shader_TerminateHandle( HANDLEINFO *HandleInfo )
{
	SHADERHANDLEDATA *Shader = ( SHADERHANDLEDATA * )HandleInfo ;

	// gpVF[_[ƂăZbgĂO
	if( GSYS.DrawSetting.UserShaderRenderInfo.SetVertexShaderHandle == HandleInfo->Handle )
	{
		NS_SetUseVertexShader( -1 ) ;
	}
	if( GSYS.DrawSetting.UserShaderRenderInfo.SetGeometryShaderHandle == HandleInfo->Handle )
	{
		NS_SetUseGeometryShader( -1 ) ;
	}
	if( GSYS.DrawSetting.UserShaderRenderInfo.SetPixelShaderHandle == HandleInfo->Handle )
	{
		NS_SetUsePixelShader( -1 ) ;
	}

	// VF[_[̃oCif[^
	if( Shader->FunctionCode != NULL )
	{
		DXFREE( Shader->FunctionCode ) ;
		Shader->FunctionCode = NULL ;
	}

	// ˑ̌ns
	Graphics_Hardware_Shader_TerminateHandle_PF( Shader ) ;

	// I
	return 0 ;
}

// VF[_[f[^nhlo
extern	SHADERHANDLEDATA *Graphics_Shader_GetData( int ShaderHandle, int ASyncThread )
{
	SHADERHANDLEDATA *Shader ;

	// G[
	if( ASyncThread )
	{
		if( SHADERCHK_ASYNC( ShaderHandle, Shader ) )
		{
			return NULL ;
		}
	}
	else
	{
		if( SHADERCHK( ShaderHandle, Shader ) )
		{
			return NULL ;
		}
	}

	return Shader ;
}



















// 萔obt@֌W֐

// VF[_[p萔obt@nh쐬
extern int Graphics_ShaderConstantBuffer_CreateHandle( int ASyncThread )
{
	if( GSYS.InitializeFlag == FALSE )
		return -1 ;

	// VF[_gȂꍇ͎s
	if( GSYS.HardInfo.UseShader == FALSE )
		return -1 ;

	return AddHandle( DX_HANDLETYPE_SHADER_CONSTANT_BUFFER, ASyncThread, -1 ) ;
}


// Graphics_ShaderConstantBuffer_CreateHandle ̎֐
static int Graphics_ShaderConstantBuffer_CreateHandle_Static(
	int ShaderConstantBufferHandle,
	int BufferSize,
	int ASyncThread
)
{
	return Graphics_Hardware_ShaderConstantBuffer_Create_PF( ShaderConstantBufferHandle, BufferSize, ASyncThread ) ;
}

#ifndef DX_NON_ASYNCLOAD

// Graphics_ShaderConstantBuffer_CreateHandle ̔񓯊ǂݍ݃XbhĂ΂֐
static void Graphics_ShaderConstantBuffer_CreateHandle_ASync( ASYNCLOADDATA_COMMON *AParam )
{
	int   ShaderConstantBufferHandle ;
	int   BufferSize ;
	int   Addr ;
	int   Result ;
	SHADERCONSTANTBUFFERHANDLEDATA *ShaderConstantBuffer ;

	Addr = 0 ;
	ShaderConstantBufferHandle = GetASyncLoadParamInt( AParam->Data, &Addr ) ;
	BufferSize                 = GetASyncLoadParamInt( AParam->Data, &Addr ) ;

	Result = Graphics_ShaderConstantBuffer_CreateHandle_Static( ShaderConstantBufferHandle, BufferSize, TRUE ) ;
	if( !SHADERCONSTANTBUFFERCHK_ASYNC( ShaderConstantBufferHandle, ShaderConstantBuffer ) )
	{
		ShaderConstantBuffer->HandleInfo.ASyncLoadResult = Result ;
	}
	DecASyncLoadCount( ShaderConstantBufferHandle ) ;
	if( Result < 0 )
	{
		NS_DeleteShaderConstantBuffer( ShaderConstantBufferHandle ) ;
	}
}

#endif // DX_NON_ASYNCLOAD

// VF[_[p萔obt@nh쐬
extern int Graphics_ShaderConstantBuffer_Create( int BufferSize, int ASyncLoadFlag, int ASyncThread )
{
	int ShaderConstantBufferHandle = -1 ;

	// VF[_gȂꍇ͎s
	if( Graphics_Hardware_CheckValid_PF() == 0 || GSYS.HardInfo.UseShader == FALSE )
		return -1 ;

	ShaderConstantBufferHandle = Graphics_ShaderConstantBuffer_CreateHandle( ASyncThread ) ;
	if( ShaderConstantBufferHandle == -1 )
		goto ERR ;

#ifndef DX_NON_ASYNCLOAD
	if( ASyncLoadFlag && ASyncThread == FALSE )
	{
		ASYNCLOADDATA_COMMON *AParam = NULL ;
		int Addr ;

		// p[^ɕKvȃ̃TCYZo
		Addr = 0 ;
		AddASyncLoadParamInt( NULL, &Addr, ShaderConstantBufferHandle ) ;
		AddASyncLoadParamInt( NULL, &Addr, BufferSize ) ;

		// ̊m
		AParam = AllocASyncLoadDataMemory( Addr ) ;
		if( AParam == NULL )
			goto ERR ;

		// ɕKvȏZbg
		AParam->ProcessFunction = Graphics_ShaderConstantBuffer_CreateHandle_ASync ;
		Addr = 0 ;
		AddASyncLoadParamInt( AParam->Data, &Addr, ShaderConstantBufferHandle ) ;
		AddASyncLoadParamInt( AParam->Data, &Addr, BufferSize ) ;

		// f[^ǉ
		if( AddASyncLoadData( AParam ) < 0 )
		{
			DXFREE( AParam ) ;
			AParam = NULL ;
			goto ERR ;
		}

		// 񓯊ǂݍ݃JEgCNg
		IncASyncLoadCount( ShaderConstantBufferHandle, AParam->Index ) ;
	}
	else
#endif // DX_NON_ASYNCLOAD
	{
		if( Graphics_ShaderConstantBuffer_CreateHandle_Static( ShaderConstantBufferHandle, BufferSize, ASyncThread ) < 0 )
			goto ERR ;
	}

#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		DecASyncLoadCount( ShaderConstantBufferHandle ) ;
	}
#endif // DX_NON_ASYNCLOAD

	// nhԂ
	return ShaderConstantBufferHandle ;

ERR :
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		DecASyncLoadCount( ShaderConstantBufferHandle ) ;
	}
#endif // DX_NON_ASYNCLOAD

	NS_DeleteShaderConstantBuffer( ShaderConstantBufferHandle ) ;
	ShaderConstantBufferHandle = -1 ;

	// I
	return -1 ;
}

// VF[_[p萔obt@nh̏
extern int Graphics_ShaderConstantBuffer_InitializeHandle( HANDLEINFO *HandleInfo )
{
	SHADERCONSTANTBUFFERHANDLEDATA *ShaderConstantBuffer = ( SHADERCONSTANTBUFFERHANDLEDATA * )HandleInfo ;

	// ˑf[^̃AhXZbg
	ShaderConstantBuffer->PF = ( SHADERCONSTANTBUFFERHANDLEDATA_PF * )( ShaderConstantBuffer + 1 ) ;

	// I
	return 0 ;
}

// VF[_[p萔obt@nȟn
extern int Graphics_ShaderConstantBuffer_TerminateHandle( HANDLEINFO *HandleInfo )
{
	SHADERCONSTANTBUFFERHANDLEDATA *ShaderConstantBuffer = ( SHADERCONSTANTBUFFERHANDLEDATA * )HandleInfo ;

	// ˑ̌ns
	Graphics_Hardware_ShaderConstantBuffer_TerminateHandle_PF( ShaderConstantBuffer ) ;

	// I
	return 0 ;
}




























// _obt@ECfbNXobt@֌W֐

// _obt@쐬
extern int Graphics_VertexBuffer_Create( int VertexNum, int VertexType /* DX_VERTEX_TYPE_NORMAL_3D  */, int ASyncThread )
{
	int NewHandle ;
	int Result ;

	// Vnh쐬
	NewHandle = AddHandle( DX_HANDLETYPE_VERTEX_BUFFER, ASyncThread, -1 ) ;
	if( NewHandle < 0 )
	{
		return -1 ;
	}

	// nh̃ZbgAbv
	Result = Graphics_VertexBuffer_SetupHandle( NewHandle, VertexNum, VertexType ) ;
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		DecASyncLoadCount( NewHandle ) ;
	}
#endif // DX_NON_ASYNCLOAD
	if( Result < 0 )
	{
		SubHandle( NewHandle ) ;
		return -1 ;
	}

	// nhԂ
	return NewHandle ;
}

// _obt@nh̃ZbgAbvs
extern int Graphics_VertexBuffer_SetupHandle( int VertexBufHandle, int VertexNum, int VertexType /* DX_VERTEX_TYPE_NORMAL_3D  */ )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;
	int VertexSize ;

	// G[
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;

	// ΉĂȂ^Cv̏ꍇ̓G[
	switch( VertexType )
	{
	case DX_VERTEX_TYPE_NORMAL_3D :
		VertexSize = sizeof( VERTEX3D ) ;
		break ;

	case DX_VERTEX_TYPE_SHADER_3D :
		VertexSize = sizeof( VERTEX3DSHADER ) ;

		// VF[_[gȂꍇ͎s
		if( GSYS.HardInfo.UseShader == FALSE )
			return -1 ;
		break ;

	default :
		DXST_LOGFILE_ADDUTF16LE( "\x02\x98\xb9\x70\xbf\x30\xa4\x30\xd7\x30\x6e\x30\x24\x50\x4c\x30\x0d\x4e\x63\x6b\x67\x30\x59\x30\x0a\x00\x00"/*@ L"_^Cv̒lsł\n" @*/ ) ;
		return -1 ;
	}

	// ^Cvۑ
	VertexBuffer->Type = VertexType ;

	// _ۑ
	VertexBuffer->Num = VertexNum ;

	// _f[^ӂ̃oCgۑ
	VertexBuffer->UnitSize = VertexSize ;

	// ˑ̒_obt@쐬
	if( Graphics_Hardware_VertexBuffer_Create_PF( VertexBuffer ) < 0 )
	{
		return -1 ;
	}

	// f[^̈mۂ
	if( ReallocHandle( VertexBufHandle, sizeof( VERTEXBUFFERHANDLEDATA ) + sizeof( VERTEXBUFFERHANDLEDATA_PF ) + VertexSize * VertexNum + 32 ) < 0 )
	{
		DXST_LOGFILE_ADDUTF16LE( "\xe1\x30\xe2\x30\xea\x30\x6e\x30\xba\x78\xdd\x4f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"̊mۂɎs܂" @*/ ) ;
		return -1 ;
	}
	VertexBuffer     = ( VERTEXBUFFERHANDLEDATA *    )GetHandleInfo( VertexBufHandle ) ;
	VertexBuffer->PF = ( VERTEXBUFFERHANDLEDATA_PF * )( VertexBuffer + 1 ) ;

	// VXe̒_f[^ۑAhXZbg
	VertexBuffer->Buffer = ( void * )( ( ( DWORD_PTR )VertexBuffer + sizeof( VERTEXBUFFERHANDLEDATA ) + sizeof( VERTEXBUFFERHANDLEDATA_PF ) + 31 ) / 32 * 32 ) ;

	// I
	return 0 ;
}

// _obt@nh̏
extern int Graphics_VertexBuffer_InitializeHandle( HANDLEINFO *HandleInfo )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer = ( VERTEXBUFFERHANDLEDATA * )HandleInfo ;

	VertexBuffer->PF = ( VERTEXBUFFERHANDLEDATA_PF * )( VertexBuffer + 1 ) ;

	// I
	return 0 ;
}

// _obt@nȟn
extern int Graphics_VertexBuffer_TerminateHandle( HANDLEINFO *HandleInfo )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer = ( VERTEXBUFFERHANDLEDATA * )HandleInfo ;

	// ˑn
	Graphics_Hardware_VertexBuffer_Terminate_PF( VertexBuffer ) ;

	// I
	return 0 ;
}

// CfbNXobt@쐬
extern int Graphics_IndexBuffer_Create( int IndexNum, int IndexType /* DX_INDEX_TYPE_16BIT  */, int ASyncThread )
{
	int NewHandle ;
	int Result ;

	// Vnh쐬
	NewHandle = AddHandle( DX_HANDLETYPE_INDEX_BUFFER, ASyncThread, -1 ) ;
	if( NewHandle < 0 )
	{
		return -1 ;
	}

	// nh̃ZbgAbv
	Result = Graphics_IndexBuffer_SetupHandle( NewHandle, IndexNum, IndexType ) ;
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		DecASyncLoadCount( NewHandle ) ;
	}
#endif // DX_NON_ASYNCLOAD
	if( Result < 0 )
	{
		SubHandle( NewHandle ) ;
		return -1 ;
	}

	// nhԂ
	return NewHandle ;
}

// CfbNXobt@nh̃ZbgAbvs
extern int Graphics_IndexBuffer_SetupHandle( int IndexBufHandle, int IndexNum, int IndexType /* DX_INDEX_TYPE_16BIT  */ )
{
	INDEXBUFFERHANDLEDATA *IndexBuffer ;
	int IndexSize ;

	// G[
	if( INDEXBUFFERCHK( IndexBufHandle, IndexBuffer ) )
		return -1 ;

	// ΉĂȂ^Cv̏ꍇ̓G[
	switch( IndexType )
	{
	case DX_INDEX_TYPE_16BIT :
		IndexSize = sizeof( WORD ) ;
		break ;

	case DX_INDEX_TYPE_32BIT :
		IndexSize = sizeof( DWORD ) ;
		break ;

	default :
		DXST_LOGFILE_ADDUTF16LE( "\xa4\x30\xf3\x30\xc7\x30\xc3\x30\xaf\x30\xb9\x30\xbf\x30\xa4\x30\xd7\x30\x6e\x30\x24\x50\x4c\x30\x0d\x4e\x63\x6b\x67\x30\x59\x30\x0a\x00\x00"/*@ L"CfbNX^Cv̒lsł\n" @*/ ) ;
		return -1 ;
	}

	// ^Cvۑ
	IndexBuffer->Type = IndexType ;

	// CfbNXf[^ӂ̃oCgۑ
	IndexBuffer->UnitSize = IndexSize ;

	// CfbNXۑ
	IndexBuffer->Num = IndexNum ;

	// ˑ̃CfbNXobt@쐬
	if( Graphics_Hardware_IndexBuffer_Create_PF( IndexBuffer ) < 0 )
	{
		return -1 ;
	}

	// f[^̈mۂ
	if( ReallocHandle( IndexBufHandle, sizeof( INDEXBUFFERHANDLEDATA ) + sizeof( INDEXBUFFERHANDLEDATA_PF ) + IndexSize * IndexNum + 32 ) < 0 )
	{
		DXST_LOGFILE_ADDUTF16LE( "\xe1\x30\xe2\x30\xea\x30\x6e\x30\xba\x78\xdd\x4f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"̊mۂɎs܂" @*/ ) ;
		return -1 ;
	}
	IndexBuffer     = ( INDEXBUFFERHANDLEDATA *    )GetHandleInfo( IndexBufHandle ) ;
	IndexBuffer->PF = ( INDEXBUFFERHANDLEDATA_PF * )( IndexBuffer + 1 ) ;

	// VXẽCfbNXf[^ۑAhXZbg
	IndexBuffer->Buffer = ( void * )( ( ( DWORD_PTR )IndexBuffer + sizeof( INDEXBUFFERHANDLEDATA ) + sizeof( INDEXBUFFERHANDLEDATA_PF ) + 31 ) / 32 * 32 ) ;

	// I
	return 0 ;
}

// CfbNXobt@nh̏
extern int Graphics_IndexBuffer_InitializeHandle( HANDLEINFO *HandleInfo )
{
	INDEXBUFFERHANDLEDATA *IndexBuffer = ( INDEXBUFFERHANDLEDATA * )HandleInfo ;

	IndexBuffer->PF = ( INDEXBUFFERHANDLEDATA_PF * )( IndexBuffer + 1 ) ;

	// I
	return 0 ;
}

// CfbNXobt@nȟn
extern int Graphics_IndexBuffer_TerminateHandle( HANDLEINFO *HandleInfo )
{
	INDEXBUFFERHANDLEDATA *IndexBuffer = ( INDEXBUFFERHANDLEDATA * )HandleInfo ;

	// ˑn
	Graphics_Hardware_IndexBuffer_Terminate_PF( IndexBuffer ) ;

	// I
	return 0 ;
}



























// VhE}bv֌W֐

// MakeShadowMap ̎֐
static int Graphics_ShadowMap_MakeShadowMap_Static(
	SETUP_SHADOWMAPHANDLE_GPARAM *GParam,
	int SmHandle,
	int SizeX,
	int SizeY,
	int ASyncThread
)
{
	// nh̏
	if( Graphics_ShadowMap_SetupHandle_UseGParam(
			GParam,
			SmHandle,
			SizeX,
			SizeY,
			TRUE,
			16,
			ASyncThread
		) == -1 )
		return -1 ;

	// I
	return 0 ;
}

#ifndef DX_NON_ASYNCLOAD

// MakeShadowMap ̔񓯊ǂݍ݃XbhĂ΂֐
static void Graphics_ShadowMap_MakeShadowMap_ASync( ASYNCLOADDATA_COMMON *AParam )
{
	SETUP_SHADOWMAPHANDLE_GPARAM *GParam ;
	int SmHandle ;
	int SizeX ;
	int SizeY ;
	int Addr ;
	int Result ;
	SHADOWMAPDATA *ShadowMap ;

	Addr = 0 ;
	GParam = ( SETUP_SHADOWMAPHANDLE_GPARAM * )GetASyncLoadParamStruct( AParam->Data, &Addr ) ;
	SmHandle = GetASyncLoadParamInt( AParam->Data, &Addr ) ;
	SizeX = GetASyncLoadParamInt( AParam->Data, &Addr ) ;
	SizeY = GetASyncLoadParamInt( AParam->Data, &Addr ) ;

	Result = Graphics_ShadowMap_MakeShadowMap_Static( GParam, SmHandle, SizeX, SizeY, TRUE ) ;
	if( !SHADOWMAPCHK_ASYNC( SmHandle, ShadowMap ) )
	{
		ShadowMap->HandleInfo.ASyncLoadResult = Result ;
	}
	DecASyncLoadCount( SmHandle ) ;
	if( Result < 0 )
	{
		NS_DeleteGraph( SmHandle, FALSE ) ;
	}
}
#endif // DX_NON_ASYNCLOAD

// VhE}bvnh쐬֐
extern int Graphics_ShadowMap_MakeShadowMap_UseGParam(
	SETUP_SHADOWMAPHANDLE_GPARAM *GParam,
	int SizeX,
	int SizeY,
	int ASyncLoadFlag,
	int ASyncThread
)
{
	int SmHandle ;

	CheckActiveState() ;

	// nh̍쐬
	SmHandle = Graphics_ShadowMap_AddHandle( ASyncThread ) ;
	if( SmHandle == -1 )
	{
		return -1 ;
	}

#ifndef DX_NON_ASYNCLOAD
	if( ASyncLoadFlag && ASyncThread == FALSE )
	{
		ASYNCLOADDATA_COMMON *AParam = NULL ;
		int Addr ;

		// p[^ɕKvȃ̃TCYZo
		Addr = 0 ;
		AddASyncLoadParamStruct( NULL, &Addr, GParam, sizeof( *GParam ) ) ;
		AddASyncLoadParamInt( NULL, &Addr, SmHandle ) ;
		AddASyncLoadParamInt( NULL, &Addr, SizeX ) ;
		AddASyncLoadParamInt( NULL, &Addr, SizeY ) ;

		// ̊m
		AParam = AllocASyncLoadDataMemory( Addr ) ;
		if( AParam == NULL )
			goto ERR ;

		// ɕKvȏZbg
		AParam->ProcessFunction = Graphics_ShadowMap_MakeShadowMap_ASync ;
		Addr = 0 ;
		AddASyncLoadParamStruct( AParam->Data, &Addr, GParam, sizeof( *GParam ) ) ;
		AddASyncLoadParamInt( AParam->Data, &Addr, SmHandle ) ;
		AddASyncLoadParamInt( AParam->Data, &Addr, SizeX ) ;
		AddASyncLoadParamInt( AParam->Data, &Addr, SizeY ) ;

		// f[^ǉ
		if( AddASyncLoadData( AParam ) < 0 )
		{
			DXFREE( AParam ) ;
			AParam = NULL ;
			goto ERR ;
		}

		// 񓯊ǂݍ݃JEgCNg
		IncASyncLoadCount( SmHandle, AParam->Index ) ;
	}
	else
#endif // DX_NON_ASYNCLOAD
	{
		if( Graphics_ShadowMap_MakeShadowMap_Static( GParam, SmHandle, SizeX, SizeY, ASyncThread ) < 0 )
			goto ERR ;
	}

#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		DecASyncLoadCount( SmHandle ) ;
	}
#endif // DX_NON_ASYNCLOAD

	// I
	return SmHandle ;

ERR :
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		DecASyncLoadCount( SmHandle ) ;
	}
#endif // DX_NON_ASYNCLOAD

	NS_DeleteGraph( SmHandle, FALSE ) ;

	return -1 ;
}

// VVhE}bvnhmۂ
extern int Graphics_ShadowMap_AddHandle( int ASyncThread )
{
	return AddHandle( DX_HANDLETYPE_SHADOWMAP, ASyncThread, -1 );
}

// VhE}bvnh̃ZbgAbvs
extern int Graphics_ShadowMap_SetupHandle_UseGParam( SETUP_SHADOWMAPHANDLE_GPARAM * /* GParam */, int SmHandle, int SizeX, int SizeY, int TexFormat_Float, int TexFormat_BitDepth, int /* ASyncThread */ )
{
	SHADOWMAPDATA *ShadowMap ;

	// AhX̎擾
	if( SHADOWMAPCHK_ASYNC( SmHandle, ShadowMap ) )
		return -1 ;

	// p[^̕ۑ
	ShadowMap->TexFormat_Float = TexFormat_Float ;
	ShadowMap->TexFormat_BitDepth = TexFormat_BitDepth ;
	ShadowMap->BaseSizeX = SizeX ;
	ShadowMap->BaseSizeY = SizeY ;
	ShadowMap->ShadowMapViewMatrix.m[ 3 ][ 3 ] = 1.0f ;

	// eNX`̍쐬
	if( Graphics_ShadowMap_CreateTexture( ShadowMap ) == -1 )
	{
		goto ERR ;
	}

	// I
	return 0 ;

	// G[I
ERR :
	NS_DeleteGraph( SmHandle, FALSE ) ;

	return -1 ;
}

// VhE}bvf[^ɕKvȃeNX`쐬
extern int Graphics_ShadowMap_CreateTexture( SHADOWMAPDATA *ShadowMap, int ASyncThread )
{
	return Graphics_Hardware_ShadowMap_CreateTexture_PF( ShadowMap, ASyncThread ) ;
}

// VhE}bvf[^ɕKvȃeNX`
extern int Graphics_ShadowMap_ReleaseTexture( SHADOWMAPDATA *ShadowMap )
{
	return Graphics_Hardware_ShadowMap_ReleaseTexture_PF( ShadowMap ) ;
}

// VhE}bvf[^nhlo
extern SHADOWMAPDATA *Graphics_ShadowMap_GetData( int SmHandle, int ASyncThread )
{
	SHADOWMAPDATA *ShadowMap ;

	// G[
	if( ASyncThread )
	{
		if( SHADOWMAPCHK_ASYNC( SmHandle, ShadowMap ) )
			return NULL ;
	}
	else
	{
		if( SHADOWMAPCHK( SmHandle, ShadowMap ) )
			return NULL ;
	}

	return ShadowMap ;
}

// _VF[_[ɐݒ肷VhE}bv̏XV
extern void Graphics_ShadowMap_RefreshVSParam( void )
{
	Graphics_Hardware_ShadowMap_RefreshVSParam_PF() ;
}

// sNZVF[_[ɐݒ肷VhE}bv̏XV
extern void Graphics_ShadowMap_RefreshPSParam( void )
{
	Graphics_Light_RefreshState() ;

	Graphics_Hardware_ShadowMap_RefreshPSParam_PF() ;
}

// VhE}bvւ̃_OŎgps̏XV
extern int Graphics_ShadowMap_RefreshMatrix( SHADOWMAPDATA *ShadowMap )
{
	VECTOR TempPos ;
	VECTOR MaxPos ;
	VECTOR MinPos ;
	VECTOR *SrcPos ;
	VECTOR EyePos ;
	VECTOR AreaSize ;
	int i ;

	// Cgn_̍őWƍŏWo
	SrcPos = ShadowMap->EnableDrawArea ? ShadowMap->DrawAreaViewClipPos : ShadowMap->DefaultViewClipPos ;
	MinPos.x =  100000000.0f ;
	MinPos.y =  100000000.0f ;
	MinPos.z =  100000000.0f ;
	MaxPos.x = -100000000.0f ;
	MaxPos.y = -100000000.0f ;
	MaxPos.z = -100000000.0f ;
	for( i = 0 ; i < 8 ; i ++, SrcPos ++ )
	{
		VectorTransformSR( &TempPos, SrcPos, &ShadowMap->LightMatrix ) ;

		if( MinPos.x > TempPos.x ) MinPos.x = TempPos.x ;
		if( MinPos.y > TempPos.y ) MinPos.y = TempPos.y ;
		if( MinPos.z > TempPos.z ) MinPos.z = TempPos.z ;

		if( MaxPos.x < TempPos.x ) MaxPos.x = TempPos.x ;
		if( MaxPos.y < TempPos.y ) MaxPos.y = TempPos.y ;
		if( MaxPos.z < TempPos.z ) MaxPos.z = TempPos.z ;
	}

	// VhE}bv`pr[s̕sړݒ
	EyePos.x = ( MaxPos.x + MinPos.x ) / 2.0f ;
	EyePos.y = ( MaxPos.y + MinPos.y ) / 2.0f ;
	EyePos.z = MinPos.z ;
	ShadowMap->ShadowMapViewMatrix.m[ 3 ][ 0 ] = -EyePos.x ;
	ShadowMap->ShadowMapViewMatrix.m[ 3 ][ 1 ] = -EyePos.y ;
	ShadowMap->ShadowMapViewMatrix.m[ 3 ][ 2 ] = -EyePos.z ;

	// VhE}bv`p̎ˉes̊g听ݒ
	AreaSize = VSub( MaxPos, MinPos ) ;
	ShadowMap->ShadowMapProjectionMatrix.m[ 0 ][ 0 ] = 2.0f / AreaSize.x ;
	ShadowMap->ShadowMapProjectionMatrix.m[ 1 ][ 1 ] = 2.0f / AreaSize.y ;
	ShadowMap->ShadowMapProjectionMatrix.m[ 2 ][ 2 ] = 1.0f / ( MaxPos.z - MinPos.z ) ;

	// VhE}bv`pr[sƃVhE}bv`pˉesẐۑ
	CreateMultiplyMatrix( &ShadowMap->ShadowMapViewProjectionMatrix, &ShadowMap->ShadowMapViewMatrix, &ShadowMap->ShadowMapProjectionMatrix ) ;

	// r[sƎˉes̃Zbg
	NS_SetTransformToView( &ShadowMap->ShadowMapViewMatrix ) ;
	NS_SetTransformToProjection( &ShadowMap->ShadowMapProjectionMatrix ) ;

	// I
	return 0 ;
}

// VhE}bvnh̏
extern int Graphics_ShadowMap_InitializeHandle( HANDLEINFO *HandleInfo )
{
	SHADOWMAPDATA *ShadowMap = ( SHADOWMAPDATA * )HandleInfo ;

	ShadowMap->PF             = ( SHADOWMAPDATA_PF * )( ShadowMap + 1 ) ;

	ShadowMap->BaseSizeX      = -1 ;
	ShadowMap->BaseSizeY      = -1 ;

	ShadowMap->AdjustDepth    = DEFAULT_SHADOWMAP_ADJUST_DEPTH ;
	ShadowMap->BlurParam      = DEFAULT_SHADOWMAP_BLUR_PARAM ;
	ShadowMap->GradationParam = DEFAULT_SHADOWMAP_GRADATION_RANGE ;

	ShadowMap->LightMatrix.m[ 3 ][ 3 ]               = 1.0f ;
	ShadowMap->ShadowMapProjectionMatrix.m[ 3 ][ 3 ] = 1.0f ;
	CreateMultiplyMatrix( &ShadowMap->ShadowMapViewProjectionMatrix, &ShadowMap->ShadowMapViewMatrix, &ShadowMap->ShadowMapProjectionMatrix ) ;

	// Cg̐ݒ
	NS_SetShadowMapLightDirection( HandleInfo->Handle, VGet( 0.0f, -1.0f, 0.0f ) ) ;

	// I
	return 0 ;
}

// VhE}bvnȟn
extern int Graphics_ShadowMap_TerminateHandle( HANDLEINFO *HandleInfo )
{
	SHADOWMAPDATA *ShadowMap = ( SHADOWMAPDATA * )HandleInfo ;
	int i ;

	// `ŎgpVhE}bvɐݒ肳Ă
	for( i = 0 ; i < MAX_USE_SHADOWMAP_NUM ; i ++ )
	{
		if( GSYS.DrawSetting.ShadowMap[ i ] == HandleInfo->Handle )
		{
			NS_SetUseShadowMap( i, -1 ) ;
		}
	}

	// VhE}bv̕`揀sĂ
	if( ShadowMap->DrawSetupFlag )
	{
		NS_ShadowMap_DrawEnd() ;
	}

	// T[tFXeNX`
	Graphics_ShadowMap_ReleaseTexture( ShadowMap ) ;

	// ɗĂtOւ̃|C^Lłꍇ͗Ă
	if( ShadowMap->LostFlag != NULL )
		*ShadowMap->LostFlag = TRUE ;

	// I
	return 0 ;
}




























// ⏕֌W֐

// L̊m
extern int Graphics_Other_AllocCommonBuffer( int Index, DWORD Size )
{
	if( Index >= COMMON_BUFFER_NUM || Index < 0 )
	{
		return -1 ;
	}

	if( GSYS.Resource.CommonBufferSize[ Index ] >= Size )
	{
		return 0 ;
	}

	GSYS.Resource.CommonBuffer[ Index ] = DXREALLOC( GSYS.Resource.CommonBuffer[ Index ], Size ) ;
	if( GSYS.Resource.CommonBuffer[ Index ] == NULL )
	{
		return -1 ;
	}
	GSYS.Resource.CommonBufferSize[ Index ] = Size ;

	return 0 ;
}

// L̉
extern int Graphics_Other_TerminateCommonBuffer( void ) 
{
	int i ;

	for( i = 0 ; i < COMMON_BUFFER_NUM ; i ++ )
	{
		if( GSYS.Resource.CommonBuffer[ i ] != NULL )
		{
			DXFREE( GSYS.Resource.CommonBuffer[ i ] ) ;
			GSYS.Resource.CommonBuffer[ i ] = 0 ;
		}

		GSYS.Resource.CommonBufferSize[ i ] = 0 ;
	}

	return 0 ;
}




































// va_list ֐

// `揈ɕ`悷摜ƃuh摜̃uhݒsABlendGraph  -1 ɂΐݒȀꍇ BlendType Ƃ̌̃p[^͖
extern int SetBlendGraphParam_VaList( int BlendGraph, int BlendType, va_list VaList )
{
	int Result ;

	if( BlendType < 0 || BlendType >= DX_BLENDGRAPHTYPE_NUM )
	{
		return -1 ;
	}

	Result = Graphics_DrawSetting_SetBlendGraphParamBase(  BlendGraph,  BlendType, VaList ) ;

	return Result ;
}













#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE


#endif // DX_NON_GRAPHICS
